-- MySQL dump 10.13  Distrib 5.5.28, for osx10.6 (i386)
--
-- Host: localhost    Database: centum
-- ------------------------------------------------------
-- Server version	5.5.28

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `actions`
--

DROP TABLE IF EXISTS `actions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `actions` (
  `aid` varchar(255) NOT NULL DEFAULT '0' COMMENT 'Primary Key: Unique actions ID.',
  `type` varchar(32) NOT NULL DEFAULT '' COMMENT 'The object that that action acts on (node, user, comment, system or custom types.)',
  `callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The callback function that executes when the action runs.',
  `parameters` longblob NOT NULL COMMENT 'Parameters to be passed to the callback function.',
  `label` varchar(255) NOT NULL DEFAULT '0' COMMENT 'Label of the action.',
  PRIMARY KEY (`aid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores action information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `actions`
--

LOCK TABLES `actions` WRITE;
/*!40000 ALTER TABLE `actions` DISABLE KEYS */;
INSERT INTO `actions` VALUES ('comment_publish_action','comment','comment_publish_action','','Publish comment'),('comment_save_action','comment','comment_save_action','','Save comment'),('comment_unpublish_action','comment','comment_unpublish_action','','Unpublish comment'),('node_make_sticky_action','node','node_make_sticky_action','','Make content sticky'),('node_make_unsticky_action','node','node_make_unsticky_action','','Make content unsticky'),('node_promote_action','node','node_promote_action','','Promote content to front page'),('node_publish_action','node','node_publish_action','','Publish content'),('node_save_action','node','node_save_action','','Save content'),('node_unpromote_action','node','node_unpromote_action','','Remove content from front page'),('node_unpublish_action','node','node_unpublish_action','','Unpublish content'),('pathauto_node_update_action','node','pathauto_node_update_action','','Update node alias'),('pathauto_taxonomy_term_update_action','taxonomy_term','pathauto_taxonomy_term_update_action','','Update taxonomy term alias'),('pathauto_user_update_action','user','pathauto_user_update_action','','Update user alias'),('system_block_ip_action','user','system_block_ip_action','','Ban IP address of current user'),('user_block_user_action','user','user_block_user_action','','Block current user');
/*!40000 ALTER TABLE `actions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `authmap`
--

DROP TABLE IF EXISTS `authmap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `authmap` (
  `aid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique authmap ID.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'User’s users.uid.',
  `authname` varchar(128) NOT NULL DEFAULT '' COMMENT 'Unique authentication name.',
  `module` varchar(128) NOT NULL DEFAULT '' COMMENT 'Module which is controlling the authentication.',
  PRIMARY KEY (`aid`),
  UNIQUE KEY `authname` (`authname`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores distributed authentication mapping.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `authmap`
--

LOCK TABLES `authmap` WRITE;
/*!40000 ALTER TABLE `authmap` DISABLE KEYS */;
/*!40000 ALTER TABLE `authmap` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `batch`
--

DROP TABLE IF EXISTS `batch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `batch` (
  `bid` int(10) unsigned NOT NULL COMMENT 'Primary Key: Unique batch ID.',
  `token` varchar(64) NOT NULL COMMENT 'A string token generated against the current user’s session id and the batch id, used to ensure that only the user who submitted the batch can effectively access it.',
  `timestamp` int(11) NOT NULL COMMENT 'A Unix timestamp indicating when this batch was submitted for processing. Stale batches are purged at cron time.',
  `batch` longblob COMMENT 'A serialized array containing the processing data for the batch.',
  PRIMARY KEY (`bid`),
  KEY `token` (`token`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores details about batches (processes that run in...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `batch`
--

LOCK TABLES `batch` WRITE;
/*!40000 ALTER TABLE `batch` DISABLE KEYS */;
/*!40000 ALTER TABLE `batch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `block`
--

DROP TABLE IF EXISTS `block`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block` (
  `bid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique block ID.',
  `module` varchar(64) NOT NULL DEFAULT '' COMMENT 'The module from which the block originates; for example, ’user’ for the Who’s Online block, and ’block’ for any custom blocks.',
  `delta` varchar(32) NOT NULL DEFAULT '0' COMMENT 'Unique ID for block within a module.',
  `theme` varchar(64) NOT NULL DEFAULT '' COMMENT 'The theme under which the block settings apply.',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Block enabled status. (1 = enabled, 0 = disabled)',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Block weight within region.',
  `region` varchar(64) NOT NULL DEFAULT '' COMMENT 'Theme region within which the block is set.',
  `custom` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate how users may control visibility of the block. (0 = Users cannot control, 1 = On by default, but can be hidden, 2 = Hidden by default, but can be shown)',
  `visibility` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate how to show blocks on pages. (0 = Show on all pages except listed pages, 1 = Show only on listed pages, 2 = Use custom PHP code to determine visibility)',
  `pages` text NOT NULL COMMENT 'Contents of the "Pages" block; contains either a list of paths on which to include/exclude the block or PHP code, depending on "visibility" setting.',
  `title` varchar(64) NOT NULL DEFAULT '' COMMENT 'Custom title for the block. (Empty string will use block default title, <none> will remove the title, text will cause block to use specified title.)',
  `cache` tinyint(4) NOT NULL DEFAULT '1' COMMENT 'Binary flag to indicate block cache mode. (-2: Custom cache, -1: Do not cache, 1: Cache per role, 2: Cache per user, 4: Cache per page, 8: Block cache global) See DRUPAL_CACHE_* constants in ../includes/common.inc for more detailed information.',
  PRIMARY KEY (`bid`),
  UNIQUE KEY `tmd` (`theme`,`module`,`delta`),
  KEY `list` (`theme`,`status`,`region`,`weight`,`module`)
) ENGINE=InnoDB AUTO_INCREMENT=100 DEFAULT CHARSET=utf8 COMMENT='Stores block settings, such as region and visibility...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block`
--

LOCK TABLES `block` WRITE;
/*!40000 ALTER TABLE `block` DISABLE KEYS */;
INSERT INTO `block` VALUES (1,'system','main','bartik',1,0,'content',0,0,'','',-1),(2,'search','form','bartik',1,-1,'sidebar_first',0,1,'blog\r\nblog/*\r\ntags/*','',-1),(3,'node','recent','seven',1,0,'dashboard_main',0,0,'','',-1),(4,'user','login','bartik',1,0,'sidebar_first',0,0,'','',-1),(5,'system','navigation','bartik',1,0,'sidebar_first',0,0,'','',-1),(6,'system','powered-by','bartik',1,10,'footer',0,0,'','',-1),(7,'system','help','bartik',1,0,'help',0,0,'','',-1),(8,'system','main','seven',1,0,'content',0,0,'','',-1),(9,'system','help','seven',1,0,'help',0,0,'','',-1),(10,'user','login','seven',1,10,'content',0,0,'','',-1),(11,'user','new','seven',1,0,'dashboard_sidebar',0,0,'','',-1),(12,'search','form','seven',1,1,'dashboard_sidebar',0,1,'','',-1),(13,'comment','recent','bartik',0,0,'-1',0,0,'','',1),(14,'node','syndicate','bartik',0,0,'-1',0,0,'','',-1),(15,'node','recent','bartik',0,0,'-1',0,0,'','',1),(16,'shortcut','shortcuts','bartik',0,0,'-1',0,0,'','',-1),(17,'system','management','bartik',0,0,'-1',0,0,'','',-1),(18,'system','user-menu','bartik',0,0,'-1',0,0,'','',-1),(19,'system','main-menu','bartik',0,0,'-1',0,0,'','',-1),(20,'user','new','bartik',0,0,'-1',0,0,'','',1),(21,'user','online','bartik',0,0,'-1',0,0,'','',-1),(22,'comment','recent','seven',1,0,'dashboard_inactive',0,0,'','',1),(23,'node','syndicate','seven',0,0,'-1',0,0,'','',-1),(24,'shortcut','shortcuts','seven',0,0,'-1',0,0,'','',-1),(25,'system','powered-by','seven',0,10,'-1',0,0,'','',-1),(26,'system','navigation','seven',0,0,'-1',0,0,'','',-1),(27,'system','management','seven',0,0,'-1',0,0,'','',-1),(28,'system','user-menu','seven',0,0,'-1',0,0,'','',-1),(29,'system','main-menu','seven',0,0,'-1',0,0,'','',-1),(30,'user','online','seven',1,1,'dashboard_inactive',0,0,'','',-1),(31,'menu','devel','bartik',0,0,'-1',0,0,'','',-1),(32,'devel','execute_php','bartik',0,0,'-1',0,0,'','',-1),(33,'devel','switch_user','bartik',0,0,'-1',0,0,'','',-1),(34,'menu','devel','seven',0,0,'-1',0,0,'','',-1),(35,'devel','execute_php','seven',0,0,'-1',0,0,'','',-1),(36,'devel','switch_user','seven',0,0,'-1',0,0,'','',-1),(37,'blog','recent','bartik',0,0,'-1',0,1,'blog\r\nblog/*\r\ntags/*','',1),(38,'blog','recent','seven',1,2,'dashboard_inactive',0,1,'','',1),(39,'blog','recent','centum',1,-14,'sidebar_second',0,1,'blog\r\nblog/*\r\ntags/*','',1),(40,'comment','recent','centum',0,0,'-1',0,0,'','',1),(41,'devel','execute_php','centum',0,0,'-1',0,0,'','',-1),(42,'devel','switch_user','centum',0,0,'-1',0,0,'','',-1),(43,'menu','devel','centum',0,0,'-1',0,0,'','',-1),(44,'node','recent','centum',0,0,'-1',0,0,'','',1),(45,'node','syndicate','centum',0,0,'-1',0,0,'','',-1),(46,'search','form','centum',1,-17,'sidebar_second',0,1,'blog\r\nblog/*\r\ntags/*','',-1),(47,'shortcut','shortcuts','centum',0,0,'-1',0,0,'','',-1),(48,'system','help','centum',1,0,'help',0,0,'','',-1),(49,'system','main','centum',1,-12,'content',0,0,'','',-1),(50,'system','main-menu','centum',0,0,'-1',0,0,'','',-1),(51,'system','management','centum',0,0,'-1',0,0,'','',-1),(52,'system','navigation','centum',0,0,'-1',0,0,'','',-1),(53,'system','powered-by','centum',0,10,'-1',0,0,'','',-1),(54,'system','user-menu','centum',0,0,'-1',0,0,'','',-1),(55,'user','login','centum',0,0,'-1',0,0,'','',-1),(56,'user','new','centum',0,0,'-1',0,0,'','',1),(57,'user','online','centum',0,0,'-1',0,0,'','',-1),(58,'widget','widget_twitter','bartik',0,0,'-1',0,0,'','',1),(59,'widget','widget_flickr','bartik',0,0,'-1',0,0,'','',1),(60,'widget','widget_twitter','centum',1,0,'footer_fourthcolumn',0,0,'','',1),(61,'widget','widget_flickr','centum',1,0,'footer_thirdcolumn',0,0,'','',1),(62,'widget','widget_twitter','seven',0,0,'-1',0,0,'','',1),(63,'widget','widget_flickr','seven',0,0,'-1',0,0,'','',1),(64,'block','1','bartik',0,0,'-1',0,0,'',' About Us',-1),(65,'block','1','centum',1,0,'footer_firstcolumn',0,0,'',' About Us',-1),(66,'block','1','seven',0,0,'-1',0,0,'',' About Us',-1),(67,'block','2','bartik',0,0,'-1',0,0,'','Useful Links',-1),(68,'block','2','centum',1,0,'footer_secondcolumn',0,0,'','Useful Links',-1),(69,'block','2','seven',0,0,'-1',0,0,'','Useful Links',-1),(70,'custom','recent_projects','bartik',0,0,'-1',0,0,'','',1),(71,'custom','recent_posts','bartik',0,0,'-1',0,0,'','',1),(72,'custom','recent_projects','centum',0,0,'-1',0,0,'','',1),(73,'custom','recent_posts','centum',0,0,'-1',0,0,'','',1),(74,'custom','recent_projects','seven',0,0,'-1',0,0,'','',1),(75,'custom','recent_posts','seven',0,0,'-1',0,0,'','',1),(76,'block','3','bartik',0,0,'-1',0,1,'contact','',-1),(77,'block','3','centum',1,-13,'highlighted',0,1,'contact','',-1),(78,'block','3','seven',0,0,'-1',0,1,'contact','',-1),(79,'block','4','bartik',0,0,'-1',0,1,'contact','',-1),(80,'block','4','centum',1,-13,'sidebar_second',0,1,'contact','',-1),(81,'block','4','seven',0,0,'-1',0,1,'contact','',-1),(82,'block','5','bartik',0,0,'-1',0,1,'contact','Social',-1),(83,'block','5','centum',1,-12,'sidebar_second',0,1,'contact','Social',-1),(84,'block','5','seven',0,0,'-1',0,1,'contact','Social',-1),(85,'block','6','bartik',0,0,'-1',0,1,'<front>','',-1),(86,'block','6','centum',1,0,'home_services',0,1,'<front>','',-1),(87,'block','6','seven',0,0,'-1',0,1,'<front>','',-1),(88,'block','7','bartik',0,0,'-1',0,0,'','',-1),(89,'block','7','centum',0,0,'-1',0,0,'','',-1),(90,'block','7','seven',0,0,'-1',0,0,'','',-1),(91,'tagadelic','2','bartik',0,0,'-1',0,0,'','',8),(92,'tagadelic','1','bartik',0,0,'-1',0,1,'blog\r\nblog/*\r\ntags/*','Tags',8),(93,'tagadelic','2','centum',0,0,'-1',0,0,'','',8),(94,'tagadelic','1','centum',1,-15,'sidebar_second',0,1,'blog\r\nblog/*\r\ntags/*','Tags',8),(95,'tagadelic','2','seven',0,0,'-1',0,0,'','',8),(96,'tagadelic','1','seven',0,0,'-1',0,1,'blog\r\nblog/*\r\ntags/*','Tags',8),(97,'block','8','bartik',0,0,'-1',0,1,'blog\r\nblog/*\r\ntags/*','Text Widget',-1),(98,'block','8','centum',1,-16,'sidebar_second',0,1,'blog\r\nblog/*\r\ntags/*','Text Widget',-1),(99,'block','8','seven',0,0,'-1',0,1,'blog\r\nblog/*\r\ntags/*','Text Widget',-1);
/*!40000 ALTER TABLE `block` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `block_custom`
--

DROP TABLE IF EXISTS `block_custom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_custom` (
  `bid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The block’s block.bid.',
  `body` longtext COMMENT 'Block contents.',
  `info` varchar(128) NOT NULL DEFAULT '' COMMENT 'Block description.',
  `format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the block body.',
  PRIMARY KEY (`bid`),
  UNIQUE KEY `info` (`info`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8 COMMENT='Stores contents of custom-made blocks.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_custom`
--

LOCK TABLES `block_custom` WRITE;
/*!40000 ALTER TABLE `block_custom` DISABLE KEYS */;
INSERT INTO `block_custom` VALUES (1,'<p>Lorem sequat ipsum dolor lorem sit amet, consectetur adipiscing dolor elit. Aenean nisl orci, condimentum.</p>\r\n<p>Consectetur adipiscing elit aeneane lorem lipsum, condimentum ultrices consequat eu, vehicula mauris lipsum adipiscing lipsum aenean orci lorem.</p>\r\n		','Footer about us','full_html'),(2,'<ul class=\"links-list\">\r\n  <li><a href=\"#\">Service Updates</a></li>\r\n  <li><a href=\"#\">Community Forum</a></li>\r\n  <li><a href=\"#\">Help Desk</a></li>\r\n  <li><a href=\"#\">Terms of Use</a></li>\r\n  <li><a href=\"#\">Validate License</a></li>\r\n  <li><a href=\"#\">Privacy Policy</a></li>\r\n  <li><a href=\"#\">Knowledgebase</a></li>\r\n</ul>','Useful Links','full_html'),(3,'<p>We create beautiful, usable, professional websites using best practice accessibility and the latest W3C web standards guidelines, resulting in semantic and seo friendly XHTML and CSS. If you’re interested in our services, please send us a message through the form below.</p>\r\n<div class=\"clear\"></div>','[Contact]Contact message','full_html'),(4,'<div id=\"googlemaps\">\r\n<iframe style=\"width: 100%;\" scrolling=\"no\" height=\"250\" frameborder=\"0\" src=\"http://maps.google.com/maps?f=q&amp;source=s_q&amp;hl=en&amp;geocode=&amp;q=seattle&amp;aq=&amp;sll=22.447841,114.109497&amp;sspn=0.448038,0.550003&amp;vpsrc=0&amp;ie=UTF8&amp;hq=&amp;hnear=%E0%B8%8B%E0%B8%B5%E0%B9%81%E0%B8%AD%E0%B8%95%E0%B9%80%E0%B8%97%E0%B8%B4%E0%B8%A5+King,+%E0%B8%A3%E0%B8%B1%E0%B8%90%E0%B8%A7%E0%B8%AD%E0%B8%8A%E0%B8%B4%E0%B8%87%E0%B8%95%E0%B8%B1%E0%B8%99+%E0%B8%AA%E0%B8%AB%E0%B8%A3%E0%B8%B1%E0%B8%90%E0%B8%AD%E0%B9%80%E0%B8%A1%E0%B8%A3%E0%B8%B4%E0%B8%81%E0%B8%B2&amp;t=m&amp;z=12&amp;ll=47.60621,-122.332071&amp;output=embed\" marginwidth=\"0\" marginheight=\"0\"></iframe>\r\n</div>','Google map embed','full_html'),(5,'<div id=\"social\" class=\"tooltips\">\r\n  <ul>\r\n    <li><a href=\"#\" rel=\"tooltip\" title=\"Facebook\" class=\"facebook\">Facebook</a></li>\r\n    <li><a href=\"#\" rel=\"tooltip\" title=\"Evernote\" class=\"evernote\">Evernote</a></li>\r\n    <li><a href=\"#\" rel=\"tooltip\" title=\"LinkedIn\" class=\"linkedin\">LinkedIn</a></li>\r\n    <li><a href=\"#\" rel=\"tooltip\" title=\"Google Plus\" class=\"googleplus\">Google Plus</a></li>\r\n    <li><a href=\"#\" rel=\"tooltip\" title=\"Vimeo\" class=\"vimeo\">Vimeo</a></li>\r\n  </ul>\r\n</div>','Sidebar contact social links','full_html'),(6,'<div class=\"icon-box-container\">\r\n\r\n  <!-- Icon Box Start -->\r\n  <div class=\"one-third column\">\r\n    <div class=\"icon-box\">\r\n      <i class=\"ico-display\" style=\"margin-left: -10px;\"></i>\r\n      <h3>Fresh &amp; Clean Design</h3>\r\n      <p>Proin iaculis purus consequat sem cure digni ssim. Donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt.</p>\r\n    </div>\r\n  </div>\r\n  <!-- Icon Box End -->\r\n\r\n  <!-- Icon Box Start -->\r\n  <div class=\"one-third column\">\r\n    <div class=\"icon-box\">\r\n      <i class=\"ico-cogwheel\"></i>\r\n      <h3>Easily Customization</h3>\r\n      <p>Nam aliquam volutpat leo vel bibendum nunc elit purus, tempus pulvinare rhoncus egestas nibh volutpat leo.</p>\r\n    </div>\r\n  </div>\r\n  <!-- Icon Box End -->\r\n\r\n  <!-- Icon Box Start -->\r\n  <div class=\"one-third column\">\r\n    <div class=\"icon-box\">\r\n      <i class=\"ico-iphone\"></i>\r\n      <h3>Fully Responsive</h3>\r\n      <p>Fusce porttitor turpis quis molestie costant equat. Nam purus, tincidunt sedeat dapibus ugravida ut dui. Fusce et magna libero.</p>\r\n    </div>\r\n  </div>\r\n  <!-- Icon Box End -->\r\n\r\n</div>','Home services box icons','full_html'),(7,'<div class=\"sixteen columns\">\r\n  <!-- Headline -->\r\n  <div class=\"headline no-margin\"><h3>Our Clients</h3></div>\r\n\r\n  <ul class=\"client-list\">\r\n    <li><img src=\"/sites/all/themes/centum/images/logo-01.png\" alt=\"\"/></li>\r\n    <li><img src=\"/sites/all/themes/centum/images/logo-02.png\" alt=\"\"/></li>\r\n    <li><img src=\"/sites/all/themes/centum/images/logo-03.png\" alt=\"\"/></li>\r\n    <li><img src=\"/sites/all/themes/centum/images/logo-04.png\" alt=\"\"/></li>\r\n    <li><img src=\"/sites/all/themes/centum/images/logo-05.png\" alt=\"\"/></li>\r\n  </ul>\r\n\r\n</div>','Clients logo','full_html'),(8,'Donec sed odio dui. Nulla vitae elit liberopsu, alasa pharetra augue. Nullam id doore nieha ultricieseam vehicula ut idea elit. Integer posuererat.','text widget','full_html');
/*!40000 ALTER TABLE `block_custom` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `block_node_type`
--

DROP TABLE IF EXISTS `block_node_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_node_type` (
  `module` varchar(64) NOT NULL COMMENT 'The block’s origin module, from block.module.',
  `delta` varchar(32) NOT NULL COMMENT 'The block’s unique delta within module, from block.delta.',
  `type` varchar(32) NOT NULL COMMENT 'The machine-readable name of this type from node_type.type.',
  PRIMARY KEY (`module`,`delta`,`type`),
  KEY `type` (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sets up display criteria for blocks based on content types';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_node_type`
--

LOCK TABLES `block_node_type` WRITE;
/*!40000 ALTER TABLE `block_node_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `block_node_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `block_role`
--

DROP TABLE IF EXISTS `block_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `block_role` (
  `module` varchar(64) NOT NULL COMMENT 'The block’s origin module, from block.module.',
  `delta` varchar(32) NOT NULL COMMENT 'The block’s unique delta within module, from block.delta.',
  `rid` int(10) unsigned NOT NULL COMMENT 'The user’s role ID from users_roles.rid.',
  PRIMARY KEY (`module`,`delta`,`rid`),
  KEY `rid` (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sets up access permissions for blocks based on user roles';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `block_role`
--

LOCK TABLES `block_role` WRITE;
/*!40000 ALTER TABLE `block_role` DISABLE KEYS */;
/*!40000 ALTER TABLE `block_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `blocked_ips`
--

DROP TABLE IF EXISTS `blocked_ips`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `blocked_ips` (
  `iid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: unique ID for IP addresses.',
  `ip` varchar(40) NOT NULL DEFAULT '' COMMENT 'IP address',
  PRIMARY KEY (`iid`),
  KEY `blocked_ip` (`ip`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores blocked IP addresses.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `blocked_ips`
--

LOCK TABLES `blocked_ips` WRITE;
/*!40000 ALTER TABLE `blocked_ips` DISABLE KEYS */;
/*!40000 ALTER TABLE `blocked_ips` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache`
--

DROP TABLE IF EXISTS `cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache`
--

LOCK TABLES `cache` WRITE;
/*!40000 ALTER TABLE `cache` DISABLE KEYS */;
INSERT INTO `cache` VALUES ('entity_info:en','a:7:{s:7:\"comment\";a:14:{s:5:\"label\";s:7:\"Comment\";s:10:\"base table\";s:7:\"comment\";s:12:\"uri callback\";s:11:\"comment_uri\";s:9:\"fieldable\";b:1;s:16:\"controller class\";s:17:\"CommentController\";s:11:\"entity keys\";a:5:{s:2:\"id\";s:3:\"cid\";s:6:\"bundle\";s:9:\"node_type\";s:5:\"label\";s:7:\"subject\";s:8:\"language\";s:8:\"language\";s:8:\"revision\";s:0:\"\";}s:7:\"bundles\";a:4:{s:20:\"comment_node_article\";a:4:{s:5:\"label\";s:15:\"Article comment\";s:11:\"node bundle\";s:7:\"article\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:44:\"admin/structure/types/manage/article/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}s:17:\"comment_node_page\";a:4:{s:5:\"label\";s:18:\"Basic page comment\";s:11:\"node bundle\";s:4:\"page\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:41:\"admin/structure/types/manage/page/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}s:17:\"comment_node_blog\";a:4:{s:5:\"label\";s:18:\"Blog entry comment\";s:11:\"node bundle\";s:4:\"blog\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:41:\"admin/structure/types/manage/blog/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}s:22:\"comment_node_portfolio\";a:4:{s:5:\"label\";s:17:\"Portfolio comment\";s:11:\"node bundle\";s:9:\"portfolio\";s:5:\"admin\";a:4:{s:4:\"path\";s:55:\"admin/structure/types/manage/%comment_node_type/comment\";s:15:\"bundle argument\";i:4;s:9:\"real path\";s:46:\"admin/structure/types/manage/portfolio/comment\";s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:8:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:13:\"sioct:Comment\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:12:\"comment_body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"pid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"sioc:reply_of\";}s:4:\"type\";s:3:\"rel\";}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}}}}s:10:\"view modes\";a:2:{s:4:\"full\";a:2:{s:5:\"label\";s:12:\"Full comment\";s:15:\"custom settings\";b:0;}s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:12:\"static cache\";b:0;s:11:\"field cache\";b:1;s:9:\"load hook\";s:12:\"comment_load\";s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:14:{i:0;s:3:\"cid\";i:1;s:3:\"pid\";i:2;s:3:\"nid\";i:3;s:3:\"uid\";i:4;s:7:\"subject\";i:5;s:8:\"hostname\";i:6;s:7:\"created\";i:7;s:7:\"changed\";i:8;s:6:\"status\";i:9;s:6:\"thread\";i:10;s:4:\"name\";i:11;s:4:\"mail\";i:12;s:8:\"homepage\";i:13;s:8:\"language\";}}s:10:\"token type\";s:7:\"comment\";}s:4:\"node\";a:16:{s:5:\"label\";s:4:\"Node\";s:16:\"controller class\";s:14:\"NodeController\";s:10:\"base table\";s:4:\"node\";s:14:\"revision table\";s:13:\"node_revision\";s:12:\"uri callback\";s:8:\"node_uri\";s:9:\"fieldable\";b:1;s:11:\"entity keys\";a:5:{s:2:\"id\";s:3:\"nid\";s:8:\"revision\";s:3:\"vid\";s:6:\"bundle\";s:4:\"type\";s:5:\"label\";s:5:\"title\";s:8:\"language\";s:8:\"language\";}s:11:\"bundle keys\";a:1:{s:6:\"bundle\";s:4:\"type\";}s:7:\"bundles\";a:4:{s:7:\"article\";a:3:{s:5:\"label\";s:7:\"Article\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:36:\"admin/structure/types/manage/article\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:11:{s:11:\"field_image\";a:2:{s:10:\"predicates\";a:2:{i:0;s:8:\"og:image\";i:1;s:12:\"rdfs:seeAlso\";}s:4:\"type\";s:3:\"rel\";}s:10:\"field_tags\";a:2:{s:10:\"predicates\";a:1:{i:0;s:10:\"dc:subject\";}s:4:\"type\";s:3:\"rel\";}s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Item\";i:1;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}s:4:\"page\";a:3:{s:5:\"label\";s:10:\"Basic page\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:33:\"admin/structure/types/manage/page\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:9:{s:7:\"rdftype\";a:1:{i:0;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}s:4:\"blog\";a:3:{s:5:\"label\";s:10:\"Blog entry\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:33:\"admin/structure/types/manage/blog\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:9:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:14:\"sioct:BlogPost\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}s:9:\"portfolio\";a:3:{s:5:\"label\";s:9:\"Portfolio\";s:5:\"admin\";a:4:{s:4:\"path\";s:39:\"admin/structure/types/manage/%node_type\";s:9:\"real path\";s:38:\"admin/structure/types/manage/portfolio\";s:15:\"bundle argument\";i:4;s:16:\"access arguments\";a:1:{i:0;s:24:\"administer content types\";}}s:11:\"rdf_mapping\";a:9:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Item\";i:1;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}}}s:10:\"view modes\";a:6:{s:4:\"full\";a:2:{s:5:\"label\";s:12:\"Full content\";s:15:\"custom settings\";b:0;}s:6:\"teaser\";a:2:{s:5:\"label\";s:6:\"Teaser\";s:15:\"custom settings\";b:1;}s:3:\"rss\";a:2:{s:5:\"label\";s:3:\"RSS\";s:15:\"custom settings\";b:0;}s:12:\"search_index\";a:2:{s:5:\"label\";s:12:\"Search index\";s:15:\"custom settings\";b:0;}s:13:\"search_result\";a:2:{s:5:\"label\";s:13:\"Search result\";s:15:\"custom settings\";b:0;}s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:9:\"node_load\";s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:2:{s:10:\"base table\";a:14:{i:0;s:3:\"nid\";i:1;s:3:\"vid\";i:2;s:4:\"type\";i:3;s:8:\"language\";i:4;s:5:\"title\";i:5;s:3:\"uid\";i:6;s:6:\"status\";i:7;s:7:\"created\";i:8;s:7:\"changed\";i:9;s:7:\"comment\";i:10;s:7:\"promote\";i:11;s:6:\"sticky\";i:12;s:4:\"tnid\";i:13;s:9:\"translate\";}s:14:\"revision table\";a:10:{i:0;s:3:\"nid\";i:1;s:3:\"vid\";i:2;s:3:\"uid\";i:3;s:5:\"title\";i:4;s:3:\"log\";i:5;s:9:\"timestamp\";i:6;s:6:\"status\";i:7;s:7:\"comment\";i:8;s:7:\"promote\";i:9;s:6:\"sticky\";}}s:10:\"token type\";s:4:\"node\";}s:4:\"file\";a:13:{s:5:\"label\";s:4:\"File\";s:10:\"base table\";s:12:\"file_managed\";s:11:\"entity keys\";a:4:{s:2:\"id\";s:3:\"fid\";s:5:\"label\";s:8:\"filename\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";}s:12:\"static cache\";b:0;s:9:\"fieldable\";b:0;s:16:\"controller class\";s:29:\"DrupalDefaultEntityController\";s:11:\"field cache\";b:1;s:9:\"load hook\";s:9:\"file_load\";s:7:\"bundles\";a:1:{s:4:\"file\";a:2:{s:5:\"label\";s:4:\"File\";s:11:\"rdf_mapping\";a:0:{}}}s:10:\"view modes\";a:0:{}s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:8:{i:0;s:3:\"fid\";i:1;s:3:\"uid\";i:2;s:8:\"filename\";i:3;s:3:\"uri\";i:4;s:8:\"filemime\";i:5;s:8:\"filesize\";i:6;s:6:\"status\";i:7;s:9:\"timestamp\";}}s:10:\"token type\";s:4:\"file\";}s:13:\"taxonomy_term\";a:15:{s:5:\"label\";s:13:\"Taxonomy term\";s:16:\"controller class\";s:22:\"TaxonomyTermController\";s:10:\"base table\";s:18:\"taxonomy_term_data\";s:12:\"uri callback\";s:17:\"taxonomy_term_uri\";s:9:\"fieldable\";b:1;s:11:\"entity keys\";a:4:{s:2:\"id\";s:3:\"tid\";s:6:\"bundle\";s:23:\"vocabulary_machine_name\";s:5:\"label\";s:4:\"name\";s:8:\"revision\";s:0:\"\";}s:11:\"bundle keys\";a:1:{s:6:\"bundle\";s:12:\"machine_name\";}s:7:\"bundles\";a:2:{s:4:\"tags\";a:3:{s:5:\"label\";s:4:\"Tags\";s:5:\"admin\";a:4:{s:4:\"path\";s:58:\"admin/structure/taxonomy/%taxonomy_vocabulary_machine_name\";s:9:\"real path\";s:29:\"admin/structure/taxonomy/tags\";s:15:\"bundle argument\";i:3;s:16:\"access arguments\";a:1:{i:0;s:19:\"administer taxonomy\";}}s:11:\"rdf_mapping\";a:5:{s:7:\"rdftype\";a:1:{i:0;s:12:\"skos:Concept\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:2:{i:0;s:10:\"rdfs:label\";i:1;s:14:\"skos:prefLabel\";}}s:11:\"description\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"skos:definition\";}}s:3:\"vid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"skos:inScheme\";}s:4:\"type\";s:3:\"rel\";}s:6:\"parent\";a:2:{s:10:\"predicates\";a:1:{i:0;s:12:\"skos:broader\";}s:4:\"type\";s:3:\"rel\";}}}s:20:\"portfolio_categories\";a:3:{s:5:\"label\";s:20:\"Portfolio categories\";s:5:\"admin\";a:4:{s:4:\"path\";s:58:\"admin/structure/taxonomy/%taxonomy_vocabulary_machine_name\";s:9:\"real path\";s:45:\"admin/structure/taxonomy/portfolio_categories\";s:15:\"bundle argument\";i:3;s:16:\"access arguments\";a:1:{i:0;s:19:\"administer taxonomy\";}}s:11:\"rdf_mapping\";a:5:{s:7:\"rdftype\";a:1:{i:0;s:12:\"skos:Concept\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:2:{i:0;s:10:\"rdfs:label\";i:1;s:14:\"skos:prefLabel\";}}s:11:\"description\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"skos:definition\";}}s:3:\"vid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:13:\"skos:inScheme\";}s:4:\"type\";s:3:\"rel\";}s:6:\"parent\";a:2:{s:10:\"predicates\";a:1:{i:0;s:12:\"skos:broader\";}s:4:\"type\";s:3:\"rel\";}}}}s:10:\"view modes\";a:2:{s:4:\"full\";a:2:{s:5:\"label\";s:18:\"Taxonomy term page\";s:15:\"custom settings\";b:0;}s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:18:\"taxonomy_term_load\";s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:6:{i:0;s:3:\"tid\";i:1;s:3:\"vid\";i:2;s:4:\"name\";i:3;s:11:\"description\";i:4;s:6:\"format\";i:5;s:6:\"weight\";}}s:10:\"token type\";s:4:\"term\";}s:19:\"taxonomy_vocabulary\";a:13:{s:5:\"label\";s:19:\"Taxonomy vocabulary\";s:16:\"controller class\";s:28:\"TaxonomyVocabularyController\";s:10:\"base table\";s:19:\"taxonomy_vocabulary\";s:11:\"entity keys\";a:4:{s:2:\"id\";s:3:\"vid\";s:5:\"label\";s:4:\"name\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";}s:9:\"fieldable\";b:0;s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:24:\"taxonomy_vocabulary_load\";s:7:\"bundles\";a:1:{s:19:\"taxonomy_vocabulary\";a:2:{s:5:\"label\";s:19:\"Taxonomy vocabulary\";s:11:\"rdf_mapping\";a:3:{s:7:\"rdftype\";a:1:{i:0;s:18:\"skos:ConceptScheme\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:11:\"description\";a:1:{s:10:\"predicates\";a:1:{i:0;s:12:\"rdfs:comment\";}}}}}s:10:\"view modes\";a:0:{}s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:7:{i:0;s:3:\"vid\";i:1;s:4:\"name\";i:2;s:12:\"machine_name\";i:3;s:11:\"description\";i:4;s:9:\"hierarchy\";i:5;s:6:\"module\";i:6;s:6:\"weight\";}}s:10:\"token type\";s:10:\"vocabulary\";}s:4:\"user\";a:15:{s:5:\"label\";s:4:\"User\";s:16:\"controller class\";s:14:\"UserController\";s:10:\"base table\";s:5:\"users\";s:12:\"uri callback\";s:8:\"user_uri\";s:14:\"label callback\";s:15:\"format_username\";s:9:\"fieldable\";b:1;s:11:\"entity keys\";a:3:{s:2:\"id\";s:3:\"uid\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";}s:7:\"bundles\";a:1:{s:4:\"user\";a:3:{s:5:\"label\";s:4:\"User\";s:5:\"admin\";a:2:{s:4:\"path\";s:28:\"admin/config/people/accounts\";s:16:\"access arguments\";a:1:{i:0;s:16:\"administer users\";}}s:11:\"rdf_mapping\";a:3:{s:7:\"rdftype\";a:1:{i:0;s:16:\"sioc:UserAccount\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:8:\"homepage\";a:2:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:page\";}s:4:\"type\";s:3:\"rel\";}}}}s:10:\"view modes\";a:2:{s:4:\"full\";a:2:{s:5:\"label\";s:12:\"User account\";s:15:\"custom settings\";b:0;}s:5:\"token\";a:2:{s:5:\"label\";s:6:\"Tokens\";s:15:\"custom settings\";b:0;}}s:12:\"static cache\";b:1;s:11:\"field cache\";b:1;s:9:\"load hook\";s:9:\"user_load\";s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:16:{i:0;s:3:\"uid\";i:1;s:4:\"name\";i:2;s:4:\"pass\";i:3;s:4:\"mail\";i:4;s:5:\"theme\";i:5;s:9:\"signature\";i:6;s:16:\"signature_format\";i:7;s:7:\"created\";i:8;s:6:\"access\";i:9;s:5:\"login\";i:10;s:6:\"status\";i:11;s:8:\"timezone\";i:12;s:8:\"language\";i:13;s:7:\"picture\";i:14;s:4:\"init\";i:15;s:4:\"data\";}}s:10:\"token type\";s:4:\"user\";}s:15:\"wysiwyg_profile\";a:13:{s:5:\"label\";s:15:\"Wysiwyg profile\";s:10:\"base table\";s:7:\"wysiwyg\";s:16:\"controller class\";s:24:\"WysiwygProfileController\";s:9:\"fieldable\";b:0;s:12:\"static cache\";b:0;s:11:\"entity keys\";a:3:{s:2:\"id\";s:6:\"format\";s:8:\"revision\";s:0:\"\";s:6:\"bundle\";s:0:\"\";}s:11:\"field cache\";b:1;s:9:\"load hook\";s:20:\"wysiwyg_profile_load\";s:7:\"bundles\";a:1:{s:15:\"wysiwyg_profile\";a:2:{s:5:\"label\";s:15:\"Wysiwyg profile\";s:11:\"rdf_mapping\";a:0:{}}}s:10:\"view modes\";a:0:{}s:11:\"translation\";a:0:{}s:17:\"schema_fields_sql\";a:1:{s:10:\"base table\";a:3:{i:0;s:6:\"format\";i:1;s:6:\"editor\";i:2;s:8:\"settings\";}}s:10:\"token type\";s:15:\"wysiwyg_profile\";}}',0,1362626465,1),('node_types:en','O:8:\"stdClass\":2:{s:5:\"types\";a:4:{s:4:\"blog\";O:8:\"stdClass\":14:{s:4:\"type\";s:4:\"blog\";s:4:\"name\";s:10:\"Blog entry\";s:4:\"base\";s:4:\"blog\";s:6:\"module\";s:4:\"blog\";s:11:\"description\";s:58:\"Use for multi-user blogs. Every user gets a personal blog.\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:5:\"Title\";s:6:\"custom\";s:1:\"0\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"1\";s:8:\"disabled\";b:0;s:9:\"orig_type\";s:4:\"blog\";s:16:\"disabled_changed\";b:0;}s:7:\"article\";O:8:\"stdClass\":14:{s:4:\"type\";s:7:\"article\";s:4:\"name\";s:7:\"Article\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:89:\"Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:5:\"Title\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:7:\"article\";s:16:\"disabled_changed\";b:0;}s:4:\"page\";O:8:\"stdClass\":14:{s:4:\"type\";s:4:\"page\";s:4:\"name\";s:10:\"Basic page\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:77:\"Use <em>basic pages</em> for your static content, such as an \'About us\' page.\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:5:\"Title\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:4:\"page\";s:16:\"disabled_changed\";b:0;}s:9:\"portfolio\";O:8:\"stdClass\":14:{s:4:\"type\";s:9:\"portfolio\";s:4:\"name\";s:9:\"Portfolio\";s:4:\"base\";s:12:\"node_content\";s:6:\"module\";s:4:\"node\";s:11:\"description\";s:18:\"Portfolio content.\";s:4:\"help\";s:0:\"\";s:9:\"has_title\";s:1:\"1\";s:11:\"title_label\";s:5:\"Title\";s:6:\"custom\";s:1:\"1\";s:8:\"modified\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:8:\"disabled\";s:1:\"0\";s:9:\"orig_type\";s:9:\"portfolio\";s:16:\"disabled_changed\";b:0;}}s:5:\"names\";a:4:{s:7:\"article\";s:7:\"Article\";s:4:\"page\";s:10:\"Basic page\";s:4:\"blog\";s:10:\"Blog entry\";s:9:\"portfolio\";s:9:\"Portfolio\";}}',0,1362626465,1),('schema:runtime:','a:9:{s:7:\"comment\";a:6:{s:6:\"fields\";a:14:{s:3:\"cid\";a:2:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;}s:3:\"pid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"nid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"subject\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"hostname\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"changed\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:1;s:4:\"size\";s:4:\"tiny\";}s:6:\"thread\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:4:\"name\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:8:\"not null\";b:0;}s:4:\"mail\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:64;s:8:\"not null\";b:0;}s:8:\"homepage\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}}s:7:\"indexes\";a:5:{s:18:\"comment_status_pid\";a:2:{i:0;s:3:\"pid\";i:1;s:6:\"status\";}s:15:\"comment_num_new\";a:5:{i:0;s:3:\"nid\";i:1;s:6:\"status\";i:2;s:7:\"created\";i:3;s:3:\"cid\";i:4;s:6:\"thread\";}s:11:\"comment_uid\";a:1:{i:0;s:3:\"uid\";}s:20:\"comment_nid_language\";a:2:{i:0;s:3:\"nid\";i:1;s:8:\"language\";}s:15:\"comment_created\";a:1:{i:0;s:7:\"created\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"cid\";}s:12:\"foreign keys\";a:2:{s:12:\"comment_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:14:\"comment_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:7:\"comment\";s:4:\"name\";s:7:\"comment\";}s:4:\"node\";a:7:{s:6:\"fields\";a:14:{s:3:\"nid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;s:7:\"default\";N;}s:4:\"type\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"changed\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"comment\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"tnid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:9:\"translate\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:9:{s:12:\"node_changed\";a:1:{i:0;s:7:\"changed\";}s:12:\"node_created\";a:1:{i:0;s:7:\"created\";}s:14:\"node_frontpage\";a:4:{i:0;s:7:\"promote\";i:1;s:6:\"status\";i:2;s:6:\"sticky\";i:3;s:7:\"created\";}s:16:\"node_status_type\";a:3:{i:0;s:6:\"status\";i:1;s:4:\"type\";i:2;s:3:\"nid\";}s:15:\"node_title_type\";a:2:{i:0;s:5:\"title\";i:1;a:2:{i:0;s:4:\"type\";i:1;i:4;}}s:9:\"node_type\";a:1:{i:0;a:2:{i:0;s:4:\"type\";i:1;i:4;}}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}s:4:\"tnid\";a:1:{i:0;s:4:\"tnid\";}s:9:\"translate\";a:1:{i:0;s:9:\"translate\";}}s:11:\"unique keys\";a:1:{s:3:\"vid\";a:1:{i:0;s:3:\"vid\";}}s:12:\"foreign keys\";a:2:{s:13:\"node_revision\";a:2:{s:5:\"table\";s:13:\"node_revision\";s:7:\"columns\";a:1:{s:3:\"vid\";s:3:\"vid\";}}s:11:\"node_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:11:\"primary key\";a:1:{i:0;s:3:\"nid\";}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:4:\"node\";}s:13:\"node_revision\";a:6:{s:6:\"fields\";a:10:{s:3:\"nid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:3:\"vid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"uid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"title\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"log\";a:3:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:1;s:4:\"size\";s:3:\"big\";}s:9:\"timestamp\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:1;}s:7:\"comment\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:7:\"promote\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"sticky\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:2:{s:3:\"nid\";a:1:{i:0;s:3:\"nid\";}s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:12:\"foreign keys\";a:2:{s:14:\"versioned_node\";a:2:{s:5:\"table\";s:4:\"node\";s:7:\"columns\";a:1:{s:3:\"nid\";s:3:\"nid\";}}s:14:\"version_author\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:4:\"node\";s:4:\"name\";s:13:\"node_revision\";}s:12:\"file_managed\";a:7:{s:6:\"fields\";a:8:{s:3:\"fid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:8:\"filename\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:3:\"uri\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:6:\"binary\";b:1;}s:8:\"filemime\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"filesize\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:9:\"timestamp\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:7:\"indexes\";a:3:{s:3:\"uid\";a:1:{i:0;s:3:\"uid\";}s:6:\"status\";a:1:{i:0;s:6:\"status\";}s:9:\"timestamp\";a:1:{i:0;s:9:\"timestamp\";}}s:11:\"unique keys\";a:1:{s:3:\"uri\";a:1:{i:0;s:3:\"uri\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"fid\";}s:12:\"foreign keys\";a:1:{s:10:\"file_owner\";a:2:{s:5:\"table\";s:5:\"users\";s:7:\"columns\";a:1:{s:3:\"uid\";s:3:\"uid\";}}}s:6:\"module\";s:6:\"system\";s:4:\"name\";s:12:\"file_managed\";}s:18:\"taxonomy_term_data\";a:6:{s:6:\"fields\";a:6:{s:3:\"tid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:3:\"vid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:11:\"description\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:12:\"translatable\";b:1;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"tid\";}s:12:\"foreign keys\";a:1:{s:10:\"vocabulary\";a:2:{s:5:\"table\";s:19:\"taxonomy_vocabulary\";s:7:\"columns\";a:1:{s:3:\"vid\";s:3:\"vid\";}}}s:7:\"indexes\";a:3:{s:13:\"taxonomy_tree\";a:3:{i:0;s:3:\"vid\";i:1;s:6:\"weight\";i:2;s:4:\"name\";}s:8:\"vid_name\";a:2:{i:0;s:3:\"vid\";i:1;s:4:\"name\";}s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:6:\"module\";s:8:\"taxonomy\";s:4:\"name\";s:18:\"taxonomy_term_data\";}s:19:\"taxonomy_vocabulary\";a:6:{s:6:\"fields\";a:7:{s:3:\"vid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;}s:4:\"name\";a:5:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";s:12:\"translatable\";b:1;}s:12:\"machine_name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:11:\"description\";a:4:{s:4:\"type\";s:4:\"text\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:12:\"translatable\";b:1;}s:9:\"hierarchy\";a:5:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:6:\"module\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:6:\"weight\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}}s:11:\"primary key\";a:1:{i:0;s:3:\"vid\";}s:7:\"indexes\";a:1:{s:4:\"list\";a:2:{i:0;s:6:\"weight\";i:1;s:4:\"name\";}}s:11:\"unique keys\";a:1:{s:12:\"machine_name\";a:1:{i:0;s:12:\"machine_name\";}}s:6:\"module\";s:8:\"taxonomy\";s:4:\"name\";s:19:\"taxonomy_vocabulary\";}s:5:\"users\";a:7:{s:6:\"fields\";a:16:{s:3:\"uid\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"name\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:60;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"pass\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:4:\"mail\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;s:7:\"default\";s:0:\"\";}s:5:\"theme\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:9:\"signature\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:16:\"signature_format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}s:7:\"created\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"access\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:5:\"login\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:6:\"status\";a:4:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;s:4:\"size\";s:4:\"tiny\";}s:8:\"timezone\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:32;s:8:\"not null\";b:0;}s:8:\"language\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:12;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:7:\"picture\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:1;s:7:\"default\";i:0;}s:4:\"init\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:254;s:8:\"not null\";b:0;s:7:\"default\";s:0:\"\";}s:4:\"data\";a:4:{s:4:\"type\";s:4:\"blob\";s:8:\"not null\";b:0;s:4:\"size\";s:3:\"big\";s:9:\"serialize\";b:1;}}s:7:\"indexes\";a:4:{s:6:\"access\";a:1:{i:0;s:6:\"access\";}s:7:\"created\";a:1:{i:0;s:7:\"created\";}s:4:\"mail\";a:1:{i:0;s:4:\"mail\";}s:7:\"picture\";a:1:{i:0;s:7:\"picture\";}}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:11:\"primary key\";a:1:{i:0;s:3:\"uid\";}s:12:\"foreign keys\";a:1:{s:16:\"signature_format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:16:\"signature_format\";s:6:\"format\";}}}s:6:\"module\";s:4:\"user\";s:4:\"name\";s:5:\"users\";}s:7:\"wysiwyg\";a:5:{s:6:\"fields\";a:3:{s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:1;}s:6:\"editor\";a:4:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:128;s:8:\"not null\";b:1;s:7:\"default\";s:0:\"\";}s:8:\"settings\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:6:\"normal\";s:9:\"serialize\";b:1;}}s:11:\"primary key\";a:1:{i:0;s:6:\"format\";}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:6:\"module\";s:7:\"wysiwyg\";s:4:\"name\";s:7:\"wysiwyg\";}s:18:\"page_manager_pages\";a:7:{s:6:\"export\";a:4:{s:10:\"identifier\";s:4:\"page\";s:11:\"bulk export\";b:1;s:15:\"export callback\";s:24:\"page_manager_page_export\";s:3:\"api\";a:4:{s:5:\"owner\";s:12:\"page_manager\";s:3:\"api\";s:13:\"pages_default\";s:15:\"minimum_version\";i:1;s:15:\"current_version\";i:1;}}s:6:\"fields\";a:10:{s:3:\"pid\";a:3:{s:4:\"type\";s:6:\"serial\";s:8:\"not null\";b:1;s:9:\"no export\";b:1;}s:4:\"name\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:4:\"task\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:2:\"64\";s:7:\"default\";s:4:\"page\";}s:11:\"admin_title\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:17:\"admin_description\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:14:\"object default\";s:0:\"\";}s:4:\"path\";a:2:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";}s:6:\"access\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}s:4:\"menu\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}s:9:\"arguments\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}s:4:\"conf\";a:5:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:1;s:9:\"serialize\";b:1;s:14:\"object default\";a:0:{}}}s:11:\"primary key\";a:1:{i:0;s:3:\"pid\";}s:11:\"unique keys\";a:1:{s:4:\"name\";a:1:{i:0;s:4:\"name\";}}s:7:\"indexes\";a:1:{s:4:\"task\";a:1:{i:0;s:4:\"task\";}}s:6:\"module\";s:12:\"page_manager\";s:4:\"name\";s:18:\"page_manager_pages\";}}',0,1362626460,1);
/*!40000 ALTER TABLE `cache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_admin_menu`
--

DROP TABLE IF EXISTS `cache_admin_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_admin_menu` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for Administration menu to store client-side...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_admin_menu`
--

LOCK TABLES `cache_admin_menu` WRITE;
/*!40000 ALTER TABLE `cache_admin_menu` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_admin_menu` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_block`
--

DROP TABLE IF EXISTS `cache_block`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_block` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the Block module to store already built...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_block`
--

LOCK TABLES `cache_block` WRITE;
/*!40000 ALTER TABLE `cache_block` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_block` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_bootstrap`
--

DROP TABLE IF EXISTS `cache_bootstrap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_bootstrap` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for data required to bootstrap Drupal, may be...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_bootstrap`
--

LOCK TABLES `cache_bootstrap` WRITE;
/*!40000 ALTER TABLE `cache_bootstrap` DISABLE KEYS */;
INSERT INTO `cache_bootstrap` VALUES ('bootstrap_modules','a:3:{s:5:\"dblog\";O:8:\"stdClass\":2:{s:4:\"name\";s:5:\"dblog\";s:8:\"filename\";s:26:\"modules/dblog/dblog.module\";}s:7:\"overlay\";O:8:\"stdClass\":2:{s:4:\"name\";s:7:\"overlay\";s:8:\"filename\";s:30:\"modules/overlay/overlay.module\";}s:6:\"system\";O:8:\"stdClass\":2:{s:4:\"name\";s:6:\"system\";s:8:\"filename\";s:28:\"modules/system/system.module\";}}',0,1362626465,1),('hook_info','a:6:{s:10:\"token_info\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:16:\"token_info_alter\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:6:\"tokens\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:12:\"tokens_alter\";a:1:{s:5:\"group\";s:6:\"tokens\";}s:8:\"pathauto\";a:1:{s:5:\"group\";s:8:\"pathauto\";}s:16:\"path_alias_types\";a:1:{s:5:\"group\";s:8:\"pathauto\";}}',0,1362626465,1),('system_list','a:3:{s:14:\"module_enabled\";a:45:{s:5:\"block\";O:8:\"stdClass\":9:{s:8:\"filename\";s:26:\"modules/block/block.module\";s:4:\"name\";s:5:\"block\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7008\";s:6:\"weight\";s:2:\"-5\";s:4:\"info\";a:12:{s:4:\"name\";s:5:\"Block\";s:11:\"description\";s:140:\"Controls the visual building blocks a page is constructed with. Blocks are boxes of content rendered into an area, or region, of a web page.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"block.test\";}s:9:\"configure\";s:21:\"admin/structure/block\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"blog\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/blog/blog.module\";s:4:\"name\";s:4:\"blog\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:4:\"Blog\";s:11:\"description\";s:25:\"Enables multi-user blogs.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"blog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:5:\"color\";O:8:\"stdClass\":9:{s:8:\"filename\";s:26:\"modules/color/color.module\";s:4:\"name\";s:5:\"color\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:5:\"Color\";s:11:\"description\";s:70:\"Allows administrators to change the color scheme of compatible themes.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"color.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:7:\"comment\";O:8:\"stdClass\":9:{s:8:\"filename\";s:30:\"modules/comment/comment.module\";s:4:\"name\";s:7:\"comment\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7009\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:7:\"Comment\";s:11:\"description\";s:57:\"Allows users to comment on and discuss published content.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"text\";}s:5:\"files\";a:2:{i:0;s:14:\"comment.module\";i:1;s:12:\"comment.test\";}s:9:\"configure\";s:21:\"admin/content/comment\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:11:\"comment.css\";s:27:\"modules/comment/comment.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:7:\"contact\";O:8:\"stdClass\":9:{s:8:\"filename\";s:30:\"modules/contact/contact.module\";s:4:\"name\";s:7:\"contact\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7003\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:7:\"Contact\";s:11:\"description\";s:61:\"Enables the use of both personal and site-wide contact forms.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"contact.test\";}s:9:\"configure\";s:23:\"admin/structure/contact\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:10:\"contextual\";O:8:\"stdClass\":9:{s:8:\"filename\";s:36:\"modules/contextual/contextual.module\";s:4:\"name\";s:10:\"contextual\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:16:\"Contextual links\";s:11:\"description\";s:75:\"Provides contextual links to perform actions related to elements on a page.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"contextual.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"ctools\";O:8:\"stdClass\":9:{s:8:\"filename\";s:38:\"sites/all/modules/ctools/ctools.module\";s:4:\"name\";s:6:\"ctools\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"6007\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:11:\"Chaos tools\";s:11:\"description\";s:46:\"A library of helpful tools by Merlin of Chaos.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:5:\"files\";a:3:{i:0;s:20:\"includes/context.inc\";i:1;s:22:\"includes/math-expr.inc\";i:2;s:21:\"includes/stylizer.inc\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"custom\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"sites/all/modules/tabvn/custom/custom.module\";s:4:\"name\";s:6:\"custom\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:9:{s:4:\"name\";s:6:\"custom\";s:11:\"description\";s:13:\"Custom module\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Tabvn\";s:12:\"dependencies\";a:0:{}s:7:\"version\";N;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:9:\"dashboard\";O:8:\"stdClass\":9:{s:8:\"filename\";s:34:\"modules/dashboard/dashboard.module\";s:4:\"name\";s:9:\"dashboard\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:9:\"Dashboard\";s:11:\"description\";s:136:\"Provides a dashboard page in the administrative interface for organizing administrative tasks and tracking information within your site.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:5:\"files\";a:1:{i:0;s:14:\"dashboard.test\";}s:12:\"dependencies\";a:1:{i:0;s:5:\"block\";}s:9:\"configure\";s:25:\"admin/dashboard/customize\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:5:\"dblog\";O:8:\"stdClass\":9:{s:8:\"filename\";s:26:\"modules/dblog/dblog.module\";s:4:\"name\";s:5:\"dblog\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"1\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:16:\"Database logging\";s:11:\"description\";s:47:\"Logs and records system events to the database.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"dblog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:5:\"field\";O:8:\"stdClass\":9:{s:8:\"filename\";s:26:\"modules/field/field.module\";s:4:\"name\";s:5:\"field\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7002\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:5:\"Field\";s:11:\"description\";s:57:\"Field API to add fields to entities like nodes and users.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:12:\"field.module\";i:1;s:16:\"field.attach.inc\";i:2;s:16:\"tests/field.test\";}s:12:\"dependencies\";a:1:{i:0;s:17:\"field_sql_storage\";}s:8:\"required\";b:1;s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:15:\"theme/field.css\";s:29:\"modules/field/theme/field.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:17:\"field_sql_storage\";O:8:\"stdClass\":9:{s:8:\"filename\";s:64:\"modules/field/modules/field_sql_storage/field_sql_storage.module\";s:4:\"name\";s:17:\"field_sql_storage\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7002\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:17:\"Field SQL storage\";s:11:\"description\";s:37:\"Stores field data in an SQL database.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:22:\"field_sql_storage.test\";}s:8:\"required\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"field_ui\";O:8:\"stdClass\":9:{s:8:\"filename\";s:32:\"modules/field_ui/field_ui.module\";s:4:\"name\";s:8:\"field_ui\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:8:\"Field UI\";s:11:\"description\";s:33:\"User interface for the Field API.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:13:\"field_ui.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"file\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/file/file.module\";s:4:\"name\";s:4:\"file\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:4:\"File\";s:11:\"description\";s:26:\"Defines a file field type.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:15:\"tests/file.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"filter\";O:8:\"stdClass\":9:{s:8:\"filename\";s:28:\"modules/filter/filter.module\";s:4:\"name\";s:6:\"filter\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7010\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:6:\"Filter\";s:11:\"description\";s:43:\"Filters content in preparation for display.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"filter.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:28:\"admin/config/content/formats\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"help\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/help/help.module\";s:4:\"name\";s:4:\"help\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:4:\"Help\";s:11:\"description\";s:35:\"Manages the display of online help.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"help.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:5:\"image\";O:8:\"stdClass\":9:{s:8:\"filename\";s:26:\"modules/image/image.module\";s:4:\"name\";s:5:\"image\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7004\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:5:\"Image\";s:11:\"description\";s:34:\"Provides image manipulation tools.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"file\";}s:5:\"files\";a:1:{i:0;s:10:\"image.test\";}s:9:\"configure\";s:31:\"admin/config/media/image-styles\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}}s:4:\"imce\";O:8:\"stdClass\":9:{s:8:\"filename\";s:34:\"sites/all/modules/imce/imce.module\";s:4:\"name\";s:4:\"imce\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:4:\"IMCE\";s:11:\"description\";s:82:\"An image/file uploader and browser supporting personal directories and user quota.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Media\";s:9:\"configure\";s:23:\"admin/config/media/imce\";s:7:\"version\";s:7:\"7.x-1.7\";s:7:\"project\";s:4:\"imce\";s:9:\"datestamp\";s:10:\"1359476607\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:12:\"imce_wysiwyg\";O:8:\"stdClass\":9:{s:8:\"filename\";s:50:\"sites/all/modules/imce_wysiwyg/imce_wysiwyg.module\";s:4:\"name\";s:12:\"imce_wysiwyg\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:23:\"IMCE Wysiwyg API bridge\";s:11:\"description\";s:82:\"Makes IMCE available as plugin for client-side editors integrated via Wysiwyg API.\";s:7:\"package\";s:14:\"User interface\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:4:\"imce\";i:1;s:7:\"wysiwyg\";}s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:12:\"imce_wysiwyg\";s:9:\"datestamp\";s:10:\"1317851503\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:13:\"jquery_update\";O:8:\"stdClass\":9:{s:8:\"filename\";s:52:\"sites/all/modules/jquery_update/jquery_update.module\";s:4:\"name\";s:13:\"jquery_update\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7000\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:13:\"jQuery Update\";s:11:\"description\";s:53:\"Update jQuery and jQuery UI to a more recent version.\";s:7:\"package\";s:14:\"User interface\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:20:\"jquery_update.module\";i:1;s:21:\"jquery_update.install\";}s:9:\"configure\";s:38:\"admin/config/development/jquery_update\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:13:\"jquery_update\";s:9:\"datestamp\";s:10:\"1360375905\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"list\";O:8:\"stdClass\":9:{s:8:\"filename\";s:38:\"modules/field/modules/list/list.module\";s:4:\"name\";s:4:\"list\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7002\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:4:\"List\";s:11:\"description\";s:69:\"Defines list field types. Use with Options to create selection lists.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:7:\"options\";}s:5:\"files\";a:1:{i:0;s:15:\"tests/list.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"menu\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/menu/menu.module\";s:4:\"name\";s:4:\"menu\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7003\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:4:\"Menu\";s:11:\"description\";s:60:\"Allows administrators to customize the site navigation menu.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"menu.test\";}s:9:\"configure\";s:20:\"admin/structure/menu\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"node\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/node/node.module\";s:4:\"name\";s:4:\"node\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7013\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:4:\"Node\";s:11:\"description\";s:66:\"Allows content to be submitted to the site and displayed on pages.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:11:\"node.module\";i:1;s:9:\"node.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:21:\"admin/structure/types\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"node.css\";s:21:\"modules/node/node.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"number\";O:8:\"stdClass\":9:{s:8:\"filename\";s:42:\"modules/field/modules/number/number.module\";s:4:\"name\";s:6:\"number\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:6:\"Number\";s:11:\"description\";s:28:\"Defines numeric field types.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:11:\"number.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:7:\"options\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"modules/field/modules/options/options.module\";s:4:\"name\";s:7:\"options\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:7:\"Options\";s:11:\"description\";s:82:\"Defines selection, check box and radio button widgets for text and numeric fields.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:12:\"options.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:7:\"overlay\";O:8:\"stdClass\":9:{s:8:\"filename\";s:30:\"modules/overlay/overlay.module\";s:4:\"name\";s:7:\"overlay\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"1\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:7:\"Overlay\";s:11:\"description\";s:59:\"Displays the Drupal administration interface in an overlay.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:6:\"panels\";O:8:\"stdClass\":9:{s:8:\"filename\";s:38:\"sites/all/modules/panels/panels.module\";s:4:\"name\";s:6:\"panels\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7301\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:6:\"Panels\";s:11:\"description\";s:107:\"Core Panels display functions; provides no external UI, at least one other Panels module should be enabled.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Panels\";s:9:\"configure\";s:22:\"admin/structure/panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:5:{i:0;s:13:\"panels.module\";i:1;s:19:\"includes/common.inc\";i:2;s:19:\"includes/legacy.inc\";i:3;s:20:\"includes/plugins.inc\";i:4;s:48:\"plugins/views/panels_views_plugin_row_fields.inc\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1345319572\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"path\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/path/path.module\";s:4:\"name\";s:4:\"path\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:4:\"Path\";s:11:\"description\";s:28:\"Allows users to rename URLs.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"path.test\";}s:9:\"configure\";s:24:\"admin/config/search/path\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:9:\"portfolio\";O:8:\"stdClass\":9:{s:8:\"filename\";s:50:\"sites/all/modules/tabvn/portfolio/portfolio.module\";s:4:\"name\";s:9:\"portfolio\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:9:{s:4:\"name\";s:14:\"Portfolio page\";s:11:\"description\";s:14:\"Portfolio page\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Tabvn\";s:12:\"dependencies\";a:0:{}s:7:\"version\";N;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:3:\"rdf\";O:8:\"stdClass\":9:{s:8:\"filename\";s:22:\"modules/rdf/rdf.module\";s:4:\"name\";s:3:\"rdf\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:3:\"RDF\";s:11:\"description\";s:148:\"Enriches your content with metadata to let other applications (e.g. search engines, aggregators) better understand its relationships and attributes.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:8:\"rdf.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"search\";O:8:\"stdClass\":9:{s:8:\"filename\";s:28:\"modules/search/search.module\";s:4:\"name\";s:6:\"search\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7000\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:6:\"Search\";s:11:\"description\";s:36:\"Enables site-wide keyword searching.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:19:\"search.extender.inc\";i:1;s:11:\"search.test\";}s:9:\"configure\";s:28:\"admin/config/search/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"search.css\";s:25:\"modules/search/search.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"shortcut\";O:8:\"stdClass\":9:{s:8:\"filename\";s:32:\"modules/shortcut/shortcut.module\";s:4:\"name\";s:8:\"shortcut\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:8:\"Shortcut\";s:11:\"description\";s:60:\"Allows users to manage customizable lists of shortcut links.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:13:\"shortcut.test\";}s:9:\"configure\";s:36:\"admin/config/user-interface/shortcut\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"system\";O:8:\"stdClass\":9:{s:8:\"filename\";s:28:\"modules/system/system.module\";s:4:\"name\";s:6:\"system\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"1\";s:14:\"schema_version\";s:4:\"7077\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:6:\"System\";s:11:\"description\";s:54:\"Handles general site configuration for administrators.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:6:{i:0;s:19:\"system.archiver.inc\";i:1;s:15:\"system.mail.inc\";i:2;s:16:\"system.queue.inc\";i:3;s:14:\"system.tar.inc\";i:4;s:18:\"system.updater.inc\";i:5;s:11:\"system.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:19:\"admin/config/system\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:9:\"tagadelic\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"sites/all/modules/tagadelic/tagadelic.module\";s:4:\"name\";s:9:\"tagadelic\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"6100\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:9:\"Tagadelic\";s:11:\"description\";s:61:\"Tagadelic makes weighted tag clouds from your taxonomy terms.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:8:\"taxonomy\";}s:7:\"package\";s:8:\"Taxonomy\";s:9:\"configure\";s:30:\"admin/config/content/tagadelic\";s:5:\"files\";a:2:{i:0;s:16:\"tagadelic.module\";i:1;s:17:\"tagadelic.install\";}s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:9:\"tagadelic\";s:9:\"datestamp\";s:10:\"1328704746\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"taxonomy\";O:8:\"stdClass\":9:{s:8:\"filename\";s:32:\"modules/taxonomy/taxonomy.module\";s:4:\"name\";s:8:\"taxonomy\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7010\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:8:\"Taxonomy\";s:11:\"description\";s:38:\"Enables the categorization of content.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:7:\"options\";}s:5:\"files\";a:2:{i:0;s:15:\"taxonomy.module\";i:1;s:13:\"taxonomy.test\";}s:9:\"configure\";s:24:\"admin/structure/taxonomy\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}}s:4:\"text\";O:8:\"stdClass\":9:{s:8:\"filename\";s:38:\"modules/field/modules/text/text.module\";s:4:\"name\";s:4:\"text\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7000\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:13:{s:4:\"name\";s:4:\"Text\";s:11:\"description\";s:32:\"Defines simple text field types.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:9:\"text.test\";}s:8:\"required\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}}s:5:\"token\";O:8:\"stdClass\":9:{s:8:\"filename\";s:36:\"sites/all/modules/token/token.module\";s:4:\"name\";s:5:\"token\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:5:\"Token\";s:11:\"description\";s:73:\"Provides a user interface for the Token API and some missing core tokens.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"token.test\";}s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1361665026\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:7:\"toolbar\";O:8:\"stdClass\":9:{s:8:\"filename\";s:30:\"modules/toolbar/toolbar.module\";s:4:\"name\";s:7:\"toolbar\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:11:{s:4:\"name\";s:7:\"Toolbar\";s:11:\"description\";s:99:\"Provides a toolbar that shows the top-level administration menu items and links from other modules.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:6:\"update\";O:8:\"stdClass\":9:{s:8:\"filename\";s:28:\"modules/update/update.module\";s:4:\"name\";s:6:\"update\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7001\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:14:\"Update manager\";s:11:\"description\";s:104:\"Checks for available updates, and can securely install or update modules and themes via a web interface.\";s:7:\"version\";s:4:\"7.21\";s:7:\"package\";s:4:\"Core\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"update.test\";}s:9:\"configure\";s:30:\"admin/reports/updates/settings\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:4:\"user\";O:8:\"stdClass\":9:{s:8:\"filename\";s:24:\"modules/user/user.module\";s:4:\"name\";s:4:\"user\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7018\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:4:\"User\";s:11:\"description\";s:47:\"Manages the user registration and login system.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:11:\"user.module\";i:1;s:9:\"user.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:19:\"admin/config/people\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"user.css\";s:21:\"modules/user/user.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:6:\"widget\";O:8:\"stdClass\":9:{s:8:\"filename\";s:44:\"sites/all/modules/tabvn/widget/widget.module\";s:4:\"name\";s:6:\"widget\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:9:{s:4:\"name\";s:6:\"widget\";s:11:\"description\";s:47:\"provide custom widget such as twitter,flickr...\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Tabvn\";s:12:\"dependencies\";a:0:{}s:7:\"version\";N;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:7:\"wysiwyg\";O:8:\"stdClass\":9:{s:8:\"filename\";s:40:\"sites/all/modules/wysiwyg/wysiwyg.module\";s:4:\"name\";s:7:\"wysiwyg\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7200\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:12:{s:4:\"name\";s:7:\"Wysiwyg\";s:11:\"description\";s:48:\"Allows to edit content with client-side editors.\";s:7:\"package\";s:14:\"User interface\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:28:\"admin/config/content/wysiwyg\";s:5:\"files\";a:2:{i:0;s:14:\"wysiwyg.module\";i:1;s:18:\"tests/wysiwyg.test\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:7:\"wysiwyg\";s:9:\"datestamp\";s:10:\"1349213776\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:8:\"pathauto\";O:8:\"stdClass\":9:{s:8:\"filename\";s:42:\"sites/all/modules/pathauto/pathauto.module\";s:4:\"name\";s:8:\"pathauto\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:4:\"7005\";s:6:\"weight\";s:1:\"1\";s:4:\"info\";a:13:{s:4:\"name\";s:8:\"Pathauto\";s:11:\"description\";s:95:\"Provides a mechanism for modules to automatically generate aliases for the content they manage.\";s:12:\"dependencies\";a:2:{i:0;s:4:\"path\";i:1;s:5:\"token\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:13:\"pathauto.test\";}s:9:\"configure\";s:33:\"admin/config/search/path/patterns\";s:10:\"recommends\";a:1:{i:0;s:8:\"redirect\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:8:\"pathauto\";s:9:\"datestamp\";s:10:\"1344525185\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}}s:12:\"page_manager\";O:8:\"stdClass\":9:{s:8:\"filename\";s:57:\"sites/all/modules/ctools/page_manager/page_manager.module\";s:4:\"name\";s:12:\"page_manager\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:2:\"99\";s:4:\"info\";a:11:{s:4:\"name\";s:12:\"Page manager\";s:11:\"description\";s:54:\"Provides a UI and API to manage pages within the site.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}}s:8:\"standard\";O:8:\"stdClass\":9:{s:8:\"filename\";s:34:\"profiles/standard/standard.profile\";s:4:\"name\";s:8:\"standard\";s:4:\"type\";s:6:\"module\";s:5:\"owner\";s:0:\"\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:1:\"0\";s:6:\"weight\";s:4:\"1000\";s:4:\"info\";a:14:{s:4:\"name\";s:8:\"Standard\";s:11:\"description\";s:51:\"Install with commonly used features pre-configured.\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:21:{i:0;s:5:\"block\";i:1;s:5:\"color\";i:2;s:7:\"comment\";i:3;s:10:\"contextual\";i:4;s:9:\"dashboard\";i:5;s:4:\"help\";i:6;s:5:\"image\";i:7;s:4:\"list\";i:8;s:4:\"menu\";i:9;s:6:\"number\";i:10;s:7:\"options\";i:11;s:4:\"path\";i:12;s:8:\"taxonomy\";i:13;s:5:\"dblog\";i:14;s:6:\"search\";i:15;s:8:\"shortcut\";i:16;s:7:\"toolbar\";i:17;s:7:\"overlay\";i:18;s:8:\"field_ui\";i:19;s:4:\"file\";i:20;s:3:\"rdf\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;s:6:\"hidden\";b:1;s:8:\"required\";b:1;s:17:\"distribution_name\";s:6:\"Drupal\";}}}s:5:\"theme\";a:5:{s:6:\"bartik\";O:8:\"stdClass\":10:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";}s:6:\"centum\";O:8:\"stdClass\":10:{s:8:\"filename\";s:35:\"sites/all/themes/centum/centum.info\";s:4:\"name\";s:6:\"centum\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:6:\"Centum\";s:11:\"description\";s:65:\"Centum theme, developed by <a href=\"http://tabvn.com/\">Tabvn</a>.\";s:4:\"core\";s:3:\"7.x\";s:7:\"scripts\";a:9:{s:12:\"js/custom.js\";s:36:\"sites/all/themes/centum/js/custom.js\";s:15:\"js/selectnav.js\";s:39:\"sites/all/themes/centum/js/selectnav.js\";s:16:\"js/flexslider.js\";s:40:\"sites/all/themes/centum/js/flexslider.js\";s:13:\"js/tooltip.js\";s:37:\"sites/all/themes/centum/js/tooltip.js\";s:13:\"js/effects.js\";s:37:\"sites/all/themes/centum/js/effects.js\";s:14:\"js/fancybox.js\";s:38:\"sites/all/themes/centum/js/fancybox.js\";s:14:\"js/carousel.js\";s:38:\"sites/all/themes/centum/js/carousel.js\";s:13:\"js/isotope.js\";s:37:\"sites/all/themes/centum/js/isotope.js\";s:12:\"js/centum.js\";s:36:\"sites/all/themes/centum/js/centum.js\";}s:8:\"features\";a:6:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:20:\"comment_user_picture\";i:4;s:25:\"comment_user_verification\";i:5;s:7:\"favicon\";}s:7:\"regions\";a:17:{s:4:\"help\";s:4:\"Help\";s:6:\"header\";s:6:\"Header\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:13:\"home_services\";s:13:\"Home services\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:15:{s:11:\"twitter_url\";s:1:\"#\";s:12:\"facebook_url\";s:1:\"#\";s:12:\"dribbble_url\";s:1:\"#\";s:12:\"linkedin_url\";s:1:\"#\";s:12:\"pintrest_url\";s:1:\"#\";s:20:\"header_contact_email\";s:18:\"support@centum.com\";s:20:\"header_contact_phone\";s:15:\"+48 880 450 120\";s:24:\"footer_copyright_message\";s:65:\"© Copyright 2012 by <a href=\"#\">Centum</a>. All rights reserved.\";s:17:\"default_portfolio\";s:2:\"4c\";s:23:\"default_nodes_portfolio\";s:2:\"12\";s:15:\"default_banners\";a:2:{i:1;a:5:{s:10:\"image_path\";s:24:\"images/slider-img-01.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:15:\"image_published\";b:1;s:12:\"image_weight\";s:1:\"0\";}i:2;a:5:{s:10:\"image_path\";s:24:\"images/slider-img-02.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:15:\"image_published\";b:1;s:12:\"image_weight\";s:1:\"1\";}}s:11:\"theme_color\";s:9:\"green.css\";s:22:\"theme_background_color\";s:0:\"\";s:22:\"theme_background_image\";s:9:\"noise.png\";s:18:\"theme_layout_style\";s:9:\"boxed.css\";}s:6:\"engine\";s:11:\"phptemplate\";s:10:\"screenshot\";s:38:\"sites/all/themes/centum/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:11:\"stylesheets\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";}s:7:\"garland\";O:8:\"stdClass\":10:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";}s:5:\"seven\";O:8:\"stdClass\":10:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";}s:5:\"stark\";O:8:\"stdClass\":10:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:17:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";}}s:9:\"filepaths\";a:48:{i:0;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"block\";s:8:\"filepath\";s:26:\"modules/block/block.module\";}i:1;a:3:{s:4:\"type\";s:5:\"theme\";s:4:\"name\";s:6:\"bartik\";s:8:\"filepath\";s:25:\"themes/bartik/bartik.info\";}i:2;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"blog\";s:8:\"filepath\";s:24:\"modules/blog/blog.module\";}i:3;a:3:{s:4:\"type\";s:5:\"theme\";s:4:\"name\";s:6:\"centum\";s:8:\"filepath\";s:35:\"sites/all/themes/centum/centum.info\";}i:4;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"color\";s:8:\"filepath\";s:26:\"modules/color/color.module\";}i:5;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:7:\"comment\";s:8:\"filepath\";s:30:\"modules/comment/comment.module\";}i:6;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:7:\"contact\";s:8:\"filepath\";s:30:\"modules/contact/contact.module\";}i:7;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:10:\"contextual\";s:8:\"filepath\";s:36:\"modules/contextual/contextual.module\";}i:8;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"ctools\";s:8:\"filepath\";s:38:\"sites/all/modules/ctools/ctools.module\";}i:9;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"custom\";s:8:\"filepath\";s:44:\"sites/all/modules/tabvn/custom/custom.module\";}i:10;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:9:\"dashboard\";s:8:\"filepath\";s:34:\"modules/dashboard/dashboard.module\";}i:11;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"dblog\";s:8:\"filepath\";s:26:\"modules/dblog/dblog.module\";}i:12;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"field\";s:8:\"filepath\";s:26:\"modules/field/field.module\";}i:13;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:17:\"field_sql_storage\";s:8:\"filepath\";s:64:\"modules/field/modules/field_sql_storage/field_sql_storage.module\";}i:14;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"field_ui\";s:8:\"filepath\";s:32:\"modules/field_ui/field_ui.module\";}i:15;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"file\";s:8:\"filepath\";s:24:\"modules/file/file.module\";}i:16;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"filter\";s:8:\"filepath\";s:28:\"modules/filter/filter.module\";}i:17;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"help\";s:8:\"filepath\";s:24:\"modules/help/help.module\";}i:18;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"image\";s:8:\"filepath\";s:26:\"modules/image/image.module\";}i:19;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"imce\";s:8:\"filepath\";s:34:\"sites/all/modules/imce/imce.module\";}i:20;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:12:\"imce_wysiwyg\";s:8:\"filepath\";s:50:\"sites/all/modules/imce_wysiwyg/imce_wysiwyg.module\";}i:21;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:13:\"jquery_update\";s:8:\"filepath\";s:52:\"sites/all/modules/jquery_update/jquery_update.module\";}i:22;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"list\";s:8:\"filepath\";s:38:\"modules/field/modules/list/list.module\";}i:23;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"menu\";s:8:\"filepath\";s:24:\"modules/menu/menu.module\";}i:24;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"node\";s:8:\"filepath\";s:24:\"modules/node/node.module\";}i:25;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"number\";s:8:\"filepath\";s:42:\"modules/field/modules/number/number.module\";}i:26;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:7:\"options\";s:8:\"filepath\";s:44:\"modules/field/modules/options/options.module\";}i:27;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:7:\"overlay\";s:8:\"filepath\";s:30:\"modules/overlay/overlay.module\";}i:28;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"panels\";s:8:\"filepath\";s:38:\"sites/all/modules/panels/panels.module\";}i:29;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"path\";s:8:\"filepath\";s:24:\"modules/path/path.module\";}i:30;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:9:\"portfolio\";s:8:\"filepath\";s:50:\"sites/all/modules/tabvn/portfolio/portfolio.module\";}i:31;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:3:\"rdf\";s:8:\"filepath\";s:22:\"modules/rdf/rdf.module\";}i:32;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"search\";s:8:\"filepath\";s:28:\"modules/search/search.module\";}i:33;a:3:{s:4:\"type\";s:5:\"theme\";s:4:\"name\";s:5:\"seven\";s:8:\"filepath\";s:23:\"themes/seven/seven.info\";}i:34;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"shortcut\";s:8:\"filepath\";s:32:\"modules/shortcut/shortcut.module\";}i:35;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"system\";s:8:\"filepath\";s:28:\"modules/system/system.module\";}i:36;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:9:\"tagadelic\";s:8:\"filepath\";s:44:\"sites/all/modules/tagadelic/tagadelic.module\";}i:37;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"taxonomy\";s:8:\"filepath\";s:32:\"modules/taxonomy/taxonomy.module\";}i:38;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"text\";s:8:\"filepath\";s:38:\"modules/field/modules/text/text.module\";}i:39;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:5:\"token\";s:8:\"filepath\";s:36:\"sites/all/modules/token/token.module\";}i:40;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:7:\"toolbar\";s:8:\"filepath\";s:30:\"modules/toolbar/toolbar.module\";}i:41;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"update\";s:8:\"filepath\";s:28:\"modules/update/update.module\";}i:42;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:4:\"user\";s:8:\"filepath\";s:24:\"modules/user/user.module\";}i:43;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:6:\"widget\";s:8:\"filepath\";s:44:\"sites/all/modules/tabvn/widget/widget.module\";}i:44;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:7:\"wysiwyg\";s:8:\"filepath\";s:40:\"sites/all/modules/wysiwyg/wysiwyg.module\";}i:45;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"pathauto\";s:8:\"filepath\";s:42:\"sites/all/modules/pathauto/pathauto.module\";}i:46;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:12:\"page_manager\";s:8:\"filepath\";s:57:\"sites/all/modules/ctools/page_manager/page_manager.module\";}i:47;a:3:{s:4:\"type\";s:6:\"module\";s:4:\"name\";s:8:\"standard\";s:8:\"filepath\";s:34:\"profiles/standard/standard.profile\";}}}',0,1362626465,1),('variables','a:134:{s:36:\"additional_settings__active_tab_blog\";s:13:\"edit-workflow\";s:41:\"additional_settings__active_tab_portfolio\";s:13:\"edit-workflow\";s:23:\"admin_menu_cache_client\";i:1;s:29:\"admin_menu_devel_modules_skip\";a:4:{s:11:\"admin_devel\";i:0;s:5:\"devel\";i:0;s:17:\"devel_node_access\";i:0;s:8:\"field_ui\";i:0;}s:21:\"admin_menu_margin_top\";i:1;s:25:\"admin_menu_position_fixed\";i:1;s:24:\"admin_menu_tweak_modules\";i:0;s:28:\"admin_menu_tweak_permissions\";i:0;s:21:\"admin_menu_tweak_tabs\";i:0;s:11:\"admin_theme\";s:5:\"seven\";s:9:\"anonymous\";s:9:\"Anonymous\";s:11:\"block_cache\";i:0;s:16:\"blog_block_count\";s:2:\"10\";s:5:\"cache\";i:0;s:14:\"cache_lifetime\";s:1:\"0\";s:9:\"clean_url\";s:1:\"1\";s:22:\"comment_anonymous_blog\";i:0;s:27:\"comment_anonymous_portfolio\";i:0;s:12:\"comment_blog\";s:1:\"2\";s:25:\"comment_default_mode_blog\";i:1;s:30:\"comment_default_mode_portfolio\";i:0;s:29:\"comment_default_per_page_blog\";s:2:\"50\";s:34:\"comment_default_per_page_portfolio\";s:2:\"50\";s:26:\"comment_form_location_blog\";i:1;s:31:\"comment_form_location_portfolio\";i:1;s:12:\"comment_page\";i:0;s:17:\"comment_portfolio\";s:1:\"0\";s:20:\"comment_preview_blog\";s:1:\"1\";s:25:\"comment_preview_portfolio\";s:1:\"0\";s:26:\"comment_subject_field_blog\";i:1;s:31:\"comment_subject_field_portfolio\";i:0;s:22:\"contact_default_status\";i:1;s:8:\"cron_key\";s:43:\"Y9SXKaqynBbR421mHl60yeUNFh09bvtCYg_l6pC8yAE\";s:9:\"cron_last\";i:1362623493;s:19:\"css_js_query_string\";s:6:\"mj9tb0\";s:16:\"ctools_last_cron\";i:1362623494;s:21:\"date_default_timezone\";s:12:\"Asia/Bangkok\";s:18:\"default_nodes_main\";s:1:\"8\";s:25:\"drupal_http_request_fails\";b:0;s:18:\"drupal_private_key\";s:43:\"IxJ4ruIYb_p0GnjeyJD6cNOuW4DG3YJSR-GX_egNdg8\";s:17:\"email__active_tab\";s:24:\"edit-email-admin-created\";s:32:\"field_bundle_settings_node__blog\";a:2:{s:10:\"view_modes\";a:6:{s:6:\"teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:3:\"rss\";a:1:{s:15:\"custom_settings\";b:0;}s:12:\"search_index\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"search_result\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:2:\"-5\";}s:4:\"path\";a:1:{s:6:\"weight\";s:2:\"30\";}}s:7:\"display\";a:0:{}}}s:37:\"field_bundle_settings_node__portfolio\";a:2:{s:10:\"view_modes\";a:6:{s:6:\"teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:3:\"rss\";a:1:{s:15:\"custom_settings\";b:0;}s:12:\"search_index\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"search_result\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:2:\"-5\";}s:4:\"path\";a:1:{s:6:\"weight\";s:2:\"30\";}}s:7:\"display\";a:0:{}}}s:19:\"file_temporary_path\";s:4:\"/tmp\";s:22:\"filter_fallback_format\";s:10:\"plain_text\";s:13:\"imce_profiles\";a:2:{i:1;a:10:{s:4:\"name\";s:6:\"User-1\";s:7:\"usertab\";i:1;s:8:\"filesize\";i:0;s:5:\"quota\";i:0;s:7:\"tuquota\";i:0;s:10:\"extensions\";s:1:\"*\";s:10:\"dimensions\";s:9:\"1200x1200\";s:7:\"filenum\";i:0;s:11:\"directories\";a:1:{i:0;a:7:{s:4:\"name\";s:1:\".\";s:6:\"subnav\";i:1;s:6:\"browse\";i:1;s:6:\"upload\";i:1;s:5:\"thumb\";i:1;s:6:\"delete\";i:1;s:6:\"resize\";i:1;}}s:10:\"thumbnails\";a:3:{i:0;a:4:{s:4:\"name\";s:5:\"Small\";s:10:\"dimensions\";s:5:\"90x90\";s:6:\"prefix\";s:6:\"small_\";s:6:\"suffix\";s:0:\"\";}i:1;a:4:{s:4:\"name\";s:6:\"Medium\";s:10:\"dimensions\";s:7:\"120x120\";s:6:\"prefix\";s:7:\"medium_\";s:6:\"suffix\";s:0:\"\";}i:2;a:4:{s:4:\"name\";s:5:\"Large\";s:10:\"dimensions\";s:7:\"180x180\";s:6:\"prefix\";s:6:\"large_\";s:6:\"suffix\";s:0:\"\";}}}i:2;a:10:{s:4:\"name\";s:14:\"Sample profile\";s:7:\"usertab\";i:1;s:8:\"filesize\";i:1;s:5:\"quota\";i:2;s:7:\"tuquota\";i:0;s:10:\"extensions\";s:16:\"gif png jpg jpeg\";s:10:\"dimensions\";s:7:\"800x600\";s:7:\"filenum\";i:1;s:11:\"directories\";a:1:{i:0;a:7:{s:4:\"name\";s:5:\"u%uid\";s:6:\"subnav\";i:0;s:6:\"browse\";i:1;s:6:\"upload\";i:1;s:5:\"thumb\";i:1;s:6:\"delete\";i:0;s:6:\"resize\";i:0;}}s:10:\"thumbnails\";a:1:{i:0;a:4:{s:4:\"name\";s:5:\"Thumb\";s:10:\"dimensions\";s:5:\"90x90\";s:6:\"prefix\";s:6:\"thumb_\";s:6:\"suffix\";s:0:\"\";}}}}s:15:\"install_profile\";s:8:\"standard\";s:12:\"install_task\";s:4:\"done\";s:12:\"install_time\";i:1359648896;s:30:\"jquery_update_compression_type\";s:3:\"min\";s:24:\"jquery_update_jquery_cdn\";s:4:\"none\";s:28:\"jquery_update_jquery_version\";s:3:\"1.7\";s:13:\"menu_expanded\";a:0:{}s:10:\"menu_masks\";a:34:{i:0;i:501;i:1;i:493;i:2;i:250;i:3;i:247;i:4;i:246;i:5;i:245;i:6;i:125;i:7;i:123;i:8;i:122;i:9;i:121;i:10;i:117;i:11;i:63;i:12;i:62;i:13;i:61;i:14;i:60;i:15;i:59;i:16;i:58;i:17;i:44;i:18;i:31;i:19;i:30;i:20;i:29;i:21;i:28;i:22;i:24;i:23;i:21;i:24;i:15;i:25;i:14;i:26;i:13;i:27;i:11;i:28;i:7;i:29;i:6;i:30;i:5;i:31;i:3;i:32;i:2;i:33;i:1;}s:17:\"menu_options_blog\";a:1:{i:0;s:9:\"main-menu\";}s:22:\"menu_options_portfolio\";a:1:{i:0;s:9:\"main-menu\";}s:16:\"menu_parent_blog\";s:11:\"main-menu:0\";s:21:\"menu_parent_portfolio\";s:11:\"main-menu:0\";s:16:\"node_admin_theme\";s:1:\"1\";s:14:\"node_cron_last\";s:10:\"1359808293\";s:17:\"node_options_blog\";a:1:{i:0;s:6:\"status\";}s:17:\"node_options_page\";a:1:{i:0;s:6:\"status\";}s:22:\"node_options_portfolio\";a:1:{i:0;s:6:\"status\";}s:17:\"node_preview_blog\";s:1:\"0\";s:22:\"node_preview_portfolio\";s:1:\"0\";s:19:\"node_submitted_blog\";i:1;s:19:\"node_submitted_page\";b:0;s:24:\"node_submitted_portfolio\";i:0;s:22:\"page_cache_maximum_age\";s:1:\"0\";s:16:\"page_compression\";i:1;s:21:\"pathauto_blog_pattern\";s:17:\"blogs/[user:name]\";s:22:\"pathauto_forum_pattern\";s:29:\"[term:vocabulary]/[term:name]\";s:29:\"pathauto_node_article_pattern\";s:0:\"\";s:26:\"pathauto_node_blog_pattern\";s:17:\"blog/[node:title]\";s:26:\"pathauto_node_page_pattern\";s:0:\"\";s:21:\"pathauto_node_pattern\";s:20:\"content/[node:title]\";s:31:\"pathauto_node_portfolio_pattern\";s:22:\"portfolio/[node:title]\";s:27:\"pathauto_punctuation_hyphen\";i:1;s:30:\"pathauto_taxonomy_term_pattern\";s:29:\"[term:vocabulary]/[term:name]\";s:51:\"pathauto_taxonomy_term_portfolio_categories_pattern\";s:0:\"\";s:35:\"pathauto_taxonomy_term_tags_pattern\";s:16:\"tags/[term:name]\";s:21:\"pathauto_user_pattern\";s:17:\"users/[user:name]\";s:20:\"path_alias_whitelist\";a:4:{s:4:\"blog\";b:1;s:4:\"node\";b:1;s:8:\"taxonomy\";b:1;s:4:\"user\";b:1;}s:14:\"preprocess_css\";i:0;s:13:\"preprocess_js\";i:0;s:23:\"save_continue_portfolio\";s:19:\"Save and add fields\";s:8:\"site_403\";s:0:\"\";s:8:\"site_404\";s:0:\"\";s:20:\"site_default_country\";s:0:\"\";s:14:\"site_frontpage\";s:10:\"front-page\";s:9:\"site_mail\";s:14:\"toan@tabvn.com\";s:9:\"site_name\";s:6:\"Centum\";s:11:\"site_slogan\";s:35:\"It\'s time to impress your visitors!\";s:22:\"tagadelic_block_tags_1\";s:2:\"12\";s:28:\"theme_centum_banner_settings\";a:2:{i:0;a:7:{s:10:\"image_path\";s:33:\"public://banner/slider-img-01.jpg\";s:11:\"image_thumb\";s:39:\"public://banner/thumb/slider-img-01.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:12:\"image_weight\";s:1:\"0\";s:15:\"image_published\";s:1:\"1\";s:12:\"image_delete\";N;}i:1;a:7:{s:10:\"image_path\";s:33:\"public://banner/slider-img-02.jpg\";s:11:\"image_thumb\";s:39:\"public://banner/thumb/slider-img-02.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:12:\"image_weight\";s:1:\"1\";s:15:\"image_published\";s:1:\"1\";s:12:\"image_delete\";N;}}s:26:\"theme_centum_first_install\";b:0;s:21:\"theme_centum_settings\";a:29:{s:11:\"toggle_logo\";i:1;s:11:\"toggle_name\";i:1;s:13:\"toggle_slogan\";i:1;s:27:\"toggle_comment_user_picture\";i:1;s:32:\"toggle_comment_user_verification\";i:1;s:14:\"toggle_favicon\";i:1;s:12:\"default_logo\";i:1;s:9:\"logo_path\";s:0:\"\";s:11:\"logo_upload\";s:0:\"\";s:15:\"default_favicon\";i:1;s:12:\"favicon_path\";s:0:\"\";s:14:\"favicon_upload\";s:0:\"\";s:20:\"header_contact_email\";s:18:\"support@centum.com\";s:20:\"header_contact_phone\";s:15:\"+48 880 450 120\";s:12:\"facebook_url\";s:1:\"#\";s:11:\"twitter_url\";s:1:\"#\";s:12:\"dribbble_url\";s:1:\"#\";s:12:\"linkedin_url\";s:1:\"#\";s:12:\"pintrest_url\";s:1:\"#\";s:17:\"default_portfolio\";s:2:\"4c\";s:23:\"default_nodes_portfolio\";s:2:\"12\";s:24:\"footer_copyright_message\";s:65:\"© Copyright 2012 by <a href=\"#\">Centum</a>. All rights reserved.\";s:18:\"theme_layout_style\";s:9:\"boxed.css\";s:11:\"theme_color\";s:9:\"green.css\";s:22:\"theme_background_color\";s:0:\"\";s:22:\"theme_background_image\";s:9:\"noise.png\";s:20:\"settings__active_tab\";s:9:\"edit-skin\";s:6:\"images\";a:3:{i:0;a:1:{s:5:\"image\";a:7:{s:10:\"image_path\";s:33:\"public://banner/slider-img-01.jpg\";s:11:\"image_thumb\";s:39:\"public://banner/thumb/slider-img-01.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:12:\"image_weight\";s:1:\"0\";s:15:\"image_published\";i:1;s:12:\"image_delete\";i:0;}}i:1;a:1:{s:5:\"image\";a:7:{s:10:\"image_path\";s:33:\"public://banner/slider-img-02.jpg\";s:11:\"image_thumb\";s:39:\"public://banner/thumb/slider-img-02.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:12:\"image_weight\";s:1:\"1\";s:15:\"image_published\";i:1;s:12:\"image_delete\";i:0;}}s:18:\"images__active_tab\";s:13:\"edit-images-0\";}s:12:\"image_upload\";s:0:\"\";}s:13:\"theme_default\";s:6:\"centum\";s:17:\"update_last_check\";i:1362626410;s:30:\"update_last_email_notification\";i:1362623493;s:20:\"update_notify_emails\";a:1:{i:0;s:14:\"toan@tabvn.com\";}s:15:\"user_admin_role\";s:1:\"3\";s:18:\"user_cancel_method\";s:17:\"user_cancel_block\";s:23:\"user_email_verification\";i:1;s:29:\"user_mail_cancel_confirm_body\";s:381:\"[user:name],\r\n\r\nA request to cancel your account has been made at [site:name].\r\n\r\nYou may now cancel your account on [site:url-brief] by clicking this link or copying and pasting it into your browser:\r\n\r\n[user:cancel-url]\r\n\r\nNOTE: The cancellation of your account is not reversible.\r\n\r\nThis link expires in one day and nothing will happen if it is not used.\r\n\r\n--  [site:name] team\";s:32:\"user_mail_cancel_confirm_subject\";s:59:\"Account cancellation request for [user:name] at [site:name]\";s:29:\"user_mail_password_reset_body\";s:407:\"[user:name],\r\n\r\nA request to reset the password for your account has been made at [site:name].\r\n\r\nYou may now log in by clicking this link or copying and pasting it to your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password. It expires after one day and nothing will happen if it\'s not used.\r\n\r\n--  [site:name] team\";s:32:\"user_mail_password_reset_subject\";s:60:\"Replacement login information for [user:name] at [site:name]\";s:37:\"user_mail_register_admin_created_body\";s:476:\"[user:name],\r\n\r\nA site administrator at [site:name] has created an account for you. You may now log in by clicking this link or copying and pasting it to your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password.\r\n\r\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\r\n\r\nusername: [user:name]\r\npassword: Your password\r\n\r\n--  [site:name] team\";s:40:\"user_mail_register_admin_created_subject\";s:58:\"An administrator created an account for you at [site:name]\";s:44:\"user_mail_register_no_approval_required_body\";s:450:\"[user:name],\r\n\r\nThank you for registering at [site:name]. You may now log in by clicking this link or copying and pasting it to your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password.\r\n\r\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\r\n\r\nusername: [user:name]\r\npassword: Your password\r\n\r\n--  [site:name] team\";s:47:\"user_mail_register_no_approval_required_subject\";s:46:\"Account details for [user:name] at [site:name]\";s:40:\"user_mail_register_pending_approval_body\";s:287:\"[user:name],\r\n\r\nThank you for registering at [site:name]. Your application for an account is currently pending approval. Once it has been approved, you will receive another e-mail containing information about how to log in, set your password, and other details.\r\n\r\n\r\n--  [site:name] team\";s:43:\"user_mail_register_pending_approval_subject\";s:71:\"Account details for [user:name] at [site:name] (pending admin approval)\";s:31:\"user_mail_status_activated_body\";s:461:\"[user:name],\r\n\r\nYour account at [site:name] has been activated.\r\n\r\nYou may now log in by clicking this link or copying and pasting it into your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password.\r\n\r\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\r\n\r\nusername: [user:name]\r\npassword: Your password\r\n\r\n--  [site:name] team\";s:33:\"user_mail_status_activated_notify\";i:1;s:34:\"user_mail_status_activated_subject\";s:57:\"Account details for [user:name] at [site:name] (approved)\";s:29:\"user_mail_status_blocked_body\";s:85:\"[user:name],\r\n\r\nYour account on [site:name] has been blocked.\r\n\r\n--  [site:name] team\";s:31:\"user_mail_status_blocked_notify\";i:0;s:32:\"user_mail_status_blocked_subject\";s:56:\"Account details for [user:name] at [site:name] (blocked)\";s:30:\"user_mail_status_canceled_body\";s:86:\"[user:name],\r\n\r\nYour account on [site:name] has been canceled.\r\n\r\n--  [site:name] team\";s:32:\"user_mail_status_canceled_notify\";i:0;s:33:\"user_mail_status_canceled_subject\";s:57:\"Account details for [user:name] at [site:name] (canceled)\";s:13:\"user_pictures\";i:1;s:20:\"user_picture_default\";s:74:\"http://www.gravatar.com/avatar/00000000000000000000000000000000?d=mm&s=100\";s:23:\"user_picture_dimensions\";s:9:\"1024x1024\";s:22:\"user_picture_file_size\";s:3:\"800\";s:23:\"user_picture_guidelines\";s:0:\"\";s:17:\"user_picture_path\";s:8:\"pictures\";s:18:\"user_picture_style\";s:9:\"thumbnail\";s:13:\"user_register\";s:1:\"2\";s:15:\"user_signatures\";i:0;s:16:\"widget_flickr_id\";s:12:\"36587311@N08\";s:25:\"widget_flickr_photo_count\";s:1:\"6\";}',0,1362626465,1);
/*!40000 ALTER TABLE `cache_bootstrap` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_field`
--

DROP TABLE IF EXISTS `cache_field`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_field` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Generic cache table for caching things not separated out...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_field`
--

LOCK TABLES `cache_field` WRITE;
/*!40000 ALTER TABLE `cache_field` DISABLE KEYS */;
INSERT INTO `cache_field` VALUES ('field:user:0','a:0:{}',0,1362626465,1),('field_info_fields','a:4:{s:6:\"fields\";a:7:{i:1;a:16:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:23:\"field_data_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:27:\"field_revision_comment_body\";a:2:{s:5:\"value\";s:18:\"comment_body_value\";s:6:\"format\";s:19:\"comment_body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:4:\"type\";s:9:\"text_long\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:7:\"comment\";a:4:{i:0;s:17:\"comment_node_page\";i:1;s:20:\"comment_node_article\";i:2;s:17:\"comment_node_blog\";i:3;s:22:\"comment_node_portfolio\";}}}i:2;a:16:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";s:1:\"0\";s:8:\"settings\";a:0:{}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:15:\"field_data_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:19:\"field_revision_body\";a:3:{s:5:\"value\";s:10:\"body_value\";s:7:\"summary\";s:12:\"body_summary\";s:6:\"format\";s:11:\"body_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:4:\"type\";s:17:\"text_with_summary\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:3:{s:5:\"value\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:7:\"summary\";a:3:{s:4:\"type\";s:4:\"text\";s:4:\"size\";s:3:\"big\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:4:{i:0;s:4:\"page\";i:1;s:7:\"article\";i:2;s:4:\"blog\";i:3;s:9:\"portfolio\";}}}i:3;a:16:{s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:4:\"tags\";s:6:\"parent\";i:0;}}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:1:\"3\";s:10:\"field_name\";s:10:\"field_tags\";s:4:\"type\";s:23:\"taxonomy_term_reference\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:2:\"-1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:3:\"tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:2:{i:0;s:7:\"article\";i:1;s:4:\"blog\";}}}i:4;a:16:{s:7:\"indexes\";a:1:{s:3:\"fid\";a:1:{i:0;s:3:\"fid\";}}s:8:\"settings\";a:2:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";i:0;}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}}}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:12:\"foreign keys\";a:1:{s:3:\"fid\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:3:\"fid\";s:3:\"fid\";}}}s:2:\"id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:4:\"type\";s:5:\"image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:2:\"-1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:5:{s:3:\"fid\";a:4:{s:11:\"description\";s:54:\"The {file_managed}.fid being referenced in this field.\";s:4:\"type\";s:3:\"int\";s:8:\"not null\";b:0;s:8:\"unsigned\";b:1;}s:3:\"alt\";a:4:{s:11:\"description\";s:56:\"Alternative image text, for the image\'s \'alt\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:512;s:8:\"not null\";b:0;}s:5:\"title\";a:4:{s:11:\"description\";s:52:\"Image title text, for the image\'s \'title\' attribute.\";s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:1024;s:8:\"not null\";b:0;}s:5:\"width\";a:3:{s:11:\"description\";s:33:\"The width of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}s:6:\"height\";a:3:{s:11:\"description\";s:34:\"The height of the image in pixels.\";s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:3:{i:0;s:7:\"article\";i:1;s:4:\"blog\";i:2;s:9:\"portfolio\";}}}i:5;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:20:\"portfolio_categories\";s:6:\"parent\";s:1:\"0\";}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:35:\"field_data_field_portfolio_category\";a:1:{s:3:\"tid\";s:28:\"field_portfolio_category_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:39:\"field_revision_field_portfolio_category\";a:1:{s:3:\"tid\";s:28:\"field_portfolio_category_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:1:\"5\";s:10:\"field_name\";s:24:\"field_portfolio_category\";s:4:\"type\";s:23:\"taxonomy_term_reference\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:2:\"-1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:1:{s:3:\"tid\";a:3:{s:4:\"type\";s:3:\"int\";s:8:\"unsigned\";b:1;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:9:\"portfolio\";}}}i:6;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_portfolio_link\";a:2:{s:5:\"value\";s:26:\"field_portfolio_link_value\";s:6:\"format\";s:27:\"field_portfolio_link_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_portfolio_link\";a:2:{s:5:\"value\";s:26:\"field_portfolio_link_value\";s:6:\"format\";s:27:\"field_portfolio_link_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"6\";s:10:\"field_name\";s:20:\"field_portfolio_link\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:9:\"portfolio\";}}}i:7;a:16:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_portfolio_client\";a:2:{s:5:\"value\";s:28:\"field_portfolio_client_value\";s:6:\"format\";s:29:\"field_portfolio_client_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_portfolio_client\";a:2:{s:5:\"value\";s:28:\"field_portfolio_client_value\";s:6:\"format\";s:29:\"field_portfolio_client_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"7\";s:10:\"field_name\";s:22:\"field_portfolio_client\";s:4:\"type\";s:4:\"text\";s:6:\"module\";s:4:\"text\";s:6:\"active\";s:1:\"1\";s:6:\"locked\";s:1:\"0\";s:11:\"cardinality\";s:1:\"1\";s:7:\"deleted\";s:1:\"0\";s:7:\"columns\";a:2:{s:5:\"value\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";s:3:\"255\";s:8:\"not null\";b:0;}s:6:\"format\";a:3:{s:4:\"type\";s:7:\"varchar\";s:6:\"length\";i:255;s:8:\"not null\";b:0;}}s:7:\"bundles\";a:1:{s:4:\"node\";a:1:{i:0;s:9:\"portfolio\";}}}}s:9:\"field_ids\";a:7:{s:12:\"comment_body\";i:1;s:4:\"body\";i:2;s:10:\"field_tags\";i:3;s:11:\"field_image\";i:4;s:24:\"field_portfolio_category\";i:5;s:20:\"field_portfolio_link\";i:6;s:22:\"field_portfolio_client\";i:7;}s:9:\"instances\";a:7:{s:7:\"comment\";a:4:{s:20:\"comment_node_article\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"3\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:20:\"comment_node_article\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:17:\"comment_node_page\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"1\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:17:\"comment_node_page\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:17:\"comment_node_blog\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"7\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:17:\"comment_node_blog\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:22:\"comment_node_portfolio\";a:1:{s:12:\"comment_body\";a:13:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"11\";s:8:\"field_id\";s:1:\"1\";s:10:\"field_name\";s:12:\"comment_body\";s:11:\"entity_type\";s:7:\"comment\";s:6:\"bundle\";s:22:\"comment_node_portfolio\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}}s:4:\"node\";a:4:{s:7:\"article\";a:3:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"4\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:10:\"field_tags\";a:13:{s:5:\"label\";s:4:\"Tags\";s:11:\"description\";s:63:\"Enter a comma-separated list of words to describe your content.\";s:6:\"widget\";a:4:{s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"weight\";i:-4;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}s:6:\"module\";s:8:\"taxonomy\";}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";i:10;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:6:\"teaser\";a:5:{s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";i:10;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";b:0;s:2:\"id\";s:1:\"5\";s:8:\"field_id\";s:1:\"3\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:11:\"field_image\";a:12:{s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:40:\"Upload an image to go with this article.\";s:8:\"required\";b:0;s:8:\"settings\";a:9:{s:14:\"file_directory\";s:11:\"field/image\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:11:\"title_field\";s:0:\"\";s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:11:\"image_image\";s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}s:6:\"weight\";i:-1;s:6:\"module\";s:5:\"image\";}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:0:\"\";}s:6:\"weight\";i:-1;s:6:\"module\";s:5:\"image\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:6:\"medium\";s:10:\"image_link\";s:7:\"content\";}s:6:\"weight\";i:-1;s:6:\"module\";s:5:\"image\";}}s:2:\"id\";s:1:\"6\";s:8:\"field_id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:7:\"article\";s:7:\"deleted\";s:1:\"0\";}}s:4:\"page\";a:1:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"2\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"page\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}}s:4:\"blog\";a:3:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:2:\"31\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:1:\"8\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"blog\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:10:\"field_tags\";a:13:{s:5:\"label\";s:4:\"Tags\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"33\";s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}}s:6:\"teaser\";a:4:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:1:\"9\";s:8:\"field_id\";s:1:\"3\";s:10:\"field_name\";s:10:\"field_tags\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"blog\";s:7:\"deleted\";s:1:\"0\";}s:11:\"field_image\";a:12:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"35\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:0:\"\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"10\";s:8:\"field_id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:4:\"blog\";s:7:\"deleted\";s:1:\"0\";}}s:9:\"portfolio\";a:5:{s:4:\"body\";a:13:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:2:\"31\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"12\";s:8:\"field_id\";s:1:\"2\";s:10:\"field_name\";s:4:\"body\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:9:\"portfolio\";s:7:\"deleted\";s:1:\"0\";s:13:\"default_value\";N;}s:11:\"field_image\";a:12:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"33\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:0:\"\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:2:\"id\";s:2:\"13\";s:8:\"field_id\";s:1:\"4\";s:10:\"field_name\";s:11:\"field_image\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:9:\"portfolio\";s:7:\"deleted\";s:1:\"0\";}s:24:\"field_portfolio_category\";a:13:{s:5:\"label\";s:8:\"Category\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"34\";s:4:\"type\";s:14:\"options_select\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:0:{}}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"14\";s:8:\"field_id\";s:1:\"5\";s:10:\"field_name\";s:24:\"field_portfolio_category\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:9:\"portfolio\";s:7:\"deleted\";s:1:\"0\";}s:20:\"field_portfolio_link\";a:13:{s:5:\"label\";s:4:\"Link\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"35\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"15\";s:8:\"field_id\";s:1:\"6\";s:10:\"field_name\";s:20:\"field_portfolio_link\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:9:\"portfolio\";s:7:\"deleted\";s:1:\"0\";}s:22:\"field_portfolio_client\";a:13:{s:5:\"label\";s:6:\"Client\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"36\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:4:{s:4:\"type\";s:6:\"hidden\";s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"weight\";i:0;}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;s:2:\"id\";s:2:\"16\";s:8:\"field_id\";s:1:\"7\";s:10:\"field_name\";s:22:\"field_portfolio_client\";s:11:\"entity_type\";s:4:\"node\";s:6:\"bundle\";s:9:\"portfolio\";s:7:\"deleted\";s:1:\"0\";}}}s:4:\"file\";a:1:{s:4:\"file\";a:0:{}}s:13:\"taxonomy_term\";a:2:{s:4:\"tags\";a:0:{}s:20:\"portfolio_categories\";a:0:{}}s:19:\"taxonomy_vocabulary\";a:1:{s:19:\"taxonomy_vocabulary\";a:0:{}}s:4:\"user\";a:1:{s:4:\"user\";a:0:{}}s:15:\"wysiwyg_profile\";a:1:{s:15:\"wysiwyg_profile\";a:0:{}}}s:12:\"extra_fields\";a:4:{s:7:\"comment\";a:3:{s:17:\"comment_node_blog\";a:1:{s:4:\"form\";a:2:{s:6:\"author\";a:3:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:16:\"Author textfield\";s:6:\"weight\";i:-2;}s:7:\"subject\";a:3:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:17:\"Subject textfield\";s:6:\"weight\";i:-1;}}}s:20:\"comment_node_article\";a:1:{s:4:\"form\";a:2:{s:6:\"author\";a:3:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:16:\"Author textfield\";s:6:\"weight\";i:-2;}s:7:\"subject\";a:3:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:17:\"Subject textfield\";s:6:\"weight\";i:-1;}}}s:17:\"comment_node_page\";a:1:{s:4:\"form\";a:2:{s:6:\"author\";a:3:{s:5:\"label\";s:6:\"Author\";s:11:\"description\";s:16:\"Author textfield\";s:6:\"weight\";i:-2;}s:7:\"subject\";a:3:{s:5:\"label\";s:7:\"Subject\";s:11:\"description\";s:17:\"Subject textfield\";s:6:\"weight\";i:-1;}}}}s:4:\"node\";a:4:{s:4:\"blog\";a:1:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";s:2:\"-5\";}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";s:2:\"30\";}}}s:7:\"article\";a:1:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";i:-5;}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";i:30;}}}s:4:\"page\";a:1:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";i:-5;}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";i:30;}}}s:9:\"portfolio\";a:1:{s:4:\"form\";a:2:{s:5:\"title\";a:3:{s:5:\"label\";s:5:\"Title\";s:11:\"description\";s:19:\"Node module element\";s:6:\"weight\";s:2:\"-5\";}s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";s:2:\"30\";}}}}s:13:\"taxonomy_term\";a:2:{s:20:\"portfolio_categories\";a:2:{s:4:\"form\";a:3:{s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";i:30;}s:4:\"name\";a:3:{s:5:\"label\";s:4:\"Name\";s:11:\"description\";s:19:\"Term name textfield\";s:6:\"weight\";i:-5;}s:11:\"description\";a:3:{s:5:\"label\";s:11:\"Description\";s:11:\"description\";s:25:\"Term description textarea\";s:6:\"weight\";i:0;}}s:7:\"display\";a:1:{s:11:\"description\";a:3:{s:5:\"label\";s:11:\"Description\";s:11:\"description\";s:16:\"Term description\";s:7:\"display\";a:3:{s:7:\"default\";a:2:{s:6:\"weight\";i:0;s:7:\"visible\";b:1;}s:4:\"full\";a:2:{s:6:\"weight\";i:0;s:7:\"visible\";b:1;}s:5:\"token\";a:2:{s:6:\"weight\";i:0;s:7:\"visible\";b:1;}}}}}s:4:\"tags\";a:2:{s:4:\"form\";a:3:{s:4:\"path\";a:3:{s:5:\"label\";s:17:\"URL path settings\";s:11:\"description\";s:25:\"Path module form elements\";s:6:\"weight\";i:30;}s:4:\"name\";a:3:{s:5:\"label\";s:4:\"Name\";s:11:\"description\";s:19:\"Term name textfield\";s:6:\"weight\";i:-5;}s:11:\"description\";a:3:{s:5:\"label\";s:11:\"Description\";s:11:\"description\";s:25:\"Term description textarea\";s:6:\"weight\";i:0;}}s:7:\"display\";a:1:{s:11:\"description\";a:3:{s:5:\"label\";s:11:\"Description\";s:11:\"description\";s:16:\"Term description\";s:7:\"display\";a:3:{s:7:\"default\";a:2:{s:6:\"weight\";i:0;s:7:\"visible\";b:1;}s:4:\"full\";a:2:{s:6:\"weight\";i:0;s:7:\"visible\";b:1;}s:5:\"token\";a:2:{s:6:\"weight\";i:0;s:7:\"visible\";b:1;}}}}}}s:4:\"user\";a:1:{s:4:\"user\";a:2:{s:4:\"form\";a:2:{s:7:\"account\";a:3:{s:5:\"label\";s:22:\"User name and password\";s:11:\"description\";s:34:\"User module account form elements.\";s:6:\"weight\";i:-10;}s:8:\"timezone\";a:3:{s:5:\"label\";s:8:\"Timezone\";s:11:\"description\";s:34:\"User module timezone form element.\";s:6:\"weight\";i:6;}}s:7:\"display\";a:1:{s:7:\"summary\";a:3:{s:5:\"label\";s:7:\"History\";s:11:\"description\";s:33:\"User module history view element.\";s:7:\"display\";a:3:{s:7:\"default\";a:2:{s:6:\"weight\";i:5;s:7:\"visible\";b:1;}s:4:\"full\";a:2:{s:6:\"weight\";i:5;s:7:\"visible\";b:1;}s:5:\"token\";a:2:{s:6:\"weight\";i:5;s:7:\"visible\";b:1;}}}}}}}}',0,1362626465,1),('field_info_types:en','a:4:{s:11:\"field types\";a:13:{s:4:\"file\";a:8:{s:5:\"label\";s:4:\"File\";s:11:\"description\";s:55:\"This field stores the ID of a file as an integer value.\";s:8:\"settings\";a:3:{s:13:\"display_field\";i:0;s:15:\"display_default\";i:0;s:10:\"uri_scheme\";s:6:\"public\";}s:17:\"instance_settings\";a:5:{s:15:\"file_extensions\";s:3:\"txt\";s:14:\"file_directory\";s:0:\"\";s:12:\"max_filesize\";s:0:\"\";s:17:\"description_field\";i:0;s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:12:\"file_generic\";s:17:\"default_formatter\";s:12:\"file_default\";s:6:\"module\";s:4:\"file\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:5:\"image\";a:8:{s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:62:\"This field stores the ID of an image file as an integer value.\";s:8:\"settings\";a:2:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";i:0;}s:17:\"instance_settings\";a:9:{s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:14:\"file_directory\";s:0:\"\";s:12:\"max_filesize\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:11:\"image_image\";s:17:\"default_formatter\";s:5:\"image\";s:6:\"module\";s:5:\"image\";s:23:\"default_token_formatter\";s:14:\"file_url_plain\";}s:12:\"list_integer\";a:8:{s:5:\"label\";s:14:\"List (integer)\";s:11:\"description\";s:144:\"This field stores integer values from a list of allowed \'value => label\' pairs, i.e. \'Lifetime in days\': 1 => 1 day, 7 => 1 week, 31 => 1 month.\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:0:{}s:23:\"allowed_values_function\";s:0:\"\";}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:4:\"list\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:10:\"list_float\";a:8:{s:5:\"label\";s:12:\"List (float)\";s:11:\"description\";s:134:\"This field stores float values from a list of allowed \'value => label\' pairs, i.e. \'Fraction\': 0 => 0, .25 => 1/4, .75 => 3/4, 1 => 1.\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:0:{}s:23:\"allowed_values_function\";s:0:\"\";}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:4:\"list\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:9:\"list_text\";a:8:{s:5:\"label\";s:11:\"List (text)\";s:11:\"description\";s:137:\"This field stores text values from a list of allowed \'value => label\' pairs, i.e. \'US States\': IL => Illinois, IA => Iowa, IN => Indiana.\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:0:{}s:23:\"allowed_values_function\";s:0:\"\";}s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:12:\"list_default\";s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:4:\"list\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:12:\"list_boolean\";a:8:{s:5:\"label\";s:7:\"Boolean\";s:11:\"description\";s:50:\"This field stores simple on/off or yes/no options.\";s:8:\"settings\";a:2:{s:14:\"allowed_values\";a:0:{}s:23:\"allowed_values_function\";s:0:\"\";}s:14:\"default_widget\";s:15:\"options_buttons\";s:17:\"default_formatter\";s:12:\"list_default\";s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:4:\"list\";s:23:\"default_token_formatter\";s:12:\"list_default\";}s:14:\"number_integer\";a:8:{s:5:\"label\";s:7:\"Integer\";s:11:\"description\";s:57:\"This field stores a number in the database as an integer.\";s:17:\"instance_settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_integer\";s:8:\"settings\";a:0:{}s:6:\"module\";s:6:\"number\";s:23:\"default_token_formatter\";s:18:\"number_unformatted\";}s:14:\"number_decimal\";a:8:{s:5:\"label\";s:7:\"Decimal\";s:11:\"description\";s:69:\"This field stores a number in the database in a fixed decimal format.\";s:8:\"settings\";a:3:{s:9:\"precision\";i:10;s:5:\"scale\";i:2;s:17:\"decimal_separator\";s:1:\".\";}s:17:\"instance_settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:23:\"default_token_formatter\";s:18:\"number_unformatted\";}s:12:\"number_float\";a:8:{s:5:\"label\";s:5:\"Float\";s:11:\"description\";s:70:\"This field stores a number in the database in a floating point format.\";s:8:\"settings\";a:1:{s:17:\"decimal_separator\";s:1:\".\";}s:17:\"instance_settings\";a:5:{s:3:\"min\";s:0:\"\";s:3:\"max\";s:0:\"\";s:6:\"prefix\";s:0:\"\";s:6:\"suffix\";s:0:\"\";s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:6:\"number\";s:17:\"default_formatter\";s:14:\"number_decimal\";s:6:\"module\";s:6:\"number\";s:23:\"default_token_formatter\";s:18:\"number_unformatted\";}s:23:\"taxonomy_term_reference\";a:8:{s:5:\"label\";s:14:\"Term reference\";s:11:\"description\";s:49:\"This field stores a reference to a taxonomy term.\";s:14:\"default_widget\";s:14:\"options_select\";s:17:\"default_formatter\";s:28:\"taxonomy_term_reference_link\";s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:0:\"\";s:6:\"parent\";s:1:\"0\";}}}s:17:\"instance_settings\";a:1:{s:18:\"user_register_form\";b:0;}s:6:\"module\";s:8:\"taxonomy\";s:23:\"default_token_formatter\";s:29:\"taxonomy_term_reference_plain\";}s:4:\"text\";a:8:{s:5:\"label\";s:4:\"Text\";s:11:\"description\";s:47:\"This field stores varchar text in the database.\";s:8:\"settings\";a:1:{s:10:\"max_length\";i:255;}s:17:\"instance_settings\";a:2:{s:15:\"text_processing\";i:0;s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:14:\"text_textfield\";s:17:\"default_formatter\";s:12:\"text_default\";s:6:\"module\";s:4:\"text\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:9:\"text_long\";a:8:{s:5:\"label\";s:9:\"Long text\";s:11:\"description\";s:44:\"This field stores long text in the database.\";s:17:\"instance_settings\";a:2:{s:15:\"text_processing\";i:0;s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:13:\"text_textarea\";s:17:\"default_formatter\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:23:\"default_token_formatter\";s:12:\"text_default\";}s:17:\"text_with_summary\";a:8:{s:5:\"label\";s:21:\"Long text and summary\";s:11:\"description\";s:77:\"This field stores long text in the database along with optional summary text.\";s:17:\"instance_settings\";a:3:{s:15:\"text_processing\";i:1;s:15:\"display_summary\";i:0;s:18:\"user_register_form\";b:0;}s:14:\"default_widget\";s:26:\"text_textarea_with_summary\";s:17:\"default_formatter\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:23:\"default_token_formatter\";s:12:\"text_default\";}}s:12:\"widget types\";a:10:{s:21:\"taxonomy_autocomplete\";a:5:{s:5:\"label\";s:34:\"Autocomplete term widget (tagging)\";s:11:\"field types\";a:1:{i:0;s:23:\"taxonomy_term_reference\";}s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:4;}s:6:\"module\";s:8:\"taxonomy\";}s:14:\"text_textfield\";a:4:{s:5:\"label\";s:10:\"Text field\";s:11:\"field types\";a:1:{i:0;s:4:\"text\";}s:8:\"settings\";a:1:{s:4:\"size\";i:60;}s:6:\"module\";s:4:\"text\";}s:13:\"text_textarea\";a:4:{s:5:\"label\";s:25:\"Text area (multiple rows)\";s:11:\"field types\";a:1:{i:0;s:9:\"text_long\";}s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"module\";s:4:\"text\";}s:26:\"text_textarea_with_summary\";a:4:{s:5:\"label\";s:24:\"Text area with a summary\";s:11:\"field types\";a:1:{i:0;s:17:\"text_with_summary\";}s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"module\";s:4:\"text\";}s:13:\"options_onoff\";a:5:{s:5:\"label\";s:22:\"Single on/off checkbox\";s:11:\"field types\";a:1:{i:0;s:12:\"list_boolean\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:4;}s:8:\"settings\";a:1:{s:13:\"display_label\";i:0;}s:6:\"module\";s:7:\"options\";}s:15:\"options_buttons\";a:5:{s:5:\"label\";s:25:\"Check boxes/radio buttons\";s:11:\"field types\";a:5:{i:0;s:12:\"list_integer\";i:1;s:10:\"list_float\";i:2;s:9:\"list_text\";i:3;s:12:\"list_boolean\";i:4;s:23:\"taxonomy_term_reference\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:4;}s:8:\"settings\";a:0:{}s:6:\"module\";s:7:\"options\";}s:11:\"image_image\";a:5:{s:5:\"label\";s:5:\"Image\";s:11:\"field types\";a:1:{i:0;s:5:\"image\";}s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}s:9:\"behaviors\";a:2:{s:15:\"multiple values\";i:4;s:13:\"default value\";i:1;}s:6:\"module\";s:5:\"image\";}s:6:\"number\";a:4:{s:5:\"label\";s:10:\"Text field\";s:11:\"field types\";a:3:{i:0;s:14:\"number_integer\";i:1;s:14:\"number_decimal\";i:2;s:12:\"number_float\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:6:\"number\";}s:14:\"options_select\";a:5:{s:5:\"label\";s:11:\"Select list\";s:11:\"field types\";a:4:{i:0;s:12:\"list_integer\";i:1;s:10:\"list_float\";i:2;s:9:\"list_text\";i:3;s:23:\"taxonomy_term_reference\";}s:9:\"behaviors\";a:1:{s:15:\"multiple values\";i:4;}s:8:\"settings\";a:0:{}s:6:\"module\";s:7:\"options\";}s:12:\"file_generic\";a:5:{s:5:\"label\";s:4:\"File\";s:11:\"field types\";a:1:{i:0;s:4:\"file\";}s:8:\"settings\";a:1:{s:18:\"progress_indicator\";s:8:\"throbber\";}s:9:\"behaviors\";a:2:{s:15:\"multiple values\";i:4;s:13:\"default value\";i:1;}s:6:\"module\";s:4:\"file\";}}s:15:\"formatter types\";a:16:{s:12:\"file_default\";a:4:{s:5:\"label\";s:12:\"Generic file\";s:11:\"field types\";a:1:{i:0;s:4:\"file\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"file\";}s:10:\"file_table\";a:4:{s:5:\"label\";s:14:\"Table of files\";s:11:\"field types\";a:1:{i:0;s:4:\"file\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"file\";}s:14:\"file_url_plain\";a:4:{s:5:\"label\";s:11:\"URL to file\";s:11:\"field types\";a:1:{i:0;s:4:\"file\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"file\";}s:5:\"image\";a:4:{s:5:\"label\";s:5:\"Image\";s:11:\"field types\";a:1:{i:0;s:5:\"image\";}s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:12:\"list_default\";a:4:{s:5:\"label\";s:7:\"Default\";s:11:\"field types\";a:4:{i:0;s:12:\"list_integer\";i:1;s:10:\"list_float\";i:2;s:9:\"list_text\";i:3;s:12:\"list_boolean\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";}s:8:\"list_key\";a:4:{s:5:\"label\";s:3:\"Key\";s:11:\"field types\";a:4:{i:0;s:12:\"list_integer\";i:1;s:10:\"list_float\";i:2;s:9:\"list_text\";i:3;s:12:\"list_boolean\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"list\";}s:14:\"number_integer\";a:4:{s:5:\"label\";s:7:\"Default\";s:11:\"field types\";a:1:{i:0;s:14:\"number_integer\";}s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:0;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:14:\"number_decimal\";a:4:{s:5:\"label\";s:7:\"Default\";s:11:\"field types\";a:2:{i:0;s:14:\"number_decimal\";i:1;s:12:\"number_float\";}s:8:\"settings\";a:4:{s:18:\"thousand_separator\";s:1:\" \";s:17:\"decimal_separator\";s:1:\".\";s:5:\"scale\";i:2;s:13:\"prefix_suffix\";b:1;}s:6:\"module\";s:6:\"number\";}s:18:\"number_unformatted\";a:4:{s:5:\"label\";s:11:\"Unformatted\";s:11:\"field types\";a:3:{i:0;s:14:\"number_integer\";i:1;s:14:\"number_decimal\";i:2;s:12:\"number_float\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:6:\"number\";}s:28:\"taxonomy_term_reference_link\";a:4:{s:5:\"label\";s:4:\"Link\";s:11:\"field types\";a:1:{i:0;s:23:\"taxonomy_term_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:29:\"taxonomy_term_reference_plain\";a:4:{s:5:\"label\";s:10:\"Plain text\";s:11:\"field types\";a:1:{i:0;s:23:\"taxonomy_term_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:36:\"taxonomy_term_reference_rss_category\";a:4:{s:5:\"label\";s:12:\"RSS category\";s:11:\"field types\";a:1:{i:0;s:23:\"taxonomy_term_reference\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:12:\"text_default\";a:4:{s:5:\"label\";s:7:\"Default\";s:11:\"field types\";a:3:{i:0;s:4:\"text\";i:1;s:9:\"text_long\";i:2;s:17:\"text_with_summary\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:10:\"text_plain\";a:4:{s:5:\"label\";s:10:\"Plain text\";s:11:\"field types\";a:3:{i:0;s:4:\"text\";i:1;s:9:\"text_long\";i:2;s:17:\"text_with_summary\";}s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:12:\"text_trimmed\";a:4:{s:5:\"label\";s:7:\"Trimmed\";s:11:\"field types\";a:3:{i:0;s:4:\"text\";i:1;s:9:\"text_long\";i:2;s:17:\"text_with_summary\";}s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}s:23:\"text_summary_or_trimmed\";a:4:{s:5:\"label\";s:18:\"Summary or trimmed\";s:11:\"field types\";a:1:{i:0;s:17:\"text_with_summary\";}s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}}s:13:\"storage types\";a:1:{s:17:\"field_sql_storage\";a:4:{s:5:\"label\";s:19:\"Default SQL storage\";s:11:\"description\";s:64:\"Stores fields in the local SQL database, using per-field tables.\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";}}}',0,1362626465,1);
/*!40000 ALTER TABLE `cache_field` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_filter`
--

DROP TABLE IF EXISTS `cache_filter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_filter` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the Filter module to store already...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_filter`
--

LOCK TABLES `cache_filter` WRITE;
/*!40000 ALTER TABLE `cache_filter` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_filter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_form`
--

DROP TABLE IF EXISTS `cache_form`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_form` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the form system to store recently built...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_form`
--

LOCK TABLES `cache_form` WRITE;
/*!40000 ALTER TABLE `cache_form` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_form` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_image`
--

DROP TABLE IF EXISTS `cache_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_image` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table used to store information about image...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_image`
--

LOCK TABLES `cache_image` WRITE;
/*!40000 ALTER TABLE `cache_image` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_menu`
--

DROP TABLE IF EXISTS `cache_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_menu` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the menu system to store router...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_menu`
--

LOCK TABLES `cache_menu` WRITE;
/*!40000 ALTER TABLE `cache_menu` DISABLE KEYS */;
INSERT INTO `cache_menu` VALUES ('menu_custom','a:5:{s:5:\"devel\";a:3:{s:9:\"menu_name\";s:5:\"devel\";s:5:\"title\";s:11:\"Development\";s:11:\"description\";s:16:\"Development link\";}s:9:\"main-menu\";a:3:{s:9:\"menu_name\";s:9:\"main-menu\";s:5:\"title\";s:9:\"Main menu\";s:11:\"description\";s:115:\"The <em>Main</em> menu is used on many sites to show the major sections of the site, often in a top navigation bar.\";}s:10:\"management\";a:3:{s:9:\"menu_name\";s:10:\"management\";s:5:\"title\";s:10:\"Management\";s:11:\"description\";s:69:\"The <em>Management</em> menu contains links for administrative tasks.\";}s:10:\"navigation\";a:3:{s:9:\"menu_name\";s:10:\"navigation\";s:5:\"title\";s:10:\"Navigation\";s:11:\"description\";s:150:\"The <em>Navigation</em> menu contains links intended for site visitors. Links are added to the <em>Navigation</em> menu automatically by some modules.\";}s:9:\"user-menu\";a:3:{s:9:\"menu_name\";s:9:\"user-menu\";s:5:\"title\";s:9:\"User menu\";s:11:\"description\";s:99:\"The <em>User</em> menu contains links related to the user\'s account, as well as the \'Log out\' link.\";}}',0,1362626460,1);
/*!40000 ALTER TABLE `cache_menu` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_page`
--

DROP TABLE IF EXISTS `cache_page`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_page` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table used to store compressed pages for anonymous...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_page`
--

LOCK TABLES `cache_page` WRITE;
/*!40000 ALTER TABLE `cache_page` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_page` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_path`
--

DROP TABLE IF EXISTS `cache_path`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_path` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for path alias lookup.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_path`
--

LOCK TABLES `cache_path` WRITE;
/*!40000 ALTER TABLE `cache_path` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_path` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_token`
--

DROP TABLE IF EXISTS `cache_token`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_token` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for token information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_token`
--

LOCK TABLES `cache_token` WRITE;
/*!40000 ALTER TABLE `cache_token` DISABLE KEYS */;
/*!40000 ALTER TABLE `cache_token` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cache_update`
--

DROP TABLE IF EXISTS `cache_update`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cache_update` (
  `cid` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique cache ID.',
  `data` longblob COMMENT 'A collection of data to cache.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry should expire, or 0 for never.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when the cache entry was created.',
  `serialized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate whether content is serialized (1) or not (0).',
  PRIMARY KEY (`cid`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache table for the Update module to store information...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cache_update`
--

LOCK TABLES `cache_update` WRITE;
/*!40000 ALTER TABLE `cache_update` DISABLE KEYS */;
INSERT INTO `cache_update` VALUES ('available_releases::ctools','a:10:{s:5:\"title\";s:25:\"Chaos tool suite (ctools)\";s:10:\"short_name\";s:6:\"ctools\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:32:\"http://drupal.org/project/ctools\";s:5:\"terms\";s:31:\"\n   \n   \n   \n   \n   \n   \n   \n  \";s:8:\"releases\";a:11:{s:7:\"7.x-1.2\";a:13:{s:4:\"name\";s:14:\"ctools 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1738460\";s:13:\"download_link\";s:58:\"http://ftp.drupal.org/files/projects/ctools-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1345319204\";s:6:\"mdhash\";s:32:\"62fa855ee8aced1e355b09ac6cd54e99\";s:8:\"filesize\";s:6:\"407345\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:7:\"7.x-1.1\";a:13:{s:4:\"name\";s:14:\"ctools 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1719782\";s:13:\"download_link\";s:58:\"http://ftp.drupal.org/files/projects/ctools-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1344463011\";s:6:\"mdhash\";s:32:\"c36cbb2fd7a6eb8b3245c13972380bd7\";s:8:\"filesize\";s:6:\"405567\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:15:\"Security update\";}}}s:7:\"7.x-1.0\";a:13:{s:4:\"name\";s:14:\"ctools 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1507412\";s:13:\"download_link\";s:58:\"http://ftp.drupal.org/files/projects/ctools-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1332962446\";s:6:\"mdhash\";s:32:\"642eca364e64b0074e5ad49f86627ac5\";s:8:\"filesize\";s:6:\"402254\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:15:\"Security update\";}}}s:11:\"7.x-1.0-rc2\";a:14:{s:4:\"name\";s:18:\"ctools 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1487980\";s:13:\"download_link\";s:62:\"http://ftp.drupal.org/files/projects/ctools-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1332017742\";s:6:\"mdhash\";s:32:\"791167a47cea014fad9018c93376aa88\";s:8:\"filesize\";s:6:\"396440\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:11:\"7.x-1.0-rc1\";a:14:{s:4:\"name\";s:18:\"ctools 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1233062\";s:13:\"download_link\";s:62:\"http://ftp.drupal.org/files/projects/ctools-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1311894415\";s:6:\"mdhash\";s:32:\"39bcea671210505409e3148c8eaefc0e\";s:8:\"filesize\";s:6:\"381078\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:13:\"7.x-1.0-beta1\";a:14:{s:4:\"name\";s:20:\"ctools 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1174824\";s:13:\"download_link\";s:64:\"http://ftp.drupal.org/files/projects/ctools-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1306885315\";s:6:\"mdhash\";s:32:\"96d8154bfab611eb59cbd3774aa94793\";s:8:\"filesize\";s:6:\"378287\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:14:\"7.x-1.0-alpha4\";a:14:{s:4:\"name\";s:21:\"ctools 7.x-1.0-alpha4\";s:7:\"version\";s:14:\"7.x-1.0-alpha4\";s:3:\"tag\";s:14:\"7.x-1.0-alpha4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1105942\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/ctools-7.x-1.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1301099792\";s:6:\"mdhash\";s:32:\"774f6654c149f192b11b136a06be5544\";s:8:\"filesize\";s:6:\"370763\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:14:\"7.x-1.0-alpha3\";a:14:{s:4:\"name\";s:21:\"ctools 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1096670\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/ctools-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1300395967\";s:6:\"mdhash\";s:32:\"1909846a7bd5775c99331c6564ffefa8\";s:8:\"filesize\";s:6:\"370238\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:14:\"7.x-1.0-alpha2\";a:14:{s:4:\"name\";s:21:\"ctools 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1016576\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/ctools-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1294276865\";s:6:\"mdhash\";s:32:\"30e0f5cb27949d2cd67b80bb36701d3e\";s:8:\"filesize\";s:6:\"521068\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:14:\"7.x-1.0-alpha1\";a:14:{s:4:\"name\";s:21:\"ctools 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/938720\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/ctools-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1286838960\";s:6:\"mdhash\";s:32:\"500a55a33f90b2bab865753a0d8c5439\";s:8:\"filesize\";s:6:\"510384\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:13:{s:4:\"name\";s:18:\"ctools 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/691544\";s:13:\"download_link\";s:62:\"http://ftp.drupal.org/files/projects/ctools-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1361580807\";s:6:\"mdhash\";s:32:\"7a22773660d0871fde79d5e35f96f1ab\";s:8:\"filesize\";s:6:\"411720\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}}}',1362712805,1362626405,1),('available_releases::drupal','a:10:{s:5:\"title\";s:11:\"Drupal core\";s:10:\"short_name\";s:6:\"drupal\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"7\";s:16:\"supported_majors\";s:1:\"7\";s:13:\"default_major\";s:1:\"7\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:32:\"http://drupal.org/project/drupal\";s:5:\"terms\";s:15:\"\n   \n   \n   \n  \";s:8:\"releases\";a:37:{s:4:\"7.21\";a:13:{s:4:\"name\";s:11:\"drupal 7.21\";s:7:\"version\";s:4:\"7.21\";s:3:\"tag\";s:4:\"7.21\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"21\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:43:\"http://drupal.org/drupal-7.21-release-notes\";s:13:\"download_link\";s:55:\"http://ftp.drupal.org/files/projects/drupal-7.21.tar.gz\";s:4:\"date\";s:10:\"1362616997\";s:6:\"mdhash\";s:32:\"eff054cd53be39ff719f77c81dce1aac\";s:8:\"filesize\";s:7:\"3163798\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:4:\"7.20\";a:13:{s:4:\"name\";s:11:\"drupal 7.20\";s:7:\"version\";s:4:\"7.20\";s:3:\"tag\";s:4:\"7.20\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"20\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:43:\"http://drupal.org/drupal-7.20-release-notes\";s:13:\"download_link\";s:55:\"http://ftp.drupal.org/files/projects/drupal-7.20.tar.gz\";s:4:\"date\";s:10:\"1361393684\";s:6:\"mdhash\";s:32:\"ee576d63f1fd8a1f1c072a56978da0c5\";s:8:\"filesize\";s:7:\"3163257\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}}s:4:\"7.19\";a:13:{s:4:\"name\";s:11:\"drupal 7.19\";s:7:\"version\";s:4:\"7.19\";s:3:\"tag\";s:4:\"7.19\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"19\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:43:\"http://drupal.org/drupal-7.19-release-notes\";s:13:\"download_link\";s:55:\"http://ftp.drupal.org/files/projects/drupal-7.19.tar.gz\";s:4:\"date\";s:10:\"1358374871\";s:6:\"mdhash\";s:32:\"c1dd3960f1555df208c80ef612e0c53a\";s:8:\"filesize\";s:7:\"3163130\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}}s:4:\"7.18\";a:13:{s:4:\"name\";s:11:\"drupal 7.18\";s:7:\"version\";s:4:\"7.18\";s:3:\"tag\";s:4:\"7.18\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"18\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:43:\"http://drupal.org/drupal-7.18-release-notes\";s:13:\"download_link\";s:55:\"http://ftp.drupal.org/files/projects/drupal-7.18.tar.gz\";s:4:\"date\";s:10:\"1355944004\";s:6:\"mdhash\";s:32:\"5c048f60a53acd7cb3c2b6d5fe42f082\";s:8:\"filesize\";s:7:\"3162333\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}}s:4:\"7.17\";a:13:{s:4:\"name\";s:11:\"drupal 7.17\";s:7:\"version\";s:4:\"7.17\";s:3:\"tag\";s:4:\"7.17\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"17\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:43:\"http://drupal.org/drupal-7.17-release-notes\";s:13:\"download_link\";s:55:\"http://ftp.drupal.org/files/projects/drupal-7.17.tar.gz\";s:4:\"date\";s:10:\"1352325358\";s:6:\"mdhash\";s:32:\"439e8ca7e6a33bb879a4624d8f01bed0\";s:8:\"filesize\";s:7:\"3162429\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:4:\"7.16\";a:13:{s:4:\"name\";s:11:\"drupal 7.16\";s:7:\"version\";s:4:\"7.16\";s:3:\"tag\";s:4:\"7.16\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"16\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1815904\";s:13:\"download_link\";s:55:\"http://ftp.drupal.org/files/projects/drupal-7.16.tar.gz\";s:4:\"date\";s:10:\"1350508568\";s:6:\"mdhash\";s:32:\"352497b2df94b5308e31cb8da020b631\";s:8:\"filesize\";s:7:\"3142889\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}}s:4:\"7.15\";a:13:{s:4:\"name\";s:11:\"drupal 7.15\";s:7:\"version\";s:4:\"7.15\";s:3:\"tag\";s:4:\"7.15\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"15\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1708292\";s:13:\"download_link\";s:55:\"http://ftp.drupal.org/files/projects/drupal-7.15.tar.gz\";s:4:\"date\";s:10:\"1343839327\";s:6:\"mdhash\";s:32:\"f42c9baccd74e1d035d61ff537ae21b4\";s:8:\"filesize\";s:7:\"3142219\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:4:\"7.14\";a:13:{s:4:\"name\";s:11:\"drupal 7.14\";s:7:\"version\";s:4:\"7.14\";s:3:\"tag\";s:4:\"7.14\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"14\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1558424\";s:13:\"download_link\";s:55:\"http://ftp.drupal.org/files/projects/drupal-7.14.tar.gz\";s:4:\"date\";s:10:\"1335997556\";s:6:\"mdhash\";s:32:\"af7abd95c03ecad4e1567ed94a438334\";s:8:\"filesize\";s:7:\"3128473\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:4:\"7.13\";a:13:{s:4:\"name\";s:11:\"drupal 7.13\";s:7:\"version\";s:4:\"7.13\";s:3:\"tag\";s:4:\"7.13\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"13\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1558412\";s:13:\"download_link\";s:55:\"http://ftp.drupal.org/files/projects/drupal-7.13.tar.gz\";s:4:\"date\";s:10:\"1335997261\";s:6:\"mdhash\";s:32:\"80587b66375c7fc539414a20a2c6f2de\";s:8:\"filesize\";s:7:\"3088448\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}}s:4:\"7.12\";a:13:{s:4:\"name\";s:11:\"drupal 7.12\";s:7:\"version\";s:4:\"7.12\";s:3:\"tag\";s:4:\"7.12\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"12\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1425104\";s:13:\"download_link\";s:55:\"http://ftp.drupal.org/files/projects/drupal-7.12.tar.gz\";s:4:\"date\";s:10:\"1328134561\";s:6:\"mdhash\";s:32:\"db2284beb97241c9bdca9c638cd8a4f1\";s:8:\"filesize\";s:7:\"3088472\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:4:\"7.11\";a:13:{s:4:\"name\";s:11:\"drupal 7.11\";s:7:\"version\";s:4:\"7.11\";s:3:\"tag\";s:4:\"7.11\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"11\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1425092\";s:13:\"download_link\";s:55:\"http://ftp.drupal.org/files/projects/drupal-7.11.tar.gz\";s:4:\"date\";s:10:\"1328134275\";s:6:\"mdhash\";s:32:\"e9857e1749762367d7631d74cc6564a7\";s:8:\"filesize\";s:7:\"2789336\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}}s:4:\"7.10\";a:13:{s:4:\"name\";s:11:\"drupal 7.10\";s:7:\"version\";s:4:\"7.10\";s:3:\"tag\";s:4:\"7.10\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"10\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1361968\";s:13:\"download_link\";s:55:\"http://ftp.drupal.org/files/projects/drupal-7.10.tar.gz\";s:4:\"date\";s:10:\"1323125439\";s:6:\"mdhash\";s:32:\"1caafb849bc756e62dd874b90b95ab31\";s:8:\"filesize\";s:7:\"3067653\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:3:\"7.9\";a:13:{s:4:\"name\";s:10:\"drupal 7.9\";s:7:\"version\";s:3:\"7.9\";s:3:\"tag\";s:3:\"7.9\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"9\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1322736\";s:13:\"download_link\";s:54:\"http://ftp.drupal.org/files/projects/drupal-7.9.tar.gz\";s:4:\"date\";s:10:\"1319660731\";s:6:\"mdhash\";s:32:\"7f45f109c413ca69ebb6e3140ed47225\";s:8:\"filesize\";s:7:\"2788086\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:3:\"7.8\";a:13:{s:4:\"name\";s:10:\"drupal 7.8\";s:7:\"version\";s:3:\"7.8\";s:3:\"tag\";s:3:\"7.8\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"8\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1265840\";s:13:\"download_link\";s:54:\"http://ftp.drupal.org/files/projects/drupal-7.8.tar.gz\";s:4:\"date\";s:10:\"1314817617\";s:6:\"mdhash\";s:32:\"e0226b56e8d5c57c6b126e8ed5866b1f\";s:8:\"filesize\";s:7:\"2766967\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:3:\"7.7\";a:13:{s:4:\"name\";s:10:\"drupal 7.7\";s:7:\"version\";s:3:\"7.7\";s:3:\"tag\";s:3:\"7.7\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1231826\";s:13:\"download_link\";s:54:\"http://ftp.drupal.org/files/projects/drupal-7.7.tar.gz\";s:4:\"date\";s:10:\"1311813880\";s:6:\"mdhash\";s:32:\"2eeb63fd1ef6b23b0a9f5f6b8aef8850\";s:8:\"filesize\";s:7:\"2754113\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:3:\"7.6\";a:13:{s:4:\"name\";s:10:\"drupal 7.6\";s:7:\"version\";s:3:\"7.6\";s:3:\"tag\";s:3:\"7.6\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1231586\";s:13:\"download_link\";s:54:\"http://ftp.drupal.org/files/projects/drupal-7.6.tar.gz\";s:4:\"date\";s:10:\"1311798716\";s:6:\"mdhash\";s:32:\"e88e63c4da9e5e170f089d050c88c827\";s:8:\"filesize\";s:7:\"2753784\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:3:\"7.5\";a:13:{s:4:\"name\";s:10:\"drupal 7.5\";s:7:\"version\";s:3:\"7.5\";s:3:\"tag\";s:3:\"7.5\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1231582\";s:13:\"download_link\";s:54:\"http://ftp.drupal.org/files/projects/drupal-7.5.tar.gz\";s:4:\"date\";s:10:\"1311798416\";s:6:\"mdhash\";s:32:\"36d65b7a97c58226c64a6abdf481de45\";s:8:\"filesize\";s:7:\"2744690\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:15:\"Security update\";}}}s:3:\"7.4\";a:13:{s:4:\"name\";s:10:\"drupal 7.4\";s:7:\"version\";s:3:\"7.4\";s:3:\"tag\";s:3:\"7.4\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1204634\";s:13:\"download_link\";s:54:\"http://ftp.drupal.org/files/projects/drupal-7.4.tar.gz\";s:4:\"date\";s:10:\"1309397516\";s:6:\"mdhash\";s:32:\"84704de078e9f5432c9bb5c6ecd841d4\";s:8:\"filesize\";s:7:\"2744808\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:3:\"7.3\";a:13:{s:4:\"name\";s:10:\"drupal 7.3\";s:7:\"version\";s:3:\"7.3\";s:3:\"tag\";s:3:\"7.3\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1204628\";s:13:\"download_link\";s:54:\"http://ftp.drupal.org/files/projects/drupal-7.3.tar.gz\";s:4:\"date\";s:10:\"1309397216\";s:6:\"mdhash\";s:32:\"c290775724bc309647d84d03ddb88e2e\";s:8:\"filesize\";s:7:\"2735461\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}}s:3:\"7.2\";a:13:{s:4:\"name\";s:10:\"drupal 7.2\";s:7:\"version\";s:3:\"7.2\";s:3:\"tag\";s:3:\"7.2\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1168946\";s:13:\"download_link\";s:54:\"http://ftp.drupal.org/files/projects/drupal-7.2.tar.gz\";s:4:\"date\";s:10:\"1306357017\";s:6:\"mdhash\";s:32:\"cf88c87e3694ebd15b62ba6f6a69124f\";s:8:\"filesize\";s:7:\"2731345\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:3:\"7.1\";a:13:{s:4:\"name\";s:10:\"drupal 7.1\";s:7:\"version\";s:3:\"7.1\";s:3:\"tag\";s:3:\"7.1\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1168910\";s:13:\"download_link\";s:54:\"http://ftp.drupal.org/files/projects/drupal-7.1.tar.gz\";s:4:\"date\";s:10:\"1306354916\";s:6:\"mdhash\";s:32:\"27eb45cb894a76f3a9ae6715584a10cc\";s:8:\"filesize\";s:7:\"2713977\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:15:\"Security update\";}}}s:3:\"7.0\";a:13:{s:4:\"name\";s:10:\"drupal 7.0\";s:7:\"version\";s:3:\"7.0\";s:3:\"tag\";s:3:\"7.0\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1015392\";s:13:\"download_link\";s:54:\"http://ftp.drupal.org/files/projects/drupal-7.0.tar.gz\";s:4:\"date\";s:10:\"1294208759\";s:6:\"mdhash\";s:32:\"e96c0a5e47c5d7706897384069dfb920\";s:8:\"filesize\";s:7:\"2728271\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:7:\"7.0-rc4\";a:14:{s:4:\"name\";s:14:\"drupal 7.0-rc4\";s:7:\"version\";s:7:\"7.0-rc4\";s:3:\"tag\";s:8:\"7.0-rc-4\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1010382\";s:13:\"download_link\";s:58:\"http://ftp.drupal.org/files/projects/drupal-7.0-rc4.tar.gz\";s:4:\"date\";s:10:\"1293684084\";s:6:\"mdhash\";s:32:\"104c08e609c64bb1e45b55a7ad1ad857\";s:8:\"filesize\";s:7:\"2717666\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:7:\"7.0-rc3\";a:14:{s:4:\"name\";s:14:\"drupal 7.0-rc3\";s:7:\"version\";s:7:\"7.0-rc3\";s:3:\"tag\";s:8:\"7.0-rc-3\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1005976\";s:13:\"download_link\";s:58:\"http://ftp.drupal.org/files/projects/drupal-7.0-rc3.tar.gz\";s:4:\"date\";s:10:\"1293099424\";s:6:\"mdhash\";s:32:\"be9a3f190e2648fa03dcb2bf3d8be199\";s:8:\"filesize\";s:7:\"2719115\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:15:\"Security update\";}}}s:7:\"7.0-rc2\";a:14:{s:4:\"name\";s:14:\"drupal 7.0-rc2\";s:7:\"version\";s:7:\"7.0-rc2\";s:3:\"tag\";s:8:\"7.0-rc-2\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/995778\";s:13:\"download_link\";s:58:\"http://ftp.drupal.org/files/projects/drupal-7.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1292101847\";s:6:\"mdhash\";s:32:\"f31982c73f1707ddccb2927325bc9cb9\";s:8:\"filesize\";s:7:\"2705734\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:15:\"Security update\";}}}s:7:\"7.0-rc1\";a:14:{s:4:\"name\";s:14:\"drupal 7.0-rc1\";s:7:\"version\";s:7:\"7.0-rc1\";s:3:\"tag\";s:8:\"7.0-rc-1\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/985946\";s:13:\"download_link\";s:58:\"http://ftp.drupal.org/files/projects/drupal-7.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1291190142\";s:6:\"mdhash\";s:32:\"b554e79cf60c02d4dec592151c4b58ee\";s:8:\"filesize\";s:7:\"2694689\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";i:2;s:15:\"Security update\";}}}s:9:\"7.0-beta3\";a:14:{s:4:\"name\";s:16:\"drupal 7.0-beta3\";s:7:\"version\";s:9:\"7.0-beta3\";s:3:\"tag\";s:9:\"7.0-beta3\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/971088\";s:13:\"download_link\";s:60:\"http://ftp.drupal.org/files/projects/drupal-7.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1289694735\";s:6:\"mdhash\";s:32:\"c942f010a2535586c4578cd7b107c652\";s:8:\"filesize\";s:7:\"2660883\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";i:2;s:15:\"Security update\";}}}s:9:\"7.0-beta2\";a:14:{s:4:\"name\";s:16:\"drupal 7.0-beta2\";s:7:\"version\";s:9:\"7.0-beta2\";s:3:\"tag\";s:9:\"7.0-beta2\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/950318\";s:13:\"download_link\";s:60:\"http://ftp.drupal.org/files/projects/drupal-7.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1287812133\";s:6:\"mdhash\";s:32:\"c2de0bdb657b77af8c8369a355cab8ce\";s:8:\"filesize\";s:7:\"2638949\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:9:\"7.0-beta1\";a:14:{s:4:\"name\";s:16:\"drupal 7.0-beta1\";s:7:\"version\";s:9:\"7.0-beta1\";s:3:\"tag\";s:9:\"7.0-beta1\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/934174\";s:13:\"download_link\";s:60:\"http://ftp.drupal.org/files/projects/drupal-7.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1286422866\";s:6:\"mdhash\";s:32:\"490ce0d95eacc15f2918becd60f6821c\";s:8:\"filesize\";s:7:\"2622225\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:15:\"Security update\";}}}s:10:\"7.0-alpha7\";a:14:{s:4:\"name\";s:17:\"drupal 7.0-alpha7\";s:7:\"version\";s:10:\"7.0-alpha7\";s:3:\"tag\";s:10:\"7.0-alpha7\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/913030\";s:13:\"download_link\";s:61:\"http://ftp.drupal.org/files/projects/drupal-7.0-alpha7.tar.gz\";s:4:\"date\";s:10:\"1284599764\";s:6:\"mdhash\";s:32:\"15183fcf862be97f7e96991e6e56fe2e\";s:8:\"filesize\";s:7:\"2586833\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:15:\"Security update\";}}}s:10:\"7.0-alpha6\";a:14:{s:4:\"name\";s:17:\"drupal 7.0-alpha6\";s:7:\"version\";s:10:\"7.0-alpha6\";s:3:\"tag\";s:10:\"7.0-alpha6\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/848970\";s:13:\"download_link\";s:61:\"http://ftp.drupal.org/files/projects/drupal-7.0-alpha6.tar.gz\";s:4:\"date\";s:10:\"1278634809\";s:6:\"mdhash\";s:32:\"eb64647263affc36f76d1e7ffb751d32\";s:8:\"filesize\";s:7:\"2458211\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";i:2;s:15:\"Security update\";}}}s:10:\"7.0-alpha5\";a:14:{s:4:\"name\";s:17:\"drupal 7.0-alpha5\";s:7:\"version\";s:10:\"7.0-alpha5\";s:3:\"tag\";s:10:\"7.0-alpha5\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/806978\";s:13:\"download_link\";s:61:\"http://ftp.drupal.org/files/projects/drupal-7.0-alpha5.tar.gz\";s:4:\"date\";s:10:\"1274628613\";s:6:\"mdhash\";s:32:\"de9c1d51f0ce730f7356bd0a160e8ce1\";s:8:\"filesize\";s:7:\"2424226\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:15:\"Security update\";}}}s:10:\"7.0-alpha4\";a:14:{s:4:\"name\";s:17:\"drupal 7.0-alpha4\";s:7:\"version\";s:10:\"7.0-alpha4\";s:3:\"tag\";s:10:\"7.0-alpha4\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/782394\";s:13:\"download_link\";s:61:\"http://ftp.drupal.org/files/projects/drupal-7.0-alpha4.tar.gz\";s:4:\"date\";s:10:\"1272318014\";s:6:\"mdhash\";s:32:\"c8f371a388bc65b2211d7d29856fb993\";s:8:\"filesize\";s:7:\"2403384\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:15:\"Security update\";}}}s:10:\"7.0-alpha3\";a:14:{s:4:\"name\";s:17:\"drupal 7.0-alpha3\";s:7:\"version\";s:10:\"7.0-alpha3\";s:3:\"tag\";s:10:\"7.0-alpha3\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/748690\";s:13:\"download_link\";s:61:\"http://ftp.drupal.org/files/projects/drupal-7.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1269192317\";s:6:\"mdhash\";s:32:\"9efc083f09d6b523d655bc90a6869945\";s:8:\"filesize\";s:7:\"2357934\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";i:2;s:15:\"Security update\";}}}s:10:\"7.0-alpha2\";a:14:{s:4:\"name\";s:17:\"drupal 7.0-alpha2\";s:7:\"version\";s:10:\"7.0-alpha2\";s:3:\"tag\";s:10:\"7.0-alpha2\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/721114\";s:13:\"download_link\";s:61:\"http://ftp.drupal.org/files/projects/drupal-7.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1266777910\";s:6:\"mdhash\";s:32:\"cfbfdd2249638a266054f2532348065d\";s:8:\"filesize\";s:7:\"2314834\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:10:\"7.0-alpha1\";a:14:{s:4:\"name\";s:17:\"drupal 7.0-alpha1\";s:7:\"version\";s:10:\"7.0-alpha1\";s:3:\"tag\";s:10:\"7.0-alpha1\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/685748\";s:13:\"download_link\";s:61:\"http://ftp.drupal.org/files/projects/drupal-7.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1263566711\";s:6:\"mdhash\";s:32:\"508109c6cf0ead868e02d8c3db2a4d1f\";s:8:\"filesize\";s:7:\"2283220\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}}s:7:\"7.x-dev\";a:13:{s:4:\"name\";s:14:\"Drupal 7.x-dev\";s:7:\"version\";s:7:\"7.x-dev\";s:3:\"tag\";s:3:\"7.x\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/156281\";s:13:\"download_link\";s:58:\"http://ftp.drupal.org/files/projects/drupal-7.x-dev.tar.gz\";s:4:\"date\";s:10:\"1362488378\";s:6:\"mdhash\";s:32:\"05edfdbb95d9cadfabb40dc71e6a8326\";s:8:\"filesize\";s:7:\"3178186\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}}}',1362709895,1362623493,1),('available_releases::imce','a:10:{s:5:\"title\";s:4:\"IMCE\";s:10:\"short_name\";s:4:\"imce\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:30:\"http://drupal.org/project/imce\";s:5:\"terms\";s:23:\"\n   \n   \n   \n   \n   \n  \";s:8:\"releases\";a:14:{s:7:\"7.x-1.7\";a:13:{s:4:\"name\";s:12:\"imce 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1902126\";s:13:\"download_link\";s:56:\"http://ftp.drupal.org/files/projects/imce-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1359476607\";s:6:\"mdhash\";s:32:\"c352bf9da8433628bed0b79c4acdcdb8\";s:8:\"filesize\";s:5:\"61286\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:7:\"7.x-1.6\";a:13:{s:4:\"name\";s:12:\"imce 7.x-1.6\";s:7:\"version\";s:7:\"7.x-1.6\";s:3:\"tag\";s:7:\"7.x-1.6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1837090\";s:13:\"download_link\";s:56:\"http://ftp.drupal.org/files/projects/imce-7.x-1.6.tar.gz\";s:4:\"date\";s:10:\"1352537820\";s:6:\"mdhash\";s:32:\"e1300316ea4245063b79bd91f9fd0bcf\";s:8:\"filesize\";s:5:\"61316\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:7:\"7.x-1.5\";a:13:{s:4:\"name\";s:12:\"imce 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1315528\";s:13:\"download_link\";s:56:\"http://ftp.drupal.org/files/projects/imce-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1319104232\";s:6:\"mdhash\";s:32:\"43c36da627ed770bec0e21a442eec712\";s:8:\"filesize\";s:5:\"61276\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:7:\"7.x-1.4\";a:13:{s:4:\"name\";s:12:\"imce 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1180420\";s:13:\"download_link\";s:56:\"http://ftp.drupal.org/files/projects/imce-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1307386616\";s:6:\"mdhash\";s:32:\"6d11af3cd365c143317a0dc37599505c\";s:8:\"filesize\";s:5:\"60190\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:7:\"7.x-1.3\";a:13:{s:4:\"name\";s:12:\"imce 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1096404\";s:13:\"download_link\";s:56:\"http://ftp.drupal.org/files/projects/imce-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1300384567\";s:6:\"mdhash\";s:32:\"9a3b27ca2b5e2aceb3f1ee30841fa8b3\";s:8:\"filesize\";s:5:\"59939\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:7:\"7.x-1.2\";a:13:{s:4:\"name\";s:12:\"imce 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1048090\";s:13:\"download_link\";s:56:\"http://ftp.drupal.org/files/projects/imce-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1296601518\";s:6:\"mdhash\";s:32:\"c6bb7fea90545f71dcf32134b8cf8157\";s:8:\"filesize\";s:5:\"58810\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:7:\"7.x-1.1\";a:13:{s:4:\"name\";s:12:\"imce 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1008336\";s:13:\"download_link\";s:56:\"http://ftp.drupal.org/files/projects/imce-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1293481279\";s:6:\"mdhash\";s:32:\"cef3122364a21b587448b659c34d7b06\";s:8:\"filesize\";s:5:\"58517\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:7:\"7.x-1.0\";a:13:{s:4:\"name\";s:12:\"imce 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1007258\";s:13:\"download_link\";s:56:\"http://ftp.drupal.org/files/projects/imce-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1293289898\";s:6:\"mdhash\";s:32:\"63947e1f2fd23888c014df5bc618b636\";s:8:\"filesize\";s:5:\"58495\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:13:\"7.x-1.0-beta1\";a:14:{s:4:\"name\";s:18:\"imce 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/936546\";s:13:\"download_link\";s:62:\"http://ftp.drupal.org/files/projects/imce-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1286606463\";s:6:\"mdhash\";s:32:\"f0a6cd298c8fd85e96b225d4b0e6a38d\";s:8:\"filesize\";s:5:\"58423\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha3\";a:14:{s:4:\"name\";s:19:\"imce 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/833832\";s:13:\"download_link\";s:63:\"http://ftp.drupal.org/files/projects/imce-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1277145015\";s:6:\"mdhash\";s:32:\"161f69f59d6f56a8529446fb147992d3\";s:8:\"filesize\";s:5:\"57825\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:14:\"7.x-1.0-alpha2\";a:14:{s:4:\"name\";s:19:\"imce 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/812594\";s:13:\"download_link\";s:63:\"http://ftp.drupal.org/files/projects/imce-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1275125108\";s:6:\"mdhash\";s:32:\"5692e073e353d7451c47c63b381fae9c\";s:8:\"filesize\";s:5:\"57483\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:14:\"7.x-1.0-alpha1\";a:14:{s:4:\"name\";s:19:\"imce 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/745530\";s:13:\"download_link\";s:63:\"http://ftp.drupal.org/files/projects/imce-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1268868307\";s:6:\"mdhash\";s:32:\"3aeebc6a28e99abbd5260c28e499d646\";s:8:\"filesize\";s:5:\"55587\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:13:{s:4:\"name\";s:16:\"imce 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/936578\";s:13:\"download_link\";s:60:\"http://ftp.drupal.org/files/projects/imce-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1359508705\";s:6:\"mdhash\";s:32:\"924167b2aef432c324b072cc8cffed69\";s:8:\"filesize\";s:5:\"61273\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:6:\"master\";a:12:{s:4:\"name\";s:9:\"imce HEAD\";s:7:\"version\";s:6:\"master\";s:3:\"tag\";s:6:\"master\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:28:\"http://drupal.org/node/96654\";s:13:\"download_link\";s:53:\"http://ftp.drupal.org/files/projects/imce-HEAD.tar.gz\";s:4:\"date\";s:10:\"1286626342\";s:6:\"mdhash\";s:32:\"94c619d7b66e55cd6c810baf0c13211d\";s:8:\"filesize\";s:5:\"58416\";s:5:\"files\";s:19:\"\n   \n   \n   \n   \n  \";s:5:\"terms\";a:0:{}}}}',1362712806,1362626405,1),('available_releases::imce_wysiwyg','a:10:{s:5:\"title\";s:19:\"IMCE Wysiwyg bridge\";s:10:\"short_name\";s:12:\"imce_wysiwyg\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:38:\"http://drupal.org/project/imce_wysiwyg\";s:5:\"terms\";s:19:\"\n   \n   \n   \n   \n  \";s:8:\"releases\";a:2:{s:7:\"7.x-1.0\";a:13:{s:4:\"name\";s:20:\"imce_wysiwyg 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1300800\";s:13:\"download_link\";s:64:\"http://ftp.drupal.org/files/projects/imce_wysiwyg-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1317851503\";s:6:\"mdhash\";s:32:\"b0b9ef729f86de2d348b4302ad3591ef\";s:8:\"filesize\";s:4:\"9020\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:13:{s:4:\"name\";s:24:\"imce_wysiwyg 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/670850\";s:13:\"download_link\";s:68:\"http://ftp.drupal.org/files/projects/imce_wysiwyg-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1317860389\";s:6:\"mdhash\";s:32:\"47c01ecddc282d903a1614c20973b6e3\";s:8:\"filesize\";s:4:\"9021\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}}}',1362712807,1362626405,1),('available_releases::jquery_update','a:10:{s:5:\"title\";s:13:\"jQuery Update\";s:10:\"short_name\";s:13:\"jquery_update\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:39:\"http://drupal.org/project/jquery_update\";s:5:\"terms\";s:19:\"\n   \n   \n   \n   \n  \";s:8:\"releases\";a:8:{s:7:\"7.x-2.3\";a:13:{s:4:\"name\";s:21:\"jquery_update 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1912546\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/jquery_update-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1360375905\";s:6:\"mdhash\";s:32:\"2d5a1e594a027fa849ed250f5dfef7c5\";s:8:\"filesize\";s:6:\"709788\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:14:\"7.x-2.3-alpha1\";a:14:{s:4:\"name\";s:28:\"jquery_update 7.x-2.3-alpha1\";s:7:\"version\";s:14:\"7.x-2.3-alpha1\";s:3:\"tag\";s:14:\"7.x-2.3-alpha1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1797336\";s:13:\"download_link\";s:72:\"http://ftp.drupal.org/files/projects/jquery_update-7.x-2.3-alpha1.tar.gz\";s:4:\"date\";s:10:\"1348790474\";s:6:\"mdhash\";s:32:\"2fe04a30f74e47c0b1a4ce24023a39fa\";s:8:\"filesize\";s:6:\"709779\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:7:\"7.x-2.2\";a:13:{s:4:\"name\";s:21:\"jquery_update 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1115508\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/jquery_update-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1301920269\";s:6:\"mdhash\";s:32:\"944e097382c08d9a3ba5028ac700162b\";s:8:\"filesize\";s:6:\"482023\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:7:\"7.x-2.1\";a:13:{s:4:\"name\";s:21:\"jquery_update 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1099392\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/jquery_update-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1300647067\";s:6:\"mdhash\";s:32:\"6b6f9064e23aaede7ce9f04ded255a57\";s:8:\"filesize\";s:6:\"479984\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:7:\"7.x-2.0\";a:13:{s:4:\"name\";s:21:\"jquery_update 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1059012\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/jquery_update-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1297454705\";s:6:\"mdhash\";s:32:\"de6d8095e0bdd4e231922974df3f8fc7\";s:8:\"filesize\";s:6:\"476204\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}}s:11:\"7.x-2.x-dev\";a:13:{s:4:\"name\";s:25:\"jquery_update 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/405854\";s:13:\"download_link\";s:69:\"http://ftp.drupal.org/files/projects/jquery_update-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1348792748\";s:6:\"mdhash\";s:32:\"4f577abd08e40e609456405f80c278f2\";s:8:\"filesize\";s:6:\"709797\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:7:\"7.x-1.0\";a:13:{s:4:\"name\";s:21:\"jquery_update 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1058970\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/jquery_update-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1297453316\";s:6:\"mdhash\";s:32:\"4fa3749b8e477b76341d72a5516344d8\";s:8:\"filesize\";s:6:\"476208\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:13:{s:4:\"name\";s:25:\"jquery_update 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1058116\";s:13:\"download_link\";s:69:\"http://ftp.drupal.org/files/projects/jquery_update-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1298619505\";s:6:\"mdhash\";s:32:\"350ad8b47b26664fd7162d480cdb0962\";s:8:\"filesize\";s:6:\"471050\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}}}',1362712808,1362626405,1),('available_releases::panels','a:10:{s:5:\"title\";s:6:\"Panels\";s:10:\"short_name\";s:6:\"panels\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"3\";s:16:\"supported_majors\";s:1:\"3\";s:13:\"default_major\";s:1:\"3\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:32:\"http://drupal.org/project/panels\";s:5:\"terms\";s:19:\"\n   \n   \n   \n   \n  \";s:8:\"releases\";a:8:{s:7:\"7.x-3.3\";a:13:{s:4:\"name\";s:14:\"panels 7.x-3.3\";s:7:\"version\";s:7:\"7.x-3.3\";s:3:\"tag\";s:7:\"7.x-3.3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1738468\";s:13:\"download_link\";s:58:\"http://ftp.drupal.org/files/projects/panels-7.x-3.3.tar.gz\";s:4:\"date\";s:10:\"1345319572\";s:6:\"mdhash\";s:32:\"41d55ac3806a254d0e16cf865f74a1ee\";s:8:\"filesize\";s:6:\"339088\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:7:\"7.x-3.2\";a:13:{s:4:\"name\";s:14:\"panels 7.x-3.2\";s:7:\"version\";s:7:\"7.x-3.2\";s:3:\"tag\";s:7:\"7.x-3.2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1488614\";s:13:\"download_link\";s:58:\"http://ftp.drupal.org/files/projects/panels-7.x-3.2.tar.gz\";s:4:\"date\";s:10:\"1332079243\";s:6:\"mdhash\";s:32:\"ce1bab0d151e3717668e5f656f7baafe\";s:8:\"filesize\";s:6:\"338032\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:7:\"7.x-3.1\";a:13:{s:4:\"name\";s:14:\"panels 7.x-3.1\";s:7:\"version\";s:7:\"7.x-3.1\";s:3:\"tag\";s:7:\"7.x-3.1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1488034\";s:13:\"download_link\";s:58:\"http://ftp.drupal.org/files/projects/panels-7.x-3.1.tar.gz\";s:4:\"date\";s:10:\"1332023443\";s:6:\"mdhash\";s:32:\"461e61c41a279c039da2bfbe2cfa41a9\";s:8:\"filesize\";s:6:\"338032\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:7:\"7.x-3.0\";a:13:{s:4:\"name\";s:14:\"panels 7.x-3.0\";s:7:\"version\";s:7:\"7.x-3.0\";s:3:\"tag\";s:7:\"7.x-3.0\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1409448\";s:13:\"download_link\";s:58:\"http://ftp.drupal.org/files/projects/panels-7.x-3.0.tar.gz\";s:4:\"date\";s:10:\"1326917446\";s:6:\"mdhash\";s:32:\"ff701b5e4bcea2d85a4bf9ea3a1ebc42\";s:8:\"filesize\";s:6:\"326150\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:15:\"Security update\";}}}s:14:\"7.x-3.0-alpha3\";a:14:{s:4:\"name\";s:21:\"panels 7.x-3.0-alpha3\";s:7:\"version\";s:14:\"7.x-3.0-alpha3\";s:3:\"tag\";s:14:\"7.x-3.0-alpha3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1096674\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/panels-7.x-3.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1300396268\";s:6:\"mdhash\";s:32:\"278d49187d64b3bc431d67fb8f88278b\";s:8:\"filesize\";s:6:\"324343\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:14:\"7.x-3.0-alpha2\";a:14:{s:4:\"name\";s:21:\"panels 7.x-3.0-alpha2\";s:7:\"version\";s:14:\"7.x-3.0-alpha2\";s:3:\"tag\";s:14:\"7.x-3.0-alpha2\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1022038\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/panels-7.x-3.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1294697038\";s:6:\"mdhash\";s:32:\"47b16bea57350c30e9c8418cdab2ce83\";s:8:\"filesize\";s:6:\"380479\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:14:\"7.x-3.0-alpha1\";a:14:{s:4:\"name\";s:21:\"panels 7.x-3.0-alpha1\";s:7:\"version\";s:14:\"7.x-3.0-alpha1\";s:3:\"tag\";s:14:\"7.x-3.0-alpha1\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/938732\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/panels-7.x-3.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1286839262\";s:6:\"mdhash\";s:32:\"948e822378926bddec3959c2f611a26c\";s:8:\"filesize\";s:6:\"386977\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:11:\"7.x-3.x-dev\";a:13:{s:4:\"name\";s:18:\"panels 7.x-3.x-dev\";s:7:\"version\";s:11:\"7.x-3.x-dev\";s:3:\"tag\";s:7:\"7.x-3.x\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/691552\";s:13:\"download_link\";s:62:\"http://ftp.drupal.org/files/projects/panels-7.x-3.x-dev.tar.gz\";s:4:\"date\";s:10:\"1362187383\";s:6:\"mdhash\";s:32:\"f3eb9ec47b73aa2dcb826e8a4cab958b\";s:8:\"filesize\";s:6:\"341536\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}}}',1362712808,1362626405,1),('available_releases::pathauto','a:10:{s:5:\"title\";s:8:\"Pathauto\";s:10:\"short_name\";s:8:\"pathauto\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:34:\"http://drupal.org/project/pathauto\";s:5:\"terms\";s:27:\"\n   \n   \n   \n   \n   \n   \n  \";s:8:\"releases\";a:9:{s:7:\"7.x-1.2\";a:13:{s:4:\"name\";s:16:\"pathauto 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1721024\";s:13:\"download_link\";s:60:\"http://ftp.drupal.org/files/projects/pathauto-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1344525185\";s:6:\"mdhash\";s:32:\"abdb73c49803aefe3c87774a92c42b87\";s:8:\"filesize\";s:5:\"38900\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}}s:7:\"7.x-1.1\";a:13:{s:4:\"name\";s:16:\"pathauto 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1576582\";s:13:\"download_link\";s:60:\"http://ftp.drupal.org/files/projects/pathauto-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1336950382\";s:6:\"mdhash\";s:32:\"ee42c248db62f384871cb526d72005f2\";s:8:\"filesize\";s:5:\"38652\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:7:\"7.x-1.0\";a:13:{s:4:\"name\";s:16:\"pathauto 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1327340\";s:13:\"download_link\";s:60:\"http://ftp.drupal.org/files/projects/pathauto-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1320072936\";s:6:\"mdhash\";s:32:\"6edd617da0cfa31ddde247933d670ef4\";s:8:\"filesize\";s:5:\"37196\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:11:\"7.x-1.0-rc2\";a:14:{s:4:\"name\";s:20:\"pathauto 7.x-1.0-rc2\";s:7:\"version\";s:11:\"7.x-1.0-rc2\";s:3:\"tag\";s:11:\"7.x-1.0-rc2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1190628\";s:13:\"download_link\";s:64:\"http://ftp.drupal.org/files/projects/pathauto-7.x-1.0-rc2.tar.gz\";s:4:\"date\";s:10:\"1308241021\";s:6:\"mdhash\";s:32:\"376c28fa39f3b383ad5134c5a1360be7\";s:8:\"filesize\";s:5:\"35681\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:11:\"7.x-1.0-rc1\";a:14:{s:4:\"name\";s:20:\"pathauto 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1188914\";s:13:\"download_link\";s:64:\"http://ftp.drupal.org/files/projects/pathauto-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1308121619\";s:6:\"mdhash\";s:32:\"a53a56cffaaa67c8775c085d542f162c\";s:8:\"filesize\";s:5:\"35350\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:13:\"7.x-1.0-beta1\";a:14:{s:4:\"name\";s:22:\"pathauto 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1025104\";s:13:\"download_link\";s:66:\"http://ftp.drupal.org/files/projects/pathauto-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1294891602\";s:6:\"mdhash\";s:32:\"37c8eaa37d69d60303e702c271f99f9e\";s:8:\"filesize\";s:5:\"56885\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:14:\"7.x-1.0-alpha2\";a:14:{s:4:\"name\";s:23:\"pathauto 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/880470\";s:13:\"download_link\";s:67:\"http://ftp.drupal.org/files/projects/pathauto-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1281556294\";s:6:\"mdhash\";s:32:\"5f4aecc1b5d6a6e4365fafcc7f0efe15\";s:8:\"filesize\";s:6:\"122301\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:3:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";i:2;s:15:\"Security update\";}}}s:14:\"7.x-1.0-alpha1\";a:14:{s:4:\"name\";s:23:\"pathauto 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/727822\";s:13:\"download_link\";s:67:\"http://ftp.drupal.org/files/projects/pathauto-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1267300506\";s:6:\"mdhash\";s:32:\"ec86f7a12f9b4daa02967a3d7ccedef6\";s:8:\"filesize\";s:6:\"121249\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:13:{s:4:\"name\";s:20:\"pathauto 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/273527\";s:13:\"download_link\";s:64:\"http://ftp.drupal.org/files/projects/pathauto-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1360157919\";s:6:\"mdhash\";s:32:\"3dd229dade71ce94f8ef542584ba2b9b\";s:8:\"filesize\";s:5:\"40212\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}}}',1362712809,1362626405,1),('available_releases::tagadelic','a:10:{s:5:\"title\";s:9:\"Tagadelic\";s:10:\"short_name\";s:9:\"tagadelic\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:3:\"1,2\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:35:\"http://drupal.org/project/tagadelic\";s:5:\"terms\";s:15:\"\n   \n   \n   \n  \";s:8:\"releases\";a:2:{s:11:\"7.x-2.x-dev\";a:13:{s:4:\"name\";s:21:\"tagadelic 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1913442\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/tagadelic-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1360547141\";s:6:\"mdhash\";s:32:\"30e45e013106c8198de48c82cca4a568\";s:8:\"filesize\";s:5:\"20864\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:13:{s:4:\"name\";s:21:\"tagadelic 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1160134\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/tagadelic-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1328704746\";s:6:\"mdhash\";s:32:\"cfb9f7e46659ec0408a95dd0719f44bd\";s:8:\"filesize\";s:5:\"26584\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}}}',1362712809,1362626405,1),('available_releases::token','a:10:{s:5:\"title\";s:5:\"Token\";s:10:\"short_name\";s:5:\"token\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"1\";s:16:\"supported_majors\";s:1:\"1\";s:13:\"default_major\";s:1:\"1\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:31:\"http://drupal.org/project/token\";s:5:\"terms\";s:23:\"\n   \n   \n   \n   \n   \n  \";s:8:\"releases\";a:18:{s:7:\"7.x-1.5\";a:13:{s:4:\"name\";s:13:\"token 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1925724\";s:13:\"download_link\";s:57:\"http://ftp.drupal.org/files/projects/token-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1361665026\";s:6:\"mdhash\";s:32:\"93e5a19e8b244022cc38e58663db8001\";s:8:\"filesize\";s:5:\"44012\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:7:\"7.x-1.4\";a:13:{s:4:\"name\";s:13:\"token 7.x-1.4\";s:7:\"version\";s:7:\"7.x-1.4\";s:3:\"tag\";s:7:\"7.x-1.4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1793386\";s:13:\"download_link\";s:57:\"http://ftp.drupal.org/files/projects/token-7.x-1.4.tar.gz\";s:4:\"date\";s:10:\"1348497279\";s:6:\"mdhash\";s:32:\"e65a894f14518751ca1da445a767965c\";s:8:\"filesize\";s:5:\"43675\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:7:\"7.x-1.3\";a:13:{s:4:\"name\";s:13:\"token 7.x-1.3\";s:7:\"version\";s:7:\"7.x-1.3\";s:3:\"tag\";s:7:\"7.x-1.3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1782538\";s:13:\"download_link\";s:57:\"http://ftp.drupal.org/files/projects/token-7.x-1.3.tar.gz\";s:4:\"date\";s:10:\"1347466790\";s:6:\"mdhash\";s:32:\"efe130120435cf38d33e6ae005ad0956\";s:8:\"filesize\";s:5:\"43666\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:9:\"Bug fixes\";i:1;s:15:\"Security update\";}}}s:7:\"7.x-1.2\";a:13:{s:4:\"name\";s:13:\"token 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1722888\";s:13:\"download_link\";s:57:\"http://ftp.drupal.org/files/projects/token-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1344634643\";s:6:\"mdhash\";s:32:\"0cb93d8a597acd5f99acdc7cb42b6332\";s:8:\"filesize\";s:5:\"43170\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:7:\"7.x-1.1\";a:13:{s:4:\"name\";s:13:\"token 7.x-1.1\";s:7:\"version\";s:7:\"7.x-1.1\";s:3:\"tag\";s:7:\"7.x-1.1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1580482\";s:13:\"download_link\";s:57:\"http://ftp.drupal.org/files/projects/token-7.x-1.1.tar.gz\";s:4:\"date\";s:10:\"1337115392\";s:6:\"mdhash\";s:32:\"8d4c96128ab3ef9f4e76fbdb73900e35\";s:8:\"filesize\";s:5:\"42496\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:7:\"7.x-1.0\";a:13:{s:4:\"name\";s:13:\"token 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1517088\";s:13:\"download_link\";s:57:\"http://ftp.drupal.org/files/projects/token-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1333672577\";s:6:\"mdhash\";s:32:\"21709598974906287ea5bd68f2b94815\";s:8:\"filesize\";s:5:\"42264\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:11:\"7.x-1.0-rc1\";a:14:{s:4:\"name\";s:17:\"token 7.x-1.0-rc1\";s:7:\"version\";s:11:\"7.x-1.0-rc1\";s:3:\"tag\";s:11:\"7.x-1.0-rc1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:3:\"rc1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1422936\";s:13:\"download_link\";s:61:\"http://ftp.drupal.org/files/projects/token-7.x-1.0-rc1.tar.gz\";s:4:\"date\";s:10:\"1328022364\";s:6:\"mdhash\";s:32:\"b63435f4a943cb013aa34339f5ce8bb0\";s:8:\"filesize\";s:5:\"41089\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:13:\"7.x-1.0-beta7\";a:14:{s:4:\"name\";s:19:\"token 7.x-1.0-beta7\";s:7:\"version\";s:13:\"7.x-1.0-beta7\";s:3:\"tag\";s:13:\"7.x-1.0-beta7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1325314\";s:13:\"download_link\";s:63:\"http://ftp.drupal.org/files/projects/token-7.x-1.0-beta7.tar.gz\";s:4:\"date\";s:10:\"1319825735\";s:6:\"mdhash\";s:32:\"9d5644d212720e8c9db7fcbcf4559468\";s:8:\"filesize\";s:5:\"40531\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:13:\"7.x-1.0-beta6\";a:14:{s:4:\"name\";s:19:\"token 7.x-1.0-beta6\";s:7:\"version\";s:13:\"7.x-1.0-beta6\";s:3:\"tag\";s:13:\"7.x-1.0-beta6\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta6\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1295968\";s:13:\"download_link\";s:63:\"http://ftp.drupal.org/files/projects/token-7.x-1.0-beta6.tar.gz\";s:4:\"date\";s:10:\"1317397307\";s:6:\"mdhash\";s:32:\"797c619140cdcc00004ce5e64b25eb02\";s:8:\"filesize\";s:5:\"40155\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}s:13:\"7.x-1.0-beta5\";a:14:{s:4:\"name\";s:19:\"token 7.x-1.0-beta5\";s:7:\"version\";s:13:\"7.x-1.0-beta5\";s:3:\"tag\";s:13:\"7.x-1.0-beta5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1265604\";s:13:\"download_link\";s:63:\"http://ftp.drupal.org/files/projects/token-7.x-1.0-beta5.tar.gz\";s:4:\"date\";s:10:\"1314804722\";s:6:\"mdhash\";s:32:\"42b75e49ecfe3945cf3971b20d64e21f\";s:8:\"filesize\";s:5:\"38428\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:13:\"7.x-1.0-beta4\";a:14:{s:4:\"name\";s:19:\"token 7.x-1.0-beta4\";s:7:\"version\";s:13:\"7.x-1.0-beta4\";s:3:\"tag\";s:13:\"7.x-1.0-beta4\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta4\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1252544\";s:13:\"download_link\";s:63:\"http://ftp.drupal.org/files/projects/token-7.x-1.0-beta4.tar.gz\";s:4:\"date\";s:10:\"1313614619\";s:6:\"mdhash\";s:32:\"00aea5ce506db5a5308e4881cc16a650\";s:8:\"filesize\";s:5:\"36328\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:13:\"7.x-1.0-beta3\";a:14:{s:4:\"name\";s:19:\"token 7.x-1.0-beta3\";s:7:\"version\";s:13:\"7.x-1.0-beta3\";s:3:\"tag\";s:13:\"7.x-1.0-beta3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1230300\";s:13:\"download_link\";s:63:\"http://ftp.drupal.org/files/projects/token-7.x-1.0-beta3.tar.gz\";s:4:\"date\";s:10:\"1311709319\";s:6:\"mdhash\";s:32:\"236041ef8c6249adae04f0af98e8aa8b\";s:8:\"filesize\";s:5:\"34573\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:13:\"7.x-1.0-beta2\";a:14:{s:4:\"name\";s:19:\"token 7.x-1.0-beta2\";s:7:\"version\";s:13:\"7.x-1.0-beta2\";s:3:\"tag\";s:13:\"7.x-1.0-beta2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1162954\";s:13:\"download_link\";s:63:\"http://ftp.drupal.org/files/projects/token-7.x-1.0-beta2.tar.gz\";s:4:\"date\";s:10:\"1305833216\";s:6:\"mdhash\";s:32:\"33678788042e89887c17f072f22b360e\";s:8:\"filesize\";s:5:\"32677\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:13:\"7.x-1.0-beta1\";a:14:{s:4:\"name\";s:19:\"token 7.x-1.0-beta1\";s:7:\"version\";s:13:\"7.x-1.0-beta1\";s:3:\"tag\";s:13:\"7.x-1.0-beta1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:5:\"beta1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1023874\";s:13:\"download_link\";s:63:\"http://ftp.drupal.org/files/projects/token-7.x-1.0-beta1.tar.gz\";s:4:\"date\";s:10:\"1294805791\";s:6:\"mdhash\";s:32:\"0c597a7a17a7a27a725cf076bbae25e4\";s:8:\"filesize\";s:5:\"31159\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:14:\"7.x-1.0-alpha3\";a:14:{s:4:\"name\";s:20:\"token 7.x-1.0-alpha3\";s:7:\"version\";s:14:\"7.x-1.0-alpha3\";s:3:\"tag\";s:14:\"7.x-1.0-alpha3\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/934904\";s:13:\"download_link\";s:64:\"http://ftp.drupal.org/files/projects/token-7.x-1.0-alpha3.tar.gz\";s:4:\"date\";s:10:\"1286469965\";s:6:\"mdhash\";s:32:\"16096ce5c4a1f7e0b70c31026d88238a\";s:8:\"filesize\";s:5:\"23473\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:14:\"7.x-1.0-alpha2\";a:14:{s:4:\"name\";s:20:\"token 7.x-1.0-alpha2\";s:7:\"version\";s:14:\"7.x-1.0-alpha2\";s:3:\"tag\";s:14:\"7.x-1.0-alpha2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/880354\";s:13:\"download_link\";s:64:\"http://ftp.drupal.org/files/projects/token-7.x-1.0-alpha2.tar.gz\";s:4:\"date\";s:10:\"1281549992\";s:6:\"mdhash\";s:32:\"788bb2827e595fa41387afbe116f462d\";s:8:\"filesize\";s:5:\"21523\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:14:\"7.x-1.0-alpha1\";a:14:{s:4:\"name\";s:20:\"token 7.x-1.0-alpha1\";s:7:\"version\";s:14:\"7.x-1.0-alpha1\";s:3:\"tag\";s:14:\"7.x-1.0-alpha1\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:13:\"version_extra\";s:6:\"alpha1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/774356\";s:13:\"download_link\";s:64:\"http://ftp.drupal.org/files/projects/token-7.x-1.0-alpha1.tar.gz\";s:4:\"date\";s:10:\"1271567107\";s:6:\"mdhash\";s:32:\"622a57e2ef607da3010c9e94d76af3fc\";s:8:\"filesize\";s:5:\"17032\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:13:{s:4:\"name\";s:17:\"token 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/734592\";s:13:\"download_link\";s:61:\"http://ftp.drupal.org/files/projects/token-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1361674412\";s:6:\"mdhash\";s:32:\"910d0f1d68e7d11192b7608ea5b90fde\";s:8:\"filesize\";s:5:\"44025\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}}}',1362712810,1362626405,1),('available_releases::wysiwyg','a:10:{s:5:\"title\";s:7:\"Wysiwyg\";s:10:\"short_name\";s:7:\"wysiwyg\";s:11:\"api_version\";s:3:\"7.x\";s:17:\"recommended_major\";s:1:\"2\";s:16:\"supported_majors\";s:1:\"2\";s:13:\"default_major\";s:1:\"2\";s:14:\"project_status\";s:9:\"published\";s:4:\"link\";s:33:\"http://drupal.org/project/wysiwyg\";s:5:\"terms\";s:39:\"\n   \n   \n   \n   \n   \n   \n   \n   \n   \n  \";s:8:\"releases\";a:4:{s:7:\"7.x-2.2\";a:13:{s:4:\"name\";s:15:\"wysiwyg 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1801458\";s:13:\"download_link\";s:59:\"http://ftp.drupal.org/files/projects/wysiwyg-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1349213776\";s:6:\"mdhash\";s:32:\"69e3f49cda05af96a2ce1c48dd08c585\";s:8:\"filesize\";s:5:\"78233\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:7:\"7.x-2.1\";a:13:{s:4:\"name\";s:15:\"wysiwyg 7.x-2.1\";s:7:\"version\";s:7:\"7.x-2.1\";s:3:\"tag\";s:7:\"7.x-2.1\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"1\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1193006\";s:13:\"download_link\";s:59:\"http://ftp.drupal.org/files/projects/wysiwyg-7.x-2.1.tar.gz\";s:4:\"date\";s:10:\"1308450722\";s:6:\"mdhash\";s:32:\"9428d3b9595de1be8cdc0bea2748d59c\";s:8:\"filesize\";s:5:\"68074\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}s:7:\"7.x-2.0\";a:13:{s:4:\"name\";s:15:\"wysiwyg 7.x-2.0\";s:7:\"version\";s:7:\"7.x-2.0\";s:3:\"tag\";s:7:\"7.x-2.0\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1016650\";s:13:\"download_link\";s:59:\"http://ftp.drupal.org/files/projects/wysiwyg-7.x-2.0.tar.gz\";s:4:\"date\";s:10:\"1294281173\";s:6:\"mdhash\";s:32:\"8d79891110883636254ce81063d3e731\";s:8:\"filesize\";s:6:\"108538\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:11:\"7.x-2.x-dev\";a:13:{s:4:\"name\";s:19:\"wysiwyg 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:29:\"http://drupal.org/node/588512\";s:13:\"download_link\";s:63:\"http://ftp.drupal.org/files/projects/wysiwyg-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1361843819\";s:6:\"mdhash\";s:32:\"8679b52799f41639a88a5f054a7a2e3d\";s:8:\"filesize\";s:5:\"78824\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}}}',1362709894,1362623493,1),('fetch_failures','a:0:{}',1362626710,1362626405,1),('update_project_data','a:10:{s:6:\"drupal\";a:17:{s:4:\"name\";s:6:\"drupal\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Block\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.20\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1361393684\";s:16:\"_info_file_ctime\";i:1361411494;}s:9:\"datestamp\";s:10:\"1361393684\";s:8:\"includes\";a:33:{s:5:\"block\";s:5:\"Block\";s:4:\"blog\";s:4:\"Blog\";s:5:\"color\";s:5:\"Color\";s:7:\"comment\";s:7:\"Comment\";s:7:\"contact\";s:7:\"Contact\";s:10:\"contextual\";s:16:\"Contextual links\";s:9:\"dashboard\";s:9:\"Dashboard\";s:5:\"dblog\";s:16:\"Database logging\";s:5:\"field\";s:5:\"Field\";s:17:\"field_sql_storage\";s:17:\"Field SQL storage\";s:8:\"field_ui\";s:8:\"Field UI\";s:4:\"file\";s:4:\"File\";s:6:\"filter\";s:6:\"Filter\";s:4:\"help\";s:4:\"Help\";s:5:\"image\";s:5:\"Image\";s:4:\"list\";s:4:\"List\";s:4:\"menu\";s:4:\"Menu\";s:4:\"node\";s:4:\"Node\";s:6:\"number\";s:6:\"Number\";s:7:\"options\";s:7:\"Options\";s:7:\"overlay\";s:7:\"Overlay\";s:4:\"path\";s:4:\"Path\";s:3:\"rdf\";s:3:\"RDF\";s:6:\"search\";s:6:\"Search\";s:8:\"shortcut\";s:8:\"Shortcut\";s:6:\"system\";s:6:\"System\";s:8:\"taxonomy\";s:8:\"Taxonomy\";s:4:\"text\";s:4:\"Text\";s:7:\"toolbar\";s:7:\"Toolbar\";s:6:\"update\";s:14:\"Update manager\";s:4:\"user\";s:4:\"User\";s:6:\"bartik\";s:6:\"Bartik\";s:5:\"seven\";s:5:\"Seven\";}s:12:\"project_type\";s:4:\"core\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:4:\"7.20\";s:14:\"existing_major\";s:1:\"7\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:11:\"Drupal core\";s:4:\"link\";s:32:\"http://drupal.org/project/drupal\";s:14:\"latest_version\";s:4:\"7.21\";s:8:\"releases\";a:1:{s:4:\"7.21\";a:13:{s:4:\"name\";s:11:\"drupal 7.21\";s:7:\"version\";s:4:\"7.21\";s:3:\"tag\";s:4:\"7.21\";s:13:\"version_major\";s:1:\"7\";s:13:\"version_patch\";s:2:\"21\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:43:\"http://drupal.org/drupal-7.21-release-notes\";s:13:\"download_link\";s:55:\"http://ftp.drupal.org/files/projects/drupal-7.21.tar.gz\";s:4:\"date\";s:10:\"1362616997\";s:6:\"mdhash\";s:32:\"eff054cd53be39ff719f77c81dce1aac\";s:8:\"filesize\";s:7:\"3163798\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}}s:11:\"recommended\";s:4:\"7.21\";s:6:\"status\";i:4;}s:6:\"ctools\";a:17:{s:4:\"name\";s:6:\"ctools\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Chaos tools\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:16:\"_info_file_ctime\";i:1359731426;}s:9:\"datestamp\";s:10:\"1345319204\";s:8:\"includes\";a:2:{s:6:\"ctools\";s:11:\"Chaos tools\";s:12:\"page_manager\";s:12:\"Page manager\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.2\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:25:\"Chaos tool suite (ctools)\";s:4:\"link\";s:32:\"http://drupal.org/project/ctools\";s:14:\"latest_version\";s:7:\"7.x-1.2\";s:8:\"releases\";a:1:{s:7:\"7.x-1.2\";a:13:{s:4:\"name\";s:14:\"ctools 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1738460\";s:13:\"download_link\";s:58:\"http://ftp.drupal.org/files/projects/ctools-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1345319204\";s:6:\"mdhash\";s:32:\"62fa855ee8aced1e355b09ac6cd54e99\";s:8:\"filesize\";s:6:\"407345\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}}s:11:\"recommended\";s:7:\"7.x-1.2\";s:6:\"status\";i:5;}s:4:\"imce\";a:17:{s:4:\"name\";s:4:\"imce\";s:4:\"info\";a:6:{s:4:\"name\";s:4:\"IMCE\";s:7:\"package\";s:5:\"Media\";s:7:\"version\";s:7:\"7.x-1.7\";s:7:\"project\";s:4:\"imce\";s:9:\"datestamp\";s:10:\"1359476607\";s:16:\"_info_file_ctime\";i:1359648958;}s:9:\"datestamp\";s:10:\"1359476607\";s:8:\"includes\";a:1:{s:4:\"imce\";s:4:\"IMCE\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.7\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:4:\"IMCE\";s:4:\"link\";s:30:\"http://drupal.org/project/imce\";s:14:\"latest_version\";s:7:\"7.x-1.7\";s:8:\"releases\";a:1:{s:7:\"7.x-1.7\";a:13:{s:4:\"name\";s:12:\"imce 7.x-1.7\";s:7:\"version\";s:7:\"7.x-1.7\";s:3:\"tag\";s:7:\"7.x-1.7\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"7\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1902126\";s:13:\"download_link\";s:56:\"http://ftp.drupal.org/files/projects/imce-7.x-1.7.tar.gz\";s:4:\"date\";s:10:\"1359476607\";s:6:\"mdhash\";s:32:\"c352bf9da8433628bed0b79c4acdcdb8\";s:8:\"filesize\";s:5:\"61286\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}}s:11:\"recommended\";s:7:\"7.x-1.7\";s:6:\"status\";i:5;}s:12:\"imce_wysiwyg\";a:17:{s:4:\"name\";s:12:\"imce_wysiwyg\";s:4:\"info\";a:6:{s:4:\"name\";s:23:\"IMCE Wysiwyg API bridge\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:12:\"imce_wysiwyg\";s:9:\"datestamp\";s:10:\"1317851503\";s:16:\"_info_file_ctime\";i:1359648960;}s:9:\"datestamp\";s:10:\"1317851503\";s:8:\"includes\";a:1:{s:12:\"imce_wysiwyg\";s:23:\"IMCE Wysiwyg API bridge\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.0\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:19:\"IMCE Wysiwyg bridge\";s:4:\"link\";s:38:\"http://drupal.org/project/imce_wysiwyg\";s:14:\"latest_version\";s:7:\"7.x-1.0\";s:8:\"releases\";a:1:{s:7:\"7.x-1.0\";a:13:{s:4:\"name\";s:20:\"imce_wysiwyg 7.x-1.0\";s:7:\"version\";s:7:\"7.x-1.0\";s:3:\"tag\";s:7:\"7.x-1.0\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"0\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1300800\";s:13:\"download_link\";s:64:\"http://ftp.drupal.org/files/projects/imce_wysiwyg-7.x-1.0.tar.gz\";s:4:\"date\";s:10:\"1317851503\";s:6:\"mdhash\";s:32:\"b0b9ef729f86de2d348b4302ad3591ef\";s:8:\"filesize\";s:4:\"9020\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}}s:11:\"recommended\";s:7:\"7.x-1.0\";s:6:\"status\";i:5;}s:13:\"jquery_update\";a:17:{s:4:\"name\";s:13:\"jquery_update\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"jQuery Update\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:13:\"jquery_update\";s:9:\"datestamp\";s:10:\"1360375905\";s:16:\"_info_file_ctime\";i:1361411476;}s:9:\"datestamp\";s:10:\"1360375905\";s:8:\"includes\";a:1:{s:13:\"jquery_update\";s:13:\"jQuery Update\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.3\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:13:\"jQuery Update\";s:4:\"link\";s:39:\"http://drupal.org/project/jquery_update\";s:14:\"latest_version\";s:7:\"7.x-2.3\";s:8:\"releases\";a:1:{s:7:\"7.x-2.3\";a:13:{s:4:\"name\";s:21:\"jquery_update 7.x-2.3\";s:7:\"version\";s:7:\"7.x-2.3\";s:3:\"tag\";s:7:\"7.x-2.3\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1912546\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/jquery_update-7.x-2.3.tar.gz\";s:4:\"date\";s:10:\"1360375905\";s:6:\"mdhash\";s:32:\"2d5a1e594a027fa849ed250f5dfef7c5\";s:8:\"filesize\";s:6:\"709788\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}}s:11:\"recommended\";s:7:\"7.x-2.3\";s:6:\"status\";i:5;}s:6:\"panels\";a:17:{s:4:\"name\";s:6:\"panels\";s:4:\"info\";a:6:{s:4:\"name\";s:6:\"Panels\";s:7:\"package\";s:6:\"Panels\";s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1345319572\";s:16:\"_info_file_ctime\";i:1359731347;}s:9:\"datestamp\";s:10:\"1345319572\";s:8:\"includes\";a:1:{s:6:\"panels\";s:6:\"Panels\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-3.3\";s:14:\"existing_major\";s:1:\"3\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:6:\"Panels\";s:4:\"link\";s:32:\"http://drupal.org/project/panels\";s:14:\"latest_version\";s:7:\"7.x-3.3\";s:8:\"releases\";a:1:{s:7:\"7.x-3.3\";a:13:{s:4:\"name\";s:14:\"panels 7.x-3.3\";s:7:\"version\";s:7:\"7.x-3.3\";s:3:\"tag\";s:7:\"7.x-3.3\";s:13:\"version_major\";s:1:\"3\";s:13:\"version_patch\";s:1:\"3\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1738468\";s:13:\"download_link\";s:58:\"http://ftp.drupal.org/files/projects/panels-7.x-3.3.tar.gz\";s:4:\"date\";s:10:\"1345319572\";s:6:\"mdhash\";s:32:\"41d55ac3806a254d0e16cf865f74a1ee\";s:8:\"filesize\";s:6:\"339088\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:9:\"Bug fixes\";}}}}s:11:\"recommended\";s:7:\"7.x-3.3\";s:6:\"status\";i:5;}s:8:\"pathauto\";a:17:{s:4:\"name\";s:8:\"pathauto\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Pathauto\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:8:\"pathauto\";s:9:\"datestamp\";s:10:\"1344525185\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1359648934;}s:9:\"datestamp\";s:10:\"1344525185\";s:8:\"includes\";a:1:{s:8:\"pathauto\";s:8:\"Pathauto\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.2\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:8:\"Pathauto\";s:4:\"link\";s:34:\"http://drupal.org/project/pathauto\";s:14:\"latest_version\";s:7:\"7.x-1.2\";s:8:\"releases\";a:1:{s:7:\"7.x-1.2\";a:13:{s:4:\"name\";s:16:\"pathauto 7.x-1.2\";s:7:\"version\";s:7:\"7.x-1.2\";s:3:\"tag\";s:7:\"7.x-1.2\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1721024\";s:13:\"download_link\";s:60:\"http://ftp.drupal.org/files/projects/pathauto-7.x-1.2.tar.gz\";s:4:\"date\";s:10:\"1344525185\";s:6:\"mdhash\";s:32:\"abdb73c49803aefe3c87774a92c42b87\";s:8:\"filesize\";s:5:\"38900\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:1:{i:0;s:12:\"New features\";}}}}s:11:\"recommended\";s:7:\"7.x-1.2\";s:6:\"status\";i:5;}s:9:\"tagadelic\";a:20:{s:4:\"name\";s:9:\"tagadelic\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Tagadelic\";s:7:\"package\";s:8:\"Taxonomy\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:9:\"tagadelic\";s:9:\"datestamp\";s:10:\"1328704746\";s:16:\"_info_file_ctime\";i:1359733435;}s:9:\"datestamp\";s:10:\"1328704746\";s:8:\"includes\";a:1:{s:9:\"tagadelic\";s:9:\"Tagadelic\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:11:\"7.x-1.x-dev\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:3:\"dev\";s:5:\"title\";s:9:\"Tagadelic\";s:4:\"link\";s:35:\"http://drupal.org/project/tagadelic\";s:4:\"also\";a:1:{i:2;s:11:\"7.x-2.x-dev\";}s:8:\"releases\";a:2:{s:11:\"7.x-2.x-dev\";a:13:{s:4:\"name\";s:21:\"tagadelic 7.x-2.x-dev\";s:7:\"version\";s:11:\"7.x-2.x-dev\";s:3:\"tag\";s:7:\"7.x-2.x\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1913442\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/tagadelic-7.x-2.x-dev.tar.gz\";s:4:\"date\";s:10:\"1360547141\";s:6:\"mdhash\";s:32:\"30e45e013106c8198de48c82cca4a568\";s:8:\"filesize\";s:5:\"20864\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}s:11:\"7.x-1.x-dev\";a:13:{s:4:\"name\";s:21:\"tagadelic 7.x-1.x-dev\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:3:\"tag\";s:7:\"7.x-1.x\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_extra\";s:3:\"dev\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1160134\";s:13:\"download_link\";s:65:\"http://ftp.drupal.org/files/projects/tagadelic-7.x-1.x-dev.tar.gz\";s:4:\"date\";s:10:\"1328704746\";s:6:\"mdhash\";s:32:\"cfb9f7e46659ec0408a95dd0719f44bd\";s:8:\"filesize\";s:5:\"26584\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:0:{}}}s:14:\"latest_version\";s:11:\"7.x-1.x-dev\";s:11:\"dev_version\";s:11:\"7.x-1.x-dev\";s:11:\"recommended\";s:11:\"7.x-1.x-dev\";s:10:\"latest_dev\";s:11:\"7.x-1.x-dev\";s:6:\"status\";i:5;}s:5:\"token\";a:17:{s:4:\"name\";s:5:\"token\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Token\";s:7:\"version\";s:7:\"7.x-1.4\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1348497279\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1359648928;}s:9:\"datestamp\";s:10:\"1348497279\";s:8:\"includes\";a:1:{s:5:\"token\";s:5:\"Token\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-1.4\";s:14:\"existing_major\";s:1:\"1\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:5:\"Token\";s:4:\"link\";s:31:\"http://drupal.org/project/token\";s:14:\"latest_version\";s:7:\"7.x-1.5\";s:8:\"releases\";a:1:{s:7:\"7.x-1.5\";a:13:{s:4:\"name\";s:13:\"token 7.x-1.5\";s:7:\"version\";s:7:\"7.x-1.5\";s:3:\"tag\";s:7:\"7.x-1.5\";s:13:\"version_major\";s:1:\"1\";s:13:\"version_patch\";s:1:\"5\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1925724\";s:13:\"download_link\";s:57:\"http://ftp.drupal.org/files/projects/token-7.x-1.5.tar.gz\";s:4:\"date\";s:10:\"1361665026\";s:6:\"mdhash\";s:32:\"93e5a19e8b244022cc38e58663db8001\";s:8:\"filesize\";s:5:\"44012\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}}s:11:\"recommended\";s:7:\"7.x-1.5\";s:6:\"status\";i:4;}s:7:\"wysiwyg\";a:17:{s:4:\"name\";s:7:\"wysiwyg\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"Wysiwyg\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:7:\"wysiwyg\";s:9:\"datestamp\";s:10:\"1349213776\";s:16:\"_info_file_ctime\";i:1359648954;}s:9:\"datestamp\";s:10:\"1349213776\";s:8:\"includes\";a:1:{s:7:\"wysiwyg\";s:7:\"Wysiwyg\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}s:16:\"existing_version\";s:7:\"7.x-2.2\";s:14:\"existing_major\";s:1:\"2\";s:12:\"install_type\";s:8:\"official\";s:5:\"title\";s:7:\"Wysiwyg\";s:4:\"link\";s:33:\"http://drupal.org/project/wysiwyg\";s:14:\"latest_version\";s:7:\"7.x-2.2\";s:8:\"releases\";a:1:{s:7:\"7.x-2.2\";a:13:{s:4:\"name\";s:15:\"wysiwyg 7.x-2.2\";s:7:\"version\";s:7:\"7.x-2.2\";s:3:\"tag\";s:7:\"7.x-2.2\";s:13:\"version_major\";s:1:\"2\";s:13:\"version_patch\";s:1:\"2\";s:6:\"status\";s:9:\"published\";s:12:\"release_link\";s:30:\"http://drupal.org/node/1801458\";s:13:\"download_link\";s:59:\"http://ftp.drupal.org/files/projects/wysiwyg-7.x-2.2.tar.gz\";s:4:\"date\";s:10:\"1349213776\";s:6:\"mdhash\";s:32:\"69e3f49cda05af96a2ce1c48dd08c585\";s:8:\"filesize\";s:5:\"78233\";s:5:\"files\";s:11:\"\n   \n   \n  \";s:5:\"terms\";a:1:{s:12:\"Release type\";a:2:{i:0;s:12:\"New features\";i:1;s:9:\"Bug fixes\";}}}}s:11:\"recommended\";s:7:\"7.x-2.2\";s:6:\"status\";i:5;}}',1362630004,1362626404,1),('update_project_projects','a:10:{s:6:\"drupal\";a:8:{s:4:\"name\";s:6:\"drupal\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Block\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.20\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1361393684\";s:16:\"_info_file_ctime\";i:1361411494;}s:9:\"datestamp\";s:10:\"1361393684\";s:8:\"includes\";a:33:{s:5:\"block\";s:5:\"Block\";s:4:\"blog\";s:4:\"Blog\";s:5:\"color\";s:5:\"Color\";s:7:\"comment\";s:7:\"Comment\";s:7:\"contact\";s:7:\"Contact\";s:10:\"contextual\";s:16:\"Contextual links\";s:9:\"dashboard\";s:9:\"Dashboard\";s:5:\"dblog\";s:16:\"Database logging\";s:5:\"field\";s:5:\"Field\";s:17:\"field_sql_storage\";s:17:\"Field SQL storage\";s:8:\"field_ui\";s:8:\"Field UI\";s:4:\"file\";s:4:\"File\";s:6:\"filter\";s:6:\"Filter\";s:4:\"help\";s:4:\"Help\";s:5:\"image\";s:5:\"Image\";s:4:\"list\";s:4:\"List\";s:4:\"menu\";s:4:\"Menu\";s:4:\"node\";s:4:\"Node\";s:6:\"number\";s:6:\"Number\";s:7:\"options\";s:7:\"Options\";s:7:\"overlay\";s:7:\"Overlay\";s:4:\"path\";s:4:\"Path\";s:3:\"rdf\";s:3:\"RDF\";s:6:\"search\";s:6:\"Search\";s:8:\"shortcut\";s:8:\"Shortcut\";s:6:\"system\";s:6:\"System\";s:8:\"taxonomy\";s:8:\"Taxonomy\";s:4:\"text\";s:4:\"Text\";s:7:\"toolbar\";s:7:\"Toolbar\";s:6:\"update\";s:14:\"Update manager\";s:4:\"user\";s:4:\"User\";s:6:\"bartik\";s:6:\"Bartik\";s:5:\"seven\";s:5:\"Seven\";}s:12:\"project_type\";s:4:\"core\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:6:\"ctools\";a:8:{s:4:\"name\";s:6:\"ctools\";s:4:\"info\";a:6:{s:4:\"name\";s:11:\"Chaos tools\";s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:16:\"_info_file_ctime\";i:1359731426;}s:9:\"datestamp\";s:10:\"1345319204\";s:8:\"includes\";a:2:{s:6:\"ctools\";s:11:\"Chaos tools\";s:12:\"page_manager\";s:12:\"Page manager\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:4:\"imce\";a:8:{s:4:\"name\";s:4:\"imce\";s:4:\"info\";a:6:{s:4:\"name\";s:4:\"IMCE\";s:7:\"package\";s:5:\"Media\";s:7:\"version\";s:7:\"7.x-1.7\";s:7:\"project\";s:4:\"imce\";s:9:\"datestamp\";s:10:\"1359476607\";s:16:\"_info_file_ctime\";i:1359648958;}s:9:\"datestamp\";s:10:\"1359476607\";s:8:\"includes\";a:1:{s:4:\"imce\";s:4:\"IMCE\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:12:\"imce_wysiwyg\";a:8:{s:4:\"name\";s:12:\"imce_wysiwyg\";s:4:\"info\";a:6:{s:4:\"name\";s:23:\"IMCE Wysiwyg API bridge\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:12:\"imce_wysiwyg\";s:9:\"datestamp\";s:10:\"1317851503\";s:16:\"_info_file_ctime\";i:1359648960;}s:9:\"datestamp\";s:10:\"1317851503\";s:8:\"includes\";a:1:{s:12:\"imce_wysiwyg\";s:23:\"IMCE Wysiwyg API bridge\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:13:\"jquery_update\";a:8:{s:4:\"name\";s:13:\"jquery_update\";s:4:\"info\";a:6:{s:4:\"name\";s:13:\"jQuery Update\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:13:\"jquery_update\";s:9:\"datestamp\";s:10:\"1360375905\";s:16:\"_info_file_ctime\";i:1361411476;}s:9:\"datestamp\";s:10:\"1360375905\";s:8:\"includes\";a:1:{s:13:\"jquery_update\";s:13:\"jQuery Update\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:6:\"panels\";a:8:{s:4:\"name\";s:6:\"panels\";s:4:\"info\";a:6:{s:4:\"name\";s:6:\"Panels\";s:7:\"package\";s:6:\"Panels\";s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1345319572\";s:16:\"_info_file_ctime\";i:1359731347;}s:9:\"datestamp\";s:10:\"1345319572\";s:8:\"includes\";a:1:{s:6:\"panels\";s:6:\"Panels\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:8:\"pathauto\";a:8:{s:4:\"name\";s:8:\"pathauto\";s:4:\"info\";a:6:{s:4:\"name\";s:8:\"Pathauto\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:8:\"pathauto\";s:9:\"datestamp\";s:10:\"1344525185\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1359648934;}s:9:\"datestamp\";s:10:\"1344525185\";s:8:\"includes\";a:1:{s:8:\"pathauto\";s:8:\"Pathauto\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:9:\"tagadelic\";a:8:{s:4:\"name\";s:9:\"tagadelic\";s:4:\"info\";a:6:{s:4:\"name\";s:9:\"Tagadelic\";s:7:\"package\";s:8:\"Taxonomy\";s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:9:\"tagadelic\";s:9:\"datestamp\";s:10:\"1328704746\";s:16:\"_info_file_ctime\";i:1359733435;}s:9:\"datestamp\";s:10:\"1328704746\";s:8:\"includes\";a:1:{s:9:\"tagadelic\";s:9:\"Tagadelic\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:5:\"token\";a:8:{s:4:\"name\";s:5:\"token\";s:4:\"info\";a:6:{s:4:\"name\";s:5:\"Token\";s:7:\"version\";s:7:\"7.x-1.4\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1348497279\";s:7:\"package\";s:5:\"Other\";s:16:\"_info_file_ctime\";i:1359648928;}s:9:\"datestamp\";s:10:\"1348497279\";s:8:\"includes\";a:1:{s:5:\"token\";s:5:\"Token\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}s:7:\"wysiwyg\";a:8:{s:4:\"name\";s:7:\"wysiwyg\";s:4:\"info\";a:6:{s:4:\"name\";s:7:\"Wysiwyg\";s:7:\"package\";s:14:\"User interface\";s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:7:\"wysiwyg\";s:9:\"datestamp\";s:10:\"1349213776\";s:16:\"_info_file_ctime\";i:1359648954;}s:9:\"datestamp\";s:10:\"1349213776\";s:8:\"includes\";a:1:{s:7:\"wysiwyg\";s:7:\"Wysiwyg\";}s:12:\"project_type\";s:6:\"module\";s:14:\"project_status\";b:1;s:10:\"sub_themes\";a:0:{}s:11:\"base_themes\";a:0:{}}}',1362630004,1362626404,1);
/*!40000 ALTER TABLE `cache_update` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `comment`
--

DROP TABLE IF EXISTS `comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `comment` (
  `cid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique comment ID.',
  `pid` int(11) NOT NULL DEFAULT '0' COMMENT 'The comment.cid to which this comment is a reply. If set to 0, this comment is not a reply to an existing comment.',
  `nid` int(11) NOT NULL DEFAULT '0' COMMENT 'The node.nid to which this comment is a reply.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid who authored the comment. If set to 0, this comment was created by an anonymous user.',
  `subject` varchar(64) NOT NULL DEFAULT '' COMMENT 'The comment title.',
  `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'The author’s host name.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The time that the comment was created, as a Unix timestamp.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The time that the comment was last edited, as a Unix timestamp.',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'The published status of a comment. (0 = Not Published, 1 = Published)',
  `thread` varchar(255) NOT NULL COMMENT 'The vancode representation of the comment’s place in a thread.',
  `name` varchar(60) DEFAULT NULL COMMENT 'The comment author’s name. Uses users.name if the user is logged in, otherwise uses the value typed into the comment form.',
  `mail` varchar(64) DEFAULT NULL COMMENT 'The comment author’s e-mail address from the comment form, if user is anonymous, and the ’Anonymous users may/must leave their contact information’ setting is turned on.',
  `homepage` varchar(255) DEFAULT NULL COMMENT 'The comment author’s home page address from the comment form, if user is anonymous, and the ’Anonymous users may/must leave their contact information’ setting is turned on.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The languages.language of this comment.',
  PRIMARY KEY (`cid`),
  KEY `comment_status_pid` (`pid`,`status`),
  KEY `comment_num_new` (`nid`,`status`,`created`,`cid`,`thread`),
  KEY `comment_uid` (`uid`),
  KEY `comment_nid_language` (`nid`,`language`),
  KEY `comment_created` (`created`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='Stores comments and associated data.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `comment`
--

LOCK TABLES `comment` WRITE;
/*!40000 ALTER TABLE `comment` DISABLE KEYS */;
INSERT INTO `comment` VALUES (1,0,1,1,'Maecenas dignissim euismod','127.0.0.1',1359797303,1359797303,1,'01/','admin','','','und'),(2,1,1,1,'Dignissim euismod nunc, in','127.0.0.1',1359797316,1359797316,1,'01.00/','admin','','','und'),(3,0,1,1,'Morbi velit eros, sagittis in','127.0.0.1',1359797325,1359797325,1,'02/','admin','','','und');
/*!40000 ALTER TABLE `comment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contact`
--

DROP TABLE IF EXISTS `contact`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contact` (
  `cid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique category ID.',
  `category` varchar(255) NOT NULL DEFAULT '' COMMENT 'Category name.',
  `recipients` longtext NOT NULL COMMENT 'Comma-separated list of recipient e-mail addresses.',
  `reply` longtext NOT NULL COMMENT 'Text of the auto-reply message.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The category’s weight.',
  `selected` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate whether or not category is selected by default. (1 = Yes, 0 = No)',
  PRIMARY KEY (`cid`),
  UNIQUE KEY `category` (`category`),
  KEY `list` (`weight`,`category`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='Contact form category settings.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contact`
--

LOCK TABLES `contact` WRITE;
/*!40000 ALTER TABLE `contact` DISABLE KEYS */;
INSERT INTO `contact` VALUES (1,'Website feedback','toan@tabvn.com','',0,1);
/*!40000 ALTER TABLE `contact` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ctools_css_cache`
--

DROP TABLE IF EXISTS `ctools_css_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ctools_css_cache` (
  `cid` varchar(128) NOT NULL COMMENT 'The CSS ID this cache object belongs to.',
  `filename` varchar(255) DEFAULT NULL COMMENT 'The filename this CSS is stored in.',
  `css` longtext COMMENT 'CSS being stored.',
  `filter` tinyint(4) DEFAULT NULL COMMENT 'Whether or not this CSS needs to be filtered.',
  PRIMARY KEY (`cid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A special cache used to store CSS that must be non-volatile.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ctools_css_cache`
--

LOCK TABLES `ctools_css_cache` WRITE;
/*!40000 ALTER TABLE `ctools_css_cache` DISABLE KEYS */;
/*!40000 ALTER TABLE `ctools_css_cache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ctools_object_cache`
--

DROP TABLE IF EXISTS `ctools_object_cache`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ctools_object_cache` (
  `sid` varchar(64) NOT NULL COMMENT 'The session ID this cache object belongs to.',
  `name` varchar(128) NOT NULL COMMENT 'The name of the object this cache is attached to.',
  `obj` varchar(32) NOT NULL COMMENT 'The type of the object this cache is attached to; this essentially represents the owner so that several sub-systems can use this cache.',
  `updated` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The time this cache was created or updated.',
  `data` longtext COMMENT 'Serialized data being stored.',
  PRIMARY KEY (`sid`,`obj`,`name`),
  KEY `updated` (`updated`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A special cache used to store objects that are being...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ctools_object_cache`
--

LOCK TABLES `ctools_object_cache` WRITE;
/*!40000 ALTER TABLE `ctools_object_cache` DISABLE KEYS */;
/*!40000 ALTER TABLE `ctools_object_cache` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `date_format_locale`
--

DROP TABLE IF EXISTS `date_format_locale`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `date_format_locale` (
  `format` varchar(100) NOT NULL COMMENT 'The date format string.',
  `type` varchar(64) NOT NULL COMMENT 'The date format type, e.g. medium.',
  `language` varchar(12) NOT NULL COMMENT 'A languages.language for this format to be used with.',
  PRIMARY KEY (`type`,`language`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores configured date formats for each locale.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `date_format_locale`
--

LOCK TABLES `date_format_locale` WRITE;
/*!40000 ALTER TABLE `date_format_locale` DISABLE KEYS */;
/*!40000 ALTER TABLE `date_format_locale` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `date_format_type`
--

DROP TABLE IF EXISTS `date_format_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `date_format_type` (
  `type` varchar(64) NOT NULL COMMENT 'The date format type, e.g. medium.',
  `title` varchar(255) NOT NULL COMMENT 'The human readable name of the format type.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether or not this is a system provided format.',
  PRIMARY KEY (`type`),
  KEY `title` (`title`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores configured date format types.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `date_format_type`
--

LOCK TABLES `date_format_type` WRITE;
/*!40000 ALTER TABLE `date_format_type` DISABLE KEYS */;
INSERT INTO `date_format_type` VALUES ('long','Long',1),('medium','Medium',1),('short','Short',1);
/*!40000 ALTER TABLE `date_format_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `date_formats`
--

DROP TABLE IF EXISTS `date_formats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `date_formats` (
  `dfid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The date format identifier.',
  `format` varchar(100) NOT NULL COMMENT 'The date format string.',
  `type` varchar(64) NOT NULL COMMENT 'The date format type, e.g. medium.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether or not this format can be modified.',
  PRIMARY KEY (`dfid`),
  UNIQUE KEY `formats` (`format`,`type`)
) ENGINE=InnoDB AUTO_INCREMENT=36 DEFAULT CHARSET=utf8 COMMENT='Stores configured date formats.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `date_formats`
--

LOCK TABLES `date_formats` WRITE;
/*!40000 ALTER TABLE `date_formats` DISABLE KEYS */;
INSERT INTO `date_formats` VALUES (1,'Y-m-d H:i','short',1),(2,'m/d/Y - H:i','short',1),(3,'d/m/Y - H:i','short',1),(4,'Y/m/d - H:i','short',1),(5,'d.m.Y - H:i','short',1),(6,'m/d/Y - g:ia','short',1),(7,'d/m/Y - g:ia','short',1),(8,'Y/m/d - g:ia','short',1),(9,'M j Y - H:i','short',1),(10,'j M Y - H:i','short',1),(11,'Y M j - H:i','short',1),(12,'M j Y - g:ia','short',1),(13,'j M Y - g:ia','short',1),(14,'Y M j - g:ia','short',1),(15,'D, Y-m-d H:i','medium',1),(16,'D, m/d/Y - H:i','medium',1),(17,'D, d/m/Y - H:i','medium',1),(18,'D, Y/m/d - H:i','medium',1),(19,'F j, Y - H:i','medium',1),(20,'j F, Y - H:i','medium',1),(21,'Y, F j - H:i','medium',1),(22,'D, m/d/Y - g:ia','medium',1),(23,'D, d/m/Y - g:ia','medium',1),(24,'D, Y/m/d - g:ia','medium',1),(25,'F j, Y - g:ia','medium',1),(26,'j F Y - g:ia','medium',1),(27,'Y, F j - g:ia','medium',1),(28,'j. F Y - G:i','medium',1),(29,'l, F j, Y - H:i','long',1),(30,'l, j F, Y - H:i','long',1),(31,'l, Y,  F j - H:i','long',1),(32,'l, F j, Y - g:ia','long',1),(33,'l, j F Y - g:ia','long',1),(34,'l, Y,  F j - g:ia','long',1),(35,'l, j. F Y - G:i','long',1);
/*!40000 ALTER TABLE `date_formats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_config`
--

DROP TABLE IF EXISTS `field_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_config` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a field',
  `field_name` varchar(32) NOT NULL COMMENT 'The name of this field. Non-deleted field names are unique, but multiple deleted fields can have the same name.',
  `type` varchar(128) NOT NULL COMMENT 'The type of this field.',
  `module` varchar(128) NOT NULL DEFAULT '' COMMENT 'The module that implements the field type.',
  `active` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the module that implements the field type is enabled.',
  `storage_type` varchar(128) NOT NULL COMMENT 'The storage backend for the field.',
  `storage_module` varchar(128) NOT NULL DEFAULT '' COMMENT 'The module that implements the storage backend.',
  `storage_active` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the module that implements the storage backend is enabled.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT '@TODO',
  `data` longblob NOT NULL COMMENT 'Serialized data containing the field properties that do not warrant a dedicated column.',
  `cardinality` tinyint(4) NOT NULL DEFAULT '0',
  `translatable` tinyint(4) NOT NULL DEFAULT '0',
  `deleted` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `field_name` (`field_name`),
  KEY `active` (`active`),
  KEY `storage_active` (`storage_active`),
  KEY `deleted` (`deleted`),
  KEY `module` (`module`),
  KEY `storage_module` (`storage_module`),
  KEY `type` (`type`),
  KEY `storage_type` (`storage_type`)
) ENGINE=InnoDB AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_config`
--

LOCK TABLES `field_config` WRITE;
/*!40000 ALTER TABLE `field_config` DISABLE KEYS */;
INSERT INTO `field_config` VALUES (1,'comment_body','text_long','text',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:7:\"comment\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:0:{}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}}',1,0,0),(2,'body','text_with_summary','text',1,'field_sql_storage','field_sql_storage',1,0,'a:6:{s:12:\"entity_types\";a:1:{i:0;s:4:\"node\";}s:12:\"translatable\";b:0;s:8:\"settings\";a:0:{}s:7:\"storage\";a:4:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";i:1;}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}}',1,0,0),(3,'field_tags','taxonomy_term_reference','taxonomy',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:4:\"tags\";s:6:\"parent\";i:0;}}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:21:\"field_data_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:25:\"field_revision_field_tags\";a:1:{s:3:\"tid\";s:14:\"field_tags_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:1:\"3\";}',-1,0,0),(4,'field_image','image','image',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:7:\"indexes\";a:1:{s:3:\"fid\";a:1:{i:0;s:3:\"fid\";}}s:8:\"settings\";a:2:{s:10:\"uri_scheme\";s:6:\"public\";s:13:\"default_image\";i:0;}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:22:\"field_data_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:26:\"field_revision_field_image\";a:5:{s:3:\"fid\";s:15:\"field_image_fid\";s:3:\"alt\";s:15:\"field_image_alt\";s:5:\"title\";s:17:\"field_image_title\";s:5:\"width\";s:17:\"field_image_width\";s:6:\"height\";s:18:\"field_image_height\";}}}}}s:12:\"entity_types\";a:0:{}s:12:\"translatable\";s:1:\"0\";s:12:\"foreign keys\";a:1:{s:3:\"fid\";a:2:{s:5:\"table\";s:12:\"file_managed\";s:7:\"columns\";a:1:{s:3:\"fid\";s:3:\"fid\";}}}s:2:\"id\";s:1:\"4\";}',-1,0,0),(5,'field_portfolio_category','taxonomy_term_reference','taxonomy',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:14:\"allowed_values\";a:1:{i:0;a:2:{s:10:\"vocabulary\";s:20:\"portfolio_categories\";s:6:\"parent\";s:1:\"0\";}}}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:35:\"field_data_field_portfolio_category\";a:1:{s:3:\"tid\";s:28:\"field_portfolio_category_tid\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:39:\"field_revision_field_portfolio_category\";a:1:{s:3:\"tid\";s:28:\"field_portfolio_category_tid\";}}}}}s:12:\"foreign keys\";a:1:{s:3:\"tid\";a:2:{s:5:\"table\";s:18:\"taxonomy_term_data\";s:7:\"columns\";a:1:{s:3:\"tid\";s:3:\"tid\";}}}s:7:\"indexes\";a:1:{s:3:\"tid\";a:1:{i:0;s:3:\"tid\";}}s:2:\"id\";s:1:\"5\";}',-1,0,0),(6,'field_portfolio_link','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:31:\"field_data_field_portfolio_link\";a:2:{s:5:\"value\";s:26:\"field_portfolio_link_value\";s:6:\"format\";s:27:\"field_portfolio_link_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:35:\"field_revision_field_portfolio_link\";a:2:{s:5:\"value\";s:26:\"field_portfolio_link_value\";s:6:\"format\";s:27:\"field_portfolio_link_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"6\";}',1,0,0),(7,'field_portfolio_client','text','text',1,'field_sql_storage','field_sql_storage',1,0,'a:7:{s:12:\"translatable\";s:1:\"0\";s:12:\"entity_types\";a:0:{}s:8:\"settings\";a:1:{s:10:\"max_length\";s:3:\"255\";}s:7:\"storage\";a:5:{s:4:\"type\";s:17:\"field_sql_storage\";s:8:\"settings\";a:0:{}s:6:\"module\";s:17:\"field_sql_storage\";s:6:\"active\";s:1:\"1\";s:7:\"details\";a:1:{s:3:\"sql\";a:2:{s:18:\"FIELD_LOAD_CURRENT\";a:1:{s:33:\"field_data_field_portfolio_client\";a:2:{s:5:\"value\";s:28:\"field_portfolio_client_value\";s:6:\"format\";s:29:\"field_portfolio_client_format\";}}s:19:\"FIELD_LOAD_REVISION\";a:1:{s:37:\"field_revision_field_portfolio_client\";a:2:{s:5:\"value\";s:28:\"field_portfolio_client_value\";s:6:\"format\";s:29:\"field_portfolio_client_format\";}}}}}s:12:\"foreign keys\";a:1:{s:6:\"format\";a:2:{s:5:\"table\";s:13:\"filter_format\";s:7:\"columns\";a:1:{s:6:\"format\";s:6:\"format\";}}}s:7:\"indexes\";a:1:{s:6:\"format\";a:1:{i:0;s:6:\"format\";}}s:2:\"id\";s:1:\"7\";}',1,0,0);
/*!40000 ALTER TABLE `field_config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_config_instance`
--

DROP TABLE IF EXISTS `field_config_instance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_config_instance` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a field instance',
  `field_id` int(11) NOT NULL COMMENT 'The identifier of the field attached by this instance',
  `field_name` varchar(32) NOT NULL DEFAULT '',
  `entity_type` varchar(32) NOT NULL DEFAULT '',
  `bundle` varchar(128) NOT NULL DEFAULT '',
  `data` longblob NOT NULL,
  `deleted` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `field_name_bundle` (`field_name`,`entity_type`,`bundle`),
  KEY `deleted` (`deleted`)
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_config_instance`
--

LOCK TABLES `field_config_instance` WRITE;
/*!40000 ALTER TABLE `field_config_instance` DISABLE KEYS */;
INSERT INTO `field_config_instance` VALUES (1,1,'comment_body','comment','comment_node_page','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(2,2,'body','node','page','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(3,1,'comment_body','comment','comment_node_article','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(4,2,'body','node','article','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";i:-4;s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(5,3,'field_tags','node','article','a:6:{s:5:\"label\";s:4:\"Tags\";s:11:\"description\";s:63:\"Enter a comma-separated list of words to describe your content.\";s:6:\"widget\";a:4:{s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"weight\";i:-4;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}s:6:\"module\";s:8:\"taxonomy\";}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";i:10;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}s:6:\"teaser\";a:5:{s:4:\"type\";s:28:\"taxonomy_term_reference_link\";s:6:\"weight\";i:10;s:5:\"label\";s:5:\"above\";s:8:\"settings\";a:0:{}s:6:\"module\";s:8:\"taxonomy\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:8:\"required\";b:0;}',0),(6,4,'field_image','node','article','a:6:{s:5:\"label\";s:5:\"Image\";s:11:\"description\";s:40:\"Upload an image to go with this article.\";s:8:\"required\";b:0;s:8:\"settings\";a:9:{s:14:\"file_directory\";s:11:\"field/image\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";b:1;s:11:\"title_field\";s:0:\"\";s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:6:\"widget\";a:4:{s:4:\"type\";s:11:\"image_image\";s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}s:6:\"weight\";i:-1;s:6:\"module\";s:5:\"image\";}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:5:\"large\";s:10:\"image_link\";s:0:\"\";}s:6:\"weight\";i:-1;s:6:\"module\";s:5:\"image\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:6:\"medium\";s:10:\"image_link\";s:7:\"content\";}s:6:\"weight\";i:-1;s:6:\"module\";s:5:\"image\";}}}',0),(7,1,'comment_body','comment','comment_node_blog','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(8,2,'body','node','blog','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:2:\"31\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(9,3,'field_tags','node','blog','a:7:{s:5:\"label\";s:4:\"Tags\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"33\";s:4:\"type\";s:21:\"taxonomy_autocomplete\";s:6:\"module\";s:8:\"taxonomy\";s:6:\"active\";i:0;s:8:\"settings\";a:2:{s:4:\"size\";i:60;s:17:\"autocomplete_path\";s:21:\"taxonomy/autocomplete\";}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}}s:6:\"teaser\";a:4:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(10,4,'field_image','node','blog','a:6:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"35\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:0:\"\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";}',0),(11,1,'comment_body','comment','comment_node_portfolio','a:6:{s:5:\"label\";s:7:\"Comment\";s:8:\"settings\";a:2:{s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:8:\"required\";b:1;s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";i:0;s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:6:\"widget\";a:4:{s:4:\"type\";s:13:\"text_textarea\";s:8:\"settings\";a:1:{s:4:\"rows\";i:5;}s:6:\"weight\";i:0;s:6:\"module\";s:4:\"text\";}s:11:\"description\";s:0:\"\";}',0),(12,2,'body','node','portfolio','a:6:{s:5:\"label\";s:4:\"Body\";s:6:\"widget\";a:4:{s:4:\"type\";s:26:\"text_textarea_with_summary\";s:8:\"settings\";a:2:{s:4:\"rows\";i:20;s:12:\"summary_rows\";i:5;}s:6:\"weight\";s:2:\"31\";s:6:\"module\";s:4:\"text\";}s:8:\"settings\";a:3:{s:15:\"display_summary\";b:1;s:15:\"text_processing\";i:1;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:2:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"1\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}s:6:\"teaser\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:23:\"text_summary_or_trimmed\";s:8:\"settings\";a:1:{s:11:\"trim_length\";i:600;}s:6:\"module\";s:4:\"text\";s:6:\"weight\";i:0;}}s:8:\"required\";b:0;s:11:\"description\";s:0:\"\";}',0),(13,4,'field_image','node','portfolio','a:6:{s:5:\"label\";s:5:\"Image\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"33\";s:4:\"type\";s:11:\"image_image\";s:6:\"module\";s:5:\"image\";s:6:\"active\";i:1;s:8:\"settings\";a:2:{s:18:\"progress_indicator\";s:8:\"throbber\";s:19:\"preview_image_style\";s:9:\"thumbnail\";}}s:8:\"settings\";a:9:{s:14:\"file_directory\";s:0:\"\";s:15:\"file_extensions\";s:16:\"png gif jpg jpeg\";s:12:\"max_filesize\";s:0:\"\";s:14:\"max_resolution\";s:0:\"\";s:14:\"min_resolution\";s:0:\"\";s:9:\"alt_field\";i:0;s:11:\"title_field\";i:0;s:13:\"default_image\";i:0;s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:6:\"hidden\";s:4:\"type\";s:5:\"image\";s:6:\"weight\";s:1:\"0\";s:8:\"settings\";a:2:{s:11:\"image_style\";s:0:\"\";s:10:\"image_link\";s:0:\"\";}s:6:\"module\";s:5:\"image\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";}',0),(14,5,'field_portfolio_category','node','portfolio','a:7:{s:5:\"label\";s:8:\"Category\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"34\";s:4:\"type\";s:14:\"options_select\";s:6:\"module\";s:7:\"options\";s:6:\"active\";i:1;s:8:\"settings\";a:0:{}}s:8:\"settings\";a:1:{s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:4:{s:5:\"label\";s:6:\"inline\";s:4:\"type\";s:6:\"hidden\";s:6:\"weight\";s:1:\"4\";s:8:\"settings\";a:0:{}}}s:8:\"required\";i:1;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(15,6,'field_portfolio_link','node','portfolio','a:7:{s:5:\"label\";s:4:\"Link\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"35\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"2\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0),(16,7,'field_portfolio_client','node','portfolio','a:7:{s:5:\"label\";s:6:\"Client\";s:6:\"widget\";a:5:{s:6:\"weight\";s:2:\"36\";s:4:\"type\";s:14:\"text_textfield\";s:6:\"module\";s:4:\"text\";s:6:\"active\";i:1;s:8:\"settings\";a:1:{s:4:\"size\";s:2:\"60\";}}s:8:\"settings\";a:2:{s:15:\"text_processing\";s:1:\"0\";s:18:\"user_register_form\";b:0;}s:7:\"display\";a:1:{s:7:\"default\";a:5:{s:5:\"label\";s:5:\"above\";s:4:\"type\";s:12:\"text_default\";s:6:\"weight\";s:1:\"3\";s:8:\"settings\";a:0:{}s:6:\"module\";s:4:\"text\";}}s:8:\"required\";i:0;s:11:\"description\";s:0:\"\";s:13:\"default_value\";N;}',0);
/*!40000 ALTER TABLE `field_config_instance` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_body`
--

DROP TABLE IF EXISTS `field_data_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext,
  `body_summary` longtext,
  `body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `body_format` (`body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 2 (body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_body`
--

LOCK TABLES `field_data_body` WRITE;
/*!40000 ALTER TABLE `field_data_body` DISABLE KEYS */;
INSERT INTO `field_data_body` VALUES ('node','blog',0,1,1,'und',0,'<p>Maecenas dolor est, interdum a euismod eu, accumsan posuere nisl. Nam sed iaculis massa. Sed nisl lectus, tempor sed euismod quis, sollicitudin nec est. Suspendisse dignissim bibendum tempor. Nam erat felis, commodo sed semper commodo vel mauris suspendisse dignissim bibendum tempus.</p><p>Sed auctor, sem et volutpat facilisis, risus leo venenatis leo, ultricies accumsan urna ante vel nisl. Integer feugiat risus nec nisl dictum vestibulum. Vestibulum nec purus orci. Mauris ornare dolor eget purus malesuada vitae convallis dui dapibus. Donec sed leo magna, ac pellentesque lorem. Vivamus sapien tortor, lobortis ut ultrices vel, tempus non metus. Suspendisse id est id elit commodo pellentesque non non lorem. Aenean sed blandit sapien. Nullam risus sapien, dignissim tempor auctor non, porta congue mi.</p><blockquote>Mauris aliquet ultricies ante, non faucibus ante gravida sed. Sed ultrices pellentesque purus, vulputate volutpat ipsum hendrerit sed neque sed sapien rutrum laoreet justo ultrices. In pellentesque lorem condimentum dui conse. Vivamus semper, mi sed congue semper, odio felis tristique neque, ac venenatis mauris augue.</blockquote><p>Cras varius enim ac tellus gravida aliquet. Praesent nec ante odio, at egestas lorem. Phasellus nec velit sit amet leo pellentesque tempor. Vivamus molestie fringilla nulla, at egestas magna tempor nec. Suspendisse potenti. Vivamus metus massa, viverra sit amet bibendum ac, consequat porta sem. Nullam venenatis faucibus sem. Donec non mi et felis iaculis tempor sed at dolor.</p>','','wysiwyg'),('node','blog',0,2,2,'und',0,'<p>Maecenas dolor est, interdum a euismod eu, accumsan posuere nisl. Nam sed iaculis massa. Sed nisl lectus, tempor sed euismod quis, sollicitudin nec est. Suspendisse dignissim bibendum tempor. Nam erat felis, commodo sed semper commodo vel mauris suspendisse dignissim bibendum tempus.</p><p>Sed auctor, sem et volutpat facilisis, risus leo venenatis leo, ultricies accumsan urna ante vel nisl. Integer feugiat risus nec nisl dictum vestibulum. Vestibulum nec purus orci. Mauris ornare dolor eget purus malesuada vitae convallis dui dapibus. Donec sed leo magna, ac pellentesque lorem. Vivamus sapien tortor, lobortis ut ultrices vel, tempus non metus. Suspendisse id est id elit commodo pellentesque non non lorem. Aenean sed blandit sapien. Nullam risus sapien, dignissim tempor auctor non, porta congue mi.</p><blockquote>Mauris aliquet ultricies ante, non faucibus ante gravida sed. Sed ultrices pellentesque purus, vulputate volutpat ipsum hendrerit sed neque sed sapien rutrum laoreet justo ultrices. In pellentesque lorem condimentum dui conse. Vivamus semper, mi sed congue semper, odio felis tristique neque, ac venenatis mauris augue.</blockquote><p>Cras varius enim ac tellus gravida aliquet. Praesent nec ante odio, at egestas lorem. Phasellus nec velit sit amet leo pellentesque tempor. Vivamus molestie fringilla nulla, at egestas magna tempor nec. Suspendisse potenti. Vivamus metus massa, viverra sit amet bibendum ac, consequat porta sem. Nullam venenatis faucibus sem. Donec non mi et felis iaculis tempor sed at dolor.</p>','','wysiwyg'),('node','blog',0,3,3,'und',0,'<p>Maecenas dolor est, interdum a euismod eu, accumsan posuere nisl. Nam sed iaculis massa. Sed nisl lectus, tempor sed euismod quis, sollicitudin nec est. Suspendisse dignissim bibendum tempor. Nam erat felis, commodo sed semper commodo vel mauris suspendisse dignissim bibendum tempus.</p><p>Sed auctor, sem et volutpat facilisis, risus leo venenatis leo, ultricies accumsan urna ante vel nisl. Integer feugiat risus nec nisl dictum vestibulum. Vestibulum nec purus orci. Mauris ornare dolor eget purus malesuada vitae convallis dui dapibus. Donec sed leo magna, ac pellentesque lorem. Vivamus sapien tortor, lobortis ut ultrices vel, tempus non metus. Suspendisse id est id elit commodo pellentesque non non lorem. Aenean sed blandit sapien. Nullam risus sapien, dignissim tempor auctor non, porta congue mi.</p><blockquote>Mauris aliquet ultricies ante, non faucibus ante gravida sed. Sed ultrices pellentesque purus, vulputate volutpat ipsum hendrerit sed neque sed sapien rutrum laoreet justo ultrices. In pellentesque lorem condimentum dui conse. Vivamus semper, mi sed congue semper, odio felis tristique neque, ac venenatis mauris augue.</blockquote><p>Cras varius enim ac tellus gravida aliquet. Praesent nec ante odio, at egestas lorem. Phasellus nec velit sit amet leo pellentesque tempor. Vivamus molestie fringilla nulla, at egestas magna tempor nec. Suspendisse potenti. Vivamus metus massa, viverra sit amet bibendum ac, consequat porta sem. Nullam venenatis faucibus sem. Donec non mi et felis iaculis tempor sed at dolor.</p>','','wysiwyg'),('node','portfolio',0,4,4,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','portfolio',0,5,5,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','portfolio',0,6,6,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','portfolio',0,7,7,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','portfolio',0,8,8,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','portfolio',0,9,9,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','portfolio',0,10,10,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','portfolio',0,11,11,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','page',0,12,12,'und',0,'<div class=\"container\">\r\n\r\n\r\n  <!-- Buttons\r\n  ================================================== -->\r\n\r\n  <div class=\"eight columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline no-margin\"><h3>Buttons</h3></div>\r\n    <ul class=\"list-inline\">\r\n      <li><a href=\"#\" class=\"button gray\">Button</a></li>\r\n      <li><a href=\"#\" class=\"button color\">Button</a></li>\r\n      <li><a href=\"#\" class=\"button light\">Button</a></li>\r\n    </ul>\r\n    <br/>\r\n    <br/>\r\n    <ul class=\"list-inline\">\r\n      <li><a href=\"#\" class=\"button gray medium\">Button</a></li>\r\n      <li><a href=\"#\" class=\"button color medium\">Button</a></li>\r\n      <li><a href=\"#\" class=\"button light medium\">Button</a></li>\r\n    </ul>\r\n  </div>\r\n\r\n\r\n  <!-- Tabs\r\n  ================================================== -->\r\n\r\n  <div class=\"eight columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline no-margin\"><h3>Tabs</h3></div>\r\n\r\n    <!-- Tabs Navigation -->\r\n    <ul class=\"tabs-nav\">\r\n      <li class=\"active\"><a href=\"#tab1\"><i class=\"mini-ico-exclamation-sign\"></i> Tab 1</a></li>\r\n      <li><a href=\"#tab2\"><i class=\"mini-ico-file\"></i></a></li>\r\n      <li><a href=\"#tab3\">Tab 3</a></li>\r\n    </ul>\r\n\r\n    <!-- Tabs Content -->\r\n    <div class=\"tabs-container\">\r\n      <div class=\"tab-content\" id=\"tab1\">1. Lorem ipsum pharetra felis. Aliquam egestas consectetur elementum class aptent taciti sociosqu ad litora torquent perea conubia nostra lorem inceptos orem ipsum dolor sit amet, consectetur adipiscing elit.</div>\r\n      <div class=\"tab-content\" id=\"tab2\">2. Lorem ipsum pharetra felis. Aliquam egestas consectetur elementum class aptent taciti sociosqu ad litora torquent perea conubia nostra lorem inceptos orem ipsum dolor sit amet, consectetur adipiscing elit.</div>\r\n      <div class=\"tab-content\" id=\"tab3\">3. Lorem ipsum pharetra felis. Aliquam egestas consectetur elementum class aptent taciti sociosqu ad litora torquent perea conubia nostra lorem inceptos orem ipsum dolor sit amet, consectetur adipiscing elit.</div>\r\n    </div>\r\n\r\n  </div>\r\n\r\n</div>\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n\r\n  <!-- Accordions\r\n  ================================================== -->\r\n\r\n  <div class=\"eight columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Accordions</h3></div>\r\n\r\n    <!-- Accordion #1 -->\r\n    <div class=\"acc-trigger\"><a href=\"#\">Accordion #1</a></div>\r\n    <div class=\"acc-container\">\r\n      <div class=\"content\">\r\n        <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean nisl orci lorem, condiment ultrices consequat eu lorem ipsum dolor sit amet inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n      </div>\r\n    </div>\r\n\r\n    <!-- Accordion #2 -->\r\n    <div class=\"acc-trigger\"><a href=\"#\">Accordion #2</a></div>\r\n    <div class=\"acc-container\">\r\n      <div class=\"content\">\r\n        <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean nisl orci lorem, condiment ultrices consequat eu lorem ipsum dolor sit amet inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n      </div>\r\n    </div>\r\n\r\n    <!-- Accordion #3 -->\r\n    <div class=\"acc-trigger\"><a href=\"#\">Accordion #3</a></div>\r\n    <div class=\"acc-container\">\r\n      <div class=\"content\">\r\n        <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean nisl orci lorem, condiment ultrices consequat eu lorem ipsum dolor sit amet inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n      </div>\r\n    </div>\r\n\r\n  </div>\r\n\r\n\r\n  <!-- Alert Boxes\r\n  ================================================== -->\r\n\r\n  <div class=\"eight columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Alert Boxes</h3></div>\r\n\r\n    <div class=\"notification error closeable\">\r\n      <p><span>Error!</span> Please fill in all the fields required.</p>\r\n    </div>\r\n\r\n    <div class=\"notification success closeable\">\r\n      <p><span>Success!</span> You did it, now relax and enjoy it.</p>\r\n    </div>\r\n\r\n    <div class=\"notification warning closeable\">\r\n      <p><span>Warning!</span> Change this and that and try again.</p>\r\n    </div>\r\n\r\n    <div class=\"notification notice closeable\">\r\n      <p><span>Notice!</span> Please edit the information below.</p>\r\n    </div>\r\n\r\n  </div>\r\n\r\n</div>\r\n<!-- 960 Container / End -->\r\n\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n\r\n  <!-- Tooltips \r\n  ================================================== -->\r\n\r\n  <div class=\"eight columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Tooltips</h3></div>\r\n\r\n    <div class=\"tooltips\">\r\n      <p>Condiment <a href=\"#\" rel=\"tooltip\" title=\"First Tooltip\">adipiscing varius </a> accumsan. Fusce placerat neque sed sapien rutrum laoreet justo ultrices. In pellentesque lorem <a href=\"#\" rel=\"tooltip\" title=\"Another one here too\">condimentum</a> dui consequat adipiscing nisi tincidunt. Morbi pulvinar dui non quam pretium ut lacinia tortor.</p>\r\n    </div>\r\n\r\n  </div>\r\n\r\n\r\n  <!-- Blockquote\r\n  ================================================== -->\r\n\r\n  <div class=\"eight columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Blockquote</h3></div>\r\n\r\n    <blockquote>Mauris aliquet ultricies ante, non faucibus ante gravida sed. Sed ultrices pellentesque purus, vulputate volutpat ipsum hendrerit sed neque sed sapien rutrum laoreet justo ultrices. In pellentesque lorem condimentum dui conse</blockquote>\r\n  </div>\r\n\r\n</div>\r\n<!-- 960 Container / End -->\r\n\r\n\r\n<!-- Icon Boxes\r\n================================================== -->\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <div class=\"sixteen columns\">\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Icon Boxes</h3></div>\r\n  </div>\r\n\r\n  <!-- Icon Box Container -->\r\n  <div class=\"icon-boxes-container\">\r\n\r\n    <!-- Icon Box Start -->\r\n    <div class=\"one-third column\">\r\n      <div class=\"icon-box\">\r\n        <i class=\"ico-stats\" style=\"margin-left: -12px;\"></i>\r\n        <h3>Website Design</h3>\r\n        <p>Proin iaculis purus consequat sem cure digni ssim. Donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt.</p>\r\n      </div>\r\n    </div>\r\n    <!-- Icon Box End -->\r\n\r\n    <!-- Icon Box Start -->\r\n    <div class=\"one-third column\">\r\n      <div class=\"icon-box\">\r\n        <i class=\"ico-lightbulb\"></i>\r\n        <h3>Website Development</h3>\r\n        <p>Nam aliquam volutpat leo vel bibendum nunc elit purus, tempus pulvinare rhoncus egestas nibh volutpat leo.</p>\r\n      </div>\r\n    </div>\r\n    <!-- Icon Box End -->\r\n\r\n    <!-- Icon Box Start -->\r\n    <div class=\"one-third column\">\r\n      <div class=\"icon-box\">\r\n        <i class=\"ico-thumbs-up\"></i>\r\n        <h3>Social Marketing</h3>\r\n        <p>Fusce porttitor turpis quis molestie costant equat. Nam purus, tincidunt sedeat dapibus ugravida ut dui. Fusce et magna libero.</p>\r\n      </div>\r\n    </div>\r\n    <!-- Icon Box End -->\r\n\r\n  </div>\r\n  <!-- Icon Box Container / End -->\r\n\r\n</div>\r\n<!-- 960 Container / End -->\r\n\r\n<br />\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <!-- List Styles\r\n  ================================================== -->\r\n\r\n  <div class=\"four columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>List Styles</h3></div>\r\n\r\n    <ul class=\"check_list\"><li>Check List - Lorem ipsum aperia</li></ul>\r\n    <ul class=\"plus_list\"><li>Plus List - Dolor beatae lorem</li></ul>\r\n    <ul class=\"minus_list\"><li>Minus List - Perspiciatis adipiscing</li></ul>\r\n    <ul class=\"star_list\"><li>Star List - Lorem ipsum aperia</li></ul>\r\n    <ul class=\"arrow_list\"><li>Arrow 2 List - Dolor beatae lorem</li></ul>\r\n    <ul class=\"square_list\"><li>Square List - Perspiciatis adipiscing</li></ul>\r\n    <ul class=\"circle_list\"><li>Circle List - Lorem ipsum aperia</li></ul>\r\n    <ul class=\"cross_list\"><li>Cross List - Dolor beatae lorem</li></ul>\r\n\r\n  </div>\r\n\r\n\r\n  <!-- Testomonial\'s Carousel\r\n  ================================================== -->\r\n\r\n  <div class=\"four columns testimonial-container\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Testimonials</h3></div>\r\n\r\n    <!-- Testimonial\'s Carousel -->\r\n    <div class=\"testimonials-carousel\" data-autorotate=\"3000\">\r\n      <ul class=\"carousel\">\r\n\r\n        <li class=\"testimonial\">\r\n          <div class=\"testimonials\">Posuere erat a ante venenatis dapibus posuere velit aliquet. Duis llis, est non coeammodo luctus, nisi erat porttitor ligula, egeteas laciniato odiomo sem.</div>\r\n          <div class=\"testimonials-bg\"></div>\r\n          <div class=\"testimonials-author\">Michael, <span>Flash Developer</span></div>\r\n        </li>\r\n\r\n        <li class=\"testimonial\">\r\n          <div class=\"testimonials\">Integer eu libero sit amet nisl vestibulum semper. Fusce nec porttitor massa. In nec neque elit. Curabitur malesuada ligula vitae purus ornare onec etea magna diam varius.</div>\r\n          <div class=\"testimonials-bg\"></div>\r\n          <div class=\"testimonials-author\">John, <span>Web Developer</span></div>\r\n        </li>\r\n\r\n        <li class=\"testimonial\">\r\n          <div class=\"testimonials\">Cras sed odio est, sit amet porttitor elit. Vestibulum elementum erat vitae ante venenatis cursus scelerisque quam vel nibh imperdiet vitae porta lorem posuere.</div>\r\n          <div class=\"testimonials-bg\"></div>\r\n          <div class=\"testimonials-author\">Peter, <span>Project Manager</span></div>\r\n        </li>\r\n\r\n        <li class=\"testimonial\">\r\n          <div class=\"testimonials\">Elementum erat vitae ante venenatis dapibus. Maecenas cursus scelerisque quam vel nibh imperdiet vitae porta lorem posuere.</div>\r\n          <div class=\"testimonials-bg\"></div>\r\n          <div class=\"testimonials-author\">Kathy, <span>Art Director</span></div>\r\n        </li>\r\n\r\n      </ul>\r\n    </div>\r\n\r\n  </div>\r\n\r\n\r\n  <!-- Large Notice\r\n  ================================================== -->\r\n\r\n  <div class=\"eight columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Large Notice</h3></div>\r\n\r\n    <!-- Large Notice -->\r\n    <div class=\"large-notice\">\r\n      <h2>This is a Headline</h2>\r\n      <p>This is a example of style component for calling extra attention to featured content or information.</p>\r\n      <a href=\"#\" class=\"button medium color\">Read More</a>\r\n    </div>\r\n\r\n  </div>\r\n\r\n</div>\r\n<!-- 960 Container / End -->\r\n\r\n\r\n<!-- Social Icons\r\n================================================== -->\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <div class=\"sixteen columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Social Icons</h3></div>\r\n\r\n    <!-- Social Icons -->\r\n    <div id=\"social\" class=\"tooltips\">\r\n      <ul class=\"list-inline\">\r\n        <li> <a href=\"#\" rel=\"tooltip\" title=\"Amazon\" class=\"amazon\">Amazon</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Behance\" class=\"behance\">Behance</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Blogger\" class=\"blogger\">Blogger</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"DeviantART\" class=\"deviantart\">DeviantART</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Dribbble\" class=\"dribbble\">Dribbble</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Dropbox\" class=\"dropbox\">Dropbox</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Evernote\" class=\"evernote\">Evernote</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Facebook\" class=\"facebook\">Facebook</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Forrst\" class=\"forrst\">Forrst</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Github\" class=\"github\">Github</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Google Plus\" class=\"googleplus\">Google Plus</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Joli Cloud\" class=\"jolicloud\">Joli Cloud</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Last FM\" class=\"last-fm\">Last FM</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"LinkedIn\" class=\"linkedin\">LinkedIn</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Picasa\" class=\"picasa\">Picasa</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Pintrest\" class=\"pintrest\">Pintrest</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"RSS\" class=\"rss\">RSS</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Skype\" class=\"skype\">Skype</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Spotify\" class=\"spotify\">Spotify</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"StumpleUpon\" class=\"stumbleupon\">StumbleUpon</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Tumblr\" class=\"tumblr\">Tumblr</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Twitter\" class=\"twitter\">Twitter</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Vimeo\" class=\"vimeo\">Vimeo</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"WordPress\" class=\"wordpress\">WordPress</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Xing\" class=\"xing\">Xing</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Yahoo\" class=\"yahoo\">Yahoo</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"YouTube\" class=\"youtube\">YouTube</a></li>\r\n      </ul>\r\n    </div>\r\n    <!-- Social Icons / End-->\r\n\r\n  </div>\r\n</div>\r\n<!-- 960 Container / End -->\r\n\r\n\r\n<!-- Regular Table\r\n================================================== -->\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <div class=\"sixteen columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Table</h3></div>\r\n\r\n    <table class=\"standard-table\">\r\n\r\n      <tr>\r\n        <th>Header 1</th>\r\n        <th>Header 2</th>\r\n        <th>Header 3</th>\r\n        <th>Header 4</th>\r\n      </tr>\r\n\r\n      <tr>\r\n        <td>Item #1</td>\r\n        <td>Description</td>\r\n        <td>100 GB</td>\r\n        <td>100 GB</td>\r\n      </tr>\r\n\r\n      <tr>\r\n        <td>Item #2</td>\r\n        <td>Description</td>\r\n        <td>200 GB</td>\r\n        <td>200 GB</td>\r\n      </tr>\r\n\r\n      <tr>\r\n        <td>Item #3</td>\r\n        <td>Description</td>\r\n        <td>300 GB</td>\r\n        <td>300 GB</td>\r\n      </tr>\r\n\r\n      <tr>\r\n        <td>Item #4</td>\r\n        <td>Description</td>\r\n        <td>400 GB</td>\r\n        <td>400 GB</td>\r\n      </tr>\r\n\r\n      <tr>\r\n        <td>Item #5</td>\r\n        <td>Description</td>\r\n        <td>500 GB</td>\r\n        <td>500 GB</td>\r\n      </tr>\r\n\r\n    </table>\r\n\r\n  </div>\r\n</div>\r\n<!-- 960 Container / End -->\r\n\r\n\r\n<!-- Mini Icons\r\n================================================== -->\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <div class=\"sixteen columns\">\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Mini Icons</h3></div>\r\n  </div>\r\n\r\n  <div class=\"four columns\">\r\n    <ul>\r\n      <li><i class=\"mini-ico-glass\"></i> mini-ico-glass</li>\r\n      <li><i class=\"mini-ico-music\"></i> mini-ico-music</li>\r\n      <li><i class=\"mini-ico-search\"></i> mini-ico-search</li>\r\n      <li><i class=\"mini-ico-envelope\"></i> mini-ico-envelope</li>\r\n      <li><i class=\"mini-ico-heart\"></i> mini-ico-heart</li>\r\n      <li><i class=\"mini-ico-star\"></i> mini-ico-star</li>\r\n      <li><i class=\"mini-ico-star-empty\"></i> mini-ico-star-empty</li>\r\n      <li><i class=\"mini-ico-user\"></i> mini-ico-user</li>\r\n      <li><i class=\"mini-ico-film\"></i> mini-ico-film</li>\r\n      <li><i class=\"mini-ico-th-large\"></i> mini-ico-th-large</li>\r\n      <li><i class=\"mini-ico-th\"></i> mini-ico-th</li>\r\n      <li><i class=\"mini-ico-th-list\"></i> mini-ico-th-list</li>\r\n      <li><i class=\"mini-ico-ok\"></i> mini-ico-ok</li>\r\n      <li><i class=\"mini-ico-remove\"></i> mini-ico-remove</li>\r\n      <li><i class=\"mini-ico-zoom-in\"></i> mini-ico-zoom-in</li>\r\n      <li><i class=\"mini-ico-zoom-out\"></i> mini-ico-zoom-out</li>\r\n      <li><i class=\"mini-ico-off\"></i> mini-ico-off</li>\r\n      <li><i class=\"mini-ico-signal\"></i> mini-ico-signal</li>\r\n      <li><i class=\"mini-ico-cog\"></i> mini-ico-cog</li>\r\n      <li><i class=\"mini-ico-trash\"></i> mini-ico-trash</li>\r\n      <li><i class=\"mini-ico-home\"></i> mini-ico-home</li>\r\n      <li><i class=\"mini-ico-file\"></i> mini-ico-file</li>\r\n      <li><i class=\"mini-ico-time\"></i> mini-ico-time</li>\r\n      <li><i class=\"mini-ico-road\"></i> mini-ico-road</li>\r\n      <li><i class=\"mini-ico-download-alt\"></i> mini-ico-download-alt</li>\r\n      <li><i class=\"mini-ico-download\"></i> mini-ico-download</li>\r\n      <li><i class=\"mini-ico-upload\"></i> mini-ico-upload</li>\r\n      <li><i class=\"mini-ico-inbox\"></i> mini-ico-inbox</li>\r\n      <li><i class=\"mini-ico-play-circle\"></i> mini-ico-play-circle</li>\r\n      <li><i class=\"mini-ico-repeat\"></i> mini-ico-repeat</li>\r\n      <li><i class=\"mini-ico-refresh\"></i> mini-ico-refresh</li>\r\n      <li><i class=\"mini-ico-list-alt\"></i> mini-ico-list-alt</li>\r\n      <li><i class=\"mini-ico-lock\"></i> mini-ico-lock</li>\r\n      <li><i class=\"mini-ico-flag\"></i> mini-ico-flag</li>\r\n      <li><i class=\"mini-ico-headphones\"></i> mini-ico-headphones</li>\r\n    </ul>\r\n  </div>\r\n  <div class=\"four columns\">\r\n    <ul>\r\n      <li><i class=\"mini-ico-volume-off\"></i> mini-ico-volume-off</li>\r\n      <li><i class=\"mini-ico-volume-down\"></i> mini-ico-volume-down</li>\r\n      <li><i class=\"mini-ico-volume-up\"></i> mini-ico-volume-up</li>\r\n      <li><i class=\"mini-ico-qrcode\"></i> mini-ico-qrcode</li>\r\n      <li><i class=\"mini-ico-barcode\"></i> mini-ico-barcode</li>\r\n      <li><i class=\"mini-ico-tag\"></i> mini-ico-tag</li>\r\n      <li><i class=\"mini-ico-tags\"></i> mini-ico-tags</li>\r\n      <li><i class=\"mini-ico-book\"></i> mini-ico-book</li>\r\n      <li><i class=\"mini-ico-bookmark\"></i> mini-ico-bookmark</li>\r\n      <li><i class=\"mini-ico-print\"></i> mini-ico-print</li>\r\n      <li><i class=\"mini-ico-camera\"></i> mini-ico-camera</li>\r\n      <li><i class=\"mini-ico-font\"></i> mini-ico-font</li>\r\n      <li><i class=\"mini-ico-bold\"></i> mini-ico-bold</li>\r\n      <li><i class=\"mini-ico-italic\"></i> mini-ico-italic</li>\r\n      <li><i class=\"mini-ico-text-height\"></i> mini-ico-text-height</li>\r\n      <li><i class=\"mini-ico-text-width\"></i> mini-ico-text-width</li>\r\n      <li><i class=\"mini-ico-align-left\"></i> mini-ico-align-left</li>\r\n      <li><i class=\"mini-ico-align-center\"></i> mini-ico-align-center</li>\r\n      <li><i class=\"mini-ico-align-right\"></i> mini-ico-align-right</li>\r\n      <li><i class=\"mini-ico-align-justify\"></i> mini-ico-align-justify</li>\r\n      <li><i class=\"mini-ico-list\"></i> mini-ico-list</li>\r\n      <li><i class=\"mini-ico-indent-left\"></i> mini-ico-indent-left</li>\r\n      <li><i class=\"mini-ico-indent-right\"></i> mini-ico-indent-right</li>\r\n      <li><i class=\"mini-ico-facetime-video\"></i> mini-ico-facetime-video</li>\r\n      <li><i class=\"mini-ico-picture\"></i> mini-ico-picture</li>\r\n      <li><i class=\"mini-ico-pencil\"></i> mini-ico-pencil</li>\r\n      <li><i class=\"mini-ico-map-marker\"></i> mini-ico-map-marker</li>\r\n      <li><i class=\"mini-ico-adjust\"></i> mini-ico-adjust</li>\r\n      <li><i class=\"mini-ico-tint\"></i> mini-ico-tint</li>\r\n      <li><i class=\"mini-ico-edit\"></i> mini-ico-edit</li>\r\n      <li><i class=\"mini-ico-share\"></i> mini-ico-share</li>\r\n      <li><i class=\"mini-ico-check\"></i> mini-ico-check</li>\r\n      <li><i class=\"mini-ico-move\"></i> mini-ico-move</li>\r\n      <li><i class=\"mini-ico-step-backward\"></i> mini-ico-step-backward</li>\r\n      <li><i class=\"mini-ico-fast-backward\"></i> mini-ico-fast-backward</li>\r\n    </ul>\r\n  </div>\r\n  <div class=\"four columns\">\r\n    <ul>\r\n      <li><i class=\"mini-ico-backward\"></i> mini-ico-backward</li>\r\n      <li><i class=\"mini-ico-play\"></i> mini-ico-play</li>\r\n      <li><i class=\"mini-ico-pause\"></i> mini-ico-pause</li>\r\n      <li><i class=\"mini-ico-stop\"></i> mini-ico-stop</li>\r\n      <li><i class=\"mini-ico-forward\"></i> mini-ico-forward</li>\r\n      <li><i class=\"mini-ico-fast-forward\"></i> mini-ico-fast-forward</li>\r\n      <li><i class=\"mini-ico-step-forward\"></i> mini-ico-step-forward</li>\r\n      <li><i class=\"mini-ico-eject\"></i> mini-ico-eject</li>\r\n      <li><i class=\"mini-ico-chevron-left\"></i> mini-ico-chevron-left</li>\r\n      <li><i class=\"mini-ico-chevron-right\"></i> mini-ico-chevron-right</li>\r\n      <li><i class=\"mini-ico-plus-sign\"></i> mini-ico-plus-sign</li>\r\n      <li><i class=\"mini-ico-minus-sign\"></i> mini-ico-minus-sign</li>\r\n      <li><i class=\"mini-ico-remove-sign\"></i> mini-ico-remove-sign</li>\r\n      <li><i class=\"mini-ico-ok-sign\"></i> mini-ico-ok-sign</li>\r\n      <li><i class=\"mini-ico-question-sign\"></i> mini-ico-question-sign</li>\r\n      <li><i class=\"mini-ico-info-sign\"></i> mini-ico-info-sign</li>\r\n      <li><i class=\"mini-ico-screenshot\"></i> mini-ico-screenshot</li>\r\n      <li><i class=\"mini-ico-remove-circle\"></i> mini-ico-remove-circle</li>\r\n      <li><i class=\"mini-ico-ok-circle\"></i> mini-ico-ok-circle</li>\r\n      <li><i class=\"mini-ico-ban-circle\"></i> mini-ico-ban-circle</li>\r\n      <li><i class=\"mini-ico-arrow-left\"></i> mini-ico-arrow-left</li>\r\n      <li><i class=\"mini-ico-arrow-right\"></i> mini-ico-arrow-right</li>\r\n      <li><i class=\"mini-ico-arrow-up\"></i> mini-ico-arrow-up</li>\r\n      <li><i class=\"mini-ico-arrow-down\"></i> mini-ico-arrow-down</li>\r\n      <li><i class=\"mini-ico-share-alt\"></i> mini-ico-share-alt</li>\r\n      <li><i class=\"mini-ico-resize-full\"></i> mini-ico-resize-full</li>\r\n      <li><i class=\"mini-ico-resize-small\"></i> mini-ico-resize-small</li>\r\n      <li><i class=\"mini-ico-plus\"></i> mini-ico-plus</li>\r\n      <li><i class=\"mini-ico-minus\"></i> mini-ico-minus</li>\r\n      <li><i class=\"mini-ico-asterisk\"></i> mini-ico-asterisk</li>\r\n      <li><i class=\"mini-ico-exclamation-sign\"></i> mini-ico-exclamation-sign</li>\r\n      <li><i class=\"mini-ico-gift\"></i> mini-ico-gift</li>\r\n      <li><i class=\"mini-ico-leaf\"></i> mini-ico-leaf</li>\r\n      <li><i class=\"mini-ico-fire\"></i> mini-ico-fire</li>\r\n      <li><i class=\"mini-ico-eye-open\"></i> mini-ico-eye-open</li>\r\n    </ul>\r\n  </div>\r\n  <div class=\"four columns\">\r\n    <ul>\r\n      <li><i class=\"mini-ico-eye-close\"></i> mini-ico-eye-close</li>\r\n      <li><i class=\"mini-ico-warning-sign\"></i> mini-ico-warning-sign</li>\r\n      <li><i class=\"mini-ico-plane\"></i> mini-ico-plane</li>\r\n      <li><i class=\"mini-ico-calendar\"></i> mini-ico-calendar</li>\r\n      <li><i class=\"mini-ico-random\"></i> mini-ico-random</li>\r\n      <li><i class=\"mini-ico-comment\"></i> mini-ico-comment</li>\r\n      <li><i class=\"mini-ico-magnet\"></i> mini-ico-magnet</li>\r\n      <li><i class=\"mini-ico-chevron-up\"></i> mini-ico-chevron-up</li>\r\n      <li><i class=\"mini-ico-chevron-down\"></i> mini-ico-chevron-down</li>\r\n      <li><i class=\"mini-ico-retweet\"></i> mini-ico-retweet</li>\r\n      <li><i class=\"mini-ico-shopping-cart\"></i> mini-ico-shopping-cart</li>\r\n      <li><i class=\"mini-ico-folder-close\"></i> mini-ico-folder-close</li>\r\n      <li><i class=\"mini-ico-folder-open\"></i> mini-ico-folder-open</li>\r\n      <li><i class=\"mini-ico-resize-vertical\"></i> mini-ico-resize-vertical</li>\r\n      <li><i class=\"mini-ico-resize-horizontal\"></i> mini-ico-resize-horizontal</li>\r\n      <li><i class=\"mini-ico-hdd\"></i> mini-ico-hdd</li>\r\n      <li><i class=\"mini-ico-bullhorn\"></i> mini-ico-bullhorn</li>\r\n      <li><i class=\"mini-ico-bell\"></i> mini-ico-bell</li>\r\n      <li><i class=\"mini-ico-certificate\"></i> mini-ico-certificate</li>\r\n      <li><i class=\"mini-ico-thumbs-up\"></i> mini-ico-thumbs-up</li>\r\n      <li><i class=\"mini-ico-thumbs-down\"></i> mini-ico-thumbs-down</li>\r\n      <li><i class=\"mini-ico-hand-right\"></i> mini-ico-hand-right</li>\r\n      <li><i class=\"mini-ico-hand-left\"></i> mini-ico-hand-left</li>\r\n      <li><i class=\"mini-ico-hand-up\"></i> mini-ico-hand-up</li>\r\n      <li><i class=\"mini-ico-hand-down\"></i> mini-ico-hand-down</li>\r\n      <li><i class=\"mini-ico-circle-arrow-right\"></i> mini-ico-circle-arrow-right</li>\r\n      <li><i class=\"mini-ico-circle-arrow-left\"></i> mini-ico-circle-arrow-left</li>\r\n      <li><i class=\"mini-ico-circle-arrow-up\"></i> mini-ico-circle-arrow-up</li>\r\n      <li><i class=\"mini-ico-circle-arrow-down\"></i> mini-ico-circle-arrow-down</li>\r\n      <li><i class=\"mini-ico-globe\"></i> mini-ico-globe</li>\r\n      <li><i class=\"mini-ico-wrench\"></i> mini-ico-wrench</li>\r\n      <li><i class=\"mini-ico-tasks\"></i> mini-ico-tasks</li>\r\n      <li><i class=\"mini-ico-filter\"></i> mini-ico-filter</li>\r\n      <li><i class=\"mini-ico-briefcase\"></i> mini-ico-briefcase</li>\r\n      <li><i class=\"mini-ico-fullscreen\"></i> mini-ico-fullscreen</li>\r\n    </ul>\r\n  </div>\r\n\r\n</div>\r\n<!-- 960 Container End -->\r\n\r\n\r\n<!-- Icons\r\n================================================== -->\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n  <div class=\"sixteen columns\"></div>\r\n\r\n  <!-- Headline -->\r\n  <div class=\"headline\"><h3>Icons</h3></div>\r\n\r\n  <div class=\"four columns\">\r\n    <ul class=\"the-icons\">\r\n      <li><i class=\"ico-glass\"></i> <b>ico-glass</b></li>\r\n      <li><i class=\"ico-leaf\"></i> <b>ico-leaf</b></li>\r\n      <li><i class=\"ico-dog\"></i> <b>ico-dog</b></li>\r\n      <li><i class=\"ico-user\"></i> <b>ico-user</b></li>\r\n      <li><i class=\"ico-girl\"></i> <b>ico-girl</b></li>\r\n      <li><i class=\"ico-car\"></i> <b>ico-car</b></li>\r\n      <li><i class=\"ico-user-add\"></i> <b>ico-user-add</b></li>\r\n      <li><i class=\"ico-user-remove\"></i> <b>ico-remove</b></li>\r\n      <li><i class=\"ico-film\"></i> <b>ico-film</b></li>\r\n      <li><i class=\"ico-magic\"></i> <b>ico-magic</b></li>\r\n      <li><i class=\"ico-envelope\"></i> <b>ico-envelope</b></li>\r\n      <li><i class=\"ico-camera\"></i> <b>ico-camera</b></li>\r\n      <li><i class=\"ico-heart\"></i> <b>ico-hearth</b></li>\r\n      <li><i class=\"ico-beach-umbrella\"></i> <b>ico-beach-umbrella</b></li>\r\n      <li><i class=\"ico-train\"></i> <b>ico-train</b></li>\r\n      <li><i class=\"ico-print\"></i> <b>ico-print</b></li>\r\n      <li><i class=\"ico-bin\"></i> <b>ico-bin</b></li>\r\n      <li><i class=\"ico-music\"></i> <b>ico--music</b></li>\r\n      <li><i class=\"ico-note\"></i> <b>ico-note</b></li>\r\n      <li><i class=\"ico-cogwheel\"></i> <b>ico-cogwheel</b></li>\r\n      <li><i class=\"ico-home\"></i> <b>ico-home</b></li>\r\n      <li><i class=\"ico-snowflake\"></i> <b>ico-snowflake</b></li>\r\n      <li><i class=\"ico-fire\"></i> <b>ico-fire</b></li>\r\n      <li><i class=\"ico-cogwheels\"></i> <b>ico-cogwheels</b></li>\r\n      <li><i class=\"ico-parents\"></i> <b>ico-parents</b></li>\r\n      <li><i class=\"ico-binoculars\"></i> <b>ico-binoculars</b></li>\r\n      <li><i class=\"ico-road\"></i> <b>ico-road</b></li>\r\n      <li><i class=\"ico-search\"></i> <b>ico-search</b></li>\r\n      <li><i class=\"ico-cars\"></i> <b>ico-cars</b></li>\r\n      <li><i class=\"ico-notes\"></i> <b>ico-notes</b></li>\r\n      <li><i class=\"ico-pencil\"></i> <b>ico-pencil</b></li>\r\n      <li><i class=\"ico-bus\"></i> <b>ico-bus</b></li>\r\n      <li><i class=\"ico-wifi-alt\"></i> <b>ico-wifi-alt</b></li>\r\n      <li><i class=\"ico-luggage\"></i> <b>ico-luggage</b></li>\r\n      <li><i class=\"ico-old-man\"></i> <b>ico-old-man</b></li>\r\n      <li><i class=\"ico-woman\"></i> <b>ico-woman</b></li>\r\n      <li><i class=\"ico-file\"></i> <b>ico-file</b></li>\r\n      <li><i class=\"ico-credit\"></i> <b>ico-credit</b></li>\r\n      <li><i class=\"ico-airplane\"></i> <b>ico-airplane</b></li>\r\n      <li><i class=\"ico-notes\"></i> <b>ico-notes</b></li>\r\n      <li><i class=\"ico-stats\"></i> <b>ico-stats</b></li>\r\n      <li><i class=\"ico-charts\"></i> <b>ico-charts</b></li>\r\n      <li><i class=\"ico-pie-chart\"></i> <b>ico-pie-chart</b></li>\r\n      <li><i class=\"ico-group\"></i> <b>ico-group</b></li>\r\n      <li><i class=\"ico-keys\"></i> <b>ico-keys</b></li>\r\n      <li><i class=\"ico-calendar\"></i> <b>ico-calendar</b></li>\r\n      <li><i class=\"ico-router\"></i> <b>ico-router</b></li>\r\n      <li><i class=\"ico-camera-small\"></i> <b>ico-camera-small</b></li>\r\n      <li><i class=\"ico-dislikes\"></i> <b>ico-dislikes</b></li>\r\n      <li><i class=\"ico-star\"></i> <b>ico-star</b></li>\r\n      <li><i class=\"ico-link\"></i> <b>ico-link</b></li>\r\n      <li><i class=\"ico-eye-open\"></i> <b>ico-eye-open</b></li>\r\n      <li><i class=\"ico-eye-close\"></i> <b>ico-eye-close</b></li>\r\n      <li><i class=\"ico-alarm\"></i> <b>ico-alarm</b></li>\r\n      <li><i class=\"ico-clock\"></i> <b>ico-clock</b></li>\r\n      <li><i class=\"ico-stopwatch\"></i> <b>ico-stopwatch</b></li>\r\n      <li><i class=\"ico-projector\"></i> <b>ico-projector</b></li>\r\n      <li><i class=\"ico-history\"></i> <b>ico-history</b></li>\r\n      <li><i class=\"ico-truck\"></i> <b>ico-truck</b></li>\r\n      <li><i class=\"ico-cargo\"></i> <b>ico-cargo</b></li>\r\n      <li><i class=\"ico-compass\"></i> <b>ico-compass</b></li>\r\n      <li><i class=\"ico-keynote\"></i> <b>ico-keynote</b></li>\r\n      <li><i class=\"ico-attach\"></i> <b>ico-attach</b></li>\r\n      <li><i class=\"ico-power\"></i> <b>ico-power</b></li>\r\n      <li><i class=\"ico-lightbulb\"></i> <b>ico-lightbulb</b></li>\r\n      <li><i class=\"ico-tag\"></i> <b>ico-tag</b></li>\r\n      <li><i class=\"ico-tags\"></i> <b>ico-tags</b></li>\r\n      <li><i class=\"ico-cleaning\"></i> <b>ico-cleaning</b></li>\r\n      <li><i class=\"ico-ruller\"></i> <b>ico-ruller</b></li>\r\n      <li><i class=\"ico-gift\"></i> <b>ico-gift</b></li>\r\n      <li><i class=\"ico-umbrella\"></i> <b>ico-umbrella</b></li>\r\n      <li><i class=\"ico-book\"></i> <b>ico--book</b></li>\r\n      <li><i class=\"ico-bookmark\"></i> <b>ico-bookmark</b></li>\r\n      <li><i class=\"ico-signal-alt\"></i> <b>ico-signal-alt</b></li>\r\n      <li><i class=\"ico-cup\"></i> <b>ico-cup</b></li>\r\n      <li><i class=\"ico-stroller\"></i> <b>ico-stroller</b></li>\r\n      <li><i class=\"ico-headphones\"></i> <b>ico-headphones</b></li>\r\n      <li><i class=\"ico-headset\"></i> <b>ico-headset</b></li>\r\n      <li><i class=\"ico-warning-sign\"></i> <b>ico-warning-sign</b></li>\r\n      <li><i class=\"ico-signal\"></i> <b>ico-signal</b></li>\r\n      <li><i class=\"ico-retweet\"></i> <b>ico-retweet</b></li>\r\n      <li><i class=\"ico-refresh\"></i> <b>ico-refresh</b></li>\r\n      <li><i class=\"ico-roundabout\"></i> <b>ico-roundabout</b></li>\r\n      <li><i class=\"ico-random\"></i> <b>ico-random</b></li>\r\n      <li><i class=\"ico-heat\"></i> <b>ico-heat</b></li>\r\n      <li><i class=\"ico-repeat\"></i> <b>ico-repeat</b></li>\r\n      <li><i class=\"ico-display\"></i> <b>ico-display</b></li>\r\n      <li><i class=\"ico-log-book\"></i> <b>ico-log-book</b></li>\r\n      <li><i class=\"ico-adress-book\"></i> <b>ico-adress-book</b></li>\r\n      <li><i class=\"ico-magnet\"></i> <b>ico-magnet</b></li>\r\n    </ul>	\r\n  </div>\r\n\r\n  <div class=\"four columns\">\r\n    <ul class=\"the-icons\">\r\n      <li><i class=\"ico-table\"></i> <b>ico-table</b></li>\r\n      <li><i class=\"ico-adjust\"></i> <b>ico-adjust</b></li>\r\n      <li><i class=\"ico-tint\"></i> <b>ico-tint</b></li>\r\n      <li><i class=\"ico-crop\"></i> <b>ico-crop</b></li>\r\n      <li><i class=\"ico-vector-path-square\"></i> <b>ico-vector-path-square</b></li>\r\n      <li><i class=\"ico-vector-path-circle\"></i> <b>ico-vector-path-circle</b></li>\r\n      <li><i class=\"ico-vector-path-polygon\"></i> <b>ico-vector-path-polygon</b></li>\r\n      <li><i class=\"ico-vector-path-line\"></i> <b>ico-vector-path-line</b></li>\r\n      <li><i class=\"ico-vector-path-curve\"></i> <b>ico-vector-path-curve</b></li>\r\n      <li><i class=\"ico-vector-path-all\"></i> <b>ico-vector-path-all</b></li>\r\n      <li><i class=\"ico-font\"></i> <b>ico-font</b></li>\r\n      <li><i class=\"ico-italic\"></i> <b>ico-italic</b></li>\r\n      <li><i class=\"ico-bold\"></i> <b>ico-bold</b></li>\r\n      <li><i class=\"ico-text-underline\"></i> <b>ico-text-underline</b></li>\r\n      <li><i class=\"ico-text-strike\"></i> <b>ico-text-strike</b></li>\r\n      <li><i class=\"ico-text-height\"></i> <b>ico-text-height</b></li>\r\n      <li><i class=\"ico-text-width\"></i> <b>ico-text-width</b></li>\r\n      <li><i class=\"ico-text-resize\"></i> <b>ico-text-resize</b></li>\r\n      <li><i class=\"ico-left-indent\"></i> <b>ico-left-indent</b></li>\r\n      <li><i class=\"ico-right-indent\"></i> <b>ico-right-indent</b></li>\r\n      <li><i class=\"ico-align-left\"></i> <b>ico-align-left</b></li>\r\n      <li><i class=\"ico-align-center\"></i> <b>ico-align-center</b></li>\r\n      <li><i class=\"ico-align-right\"></i> <b>ico-align-right</b></li>\r\n      <li><i class=\"ico-justify\"></i> <b>ico-justify</b></li>\r\n      <li><i class=\"ico-list\"></i> <b>ico-list</b></li>\r\n      <li><i class=\"ico-text-smaller\"></i> <b>ico-text-smaller</b></li>\r\n      <li><i class=\"ico-text-bugger\"></i> <b>ico-text-bugger</b></li>\r\n      <li><i class=\"ico-embed\"></i> <b>ico-embed</b></li>\r\n      <li><i class=\"ico-embed-close\"></i> <b>ico-embed-close</b></li>\r\n      <li><i class=\"ico-adjust-alt\"></i> <b>ico-adjust-alt</b></li>\r\n      <li><i class=\"ico-message-full\"></i> <b>ico-message-full</b></li>\r\n      <li><i class=\"ico-message-empty\"></i> <b>ico-message-empty</b></li>\r\n      <li><i class=\"ico-message-in\"></i> <b>ico-message-in</b></li>\r\n      <li><i class=\"ico-message-out\"></i> <b>ico-message-out</b></li>\r\n      <li><i class=\"ico-message-plus\"></i> <b>ico-message-plus</b></li>\r\n      <li><i class=\"ico-message-minus\"></i> <b>ico-message-minus</b></li>\r\n      <li><i class=\"ico-message-ban\"></i> <b>ico-message-ban</b></li>\r\n      <li><i class=\"ico-message-flag\"></i> <b>ico-message-flag</b></li>\r\n      <li><i class=\"ico-message-lock\"></i> <b>ico-message-lock</b></li>\r\n      <li><i class=\"ico-message-new\"></i> <b>ico-message-new</b></li>\r\n      <li><i class=\"ico-inbox\"></i> <b>ico-inbox</b></li>\r\n      <li><i class=\"ico-inbox-plus\"></i> <b>ico-inbox-plus</b></li>\r\n      <li><i class=\"ico-inbox-minus\"></i> <b>ico-inbox-minus</b></li>\r\n      <li><i class=\"ico-inbox-lock\"></i> <b>ico-inbox-lock</b></li>\r\n      <li><i class=\"ico-inbox-in\"></i> <b>ico-inbox-in</b></li>\r\n      <li><i class=\"ico-inbox-out\"></i> <b>ico-inbox-out</b></li>\r\n      <li><i class=\"ico-computer-locked\"></i> <b>ico-computer-locked</b></li>\r\n      <li><i class=\"ico-computer-service\"></i> <b>ico-computer-service</b></li>\r\n      <li><i class=\"ico-computer-process\"></i> <b>ico-computer-process</b></li>\r\n      <li><i class=\"ico-phone\"></i> <b>ico-phone</b></li>\r\n      <li><i class=\"ico-database-lock\"></i> <b>ico-database-lock</b></li>\r\n      <li><i class=\"ico-database-plus\"></i> <b>ico-database-plus</b></li>\r\n      <li><i class=\"ico-database-minus\"></i> <b>ico-database-minus</b></li>\r\n      <li><i class=\"ico-database-ban\"></i> <b>ico-database-ban</b></li>\r\n      <li><i class=\"ico-folder-open\"></i> <b>ico-folder-open</b></li>\r\n      <li><i class=\"ico-folder-plus\"></i> <b>ico-folder-plus</b></li>\r\n      <li><i class=\"ico-folder-minus\"></i> <b>ico--folder-minus</b></li>\r\n      <li><i class=\"ico-folder-lock\"></i> <b>ico-folder-lock</b></li>\r\n      <li><i class=\"ico-folder-flag\"></i> <b>ico-folder-flag</b></li>\r\n      <li><i class=\"ico-folder-new\"></i> <b>ico-folder-new</b></li>\r\n      <li><i class=\"ico-check\"></i> <b>ico-check</b></li>\r\n      <li><i class=\"ico-edit\"></i> <b>ico-edit</b></li>\r\n      <li><i class=\"ico-new-window\"></i> <b>ico-new-window</b></li>\r\n      <li><i class=\"ico-more-windows\"></i> <b>ico-more-windows</b></li>\r\n      <li><i class=\"ico-show-big-thumbnails\"></i> <b>ico-show-big-thumbnails</b></li>\r\n      <li><i class=\"ico-show-thumbnails\"></i> <b>ico-show-thumbnails</b></li>\r\n      <li><i class=\"ico-show-thumbnails-lines\"></i> <b>ico-show-thumbnails-lines</b></li>\r\n      <li><i class=\"ico-show-lines\"></i> <b>ico-show-lines</b></li>\r\n      <li><i class=\"ico-playlist\"></i> <b>ico-playlist</b></li>\r\n      <li><i class=\"ico-picture\"></i> <b>ico-picture</b></li>\r\n      <li><i class=\"ico-imac\"></i> <b>ico-imac</b></li>\r\n      <li><i class=\"ico-macbook\"></i> <b>ico-macbook</b></li>\r\n      <li><i class=\"ico-ipad\"></i> <b>ico-ipad</b></li>\r\n      <li><i class=\"ico-iphone\"></i> <b>ico-iphone</b></li>\r\n      <li><i class=\"ico-iphone-transfer\"></i> <b>ico-iphone-transfer</b></li>\r\n      <li><i class=\"ico-iphone-exchange\"></i> <b>ico-iphone-exchange</b></li>\r\n      <li><i class=\"ico-ipod\"></i> <b>ico-ipod</b></li>\r\n      <li><i class=\"ico-ipod-shuffle\"></i> <b>ico-ipod-shuffle</b></li>\r\n      <li><i class=\"ico-ear-plugs\"></i> <b>ico-ear-plugs</b></li>\r\n      <li><i class=\"ico-albums\"></i> <b>ico-albums</b></li>\r\n      <li><i class=\"ico-step-backward\"></i> <b>ico-step-backward</b></li>\r\n      <li><i class=\"ico-fast-backward\"></i> <b>ico-fast-backward</b></li>\r\n      <li><i class=\"ico-rewind\"></i> <b>ico-rewind</b></li>\r\n      <li><i class=\"ico-play\"></i> <b>ico-play</b></li>\r\n      <li><i class=\"ico-pause\"></i> <b>ico-pause</b></li>\r\n      <li><i class=\"ico-stop\"></i> <b>ico-stop</b></li>\r\n      <li><i class=\"ico-forward\"></i> <b>ico-forward</b></li>\r\n      <li><i class=\"ico-fast-forward\"></i> <b>ico-fast-forward</b></li>\r\n      <li><i class=\"ico-step-forward\"></i> <b>ico-step-forward</b></li>\r\n      <li><i class=\"ico-eject\"></i> <b>ico-eject</b></li>\r\n    </ul>	\r\n  </div>\r\n\r\n\r\n  <div class=\"four columns\">\r\n    <ul class=\"the-icons\">\r\n      <li><i class=\"ico-facetime-video\"></i> <b>ico-facetime-video</b></li>\r\n      <li><i class=\"ico-download-alt\"></i> <b>ico-download-alt</b></li>\r\n      <li><i class=\"ico-mute\"></i> <b>ico-mute</b></li>\r\n      <li><i class=\"ico-volume-up\"></i> <b>ico-volume-up</b></li>\r\n      <li><i class=\"ico-volume-down\"></i> <b>ico-volume-down</b></li>\r\n      <li><i class=\"ico-screenshot\"></i> <b>ico-screenshot</b></li>\r\n      <li><i class=\"ico-move\"></i> <b>ico-move</b></li>\r\n      <li><i class=\"ico-more\"></i> <b>ico-more</b></li>\r\n      <li><i class=\"ico-brightness-reduce\"></i> <b>ico-brightness-reduce</b></li>\r\n      <li><i class=\"ico-brightness-increase\"></i> <b>ico-brightness-increase</b></li>\r\n      <li><i class=\"ico-circle-plus\"></i> <b>ico-circle-plus</b></li>\r\n      <li><i class=\"ico-circle-minus\"></i> <b>ico-circle-minus</b></li>\r\n      <li><i class=\"ico-circle-remove\"></i> <b>ico-circle-remove</b></li>\r\n      <li><i class=\"ico-circle-ok\"></i> <b>ico-circle-ok</b></li>\r\n      <li><i class=\"ico-circle-question-mark\"></i> <b>ico-circle-question-mark</b></li>\r\n      <li><i class=\"ico-circle-info\"></i> <b>ico-circle-info</b></li>\r\n      <li><i class=\"ico-circle-exclamation-mark\"></i> <b>ico-circle-exclamation-mark</b></li>\r\n      <li><i class=\"ico-remove\"></i> <b>ico-remove</b></li>\r\n      <li><i class=\"ico-ok\"></i> <b>ico-ok</b></li>\r\n      <li><i class=\"ico-ban\"></i> <b>ico-ban</b></li>\r\n      <li><i class=\"ico-download\"></i> <b>ico-download</b></li>\r\n      <li><i class=\"ico-upload\"></i> <b>ico-upload</b></li>\r\n      <li><i class=\"ico-shopping-cart\"></i> <b>ico-shopping-cart</b></li>\r\n      <li><i class=\"ico-lock\"></i> <b>ico-lock</b></li>\r\n      <li><i class=\"ico-unlock\"></i> <b>ico-unlock</b></li>\r\n      <li><i class=\"ico-electricity\"></i> <b>ico-electricity</b></li>\r\n      <li><i class=\"ico-ok\"></i> <b>ico-ok</b></li>\r\n      <li><i class=\"ico-remove\"></i> <b>ico-remove</b></li>\r\n      <li><i class=\"ico-cart-out\"></i> <b>ico-cart-out</b></li>\r\n      <li><i class=\"ico-cart-in\"></i> <b>ico-cart-in</b></li>\r\n      <li><i class=\"ico-left-arrow\"></i> <b>ico-left-arrow</b></li>\r\n      <li><i class=\"ico-right-arrow\"></i> <b>ico-right-arrow</b></li>\r\n      <li><i class=\"ico-down-arrow\"></i> <b>ico-down-arrow</b></li>\r\n      <li><i class=\"ico-up-arrow\"></i> <b>ico-up-arrow</b></li>\r\n      <li><i class=\"ico-resize-small\"></i> <b>ico-resize-small</b></li>\r\n      <li><i class=\"ico-resize-full\"></i> <b>ico-resize-full</b></li>\r\n      <li><i class=\"ico-circle-arrow-left\"></i> <b>ico-circle-arrow-left</b></li>\r\n      <li><i class=\"ico-circle-arrow-right\"></i> <b>ico-circle-arrow-right</b></li>\r\n      <li><i class=\"ico-circle-arrow-top\"></i> <b>ico-circle-arrow-top</b></li>\r\n      <li><i class=\"ico-circle-arrow-down\"></i> <b>ico-</b></li>\r\n      <li><i class=\"ico-play-button\"></i> <b>ico-play-button</b></li>\r\n      <li><i class=\"ico-unshare\"></i> <b>ico-unshare</b></li>\r\n      <li><i class=\"ico-share\"></i> <b>ico-share</b></li>\r\n      <li><i class=\"ico-thin-right-arrow\"></i> <b>ico-thin-right-arrow</b></li>\r\n      <li><i class=\"ico-thin-left-arrow\"></i> <b>ico-thin-left-arrow</b></li>\r\n      <li><i class=\"ico-bluetooth\"></i> <b>ico-bluetooth</b></li>\r\n      <li><i class=\"ico-euro\"></i> <b>ico-euro</b></li>\r\n      <li><i class=\"ico-usd\"></i> <b>ico-usd</b></li>\r\n      <li><i class=\"ico-bp\"></i> <b>ico-bp</b></li>\r\n      <li><i class=\"ico-retweet\"></i> <b>ico-retweet</b></li>\r\n      <li><i class=\"ico-moon\"></i> <b>ico-moon</b></li>\r\n      <li><i class=\"ico-sun\"></i> <b>ico-sun</b></li>\r\n      <li><i class=\"ico-cloud\"></i> <b>ico-cloud</b></li>\r\n      <li><i class=\"ico-direction\"></i> <b>ico-directio</b></li>\r\n      <li><i class=\"ico-brush\"></i> <b>ico-brush</b></li>\r\n      <li><i class=\"ico-pen\"></i> <b>ico-pen</b></li>\r\n      <li><i class=\"ico-zoom-in\"></i> <b>ico-zoom-in</b></li>\r\n      <li><i class=\"ico-zoom-out\"></i> <b>ico-zoom-out</b></li>\r\n      <li><i class=\"ico-pin\"></i> <b>ico-pin</b></li>\r\n      <li><i class=\"ico-riflescope\"></i> <b>ico-riflescope</b></li>\r\n      <li><i class=\"ico-rotation-lock\"></i> <b>ico-rotation-lock</b></li>\r\n      <li><i class=\"ico-flash\"></i> <b>ico-flash</b></li>\r\n      <li><i class=\"ico-google-maps\"></i> <b>ico-google-maps</b></li>\r\n      <li><i class=\"ico-anchor\"></i> <b>ico-anchor</b></li>\r\n      <li><i class=\"ico-conversation\"></i> <b>ico-conversation</b></li>\r\n      <li><i class=\"ico-chat\"></i> <b>ico-chat</b></li>\r\n      <li><i class=\"ico-male\"></i> <b>ico-male</b></li>\r\n      <li><i class=\"ico-female\"></i> <b>ico-female</b></li>\r\n      <li><i class=\"ico-asterisk\"></i> <b>ico-asterisk</b></li>\r\n      <li><i class=\"ico-divide\"></i> <b>ico-divide</b></li>\r\n      <li><i class=\"ico-snorkel-diving\"></i> <b>ico-snorkel-diving</b></li>\r\n      <li><i class=\"ico-scuba-diving\"></i> <b>ico-scuba-diving</b></li>\r\n      <li><i class=\"ico-oxygen-vottle\"></i> <b>ico-oxygen-vottle</b></li>\r\n      <li><i class=\"ico-fins\"></i> <b>ico-fins</b></li>\r\n      <li><i class=\"ico-fishes\"></i> <b>ico-fishes</b></li>\r\n      <li><i class=\"ico-boat\"></i> <b>ico-boat</b></li>\r\n      <li><i class=\"ico-delete-point\"></i> <b>ico-delete-point</b></li>\r\n      <li><i class=\"ico-sheriffs-star\"></i> <b>ico-sheriffs-star</b></li>\r\n      <li><i class=\"ico-qrcode\"></i> <b>ico-qrcode</b></li>\r\n      <li><i class=\"ico-barcode\"></i> <b>ico-barcode\"</b></li>\r\n      <li><i class=\"ico-pool\"></i> <b>ico-pool</b></li>\r\n      <li><i class=\"ico-buoy\"></i> <b>ico-buoy</b></li>\r\n      <li><i class=\"ico-spade\"></i> <b>ico-spade</b></li>\r\n      <li><i class=\"ico-bank\"></i> <b>ico-bank</b></li>\r\n      <li><i class=\"ico-vcard\"></i> <b>ico-vcard</b></li>\r\n      <li><i class=\"ico-electircal-plug\"></i> <b>ico-electircal-plug</b></li>\r\n      <li><i class=\"ico-flag\"></i> <b>ico-flag</b></li>\r\n      <li><i class=\"ico-credit-card\"></i> <b>ico-credit-card</b></li>\r\n      <li><i class=\"ico-keyboard-wirelsss\"></i> <b>ico-keyboard-wirelsss</b></li>\r\n      <li><i class=\"ico-keyboard-wired\"></i> <b>ico-keyboard-wired</b></li>\r\n    </ul>	\r\n  </div>\r\n\r\n  <div class=\"four columns\">\r\n    <ul class=\"the-icons\">\r\n      <li><i class=\"ico-shield\"></i> <b>ico-shield</b></li>\r\n      <li><i class=\"ico-ring\"></i> <b>ico-ring</b></li>\r\n      <li><i class=\"ico-cake\"></i> <b>ico-cake</b></li>\r\n      <li><i class=\"ico-drink\"></i> <b>ico-drink</b></li>\r\n      <li><i class=\"ico-beer\"></i> <b>ico-beer</b></li>\r\n      <li><i class=\"ico-fast-food\"></i> <b>ico-fast-food</b></li>\r\n      <li><i class=\"ico-cutlery\"></i> <b>ico-cutlery</b></li>\r\n      <li><i class=\"ico-pizza\"></i> <b>ico-pizza</b></li>\r\n      <li><i class=\"ico-birthday-cake\"></i> <b>ico-birthday-cake</b></li>\r\n      <li><i class=\"ico-tablet\"></i> <b>ico-tablet</b></li>\r\n      <li><i class=\"ico-settings\"></i> <b>ico-settings</b></li>\r\n      <li><i class=\"ico-bullets\"></i> <b>ico-bullets</b></li>\r\n      <li><i class=\"ico-cardio\"></i> <b>ico-cardio</b></li>\r\n      <li><i class=\"ico-t-shirt\"></i> <b>ico-t-shirt</b></li>\r\n      <li><i class=\"ico-pants\"></i> <b>ico-pants</b></li>\r\n      <li><i class=\"ico-sweater\"></i> <b>ico-sweater</b></li>\r\n      <li><i class=\"ico-fabric\"></i> <b>ico-fabric</b></li>\r\n      <li><i class=\"ico-leather\"></i> <b>ico-leather</b></li>\r\n      <li><i class=\"ico-scissors\"></i> <b>ico-scissors</b></li>\r\n      <li><i class=\"ico-podium\"></i> <b>ico-podium</b></li>\r\n      <li><i class=\"ico-skull\"></i> <b>ico-skull</b></li>\r\n      <li><i class=\"ico-celebration\"></i> <b>ico-celebratio</b></li>\r\n      <li><i class=\"ico-tea-kettle\"></i> <b>ico-tea-kettle</b></li>\r\n      <li><i class=\"ico-french-press\"></i> <b>ico-french-press</b></li>\r\n      <li><i class=\"ico-coffe-cup\"></i> <b>ico-coffe-cup</b></li>\r\n      <li><i class=\"ico-pot\"></i> <b>ico-pot</b></li>\r\n      <li><i class=\"ico-grater\"></i> <b>ico-grater</b></li>\r\n      <li><i class=\"ico-kettle\"></i> <b>ico-kettle</b></li>\r\n      <li><i class=\"ico-hospital\"></i> <b>ico-hospital</b></li>\r\n      <li><i class=\"ico-hospital-h\"></i> <b>ico-hospital-h</b></li>\r\n      <li><i class=\"ico-microphone\"></i> <b>ico-microphone</b></li>\r\n      <li><i class=\"ico-webcam\"></i> <b>ico-webcam</b></li>\r\n      <li><i class=\"ico-temple-church\"></i> <b>ico-temple-church</b></li>\r\n      <li><i class=\"ico-temple-islam\"></i> <b>ico-temple-islam</b></li>\r\n      <li><i class=\"ico-temple-hindu\"></i> <b>ico-temple-hindu</b></li>\r\n      <li><i class=\"ico-temple-buddhist\"></i> <b>ico-temple-buddhist</b></li>\r\n      <li><i class=\"ico-electrical-socket-eu\"></i> <b>ico-electrical-socket-eu</b></li>\r\n      <li><i class=\"ico-electrical-socket-us\"></i> <b>ico-electrical-socket-us</b></li>\r\n      <li><i class=\"ico-bomb\"></i> <b>ico-bomb</b></li>\r\n      <li><i class=\"ico-comments\"></i> <b>ico-comments</b></li>\r\n      <li><i class=\"ico-flower\"></i> <b>ico-flower</b></li>\r\n      <li><i class=\"ico-baseball\"></i> <b>ico-baseball</b></li>\r\n      <li><i class=\"ico-rugby\"></i> <b>ico-rugby</b></li>\r\n      <li><i class=\"ico-ax\"></i> <b>ico-ax</b></li>\r\n      <li><i class=\"ico-table-tennis\"></i> <b>ico-table-tennis</b></li>\r\n      <li><i class=\"ico-bowling\"></i> <b>ico-bowling\"</b></li>\r\n      <li><i class=\"ico-tree-conifer\"></i> <b>ico-tree-conifer</b></li>\r\n      <li><i class=\"ico-tree-deciduous\"></i> <b>ico-tree-deciduous</b></li>\r\n      <li><i class=\"ico-more-items\"></i> <b>ico-more-items</b></li>\r\n      <li><i class=\"ico-sort\"></i> <b>ico-sort</b></li>\r\n      <li><i class=\"ico-filter\"></i> <b>icofilter-</b></li>\r\n      <li><i class=\"ico-gamepad\"></i> <b>ico-gamepad</b></li>\r\n      <li><i class=\"ico-playing-dices\"></i> <b>ico-playing-dices</b></li>\r\n      <li><i class=\"ico-calculator\"></i> <b>ico-calculator</b></li>\r\n      <li><i class=\"ico-tie\"></i> <b>ico-tie</b></li>\r\n      <li><i class=\"ico-wallet\"></i> <b>ico-wallet</b></li>\r\n      <li><i class=\"ico-share\"></i> <b>ico-share</b></li>\r\n      <li><i class=\"ico-sampler\"></i> <b>ico-sampler</b></li>\r\n      <li><i class=\"ico-piano\"></i> <b>ico-piano</b></li>\r\n      <li><i class=\"ico-web-browser\"></i> <b>ico-web-browser</b></li>\r\n      <li><i class=\"ico-blog\"></i> <b>ico-blog</b></li>\r\n      <li><i class=\"ico-dashboard\"></i> <b>ico-dashboard</b></li>\r\n      <li><i class=\"ico-certificate\"></i> <b>ico-certificate</b></li>\r\n      <li><i class=\"ico-bell\"></i> <b>ico-bell</b></li>\r\n      <li><i class=\"ico-candle\"></i> <b>ico-candle</b></li>\r\n      <li><i class=\"ico-pin-classic\"></i> <b>ico-pin-classic</b></li>\r\n      <li><i class=\"ico-iphone-shake\"></i> <b>ico-iphone-shake</b></li>\r\n      <li><i class=\"ico-pin-flag\"></i> <b>ico-pin-flag</b></li>\r\n      <li><i class=\"ico-turtle\"></i> <b>ico-turtle</b></li>\r\n      <li><i class=\"ico-rabbit\"></i> <b>ico-rabbit</b></li>\r\n      <li><i class=\"ico-globe\"></i> <b>ico-globe</b></li>\r\n      <li><i class=\"ico-briefcase\"></i> <b>ico-briefcase</b></li>\r\n      <li><i class=\"ico-hdd\"></i> <b>ico-hdd</b></li>\r\n      <li><i class=\"ico-thumbs-up\"></i> <b>ico-thumbs-up</b></li>\r\n      <li><i class=\"ico-thumbs-down\"></i> <b>ico-thumbs-down</b></li>\r\n      <li><i class=\"ico-hand-right\"></i> <b>ico-hand-right</b></li>\r\n      <li><i class=\"ico-hand-left\"></i> <b>ico--hand-left</b></li>\r\n      <li><i class=\"ico-hand-up\"></i> <b>ico-hand-up</b></li>\r\n      <li><i class=\"ico-hand-down\"></i> <b>ico-hand-down</b></li>\r\n      <li><i class=\"ico-fullscreen\"></i> <b>ico-fullscreen</b></li>\r\n      <li><i class=\"ico-shopping-bag\"></i> <b>ico-shopping-bag</b></li>\r\n      <li><i class=\"ico-book-open\"></i> <b>ico-book-open</b></li>\r\n      <li><i class=\"ico-nameplate\"></i> <b>ico-nameplate</b></li>\r\n      <li><i class=\"ico-nameplate-alt\"></i> <b>ico-nameplate-alt</b></li>\r\n      <li><i class=\"ico-vases\"></i> <b>ico-vases</b></li>\r\n      <li><i class=\"ico-announcement\"></i> <b>ico-announcement</b></li>\r\n      <li><i class=\"ico-dumbbell\"></i> <b>ico-dumbbell</b></li>\r\n      <li><i class=\"ico-suitcase\"></i> <b>ico-suitcase</b></li>\r\n      <li><i class=\"ico-file-import\"></i> <b>ico-file-import</b></li>\r\n      <li><i class=\"ico-file-export\"></i> <b>ico-file-export</b></li>\r\n    </ul>	\r\n  </div>\r\n</div>','','full_html'),('node','page',0,13,13,'und',0,'<div class=\"container\">\r\n\r\n  <!-- 16 Columns -->\r\n  <div class=\"sixteen columns\">\r\n    <div class=\"headline no-margin\"><h3>16 Columns</h3></div>\r\n    <p>Cras consequat porttitor tincidunt. Praesent eu tincidunt lacus. Donec ut neque vitae erat congue venenatis. Duis hendrerit lacinia leo in dignissim. Aliquam erat volutpat. Sed dignissim hendrerit nibh, quis faucibus erat cursus eget. Integer porta nisl vitae felis rutrum ut mollis felis congue. Vestibulum augue nisl, egestas eu rhoncus eu, fermentum in leo. Pellentesque ultricies pharetra nulla sit amet sagittis. Curabitur at feugiat nibh. Duis sit amet odio eros. Donec non purus non augue cursus convallis sed id purus. In fringilla luctus scelerisque. Donec mauris magna, iaculis non suscipit eu, pellentesque nec urna.</p>\r\n  </div>\r\n  <!-- 16 Columns End -->\r\n\r\n</div>\r\n<!-- 960 Container End -->\r\n\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <!-- 1/2 Columns -->\r\n  <div class=\"eight columns\">\r\n    <div class=\"headline\"><h3>8 Columns</h3></div>\r\n    <p>Praesent ut ante id metus sollicitudin sodales. Mauris dictum, lorem quis pretium feugiat, nibh metus ultricies quam, nec venenatis dolor dolor at massa. Aliquam aliquet quam augue feugiat in lore ipsum dolor sit amet convallis magna suscipit.</p>\r\n  </div>\r\n\r\n  <div class=\"eight columns\">\r\n    <div class=\"headline\"><h3>8 Columns</h3></div>\r\n    <p>Praesent ut ante id metus sollicitudin sodales. Mauris dictum, lorem quis pretium feugiat, nibh metus ultricies quam, nec venenatis dolor dolor at massa. Aliquam aliquet quam augue feugiat in lore ipsum dolor sit amet convallis magna suscipit.</p>\r\n  </div>\r\n  <!-- 1/2 Columns End -->\r\n\r\n</div>\r\n<!-- 960 Container End -->\r\n\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <!-- 1/3 Columns -->\r\n  <div class=\"one-third column\">\r\n    <div class=\"headline\"><h3>1/3 Column</h3></div>\r\n    <p>Cras semper facilisis vestibulum. Nam purus magna, venenatis a mollis at, lacinia id lacus. Quisque metus arcu, condimentum vitae dignissim at, condimentum id dui. Fusce at dui metus. Nulla in purus in mauris luctus gravida vel vitae arcu Magna nisi. Integer ut risus nulla.</p>\r\n  </div>\r\n\r\n  <div class=\"one-third column\">\r\n    <div class=\"headline\"><h3>1/3 Column</h3></div>\r\n    <p>Cras semper facilisis vestibulum. Nam purus magna, venenatis a mollis at, lacinia id lacus. Quisque metus arcu, condimentum vitae dignissim at, condimentum id dui. Fusce at dui metus. Nulla in purus in mauris luctus gravida vel vitae arcu Magna nisi. Integer ut risus nulla.</p>\r\n  </div>\r\n\r\n  <div class=\"one-third column\">\r\n    <div class=\"headline\"><h3>1/3 Column</h3></div>\r\n    <p>Cras semper facilisis vestibulum. Nam purus magna, venenatis a mollis at, lacinia id lacus. Quisque metus arcu, condimentum vitae dignissim at, condimentum id dui. Fusce at dui metus. Nulla in purus in mauris luctus gravida vel vitae arcu Magna nisi. Integer ut risus nulla.</p>\r\n  </div>\r\n  <!-- 1/3 Columns End -->\r\n\r\n</div>\r\n<!-- 960 Container End -->\r\n\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <!-- 1/4 Columns End -->\r\n  <div class=\"four columns\">\r\n    <div class=\"headline\"><h3>1/4 Column</h3></div>\r\n    <p>Magna nisi. Integer ut risus nulla. Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas. Nullam vitae neque luctus dolor pulvinar condimentum nec sed.</p>\r\n  </div>\r\n\r\n  <div class=\"four columns\">\r\n    <div class=\"headline\"><h3>1/4 Column</h3></div>\r\n    <p>Magna nisi. Integer ut risus nulla. Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas. Nullam vitae neque luctus dolor pulvinar condimentum nec sed.</p>\r\n  </div>\r\n\r\n  <div class=\"four columns\">\r\n    <div class=\"headline\"><h3>1/4 Column</h3></div>\r\n    <p>Magna nisi. Integer ut risus nulla. Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas. Nullam vitae neque luctus dolor pulvinar condimentum nec sed.</p>\r\n  </div>\r\n\r\n  <div class=\"four columns\">\r\n    <div class=\"headline\"><h3>1/4 Column</h3></div>\r\n    <p>Magna nisi. Integer ut risus nulla. Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas. Nullam vitae neque luctus dolor pulvinar condimentum nec sed.</p>\r\n  </div>\r\n  <!-- 1/4 Columns End -->\r\n\r\n</div>\r\n<!-- 960 Container End -->\r\n\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <!-- 12 Columns -->\r\n  <div class=\"twelve columns\">\r\n    <div class=\"headline\"><h3>12 Columns</h3></div>\r\n    <p>Sed at odio ut arcu fringilla dictum eu eu nisl. Donec rutrum erat non arcu gravida porttitor. Nunc et magna nisi.Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas. Maecenas ut nulla quis eros scelerisque posuere vel vitae nibh. Proin id condimentum sem. Morbi vitae dui in magna vestibulum suscipit vitae vel nunc. Integer ut risus nulla. malesuada tortor, nec scelerisque lorem mattis  lore Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas nullam vitae neque luctus dolor.</p>\r\n  </div>\r\n\r\n  <div class=\"four columns\">\r\n    <div class=\"headline\"><h3>4 Columns</h3></div>\r\n    <p>Magna nisi. Integer ut risus nulla lorem. Aliquam at erat in purus aliquet mollis nullam vitae pulvinar condimentum nec aiquam at erat in purus aliquet mollis lorem ipsum dolor sed.</p>\r\n  </div>\r\n\r\n</div>','','full_html'),('node','page',0,14,14,'und',0,'<div class=\"container\">\r\n\r\n  <!-- Standard Structure -->\r\n  <div class=\"two-thirds column\">\r\n    <div class=\"headline no-margin\"><h4>Our Approach</h4></div>\r\n    <p>Donec odio ut arcu fringilla dictum eu eu nisl. Donec rutrum erat non arcu gravida porttitor. Nunc et magna nisi.Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas. Maecenas ut nulla quis eros scelerisque posuere vel vitae nibh. Proin id condimentum sem. Morbi vitae dui in magna vestibulum suscipit vitae vel nunc. Integer ut risus nulla. malesuada tortor, nec scelerisque lorem mattis.</p>\r\n    <p>Nunc et rutrum consetetur sadipscing elitr, sed diam nonumy at volutpat. Sed consectetur suscipit lorem nunc.adipiscing elit. Integer commodo tristique odio, quis fringilla ligula aliquet ut. Maecenas sed justo varius velit imperdiet bibendum</p>\r\n    <p>Integer commodo tristique odio, quis fringilla ligula aliquet ut. Maecenas sed justo varius velit imperdiet bibendum. Vivamus nec sapien massa, a imperdiet diam. Aliquam erat volutpat. Sed tetur suscipit nunc et rutrum. </p>\r\n  </div>\r\n\r\n  <div class=\"one-third column\">\r\n    <div class=\"headline no-margin\"><h4>Careers</h4></div>\r\n\r\n    <!-- Large Notice -->\r\n    <div class=\"large-notice\">\r\n      <h2>We\'re Hiring</h2>\r\n      <p>We\'re offering great oppurtunites for Project Manager and Web Designer.</p>\r\n      <a href=\"#\" class=\"button medium color\">Apply</a>\r\n    </div>\r\n    </p>\r\n  </div>\r\n  <!-- Standard Structure End -->\r\n\r\n\r\n  <div class=\"sixteen columns\">\r\n    <div class=\"headline low-margin\"><h4>Meet the Team</h4></div>\r\n  </div>\r\n\r\n  <!-- About -->\r\n  <div class=\"one-third column\">\r\n    <img src=\"/sites/all/themes/centum/images/about-01.png\" alt=\"\"/>\r\n    <div class=\"team-name\"><h5>Jane Smith</h5> <span>Chief Executive Officer / CEO</span></div>\r\n    <div class=\"team-about\"><p>Consectetur dolor ipsum quiam dolor adipisci velit, aenean at lorem vel est posuere feugiat sed quia noneas numquasa mode tempora incidunt ipsum.</p></div>\r\n\r\n    <!-- Social Icons -->\r\n    <ul class=\"social-icons about\">\r\n      <li class=\"facebook\"><a href=\"#\">Facebook</a></li>\r\n      <li class=\"linkedin\"><a href=\"#\">LinkedIn</a></li>\r\n      <li class=\"googleplus\"><a href=\"#\">Google Plus</a></li>\r\n    </ul>\r\n\r\n  </div>\r\n\r\n  <!-- About -->\r\n  <div class=\"one-third column\">\r\n    <div class=\"clear\"></div>\r\n    <img src=\"/sites/all/themes/centum/images/about-01.png\" alt=\"\"/>\r\n    <div class=\"team-name\"><h5>John Doe</h5> <span>Web Designer</span></div>\r\n    <div class=\"team-about\"><p>Consectetur dolor ipsum quiam dolor adipisci velit, aenean at lorem vel est posuere feugiat sed quia noneas numquasa mode tempora incidunt ipsum.</p></div>\r\n\r\n    <!-- Social Icons -->\r\n    <ul class=\"social-icons about\">\r\n      <li class=\"facebook\"><a href=\"#\">Facebook</a></li>\r\n      <li class=\"linkedin\"><a href=\"#\">LinkedIn</a></li>\r\n      <li class=\"forrst\"><a href=\"#\">Forrst</a></li>\r\n      <li class=\"dribbble\"><a href=\"#\">Dribbble</a></li>\r\n    </ul>\r\n\r\n  </div>\r\n\r\n  <!-- About -->\r\n  <div class=\"one-third column\">\r\n    <img src=\"/sites/all/themes/centum/images/about-01.png\" alt=\"\"/>\r\n    <div class=\"team-name\"><h5>Michael Smith</h5> <span>Project Manager</span></div>\r\n    <div class=\"team-about\"><p>Consectetur dolor ipsum quiam dolor adipisci velit, aenean at lorem vel est posuere feugiat sed quia noneas numquasa mode tempora incidunt ipsum.</p></div>\r\n\r\n    <!-- Social Icons -->\r\n    <ul class=\"social-icons about\">\r\n      <li class=\"facebook\"><a href=\"#\">Facebook</a></li>\r\n      <li class=\"linkedin\"><a href=\"#\">LinkedIn</a></li>\r\n      <li class=\"blogger\"><a href=\"#\">Blogger</a></li>\r\n      <li class=\"googleplus\"><a href=\"#\">Google Plus</a></li>\r\n      <li class=\"pintrest\"><a href=\"#\">Pintrest</a></li>\r\n    </ul>\r\n\r\n  </div>\r\n\r\n</div>\r\n<!-- 960 Container End -->','','full_html'),('node','page',0,15,15,'und',0,'<div class=\"container\">\r\n\r\n  <div class=\"sixteen columns\">\r\n    <div class=\"notification notice closeable\" style=\"margin: 5px 0 25px 0;\">\r\n      <p>If you\'re looking for service which isn\'t listed below, please send us a message!</p>\r\n    </div>\r\n  </div>\r\n\r\n  <div class=\"two-thirds column\">\r\n    <div class=\"headline no-margin\"><h4>Methodology</h4></div>\r\n\r\n    <div class=\"one-third column alpha\">\r\n      <p>Donec rutrum erat non arcu gravida porttitor. Nunc et magna nisi.Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas. Maecenas ut nulla quis eros scelerisque posuere vel vitae nibh. Proin id condimentum sem. Morbi vitae dui in magna vestibulum suscipit vitae vel nunc. </p>\r\n    </div>\r\n\r\n    <div class=\"one-third column alpha\">\r\n      <p>Nunc et rutrum consetetur sadipscing elitr, sed diam nonumy at volutpat. Sed consectetur suscipit lorem nunc.adipiscing elit. Integer commodo tristique odio, quis fringilla ligula aliquet ut. Maecenas sed justo varius velit imperdietAliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis.</p>\r\n    </div>\r\n  </div>\r\n\r\n  <div class=\"one-third column\">\r\n    <div class=\"headline no-margin\"><h4>Features</h4></div>\r\n\r\n    <ul class=\"check_list\">\r\n      <li>Quick and convenient Localization Support</li>\r\n      <li>Compatible with the latest W3C standards</li>\r\n      <li>Flexible, Responsive Layout</li>\r\n      <li>Compatible with Major Browsers</li>\r\n      <li>Attuned to Smartphones and Tablet PCs</li>\r\n    </ul>\r\n    </p>\r\n  </div>\r\n\r\n  <div class=\"sixteen columns\">\r\n    <div class=\"headline low-margin\"><h4>Services</h4></div>\r\n  </div>\r\n\r\n  <!-- Icon Box Container -->\r\n  <div class=\"icon-boxes-container\">\r\n\r\n    <!-- Icon Box Start -->\r\n    <div class=\"eight columns\">\r\n      <div class=\"icon-box\">\r\n        <i class=\"ico-stats\" style=\"margin-left: -12px;\"></i>\r\n        <h3>Web Usability</h3>\r\n        <p>Proin iaculis purus consequat sem cure digni ssim. Donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt. Mauris ut ligula tortorea lorem ipsum dolor sit amet gorbi vel nulla eget quam porttitor gravida.</p>\r\n      </div>\r\n    </div>\r\n    <!-- Icon Box End -->\r\n\r\n    <!-- Icon Box Start -->\r\n    <div class=\"eight columns\">\r\n      <div class=\"icon-box\">\r\n        <i class=\"ico-thumbs-up\"></i>\r\n        <h3>Social Marketing</h3>\r\n        <p>Proin iaculis purus consequat sem cure digni ssim. Donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt. Mauris ut ligula tortorea lorem ipsum dolor sit amet gorbi vel nulla eget quam porttitor gravida.</p>\r\n      </div>\r\n    </div>\r\n    <!-- Icon Box End -->\r\n\r\n  </div>\r\n  <!-- Icon Box Container / End -->\r\n\r\n  <!-- Icon Box Container -->\r\n  <div class=\"icon-boxes-container\">\r\n\r\n    <!-- Icon Box Start -->\r\n    <div class=\"eight columns\">\r\n      <div class=\"icon-box\">\r\n        <i class=\"ico-display\" style=\"margin-left: -10px;\"></i>\r\n        <h3>Web Design</h3>\r\n        <p>Proin iaculis purus consequat sem cure digni ssim. Donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt. Mauris ut ligula tortorea lorem ipsum dolor sit amet gorbi vel nulla eget quam porttitor gravida.</p>\r\n      </div>\r\n    </div>\r\n    <!-- Icon Box End -->\r\n\r\n    <!-- Icon Box Start -->\r\n    <div class=\"eight columns\">\r\n      <div class=\"icon-box\">\r\n        <i class=\"ico-film\"></i>\r\n        <h3>Video Recording</h3>\r\n        <p>Proin iaculis purus consequat sem cure digni ssim. Donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt. Mauris ut ligula tortorea lorem ipsum dolor sit amet gorbi vel nulla eget quam porttitor gravida.</p>\r\n      </div>\r\n    </div>\r\n    <!-- Icon Box End -->\r\n\r\n  </div>\r\n  <!-- Icon Box Container / End -->\r\n\r\n\r\n</div>\r\n<!-- 960 Container End -->\r\n\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n  <div class=\"sixteen columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h4>Our Clients</h4></div>\r\n\r\n    <ul class=\"client-list\">\r\n      <li><img src=\"/sites/all/themes/centum/images/logo-01.png\" alt=\"\"/></li>\r\n      <li><img src=\"/sites/all/themes/centum/images/logo-02.png\" alt=\"\"/></li>\r\n      <li><img src=\"/sites/all/themes/centum/images/logo-03.png\" alt=\"\"/></li>\r\n      <li><img src=\"/sites/all/themes/centum/images/logo-04.png\" alt=\"\"/></li>\r\n      <li><img src=\"/sites/all/themes/centum/images/logo-05.png\" alt=\"\"/></li>\r\n    </ul>\r\n\r\n  </div>\r\n</div>','','full_html'),('node','page',0,16,16,'und',0,'<div class=\"container\">\r\n\r\n  <div class=\"sixteen columns\">\r\n\r\n    <div class=\"headline no-margin\">\r\n      <h4>Four Tables</h4>\r\n    </div>\r\n\r\n    <!-- Number of Tables / From 2 to 5 / -->\r\n    <div class=\"four-tables\">\r\n\r\n      <div class=\"pricing-table\">\r\n        <div class=\"color-1\">\r\n          <h3>Standard</h3>\r\n          <h4><span class=\"price\">$9.99</span> <span class=\"time\">per month</span></h4>\r\n          <ul>\r\n            <li>5 GB Storage</li>\r\n            <li>Free Live Support</li>\r\n            <li>Unlimited Users</li>\r\n            <li>No Time Tracking</li>\r\n            <li>Enhanced SSL Security</li>\r\n          </ul>\r\n          <a href=\"#\" class=\"sign-up\"><span>Sign Up</span></a>\r\n        </div>\r\n      </div>\r\n\r\n      <div class=\"pricing-table\">\r\n        <div class=\"color-2\">\r\n          <h3>Premium</h3>\r\n          <h4><span class=\"price\">$29.99</span> <span class=\"time\">per month</span></h4>\r\n          <ul>\r\n            <li>25 GB Storage</li>\r\n            <li>Free Live Support</li>\r\n            <li>Unlimited Users</li>\r\n            <li>No Time Tracking</li>\r\n            <li>Enhanced SSL Security</li>\r\n          </ul>\r\n          <a href=\"#\" class=\"sign-up\"><span>Sign Up</span></a>\r\n        </div>\r\n      </div>\r\n\r\n      <div class=\"pricing-table\">\r\n        <div class=\"color-3\">\r\n          <h3>Professional</h3>\r\n          <h4><span class=\"price\">$49.99</span> <span class=\"time\">per month</span></h4>\r\n          <ul>\r\n            <li>50 GB Storage</li>\r\n            <li>Free Live Support</li>\r\n            <li>Unlimited Users</li>\r\n            <li>No Time Tracking</li>\r\n            <li>Enhanced SSL Security</li>\r\n          </ul>\r\n          <a href=\"#\" class=\"sign-up\"><span>Sign Up</span></a>\r\n        </div>\r\n      </div>\r\n\r\n      <div class=\"pricing-table\">\r\n        <div class=\"color-2\">\r\n          <h3>Ultimate</h3>\r\n          <h4><span class=\"price\">$99.99</span> <span class=\"time\">per month</span></h4>\r\n          <ul>\r\n            <li>100 GB Storage</li>\r\n            <li>Free Live Support</li>\r\n            <li>Unlimited Users</li>\r\n            <li>No Time Tracking</li>\r\n            <li>Enhanced SSL Security</li>\r\n          </ul>\r\n          <a href=\"#\" class=\"sign-up\"><span>Sign Up</span></a>\r\n        </div>\r\n      </div>\r\n\r\n    </div>\r\n\r\n  </div>\r\n\r\n</div>\r\n<!-- 960 Container / End -->\r\n\r\n\r\n<!-- Three Tables\r\n================================================== -->\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <div class=\"sixteen columns\">\r\n\r\n    <div class=\"headline\">\r\n      <h4>Three Tables</h4>\r\n    </div>\r\n\r\n    <!-- Number of Tables / From 2 to 5 / -->\r\n    <div class=\"three-tables\">\r\n\r\n      <div class=\"pricing-table\">\r\n        <div class=\"color-1\">\r\n          <h3>Standard</h3>\r\n          <h4><span class=\"price\">$9.99</span> <span class=\"time\">per month</span></h4>\r\n          <ul>\r\n            <li>5 GB Storage</li>\r\n            <li>Free Live Support</li>\r\n            <li>Unlimited Users</li>\r\n            <li>No Time Tracking</li>\r\n            <li>Enhanced SSL Security</li>\r\n          </ul>\r\n          <a href=\"#\" class=\"sign-up\"><span>Sign Up</span></a>\r\n        </div>\r\n      </div>\r\n\r\n      <div class=\"pricing-table\">\r\n        <div class=\"color-2\">\r\n          <h3>Premium</h3>\r\n          <h4><span class=\"price\">$29.99</span> <span class=\"time\">per month</span></h4>\r\n          <ul>\r\n            <li>25 GB Storage</li>\r\n            <li>Free Live Support</li>\r\n            <li>Unlimited Users</li>\r\n            <li>No Time Tracking</li>\r\n            <li>Enhanced SSL Security</li>\r\n          </ul>\r\n          <a href=\"#\" class=\"sign-up\"><span>Sign Up</span></a>\r\n        </div>\r\n      </div>\r\n\r\n      <div class=\"pricing-table\">\r\n        <div class=\"color-1\">\r\n          <h3>Professional</h3>\r\n          <h4><span class=\"price\">$49.99</span> <span class=\"time\">per month</span></h4>\r\n          <ul>\r\n            <li>50 GB Storage</li>\r\n            <li>Free Live Support</li>\r\n            <li>Unlimited Users</li>\r\n            <li>No Time Tracking</li>\r\n            <li>Enhanced SSL Security</li>\r\n          </ul>\r\n          <a href=\"#\" class=\"sign-up\"><span>Sign Up</span></a>\r\n        </div>\r\n      </div>\r\n\r\n    </div>\r\n\r\n  </div>\r\n\r\n</div>','','full_html');
/*!40000 ALTER TABLE `field_data_body` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_comment_body`
--

DROP TABLE IF EXISTS `field_data_comment_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_comment_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `comment_body_value` longtext,
  `comment_body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `comment_body_format` (`comment_body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 1 (comment_body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_comment_body`
--

LOCK TABLES `field_data_comment_body` WRITE;
/*!40000 ALTER TABLE `field_data_comment_body` DISABLE KEYS */;
INSERT INTO `field_data_comment_body` VALUES ('comment','comment_node_blog',0,1,1,'und',0,'Maecenas dignissim euismod nunc, in commodo est luctus eget. Proin in nunc laoreet justo volutpat blandit enim. Sem felis, ullamcorper vel aliquam non, varius eget justo. Duis quis nunc tellus. Mauris a felis arcu, vitae sollicitudin mauris. Aliquam quis tellus vel massa mattis ornare et eu felis. ','full_html'),('comment','comment_node_blog',0,2,2,'und',0,'Dignissim euismod nunc, in commodo est luctus eget. Proin in nunc laoreet justo volutpat blandit enim. Sem felis, ullamcorper vel aliquam non, varius eget justo. Duis quis nunc tellus. Mauris a felis arcu, vitae sollicitudin mauris. Aliquam quis tellus vel massa mattis.','full_html'),('comment','comment_node_blog',0,3,3,'und',0,'Morbi velit eros, sagittis in facilisis non, rhoncus et erat. Nam posuere tristique sem, eu ultricies tortor imperdiet vitae. Curabitur lacinia neque non metus','full_html');
/*!40000 ALTER TABLE `field_data_comment_body` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_image`
--

DROP TABLE IF EXISTS `field_data_field_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_image` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_image_fid` int(10) unsigned DEFAULT NULL COMMENT 'The file_managed.fid being referenced in this field.',
  `field_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image’s ’alt’ attribute.',
  `field_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image’s ’title’ attribute.',
  `field_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_image_fid` (`field_image_fid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 4 (field_image)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_image`
--

LOCK TABLES `field_data_field_image` WRITE;
/*!40000 ALTER TABLE `field_data_field_image` DISABLE KEYS */;
INSERT INTO `field_data_field_image` VALUES ('node','blog',0,1,1,'und',0,1,'','',900,558),('node','blog',0,2,2,'und',0,2,'','',900,600),('node','blog',0,2,2,'und',1,3,'','',948,632),('node','blog',0,3,3,'und',0,4,'','',900,558),('node','blog',0,3,3,'und',1,5,'','',948,632),('node','portfolio',0,4,4,'und',0,8,'','',940,450),('node','portfolio',0,5,5,'und',0,10,'','',940,450),('node','portfolio',0,5,5,'und',1,9,'','',940,450),('node','portfolio',0,6,6,'und',0,11,'','',940,473),('node','portfolio',0,6,6,'und',1,12,'','',940,473),('node','portfolio',0,7,7,'und',0,13,'','',940,473),('node','portfolio',0,7,7,'und',1,14,'','',940,473),('node','portfolio',0,8,8,'und',0,15,'','',896,473),('node','portfolio',0,9,9,'und',0,16,'','',940,473),('node','portfolio',0,10,10,'und',0,17,'','',940,473),('node','portfolio',0,10,10,'und',1,18,'','',940,473),('node','portfolio',0,11,11,'und',0,19,'','',940,473),('node','portfolio',0,11,11,'und',1,20,'','',940,473);
/*!40000 ALTER TABLE `field_data_field_image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_portfolio_category`
--

DROP TABLE IF EXISTS `field_data_field_portfolio_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_portfolio_category` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_portfolio_category_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_portfolio_category_tid` (`field_portfolio_category_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 5 (field_portfolio_category)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_portfolio_category`
--

LOCK TABLES `field_data_field_portfolio_category` WRITE;
/*!40000 ALTER TABLE `field_data_field_portfolio_category` DISABLE KEYS */;
INSERT INTO `field_data_field_portfolio_category` VALUES ('node','portfolio',0,4,4,'und',0,7),('node','portfolio',0,4,4,'und',1,8),('node','portfolio',0,5,5,'und',0,8),('node','portfolio',0,5,5,'und',1,9),('node','portfolio',0,6,6,'und',0,9),('node','portfolio',0,6,6,'und',1,10),('node','portfolio',0,7,7,'und',0,7),('node','portfolio',0,7,7,'und',1,8),('node','portfolio',0,8,8,'und',0,8),('node','portfolio',0,8,8,'und',1,9),('node','portfolio',0,9,9,'und',0,9),('node','portfolio',0,9,9,'und',1,10),('node','portfolio',0,10,10,'und',0,9),('node','portfolio',0,10,10,'und',1,10),('node','portfolio',0,11,11,'und',0,9),('node','portfolio',0,11,11,'und',1,10);
/*!40000 ALTER TABLE `field_data_field_portfolio_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_portfolio_client`
--

DROP TABLE IF EXISTS `field_data_field_portfolio_client`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_portfolio_client` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_portfolio_client_value` varchar(255) DEFAULT NULL,
  `field_portfolio_client_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_portfolio_client_format` (`field_portfolio_client_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 7 (field_portfolio_client)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_portfolio_client`
--

LOCK TABLES `field_data_field_portfolio_client` WRITE;
/*!40000 ALTER TABLE `field_data_field_portfolio_client` DISABLE KEYS */;
INSERT INTO `field_data_field_portfolio_client` VALUES ('node','portfolio',0,4,4,'und',0,'Google',NULL),('node','portfolio',0,5,5,'und',0,'Envato',NULL),('node','portfolio',0,6,6,'und',0,'Google',NULL),('node','portfolio',0,7,7,'und',0,'Google',NULL),('node','portfolio',0,8,8,'und',0,'Google',NULL),('node','portfolio',0,9,9,'und',0,'Google',NULL),('node','portfolio',0,10,10,'und',0,'Envato',NULL),('node','portfolio',0,11,11,'und',0,'Google',NULL);
/*!40000 ALTER TABLE `field_data_field_portfolio_client` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_portfolio_link`
--

DROP TABLE IF EXISTS `field_data_field_portfolio_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_portfolio_link` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_portfolio_link_value` varchar(255) DEFAULT NULL,
  `field_portfolio_link_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_portfolio_link_format` (`field_portfolio_link_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 6 (field_portfolio_link)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_portfolio_link`
--

LOCK TABLES `field_data_field_portfolio_link` WRITE;
/*!40000 ALTER TABLE `field_data_field_portfolio_link` DISABLE KEYS */;
INSERT INTO `field_data_field_portfolio_link` VALUES ('node','portfolio',0,4,4,'und',0,'http://tabvn.com',NULL),('node','portfolio',0,5,5,'und',0,'http://tabvn.com',NULL),('node','portfolio',0,6,6,'und',0,'http://tabvn.com',NULL),('node','portfolio',0,7,7,'und',0,'http://tabvn.com',NULL),('node','portfolio',0,8,8,'und',0,'http://tabvn.com',NULL),('node','portfolio',0,9,9,'und',0,'http://tabvn.com',NULL),('node','portfolio',0,10,10,'und',0,'http://tabvn.com',NULL),('node','portfolio',0,11,11,'und',0,'http://tabvn.com',NULL);
/*!40000 ALTER TABLE `field_data_field_portfolio_link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_data_field_tags`
--

DROP TABLE IF EXISTS `field_data_field_tags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_data_field_tags` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned DEFAULT NULL COMMENT 'The entity revision id this data is attached to, or NULL if the entity type is not versioned',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_tags_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_tags_tid` (`field_tags_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Data storage for field 3 (field_tags)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_data_field_tags`
--

LOCK TABLES `field_data_field_tags` WRITE;
/*!40000 ALTER TABLE `field_data_field_tags` DISABLE KEYS */;
INSERT INTO `field_data_field_tags` VALUES ('node','blog',0,1,1,'und',0,1),('node','blog',0,1,1,'und',1,2),('node','blog',0,1,1,'und',2,3),('node','blog',0,2,2,'und',0,4),('node','blog',0,2,2,'und',1,5),('node','blog',0,2,2,'und',2,6),('node','blog',0,3,3,'und',0,1),('node','blog',0,3,3,'und',1,3);
/*!40000 ALTER TABLE `field_data_field_tags` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_body`
--

DROP TABLE IF EXISTS `field_revision_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `body_value` longtext,
  `body_summary` longtext,
  `body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `body_format` (`body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 2 (body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_body`
--

LOCK TABLES `field_revision_body` WRITE;
/*!40000 ALTER TABLE `field_revision_body` DISABLE KEYS */;
INSERT INTO `field_revision_body` VALUES ('node','blog',0,1,1,'und',0,'<p>Maecenas dolor est, interdum a euismod eu, accumsan posuere nisl. Nam sed iaculis massa. Sed nisl lectus, tempor sed euismod quis, sollicitudin nec est. Suspendisse dignissim bibendum tempor. Nam erat felis, commodo sed semper commodo vel mauris suspendisse dignissim bibendum tempus.</p><p>Sed auctor, sem et volutpat facilisis, risus leo venenatis leo, ultricies accumsan urna ante vel nisl. Integer feugiat risus nec nisl dictum vestibulum. Vestibulum nec purus orci. Mauris ornare dolor eget purus malesuada vitae convallis dui dapibus. Donec sed leo magna, ac pellentesque lorem. Vivamus sapien tortor, lobortis ut ultrices vel, tempus non metus. Suspendisse id est id elit commodo pellentesque non non lorem. Aenean sed blandit sapien. Nullam risus sapien, dignissim tempor auctor non, porta congue mi.</p><blockquote>Mauris aliquet ultricies ante, non faucibus ante gravida sed. Sed ultrices pellentesque purus, vulputate volutpat ipsum hendrerit sed neque sed sapien rutrum laoreet justo ultrices. In pellentesque lorem condimentum dui conse. Vivamus semper, mi sed congue semper, odio felis tristique neque, ac venenatis mauris augue.</blockquote><p>Cras varius enim ac tellus gravida aliquet. Praesent nec ante odio, at egestas lorem. Phasellus nec velit sit amet leo pellentesque tempor. Vivamus molestie fringilla nulla, at egestas magna tempor nec. Suspendisse potenti. Vivamus metus massa, viverra sit amet bibendum ac, consequat porta sem. Nullam venenatis faucibus sem. Donec non mi et felis iaculis tempor sed at dolor.</p>','','wysiwyg'),('node','blog',0,2,2,'und',0,'<p>Maecenas dolor est, interdum a euismod eu, accumsan posuere nisl. Nam sed iaculis massa. Sed nisl lectus, tempor sed euismod quis, sollicitudin nec est. Suspendisse dignissim bibendum tempor. Nam erat felis, commodo sed semper commodo vel mauris suspendisse dignissim bibendum tempus.</p><p>Sed auctor, sem et volutpat facilisis, risus leo venenatis leo, ultricies accumsan urna ante vel nisl. Integer feugiat risus nec nisl dictum vestibulum. Vestibulum nec purus orci. Mauris ornare dolor eget purus malesuada vitae convallis dui dapibus. Donec sed leo magna, ac pellentesque lorem. Vivamus sapien tortor, lobortis ut ultrices vel, tempus non metus. Suspendisse id est id elit commodo pellentesque non non lorem. Aenean sed blandit sapien. Nullam risus sapien, dignissim tempor auctor non, porta congue mi.</p><blockquote>Mauris aliquet ultricies ante, non faucibus ante gravida sed. Sed ultrices pellentesque purus, vulputate volutpat ipsum hendrerit sed neque sed sapien rutrum laoreet justo ultrices. In pellentesque lorem condimentum dui conse. Vivamus semper, mi sed congue semper, odio felis tristique neque, ac venenatis mauris augue.</blockquote><p>Cras varius enim ac tellus gravida aliquet. Praesent nec ante odio, at egestas lorem. Phasellus nec velit sit amet leo pellentesque tempor. Vivamus molestie fringilla nulla, at egestas magna tempor nec. Suspendisse potenti. Vivamus metus massa, viverra sit amet bibendum ac, consequat porta sem. Nullam venenatis faucibus sem. Donec non mi et felis iaculis tempor sed at dolor.</p>','','wysiwyg'),('node','blog',0,3,3,'und',0,'<p>Maecenas dolor est, interdum a euismod eu, accumsan posuere nisl. Nam sed iaculis massa. Sed nisl lectus, tempor sed euismod quis, sollicitudin nec est. Suspendisse dignissim bibendum tempor. Nam erat felis, commodo sed semper commodo vel mauris suspendisse dignissim bibendum tempus.</p><p>Sed auctor, sem et volutpat facilisis, risus leo venenatis leo, ultricies accumsan urna ante vel nisl. Integer feugiat risus nec nisl dictum vestibulum. Vestibulum nec purus orci. Mauris ornare dolor eget purus malesuada vitae convallis dui dapibus. Donec sed leo magna, ac pellentesque lorem. Vivamus sapien tortor, lobortis ut ultrices vel, tempus non metus. Suspendisse id est id elit commodo pellentesque non non lorem. Aenean sed blandit sapien. Nullam risus sapien, dignissim tempor auctor non, porta congue mi.</p><blockquote>Mauris aliquet ultricies ante, non faucibus ante gravida sed. Sed ultrices pellentesque purus, vulputate volutpat ipsum hendrerit sed neque sed sapien rutrum laoreet justo ultrices. In pellentesque lorem condimentum dui conse. Vivamus semper, mi sed congue semper, odio felis tristique neque, ac venenatis mauris augue.</blockquote><p>Cras varius enim ac tellus gravida aliquet. Praesent nec ante odio, at egestas lorem. Phasellus nec velit sit amet leo pellentesque tempor. Vivamus molestie fringilla nulla, at egestas magna tempor nec. Suspendisse potenti. Vivamus metus massa, viverra sit amet bibendum ac, consequat porta sem. Nullam venenatis faucibus sem. Donec non mi et felis iaculis tempor sed at dolor.</p>','','wysiwyg'),('node','portfolio',0,4,4,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','portfolio',0,5,5,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','portfolio',0,6,6,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','portfolio',0,7,7,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','portfolio',0,8,8,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','portfolio',0,9,9,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','portfolio',0,10,10,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','portfolio',0,11,11,'und',0,'  <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum id ligula felis euismod semper. Donec ullamcorper nulla non metus auctor fringilla. Nullam quis risus eget urna mollis ornare vel eu leo. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Vestibulum id ligula porta felis euismod semper. Sed posuere consectetur est at lobortis. Cras mattis consectetur purus sit amet fermentum.Nullam quis risus eget urna mollis ornare.</p>\r\n  <p>Donec sed odio dui. Nulla vitae elit libero, a pharetra augue. Nullam id dolor id ultricies vehicula ut id elit. Integer posuere erat a ante venenatis dapibus posuere velit aliquet. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio sem nec elit. Aenean lacinia bibendum nulla sed consectetur. Cras mattis consectetur purus sit amet fermentum. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor.</p>\r\n\r\n','','full_html'),('node','page',0,12,12,'und',0,'<div class=\"container\">\r\n\r\n\r\n  <!-- Buttons\r\n  ================================================== -->\r\n\r\n  <div class=\"eight columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline no-margin\"><h3>Buttons</h3></div>\r\n    <ul class=\"list-inline\">\r\n      <li><a href=\"#\" class=\"button gray\">Button</a></li>\r\n      <li><a href=\"#\" class=\"button color\">Button</a></li>\r\n      <li><a href=\"#\" class=\"button light\">Button</a></li>\r\n    </ul>\r\n    <br/>\r\n    <br/>\r\n    <ul class=\"list-inline\">\r\n      <li><a href=\"#\" class=\"button gray medium\">Button</a></li>\r\n      <li><a href=\"#\" class=\"button color medium\">Button</a></li>\r\n      <li><a href=\"#\" class=\"button light medium\">Button</a></li>\r\n    </ul>\r\n  </div>\r\n\r\n\r\n  <!-- Tabs\r\n  ================================================== -->\r\n\r\n  <div class=\"eight columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline no-margin\"><h3>Tabs</h3></div>\r\n\r\n    <!-- Tabs Navigation -->\r\n    <ul class=\"tabs-nav\">\r\n      <li class=\"active\"><a href=\"#tab1\"><i class=\"mini-ico-exclamation-sign\"></i> Tab 1</a></li>\r\n      <li><a href=\"#tab2\"><i class=\"mini-ico-file\"></i></a></li>\r\n      <li><a href=\"#tab3\">Tab 3</a></li>\r\n    </ul>\r\n\r\n    <!-- Tabs Content -->\r\n    <div class=\"tabs-container\">\r\n      <div class=\"tab-content\" id=\"tab1\">1. Lorem ipsum pharetra felis. Aliquam egestas consectetur elementum class aptent taciti sociosqu ad litora torquent perea conubia nostra lorem inceptos orem ipsum dolor sit amet, consectetur adipiscing elit.</div>\r\n      <div class=\"tab-content\" id=\"tab2\">2. Lorem ipsum pharetra felis. Aliquam egestas consectetur elementum class aptent taciti sociosqu ad litora torquent perea conubia nostra lorem inceptos orem ipsum dolor sit amet, consectetur adipiscing elit.</div>\r\n      <div class=\"tab-content\" id=\"tab3\">3. Lorem ipsum pharetra felis. Aliquam egestas consectetur elementum class aptent taciti sociosqu ad litora torquent perea conubia nostra lorem inceptos orem ipsum dolor sit amet, consectetur adipiscing elit.</div>\r\n    </div>\r\n\r\n  </div>\r\n\r\n</div>\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n\r\n  <!-- Accordions\r\n  ================================================== -->\r\n\r\n  <div class=\"eight columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Accordions</h3></div>\r\n\r\n    <!-- Accordion #1 -->\r\n    <div class=\"acc-trigger\"><a href=\"#\">Accordion #1</a></div>\r\n    <div class=\"acc-container\">\r\n      <div class=\"content\">\r\n        <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean nisl orci lorem, condiment ultrices consequat eu lorem ipsum dolor sit amet inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n      </div>\r\n    </div>\r\n\r\n    <!-- Accordion #2 -->\r\n    <div class=\"acc-trigger\"><a href=\"#\">Accordion #2</a></div>\r\n    <div class=\"acc-container\">\r\n      <div class=\"content\">\r\n        <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean nisl orci lorem, condiment ultrices consequat eu lorem ipsum dolor sit amet inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n      </div>\r\n    </div>\r\n\r\n    <!-- Accordion #3 -->\r\n    <div class=\"acc-trigger\"><a href=\"#\">Accordion #3</a></div>\r\n    <div class=\"acc-container\">\r\n      <div class=\"content\">\r\n        <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aenean nisl orci lorem, condiment ultrices consequat eu lorem ipsum dolor sit amet inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo.</p>\r\n      </div>\r\n    </div>\r\n\r\n  </div>\r\n\r\n\r\n  <!-- Alert Boxes\r\n  ================================================== -->\r\n\r\n  <div class=\"eight columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Alert Boxes</h3></div>\r\n\r\n    <div class=\"notification error closeable\">\r\n      <p><span>Error!</span> Please fill in all the fields required.</p>\r\n    </div>\r\n\r\n    <div class=\"notification success closeable\">\r\n      <p><span>Success!</span> You did it, now relax and enjoy it.</p>\r\n    </div>\r\n\r\n    <div class=\"notification warning closeable\">\r\n      <p><span>Warning!</span> Change this and that and try again.</p>\r\n    </div>\r\n\r\n    <div class=\"notification notice closeable\">\r\n      <p><span>Notice!</span> Please edit the information below.</p>\r\n    </div>\r\n\r\n  </div>\r\n\r\n</div>\r\n<!-- 960 Container / End -->\r\n\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n\r\n  <!-- Tooltips \r\n  ================================================== -->\r\n\r\n  <div class=\"eight columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Tooltips</h3></div>\r\n\r\n    <div class=\"tooltips\">\r\n      <p>Condiment <a href=\"#\" rel=\"tooltip\" title=\"First Tooltip\">adipiscing varius </a> accumsan. Fusce placerat neque sed sapien rutrum laoreet justo ultrices. In pellentesque lorem <a href=\"#\" rel=\"tooltip\" title=\"Another one here too\">condimentum</a> dui consequat adipiscing nisi tincidunt. Morbi pulvinar dui non quam pretium ut lacinia tortor.</p>\r\n    </div>\r\n\r\n  </div>\r\n\r\n\r\n  <!-- Blockquote\r\n  ================================================== -->\r\n\r\n  <div class=\"eight columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Blockquote</h3></div>\r\n\r\n    <blockquote>Mauris aliquet ultricies ante, non faucibus ante gravida sed. Sed ultrices pellentesque purus, vulputate volutpat ipsum hendrerit sed neque sed sapien rutrum laoreet justo ultrices. In pellentesque lorem condimentum dui conse</blockquote>\r\n  </div>\r\n\r\n</div>\r\n<!-- 960 Container / End -->\r\n\r\n\r\n<!-- Icon Boxes\r\n================================================== -->\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <div class=\"sixteen columns\">\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Icon Boxes</h3></div>\r\n  </div>\r\n\r\n  <!-- Icon Box Container -->\r\n  <div class=\"icon-boxes-container\">\r\n\r\n    <!-- Icon Box Start -->\r\n    <div class=\"one-third column\">\r\n      <div class=\"icon-box\">\r\n        <i class=\"ico-stats\" style=\"margin-left: -12px;\"></i>\r\n        <h3>Website Design</h3>\r\n        <p>Proin iaculis purus consequat sem cure digni ssim. Donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt.</p>\r\n      </div>\r\n    </div>\r\n    <!-- Icon Box End -->\r\n\r\n    <!-- Icon Box Start -->\r\n    <div class=\"one-third column\">\r\n      <div class=\"icon-box\">\r\n        <i class=\"ico-lightbulb\"></i>\r\n        <h3>Website Development</h3>\r\n        <p>Nam aliquam volutpat leo vel bibendum nunc elit purus, tempus pulvinare rhoncus egestas nibh volutpat leo.</p>\r\n      </div>\r\n    </div>\r\n    <!-- Icon Box End -->\r\n\r\n    <!-- Icon Box Start -->\r\n    <div class=\"one-third column\">\r\n      <div class=\"icon-box\">\r\n        <i class=\"ico-thumbs-up\"></i>\r\n        <h3>Social Marketing</h3>\r\n        <p>Fusce porttitor turpis quis molestie costant equat. Nam purus, tincidunt sedeat dapibus ugravida ut dui. Fusce et magna libero.</p>\r\n      </div>\r\n    </div>\r\n    <!-- Icon Box End -->\r\n\r\n  </div>\r\n  <!-- Icon Box Container / End -->\r\n\r\n</div>\r\n<!-- 960 Container / End -->\r\n\r\n<br />\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <!-- List Styles\r\n  ================================================== -->\r\n\r\n  <div class=\"four columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>List Styles</h3></div>\r\n\r\n    <ul class=\"check_list\"><li>Check List - Lorem ipsum aperia</li></ul>\r\n    <ul class=\"plus_list\"><li>Plus List - Dolor beatae lorem</li></ul>\r\n    <ul class=\"minus_list\"><li>Minus List - Perspiciatis adipiscing</li></ul>\r\n    <ul class=\"star_list\"><li>Star List - Lorem ipsum aperia</li></ul>\r\n    <ul class=\"arrow_list\"><li>Arrow 2 List - Dolor beatae lorem</li></ul>\r\n    <ul class=\"square_list\"><li>Square List - Perspiciatis adipiscing</li></ul>\r\n    <ul class=\"circle_list\"><li>Circle List - Lorem ipsum aperia</li></ul>\r\n    <ul class=\"cross_list\"><li>Cross List - Dolor beatae lorem</li></ul>\r\n\r\n  </div>\r\n\r\n\r\n  <!-- Testomonial\'s Carousel\r\n  ================================================== -->\r\n\r\n  <div class=\"four columns testimonial-container\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Testimonials</h3></div>\r\n\r\n    <!-- Testimonial\'s Carousel -->\r\n    <div class=\"testimonials-carousel\" data-autorotate=\"3000\">\r\n      <ul class=\"carousel\">\r\n\r\n        <li class=\"testimonial\">\r\n          <div class=\"testimonials\">Posuere erat a ante venenatis dapibus posuere velit aliquet. Duis llis, est non coeammodo luctus, nisi erat porttitor ligula, egeteas laciniato odiomo sem.</div>\r\n          <div class=\"testimonials-bg\"></div>\r\n          <div class=\"testimonials-author\">Michael, <span>Flash Developer</span></div>\r\n        </li>\r\n\r\n        <li class=\"testimonial\">\r\n          <div class=\"testimonials\">Integer eu libero sit amet nisl vestibulum semper. Fusce nec porttitor massa. In nec neque elit. Curabitur malesuada ligula vitae purus ornare onec etea magna diam varius.</div>\r\n          <div class=\"testimonials-bg\"></div>\r\n          <div class=\"testimonials-author\">John, <span>Web Developer</span></div>\r\n        </li>\r\n\r\n        <li class=\"testimonial\">\r\n          <div class=\"testimonials\">Cras sed odio est, sit amet porttitor elit. Vestibulum elementum erat vitae ante venenatis cursus scelerisque quam vel nibh imperdiet vitae porta lorem posuere.</div>\r\n          <div class=\"testimonials-bg\"></div>\r\n          <div class=\"testimonials-author\">Peter, <span>Project Manager</span></div>\r\n        </li>\r\n\r\n        <li class=\"testimonial\">\r\n          <div class=\"testimonials\">Elementum erat vitae ante venenatis dapibus. Maecenas cursus scelerisque quam vel nibh imperdiet vitae porta lorem posuere.</div>\r\n          <div class=\"testimonials-bg\"></div>\r\n          <div class=\"testimonials-author\">Kathy, <span>Art Director</span></div>\r\n        </li>\r\n\r\n      </ul>\r\n    </div>\r\n\r\n  </div>\r\n\r\n\r\n  <!-- Large Notice\r\n  ================================================== -->\r\n\r\n  <div class=\"eight columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Large Notice</h3></div>\r\n\r\n    <!-- Large Notice -->\r\n    <div class=\"large-notice\">\r\n      <h2>This is a Headline</h2>\r\n      <p>This is a example of style component for calling extra attention to featured content or information.</p>\r\n      <a href=\"#\" class=\"button medium color\">Read More</a>\r\n    </div>\r\n\r\n  </div>\r\n\r\n</div>\r\n<!-- 960 Container / End -->\r\n\r\n\r\n<!-- Social Icons\r\n================================================== -->\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <div class=\"sixteen columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Social Icons</h3></div>\r\n\r\n    <!-- Social Icons -->\r\n    <div id=\"social\" class=\"tooltips\">\r\n      <ul class=\"list-inline\">\r\n        <li> <a href=\"#\" rel=\"tooltip\" title=\"Amazon\" class=\"amazon\">Amazon</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Behance\" class=\"behance\">Behance</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Blogger\" class=\"blogger\">Blogger</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"DeviantART\" class=\"deviantart\">DeviantART</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Dribbble\" class=\"dribbble\">Dribbble</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Dropbox\" class=\"dropbox\">Dropbox</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Evernote\" class=\"evernote\">Evernote</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Facebook\" class=\"facebook\">Facebook</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Forrst\" class=\"forrst\">Forrst</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Github\" class=\"github\">Github</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Google Plus\" class=\"googleplus\">Google Plus</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Joli Cloud\" class=\"jolicloud\">Joli Cloud</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Last FM\" class=\"last-fm\">Last FM</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"LinkedIn\" class=\"linkedin\">LinkedIn</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Picasa\" class=\"picasa\">Picasa</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Pintrest\" class=\"pintrest\">Pintrest</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"RSS\" class=\"rss\">RSS</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Skype\" class=\"skype\">Skype</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Spotify\" class=\"spotify\">Spotify</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"StumpleUpon\" class=\"stumbleupon\">StumbleUpon</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Tumblr\" class=\"tumblr\">Tumblr</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Twitter\" class=\"twitter\">Twitter</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Vimeo\" class=\"vimeo\">Vimeo</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"WordPress\" class=\"wordpress\">WordPress</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Xing\" class=\"xing\">Xing</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"Yahoo\" class=\"yahoo\">Yahoo</a></li>\r\n      <li><a href=\"#\" rel=\"tooltip\" title=\"YouTube\" class=\"youtube\">YouTube</a></li>\r\n      </ul>\r\n    </div>\r\n    <!-- Social Icons / End-->\r\n\r\n  </div>\r\n</div>\r\n<!-- 960 Container / End -->\r\n\r\n\r\n<!-- Regular Table\r\n================================================== -->\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <div class=\"sixteen columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Table</h3></div>\r\n\r\n    <table class=\"standard-table\">\r\n\r\n      <tr>\r\n        <th>Header 1</th>\r\n        <th>Header 2</th>\r\n        <th>Header 3</th>\r\n        <th>Header 4</th>\r\n      </tr>\r\n\r\n      <tr>\r\n        <td>Item #1</td>\r\n        <td>Description</td>\r\n        <td>100 GB</td>\r\n        <td>100 GB</td>\r\n      </tr>\r\n\r\n      <tr>\r\n        <td>Item #2</td>\r\n        <td>Description</td>\r\n        <td>200 GB</td>\r\n        <td>200 GB</td>\r\n      </tr>\r\n\r\n      <tr>\r\n        <td>Item #3</td>\r\n        <td>Description</td>\r\n        <td>300 GB</td>\r\n        <td>300 GB</td>\r\n      </tr>\r\n\r\n      <tr>\r\n        <td>Item #4</td>\r\n        <td>Description</td>\r\n        <td>400 GB</td>\r\n        <td>400 GB</td>\r\n      </tr>\r\n\r\n      <tr>\r\n        <td>Item #5</td>\r\n        <td>Description</td>\r\n        <td>500 GB</td>\r\n        <td>500 GB</td>\r\n      </tr>\r\n\r\n    </table>\r\n\r\n  </div>\r\n</div>\r\n<!-- 960 Container / End -->\r\n\r\n\r\n<!-- Mini Icons\r\n================================================== -->\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <div class=\"sixteen columns\">\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h3>Mini Icons</h3></div>\r\n  </div>\r\n\r\n  <div class=\"four columns\">\r\n    <ul>\r\n      <li><i class=\"mini-ico-glass\"></i> mini-ico-glass</li>\r\n      <li><i class=\"mini-ico-music\"></i> mini-ico-music</li>\r\n      <li><i class=\"mini-ico-search\"></i> mini-ico-search</li>\r\n      <li><i class=\"mini-ico-envelope\"></i> mini-ico-envelope</li>\r\n      <li><i class=\"mini-ico-heart\"></i> mini-ico-heart</li>\r\n      <li><i class=\"mini-ico-star\"></i> mini-ico-star</li>\r\n      <li><i class=\"mini-ico-star-empty\"></i> mini-ico-star-empty</li>\r\n      <li><i class=\"mini-ico-user\"></i> mini-ico-user</li>\r\n      <li><i class=\"mini-ico-film\"></i> mini-ico-film</li>\r\n      <li><i class=\"mini-ico-th-large\"></i> mini-ico-th-large</li>\r\n      <li><i class=\"mini-ico-th\"></i> mini-ico-th</li>\r\n      <li><i class=\"mini-ico-th-list\"></i> mini-ico-th-list</li>\r\n      <li><i class=\"mini-ico-ok\"></i> mini-ico-ok</li>\r\n      <li><i class=\"mini-ico-remove\"></i> mini-ico-remove</li>\r\n      <li><i class=\"mini-ico-zoom-in\"></i> mini-ico-zoom-in</li>\r\n      <li><i class=\"mini-ico-zoom-out\"></i> mini-ico-zoom-out</li>\r\n      <li><i class=\"mini-ico-off\"></i> mini-ico-off</li>\r\n      <li><i class=\"mini-ico-signal\"></i> mini-ico-signal</li>\r\n      <li><i class=\"mini-ico-cog\"></i> mini-ico-cog</li>\r\n      <li><i class=\"mini-ico-trash\"></i> mini-ico-trash</li>\r\n      <li><i class=\"mini-ico-home\"></i> mini-ico-home</li>\r\n      <li><i class=\"mini-ico-file\"></i> mini-ico-file</li>\r\n      <li><i class=\"mini-ico-time\"></i> mini-ico-time</li>\r\n      <li><i class=\"mini-ico-road\"></i> mini-ico-road</li>\r\n      <li><i class=\"mini-ico-download-alt\"></i> mini-ico-download-alt</li>\r\n      <li><i class=\"mini-ico-download\"></i> mini-ico-download</li>\r\n      <li><i class=\"mini-ico-upload\"></i> mini-ico-upload</li>\r\n      <li><i class=\"mini-ico-inbox\"></i> mini-ico-inbox</li>\r\n      <li><i class=\"mini-ico-play-circle\"></i> mini-ico-play-circle</li>\r\n      <li><i class=\"mini-ico-repeat\"></i> mini-ico-repeat</li>\r\n      <li><i class=\"mini-ico-refresh\"></i> mini-ico-refresh</li>\r\n      <li><i class=\"mini-ico-list-alt\"></i> mini-ico-list-alt</li>\r\n      <li><i class=\"mini-ico-lock\"></i> mini-ico-lock</li>\r\n      <li><i class=\"mini-ico-flag\"></i> mini-ico-flag</li>\r\n      <li><i class=\"mini-ico-headphones\"></i> mini-ico-headphones</li>\r\n    </ul>\r\n  </div>\r\n  <div class=\"four columns\">\r\n    <ul>\r\n      <li><i class=\"mini-ico-volume-off\"></i> mini-ico-volume-off</li>\r\n      <li><i class=\"mini-ico-volume-down\"></i> mini-ico-volume-down</li>\r\n      <li><i class=\"mini-ico-volume-up\"></i> mini-ico-volume-up</li>\r\n      <li><i class=\"mini-ico-qrcode\"></i> mini-ico-qrcode</li>\r\n      <li><i class=\"mini-ico-barcode\"></i> mini-ico-barcode</li>\r\n      <li><i class=\"mini-ico-tag\"></i> mini-ico-tag</li>\r\n      <li><i class=\"mini-ico-tags\"></i> mini-ico-tags</li>\r\n      <li><i class=\"mini-ico-book\"></i> mini-ico-book</li>\r\n      <li><i class=\"mini-ico-bookmark\"></i> mini-ico-bookmark</li>\r\n      <li><i class=\"mini-ico-print\"></i> mini-ico-print</li>\r\n      <li><i class=\"mini-ico-camera\"></i> mini-ico-camera</li>\r\n      <li><i class=\"mini-ico-font\"></i> mini-ico-font</li>\r\n      <li><i class=\"mini-ico-bold\"></i> mini-ico-bold</li>\r\n      <li><i class=\"mini-ico-italic\"></i> mini-ico-italic</li>\r\n      <li><i class=\"mini-ico-text-height\"></i> mini-ico-text-height</li>\r\n      <li><i class=\"mini-ico-text-width\"></i> mini-ico-text-width</li>\r\n      <li><i class=\"mini-ico-align-left\"></i> mini-ico-align-left</li>\r\n      <li><i class=\"mini-ico-align-center\"></i> mini-ico-align-center</li>\r\n      <li><i class=\"mini-ico-align-right\"></i> mini-ico-align-right</li>\r\n      <li><i class=\"mini-ico-align-justify\"></i> mini-ico-align-justify</li>\r\n      <li><i class=\"mini-ico-list\"></i> mini-ico-list</li>\r\n      <li><i class=\"mini-ico-indent-left\"></i> mini-ico-indent-left</li>\r\n      <li><i class=\"mini-ico-indent-right\"></i> mini-ico-indent-right</li>\r\n      <li><i class=\"mini-ico-facetime-video\"></i> mini-ico-facetime-video</li>\r\n      <li><i class=\"mini-ico-picture\"></i> mini-ico-picture</li>\r\n      <li><i class=\"mini-ico-pencil\"></i> mini-ico-pencil</li>\r\n      <li><i class=\"mini-ico-map-marker\"></i> mini-ico-map-marker</li>\r\n      <li><i class=\"mini-ico-adjust\"></i> mini-ico-adjust</li>\r\n      <li><i class=\"mini-ico-tint\"></i> mini-ico-tint</li>\r\n      <li><i class=\"mini-ico-edit\"></i> mini-ico-edit</li>\r\n      <li><i class=\"mini-ico-share\"></i> mini-ico-share</li>\r\n      <li><i class=\"mini-ico-check\"></i> mini-ico-check</li>\r\n      <li><i class=\"mini-ico-move\"></i> mini-ico-move</li>\r\n      <li><i class=\"mini-ico-step-backward\"></i> mini-ico-step-backward</li>\r\n      <li><i class=\"mini-ico-fast-backward\"></i> mini-ico-fast-backward</li>\r\n    </ul>\r\n  </div>\r\n  <div class=\"four columns\">\r\n    <ul>\r\n      <li><i class=\"mini-ico-backward\"></i> mini-ico-backward</li>\r\n      <li><i class=\"mini-ico-play\"></i> mini-ico-play</li>\r\n      <li><i class=\"mini-ico-pause\"></i> mini-ico-pause</li>\r\n      <li><i class=\"mini-ico-stop\"></i> mini-ico-stop</li>\r\n      <li><i class=\"mini-ico-forward\"></i> mini-ico-forward</li>\r\n      <li><i class=\"mini-ico-fast-forward\"></i> mini-ico-fast-forward</li>\r\n      <li><i class=\"mini-ico-step-forward\"></i> mini-ico-step-forward</li>\r\n      <li><i class=\"mini-ico-eject\"></i> mini-ico-eject</li>\r\n      <li><i class=\"mini-ico-chevron-left\"></i> mini-ico-chevron-left</li>\r\n      <li><i class=\"mini-ico-chevron-right\"></i> mini-ico-chevron-right</li>\r\n      <li><i class=\"mini-ico-plus-sign\"></i> mini-ico-plus-sign</li>\r\n      <li><i class=\"mini-ico-minus-sign\"></i> mini-ico-minus-sign</li>\r\n      <li><i class=\"mini-ico-remove-sign\"></i> mini-ico-remove-sign</li>\r\n      <li><i class=\"mini-ico-ok-sign\"></i> mini-ico-ok-sign</li>\r\n      <li><i class=\"mini-ico-question-sign\"></i> mini-ico-question-sign</li>\r\n      <li><i class=\"mini-ico-info-sign\"></i> mini-ico-info-sign</li>\r\n      <li><i class=\"mini-ico-screenshot\"></i> mini-ico-screenshot</li>\r\n      <li><i class=\"mini-ico-remove-circle\"></i> mini-ico-remove-circle</li>\r\n      <li><i class=\"mini-ico-ok-circle\"></i> mini-ico-ok-circle</li>\r\n      <li><i class=\"mini-ico-ban-circle\"></i> mini-ico-ban-circle</li>\r\n      <li><i class=\"mini-ico-arrow-left\"></i> mini-ico-arrow-left</li>\r\n      <li><i class=\"mini-ico-arrow-right\"></i> mini-ico-arrow-right</li>\r\n      <li><i class=\"mini-ico-arrow-up\"></i> mini-ico-arrow-up</li>\r\n      <li><i class=\"mini-ico-arrow-down\"></i> mini-ico-arrow-down</li>\r\n      <li><i class=\"mini-ico-share-alt\"></i> mini-ico-share-alt</li>\r\n      <li><i class=\"mini-ico-resize-full\"></i> mini-ico-resize-full</li>\r\n      <li><i class=\"mini-ico-resize-small\"></i> mini-ico-resize-small</li>\r\n      <li><i class=\"mini-ico-plus\"></i> mini-ico-plus</li>\r\n      <li><i class=\"mini-ico-minus\"></i> mini-ico-minus</li>\r\n      <li><i class=\"mini-ico-asterisk\"></i> mini-ico-asterisk</li>\r\n      <li><i class=\"mini-ico-exclamation-sign\"></i> mini-ico-exclamation-sign</li>\r\n      <li><i class=\"mini-ico-gift\"></i> mini-ico-gift</li>\r\n      <li><i class=\"mini-ico-leaf\"></i> mini-ico-leaf</li>\r\n      <li><i class=\"mini-ico-fire\"></i> mini-ico-fire</li>\r\n      <li><i class=\"mini-ico-eye-open\"></i> mini-ico-eye-open</li>\r\n    </ul>\r\n  </div>\r\n  <div class=\"four columns\">\r\n    <ul>\r\n      <li><i class=\"mini-ico-eye-close\"></i> mini-ico-eye-close</li>\r\n      <li><i class=\"mini-ico-warning-sign\"></i> mini-ico-warning-sign</li>\r\n      <li><i class=\"mini-ico-plane\"></i> mini-ico-plane</li>\r\n      <li><i class=\"mini-ico-calendar\"></i> mini-ico-calendar</li>\r\n      <li><i class=\"mini-ico-random\"></i> mini-ico-random</li>\r\n      <li><i class=\"mini-ico-comment\"></i> mini-ico-comment</li>\r\n      <li><i class=\"mini-ico-magnet\"></i> mini-ico-magnet</li>\r\n      <li><i class=\"mini-ico-chevron-up\"></i> mini-ico-chevron-up</li>\r\n      <li><i class=\"mini-ico-chevron-down\"></i> mini-ico-chevron-down</li>\r\n      <li><i class=\"mini-ico-retweet\"></i> mini-ico-retweet</li>\r\n      <li><i class=\"mini-ico-shopping-cart\"></i> mini-ico-shopping-cart</li>\r\n      <li><i class=\"mini-ico-folder-close\"></i> mini-ico-folder-close</li>\r\n      <li><i class=\"mini-ico-folder-open\"></i> mini-ico-folder-open</li>\r\n      <li><i class=\"mini-ico-resize-vertical\"></i> mini-ico-resize-vertical</li>\r\n      <li><i class=\"mini-ico-resize-horizontal\"></i> mini-ico-resize-horizontal</li>\r\n      <li><i class=\"mini-ico-hdd\"></i> mini-ico-hdd</li>\r\n      <li><i class=\"mini-ico-bullhorn\"></i> mini-ico-bullhorn</li>\r\n      <li><i class=\"mini-ico-bell\"></i> mini-ico-bell</li>\r\n      <li><i class=\"mini-ico-certificate\"></i> mini-ico-certificate</li>\r\n      <li><i class=\"mini-ico-thumbs-up\"></i> mini-ico-thumbs-up</li>\r\n      <li><i class=\"mini-ico-thumbs-down\"></i> mini-ico-thumbs-down</li>\r\n      <li><i class=\"mini-ico-hand-right\"></i> mini-ico-hand-right</li>\r\n      <li><i class=\"mini-ico-hand-left\"></i> mini-ico-hand-left</li>\r\n      <li><i class=\"mini-ico-hand-up\"></i> mini-ico-hand-up</li>\r\n      <li><i class=\"mini-ico-hand-down\"></i> mini-ico-hand-down</li>\r\n      <li><i class=\"mini-ico-circle-arrow-right\"></i> mini-ico-circle-arrow-right</li>\r\n      <li><i class=\"mini-ico-circle-arrow-left\"></i> mini-ico-circle-arrow-left</li>\r\n      <li><i class=\"mini-ico-circle-arrow-up\"></i> mini-ico-circle-arrow-up</li>\r\n      <li><i class=\"mini-ico-circle-arrow-down\"></i> mini-ico-circle-arrow-down</li>\r\n      <li><i class=\"mini-ico-globe\"></i> mini-ico-globe</li>\r\n      <li><i class=\"mini-ico-wrench\"></i> mini-ico-wrench</li>\r\n      <li><i class=\"mini-ico-tasks\"></i> mini-ico-tasks</li>\r\n      <li><i class=\"mini-ico-filter\"></i> mini-ico-filter</li>\r\n      <li><i class=\"mini-ico-briefcase\"></i> mini-ico-briefcase</li>\r\n      <li><i class=\"mini-ico-fullscreen\"></i> mini-ico-fullscreen</li>\r\n    </ul>\r\n  </div>\r\n\r\n</div>\r\n<!-- 960 Container End -->\r\n\r\n\r\n<!-- Icons\r\n================================================== -->\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n  <div class=\"sixteen columns\"></div>\r\n\r\n  <!-- Headline -->\r\n  <div class=\"headline\"><h3>Icons</h3></div>\r\n\r\n  <div class=\"four columns\">\r\n    <ul class=\"the-icons\">\r\n      <li><i class=\"ico-glass\"></i> <b>ico-glass</b></li>\r\n      <li><i class=\"ico-leaf\"></i> <b>ico-leaf</b></li>\r\n      <li><i class=\"ico-dog\"></i> <b>ico-dog</b></li>\r\n      <li><i class=\"ico-user\"></i> <b>ico-user</b></li>\r\n      <li><i class=\"ico-girl\"></i> <b>ico-girl</b></li>\r\n      <li><i class=\"ico-car\"></i> <b>ico-car</b></li>\r\n      <li><i class=\"ico-user-add\"></i> <b>ico-user-add</b></li>\r\n      <li><i class=\"ico-user-remove\"></i> <b>ico-remove</b></li>\r\n      <li><i class=\"ico-film\"></i> <b>ico-film</b></li>\r\n      <li><i class=\"ico-magic\"></i> <b>ico-magic</b></li>\r\n      <li><i class=\"ico-envelope\"></i> <b>ico-envelope</b></li>\r\n      <li><i class=\"ico-camera\"></i> <b>ico-camera</b></li>\r\n      <li><i class=\"ico-heart\"></i> <b>ico-hearth</b></li>\r\n      <li><i class=\"ico-beach-umbrella\"></i> <b>ico-beach-umbrella</b></li>\r\n      <li><i class=\"ico-train\"></i> <b>ico-train</b></li>\r\n      <li><i class=\"ico-print\"></i> <b>ico-print</b></li>\r\n      <li><i class=\"ico-bin\"></i> <b>ico-bin</b></li>\r\n      <li><i class=\"ico-music\"></i> <b>ico--music</b></li>\r\n      <li><i class=\"ico-note\"></i> <b>ico-note</b></li>\r\n      <li><i class=\"ico-cogwheel\"></i> <b>ico-cogwheel</b></li>\r\n      <li><i class=\"ico-home\"></i> <b>ico-home</b></li>\r\n      <li><i class=\"ico-snowflake\"></i> <b>ico-snowflake</b></li>\r\n      <li><i class=\"ico-fire\"></i> <b>ico-fire</b></li>\r\n      <li><i class=\"ico-cogwheels\"></i> <b>ico-cogwheels</b></li>\r\n      <li><i class=\"ico-parents\"></i> <b>ico-parents</b></li>\r\n      <li><i class=\"ico-binoculars\"></i> <b>ico-binoculars</b></li>\r\n      <li><i class=\"ico-road\"></i> <b>ico-road</b></li>\r\n      <li><i class=\"ico-search\"></i> <b>ico-search</b></li>\r\n      <li><i class=\"ico-cars\"></i> <b>ico-cars</b></li>\r\n      <li><i class=\"ico-notes\"></i> <b>ico-notes</b></li>\r\n      <li><i class=\"ico-pencil\"></i> <b>ico-pencil</b></li>\r\n      <li><i class=\"ico-bus\"></i> <b>ico-bus</b></li>\r\n      <li><i class=\"ico-wifi-alt\"></i> <b>ico-wifi-alt</b></li>\r\n      <li><i class=\"ico-luggage\"></i> <b>ico-luggage</b></li>\r\n      <li><i class=\"ico-old-man\"></i> <b>ico-old-man</b></li>\r\n      <li><i class=\"ico-woman\"></i> <b>ico-woman</b></li>\r\n      <li><i class=\"ico-file\"></i> <b>ico-file</b></li>\r\n      <li><i class=\"ico-credit\"></i> <b>ico-credit</b></li>\r\n      <li><i class=\"ico-airplane\"></i> <b>ico-airplane</b></li>\r\n      <li><i class=\"ico-notes\"></i> <b>ico-notes</b></li>\r\n      <li><i class=\"ico-stats\"></i> <b>ico-stats</b></li>\r\n      <li><i class=\"ico-charts\"></i> <b>ico-charts</b></li>\r\n      <li><i class=\"ico-pie-chart\"></i> <b>ico-pie-chart</b></li>\r\n      <li><i class=\"ico-group\"></i> <b>ico-group</b></li>\r\n      <li><i class=\"ico-keys\"></i> <b>ico-keys</b></li>\r\n      <li><i class=\"ico-calendar\"></i> <b>ico-calendar</b></li>\r\n      <li><i class=\"ico-router\"></i> <b>ico-router</b></li>\r\n      <li><i class=\"ico-camera-small\"></i> <b>ico-camera-small</b></li>\r\n      <li><i class=\"ico-dislikes\"></i> <b>ico-dislikes</b></li>\r\n      <li><i class=\"ico-star\"></i> <b>ico-star</b></li>\r\n      <li><i class=\"ico-link\"></i> <b>ico-link</b></li>\r\n      <li><i class=\"ico-eye-open\"></i> <b>ico-eye-open</b></li>\r\n      <li><i class=\"ico-eye-close\"></i> <b>ico-eye-close</b></li>\r\n      <li><i class=\"ico-alarm\"></i> <b>ico-alarm</b></li>\r\n      <li><i class=\"ico-clock\"></i> <b>ico-clock</b></li>\r\n      <li><i class=\"ico-stopwatch\"></i> <b>ico-stopwatch</b></li>\r\n      <li><i class=\"ico-projector\"></i> <b>ico-projector</b></li>\r\n      <li><i class=\"ico-history\"></i> <b>ico-history</b></li>\r\n      <li><i class=\"ico-truck\"></i> <b>ico-truck</b></li>\r\n      <li><i class=\"ico-cargo\"></i> <b>ico-cargo</b></li>\r\n      <li><i class=\"ico-compass\"></i> <b>ico-compass</b></li>\r\n      <li><i class=\"ico-keynote\"></i> <b>ico-keynote</b></li>\r\n      <li><i class=\"ico-attach\"></i> <b>ico-attach</b></li>\r\n      <li><i class=\"ico-power\"></i> <b>ico-power</b></li>\r\n      <li><i class=\"ico-lightbulb\"></i> <b>ico-lightbulb</b></li>\r\n      <li><i class=\"ico-tag\"></i> <b>ico-tag</b></li>\r\n      <li><i class=\"ico-tags\"></i> <b>ico-tags</b></li>\r\n      <li><i class=\"ico-cleaning\"></i> <b>ico-cleaning</b></li>\r\n      <li><i class=\"ico-ruller\"></i> <b>ico-ruller</b></li>\r\n      <li><i class=\"ico-gift\"></i> <b>ico-gift</b></li>\r\n      <li><i class=\"ico-umbrella\"></i> <b>ico-umbrella</b></li>\r\n      <li><i class=\"ico-book\"></i> <b>ico--book</b></li>\r\n      <li><i class=\"ico-bookmark\"></i> <b>ico-bookmark</b></li>\r\n      <li><i class=\"ico-signal-alt\"></i> <b>ico-signal-alt</b></li>\r\n      <li><i class=\"ico-cup\"></i> <b>ico-cup</b></li>\r\n      <li><i class=\"ico-stroller\"></i> <b>ico-stroller</b></li>\r\n      <li><i class=\"ico-headphones\"></i> <b>ico-headphones</b></li>\r\n      <li><i class=\"ico-headset\"></i> <b>ico-headset</b></li>\r\n      <li><i class=\"ico-warning-sign\"></i> <b>ico-warning-sign</b></li>\r\n      <li><i class=\"ico-signal\"></i> <b>ico-signal</b></li>\r\n      <li><i class=\"ico-retweet\"></i> <b>ico-retweet</b></li>\r\n      <li><i class=\"ico-refresh\"></i> <b>ico-refresh</b></li>\r\n      <li><i class=\"ico-roundabout\"></i> <b>ico-roundabout</b></li>\r\n      <li><i class=\"ico-random\"></i> <b>ico-random</b></li>\r\n      <li><i class=\"ico-heat\"></i> <b>ico-heat</b></li>\r\n      <li><i class=\"ico-repeat\"></i> <b>ico-repeat</b></li>\r\n      <li><i class=\"ico-display\"></i> <b>ico-display</b></li>\r\n      <li><i class=\"ico-log-book\"></i> <b>ico-log-book</b></li>\r\n      <li><i class=\"ico-adress-book\"></i> <b>ico-adress-book</b></li>\r\n      <li><i class=\"ico-magnet\"></i> <b>ico-magnet</b></li>\r\n    </ul>	\r\n  </div>\r\n\r\n  <div class=\"four columns\">\r\n    <ul class=\"the-icons\">\r\n      <li><i class=\"ico-table\"></i> <b>ico-table</b></li>\r\n      <li><i class=\"ico-adjust\"></i> <b>ico-adjust</b></li>\r\n      <li><i class=\"ico-tint\"></i> <b>ico-tint</b></li>\r\n      <li><i class=\"ico-crop\"></i> <b>ico-crop</b></li>\r\n      <li><i class=\"ico-vector-path-square\"></i> <b>ico-vector-path-square</b></li>\r\n      <li><i class=\"ico-vector-path-circle\"></i> <b>ico-vector-path-circle</b></li>\r\n      <li><i class=\"ico-vector-path-polygon\"></i> <b>ico-vector-path-polygon</b></li>\r\n      <li><i class=\"ico-vector-path-line\"></i> <b>ico-vector-path-line</b></li>\r\n      <li><i class=\"ico-vector-path-curve\"></i> <b>ico-vector-path-curve</b></li>\r\n      <li><i class=\"ico-vector-path-all\"></i> <b>ico-vector-path-all</b></li>\r\n      <li><i class=\"ico-font\"></i> <b>ico-font</b></li>\r\n      <li><i class=\"ico-italic\"></i> <b>ico-italic</b></li>\r\n      <li><i class=\"ico-bold\"></i> <b>ico-bold</b></li>\r\n      <li><i class=\"ico-text-underline\"></i> <b>ico-text-underline</b></li>\r\n      <li><i class=\"ico-text-strike\"></i> <b>ico-text-strike</b></li>\r\n      <li><i class=\"ico-text-height\"></i> <b>ico-text-height</b></li>\r\n      <li><i class=\"ico-text-width\"></i> <b>ico-text-width</b></li>\r\n      <li><i class=\"ico-text-resize\"></i> <b>ico-text-resize</b></li>\r\n      <li><i class=\"ico-left-indent\"></i> <b>ico-left-indent</b></li>\r\n      <li><i class=\"ico-right-indent\"></i> <b>ico-right-indent</b></li>\r\n      <li><i class=\"ico-align-left\"></i> <b>ico-align-left</b></li>\r\n      <li><i class=\"ico-align-center\"></i> <b>ico-align-center</b></li>\r\n      <li><i class=\"ico-align-right\"></i> <b>ico-align-right</b></li>\r\n      <li><i class=\"ico-justify\"></i> <b>ico-justify</b></li>\r\n      <li><i class=\"ico-list\"></i> <b>ico-list</b></li>\r\n      <li><i class=\"ico-text-smaller\"></i> <b>ico-text-smaller</b></li>\r\n      <li><i class=\"ico-text-bugger\"></i> <b>ico-text-bugger</b></li>\r\n      <li><i class=\"ico-embed\"></i> <b>ico-embed</b></li>\r\n      <li><i class=\"ico-embed-close\"></i> <b>ico-embed-close</b></li>\r\n      <li><i class=\"ico-adjust-alt\"></i> <b>ico-adjust-alt</b></li>\r\n      <li><i class=\"ico-message-full\"></i> <b>ico-message-full</b></li>\r\n      <li><i class=\"ico-message-empty\"></i> <b>ico-message-empty</b></li>\r\n      <li><i class=\"ico-message-in\"></i> <b>ico-message-in</b></li>\r\n      <li><i class=\"ico-message-out\"></i> <b>ico-message-out</b></li>\r\n      <li><i class=\"ico-message-plus\"></i> <b>ico-message-plus</b></li>\r\n      <li><i class=\"ico-message-minus\"></i> <b>ico-message-minus</b></li>\r\n      <li><i class=\"ico-message-ban\"></i> <b>ico-message-ban</b></li>\r\n      <li><i class=\"ico-message-flag\"></i> <b>ico-message-flag</b></li>\r\n      <li><i class=\"ico-message-lock\"></i> <b>ico-message-lock</b></li>\r\n      <li><i class=\"ico-message-new\"></i> <b>ico-message-new</b></li>\r\n      <li><i class=\"ico-inbox\"></i> <b>ico-inbox</b></li>\r\n      <li><i class=\"ico-inbox-plus\"></i> <b>ico-inbox-plus</b></li>\r\n      <li><i class=\"ico-inbox-minus\"></i> <b>ico-inbox-minus</b></li>\r\n      <li><i class=\"ico-inbox-lock\"></i> <b>ico-inbox-lock</b></li>\r\n      <li><i class=\"ico-inbox-in\"></i> <b>ico-inbox-in</b></li>\r\n      <li><i class=\"ico-inbox-out\"></i> <b>ico-inbox-out</b></li>\r\n      <li><i class=\"ico-computer-locked\"></i> <b>ico-computer-locked</b></li>\r\n      <li><i class=\"ico-computer-service\"></i> <b>ico-computer-service</b></li>\r\n      <li><i class=\"ico-computer-process\"></i> <b>ico-computer-process</b></li>\r\n      <li><i class=\"ico-phone\"></i> <b>ico-phone</b></li>\r\n      <li><i class=\"ico-database-lock\"></i> <b>ico-database-lock</b></li>\r\n      <li><i class=\"ico-database-plus\"></i> <b>ico-database-plus</b></li>\r\n      <li><i class=\"ico-database-minus\"></i> <b>ico-database-minus</b></li>\r\n      <li><i class=\"ico-database-ban\"></i> <b>ico-database-ban</b></li>\r\n      <li><i class=\"ico-folder-open\"></i> <b>ico-folder-open</b></li>\r\n      <li><i class=\"ico-folder-plus\"></i> <b>ico-folder-plus</b></li>\r\n      <li><i class=\"ico-folder-minus\"></i> <b>ico--folder-minus</b></li>\r\n      <li><i class=\"ico-folder-lock\"></i> <b>ico-folder-lock</b></li>\r\n      <li><i class=\"ico-folder-flag\"></i> <b>ico-folder-flag</b></li>\r\n      <li><i class=\"ico-folder-new\"></i> <b>ico-folder-new</b></li>\r\n      <li><i class=\"ico-check\"></i> <b>ico-check</b></li>\r\n      <li><i class=\"ico-edit\"></i> <b>ico-edit</b></li>\r\n      <li><i class=\"ico-new-window\"></i> <b>ico-new-window</b></li>\r\n      <li><i class=\"ico-more-windows\"></i> <b>ico-more-windows</b></li>\r\n      <li><i class=\"ico-show-big-thumbnails\"></i> <b>ico-show-big-thumbnails</b></li>\r\n      <li><i class=\"ico-show-thumbnails\"></i> <b>ico-show-thumbnails</b></li>\r\n      <li><i class=\"ico-show-thumbnails-lines\"></i> <b>ico-show-thumbnails-lines</b></li>\r\n      <li><i class=\"ico-show-lines\"></i> <b>ico-show-lines</b></li>\r\n      <li><i class=\"ico-playlist\"></i> <b>ico-playlist</b></li>\r\n      <li><i class=\"ico-picture\"></i> <b>ico-picture</b></li>\r\n      <li><i class=\"ico-imac\"></i> <b>ico-imac</b></li>\r\n      <li><i class=\"ico-macbook\"></i> <b>ico-macbook</b></li>\r\n      <li><i class=\"ico-ipad\"></i> <b>ico-ipad</b></li>\r\n      <li><i class=\"ico-iphone\"></i> <b>ico-iphone</b></li>\r\n      <li><i class=\"ico-iphone-transfer\"></i> <b>ico-iphone-transfer</b></li>\r\n      <li><i class=\"ico-iphone-exchange\"></i> <b>ico-iphone-exchange</b></li>\r\n      <li><i class=\"ico-ipod\"></i> <b>ico-ipod</b></li>\r\n      <li><i class=\"ico-ipod-shuffle\"></i> <b>ico-ipod-shuffle</b></li>\r\n      <li><i class=\"ico-ear-plugs\"></i> <b>ico-ear-plugs</b></li>\r\n      <li><i class=\"ico-albums\"></i> <b>ico-albums</b></li>\r\n      <li><i class=\"ico-step-backward\"></i> <b>ico-step-backward</b></li>\r\n      <li><i class=\"ico-fast-backward\"></i> <b>ico-fast-backward</b></li>\r\n      <li><i class=\"ico-rewind\"></i> <b>ico-rewind</b></li>\r\n      <li><i class=\"ico-play\"></i> <b>ico-play</b></li>\r\n      <li><i class=\"ico-pause\"></i> <b>ico-pause</b></li>\r\n      <li><i class=\"ico-stop\"></i> <b>ico-stop</b></li>\r\n      <li><i class=\"ico-forward\"></i> <b>ico-forward</b></li>\r\n      <li><i class=\"ico-fast-forward\"></i> <b>ico-fast-forward</b></li>\r\n      <li><i class=\"ico-step-forward\"></i> <b>ico-step-forward</b></li>\r\n      <li><i class=\"ico-eject\"></i> <b>ico-eject</b></li>\r\n    </ul>	\r\n  </div>\r\n\r\n\r\n  <div class=\"four columns\">\r\n    <ul class=\"the-icons\">\r\n      <li><i class=\"ico-facetime-video\"></i> <b>ico-facetime-video</b></li>\r\n      <li><i class=\"ico-download-alt\"></i> <b>ico-download-alt</b></li>\r\n      <li><i class=\"ico-mute\"></i> <b>ico-mute</b></li>\r\n      <li><i class=\"ico-volume-up\"></i> <b>ico-volume-up</b></li>\r\n      <li><i class=\"ico-volume-down\"></i> <b>ico-volume-down</b></li>\r\n      <li><i class=\"ico-screenshot\"></i> <b>ico-screenshot</b></li>\r\n      <li><i class=\"ico-move\"></i> <b>ico-move</b></li>\r\n      <li><i class=\"ico-more\"></i> <b>ico-more</b></li>\r\n      <li><i class=\"ico-brightness-reduce\"></i> <b>ico-brightness-reduce</b></li>\r\n      <li><i class=\"ico-brightness-increase\"></i> <b>ico-brightness-increase</b></li>\r\n      <li><i class=\"ico-circle-plus\"></i> <b>ico-circle-plus</b></li>\r\n      <li><i class=\"ico-circle-minus\"></i> <b>ico-circle-minus</b></li>\r\n      <li><i class=\"ico-circle-remove\"></i> <b>ico-circle-remove</b></li>\r\n      <li><i class=\"ico-circle-ok\"></i> <b>ico-circle-ok</b></li>\r\n      <li><i class=\"ico-circle-question-mark\"></i> <b>ico-circle-question-mark</b></li>\r\n      <li><i class=\"ico-circle-info\"></i> <b>ico-circle-info</b></li>\r\n      <li><i class=\"ico-circle-exclamation-mark\"></i> <b>ico-circle-exclamation-mark</b></li>\r\n      <li><i class=\"ico-remove\"></i> <b>ico-remove</b></li>\r\n      <li><i class=\"ico-ok\"></i> <b>ico-ok</b></li>\r\n      <li><i class=\"ico-ban\"></i> <b>ico-ban</b></li>\r\n      <li><i class=\"ico-download\"></i> <b>ico-download</b></li>\r\n      <li><i class=\"ico-upload\"></i> <b>ico-upload</b></li>\r\n      <li><i class=\"ico-shopping-cart\"></i> <b>ico-shopping-cart</b></li>\r\n      <li><i class=\"ico-lock\"></i> <b>ico-lock</b></li>\r\n      <li><i class=\"ico-unlock\"></i> <b>ico-unlock</b></li>\r\n      <li><i class=\"ico-electricity\"></i> <b>ico-electricity</b></li>\r\n      <li><i class=\"ico-ok\"></i> <b>ico-ok</b></li>\r\n      <li><i class=\"ico-remove\"></i> <b>ico-remove</b></li>\r\n      <li><i class=\"ico-cart-out\"></i> <b>ico-cart-out</b></li>\r\n      <li><i class=\"ico-cart-in\"></i> <b>ico-cart-in</b></li>\r\n      <li><i class=\"ico-left-arrow\"></i> <b>ico-left-arrow</b></li>\r\n      <li><i class=\"ico-right-arrow\"></i> <b>ico-right-arrow</b></li>\r\n      <li><i class=\"ico-down-arrow\"></i> <b>ico-down-arrow</b></li>\r\n      <li><i class=\"ico-up-arrow\"></i> <b>ico-up-arrow</b></li>\r\n      <li><i class=\"ico-resize-small\"></i> <b>ico-resize-small</b></li>\r\n      <li><i class=\"ico-resize-full\"></i> <b>ico-resize-full</b></li>\r\n      <li><i class=\"ico-circle-arrow-left\"></i> <b>ico-circle-arrow-left</b></li>\r\n      <li><i class=\"ico-circle-arrow-right\"></i> <b>ico-circle-arrow-right</b></li>\r\n      <li><i class=\"ico-circle-arrow-top\"></i> <b>ico-circle-arrow-top</b></li>\r\n      <li><i class=\"ico-circle-arrow-down\"></i> <b>ico-</b></li>\r\n      <li><i class=\"ico-play-button\"></i> <b>ico-play-button</b></li>\r\n      <li><i class=\"ico-unshare\"></i> <b>ico-unshare</b></li>\r\n      <li><i class=\"ico-share\"></i> <b>ico-share</b></li>\r\n      <li><i class=\"ico-thin-right-arrow\"></i> <b>ico-thin-right-arrow</b></li>\r\n      <li><i class=\"ico-thin-left-arrow\"></i> <b>ico-thin-left-arrow</b></li>\r\n      <li><i class=\"ico-bluetooth\"></i> <b>ico-bluetooth</b></li>\r\n      <li><i class=\"ico-euro\"></i> <b>ico-euro</b></li>\r\n      <li><i class=\"ico-usd\"></i> <b>ico-usd</b></li>\r\n      <li><i class=\"ico-bp\"></i> <b>ico-bp</b></li>\r\n      <li><i class=\"ico-retweet\"></i> <b>ico-retweet</b></li>\r\n      <li><i class=\"ico-moon\"></i> <b>ico-moon</b></li>\r\n      <li><i class=\"ico-sun\"></i> <b>ico-sun</b></li>\r\n      <li><i class=\"ico-cloud\"></i> <b>ico-cloud</b></li>\r\n      <li><i class=\"ico-direction\"></i> <b>ico-directio</b></li>\r\n      <li><i class=\"ico-brush\"></i> <b>ico-brush</b></li>\r\n      <li><i class=\"ico-pen\"></i> <b>ico-pen</b></li>\r\n      <li><i class=\"ico-zoom-in\"></i> <b>ico-zoom-in</b></li>\r\n      <li><i class=\"ico-zoom-out\"></i> <b>ico-zoom-out</b></li>\r\n      <li><i class=\"ico-pin\"></i> <b>ico-pin</b></li>\r\n      <li><i class=\"ico-riflescope\"></i> <b>ico-riflescope</b></li>\r\n      <li><i class=\"ico-rotation-lock\"></i> <b>ico-rotation-lock</b></li>\r\n      <li><i class=\"ico-flash\"></i> <b>ico-flash</b></li>\r\n      <li><i class=\"ico-google-maps\"></i> <b>ico-google-maps</b></li>\r\n      <li><i class=\"ico-anchor\"></i> <b>ico-anchor</b></li>\r\n      <li><i class=\"ico-conversation\"></i> <b>ico-conversation</b></li>\r\n      <li><i class=\"ico-chat\"></i> <b>ico-chat</b></li>\r\n      <li><i class=\"ico-male\"></i> <b>ico-male</b></li>\r\n      <li><i class=\"ico-female\"></i> <b>ico-female</b></li>\r\n      <li><i class=\"ico-asterisk\"></i> <b>ico-asterisk</b></li>\r\n      <li><i class=\"ico-divide\"></i> <b>ico-divide</b></li>\r\n      <li><i class=\"ico-snorkel-diving\"></i> <b>ico-snorkel-diving</b></li>\r\n      <li><i class=\"ico-scuba-diving\"></i> <b>ico-scuba-diving</b></li>\r\n      <li><i class=\"ico-oxygen-vottle\"></i> <b>ico-oxygen-vottle</b></li>\r\n      <li><i class=\"ico-fins\"></i> <b>ico-fins</b></li>\r\n      <li><i class=\"ico-fishes\"></i> <b>ico-fishes</b></li>\r\n      <li><i class=\"ico-boat\"></i> <b>ico-boat</b></li>\r\n      <li><i class=\"ico-delete-point\"></i> <b>ico-delete-point</b></li>\r\n      <li><i class=\"ico-sheriffs-star\"></i> <b>ico-sheriffs-star</b></li>\r\n      <li><i class=\"ico-qrcode\"></i> <b>ico-qrcode</b></li>\r\n      <li><i class=\"ico-barcode\"></i> <b>ico-barcode\"</b></li>\r\n      <li><i class=\"ico-pool\"></i> <b>ico-pool</b></li>\r\n      <li><i class=\"ico-buoy\"></i> <b>ico-buoy</b></li>\r\n      <li><i class=\"ico-spade\"></i> <b>ico-spade</b></li>\r\n      <li><i class=\"ico-bank\"></i> <b>ico-bank</b></li>\r\n      <li><i class=\"ico-vcard\"></i> <b>ico-vcard</b></li>\r\n      <li><i class=\"ico-electircal-plug\"></i> <b>ico-electircal-plug</b></li>\r\n      <li><i class=\"ico-flag\"></i> <b>ico-flag</b></li>\r\n      <li><i class=\"ico-credit-card\"></i> <b>ico-credit-card</b></li>\r\n      <li><i class=\"ico-keyboard-wirelsss\"></i> <b>ico-keyboard-wirelsss</b></li>\r\n      <li><i class=\"ico-keyboard-wired\"></i> <b>ico-keyboard-wired</b></li>\r\n    </ul>	\r\n  </div>\r\n\r\n  <div class=\"four columns\">\r\n    <ul class=\"the-icons\">\r\n      <li><i class=\"ico-shield\"></i> <b>ico-shield</b></li>\r\n      <li><i class=\"ico-ring\"></i> <b>ico-ring</b></li>\r\n      <li><i class=\"ico-cake\"></i> <b>ico-cake</b></li>\r\n      <li><i class=\"ico-drink\"></i> <b>ico-drink</b></li>\r\n      <li><i class=\"ico-beer\"></i> <b>ico-beer</b></li>\r\n      <li><i class=\"ico-fast-food\"></i> <b>ico-fast-food</b></li>\r\n      <li><i class=\"ico-cutlery\"></i> <b>ico-cutlery</b></li>\r\n      <li><i class=\"ico-pizza\"></i> <b>ico-pizza</b></li>\r\n      <li><i class=\"ico-birthday-cake\"></i> <b>ico-birthday-cake</b></li>\r\n      <li><i class=\"ico-tablet\"></i> <b>ico-tablet</b></li>\r\n      <li><i class=\"ico-settings\"></i> <b>ico-settings</b></li>\r\n      <li><i class=\"ico-bullets\"></i> <b>ico-bullets</b></li>\r\n      <li><i class=\"ico-cardio\"></i> <b>ico-cardio</b></li>\r\n      <li><i class=\"ico-t-shirt\"></i> <b>ico-t-shirt</b></li>\r\n      <li><i class=\"ico-pants\"></i> <b>ico-pants</b></li>\r\n      <li><i class=\"ico-sweater\"></i> <b>ico-sweater</b></li>\r\n      <li><i class=\"ico-fabric\"></i> <b>ico-fabric</b></li>\r\n      <li><i class=\"ico-leather\"></i> <b>ico-leather</b></li>\r\n      <li><i class=\"ico-scissors\"></i> <b>ico-scissors</b></li>\r\n      <li><i class=\"ico-podium\"></i> <b>ico-podium</b></li>\r\n      <li><i class=\"ico-skull\"></i> <b>ico-skull</b></li>\r\n      <li><i class=\"ico-celebration\"></i> <b>ico-celebratio</b></li>\r\n      <li><i class=\"ico-tea-kettle\"></i> <b>ico-tea-kettle</b></li>\r\n      <li><i class=\"ico-french-press\"></i> <b>ico-french-press</b></li>\r\n      <li><i class=\"ico-coffe-cup\"></i> <b>ico-coffe-cup</b></li>\r\n      <li><i class=\"ico-pot\"></i> <b>ico-pot</b></li>\r\n      <li><i class=\"ico-grater\"></i> <b>ico-grater</b></li>\r\n      <li><i class=\"ico-kettle\"></i> <b>ico-kettle</b></li>\r\n      <li><i class=\"ico-hospital\"></i> <b>ico-hospital</b></li>\r\n      <li><i class=\"ico-hospital-h\"></i> <b>ico-hospital-h</b></li>\r\n      <li><i class=\"ico-microphone\"></i> <b>ico-microphone</b></li>\r\n      <li><i class=\"ico-webcam\"></i> <b>ico-webcam</b></li>\r\n      <li><i class=\"ico-temple-church\"></i> <b>ico-temple-church</b></li>\r\n      <li><i class=\"ico-temple-islam\"></i> <b>ico-temple-islam</b></li>\r\n      <li><i class=\"ico-temple-hindu\"></i> <b>ico-temple-hindu</b></li>\r\n      <li><i class=\"ico-temple-buddhist\"></i> <b>ico-temple-buddhist</b></li>\r\n      <li><i class=\"ico-electrical-socket-eu\"></i> <b>ico-electrical-socket-eu</b></li>\r\n      <li><i class=\"ico-electrical-socket-us\"></i> <b>ico-electrical-socket-us</b></li>\r\n      <li><i class=\"ico-bomb\"></i> <b>ico-bomb</b></li>\r\n      <li><i class=\"ico-comments\"></i> <b>ico-comments</b></li>\r\n      <li><i class=\"ico-flower\"></i> <b>ico-flower</b></li>\r\n      <li><i class=\"ico-baseball\"></i> <b>ico-baseball</b></li>\r\n      <li><i class=\"ico-rugby\"></i> <b>ico-rugby</b></li>\r\n      <li><i class=\"ico-ax\"></i> <b>ico-ax</b></li>\r\n      <li><i class=\"ico-table-tennis\"></i> <b>ico-table-tennis</b></li>\r\n      <li><i class=\"ico-bowling\"></i> <b>ico-bowling\"</b></li>\r\n      <li><i class=\"ico-tree-conifer\"></i> <b>ico-tree-conifer</b></li>\r\n      <li><i class=\"ico-tree-deciduous\"></i> <b>ico-tree-deciduous</b></li>\r\n      <li><i class=\"ico-more-items\"></i> <b>ico-more-items</b></li>\r\n      <li><i class=\"ico-sort\"></i> <b>ico-sort</b></li>\r\n      <li><i class=\"ico-filter\"></i> <b>icofilter-</b></li>\r\n      <li><i class=\"ico-gamepad\"></i> <b>ico-gamepad</b></li>\r\n      <li><i class=\"ico-playing-dices\"></i> <b>ico-playing-dices</b></li>\r\n      <li><i class=\"ico-calculator\"></i> <b>ico-calculator</b></li>\r\n      <li><i class=\"ico-tie\"></i> <b>ico-tie</b></li>\r\n      <li><i class=\"ico-wallet\"></i> <b>ico-wallet</b></li>\r\n      <li><i class=\"ico-share\"></i> <b>ico-share</b></li>\r\n      <li><i class=\"ico-sampler\"></i> <b>ico-sampler</b></li>\r\n      <li><i class=\"ico-piano\"></i> <b>ico-piano</b></li>\r\n      <li><i class=\"ico-web-browser\"></i> <b>ico-web-browser</b></li>\r\n      <li><i class=\"ico-blog\"></i> <b>ico-blog</b></li>\r\n      <li><i class=\"ico-dashboard\"></i> <b>ico-dashboard</b></li>\r\n      <li><i class=\"ico-certificate\"></i> <b>ico-certificate</b></li>\r\n      <li><i class=\"ico-bell\"></i> <b>ico-bell</b></li>\r\n      <li><i class=\"ico-candle\"></i> <b>ico-candle</b></li>\r\n      <li><i class=\"ico-pin-classic\"></i> <b>ico-pin-classic</b></li>\r\n      <li><i class=\"ico-iphone-shake\"></i> <b>ico-iphone-shake</b></li>\r\n      <li><i class=\"ico-pin-flag\"></i> <b>ico-pin-flag</b></li>\r\n      <li><i class=\"ico-turtle\"></i> <b>ico-turtle</b></li>\r\n      <li><i class=\"ico-rabbit\"></i> <b>ico-rabbit</b></li>\r\n      <li><i class=\"ico-globe\"></i> <b>ico-globe</b></li>\r\n      <li><i class=\"ico-briefcase\"></i> <b>ico-briefcase</b></li>\r\n      <li><i class=\"ico-hdd\"></i> <b>ico-hdd</b></li>\r\n      <li><i class=\"ico-thumbs-up\"></i> <b>ico-thumbs-up</b></li>\r\n      <li><i class=\"ico-thumbs-down\"></i> <b>ico-thumbs-down</b></li>\r\n      <li><i class=\"ico-hand-right\"></i> <b>ico-hand-right</b></li>\r\n      <li><i class=\"ico-hand-left\"></i> <b>ico--hand-left</b></li>\r\n      <li><i class=\"ico-hand-up\"></i> <b>ico-hand-up</b></li>\r\n      <li><i class=\"ico-hand-down\"></i> <b>ico-hand-down</b></li>\r\n      <li><i class=\"ico-fullscreen\"></i> <b>ico-fullscreen</b></li>\r\n      <li><i class=\"ico-shopping-bag\"></i> <b>ico-shopping-bag</b></li>\r\n      <li><i class=\"ico-book-open\"></i> <b>ico-book-open</b></li>\r\n      <li><i class=\"ico-nameplate\"></i> <b>ico-nameplate</b></li>\r\n      <li><i class=\"ico-nameplate-alt\"></i> <b>ico-nameplate-alt</b></li>\r\n      <li><i class=\"ico-vases\"></i> <b>ico-vases</b></li>\r\n      <li><i class=\"ico-announcement\"></i> <b>ico-announcement</b></li>\r\n      <li><i class=\"ico-dumbbell\"></i> <b>ico-dumbbell</b></li>\r\n      <li><i class=\"ico-suitcase\"></i> <b>ico-suitcase</b></li>\r\n      <li><i class=\"ico-file-import\"></i> <b>ico-file-import</b></li>\r\n      <li><i class=\"ico-file-export\"></i> <b>ico-file-export</b></li>\r\n    </ul>	\r\n  </div>\r\n</div>','','full_html'),('node','page',0,13,13,'und',0,'<div class=\"container\">\r\n\r\n  <!-- 16 Columns -->\r\n  <div class=\"sixteen columns\">\r\n    <div class=\"headline no-margin\"><h3>16 Columns</h3></div>\r\n    <p>Cras consequat porttitor tincidunt. Praesent eu tincidunt lacus. Donec ut neque vitae erat congue venenatis. Duis hendrerit lacinia leo in dignissim. Aliquam erat volutpat. Sed dignissim hendrerit nibh, quis faucibus erat cursus eget. Integer porta nisl vitae felis rutrum ut mollis felis congue. Vestibulum augue nisl, egestas eu rhoncus eu, fermentum in leo. Pellentesque ultricies pharetra nulla sit amet sagittis. Curabitur at feugiat nibh. Duis sit amet odio eros. Donec non purus non augue cursus convallis sed id purus. In fringilla luctus scelerisque. Donec mauris magna, iaculis non suscipit eu, pellentesque nec urna.</p>\r\n  </div>\r\n  <!-- 16 Columns End -->\r\n\r\n</div>\r\n<!-- 960 Container End -->\r\n\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <!-- 1/2 Columns -->\r\n  <div class=\"eight columns\">\r\n    <div class=\"headline\"><h3>8 Columns</h3></div>\r\n    <p>Praesent ut ante id metus sollicitudin sodales. Mauris dictum, lorem quis pretium feugiat, nibh metus ultricies quam, nec venenatis dolor dolor at massa. Aliquam aliquet quam augue feugiat in lore ipsum dolor sit amet convallis magna suscipit.</p>\r\n  </div>\r\n\r\n  <div class=\"eight columns\">\r\n    <div class=\"headline\"><h3>8 Columns</h3></div>\r\n    <p>Praesent ut ante id metus sollicitudin sodales. Mauris dictum, lorem quis pretium feugiat, nibh metus ultricies quam, nec venenatis dolor dolor at massa. Aliquam aliquet quam augue feugiat in lore ipsum dolor sit amet convallis magna suscipit.</p>\r\n  </div>\r\n  <!-- 1/2 Columns End -->\r\n\r\n</div>\r\n<!-- 960 Container End -->\r\n\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <!-- 1/3 Columns -->\r\n  <div class=\"one-third column\">\r\n    <div class=\"headline\"><h3>1/3 Column</h3></div>\r\n    <p>Cras semper facilisis vestibulum. Nam purus magna, venenatis a mollis at, lacinia id lacus. Quisque metus arcu, condimentum vitae dignissim at, condimentum id dui. Fusce at dui metus. Nulla in purus in mauris luctus gravida vel vitae arcu Magna nisi. Integer ut risus nulla.</p>\r\n  </div>\r\n\r\n  <div class=\"one-third column\">\r\n    <div class=\"headline\"><h3>1/3 Column</h3></div>\r\n    <p>Cras semper facilisis vestibulum. Nam purus magna, venenatis a mollis at, lacinia id lacus. Quisque metus arcu, condimentum vitae dignissim at, condimentum id dui. Fusce at dui metus. Nulla in purus in mauris luctus gravida vel vitae arcu Magna nisi. Integer ut risus nulla.</p>\r\n  </div>\r\n\r\n  <div class=\"one-third column\">\r\n    <div class=\"headline\"><h3>1/3 Column</h3></div>\r\n    <p>Cras semper facilisis vestibulum. Nam purus magna, venenatis a mollis at, lacinia id lacus. Quisque metus arcu, condimentum vitae dignissim at, condimentum id dui. Fusce at dui metus. Nulla in purus in mauris luctus gravida vel vitae arcu Magna nisi. Integer ut risus nulla.</p>\r\n  </div>\r\n  <!-- 1/3 Columns End -->\r\n\r\n</div>\r\n<!-- 960 Container End -->\r\n\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <!-- 1/4 Columns End -->\r\n  <div class=\"four columns\">\r\n    <div class=\"headline\"><h3>1/4 Column</h3></div>\r\n    <p>Magna nisi. Integer ut risus nulla. Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas. Nullam vitae neque luctus dolor pulvinar condimentum nec sed.</p>\r\n  </div>\r\n\r\n  <div class=\"four columns\">\r\n    <div class=\"headline\"><h3>1/4 Column</h3></div>\r\n    <p>Magna nisi. Integer ut risus nulla. Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas. Nullam vitae neque luctus dolor pulvinar condimentum nec sed.</p>\r\n  </div>\r\n\r\n  <div class=\"four columns\">\r\n    <div class=\"headline\"><h3>1/4 Column</h3></div>\r\n    <p>Magna nisi. Integer ut risus nulla. Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas. Nullam vitae neque luctus dolor pulvinar condimentum nec sed.</p>\r\n  </div>\r\n\r\n  <div class=\"four columns\">\r\n    <div class=\"headline\"><h3>1/4 Column</h3></div>\r\n    <p>Magna nisi. Integer ut risus nulla. Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas. Nullam vitae neque luctus dolor pulvinar condimentum nec sed.</p>\r\n  </div>\r\n  <!-- 1/4 Columns End -->\r\n\r\n</div>\r\n<!-- 960 Container End -->\r\n\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <!-- 12 Columns -->\r\n  <div class=\"twelve columns\">\r\n    <div class=\"headline\"><h3>12 Columns</h3></div>\r\n    <p>Sed at odio ut arcu fringilla dictum eu eu nisl. Donec rutrum erat non arcu gravida porttitor. Nunc et magna nisi.Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas. Maecenas ut nulla quis eros scelerisque posuere vel vitae nibh. Proin id condimentum sem. Morbi vitae dui in magna vestibulum suscipit vitae vel nunc. Integer ut risus nulla. malesuada tortor, nec scelerisque lorem mattis  lore Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas nullam vitae neque luctus dolor.</p>\r\n  </div>\r\n\r\n  <div class=\"four columns\">\r\n    <div class=\"headline\"><h3>4 Columns</h3></div>\r\n    <p>Magna nisi. Integer ut risus nulla lorem. Aliquam at erat in purus aliquet mollis nullam vitae pulvinar condimentum nec aiquam at erat in purus aliquet mollis lorem ipsum dolor sed.</p>\r\n  </div>\r\n\r\n</div>','','full_html'),('node','page',0,14,14,'und',0,'<div class=\"container\">\r\n\r\n  <!-- Standard Structure -->\r\n  <div class=\"two-thirds column\">\r\n    <div class=\"headline no-margin\"><h4>Our Approach</h4></div>\r\n    <p>Donec odio ut arcu fringilla dictum eu eu nisl. Donec rutrum erat non arcu gravida porttitor. Nunc et magna nisi.Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas. Maecenas ut nulla quis eros scelerisque posuere vel vitae nibh. Proin id condimentum sem. Morbi vitae dui in magna vestibulum suscipit vitae vel nunc. Integer ut risus nulla. malesuada tortor, nec scelerisque lorem mattis.</p>\r\n    <p>Nunc et rutrum consetetur sadipscing elitr, sed diam nonumy at volutpat. Sed consectetur suscipit lorem nunc.adipiscing elit. Integer commodo tristique odio, quis fringilla ligula aliquet ut. Maecenas sed justo varius velit imperdiet bibendum</p>\r\n    <p>Integer commodo tristique odio, quis fringilla ligula aliquet ut. Maecenas sed justo varius velit imperdiet bibendum. Vivamus nec sapien massa, a imperdiet diam. Aliquam erat volutpat. Sed tetur suscipit nunc et rutrum. </p>\r\n  </div>\r\n\r\n  <div class=\"one-third column\">\r\n    <div class=\"headline no-margin\"><h4>Careers</h4></div>\r\n\r\n    <!-- Large Notice -->\r\n    <div class=\"large-notice\">\r\n      <h2>We\'re Hiring</h2>\r\n      <p>We\'re offering great oppurtunites for Project Manager and Web Designer.</p>\r\n      <a href=\"#\" class=\"button medium color\">Apply</a>\r\n    </div>\r\n    </p>\r\n  </div>\r\n  <!-- Standard Structure End -->\r\n\r\n\r\n  <div class=\"sixteen columns\">\r\n    <div class=\"headline low-margin\"><h4>Meet the Team</h4></div>\r\n  </div>\r\n\r\n  <!-- About -->\r\n  <div class=\"one-third column\">\r\n    <img src=\"/sites/all/themes/centum/images/about-01.png\" alt=\"\"/>\r\n    <div class=\"team-name\"><h5>Jane Smith</h5> <span>Chief Executive Officer / CEO</span></div>\r\n    <div class=\"team-about\"><p>Consectetur dolor ipsum quiam dolor adipisci velit, aenean at lorem vel est posuere feugiat sed quia noneas numquasa mode tempora incidunt ipsum.</p></div>\r\n\r\n    <!-- Social Icons -->\r\n    <ul class=\"social-icons about\">\r\n      <li class=\"facebook\"><a href=\"#\">Facebook</a></li>\r\n      <li class=\"linkedin\"><a href=\"#\">LinkedIn</a></li>\r\n      <li class=\"googleplus\"><a href=\"#\">Google Plus</a></li>\r\n    </ul>\r\n\r\n  </div>\r\n\r\n  <!-- About -->\r\n  <div class=\"one-third column\">\r\n    <div class=\"clear\"></div>\r\n    <img src=\"/sites/all/themes/centum/images/about-01.png\" alt=\"\"/>\r\n    <div class=\"team-name\"><h5>John Doe</h5> <span>Web Designer</span></div>\r\n    <div class=\"team-about\"><p>Consectetur dolor ipsum quiam dolor adipisci velit, aenean at lorem vel est posuere feugiat sed quia noneas numquasa mode tempora incidunt ipsum.</p></div>\r\n\r\n    <!-- Social Icons -->\r\n    <ul class=\"social-icons about\">\r\n      <li class=\"facebook\"><a href=\"#\">Facebook</a></li>\r\n      <li class=\"linkedin\"><a href=\"#\">LinkedIn</a></li>\r\n      <li class=\"forrst\"><a href=\"#\">Forrst</a></li>\r\n      <li class=\"dribbble\"><a href=\"#\">Dribbble</a></li>\r\n    </ul>\r\n\r\n  </div>\r\n\r\n  <!-- About -->\r\n  <div class=\"one-third column\">\r\n    <img src=\"/sites/all/themes/centum/images/about-01.png\" alt=\"\"/>\r\n    <div class=\"team-name\"><h5>Michael Smith</h5> <span>Project Manager</span></div>\r\n    <div class=\"team-about\"><p>Consectetur dolor ipsum quiam dolor adipisci velit, aenean at lorem vel est posuere feugiat sed quia noneas numquasa mode tempora incidunt ipsum.</p></div>\r\n\r\n    <!-- Social Icons -->\r\n    <ul class=\"social-icons about\">\r\n      <li class=\"facebook\"><a href=\"#\">Facebook</a></li>\r\n      <li class=\"linkedin\"><a href=\"#\">LinkedIn</a></li>\r\n      <li class=\"blogger\"><a href=\"#\">Blogger</a></li>\r\n      <li class=\"googleplus\"><a href=\"#\">Google Plus</a></li>\r\n      <li class=\"pintrest\"><a href=\"#\">Pintrest</a></li>\r\n    </ul>\r\n\r\n  </div>\r\n\r\n</div>\r\n<!-- 960 Container End -->','','full_html'),('node','page',0,15,15,'und',0,'<div class=\"container\">\r\n\r\n  <div class=\"sixteen columns\">\r\n    <div class=\"notification notice closeable\" style=\"margin: 5px 0 25px 0;\">\r\n      <p>If you\'re looking for service which isn\'t listed below, please send us a message!</p>\r\n    </div>\r\n  </div>\r\n\r\n  <div class=\"two-thirds column\">\r\n    <div class=\"headline no-margin\"><h4>Methodology</h4></div>\r\n\r\n    <div class=\"one-third column alpha\">\r\n      <p>Donec rutrum erat non arcu gravida porttitor. Nunc et magna nisi.Aliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis egestas. Maecenas ut nulla quis eros scelerisque posuere vel vitae nibh. Proin id condimentum sem. Morbi vitae dui in magna vestibulum suscipit vitae vel nunc. </p>\r\n    </div>\r\n\r\n    <div class=\"one-third column alpha\">\r\n      <p>Nunc et rutrum consetetur sadipscing elitr, sed diam nonumy at volutpat. Sed consectetur suscipit lorem nunc.adipiscing elit. Integer commodo tristique odio, quis fringilla ligula aliquet ut. Maecenas sed justo varius velit imperdietAliquam at erat in purus aliquet mollis. Fusce elementum velit vel dolor iaculis.</p>\r\n    </div>\r\n  </div>\r\n\r\n  <div class=\"one-third column\">\r\n    <div class=\"headline no-margin\"><h4>Features</h4></div>\r\n\r\n    <ul class=\"check_list\">\r\n      <li>Quick and convenient Localization Support</li>\r\n      <li>Compatible with the latest W3C standards</li>\r\n      <li>Flexible, Responsive Layout</li>\r\n      <li>Compatible with Major Browsers</li>\r\n      <li>Attuned to Smartphones and Tablet PCs</li>\r\n    </ul>\r\n    </p>\r\n  </div>\r\n\r\n  <div class=\"sixteen columns\">\r\n    <div class=\"headline low-margin\"><h4>Services</h4></div>\r\n  </div>\r\n\r\n  <!-- Icon Box Container -->\r\n  <div class=\"icon-boxes-container\">\r\n\r\n    <!-- Icon Box Start -->\r\n    <div class=\"eight columns\">\r\n      <div class=\"icon-box\">\r\n        <i class=\"ico-stats\" style=\"margin-left: -12px;\"></i>\r\n        <h3>Web Usability</h3>\r\n        <p>Proin iaculis purus consequat sem cure digni ssim. Donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt. Mauris ut ligula tortorea lorem ipsum dolor sit amet gorbi vel nulla eget quam porttitor gravida.</p>\r\n      </div>\r\n    </div>\r\n    <!-- Icon Box End -->\r\n\r\n    <!-- Icon Box Start -->\r\n    <div class=\"eight columns\">\r\n      <div class=\"icon-box\">\r\n        <i class=\"ico-thumbs-up\"></i>\r\n        <h3>Social Marketing</h3>\r\n        <p>Proin iaculis purus consequat sem cure digni ssim. Donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt. Mauris ut ligula tortorea lorem ipsum dolor sit amet gorbi vel nulla eget quam porttitor gravida.</p>\r\n      </div>\r\n    </div>\r\n    <!-- Icon Box End -->\r\n\r\n  </div>\r\n  <!-- Icon Box Container / End -->\r\n\r\n  <!-- Icon Box Container -->\r\n  <div class=\"icon-boxes-container\">\r\n\r\n    <!-- Icon Box Start -->\r\n    <div class=\"eight columns\">\r\n      <div class=\"icon-box\">\r\n        <i class=\"ico-display\" style=\"margin-left: -10px;\"></i>\r\n        <h3>Web Design</h3>\r\n        <p>Proin iaculis purus consequat sem cure digni ssim. Donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt. Mauris ut ligula tortorea lorem ipsum dolor sit amet gorbi vel nulla eget quam porttitor gravida.</p>\r\n      </div>\r\n    </div>\r\n    <!-- Icon Box End -->\r\n\r\n    <!-- Icon Box Start -->\r\n    <div class=\"eight columns\">\r\n      <div class=\"icon-box\">\r\n        <i class=\"ico-film\"></i>\r\n        <h3>Video Recording</h3>\r\n        <p>Proin iaculis purus consequat sem cure digni ssim. Donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt. Mauris ut ligula tortorea lorem ipsum dolor sit amet gorbi vel nulla eget quam porttitor gravida.</p>\r\n      </div>\r\n    </div>\r\n    <!-- Icon Box End -->\r\n\r\n  </div>\r\n  <!-- Icon Box Container / End -->\r\n\r\n\r\n</div>\r\n<!-- 960 Container End -->\r\n\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n  <div class=\"sixteen columns\">\r\n\r\n    <!-- Headline -->\r\n    <div class=\"headline\"><h4>Our Clients</h4></div>\r\n\r\n    <ul class=\"client-list\">\r\n      <li><img src=\"/sites/all/themes/centum/images/logo-01.png\" alt=\"\"/></li>\r\n      <li><img src=\"/sites/all/themes/centum/images/logo-02.png\" alt=\"\"/></li>\r\n      <li><img src=\"/sites/all/themes/centum/images/logo-03.png\" alt=\"\"/></li>\r\n      <li><img src=\"/sites/all/themes/centum/images/logo-04.png\" alt=\"\"/></li>\r\n      <li><img src=\"/sites/all/themes/centum/images/logo-05.png\" alt=\"\"/></li>\r\n    </ul>\r\n\r\n  </div>\r\n</div>','','full_html'),('node','page',0,16,16,'und',0,'<div class=\"container\">\r\n\r\n  <div class=\"sixteen columns\">\r\n\r\n    <div class=\"headline no-margin\">\r\n      <h4>Four Tables</h4>\r\n    </div>\r\n\r\n    <!-- Number of Tables / From 2 to 5 / -->\r\n    <div class=\"four-tables\">\r\n\r\n      <div class=\"pricing-table\">\r\n        <div class=\"color-1\">\r\n          <h3>Standard</h3>\r\n          <h4><span class=\"price\">$9.99</span> <span class=\"time\">per month</span></h4>\r\n          <ul>\r\n            <li>5 GB Storage</li>\r\n            <li>Free Live Support</li>\r\n            <li>Unlimited Users</li>\r\n            <li>No Time Tracking</li>\r\n            <li>Enhanced SSL Security</li>\r\n          </ul>\r\n          <a href=\"#\" class=\"sign-up\"><span>Sign Up</span></a>\r\n        </div>\r\n      </div>\r\n\r\n      <div class=\"pricing-table\">\r\n        <div class=\"color-2\">\r\n          <h3>Premium</h3>\r\n          <h4><span class=\"price\">$29.99</span> <span class=\"time\">per month</span></h4>\r\n          <ul>\r\n            <li>25 GB Storage</li>\r\n            <li>Free Live Support</li>\r\n            <li>Unlimited Users</li>\r\n            <li>No Time Tracking</li>\r\n            <li>Enhanced SSL Security</li>\r\n          </ul>\r\n          <a href=\"#\" class=\"sign-up\"><span>Sign Up</span></a>\r\n        </div>\r\n      </div>\r\n\r\n      <div class=\"pricing-table\">\r\n        <div class=\"color-3\">\r\n          <h3>Professional</h3>\r\n          <h4><span class=\"price\">$49.99</span> <span class=\"time\">per month</span></h4>\r\n          <ul>\r\n            <li>50 GB Storage</li>\r\n            <li>Free Live Support</li>\r\n            <li>Unlimited Users</li>\r\n            <li>No Time Tracking</li>\r\n            <li>Enhanced SSL Security</li>\r\n          </ul>\r\n          <a href=\"#\" class=\"sign-up\"><span>Sign Up</span></a>\r\n        </div>\r\n      </div>\r\n\r\n      <div class=\"pricing-table\">\r\n        <div class=\"color-2\">\r\n          <h3>Ultimate</h3>\r\n          <h4><span class=\"price\">$99.99</span> <span class=\"time\">per month</span></h4>\r\n          <ul>\r\n            <li>100 GB Storage</li>\r\n            <li>Free Live Support</li>\r\n            <li>Unlimited Users</li>\r\n            <li>No Time Tracking</li>\r\n            <li>Enhanced SSL Security</li>\r\n          </ul>\r\n          <a href=\"#\" class=\"sign-up\"><span>Sign Up</span></a>\r\n        </div>\r\n      </div>\r\n\r\n    </div>\r\n\r\n  </div>\r\n\r\n</div>\r\n<!-- 960 Container / End -->\r\n\r\n\r\n<!-- Three Tables\r\n================================================== -->\r\n\r\n<!-- 960 Container -->\r\n<div class=\"container\">\r\n\r\n  <div class=\"sixteen columns\">\r\n\r\n    <div class=\"headline\">\r\n      <h4>Three Tables</h4>\r\n    </div>\r\n\r\n    <!-- Number of Tables / From 2 to 5 / -->\r\n    <div class=\"three-tables\">\r\n\r\n      <div class=\"pricing-table\">\r\n        <div class=\"color-1\">\r\n          <h3>Standard</h3>\r\n          <h4><span class=\"price\">$9.99</span> <span class=\"time\">per month</span></h4>\r\n          <ul>\r\n            <li>5 GB Storage</li>\r\n            <li>Free Live Support</li>\r\n            <li>Unlimited Users</li>\r\n            <li>No Time Tracking</li>\r\n            <li>Enhanced SSL Security</li>\r\n          </ul>\r\n          <a href=\"#\" class=\"sign-up\"><span>Sign Up</span></a>\r\n        </div>\r\n      </div>\r\n\r\n      <div class=\"pricing-table\">\r\n        <div class=\"color-2\">\r\n          <h3>Premium</h3>\r\n          <h4><span class=\"price\">$29.99</span> <span class=\"time\">per month</span></h4>\r\n          <ul>\r\n            <li>25 GB Storage</li>\r\n            <li>Free Live Support</li>\r\n            <li>Unlimited Users</li>\r\n            <li>No Time Tracking</li>\r\n            <li>Enhanced SSL Security</li>\r\n          </ul>\r\n          <a href=\"#\" class=\"sign-up\"><span>Sign Up</span></a>\r\n        </div>\r\n      </div>\r\n\r\n      <div class=\"pricing-table\">\r\n        <div class=\"color-1\">\r\n          <h3>Professional</h3>\r\n          <h4><span class=\"price\">$49.99</span> <span class=\"time\">per month</span></h4>\r\n          <ul>\r\n            <li>50 GB Storage</li>\r\n            <li>Free Live Support</li>\r\n            <li>Unlimited Users</li>\r\n            <li>No Time Tracking</li>\r\n            <li>Enhanced SSL Security</li>\r\n          </ul>\r\n          <a href=\"#\" class=\"sign-up\"><span>Sign Up</span></a>\r\n        </div>\r\n      </div>\r\n\r\n    </div>\r\n\r\n  </div>\r\n\r\n</div>','','full_html');
/*!40000 ALTER TABLE `field_revision_body` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_comment_body`
--

DROP TABLE IF EXISTS `field_revision_comment_body`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_comment_body` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `comment_body_value` longtext,
  `comment_body_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `comment_body_format` (`comment_body_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 1 (comment_body)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_comment_body`
--

LOCK TABLES `field_revision_comment_body` WRITE;
/*!40000 ALTER TABLE `field_revision_comment_body` DISABLE KEYS */;
INSERT INTO `field_revision_comment_body` VALUES ('comment','comment_node_blog',0,1,1,'und',0,'Maecenas dignissim euismod nunc, in commodo est luctus eget. Proin in nunc laoreet justo volutpat blandit enim. Sem felis, ullamcorper vel aliquam non, varius eget justo. Duis quis nunc tellus. Mauris a felis arcu, vitae sollicitudin mauris. Aliquam quis tellus vel massa mattis ornare et eu felis. ','full_html'),('comment','comment_node_blog',0,2,2,'und',0,'Dignissim euismod nunc, in commodo est luctus eget. Proin in nunc laoreet justo volutpat blandit enim. Sem felis, ullamcorper vel aliquam non, varius eget justo. Duis quis nunc tellus. Mauris a felis arcu, vitae sollicitudin mauris. Aliquam quis tellus vel massa mattis.','full_html'),('comment','comment_node_blog',0,3,3,'und',0,'Morbi velit eros, sagittis in facilisis non, rhoncus et erat. Nam posuere tristique sem, eu ultricies tortor imperdiet vitae. Curabitur lacinia neque non metus','full_html');
/*!40000 ALTER TABLE `field_revision_comment_body` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_image`
--

DROP TABLE IF EXISTS `field_revision_field_image`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_image` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_image_fid` int(10) unsigned DEFAULT NULL COMMENT 'The file_managed.fid being referenced in this field.',
  `field_image_alt` varchar(512) DEFAULT NULL COMMENT 'Alternative image text, for the image’s ’alt’ attribute.',
  `field_image_title` varchar(1024) DEFAULT NULL COMMENT 'Image title text, for the image’s ’title’ attribute.',
  `field_image_width` int(10) unsigned DEFAULT NULL COMMENT 'The width of the image in pixels.',
  `field_image_height` int(10) unsigned DEFAULT NULL COMMENT 'The height of the image in pixels.',
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_image_fid` (`field_image_fid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 4 (field_image)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_image`
--

LOCK TABLES `field_revision_field_image` WRITE;
/*!40000 ALTER TABLE `field_revision_field_image` DISABLE KEYS */;
INSERT INTO `field_revision_field_image` VALUES ('node','blog',0,1,1,'und',0,1,'','',900,558),('node','blog',0,2,2,'und',0,2,'','',900,600),('node','blog',0,2,2,'und',1,3,'','',948,632),('node','blog',0,3,3,'und',0,4,'','',900,558),('node','blog',0,3,3,'und',1,5,'','',948,632),('node','portfolio',0,4,4,'und',0,8,'','',940,450),('node','portfolio',0,5,5,'und',0,10,'','',940,450),('node','portfolio',0,5,5,'und',1,9,'','',940,450),('node','portfolio',0,6,6,'und',0,11,'','',940,473),('node','portfolio',0,6,6,'und',1,12,'','',940,473),('node','portfolio',0,7,7,'und',0,13,'','',940,473),('node','portfolio',0,7,7,'und',1,14,'','',940,473),('node','portfolio',0,8,8,'und',0,15,'','',896,473),('node','portfolio',0,9,9,'und',0,16,'','',940,473),('node','portfolio',0,10,10,'und',0,17,'','',940,473),('node','portfolio',0,10,10,'und',1,18,'','',940,473),('node','portfolio',0,11,11,'und',0,19,'','',940,473),('node','portfolio',0,11,11,'und',1,20,'','',940,473);
/*!40000 ALTER TABLE `field_revision_field_image` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_portfolio_category`
--

DROP TABLE IF EXISTS `field_revision_field_portfolio_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_portfolio_category` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_portfolio_category_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_portfolio_category_tid` (`field_portfolio_category_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 5 (field_portfolio...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_portfolio_category`
--

LOCK TABLES `field_revision_field_portfolio_category` WRITE;
/*!40000 ALTER TABLE `field_revision_field_portfolio_category` DISABLE KEYS */;
INSERT INTO `field_revision_field_portfolio_category` VALUES ('node','portfolio',0,4,4,'und',0,7),('node','portfolio',0,4,4,'und',1,8),('node','portfolio',0,5,5,'und',0,8),('node','portfolio',0,5,5,'und',1,9),('node','portfolio',0,6,6,'und',0,9),('node','portfolio',0,6,6,'und',1,10),('node','portfolio',0,7,7,'und',0,7),('node','portfolio',0,7,7,'und',1,8),('node','portfolio',0,8,8,'und',0,8),('node','portfolio',0,8,8,'und',1,9),('node','portfolio',0,9,9,'und',0,9),('node','portfolio',0,9,9,'und',1,10),('node','portfolio',0,10,10,'und',0,9),('node','portfolio',0,10,10,'und',1,10),('node','portfolio',0,11,11,'und',0,9),('node','portfolio',0,11,11,'und',1,10);
/*!40000 ALTER TABLE `field_revision_field_portfolio_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_portfolio_client`
--

DROP TABLE IF EXISTS `field_revision_field_portfolio_client`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_portfolio_client` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_portfolio_client_value` varchar(255) DEFAULT NULL,
  `field_portfolio_client_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_portfolio_client_format` (`field_portfolio_client_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 7 (field_portfolio...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_portfolio_client`
--

LOCK TABLES `field_revision_field_portfolio_client` WRITE;
/*!40000 ALTER TABLE `field_revision_field_portfolio_client` DISABLE KEYS */;
INSERT INTO `field_revision_field_portfolio_client` VALUES ('node','portfolio',0,4,4,'und',0,'Google',NULL),('node','portfolio',0,5,5,'und',0,'Envato',NULL),('node','portfolio',0,6,6,'und',0,'Google',NULL),('node','portfolio',0,7,7,'und',0,'Google',NULL),('node','portfolio',0,8,8,'und',0,'Google',NULL),('node','portfolio',0,9,9,'und',0,'Google',NULL),('node','portfolio',0,10,10,'und',0,'Envato',NULL),('node','portfolio',0,11,11,'und',0,'Google',NULL);
/*!40000 ALTER TABLE `field_revision_field_portfolio_client` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_portfolio_link`
--

DROP TABLE IF EXISTS `field_revision_field_portfolio_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_portfolio_link` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_portfolio_link_value` varchar(255) DEFAULT NULL,
  `field_portfolio_link_format` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_portfolio_link_format` (`field_portfolio_link_format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 6 (field_portfolio_link)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_portfolio_link`
--

LOCK TABLES `field_revision_field_portfolio_link` WRITE;
/*!40000 ALTER TABLE `field_revision_field_portfolio_link` DISABLE KEYS */;
INSERT INTO `field_revision_field_portfolio_link` VALUES ('node','portfolio',0,4,4,'und',0,'http://tabvn.com',NULL),('node','portfolio',0,5,5,'und',0,'http://tabvn.com',NULL),('node','portfolio',0,6,6,'und',0,'http://tabvn.com',NULL),('node','portfolio',0,7,7,'und',0,'http://tabvn.com',NULL),('node','portfolio',0,8,8,'und',0,'http://tabvn.com',NULL),('node','portfolio',0,9,9,'und',0,'http://tabvn.com',NULL),('node','portfolio',0,10,10,'und',0,'http://tabvn.com',NULL),('node','portfolio',0,11,11,'und',0,'http://tabvn.com',NULL);
/*!40000 ALTER TABLE `field_revision_field_portfolio_link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_revision_field_tags`
--

DROP TABLE IF EXISTS `field_revision_field_tags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `field_revision_field_tags` (
  `entity_type` varchar(128) NOT NULL DEFAULT '' COMMENT 'The entity type this data is attached to',
  `bundle` varchar(128) NOT NULL DEFAULT '' COMMENT 'The field instance bundle to which this row belongs, used when deleting a field instance',
  `deleted` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this data item has been deleted',
  `entity_id` int(10) unsigned NOT NULL COMMENT 'The entity id this data is attached to',
  `revision_id` int(10) unsigned NOT NULL COMMENT 'The entity revision id this data is attached to',
  `language` varchar(32) NOT NULL DEFAULT '' COMMENT 'The language for this data item.',
  `delta` int(10) unsigned NOT NULL COMMENT 'The sequence number for this data item, used for multi-value fields',
  `field_tags_tid` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`entity_type`,`entity_id`,`revision_id`,`deleted`,`delta`,`language`),
  KEY `entity_type` (`entity_type`),
  KEY `bundle` (`bundle`),
  KEY `deleted` (`deleted`),
  KEY `entity_id` (`entity_id`),
  KEY `revision_id` (`revision_id`),
  KEY `language` (`language`),
  KEY `field_tags_tid` (`field_tags_tid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Revision archive storage for field 3 (field_tags)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `field_revision_field_tags`
--

LOCK TABLES `field_revision_field_tags` WRITE;
/*!40000 ALTER TABLE `field_revision_field_tags` DISABLE KEYS */;
INSERT INTO `field_revision_field_tags` VALUES ('node','blog',0,1,1,'und',0,1),('node','blog',0,1,1,'und',1,2),('node','blog',0,1,1,'und',2,3),('node','blog',0,2,2,'und',0,4),('node','blog',0,2,2,'und',1,5),('node','blog',0,2,2,'und',2,6),('node','blog',0,3,3,'und',0,1),('node','blog',0,3,3,'und',1,3);
/*!40000 ALTER TABLE `field_revision_field_tags` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `file_managed`
--

DROP TABLE IF EXISTS `file_managed`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `file_managed` (
  `fid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'File ID.',
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user who is associated with the file.',
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the file with no path components. This may differ from the basename of the URI if the file is renamed to avoid overwriting an existing file.',
  `uri` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT 'The URI to access the file (either local or remote).',
  `filemime` varchar(255) NOT NULL DEFAULT '' COMMENT 'The file’s MIME type.',
  `filesize` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The size of the file in bytes.',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A field indicating the status of the file. Two status are defined in core: temporary (0) and permanent (1). Temporary files older than DRUPAL_MAXIMUM_TEMP_FILE_AGE will be removed during a cron run.',
  `timestamp` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'UNIX timestamp for when the file was added.',
  PRIMARY KEY (`fid`),
  UNIQUE KEY `uri` (`uri`),
  KEY `uid` (`uid`),
  KEY `status` (`status`),
  KEY `timestamp` (`timestamp`)
) ENGINE=InnoDB AUTO_INCREMENT=23 DEFAULT CHARSET=utf8 COMMENT='Stores information for uploaded files.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `file_managed`
--

LOCK TABLES `file_managed` WRITE;
/*!40000 ALTER TABLE `file_managed` DISABLE KEYS */;
INSERT INTO `file_managed` VALUES (1,1,'blog-img-02-large.jpg','public://blog-img-02-large.jpg','image/jpeg',480892,1,1359708190),(2,1,'blog-img-04-large.jpg','public://blog-img-04-large.jpg','image/jpeg',270483,1,1359708253),(3,1,'blog-img-03-large.jpg','public://blog-img-03-large.jpg','image/jpeg',177865,1,1359708253),(4,1,'blog-img-02-large.jpg','public://blog-img-02-large_0.jpg','image/jpeg',480892,1,1359708289),(5,1,'blog-img-03-large.jpg','public://blog-img-03-large_0.jpg','image/jpeg',177865,1,1359708289),(6,0,'slider-img-01.jpg','public://banner/slider-img-01.jpg','',150818,1,1359710292),(7,0,'slider-img-02.jpg','public://banner/slider-img-02.jpg','',145481,1,1359710292),(8,1,'portoflio-single-02.jpg','public://portoflio-single-02.jpg','image/jpeg',112367,1,1359716915),(9,1,'portoflio-single-02.jpg','public://portoflio-single-02_0.jpg','image/jpeg',112367,1,1359717317),(10,1,'portoflio-single-01.jpg','public://portoflio-single-01.jpg','image/jpeg',127605,1,1359717317),(11,1,'project-02-a-940x473.jpg','public://project-02-a-940x473.jpg','image/jpeg',132455,1,1359734371),(12,1,'project-02-b-940x473.jpg','public://project-02-b-940x473.jpg','image/jpeg',74706,1,1359734371),(13,1,'project-03-940x473.jpg','public://project-03-940x473.jpg','image/jpeg',113841,1,1359734487),(14,1,'photodune-1178489-open-road-s1-940x473.jpg','public://photodune-1178489-open-road-s1-940x473.jpg','image/jpeg',135541,1,1359734487),(15,1,'project-04-896x473.jpg','public://project-04-896x473.jpg','image/jpeg',84462,1,1359734848),(16,1,'photodune-2335556-pine-tree-near-water-s-940x473.jpg','public://photodune-2335556-pine-tree-near-water-s-940x473.jpg','image/jpeg',69562,1,1359734895),(17,1,'project-01-a-940x473.jpg','public://project-01-a-940x473.jpg','image/jpeg',62804,1,1359734998),(18,1,'project-01-b-940x473.jpg','public://project-01-b-940x473.jpg','image/jpeg',56113,1,1359735009),(19,1,'project-08-a-940x473.jpg','public://project-08-a-940x473.jpg','image/jpeg',65749,1,1359735771),(20,1,'project-08-b-940x473.jpg','public://project-08-b-940x473.jpg','image/jpeg',135541,1,1359735771),(22,1,'picture-1-1359797281.jpg','public://pictures/picture-1-1359797281.jpg','image/png',1665,1,1359797281);
/*!40000 ALTER TABLE `file_managed` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `file_usage`
--

DROP TABLE IF EXISTS `file_usage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `file_usage` (
  `fid` int(10) unsigned NOT NULL COMMENT 'File ID.',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the module that is using the file.',
  `type` varchar(64) NOT NULL DEFAULT '' COMMENT 'The name of the object type in which the file is used.',
  `id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The primary key of the object using the file.',
  `count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The number of times this file is used by this object.',
  PRIMARY KEY (`fid`,`type`,`id`,`module`),
  KEY `type_id` (`type`,`id`),
  KEY `fid_count` (`fid`,`count`),
  KEY `fid_module` (`fid`,`module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Track where a file is used.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `file_usage`
--

LOCK TABLES `file_usage` WRITE;
/*!40000 ALTER TABLE `file_usage` DISABLE KEYS */;
INSERT INTO `file_usage` VALUES (1,'file','node',1,1),(2,'file','node',2,1),(3,'file','node',2,1),(4,'file','node',3,1),(5,'file','node',3,1),(8,'file','node',4,1),(9,'file','node',5,1),(10,'file','node',5,1),(11,'file','node',6,1),(12,'file','node',6,1),(13,'file','node',7,1),(14,'file','node',7,1),(15,'file','node',8,1),(16,'file','node',9,1),(17,'file','node',10,1),(18,'file','node',10,1),(19,'file','node',11,1),(20,'file','node',11,1),(22,'user','user',1,1);
/*!40000 ALTER TABLE `file_usage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `filter`
--

DROP TABLE IF EXISTS `filter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `filter` (
  `format` varchar(255) NOT NULL COMMENT 'Foreign key: The filter_format.format to which this filter is assigned.',
  `module` varchar(64) NOT NULL DEFAULT '' COMMENT 'The origin module of the filter.',
  `name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Name of the filter being referenced.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight of filter within format.',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'Filter enabled status. (1 = enabled, 0 = disabled)',
  `settings` longblob COMMENT 'A serialized array of name value pairs that store the filter settings for the specific format.',
  PRIMARY KEY (`format`,`name`),
  KEY `list` (`weight`,`module`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table that maps filters (HTML corrector) to text formats ...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `filter`
--

LOCK TABLES `filter` WRITE;
/*!40000 ALTER TABLE `filter` DISABLE KEYS */;
INSERT INTO `filter` VALUES ('filtered_html','filter','filter_autop',2,1,'a:0:{}'),('filtered_html','filter','filter_html',1,1,'a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('filtered_html','filter','filter_htmlcorrector',10,1,'a:0:{}'),('filtered_html','filter','filter_html_escape',-10,0,'a:0:{}'),('filtered_html','filter','filter_url',0,1,'a:1:{s:17:\"filter_url_length\";i:72;}'),('full_html','filter','filter_autop',1,1,'a:0:{}'),('full_html','filter','filter_html',-10,0,'a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('full_html','filter','filter_htmlcorrector',10,1,'a:0:{}'),('full_html','filter','filter_html_escape',-10,0,'a:0:{}'),('full_html','filter','filter_url',0,1,'a:1:{s:17:\"filter_url_length\";i:72;}'),('plain_text','filter','filter_autop',2,1,'a:0:{}'),('plain_text','filter','filter_html',-10,0,'a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('plain_text','filter','filter_htmlcorrector',10,0,'a:0:{}'),('plain_text','filter','filter_html_escape',0,1,'a:0:{}'),('plain_text','filter','filter_url',1,1,'a:1:{s:17:\"filter_url_length\";i:72;}'),('wysiwyg','filter','filter_autop',0,1,'a:0:{}'),('wysiwyg','filter','filter_html',-10,0,'a:3:{s:12:\"allowed_html\";s:74:\"<a> <em> <strong> <cite> <blockquote> <code> <ul> <ol> <li> <dl> <dt> <dd>\";s:16:\"filter_html_help\";i:1;s:20:\"filter_html_nofollow\";i:0;}'),('wysiwyg','filter','filter_htmlcorrector',10,1,'a:0:{}'),('wysiwyg','filter','filter_html_escape',-10,0,'a:0:{}'),('wysiwyg','filter','filter_url',0,1,'a:1:{s:17:\"filter_url_length\";s:2:\"72\";}');
/*!40000 ALTER TABLE `filter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `filter_format`
--

DROP TABLE IF EXISTS `filter_format`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `filter_format` (
  `format` varchar(255) NOT NULL COMMENT 'Primary Key: Unique machine name of the format.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the text format (Filtered HTML).',
  `cache` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Flag to indicate whether format is cacheable. (1 = cacheable, 0 = not cacheable)',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '1' COMMENT 'The status of the text format. (1 = enabled, 0 = disabled)',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight of text format to use when listing.',
  PRIMARY KEY (`format`),
  UNIQUE KEY `name` (`name`),
  KEY `status_weight` (`status`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores text formats: custom groupings of filters, such as...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `filter_format`
--

LOCK TABLES `filter_format` WRITE;
/*!40000 ALTER TABLE `filter_format` DISABLE KEYS */;
INSERT INTO `filter_format` VALUES ('filtered_html','Filtered HTML',1,1,-8),('full_html','Full HTML',1,1,-10),('plain_text','Plain text',1,1,-7),('wysiwyg','Wysiwyg',1,1,-9);
/*!40000 ALTER TABLE `filter_format` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `flood`
--

DROP TABLE IF EXISTS `flood`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `flood` (
  `fid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Unique flood event ID.',
  `event` varchar(64) NOT NULL DEFAULT '' COMMENT 'Name of event (e.g. contact).',
  `identifier` varchar(128) NOT NULL DEFAULT '' COMMENT 'Identifier of the visitor, such as an IP address or hostname.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp of the event.',
  `expiration` int(11) NOT NULL DEFAULT '0' COMMENT 'Expiration timestamp. Expired events are purged on cron run.',
  PRIMARY KEY (`fid`),
  KEY `allow` (`event`,`identifier`,`timestamp`),
  KEY `purge` (`expiration`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Flood controls the threshold of events, such as the...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `flood`
--

LOCK TABLES `flood` WRITE;
/*!40000 ALTER TABLE `flood` DISABLE KEYS */;
/*!40000 ALTER TABLE `flood` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `history`
--

DROP TABLE IF EXISTS `history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `history` (
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that read the node nid.',
  `nid` int(11) NOT NULL DEFAULT '0' COMMENT 'The node.nid that was read.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp at which the read occurred.',
  PRIMARY KEY (`uid`,`nid`),
  KEY `nid` (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A record of which users have read which nodes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `history`
--

LOCK TABLES `history` WRITE;
/*!40000 ALTER TABLE `history` DISABLE KEYS */;
INSERT INTO `history` VALUES (1,1,1360655964),(1,5,1360649813),(1,12,1361711920),(1,13,1361711995),(1,14,1361709271);
/*!40000 ALTER TABLE `history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `image_effects`
--

DROP TABLE IF EXISTS `image_effects`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `image_effects` (
  `ieid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for an image effect.',
  `isid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The image_styles.isid for an image style.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of the effect in the style.',
  `name` varchar(255) NOT NULL COMMENT 'The unique name of the effect to be executed.',
  `data` longblob NOT NULL COMMENT 'The configuration data for the effect.',
  PRIMARY KEY (`ieid`),
  KEY `isid` (`isid`),
  KEY `weight` (`weight`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='Stores configuration options for image effects.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `image_effects`
--

LOCK TABLES `image_effects` WRITE;
/*!40000 ALTER TABLE `image_effects` DISABLE KEYS */;
INSERT INTO `image_effects` VALUES (1,1,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"700\";s:6:\"height\";s:3:\"320\";}'),(2,2,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"460\";s:6:\"height\";s:3:\"290\";}'),(3,3,1,'image_scale_and_crop','a:2:{s:5:\"width\";s:3:\"940\";s:6:\"height\";s:3:\"450\";}');
/*!40000 ALTER TABLE `image_effects` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `image_styles`
--

DROP TABLE IF EXISTS `image_styles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `image_styles` (
  `isid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for an image style.',
  `name` varchar(255) NOT NULL COMMENT 'The style name.',
  PRIMARY KEY (`isid`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='Stores configuration options for image styles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `image_styles`
--

LOCK TABLES `image_styles` WRITE;
/*!40000 ALTER TABLE `image_styles` DISABLE KEYS */;
INSERT INTO `image_styles` VALUES (1,'blog_teaser'),(2,'portfolio_item'),(3,'portfolio_view');
/*!40000 ALTER TABLE `image_styles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menu_custom`
--

DROP TABLE IF EXISTS `menu_custom`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_custom` (
  `menu_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique key for menu. This is used as a block delta so length is 32.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'Menu title; displayed at top of block.',
  `description` text COMMENT 'Menu description.',
  PRIMARY KEY (`menu_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Holds definitions for top-level custom menus (for example...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_custom`
--

LOCK TABLES `menu_custom` WRITE;
/*!40000 ALTER TABLE `menu_custom` DISABLE KEYS */;
INSERT INTO `menu_custom` VALUES ('devel','Development','Development link'),('main-menu','Main menu','The <em>Main</em> menu is used on many sites to show the major sections of the site, often in a top navigation bar.'),('management','Management','The <em>Management</em> menu contains links for administrative tasks.'),('navigation','Navigation','The <em>Navigation</em> menu contains links intended for site visitors. Links are added to the <em>Navigation</em> menu automatically by some modules.'),('user-menu','User menu','The <em>User</em> menu contains links related to the user\'s account, as well as the \'Log out\' link.');
/*!40000 ALTER TABLE `menu_custom` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menu_links`
--

DROP TABLE IF EXISTS `menu_links`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_links` (
  `menu_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The menu name. All links with the same menu name (such as ’navigation’) are part of the same menu.',
  `mlid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The menu link ID (mlid) is the integer primary key.',
  `plid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The parent link ID (plid) is the mlid of the link above in the hierarchy, or zero if the link is at the top level in its menu.',
  `link_path` varchar(255) NOT NULL DEFAULT '' COMMENT 'The Drupal path or external path this link points to.',
  `router_path` varchar(255) NOT NULL DEFAULT '' COMMENT 'For links corresponding to a Drupal path (external = 0), this connects the link to a menu_router.path for joins.',
  `link_title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The text displayed for the link, which may be modified by a title callback stored in menu_router.',
  `options` blob COMMENT 'A serialized array of options to be passed to the url() or l() function, such as a query string or HTML attributes.',
  `module` varchar(255) NOT NULL DEFAULT 'system' COMMENT 'The name of the module that generated this link.',
  `hidden` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag for whether the link should be rendered in menus. (1 = a disabled menu item that may be shown on admin screens, -1 = a menu callback, 0 = a normal, visible link)',
  `external` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate if the link points to a full URL starting with a protocol, like http:// (1 = external, 0 = internal).',
  `has_children` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag indicating whether any links have this link as a parent (1 = children exist, 0 = no children).',
  `expanded` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag for whether this link should be rendered as expanded in menus - expanded links always have their child links displayed, instead of only when the link is in the active trail (1 = expanded, 0 = not expanded)',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Link weight among links in the same menu at the same depth.',
  `depth` smallint(6) NOT NULL DEFAULT '0' COMMENT 'The depth relative to the top level. A link with plid == 0 will have depth == 1.',
  `customized` smallint(6) NOT NULL DEFAULT '0' COMMENT 'A flag to indicate that the user has manually created or edited the link (1 = customized, 0 = not customized).',
  `p1` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The first mlid in the materialized path. If N = depth, then pN must equal the mlid. If depth > 1 then p(N-1) must equal the plid. All pX where X > depth must equal zero. The columns p1 .. p9 are also called the parents.',
  `p2` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The second mlid in the materialized path. See p1.',
  `p3` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The third mlid in the materialized path. See p1.',
  `p4` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fourth mlid in the materialized path. See p1.',
  `p5` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The fifth mlid in the materialized path. See p1.',
  `p6` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The sixth mlid in the materialized path. See p1.',
  `p7` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The seventh mlid in the materialized path. See p1.',
  `p8` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The eighth mlid in the materialized path. See p1.',
  `p9` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The ninth mlid in the materialized path. See p1.',
  `updated` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Flag that indicates that this link was generated during the update from Drupal 5.',
  PRIMARY KEY (`mlid`),
  KEY `path_menu` (`link_path`(128),`menu_name`),
  KEY `menu_plid_expand_child` (`menu_name`,`plid`,`expanded`,`has_children`),
  KEY `menu_parents` (`menu_name`,`p1`,`p2`,`p3`,`p4`,`p5`,`p6`,`p7`,`p8`,`p9`),
  KEY `router_path` (`router_path`(128))
) ENGINE=InnoDB AUTO_INCREMENT=416 DEFAULT CHARSET=utf8 COMMENT='Contains the individual links within a menu.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_links`
--

LOCK TABLES `menu_links` WRITE;
/*!40000 ALTER TABLE `menu_links` DISABLE KEYS */;
INSERT INTO `menu_links` VALUES ('management',1,0,'admin','admin','Administration','a:0:{}','system',0,0,1,0,9,1,0,1,0,0,0,0,0,0,0,0,0),('user-menu',2,0,'user','user','User account','a:1:{s:5:\"alter\";b:1;}','system',0,0,0,0,-10,1,0,2,0,0,0,0,0,0,0,0,0),('navigation',3,0,'comment/%','comment/%','Comment permalink','a:0:{}','system',0,0,1,0,0,1,0,3,0,0,0,0,0,0,0,0,0),('navigation',4,0,'filter/tips','filter/tips','Compose tips','a:0:{}','system',1,0,0,0,0,1,0,4,0,0,0,0,0,0,0,0,0),('navigation',5,0,'node/%','node/%','','a:0:{}','system',0,0,0,0,0,1,0,5,0,0,0,0,0,0,0,0,0),('navigation',6,0,'node/add','node/add','Add content','a:0:{}','system',0,0,1,0,0,1,0,6,0,0,0,0,0,0,0,0,0),('management',7,1,'admin/appearance','admin/appearance','Appearance','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"Select and configure your themes.\";}}','system',0,0,0,0,-6,2,0,1,7,0,0,0,0,0,0,0,0),('management',8,1,'admin/config','admin/config','Configuration','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:20:\"Administer settings.\";}}','system',0,0,1,0,0,2,0,1,8,0,0,0,0,0,0,0,0),('management',9,1,'admin/content','admin/content','Content','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:32:\"Administer content and comments.\";}}','system',0,0,1,0,-10,2,0,1,9,0,0,0,0,0,0,0,0),('user-menu',10,2,'user/register','user/register','Create new account','a:0:{}','system',-1,0,0,0,0,2,0,2,10,0,0,0,0,0,0,0,0),('management',11,1,'admin/dashboard','admin/dashboard','Dashboard','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View and customize your dashboard.\";}}','system',0,0,0,0,-15,2,0,1,11,0,0,0,0,0,0,0,0),('management',12,1,'admin/help','admin/help','Help','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:48:\"Reference for usage, configuration, and modules.\";}}','system',0,0,0,0,9,2,0,1,12,0,0,0,0,0,0,0,0),('management',13,1,'admin/index','admin/index','Index','a:0:{}','system',-1,0,0,0,-18,2,0,1,13,0,0,0,0,0,0,0,0),('user-menu',14,2,'user/login','user/login','Log in','a:0:{}','system',-1,0,0,0,0,2,0,2,14,0,0,0,0,0,0,0,0),('user-menu',15,0,'user/logout','user/logout','Log out','a:0:{}','system',0,0,0,0,10,1,0,15,0,0,0,0,0,0,0,0,0),('management',16,1,'admin/modules','admin/modules','Modules','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:26:\"Extend site functionality.\";}}','system',0,0,0,0,-2,2,0,1,16,0,0,0,0,0,0,0,0),('navigation',17,0,'user/%','user/%','My account','a:0:{}','system',0,0,1,0,0,1,0,17,0,0,0,0,0,0,0,0,0),('management',18,1,'admin/people','admin/people','People','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Manage user accounts, roles, and permissions.\";}}','system',0,0,0,0,-4,2,0,1,18,0,0,0,0,0,0,0,0),('management',19,1,'admin/reports','admin/reports','Reports','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:34:\"View reports, updates, and errors.\";}}','system',0,0,1,0,5,2,0,1,19,0,0,0,0,0,0,0,0),('user-menu',20,2,'user/password','user/password','Request new password','a:0:{}','system',-1,0,0,0,0,2,0,2,20,0,0,0,0,0,0,0,0),('management',21,1,'admin/structure','admin/structure','Structure','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Administer blocks, content types, menus, etc.\";}}','system',0,0,1,0,-8,2,0,1,21,0,0,0,0,0,0,0,0),('management',22,1,'admin/tasks','admin/tasks','Tasks','a:0:{}','system',-1,0,0,0,-20,2,0,1,22,0,0,0,0,0,0,0,0),('navigation',23,0,'comment/reply/%','comment/reply/%','Add new comment','a:0:{}','system',0,0,0,0,0,1,0,23,0,0,0,0,0,0,0,0,0),('navigation',24,3,'comment/%/approve','comment/%/approve','Approve','a:0:{}','system',0,0,0,0,1,2,0,3,24,0,0,0,0,0,0,0,0),('navigation',25,3,'comment/%/delete','comment/%/delete','Delete','a:0:{}','system',-1,0,0,0,2,2,0,3,25,0,0,0,0,0,0,0,0),('navigation',26,3,'comment/%/edit','comment/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,2,0,3,26,0,0,0,0,0,0,0,0),('navigation',27,0,'taxonomy/term/%','taxonomy/term/%','Taxonomy term','a:0:{}','system',0,0,0,0,0,1,0,27,0,0,0,0,0,0,0,0,0),('navigation',28,3,'comment/%/view','comment/%/view','View comment','a:0:{}','system',-1,0,0,0,-10,2,0,3,28,0,0,0,0,0,0,0,0),('management',29,18,'admin/people/create','admin/people/create','Add user','a:0:{}','system',-1,0,0,0,0,3,0,1,18,29,0,0,0,0,0,0,0),('management',30,21,'admin/structure/block','admin/structure/block','Blocks','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:79:\"Configure what block content appears in your site\'s sidebars and other regions.\";}}','system',0,0,1,0,0,3,0,1,21,30,0,0,0,0,0,0,0),('navigation',31,17,'user/%/cancel','user/%/cancel','Cancel account','a:0:{}','system',0,0,1,0,0,2,0,17,31,0,0,0,0,0,0,0,0),('management',32,9,'admin/content/comment','admin/content/comment','Comments','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:59:\"List and edit site comments and the comment approval queue.\";}}','system',0,0,0,0,0,3,0,1,9,32,0,0,0,0,0,0,0),('management',33,11,'admin/dashboard/configure','admin/dashboard/configure','Configure available dashboard blocks','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Configure which blocks can be shown on the dashboard.\";}}','system',-1,0,0,0,0,3,0,1,11,33,0,0,0,0,0,0,0),('management',34,9,'admin/content/node','admin/content/node','Content','a:0:{}','system',-1,0,0,0,-10,3,0,1,9,34,0,0,0,0,0,0,0),('management',35,8,'admin/config/content','admin/config/content','Content authoring','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:53:\"Settings related to formatting and authoring content.\";}}','system',0,0,1,0,-15,3,0,1,8,35,0,0,0,0,0,0,0),('management',36,21,'admin/structure/types','admin/structure/types','Content types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:92:\"Manage content types, including default status, front page promotion, comment settings, etc.\";}}','system',0,0,1,0,0,3,0,1,21,36,0,0,0,0,0,0,0),('management',37,11,'admin/dashboard/customize','admin/dashboard/customize','Customize dashboard','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:25:\"Customize your dashboard.\";}}','system',-1,0,0,0,0,3,0,1,11,37,0,0,0,0,0,0,0),('navigation',38,5,'node/%/delete','node/%/delete','Delete','a:0:{}','system',-1,0,0,0,1,2,0,5,38,0,0,0,0,0,0,0,0),('management',39,8,'admin/config/development','admin/config/development','Development','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Development tools.\";}}','system',0,0,1,0,-10,3,0,1,8,39,0,0,0,0,0,0,0),('navigation',40,17,'user/%/edit','user/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,2,0,17,40,0,0,0,0,0,0,0,0),('navigation',41,5,'node/%/edit','node/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,2,0,5,41,0,0,0,0,0,0,0,0),('management',42,19,'admin/reports/fields','admin/reports/fields','Field list','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Overview of fields on all entity types.\";}}','system',0,0,0,0,0,3,0,1,19,42,0,0,0,0,0,0,0),('management',43,7,'admin/appearance/list','admin/appearance/list','List','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:31:\"Select and configure your theme\";}}','system',-1,0,0,0,-1,3,0,1,7,43,0,0,0,0,0,0,0),('management',44,16,'admin/modules/list','admin/modules/list','List','a:0:{}','system',-1,0,0,0,0,3,0,1,16,44,0,0,0,0,0,0,0),('management',45,18,'admin/people/people','admin/people/people','List','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:50:\"Find and manage people interacting with your site.\";}}','system',-1,0,0,0,-10,3,0,1,18,45,0,0,0,0,0,0,0),('management',46,8,'admin/config/media','admin/config/media','Media','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:12:\"Media tools.\";}}','system',0,0,1,0,-10,3,0,1,8,46,0,0,0,0,0,0,0),('management',47,21,'admin/structure/menu','admin/structure/menu','Menus','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:86:\"Add new menus to your site, edit existing menus, and rename and reorganize menu links.\";}}','system',0,0,1,0,0,3,0,1,21,47,0,0,0,0,0,0,0),('management',48,8,'admin/config/people','admin/config/people','People','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:24:\"Configure user accounts.\";}}','system',0,0,1,0,-20,3,0,1,8,48,0,0,0,0,0,0,0),('management',49,18,'admin/people/permissions','admin/people/permissions','Permissions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Determine access to features by selecting permissions for roles.\";}}','system',-1,0,0,0,0,3,0,1,18,49,0,0,0,0,0,0,0),('management',50,19,'admin/reports/dblog','admin/reports/dblog','Recent log messages','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"View events that have recently been logged.\";}}','system',0,0,0,0,-1,3,0,1,19,50,0,0,0,0,0,0,0),('management',51,8,'admin/config/regional','admin/config/regional','Regional and language','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:48:\"Regional settings, localization and translation.\";}}','system',0,0,1,0,-5,3,0,1,8,51,0,0,0,0,0,0,0),('navigation',52,5,'node/%/revisions','node/%/revisions','Revisions','a:0:{}','system',-1,0,1,0,2,2,0,5,52,0,0,0,0,0,0,0,0),('management',53,8,'admin/config/search','admin/config/search','Search and metadata','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"Local site search, metadata and SEO.\";}}','system',0,0,1,0,-10,3,0,1,8,53,0,0,0,0,0,0,0),('management',54,7,'admin/appearance/settings','admin/appearance/settings','Settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Configure default and theme specific settings.\";}}','system',-1,0,0,0,20,3,0,1,7,54,0,0,0,0,0,0,0),('management',55,19,'admin/reports/status','admin/reports/status','Status report','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:74:\"Get a status report about your site\'s operation and any detected problems.\";}}','system',0,0,0,0,-60,3,0,1,19,55,0,0,0,0,0,0,0),('management',56,8,'admin/config/system','admin/config/system','System','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:37:\"General system related configuration.\";}}','system',0,0,1,0,-20,3,0,1,8,56,0,0,0,0,0,0,0),('management',57,21,'admin/structure/taxonomy','admin/structure/taxonomy','Taxonomy','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:67:\"Manage tagging, categorization, and classification of your content.\";}}','system',0,0,1,0,0,3,0,1,21,57,0,0,0,0,0,0,0),('management',58,19,'admin/reports/access-denied','admin/reports/access-denied','Top \'access denied\' errors','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:35:\"View \'access denied\' errors (403s).\";}}','system',0,0,0,0,0,3,0,1,19,58,0,0,0,0,0,0,0),('management',59,19,'admin/reports/page-not-found','admin/reports/page-not-found','Top \'page not found\' errors','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:36:\"View \'page not found\' errors (404s).\";}}','system',0,0,0,0,0,3,0,1,19,59,0,0,0,0,0,0,0),('management',60,16,'admin/modules/uninstall','admin/modules/uninstall','Uninstall','a:0:{}','system',-1,0,0,0,20,3,0,1,16,60,0,0,0,0,0,0,0),('management',61,8,'admin/config/user-interface','admin/config/user-interface','User interface','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:38:\"Tools that enhance the user interface.\";}}','system',0,0,1,0,-15,3,0,1,8,61,0,0,0,0,0,0,0),('navigation',62,5,'node/%/view','node/%/view','View','a:0:{}','system',-1,0,0,0,-10,2,0,5,62,0,0,0,0,0,0,0,0),('navigation',63,17,'user/%/view','user/%/view','View','a:0:{}','system',-1,0,0,0,-10,2,0,17,63,0,0,0,0,0,0,0,0),('management',64,8,'admin/config/services','admin/config/services','Web services','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"Tools related to web services.\";}}','system',0,0,1,0,0,3,0,1,8,64,0,0,0,0,0,0,0),('management',65,8,'admin/config/workflow','admin/config/workflow','Workflow','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Content workflow, editorial workflow tools.\";}}','system',0,0,0,0,5,3,0,1,8,65,0,0,0,0,0,0,0),('management',66,12,'admin/help/block','admin/help/block','block','a:0:{}','system',-1,0,0,0,0,3,0,1,12,66,0,0,0,0,0,0,0),('management',67,12,'admin/help/color','admin/help/color','color','a:0:{}','system',-1,0,0,0,0,3,0,1,12,67,0,0,0,0,0,0,0),('management',68,12,'admin/help/comment','admin/help/comment','comment','a:0:{}','system',-1,0,0,0,0,3,0,1,12,68,0,0,0,0,0,0,0),('management',69,12,'admin/help/contextual','admin/help/contextual','contextual','a:0:{}','system',-1,0,0,0,0,3,0,1,12,69,0,0,0,0,0,0,0),('management',70,12,'admin/help/dashboard','admin/help/dashboard','dashboard','a:0:{}','system',-1,0,0,0,0,3,0,1,12,70,0,0,0,0,0,0,0),('management',71,12,'admin/help/dblog','admin/help/dblog','dblog','a:0:{}','system',-1,0,0,0,0,3,0,1,12,71,0,0,0,0,0,0,0),('management',72,12,'admin/help/field','admin/help/field','field','a:0:{}','system',-1,0,0,0,0,3,0,1,12,72,0,0,0,0,0,0,0),('management',73,12,'admin/help/field_sql_storage','admin/help/field_sql_storage','field_sql_storage','a:0:{}','system',-1,0,0,0,0,3,0,1,12,73,0,0,0,0,0,0,0),('management',74,12,'admin/help/field_ui','admin/help/field_ui','field_ui','a:0:{}','system',-1,0,0,0,0,3,0,1,12,74,0,0,0,0,0,0,0),('management',75,12,'admin/help/file','admin/help/file','file','a:0:{}','system',-1,0,0,0,0,3,0,1,12,75,0,0,0,0,0,0,0),('management',76,12,'admin/help/filter','admin/help/filter','filter','a:0:{}','system',-1,0,0,0,0,3,0,1,12,76,0,0,0,0,0,0,0),('management',77,12,'admin/help/help','admin/help/help','help','a:0:{}','system',-1,0,0,0,0,3,0,1,12,77,0,0,0,0,0,0,0),('management',78,12,'admin/help/image','admin/help/image','image','a:0:{}','system',-1,0,0,0,0,3,0,1,12,78,0,0,0,0,0,0,0),('management',79,12,'admin/help/list','admin/help/list','list','a:0:{}','system',-1,0,0,0,0,3,0,1,12,79,0,0,0,0,0,0,0),('management',80,12,'admin/help/menu','admin/help/menu','menu','a:0:{}','system',-1,0,0,0,0,3,0,1,12,80,0,0,0,0,0,0,0),('management',81,12,'admin/help/node','admin/help/node','node','a:0:{}','system',-1,0,0,0,0,3,0,1,12,81,0,0,0,0,0,0,0),('management',82,12,'admin/help/options','admin/help/options','options','a:0:{}','system',-1,0,0,0,0,3,0,1,12,82,0,0,0,0,0,0,0),('management',83,12,'admin/help/system','admin/help/system','system','a:0:{}','system',-1,0,0,0,0,3,0,1,12,83,0,0,0,0,0,0,0),('management',84,12,'admin/help/taxonomy','admin/help/taxonomy','taxonomy','a:0:{}','system',-1,0,0,0,0,3,0,1,12,84,0,0,0,0,0,0,0),('management',85,12,'admin/help/text','admin/help/text','text','a:0:{}','system',-1,0,0,0,0,3,0,1,12,85,0,0,0,0,0,0,0),('management',86,12,'admin/help/user','admin/help/user','user','a:0:{}','system',-1,0,0,0,0,3,0,1,12,86,0,0,0,0,0,0,0),('navigation',87,27,'taxonomy/term/%/edit','taxonomy/term/%/edit','Edit','a:0:{}','system',-1,0,0,0,10,2,0,27,87,0,0,0,0,0,0,0,0),('navigation',88,27,'taxonomy/term/%/view','taxonomy/term/%/view','View','a:0:{}','system',-1,0,0,0,0,2,0,27,88,0,0,0,0,0,0,0,0),('management',89,57,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','','a:0:{}','system',0,0,0,0,0,4,0,1,21,57,89,0,0,0,0,0,0),('management',90,48,'admin/config/people/accounts','admin/config/people/accounts','Account settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:109:\"Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.\";}}','system',0,0,0,0,-10,4,0,1,8,48,90,0,0,0,0,0,0),('management',91,56,'admin/config/system/actions','admin/config/system/actions','Actions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"Manage the actions defined for your site.\";}}','system',0,0,1,0,0,4,0,1,8,56,91,0,0,0,0,0,0),('management',92,30,'admin/structure/block/add','admin/structure/block/add','Add block','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,92,0,0,0,0,0,0),('management',93,36,'admin/structure/types/add','admin/structure/types/add','Add content type','a:0:{}','system',-1,0,0,0,0,4,0,1,21,36,93,0,0,0,0,0,0),('management',94,47,'admin/structure/menu/add','admin/structure/menu/add','Add menu','a:0:{}','system',-1,0,0,0,0,4,0,1,21,47,94,0,0,0,0,0,0),('management',95,57,'admin/structure/taxonomy/add','admin/structure/taxonomy/add','Add vocabulary','a:0:{}','system',-1,0,0,0,0,4,0,1,21,57,95,0,0,0,0,0,0),('management',96,54,'admin/appearance/settings/bartik','admin/appearance/settings/bartik','Bartik','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,96,0,0,0,0,0,0),('management',97,53,'admin/config/search/clean-urls','admin/config/search/clean-urls','Clean URLs','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Enable or disable clean URLs for your site.\";}}','system',0,0,0,0,5,4,0,1,8,53,97,0,0,0,0,0,0),('management',98,56,'admin/config/system/cron','admin/config/system/cron','Cron','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:40:\"Manage automatic site maintenance tasks.\";}}','system',0,0,0,0,20,4,0,1,8,56,98,0,0,0,0,0,0),('management',99,51,'admin/config/regional/date-time','admin/config/regional/date-time','Date and time','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Configure display formats for date and time.\";}}','system',0,0,0,0,-15,4,0,1,8,51,99,0,0,0,0,0,0),('management',100,19,'admin/reports/event/%','admin/reports/event/%','Details','a:0:{}','system',0,0,0,0,0,3,0,1,19,100,0,0,0,0,0,0,0),('management',101,46,'admin/config/media/file-system','admin/config/media/file-system','File system','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:68:\"Tell Drupal where to store uploaded files and how they are accessed.\";}}','system',0,0,0,0,-10,4,0,1,8,46,101,0,0,0,0,0,0),('management',102,54,'admin/appearance/settings/garland','admin/appearance/settings/garland','Garland','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,102,0,0,0,0,0,0),('management',103,54,'admin/appearance/settings/global','admin/appearance/settings/global','Global settings','a:0:{}','system',-1,0,0,0,-1,4,0,1,7,54,103,0,0,0,0,0,0),('management',104,48,'admin/config/people/ip-blocking','admin/config/people/ip-blocking','IP address blocking','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Manage blocked IP addresses.\";}}','system',0,0,1,0,10,4,0,1,8,48,104,0,0,0,0,0,0),('management',105,46,'admin/config/media/image-styles','admin/config/media/image-styles','Image styles','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:78:\"Configure styles that can be used for resizing or adjusting images on display.\";}}','system',0,0,1,0,0,4,0,1,8,46,105,0,0,0,0,0,0),('management',106,46,'admin/config/media/image-toolkit','admin/config/media/image-toolkit','Image toolkit','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:74:\"Choose which image toolkit to use if you have installed optional toolkits.\";}}','system',0,0,0,0,20,4,0,1,8,46,106,0,0,0,0,0,0),('management',107,44,'admin/modules/list/confirm','admin/modules/list/confirm','List','a:0:{}','system',-1,0,0,0,0,4,0,1,16,44,107,0,0,0,0,0,0),('management',108,36,'admin/structure/types/list','admin/structure/types/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,36,108,0,0,0,0,0,0),('management',109,57,'admin/structure/taxonomy/list','admin/structure/taxonomy/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,57,109,0,0,0,0,0,0),('management',110,47,'admin/structure/menu/list','admin/structure/menu/list','List menus','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,47,110,0,0,0,0,0,0),('management',111,39,'admin/config/development/logging','admin/config/development/logging','Logging and errors','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:154:\"Settings for logging and alerts modules. Various modules can route Drupal\'s system events to different destinations, such as syslog, database, email, etc.\";}}','system',0,0,0,0,-15,4,0,1,8,39,111,0,0,0,0,0,0),('management',112,39,'admin/config/development/maintenance','admin/config/development/maintenance','Maintenance mode','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:62:\"Take the site offline for maintenance or bring it back online.\";}}','system',0,0,0,0,-10,4,0,1,8,39,112,0,0,0,0,0,0),('management',113,39,'admin/config/development/performance','admin/config/development/performance','Performance','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:101:\"Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.\";}}','system',0,0,0,0,-20,4,0,1,8,39,113,0,0,0,0,0,0),('management',114,49,'admin/people/permissions/list','admin/people/permissions/list','Permissions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:64:\"Determine access to features by selecting permissions for roles.\";}}','system',-1,0,0,0,-8,4,0,1,18,49,114,0,0,0,0,0,0),('management',115,32,'admin/content/comment/new','admin/content/comment/new','Published comments','a:0:{}','system',-1,0,0,0,-10,4,0,1,9,32,115,0,0,0,0,0,0),('management',116,64,'admin/config/services/rss-publishing','admin/config/services/rss-publishing','RSS publishing','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:114:\"Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.\";}}','system',0,0,0,0,0,4,0,1,8,64,116,0,0,0,0,0,0),('management',117,51,'admin/config/regional/settings','admin/config/regional/settings','Regional settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:54:\"Settings for the site\'s default time zone and country.\";}}','system',0,0,0,0,-20,4,0,1,8,51,117,0,0,0,0,0,0),('management',118,49,'admin/people/permissions/roles','admin/people/permissions/roles','Roles','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"List, edit, or add user roles.\";}}','system',-1,0,1,0,-5,4,0,1,18,49,118,0,0,0,0,0,0),('management',119,47,'admin/structure/menu/settings','admin/structure/menu/settings','Settings','a:0:{}','system',-1,0,0,0,5,4,0,1,21,47,119,0,0,0,0,0,0),('management',120,54,'admin/appearance/settings/seven','admin/appearance/settings/seven','Seven','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,120,0,0,0,0,0,0),('management',121,56,'admin/config/system/site-information','admin/config/system/site-information','Site information','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:104:\"Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.\";}}','system',0,0,0,0,-20,4,0,1,8,56,121,0,0,0,0,0,0),('management',122,54,'admin/appearance/settings/stark','admin/appearance/settings/stark','Stark','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,122,0,0,0,0,0,0),('management',123,35,'admin/config/content/formats','admin/config/content/formats','Text formats','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:127:\"Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.\";}}','system',0,0,1,0,0,4,0,1,8,35,123,0,0,0,0,0,0),('management',124,32,'admin/content/comment/approval','admin/content/comment/approval','Unapproved comments','a:0:{}','system',-1,0,0,0,0,4,0,1,9,32,124,0,0,0,0,0,0),('management',125,60,'admin/modules/uninstall/confirm','admin/modules/uninstall/confirm','Uninstall','a:0:{}','system',-1,0,0,0,0,4,0,1,16,60,125,0,0,0,0,0,0),('navigation',126,40,'user/%/edit/account','user/%/edit/account','Account','a:0:{}','system',-1,0,0,0,0,3,0,17,40,126,0,0,0,0,0,0,0),('management',127,123,'admin/config/content/formats/%','admin/config/content/formats/%','','a:0:{}','system',0,0,1,0,0,5,0,1,8,35,123,127,0,0,0,0,0),('management',128,105,'admin/config/media/image-styles/add','admin/config/media/image-styles/add','Add style','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Add a new image style.\";}}','system',-1,0,0,0,2,5,0,1,8,46,105,128,0,0,0,0,0),('management',129,89,'admin/structure/taxonomy/%/add','admin/structure/taxonomy/%/add','Add term','a:0:{}','system',-1,0,0,0,0,5,0,1,21,57,89,129,0,0,0,0,0),('management',130,123,'admin/config/content/formats/add','admin/config/content/formats/add','Add text format','a:0:{}','system',-1,0,0,0,1,5,0,1,8,35,123,130,0,0,0,0,0),('management',131,30,'admin/structure/block/list/bartik','admin/structure/block/list/bartik','Bartik','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,131,0,0,0,0,0,0),('management',132,91,'admin/config/system/actions/configure','admin/config/system/actions/configure','Configure an advanced action','a:0:{}','system',-1,0,0,0,0,5,0,1,8,56,91,132,0,0,0,0,0),('management',133,47,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','Customize menu','a:0:{}','system',0,0,1,0,0,4,0,1,21,47,133,0,0,0,0,0,0),('management',134,89,'admin/structure/taxonomy/%/edit','admin/structure/taxonomy/%/edit','Edit','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,57,89,134,0,0,0,0,0),('management',135,36,'admin/structure/types/manage/%','admin/structure/types/manage/%','Edit content type','a:0:{}','system',0,0,1,0,0,4,0,1,21,36,135,0,0,0,0,0,0),('management',136,99,'admin/config/regional/date-time/formats','admin/config/regional/date-time/formats','Formats','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:51:\"Configure display format strings for date and time.\";}}','system',-1,0,1,0,-9,5,0,1,8,51,99,136,0,0,0,0,0),('management',137,30,'admin/structure/block/list/garland','admin/structure/block/list/garland','Garland','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,137,0,0,0,0,0,0),('management',138,123,'admin/config/content/formats/list','admin/config/content/formats/list','List','a:0:{}','system',-1,0,0,0,0,5,0,1,8,35,123,138,0,0,0,0,0),('management',139,89,'admin/structure/taxonomy/%/list','admin/structure/taxonomy/%/list','List','a:0:{}','system',-1,0,0,0,-20,5,0,1,21,57,89,139,0,0,0,0,0),('management',140,105,'admin/config/media/image-styles/list','admin/config/media/image-styles/list','List','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"List the current image styles on the site.\";}}','system',-1,0,0,0,1,5,0,1,8,46,105,140,0,0,0,0,0),('management',141,91,'admin/config/system/actions/manage','admin/config/system/actions/manage','Manage actions','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:41:\"Manage the actions defined for your site.\";}}','system',-1,0,0,0,-2,5,0,1,8,56,91,141,0,0,0,0,0),('management',142,90,'admin/config/people/accounts/settings','admin/config/people/accounts/settings','Settings','a:0:{}','system',-1,0,0,0,-10,5,0,1,8,48,90,142,0,0,0,0,0),('management',143,30,'admin/structure/block/list/seven','admin/structure/block/list/seven','Seven','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,143,0,0,0,0,0,0),('management',144,30,'admin/structure/block/list/stark','admin/structure/block/list/stark','Stark','a:0:{}','system',-1,0,0,0,0,4,0,1,21,30,144,0,0,0,0,0,0),('management',145,99,'admin/config/regional/date-time/types','admin/config/regional/date-time/types','Types','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:44:\"Configure display formats for date and time.\";}}','system',-1,0,1,0,-10,5,0,1,8,51,99,145,0,0,0,0,0),('navigation',146,52,'node/%/revisions/%/delete','node/%/revisions/%/delete','Delete earlier revision','a:0:{}','system',0,0,0,0,0,3,0,5,52,146,0,0,0,0,0,0,0),('navigation',147,52,'node/%/revisions/%/revert','node/%/revisions/%/revert','Revert to earlier revision','a:0:{}','system',0,0,0,0,0,3,0,5,52,147,0,0,0,0,0,0,0),('navigation',148,52,'node/%/revisions/%/view','node/%/revisions/%/view','Revisions','a:0:{}','system',0,0,0,0,0,3,0,5,52,148,0,0,0,0,0,0,0),('management',149,137,'admin/structure/block/list/garland/add','admin/structure/block/list/garland/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,137,149,0,0,0,0,0),('management',150,143,'admin/structure/block/list/seven/add','admin/structure/block/list/seven/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,143,150,0,0,0,0,0),('management',151,144,'admin/structure/block/list/stark/add','admin/structure/block/list/stark/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,144,151,0,0,0,0,0),('management',152,145,'admin/config/regional/date-time/types/add','admin/config/regional/date-time/types/add','Add date type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Add new date type.\";}}','system',-1,0,0,0,-10,6,0,1,8,51,99,145,152,0,0,0,0),('management',153,136,'admin/config/regional/date-time/formats/add','admin/config/regional/date-time/formats/add','Add format','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Allow users to add additional date formats.\";}}','system',-1,0,0,0,-10,6,0,1,8,51,99,136,153,0,0,0,0),('management',154,133,'admin/structure/menu/manage/%/add','admin/structure/menu/manage/%/add','Add link','a:0:{}','system',-1,0,0,0,0,5,0,1,21,47,133,154,0,0,0,0,0),('management',155,30,'admin/structure/block/manage/%/%','admin/structure/block/manage/%/%','Configure block','a:0:{}','system',0,0,0,0,0,4,0,1,21,30,155,0,0,0,0,0,0),('navigation',156,31,'user/%/cancel/confirm/%/%','user/%/cancel/confirm/%/%','Confirm account cancellation','a:0:{}','system',0,0,0,0,0,3,0,17,31,156,0,0,0,0,0,0,0),('management',157,135,'admin/structure/types/manage/%/delete','admin/structure/types/manage/%/delete','Delete','a:0:{}','system',0,0,0,0,0,5,0,1,21,36,135,157,0,0,0,0,0),('management',158,104,'admin/config/people/ip-blocking/delete/%','admin/config/people/ip-blocking/delete/%','Delete IP address','a:0:{}','system',0,0,0,0,0,5,0,1,8,48,104,158,0,0,0,0,0),('management',159,91,'admin/config/system/actions/delete/%','admin/config/system/actions/delete/%','Delete action','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:17:\"Delete an action.\";}}','system',0,0,0,0,0,5,0,1,8,56,91,159,0,0,0,0,0),('management',160,133,'admin/structure/menu/manage/%/delete','admin/structure/menu/manage/%/delete','Delete menu','a:0:{}','system',0,0,0,0,0,5,0,1,21,47,133,160,0,0,0,0,0),('management',161,47,'admin/structure/menu/item/%/delete','admin/structure/menu/item/%/delete','Delete menu link','a:0:{}','system',0,0,0,0,0,4,0,1,21,47,161,0,0,0,0,0,0),('management',162,118,'admin/people/permissions/roles/delete/%','admin/people/permissions/roles/delete/%','Delete role','a:0:{}','system',0,0,0,0,0,5,0,1,18,49,118,162,0,0,0,0,0),('management',163,127,'admin/config/content/formats/%/disable','admin/config/content/formats/%/disable','Disable text format','a:0:{}','system',0,0,0,0,0,6,0,1,8,35,123,127,163,0,0,0,0),('management',164,135,'admin/structure/types/manage/%/edit','admin/structure/types/manage/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,5,0,1,21,36,135,164,0,0,0,0,0),('management',165,133,'admin/structure/menu/manage/%/edit','admin/structure/menu/manage/%/edit','Edit menu','a:0:{}','system',-1,0,0,0,0,5,0,1,21,47,133,165,0,0,0,0,0),('management',166,47,'admin/structure/menu/item/%/edit','admin/structure/menu/item/%/edit','Edit menu link','a:0:{}','system',0,0,0,0,0,4,0,1,21,47,166,0,0,0,0,0,0),('management',167,118,'admin/people/permissions/roles/edit/%','admin/people/permissions/roles/edit/%','Edit role','a:0:{}','system',0,0,0,0,0,5,0,1,18,49,118,167,0,0,0,0,0),('management',168,105,'admin/config/media/image-styles/edit/%','admin/config/media/image-styles/edit/%','Edit style','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:25:\"Configure an image style.\";}}','system',0,0,1,0,0,5,0,1,8,46,105,168,0,0,0,0,0),('management',169,133,'admin/structure/menu/manage/%/list','admin/structure/menu/manage/%/list','List links','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,47,133,169,0,0,0,0,0),('management',170,47,'admin/structure/menu/item/%/reset','admin/structure/menu/item/%/reset','Reset menu link','a:0:{}','system',0,0,0,0,0,4,0,1,21,47,170,0,0,0,0,0,0),('management',171,105,'admin/config/media/image-styles/delete/%','admin/config/media/image-styles/delete/%','Delete style','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Delete an image style.\";}}','system',0,0,0,0,0,5,0,1,8,46,105,171,0,0,0,0,0),('management',172,105,'admin/config/media/image-styles/revert/%','admin/config/media/image-styles/revert/%','Revert style','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:22:\"Revert an image style.\";}}','system',0,0,0,0,0,5,0,1,8,46,105,172,0,0,0,0,0),('management',173,135,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%/comment/display','Comment display','a:0:{}','system',-1,0,0,0,4,5,0,1,21,36,135,173,0,0,0,0,0),('management',174,135,'admin/structure/types/manage/%/comment/fields','admin/structure/types/manage/%/comment/fields','Comment fields','a:0:{}','system',-1,0,1,0,3,5,0,1,21,36,135,174,0,0,0,0,0),('management',175,155,'admin/structure/block/manage/%/%/configure','admin/structure/block/manage/%/%/configure','Configure block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,155,175,0,0,0,0,0),('management',176,155,'admin/structure/block/manage/%/%/delete','admin/structure/block/manage/%/%/delete','Delete block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,155,176,0,0,0,0,0),('management',177,136,'admin/config/regional/date-time/formats/%/delete','admin/config/regional/date-time/formats/%/delete','Delete date format','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:47:\"Allow users to delete a configured date format.\";}}','system',0,0,0,0,0,6,0,1,8,51,99,136,177,0,0,0,0),('management',178,145,'admin/config/regional/date-time/types/%/delete','admin/config/regional/date-time/types/%/delete','Delete date type','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Allow users to delete a configured date type.\";}}','system',0,0,0,0,0,6,0,1,8,51,99,145,178,0,0,0,0),('management',179,136,'admin/config/regional/date-time/formats/%/edit','admin/config/regional/date-time/formats/%/edit','Edit date format','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:45:\"Allow users to edit a configured date format.\";}}','system',0,0,0,0,0,6,0,1,8,51,99,136,179,0,0,0,0),('management',180,168,'admin/config/media/image-styles/edit/%/add/%','admin/config/media/image-styles/edit/%/add/%','Add image effect','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:28:\"Add a new effect to a style.\";}}','system',0,0,0,0,0,6,0,1,8,46,105,168,180,0,0,0,0),('management',181,168,'admin/config/media/image-styles/edit/%/effects/%','admin/config/media/image-styles/edit/%/effects/%','Edit image effect','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Edit an existing effect within a style.\";}}','system',0,0,1,0,0,6,0,1,8,46,105,168,181,0,0,0,0),('management',182,181,'admin/config/media/image-styles/edit/%/effects/%/delete','admin/config/media/image-styles/edit/%/effects/%/delete','Delete image effect','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:39:\"Delete an existing effect from a style.\";}}','system',0,0,0,0,0,7,0,1,8,46,105,168,181,182,0,0,0),('management',183,47,'admin/structure/menu/manage/main-menu','admin/structure/menu/manage/%','Main menu','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,183,0,0,0,0,0,0),('management',184,47,'admin/structure/menu/manage/management','admin/structure/menu/manage/%','Management','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,184,0,0,0,0,0,0),('management',185,47,'admin/structure/menu/manage/navigation','admin/structure/menu/manage/%','Navigation','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,185,0,0,0,0,0,0),('management',186,47,'admin/structure/menu/manage/user-menu','admin/structure/menu/manage/%','User menu','a:0:{}','menu',0,0,0,0,0,4,0,1,21,47,186,0,0,0,0,0,0),('navigation',187,0,'search','search','Search','a:0:{}','system',1,0,0,0,0,1,0,187,0,0,0,0,0,0,0,0,0),('navigation',188,187,'search/node','search/node','Content','a:0:{}','system',-1,0,0,0,-10,2,0,187,188,0,0,0,0,0,0,0,0),('navigation',189,187,'search/user','search/user','Users','a:0:{}','system',-1,0,0,0,0,2,0,187,189,0,0,0,0,0,0,0,0),('navigation',190,188,'search/node/%','search/node/%','Content','a:0:{}','system',-1,0,0,0,0,3,0,187,188,190,0,0,0,0,0,0,0),('navigation',191,17,'user/%/shortcuts','user/%/shortcuts','Shortcuts','a:0:{}','system',-1,0,0,0,0,2,0,17,191,0,0,0,0,0,0,0,0),('management',192,19,'admin/reports/search','admin/reports/search','Top search phrases','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:33:\"View most popular search phrases.\";}}','system',0,0,0,0,0,3,0,1,19,192,0,0,0,0,0,0,0),('navigation',193,189,'search/user/%','search/user/%','Users','a:0:{}','system',-1,0,0,0,0,3,0,187,189,193,0,0,0,0,0,0,0),('management',194,12,'admin/help/number','admin/help/number','number','a:0:{}','system',-1,0,0,0,0,3,0,1,12,194,0,0,0,0,0,0,0),('management',196,12,'admin/help/path','admin/help/path','path','a:0:{}','system',-1,0,0,0,0,3,0,1,12,196,0,0,0,0,0,0,0),('management',197,12,'admin/help/rdf','admin/help/rdf','rdf','a:0:{}','system',-1,0,0,0,0,3,0,1,12,197,0,0,0,0,0,0,0),('management',198,12,'admin/help/search','admin/help/search','search','a:0:{}','system',-1,0,0,0,0,3,0,1,12,198,0,0,0,0,0,0,0),('management',199,12,'admin/help/shortcut','admin/help/shortcut','shortcut','a:0:{}','system',-1,0,0,0,0,3,0,1,12,199,0,0,0,0,0,0,0),('management',200,53,'admin/config/search/settings','admin/config/search/settings','Search settings','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:67:\"Configure relevance settings for search and other indexing options.\";}}','system',0,0,0,0,-10,4,0,1,8,53,200,0,0,0,0,0,0),('management',201,61,'admin/config/user-interface/shortcut','admin/config/user-interface/shortcut','Shortcuts','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:29:\"Add and modify shortcut sets.\";}}','system',0,0,1,0,0,4,0,1,8,61,201,0,0,0,0,0,0),('management',202,53,'admin/config/search/path','admin/config/search/path','URL aliases','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:46:\"Change your site\'s URL paths by aliasing them.\";}}','system',0,0,1,0,-5,4,0,1,8,53,202,0,0,0,0,0,0),('management',203,202,'admin/config/search/path/add','admin/config/search/path/add','Add alias','a:0:{}','system',-1,0,0,0,0,5,0,1,8,53,202,203,0,0,0,0,0),('management',204,201,'admin/config/user-interface/shortcut/add-set','admin/config/user-interface/shortcut/add-set','Add shortcut set','a:0:{}','system',-1,0,0,0,0,5,0,1,8,61,201,204,0,0,0,0,0),('management',205,200,'admin/config/search/settings/reindex','admin/config/search/settings/reindex','Clear index','a:0:{}','system',-1,0,0,0,0,5,0,1,8,53,200,205,0,0,0,0,0),('management',206,201,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','Edit shortcuts','a:0:{}','system',0,0,1,0,0,5,0,1,8,61,201,206,0,0,0,0,0),('management',207,202,'admin/config/search/path/list','admin/config/search/path/list','List','a:0:{}','system',-1,0,0,0,-10,5,0,1,8,53,202,207,0,0,0,0,0),('management',208,206,'admin/config/user-interface/shortcut/%/add-link','admin/config/user-interface/shortcut/%/add-link','Add shortcut','a:0:{}','system',-1,0,0,0,0,6,0,1,8,61,201,206,208,0,0,0,0),('management',209,202,'admin/config/search/path/delete/%','admin/config/search/path/delete/%','Delete alias','a:0:{}','system',0,0,0,0,0,5,0,1,8,53,202,209,0,0,0,0,0),('management',210,206,'admin/config/user-interface/shortcut/%/delete','admin/config/user-interface/shortcut/%/delete','Delete shortcut set','a:0:{}','system',0,0,0,0,0,6,0,1,8,61,201,206,210,0,0,0,0),('management',211,202,'admin/config/search/path/edit/%','admin/config/search/path/edit/%','Edit alias','a:0:{}','system',0,0,0,0,0,5,0,1,8,53,202,211,0,0,0,0,0),('management',212,206,'admin/config/user-interface/shortcut/%/edit','admin/config/user-interface/shortcut/%/edit','Edit set name','a:0:{}','system',-1,0,0,0,10,6,0,1,8,61,201,206,212,0,0,0,0),('management',213,201,'admin/config/user-interface/shortcut/link/%','admin/config/user-interface/shortcut/link/%','Edit shortcut','a:0:{}','system',0,0,1,0,0,5,0,1,8,61,201,213,0,0,0,0,0),('management',214,206,'admin/config/user-interface/shortcut/%/links','admin/config/user-interface/shortcut/%/links','List links','a:0:{}','system',-1,0,0,0,0,6,0,1,8,61,201,206,214,0,0,0,0),('management',215,213,'admin/config/user-interface/shortcut/link/%/delete','admin/config/user-interface/shortcut/link/%/delete','Delete shortcut','a:0:{}','system',0,0,0,0,0,6,0,1,8,61,201,213,215,0,0,0,0),('shortcut-set-1',216,0,'node/add','node/add','Add content','a:0:{}','menu',0,0,0,0,-20,1,0,216,0,0,0,0,0,0,0,0,0),('shortcut-set-1',217,0,'admin/content','admin/content','Find content','a:0:{}','menu',0,0,0,0,-19,1,0,217,0,0,0,0,0,0,0,0,0),('main-menu',218,0,'<front>','','Home','a:0:{}','menu',0,1,0,0,-50,1,1,218,0,0,0,0,0,0,0,0,0),('navigation',219,6,'node/add/article','node/add/article','Article','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:89:\"Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.\";}}','system',0,0,0,0,0,2,0,6,219,0,0,0,0,0,0,0,0),('navigation',220,6,'node/add/page','node/add/page','Basic page','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:77:\"Use <em>basic pages</em> for your static content, such as an \'About us\' page.\";}}','system',0,0,0,0,0,2,0,6,220,0,0,0,0,0,0,0,0),('management',260,19,'admin/reports/updates','admin/reports/updates','Available updates','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:82:\"Get a status report about available updates for your installed modules and themes.\";}}','system',0,0,0,0,-50,3,0,1,19,260,0,0,0,0,0,0,0),('management',261,7,'admin/appearance/install','admin/appearance/install','Install new theme','a:0:{}','system',-1,0,0,0,25,3,0,1,7,261,0,0,0,0,0,0,0),('management',262,16,'admin/modules/update','admin/modules/update','Update','a:0:{}','system',-1,0,0,0,10,3,0,1,16,262,0,0,0,0,0,0,0),('management',263,16,'admin/modules/install','admin/modules/install','Install new module','a:0:{}','system',-1,0,0,0,25,3,0,1,16,263,0,0,0,0,0,0,0),('management',264,7,'admin/appearance/update','admin/appearance/update','Update','a:0:{}','system',-1,0,0,0,10,3,0,1,7,264,0,0,0,0,0,0,0),('management',265,12,'admin/help/update','admin/help/update','update','a:0:{}','system',-1,0,0,0,0,3,0,1,12,265,0,0,0,0,0,0,0),('management',266,260,'admin/reports/updates/install','admin/reports/updates/install','Install new module or theme','a:0:{}','system',-1,0,0,0,25,4,0,1,19,260,266,0,0,0,0,0,0),('management',267,260,'admin/reports/updates/update','admin/reports/updates/update','Update','a:0:{}','system',-1,0,0,0,10,4,0,1,19,260,267,0,0,0,0,0,0),('management',268,260,'admin/reports/updates/list','admin/reports/updates/list','List','a:0:{}','system',-1,0,0,0,0,4,0,1,19,260,268,0,0,0,0,0,0),('management',269,260,'admin/reports/updates/settings','admin/reports/updates/settings','Settings','a:0:{}','system',-1,0,0,0,50,4,0,1,19,260,269,0,0,0,0,0,0),('management',270,89,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,21,57,89,270,0,0,0,0,0),('management',271,90,'admin/config/people/accounts/display','admin/config/people/accounts/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,8,48,90,271,0,0,0,0,0),('management',272,89,'admin/structure/taxonomy/%/fields','admin/structure/taxonomy/%/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,21,57,89,272,0,0,0,0,0),('management',273,90,'admin/config/people/accounts/fields','admin/config/people/accounts/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,8,48,90,273,0,0,0,0,0),('management',274,270,'admin/structure/taxonomy/%/display/default','admin/structure/taxonomy/%/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,21,57,89,270,274,0,0,0,0),('management',275,271,'admin/config/people/accounts/display/default','admin/config/people/accounts/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,8,48,90,271,275,0,0,0,0),('management',276,135,'admin/structure/types/manage/%/display','admin/structure/types/manage/%/display','Manage display','a:0:{}','system',-1,0,0,0,2,5,0,1,21,36,135,276,0,0,0,0,0),('management',277,135,'admin/structure/types/manage/%/fields','admin/structure/types/manage/%/fields','Manage fields','a:0:{}','system',-1,0,1,0,1,5,0,1,21,36,135,277,0,0,0,0,0),('management',278,270,'admin/structure/taxonomy/%/display/full','admin/structure/taxonomy/%/display/full','Taxonomy term page','a:0:{}','system',-1,0,0,0,0,6,0,1,21,57,89,270,278,0,0,0,0),('management',279,271,'admin/config/people/accounts/display/full','admin/config/people/accounts/display/full','User account','a:0:{}','system',-1,0,0,0,0,6,0,1,8,48,90,271,279,0,0,0,0),('management',280,272,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,21,57,89,272,280,0,0,0,0),('management',281,273,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,8,48,90,273,281,0,0,0,0),('management',282,276,'admin/structure/types/manage/%/display/default','admin/structure/types/manage/%/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,21,36,135,276,282,0,0,0,0),('management',283,276,'admin/structure/types/manage/%/display/full','admin/structure/types/manage/%/display/full','Full content','a:0:{}','system',-1,0,0,0,0,6,0,1,21,36,135,276,283,0,0,0,0),('management',284,276,'admin/structure/types/manage/%/display/rss','admin/structure/types/manage/%/display/rss','RSS','a:0:{}','system',-1,0,0,0,2,6,0,1,21,36,135,276,284,0,0,0,0),('management',285,276,'admin/structure/types/manage/%/display/search_index','admin/structure/types/manage/%/display/search_index','Search index','a:0:{}','system',-1,0,0,0,3,6,0,1,21,36,135,276,285,0,0,0,0),('management',286,276,'admin/structure/types/manage/%/display/search_result','admin/structure/types/manage/%/display/search_result','Search result','a:0:{}','system',-1,0,0,0,4,6,0,1,21,36,135,276,286,0,0,0,0),('management',287,276,'admin/structure/types/manage/%/display/teaser','admin/structure/types/manage/%/display/teaser','Teaser','a:0:{}','system',-1,0,0,0,1,6,0,1,21,36,135,276,287,0,0,0,0),('management',288,277,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,21,36,135,277,288,0,0,0,0),('management',289,280,'admin/structure/taxonomy/%/fields/%/delete','admin/structure/taxonomy/%/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,21,57,89,272,280,289,0,0,0),('management',290,280,'admin/structure/taxonomy/%/fields/%/edit','admin/structure/taxonomy/%/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,21,57,89,272,280,290,0,0,0),('management',291,280,'admin/structure/taxonomy/%/fields/%/field-settings','admin/structure/taxonomy/%/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,21,57,89,272,280,291,0,0,0),('management',292,280,'admin/structure/taxonomy/%/fields/%/widget-type','admin/structure/taxonomy/%/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,21,57,89,272,280,292,0,0,0),('management',293,281,'admin/config/people/accounts/fields/%/delete','admin/config/people/accounts/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,8,48,90,273,281,293,0,0,0),('management',294,281,'admin/config/people/accounts/fields/%/edit','admin/config/people/accounts/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,8,48,90,273,281,294,0,0,0),('management',295,281,'admin/config/people/accounts/fields/%/field-settings','admin/config/people/accounts/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,8,48,90,273,281,295,0,0,0),('management',296,281,'admin/config/people/accounts/fields/%/widget-type','admin/config/people/accounts/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,8,48,90,273,281,296,0,0,0),('management',297,173,'admin/structure/types/manage/%/comment/display/default','admin/structure/types/manage/%/comment/display/default','Default','a:0:{}','system',-1,0,0,0,-10,6,0,1,21,36,135,173,297,0,0,0,0),('management',298,173,'admin/structure/types/manage/%/comment/display/full','admin/structure/types/manage/%/comment/display/full','Full comment','a:0:{}','system',-1,0,0,0,0,6,0,1,21,36,135,173,298,0,0,0,0),('management',299,288,'admin/structure/types/manage/%/fields/%/delete','admin/structure/types/manage/%/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,21,36,135,277,288,299,0,0,0),('management',300,174,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','','a:0:{}','system',0,0,0,0,0,6,0,1,21,36,135,174,300,0,0,0,0),('management',301,288,'admin/structure/types/manage/%/fields/%/edit','admin/structure/types/manage/%/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,135,277,288,301,0,0,0),('management',302,288,'admin/structure/types/manage/%/fields/%/field-settings','admin/structure/types/manage/%/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,135,277,288,302,0,0,0),('management',303,288,'admin/structure/types/manage/%/fields/%/widget-type','admin/structure/types/manage/%/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,135,277,288,303,0,0,0),('management',304,300,'admin/structure/types/manage/%/comment/fields/%/delete','admin/structure/types/manage/%/comment/fields/%/delete','Delete','a:0:{}','system',-1,0,0,0,10,7,0,1,21,36,135,174,300,304,0,0,0),('management',305,300,'admin/structure/types/manage/%/comment/fields/%/edit','admin/structure/types/manage/%/comment/fields/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,135,174,300,305,0,0,0),('management',306,300,'admin/structure/types/manage/%/comment/fields/%/field-settings','admin/structure/types/manage/%/comment/fields/%/field-settings','Field settings','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,135,174,300,306,0,0,0),('management',307,300,'admin/structure/types/manage/%/comment/fields/%/widget-type','admin/structure/types/manage/%/comment/fields/%/widget-type','Widget type','a:0:{}','system',-1,0,0,0,0,7,0,1,21,36,135,174,300,307,0,0,0),('navigation',323,17,'user/%/imce','user/%/imce','File browser','a:0:{}','system',-1,0,0,0,10,2,0,17,323,0,0,0,0,0,0,0,0),('management',328,12,'admin/help/pathauto','admin/help/pathauto','pathauto','a:0:{}','system',-1,0,0,0,0,3,0,1,12,328,0,0,0,0,0,0,0),('management',329,12,'admin/help/token','admin/help/token','token','a:0:{}','system',-1,0,0,0,0,3,0,1,12,329,0,0,0,0,0,0,0),('management',330,12,'admin/help/wysiwyg','admin/help/wysiwyg','wysiwyg','a:0:{}','system',-1,0,0,0,0,3,0,1,12,330,0,0,0,0,0,0,0),('management',333,46,'admin/config/media/imce','admin/config/media/imce','IMCE','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:42:\"Control how your image/file browser works.\";}}','system',0,0,0,0,0,4,0,1,8,46,333,0,0,0,0,0,0),('management',343,35,'admin/config/content/wysiwyg','admin/config/content/wysiwyg','Wysiwyg profiles','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:30:\"Configure client-side editors.\";}}','system',0,0,0,0,0,4,0,1,8,35,343,0,0,0,0,0,0),('management',344,333,'admin/config/media/imce/profile','admin/config/media/imce/profile','Add new profile','a:0:{}','system',-1,0,0,0,0,5,0,1,8,46,333,344,0,0,0,0,0),('management',345,202,'admin/config/search/path/update_bulk','admin/config/search/path/update_bulk','Bulk update','a:0:{}','system',-1,0,0,0,30,5,0,1,8,53,202,345,0,0,0,0,0),('management',346,202,'admin/config/search/path/delete_bulk','admin/config/search/path/delete_bulk','Delete aliases','a:0:{}','system',-1,0,0,0,40,5,0,1,8,53,202,346,0,0,0,0,0),('management',347,343,'admin/config/content/wysiwyg/profile','admin/config/content/wysiwyg/profile','List','a:0:{}','system',-1,0,0,0,0,5,0,1,8,35,343,347,0,0,0,0,0),('management',349,202,'admin/config/search/path/patterns','admin/config/search/path/patterns','Patterns','a:0:{}','system',-1,0,0,0,10,5,0,1,8,53,202,349,0,0,0,0,0),('management',351,202,'admin/config/search/path/settings','admin/config/search/path/settings','Settings','a:0:{}','system',-1,0,0,0,20,5,0,1,8,53,202,351,0,0,0,0,0),('management',353,270,'admin/structure/taxonomy/%/display/token','admin/structure/taxonomy/%/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,21,57,89,270,353,0,0,0,0),('management',354,271,'admin/config/people/accounts/display/token','admin/config/people/accounts/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,8,48,90,271,354,0,0,0,0),('management',355,347,'admin/config/content/wysiwyg/profile/%/edit','admin/config/content/wysiwyg/profile/%/edit','Edit','a:0:{}','system',-1,0,0,0,0,6,0,1,8,35,343,347,355,0,0,0,0),('management',356,347,'admin/config/content/wysiwyg/profile/%/delete','admin/config/content/wysiwyg/profile/%/delete','Remove','a:0:{}','system',-1,0,0,0,10,6,0,1,8,35,343,347,356,0,0,0,0),('management',357,276,'admin/structure/types/manage/%/display/token','admin/structure/types/manage/%/display/token','Tokens','a:0:{}','system',-1,0,0,0,5,6,0,1,21,36,135,276,357,0,0,0,0),('management',358,173,'admin/structure/types/manage/%/comment/display/token','admin/structure/types/manage/%/comment/display/token','Tokens','a:0:{}','system',-1,0,0,0,1,6,0,1,21,36,135,173,358,0,0,0,0),('navigation',362,0,'blog','blog','Blogs','a:0:{}','system',1,0,1,0,0,1,0,362,0,0,0,0,0,0,0,0,0),('navigation',363,0,'contact','contact','Contact','a:0:{}','system',1,0,0,0,0,1,0,363,0,0,0,0,0,0,0,0,0),('navigation',364,362,'blog/%','blog/%','My blog','a:0:{}','system',0,0,0,0,0,2,0,362,364,0,0,0,0,0,0,0,0),('navigation',365,6,'node/add/blog','node/add/blog','Blog entry','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:58:\"Use for multi-user blogs. Every user gets a personal blog.\";}}','system',0,0,0,0,0,2,0,6,365,0,0,0,0,0,0,0,0),('navigation',366,17,'user/%/contact','user/%/contact','Contact','a:0:{}','system',-1,0,0,0,2,2,0,17,366,0,0,0,0,0,0,0,0),('management',367,21,'admin/structure/contact','admin/structure/contact','Contact form','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:71:\"Create a system contact form and set up categories for the form to use.\";}}','system',0,0,1,0,0,3,0,1,21,367,0,0,0,0,0,0,0),('management',368,12,'admin/help/blog','admin/help/blog','blog','a:0:{}','system',-1,0,0,0,0,3,0,1,12,368,0,0,0,0,0,0,0),('management',369,12,'admin/help/contact','admin/help/contact','contact','a:0:{}','system',-1,0,0,0,0,3,0,1,12,369,0,0,0,0,0,0,0),('management',370,367,'admin/structure/contact/add','admin/structure/contact/add','Add category','a:0:{}','system',-1,0,0,0,1,4,0,1,21,367,370,0,0,0,0,0,0),('management',371,54,'admin/appearance/settings/centum','admin/appearance/settings/centum','Centum','a:0:{}','system',-1,0,0,0,0,4,0,1,7,54,371,0,0,0,0,0,0),('management',372,30,'admin/structure/block/list/centum','admin/structure/block/list/centum','Centum','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,30,372,0,0,0,0,0,0),('management',373,367,'admin/structure/contact/delete/%','admin/structure/contact/delete/%','Delete contact','a:0:{}','system',0,0,0,0,0,4,0,1,21,367,373,0,0,0,0,0,0),('management',374,367,'admin/structure/contact/edit/%','admin/structure/contact/edit/%','Edit contact category','a:0:{}','system',0,0,0,0,0,4,0,1,21,367,374,0,0,0,0,0,0),('management',376,131,'admin/structure/block/list/bartik/add','admin/structure/block/list/bartik/add','Add block','a:0:{}','system',-1,0,0,0,0,5,0,1,21,30,131,376,0,0,0,0,0),('management',377,12,'admin/help/jquery_update','admin/help/jquery_update','jquery_update','a:0:{}','system',-1,0,0,0,0,3,0,1,12,377,0,0,0,0,0,0,0),('management',378,39,'admin/config/development/jquery_update','admin/config/development/jquery_update','jQuery update','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:83:\"Configure settings related to the jQuery upgrade, the library path and compression.\";}}','system',0,0,0,0,0,4,0,1,8,39,378,0,0,0,0,0,0),('main-menu',379,0,'blog','blog','Blog','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-46,1,1,379,0,0,0,0,0,0,0,0,0),('main-menu',380,0,'contact','contact','Contact','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-45,1,1,380,0,0,0,0,0,0,0,0,0),('navigation',381,6,'node/add/portfolio','node/add/portfolio','Portfolio','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:18:\"Portfolio content.\";}}','system',0,0,0,0,0,2,0,6,381,0,0,0,0,0,0,0,0),('main-menu',382,0,'portfolio','portfolio','Portfolio','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,1,0,-47,1,1,382,0,0,0,0,0,0,0,0,0),('main-menu',383,382,'portfolio/2c','portfolio','Portfolio 2 Columns','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-50,2,1,382,383,0,0,0,0,0,0,0,0),('main-menu',384,382,'portfolio/3c','portfolio','Portfolio 3 Columns','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-49,2,1,382,384,0,0,0,0,0,0,0,0),('main-menu',385,382,'portfolio/4c','portfolio','Portfolio 4 columns','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-48,2,1,382,385,0,0,0,0,0,0,0,0),('management',386,21,'admin/structure/panels','admin/structure/panels','Panels','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:49:\"Get a bird\'s eye view of items related to Panels.\";}}','system',0,0,0,0,0,3,0,1,21,386,0,0,0,0,0,0,0),('management',387,386,'admin/structure/panels/dashboard','admin/structure/panels/dashboard','Dashboard','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,386,387,0,0,0,0,0,0),('management',388,386,'admin/structure/panels/layouts','admin/structure/panels/layouts','Layouts','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:43:\"Add, edit or delete custom content layouts.\";}}','system',-1,0,0,0,0,4,0,1,21,386,388,0,0,0,0,0,0),('management',389,386,'admin/structure/panels/settings','admin/structure/panels/settings','Settings','a:0:{}','system',-1,0,0,0,0,4,0,1,21,386,389,0,0,0,0,0,0),('management',390,388,'admin/structure/panels/layouts/add-flexible','admin/structure/panels/layouts/add-flexible','Add flexible layout','a:0:{}','system',-1,0,0,0,0,5,0,1,21,386,388,390,0,0,0,0,0),('management',391,389,'admin/structure/panels/settings/general','admin/structure/panels/settings/general','General','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,386,389,391,0,0,0,0,0),('management',392,388,'admin/structure/panels/layouts/import','admin/structure/panels/layouts/import','Import','a:0:{}','system',-1,0,0,0,0,5,0,1,21,386,388,392,0,0,0,0,0),('management',393,388,'admin/structure/panels/layouts/list','admin/structure/panels/layouts/list','List','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,386,388,393,0,0,0,0,0),('management',394,393,'admin/structure/panels/layouts/list/%/edit','admin/structure/panels/layouts/list/%/edit','Edit','a:0:{}','system',-1,0,0,0,-10,6,0,1,21,386,388,393,394,0,0,0,0),('management',395,393,'admin/structure/panels/layouts/list/%/export','admin/structure/panels/layouts/list/%/export','Export','a:0:{}','system',-1,0,0,0,0,6,0,1,21,386,388,393,395,0,0,0,0),('management',396,21,'admin/structure/pages','admin/structure/pages','Pages','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:84:\"Add, edit and remove overridden system pages and user defined pages from the system.\";}}','system',0,0,1,0,0,3,0,1,21,396,0,0,0,0,0,0,0),('management',397,396,'admin/structure/pages/add','admin/structure/pages/add','Add custom page','a:0:{}','system',-1,0,0,0,0,4,0,1,21,396,397,0,0,0,0,0,0),('management',398,396,'admin/structure/pages/import','admin/structure/pages/import','Import page','a:0:{}','system',-1,0,0,0,0,4,0,1,21,396,398,0,0,0,0,0,0),('management',399,396,'admin/structure/pages/list','admin/structure/pages/list','List','a:0:{}','system',-1,0,0,0,-10,4,0,1,21,396,399,0,0,0,0,0,0),('management',400,396,'admin/structure/pages/wizard','admin/structure/pages/wizard','Wizards','a:0:{}','system',-1,0,0,0,-5,4,0,1,21,396,400,0,0,0,0,0,0),('management',401,396,'admin/structure/pages/edit/%','admin/structure/pages/edit/%','Edit','a:0:{}','system',0,0,0,0,0,4,0,1,21,396,401,0,0,0,0,0,0),('management',402,389,'admin/structure/panels/settings/panel-page','admin/structure/panels/settings/panel-page','Panel pages','a:0:{}','system',-1,0,0,0,-10,5,0,1,21,386,389,402,0,0,0,0,0),('management',403,396,'admin/structure/pages/%/operation/%','admin/structure/pages/%/operation/%','','a:0:{}','system',0,0,0,0,0,4,0,1,21,396,403,0,0,0,0,0,0),('navigation',404,0,'tagadelic','tagadelic','Tags','a:0:{}','system',1,0,0,0,0,1,0,404,0,0,0,0,0,0,0,0,0),('navigation',405,404,'tagadelic/chunk/%','tagadelic/chunk/%','Tags','a:0:{}','system',1,0,0,0,0,2,0,404,405,0,0,0,0,0,0,0,0),('management',406,12,'admin/help/tagadelic','admin/help/tagadelic','tagadelic','a:0:{}','system',-1,0,0,0,0,3,0,1,12,406,0,0,0,0,0,0,0),('management',407,35,'admin/config/content/tagadelic','admin/config/content/tagadelic','Tagadelic configuration','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:89:\"Configure the tag clouds. Set the order, the number of tags, and the depth of the clouds.\";}}','system',0,0,0,0,0,4,0,1,8,35,407,0,0,0,0,0,0),('main-menu',408,0,'node/12','node/%','Features','a:0:{}','menu',0,0,1,0,-49,1,1,408,0,0,0,0,0,0,0,0,0),('main-menu',409,408,'node/13','node/%','Full width','a:0:{}','menu',0,0,0,0,0,2,0,408,409,0,0,0,0,0,0,0,0),('main-menu',410,408,'node/14','node/%','About Us','a:0:{}','menu',0,0,0,0,0,2,0,408,410,0,0,0,0,0,0,0,0),('main-menu',411,408,'node/15','node/%','Services','a:0:{}','menu',0,0,0,0,0,2,0,408,411,0,0,0,0,0,0,0,0),('main-menu',412,408,'node/16','node/%','Pricing tables','a:0:{}','menu',0,0,0,0,0,2,0,408,412,0,0,0,0,0,0,0,0),('main-menu',413,0,'node/12','node/%','Shortcodes','a:1:{s:10:\"attributes\";a:1:{s:5:\"title\";s:0:\"\";}}','menu',0,0,0,0,-48,1,1,413,0,0,0,0,0,0,0,0,0),('management',414,12,'admin/help/overlay','admin/help/overlay','overlay','a:0:{}','system',-1,0,0,0,0,3,0,1,12,414,0,0,0,0,0,0,0),('management',415,12,'admin/help/toolbar','admin/help/toolbar','toolbar','a:0:{}','system',-1,0,0,0,0,3,0,1,12,415,0,0,0,0,0,0,0);
/*!40000 ALTER TABLE `menu_links` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menu_router`
--

DROP TABLE IF EXISTS `menu_router`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `menu_router` (
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: the Drupal path this entry describes',
  `load_functions` blob NOT NULL COMMENT 'A serialized array of function names (like node_load) to be called to load an object corresponding to a part of the current path.',
  `to_arg_functions` blob NOT NULL COMMENT 'A serialized array of function names (like user_uid_optional_to_arg) to be called to replace a part of the router path with another string.',
  `access_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The callback which determines the access to this router path. Defaults to user_access.',
  `access_arguments` blob COMMENT 'A serialized array of arguments for the access callback.',
  `page_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the function that renders the page.',
  `page_arguments` blob COMMENT 'A serialized array of arguments for the page callback.',
  `delivery_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the function that sends the result of the page_callback function to the browser.',
  `fit` int(11) NOT NULL DEFAULT '0' COMMENT 'A numeric representation of how specific the path is.',
  `number_parts` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Number of parts in this router path.',
  `context` int(11) NOT NULL DEFAULT '0' COMMENT 'Only for local tasks (tabs) - the context of a local task to control its placement.',
  `tab_parent` varchar(255) NOT NULL DEFAULT '' COMMENT 'Only for local tasks (tabs) - the router path of the parent page (which may also be a local task).',
  `tab_root` varchar(255) NOT NULL DEFAULT '' COMMENT 'Router path of the closest non-tab parent page. For pages that are not local tasks, this will be the same as the path.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title for the current page, or the title for the tab if this is a local task.',
  `title_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'A function which will alter the title. Defaults to t()',
  `title_arguments` varchar(255) NOT NULL DEFAULT '' COMMENT 'A serialized array of arguments for the title callback. If empty, the title will be used as the sole argument for the title callback.',
  `theme_callback` varchar(255) NOT NULL DEFAULT '' COMMENT 'A function which returns the name of the theme that will be used to render this page. If left empty, the default theme will be used.',
  `theme_arguments` varchar(255) NOT NULL DEFAULT '' COMMENT 'A serialized array of arguments for the theme callback.',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT 'Numeric representation of the type of the menu item, like MENU_LOCAL_TASK.',
  `description` text NOT NULL COMMENT 'A description of this item.',
  `position` varchar(255) NOT NULL DEFAULT '' COMMENT 'The position of the block (left or right) on the system administration page for this item.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'Weight of the element. Lighter weights are higher up, heavier weights go down.',
  `include_file` mediumtext COMMENT 'The file to include for this element, usually the page callback function lives in this file.',
  PRIMARY KEY (`path`),
  KEY `fit` (`fit`),
  KEY `tab_parent` (`tab_parent`(64),`weight`,`title`),
  KEY `tab_root_weight_title` (`tab_root`(64),`weight`,`title`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maps paths to various callbacks (access, page and title)';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menu_router`
--

LOCK TABLES `menu_router` WRITE;
/*!40000 ALTER TABLE `menu_router` DISABLE KEYS */;
INSERT INTO `menu_router` VALUES ('admin','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',1,1,0,'','admin','Administration','t','','','a:0:{}',6,'','',9,'modules/system/system.admin.inc'),('admin/appearance','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_themes_page','a:0:{}','',3,2,0,'','admin/appearance','Appearance','t','','','a:0:{}',6,'Select and configure your themes.','left',-6,'modules/system/system.admin.inc'),('admin/appearance/default','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_theme_default','a:0:{}','',7,3,0,'','admin/appearance/default','Set default theme','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/appearance/disable','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_theme_disable','a:0:{}','',7,3,0,'','admin/appearance/disable','Disable theme','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/appearance/enable','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_theme_enable','a:0:{}','',7,3,0,'','admin/appearance/enable','Enable theme','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/appearance/install','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:27:\"update_manager_install_form\";i:1;s:5:\"theme\";}','',7,3,1,'admin/appearance','admin/appearance','Install new theme','t','','','a:0:{}',388,'','',25,'modules/update/update.manager.inc'),('admin/appearance/list','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','system_themes_page','a:0:{}','',7,3,1,'admin/appearance','admin/appearance','List','t','','','a:0:{}',140,'Select and configure your theme','',-1,'modules/system/system.admin.inc'),('admin/appearance/settings','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','drupal_get_form','a:1:{i:0;s:21:\"system_theme_settings\";}','',7,3,1,'admin/appearance','admin/appearance','Settings','t','','','a:0:{}',132,'Configure default and theme specific settings.','',20,'modules/system/system.admin.inc'),('admin/appearance/settings/bartik','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:6:\"bartik\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Bartik','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/settings/centum','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:35:\"sites/all/themes/centum/centum.info\";s:4:\"name\";s:6:\"centum\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:6:\"Centum\";s:11:\"description\";s:65:\"Centum theme, developed by <a href=\"http://tabvn.com/\">Tabvn</a>.\";s:4:\"core\";s:3:\"7.x\";s:7:\"scripts\";a:9:{s:12:\"js/custom.js\";s:36:\"sites/all/themes/centum/js/custom.js\";s:15:\"js/selectnav.js\";s:39:\"sites/all/themes/centum/js/selectnav.js\";s:16:\"js/flexslider.js\";s:40:\"sites/all/themes/centum/js/flexslider.js\";s:13:\"js/tooltip.js\";s:37:\"sites/all/themes/centum/js/tooltip.js\";s:13:\"js/effects.js\";s:37:\"sites/all/themes/centum/js/effects.js\";s:14:\"js/fancybox.js\";s:38:\"sites/all/themes/centum/js/fancybox.js\";s:14:\"js/carousel.js\";s:38:\"sites/all/themes/centum/js/carousel.js\";s:13:\"js/isotope.js\";s:37:\"sites/all/themes/centum/js/isotope.js\";s:12:\"js/centum.js\";s:36:\"sites/all/themes/centum/js/centum.js\";}s:8:\"features\";a:6:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:20:\"comment_user_picture\";i:4;s:25:\"comment_user_verification\";i:5;s:7:\"favicon\";}s:7:\"regions\";a:17:{s:4:\"help\";s:4:\"Help\";s:6:\"header\";s:6:\"Header\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:13:\"home_services\";s:13:\"Home services\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:15:{s:11:\"twitter_url\";s:1:\"#\";s:12:\"facebook_url\";s:1:\"#\";s:12:\"dribbble_url\";s:1:\"#\";s:12:\"linkedin_url\";s:1:\"#\";s:12:\"pintrest_url\";s:1:\"#\";s:20:\"header_contact_email\";s:18:\"support@centum.com\";s:20:\"header_contact_phone\";s:15:\"+48 880 450 120\";s:24:\"footer_copyright_message\";s:65:\"© Copyright 2012 by <a href=\"#\">Centum</a>. All rights reserved.\";s:17:\"default_portfolio\";s:2:\"4c\";s:23:\"default_nodes_portfolio\";s:2:\"12\";s:15:\"default_banners\";a:2:{i:1;a:5:{s:10:\"image_path\";s:24:\"images/slider-img-01.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:15:\"image_published\";b:1;s:12:\"image_weight\";s:1:\"0\";}i:2;a:5:{s:10:\"image_path\";s:24:\"images/slider-img-02.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:15:\"image_published\";b:1;s:12:\"image_weight\";s:1:\"1\";}}s:11:\"theme_color\";s:9:\"green.css\";s:22:\"theme_background_color\";s:0:\"\";s:22:\"theme_background_image\";s:9:\"noise.png\";s:18:\"theme_layout_style\";s:9:\"boxed.css\";}s:6:\"engine\";s:11:\"phptemplate\";s:10:\"screenshot\";s:38:\"sites/all/themes/centum/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:11:\"stylesheets\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:7:\"scripts\";a:9:{s:12:\"js/custom.js\";s:36:\"sites/all/themes/centum/js/custom.js\";s:15:\"js/selectnav.js\";s:39:\"sites/all/themes/centum/js/selectnav.js\";s:16:\"js/flexslider.js\";s:40:\"sites/all/themes/centum/js/flexslider.js\";s:13:\"js/tooltip.js\";s:37:\"sites/all/themes/centum/js/tooltip.js\";s:13:\"js/effects.js\";s:37:\"sites/all/themes/centum/js/effects.js\";s:14:\"js/fancybox.js\";s:38:\"sites/all/themes/centum/js/fancybox.js\";s:14:\"js/carousel.js\";s:38:\"sites/all/themes/centum/js/carousel.js\";s:13:\"js/isotope.js\";s:37:\"sites/all/themes/centum/js/isotope.js\";s:12:\"js/centum.js\";s:36:\"sites/all/themes/centum/js/centum.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:6:\"centum\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Centum','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/settings/garland','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:7:\"garland\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Garland','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/settings/global','','','user_access','a:1:{i:0;s:17:\"administer themes\";}','drupal_get_form','a:1:{i:0;s:21:\"system_theme_settings\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Global settings','t','','','a:0:{}',140,'','',-1,'modules/system/system.admin.inc'),('admin/appearance/settings/seven','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:5:\"seven\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Seven','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/settings/stark','','','_system_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:17:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','drupal_get_form','a:2:{i:0;s:21:\"system_theme_settings\";i:1;s:5:\"stark\";}','',15,4,1,'admin/appearance/settings','admin/appearance','Stark','t','','','a:0:{}',132,'','',0,'modules/system/system.admin.inc'),('admin/appearance/update','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:26:\"update_manager_update_form\";i:1;s:5:\"theme\";}','',7,3,1,'admin/appearance','admin/appearance','Update','t','','','a:0:{}',132,'','',10,'modules/update/update.manager.inc'),('admin/compact','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_compact_page','a:0:{}','',3,2,0,'','admin/compact','Compact mode','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/config','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_config_page','a:0:{}','',3,2,0,'','admin/config','Configuration','t','','','a:0:{}',6,'Administer settings.','',0,'modules/system/system.admin.inc'),('admin/config/content','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/content','Content authoring','t','','','a:0:{}',6,'Settings related to formatting and authoring content.','left',-15,'modules/system/system.admin.inc'),('admin/config/content/formats','','','user_access','a:1:{i:0;s:18:\"administer filters\";}','drupal_get_form','a:1:{i:0;s:21:\"filter_admin_overview\";}','',15,4,0,'','admin/config/content/formats','Text formats','t','','','a:0:{}',6,'Configure how content input by users is filtered, including allowed HTML tags. Also allows enabling of module-provided filters.','',0,'modules/filter/filter.admin.inc'),('admin/config/content/formats/%','a:1:{i:4;s:18:\"filter_format_load\";}','','user_access','a:1:{i:0;s:18:\"administer filters\";}','filter_admin_format_page','a:1:{i:0;i:4;}','',30,5,0,'','admin/config/content/formats/%','','filter_admin_format_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/filter/filter.admin.inc'),('admin/config/content/formats/%/disable','a:1:{i:4;s:18:\"filter_format_load\";}','','_filter_disable_format_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:20:\"filter_admin_disable\";i:1;i:4;}','',61,6,0,'','admin/config/content/formats/%/disable','Disable text format','t','','','a:0:{}',6,'','',0,'modules/filter/filter.admin.inc'),('admin/config/content/formats/add','','','user_access','a:1:{i:0;s:18:\"administer filters\";}','filter_admin_format_page','a:0:{}','',31,5,1,'admin/config/content/formats','admin/config/content/formats','Add text format','t','','','a:0:{}',388,'','',1,'modules/filter/filter.admin.inc'),('admin/config/content/formats/list','','','user_access','a:1:{i:0;s:18:\"administer filters\";}','drupal_get_form','a:1:{i:0;s:21:\"filter_admin_overview\";}','',31,5,1,'admin/config/content/formats','admin/config/content/formats','List','t','','','a:0:{}',140,'','',0,'modules/filter/filter.admin.inc'),('admin/config/content/tagadelic','','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:1:{i:0;s:18:\"tagadelic_settings\";}','',15,4,0,'','admin/config/content/tagadelic','Tagadelic configuration','t','','','a:0:{}',6,'Configure the tag clouds. Set the order, the number of tags, and the depth of the clouds.','',0,''),('admin/config/content/wysiwyg','','','user_access','a:1:{i:0;s:18:\"administer filters\";}','drupal_get_form','a:1:{i:0;s:24:\"wysiwyg_profile_overview\";}','',15,4,0,'','admin/config/content/wysiwyg','Wysiwyg profiles','t','','','a:0:{}',6,'Configure client-side editors.','',0,'sites/all/modules/wysiwyg/wysiwyg.admin.inc'),('admin/config/content/wysiwyg/profile','','','user_access','a:1:{i:0;s:18:\"administer filters\";}','drupal_get_form','a:1:{i:0;s:24:\"wysiwyg_profile_overview\";}','',31,5,1,'admin/config/content/wysiwyg','admin/config/content/wysiwyg','List','t','','','a:0:{}',140,'','',0,'sites/all/modules/wysiwyg/wysiwyg.admin.inc'),('admin/config/content/wysiwyg/profile/%/delete','a:1:{i:5;s:20:\"wysiwyg_profile_load\";}','','user_access','a:1:{i:0;s:18:\"administer filters\";}','drupal_get_form','a:2:{i:0;s:30:\"wysiwyg_profile_delete_confirm\";i:1;i:5;}','',125,7,1,'admin/config/content/wysiwyg/profile/%wysiwyg_profile','admin/config/content/wysiwyg/profile','Remove','t','','','a:0:{}',132,'','',10,'sites/all/modules/wysiwyg/wysiwyg.admin.inc'),('admin/config/content/wysiwyg/profile/%/edit','a:1:{i:5;s:20:\"wysiwyg_profile_load\";}','','user_access','a:1:{i:0;s:18:\"administer filters\";}','drupal_get_form','a:2:{i:0;s:20:\"wysiwyg_profile_form\";i:1;i:5;}','',125,7,1,'admin/config/content/wysiwyg/profile/%wysiwyg_profile','admin/config/content/wysiwyg/profile','Edit','t','','','a:0:{}',132,'','',0,'sites/all/modules/wysiwyg/wysiwyg.admin.inc'),('admin/config/development','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/development','Development','t','','','a:0:{}',6,'Development tools.','right',-10,'modules/system/system.admin.inc'),('admin/config/development/jquery_update','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:27:\"jquery_update_settings_form\";}','',15,4,0,'','admin/config/development/jquery_update','jQuery update','t','','','a:0:{}',6,'Configure settings related to the jQuery upgrade, the library path and compression.','',0,''),('admin/config/development/logging','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:23:\"system_logging_settings\";}','',15,4,0,'','admin/config/development/logging','Logging and errors','t','','','a:0:{}',6,'Settings for logging and alerts modules. Various modules can route Drupal\'s system events to different destinations, such as syslog, database, email, etc.','',-15,'modules/system/system.admin.inc'),('admin/config/development/maintenance','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:28:\"system_site_maintenance_mode\";}','',15,4,0,'','admin/config/development/maintenance','Maintenance mode','t','','','a:0:{}',6,'Take the site offline for maintenance or bring it back online.','',-10,'modules/system/system.admin.inc'),('admin/config/development/performance','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:27:\"system_performance_settings\";}','',15,4,0,'','admin/config/development/performance','Performance','t','','','a:0:{}',6,'Enable or disable page caching for anonymous users and set CSS and JS bandwidth optimization options.','',-20,'modules/system/system.admin.inc'),('admin/config/media','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/media','Media','t','','','a:0:{}',6,'Media tools.','left',-10,'modules/system/system.admin.inc'),('admin/config/media/file-system','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:27:\"system_file_system_settings\";}','',15,4,0,'','admin/config/media/file-system','File system','t','','','a:0:{}',6,'Tell Drupal where to store uploaded files and how they are accessed.','',-10,'modules/system/system.admin.inc'),('admin/config/media/image-styles','','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','image_style_list','a:0:{}','',15,4,0,'','admin/config/media/image-styles','Image styles','t','','','a:0:{}',6,'Configure styles that can be used for resizing or adjusting images on display.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/add','','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:1:{i:0;s:20:\"image_style_add_form\";}','',31,5,1,'admin/config/media/image-styles','admin/config/media/image-styles','Add style','t','','','a:0:{}',388,'Add a new image style.','',2,'modules/image/image.admin.inc'),('admin/config/media/image-styles/delete/%','a:1:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;N;i:1;s:1:\"1\";}}}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:2:{i:0;s:23:\"image_style_delete_form\";i:1;i:5;}','',62,6,0,'','admin/config/media/image-styles/delete/%','Delete style','t','','','a:0:{}',6,'Delete an image style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/edit/%','a:1:{i:5;s:16:\"image_style_load\";}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:2:{i:0;s:16:\"image_style_form\";i:1;i:5;}','',62,6,0,'','admin/config/media/image-styles/edit/%','Edit style','t','','','a:0:{}',6,'Configure an image style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/edit/%/add/%','a:2:{i:5;a:1:{s:16:\"image_style_load\";a:1:{i:0;i:5;}}i:7;a:1:{s:28:\"image_effect_definition_load\";a:1:{i:0;i:5;}}}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:3:{i:0;s:17:\"image_effect_form\";i:1;i:5;i:2;i:7;}','',250,8,0,'','admin/config/media/image-styles/edit/%/add/%','Add image effect','t','','','a:0:{}',6,'Add a new effect to a style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/edit/%/effects/%','a:2:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}i:7;a:1:{s:17:\"image_effect_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:3:{i:0;s:17:\"image_effect_form\";i:1;i:5;i:2;i:7;}','',250,8,0,'','admin/config/media/image-styles/edit/%/effects/%','Edit image effect','t','','','a:0:{}',6,'Edit an existing effect within a style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/edit/%/effects/%/delete','a:2:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}i:7;a:1:{s:17:\"image_effect_load\";a:2:{i:0;i:5;i:1;s:1:\"3\";}}}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:3:{i:0;s:24:\"image_effect_delete_form\";i:1;i:5;i:2;i:7;}','',501,9,0,'','admin/config/media/image-styles/edit/%/effects/%/delete','Delete image effect','t','','','a:0:{}',6,'Delete an existing effect from a style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-styles/list','','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','image_style_list','a:0:{}','',31,5,1,'admin/config/media/image-styles','admin/config/media/image-styles','List','t','','','a:0:{}',140,'List the current image styles on the site.','',1,'modules/image/image.admin.inc'),('admin/config/media/image-styles/revert/%','a:1:{i:5;a:1:{s:16:\"image_style_load\";a:2:{i:0;N;i:1;s:1:\"2\";}}}','','user_access','a:1:{i:0;s:23:\"administer image styles\";}','drupal_get_form','a:2:{i:0;s:23:\"image_style_revert_form\";i:1;i:5;}','',62,6,0,'','admin/config/media/image-styles/revert/%','Revert style','t','','','a:0:{}',6,'Revert an image style.','',0,'modules/image/image.admin.inc'),('admin/config/media/image-toolkit','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:29:\"system_image_toolkit_settings\";}','',15,4,0,'','admin/config/media/image-toolkit','Image toolkit','t','','','a:0:{}',6,'Choose which image toolkit to use if you have installed optional toolkits.','',20,'modules/system/system.admin.inc'),('admin/config/media/imce','','','user_access','a:1:{i:0;s:15:\"administer imce\";}','imce_admin','a:0:{}','',15,4,0,'','admin/config/media/imce','IMCE','t','','','a:0:{}',6,'Control how your image/file browser works.','',0,'sites/all/modules/imce/inc/imce.admin.inc'),('admin/config/media/imce/profile','','','user_access','a:1:{i:0;s:15:\"administer imce\";}','imce_profile_operations','a:0:{}','',31,5,0,'','admin/config/media/imce/profile','Add new profile','t','','','a:0:{}',4,'','',0,'sites/all/modules/imce/inc/imce.admin.inc'),('admin/config/people','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/people','People','t','','','a:0:{}',6,'Configure user accounts.','left',-20,'modules/system/system.admin.inc'),('admin/config/people/accounts','','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:1:{i:0;s:19:\"user_admin_settings\";}','',15,4,0,'','admin/config/people/accounts','Account settings','t','','','a:0:{}',6,'Configure default behavior of users, including registration requirements, e-mails, fields, and user pictures.','',-10,'modules/user/user.admin.inc'),('admin/config/people/accounts/display','','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:7:\"default\";}','',31,5,1,'admin/config/people/accounts','admin/config/people/accounts','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/display/default','','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:7:\"default\";i:3;s:11:\"user_access\";i:4;s:16:\"administer users\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:7:\"default\";}','',63,6,1,'admin/config/people/accounts/display','admin/config/people/accounts','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/display/full','','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:4:\"full\";i:3;s:11:\"user_access\";i:4;s:16:\"administer users\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:4:\"full\";}','',63,6,1,'admin/config/people/accounts/display','admin/config/people/accounts','User account','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/display/token','','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:5:\"token\";i:3;s:11:\"user_access\";i:4;s:16:\"administer users\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";i:3;s:5:\"token\";}','',63,6,1,'admin/config/people/accounts/display','admin/config/people/accounts','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields','','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:4:\"user\";i:2;s:4:\"user\";}','',31,5,1,'admin/config/people/accounts','admin/config/people/accounts','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',62,6,0,'','admin/config/people/accounts/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/delete','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/edit','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/field-settings','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/fields/%/widget-type','a:1:{i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"user\";i:1;s:4:\"user\";i:2;s:1:\"0\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}','',125,7,1,'admin/config/people/accounts/fields/%','admin/config/people/accounts/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/config/people/accounts/settings','','','user_access','a:1:{i:0;s:16:\"administer users\";}','drupal_get_form','a:1:{i:0;s:19:\"user_admin_settings\";}','',31,5,1,'admin/config/people/accounts','admin/config/people/accounts','Settings','t','','','a:0:{}',140,'','',-10,'modules/user/user.admin.inc'),('admin/config/people/ip-blocking','','','user_access','a:1:{i:0;s:18:\"block IP addresses\";}','system_ip_blocking','a:0:{}','',15,4,0,'','admin/config/people/ip-blocking','IP address blocking','t','','','a:0:{}',6,'Manage blocked IP addresses.','',10,'modules/system/system.admin.inc'),('admin/config/people/ip-blocking/delete/%','a:1:{i:5;s:15:\"blocked_ip_load\";}','','user_access','a:1:{i:0;s:18:\"block IP addresses\";}','drupal_get_form','a:2:{i:0;s:25:\"system_ip_blocking_delete\";i:1;i:5;}','',62,6,0,'','admin/config/people/ip-blocking/delete/%','Delete IP address','t','','','a:0:{}',6,'','',0,'modules/system/system.admin.inc'),('admin/config/regional','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/regional','Regional and language','t','','','a:0:{}',6,'Regional settings, localization and translation.','left',-5,'modules/system/system.admin.inc'),('admin/config/regional/date-time','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_date_time_settings\";}','',15,4,0,'','admin/config/regional/date-time','Date and time','t','','','a:0:{}',6,'Configure display formats for date and time.','',-15,'modules/system/system.admin.inc'),('admin/config/regional/date-time/formats','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_date_time_formats','a:0:{}','',31,5,1,'admin/config/regional/date-time','admin/config/regional/date-time','Formats','t','','','a:0:{}',132,'Configure display format strings for date and time.','',-9,'modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/%/delete','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:30:\"system_date_delete_format_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/formats/%/delete','Delete date format','t','','','a:0:{}',6,'Allow users to delete a configured date format.','',0,'modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/%/edit','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:34:\"system_configure_date_formats_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/formats/%/edit','Edit date format','t','','','a:0:{}',6,'Allow users to edit a configured date format.','',0,'modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/add','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:34:\"system_configure_date_formats_form\";}','',63,6,1,'admin/config/regional/date-time/formats','admin/config/regional/date-time','Add format','t','','','a:0:{}',388,'Allow users to add additional date formats.','',-10,'modules/system/system.admin.inc'),('admin/config/regional/date-time/formats/lookup','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_date_time_lookup','a:0:{}','',63,6,0,'','admin/config/regional/date-time/formats/lookup','Date and time lookup','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/config/regional/date-time/types','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_date_time_settings\";}','',31,5,1,'admin/config/regional/date-time','admin/config/regional/date-time','Types','t','','','a:0:{}',140,'Configure display formats for date and time.','',-10,'modules/system/system.admin.inc'),('admin/config/regional/date-time/types/%/delete','a:1:{i:5;N;}','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:2:{i:0;s:35:\"system_delete_date_format_type_form\";i:1;i:5;}','',125,7,0,'','admin/config/regional/date-time/types/%/delete','Delete date type','t','','','a:0:{}',6,'Allow users to delete a configured date type.','',0,'modules/system/system.admin.inc'),('admin/config/regional/date-time/types/add','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:32:\"system_add_date_format_type_form\";}','',63,6,1,'admin/config/regional/date-time/types','admin/config/regional/date-time','Add date type','t','','','a:0:{}',388,'Add new date type.','',-10,'modules/system/system.admin.inc'),('admin/config/regional/settings','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:24:\"system_regional_settings\";}','',15,4,0,'','admin/config/regional/settings','Regional settings','t','','','a:0:{}',6,'Settings for the site\'s default time zone and country.','',-20,'modules/system/system.admin.inc'),('admin/config/search','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/search','Search and metadata','t','','','a:0:{}',6,'Local site search, metadata and SEO.','left',-10,'modules/system/system.admin.inc'),('admin/config/search/clean-urls','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_clean_url_settings\";}','',15,4,0,'','admin/config/search/clean-urls','Clean URLs','t','','','a:0:{}',6,'Enable or disable clean URLs for your site.','',5,'modules/system/system.admin.inc'),('admin/config/search/clean-urls/check','','','1','a:0:{}','drupal_json_output','a:1:{i:0;a:1:{s:6:\"status\";b:1;}}','',31,5,0,'','admin/config/search/clean-urls/check','Clean URL check','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/config/search/path','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_overview','a:0:{}','',15,4,0,'','admin/config/search/path','URL aliases','t','','','a:0:{}',6,'Change your site\'s URL paths by aliasing them.','',-5,'modules/path/path.admin.inc'),('admin/config/search/path/add','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_edit','a:0:{}','',31,5,1,'admin/config/search/path','admin/config/search/path','Add alias','t','','','a:0:{}',388,'','',0,'modules/path/path.admin.inc'),('admin/config/search/path/delete/%','a:1:{i:5;s:9:\"path_load\";}','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','drupal_get_form','a:2:{i:0;s:25:\"path_admin_delete_confirm\";i:1;i:5;}','',62,6,0,'','admin/config/search/path/delete/%','Delete alias','t','','','a:0:{}',6,'','',0,'modules/path/path.admin.inc'),('admin/config/search/path/delete_bulk','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','drupal_get_form','a:1:{i:0;s:21:\"pathauto_admin_delete\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Delete aliases','t','','','a:0:{}',132,'','',40,'sites/all/modules/pathauto/pathauto.admin.inc'),('admin/config/search/path/edit/%','a:1:{i:5;s:9:\"path_load\";}','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_edit','a:1:{i:0;i:5;}','',62,6,0,'','admin/config/search/path/edit/%','Edit alias','t','','','a:0:{}',6,'','',0,'modules/path/path.admin.inc'),('admin/config/search/path/list','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','path_admin_overview','a:0:{}','',31,5,1,'admin/config/search/path','admin/config/search/path','List','t','','','a:0:{}',140,'','',-10,'modules/path/path.admin.inc'),('admin/config/search/path/patterns','','','user_access','a:1:{i:0;s:19:\"administer pathauto\";}','drupal_get_form','a:1:{i:0;s:22:\"pathauto_patterns_form\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Patterns','t','','','a:0:{}',132,'','',10,'sites/all/modules/pathauto/pathauto.admin.inc'),('admin/config/search/path/settings','','','user_access','a:1:{i:0;s:19:\"administer pathauto\";}','drupal_get_form','a:1:{i:0;s:22:\"pathauto_settings_form\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Settings','t','','','a:0:{}',132,'','',20,'sites/all/modules/pathauto/pathauto.admin.inc'),('admin/config/search/path/update_bulk','','','user_access','a:1:{i:0;s:22:\"administer url aliases\";}','drupal_get_form','a:1:{i:0;s:25:\"pathauto_bulk_update_form\";}','',31,5,1,'admin/config/search/path','admin/config/search/path','Bulk update','t','','','a:0:{}',132,'','',30,'sites/all/modules/pathauto/pathauto.admin.inc'),('admin/config/search/settings','','','user_access','a:1:{i:0;s:17:\"administer search\";}','drupal_get_form','a:1:{i:0;s:21:\"search_admin_settings\";}','',15,4,0,'','admin/config/search/settings','Search settings','t','','','a:0:{}',6,'Configure relevance settings for search and other indexing options.','',-10,'modules/search/search.admin.inc'),('admin/config/search/settings/reindex','','','user_access','a:1:{i:0;s:17:\"administer search\";}','drupal_get_form','a:1:{i:0;s:22:\"search_reindex_confirm\";}','',31,5,0,'','admin/config/search/settings/reindex','Clear index','t','','','a:0:{}',4,'','',0,'modules/search/search.admin.inc'),('admin/config/services','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/services','Web services','t','','','a:0:{}',6,'Tools related to web services.','right',0,'modules/system/system.admin.inc'),('admin/config/services/rss-publishing','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:25:\"system_rss_feeds_settings\";}','',15,4,0,'','admin/config/services/rss-publishing','RSS publishing','t','','','a:0:{}',6,'Configure the site description, the number of items per feed and whether feeds should be titles/teasers/full-text.','',0,'modules/system/system.admin.inc'),('admin/config/system','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/system','System','t','','','a:0:{}',6,'General system related configuration.','right',-20,'modules/system/system.admin.inc'),('admin/config/system/actions','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','system_actions_manage','a:0:{}','',15,4,0,'','admin/config/system/actions','Actions','t','','','a:0:{}',6,'Manage the actions defined for your site.','',0,'modules/system/system.admin.inc'),('admin/config/system/actions/configure','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','drupal_get_form','a:1:{i:0;s:24:\"system_actions_configure\";}','',31,5,0,'','admin/config/system/actions/configure','Configure an advanced action','t','','','a:0:{}',4,'','',0,'modules/system/system.admin.inc'),('admin/config/system/actions/delete/%','a:1:{i:5;s:12:\"actions_load\";}','','user_access','a:1:{i:0;s:18:\"administer actions\";}','drupal_get_form','a:2:{i:0;s:26:\"system_actions_delete_form\";i:1;i:5;}','',62,6,0,'','admin/config/system/actions/delete/%','Delete action','t','','','a:0:{}',6,'Delete an action.','',0,'modules/system/system.admin.inc'),('admin/config/system/actions/manage','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','system_actions_manage','a:0:{}','',31,5,1,'admin/config/system/actions','admin/config/system/actions','Manage actions','t','','','a:0:{}',140,'Manage the actions defined for your site.','',-2,'modules/system/system.admin.inc'),('admin/config/system/actions/orphan','','','user_access','a:1:{i:0;s:18:\"administer actions\";}','system_actions_remove_orphans','a:0:{}','',31,5,0,'','admin/config/system/actions/orphan','Remove orphans','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/config/system/cron','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:20:\"system_cron_settings\";}','',15,4,0,'','admin/config/system/cron','Cron','t','','','a:0:{}',6,'Manage automatic site maintenance tasks.','',20,'modules/system/system.admin.inc'),('admin/config/system/site-information','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:32:\"system_site_information_settings\";}','',15,4,0,'','admin/config/system/site-information','Site information','t','','','a:0:{}',6,'Change site name, e-mail address, slogan, default front page, and number of posts per page, error pages.','',-20,'modules/system/system.admin.inc'),('admin/config/user-interface','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/user-interface','User interface','t','','','a:0:{}',6,'Tools that enhance the user interface.','right',-15,'modules/system/system.admin.inc'),('admin/config/user-interface/shortcut','','','user_access','a:1:{i:0;s:20:\"administer shortcuts\";}','shortcut_set_admin','a:0:{}','',15,4,0,'','admin/config/user-interface/shortcut','Shortcuts','t','','','a:0:{}',6,'Add and modify shortcut sets.','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:22:\"shortcut_set_customize\";i:1;i:4;}','',30,5,0,'','admin/config/user-interface/shortcut/%','Edit shortcuts','shortcut_set_title_callback','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/add-link','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:17:\"shortcut_link_add\";i:1;i:4;}','',61,6,1,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','Add shortcut','t','','','a:0:{}',388,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/add-link-inline','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','shortcut_link_add_inline','a:1:{i:0;i:4;}','',61,6,0,'','admin/config/user-interface/shortcut/%/add-link-inline','Add shortcut','t','','','a:0:{}',0,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/delete','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_delete_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:24:\"shortcut_set_delete_form\";i:1;i:4;}','',61,6,0,'','admin/config/user-interface/shortcut/%/delete','Delete shortcut set','t','','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/edit','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:22:\"shortcut_set_edit_form\";i:1;i:4;}','',61,6,1,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','Edit set name','t','','','a:0:{}',132,'','',10,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/%/links','a:1:{i:4;s:17:\"shortcut_set_load\";}','','shortcut_set_edit_access','a:1:{i:0;i:4;}','drupal_get_form','a:2:{i:0;s:22:\"shortcut_set_customize\";i:1;i:4;}','',61,6,1,'admin/config/user-interface/shortcut/%','admin/config/user-interface/shortcut/%','List links','t','','','a:0:{}',140,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/add-set','','','user_access','a:1:{i:0;s:20:\"administer shortcuts\";}','drupal_get_form','a:1:{i:0;s:21:\"shortcut_set_add_form\";}','',31,5,1,'admin/config/user-interface/shortcut','admin/config/user-interface/shortcut','Add shortcut set','t','','','a:0:{}',388,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/link/%','a:1:{i:5;s:14:\"menu_link_load\";}','','shortcut_link_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:18:\"shortcut_link_edit\";i:1;i:5;}','',62,6,0,'','admin/config/user-interface/shortcut/link/%','Edit shortcut','t','','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/user-interface/shortcut/link/%/delete','a:1:{i:5;s:14:\"menu_link_load\";}','','shortcut_link_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:20:\"shortcut_link_delete\";i:1;i:5;}','',125,7,0,'','admin/config/user-interface/shortcut/link/%/delete','Delete shortcut','t','','','a:0:{}',6,'','',0,'modules/shortcut/shortcut.admin.inc'),('admin/config/workflow','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',7,3,0,'','admin/config/workflow','Workflow','t','','','a:0:{}',6,'Content workflow, editorial workflow tools.','right',5,'modules/system/system.admin.inc'),('admin/content','','','user_access','a:1:{i:0;s:23:\"access content overview\";}','drupal_get_form','a:1:{i:0;s:18:\"node_admin_content\";}','',3,2,0,'','admin/content','Content','t','','','a:0:{}',6,'Administer content and comments.','',-10,'modules/node/node.admin.inc'),('admin/content/comment','','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_admin','a:0:{}','',7,3,1,'admin/content','admin/content','Comments','t','','','a:0:{}',134,'List and edit site comments and the comment approval queue.','',0,'modules/comment/comment.admin.inc'),('admin/content/comment/approval','','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_admin','a:1:{i:0;s:8:\"approval\";}','',15,4,1,'admin/content/comment','admin/content','Unapproved comments','comment_count_unpublished','','','a:0:{}',132,'','',0,'modules/comment/comment.admin.inc'),('admin/content/comment/new','','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_admin','a:0:{}','',15,4,1,'admin/content/comment','admin/content','Published comments','t','','','a:0:{}',140,'','',-10,'modules/comment/comment.admin.inc'),('admin/content/node','','','user_access','a:1:{i:0;s:23:\"access content overview\";}','drupal_get_form','a:1:{i:0;s:18:\"node_admin_content\";}','',7,3,1,'admin/content','admin/content','Content','t','','','a:0:{}',140,'','',-10,'modules/node/node.admin.inc'),('admin/dashboard','','','user_access','a:1:{i:0;s:16:\"access dashboard\";}','dashboard_admin','a:0:{}','',3,2,0,'','admin/dashboard','Dashboard','t','','','a:0:{}',6,'View and customize your dashboard.','',-15,''),('admin/dashboard/block-content/%/%','a:2:{i:3;N;i:4;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_show_block_content','a:2:{i:0;i:3;i:1;i:4;}','',28,5,0,'','admin/dashboard/block-content/%/%','','t','','','a:0:{}',0,'','',0,''),('admin/dashboard/configure','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_admin_blocks','a:0:{}','',7,3,0,'','admin/dashboard/configure','Configure available dashboard blocks','t','','','a:0:{}',4,'Configure which blocks can be shown on the dashboard.','',0,''),('admin/dashboard/customize','','','user_access','a:1:{i:0;s:16:\"access dashboard\";}','dashboard_admin','a:1:{i:0;b:1;}','',7,3,0,'','admin/dashboard/customize','Customize dashboard','t','','','a:0:{}',4,'Customize your dashboard.','',0,''),('admin/dashboard/drawer','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_show_disabled','a:0:{}','',7,3,0,'','admin/dashboard/drawer','','t','','','a:0:{}',0,'','',0,''),('admin/dashboard/update','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','dashboard_update','a:0:{}','',7,3,0,'','admin/dashboard/update','','t','','','a:0:{}',0,'','',0,''),('admin/help','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_main','a:0:{}','',3,2,0,'','admin/help','Help','t','','','a:0:{}',6,'Reference for usage, configuration, and modules.','',9,'modules/help/help.admin.inc'),('admin/help/block','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/block','block','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/blog','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/blog','blog','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/color','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/color','color','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/comment','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/comment','comment','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/contact','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/contact','contact','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/contextual','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/contextual','contextual','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/dashboard','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/dashboard','dashboard','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/dblog','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/dblog','dblog','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/field','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/field','field','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/field_sql_storage','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/field_sql_storage','field_sql_storage','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/field_ui','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/field_ui','field_ui','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/file','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/file','file','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/filter','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/filter','filter','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/help','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/help','help','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/image','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/image','image','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/jquery_update','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/jquery_update','jquery_update','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/list','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/list','list','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/menu','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/menu','menu','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/node','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/node','node','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/number','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/number','number','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/options','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/options','options','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/overlay','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/overlay','overlay','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/path','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/path','path','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/pathauto','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/pathauto','pathauto','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/rdf','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/rdf','rdf','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/search','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/search','search','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/shortcut','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/shortcut','shortcut','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/system','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/system','system','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/tagadelic','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/tagadelic','tagadelic','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/taxonomy','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/taxonomy','taxonomy','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/text','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/text','text','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/token','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/token','token','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/toolbar','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/toolbar','toolbar','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/update','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/update','update','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/user','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/user','user','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/help/wysiwyg','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','help_page','a:1:{i:0;i:2;}','',7,3,0,'','admin/help/wysiwyg','wysiwyg','t','','','a:0:{}',4,'','',0,'modules/help/help.admin.inc'),('admin/index','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_index','a:0:{}','',3,2,1,'admin','admin','Index','t','','','a:0:{}',132,'','',-18,'modules/system/system.admin.inc'),('admin/modules','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:14:\"system_modules\";}','',3,2,0,'','admin/modules','Modules','t','','','a:0:{}',6,'Extend site functionality.','',-2,'modules/system/system.admin.inc'),('admin/modules/install','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:27:\"update_manager_install_form\";i:1;s:6:\"module\";}','',7,3,1,'admin/modules','admin/modules','Install new module','t','','','a:0:{}',388,'','',25,'modules/update/update.manager.inc'),('admin/modules/list','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:14:\"system_modules\";}','',7,3,1,'admin/modules','admin/modules','List','t','','','a:0:{}',140,'','',0,'modules/system/system.admin.inc'),('admin/modules/list/confirm','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:14:\"system_modules\";}','',15,4,0,'','admin/modules/list/confirm','List','t','','','a:0:{}',4,'','',0,'modules/system/system.admin.inc'),('admin/modules/uninstall','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:24:\"system_modules_uninstall\";}','',7,3,1,'admin/modules','admin/modules','Uninstall','t','','','a:0:{}',132,'','',20,'modules/system/system.admin.inc'),('admin/modules/uninstall/confirm','','','user_access','a:1:{i:0;s:18:\"administer modules\";}','drupal_get_form','a:1:{i:0;s:24:\"system_modules_uninstall\";}','',15,4,0,'','admin/modules/uninstall/confirm','Uninstall','t','','','a:0:{}',4,'','',0,'modules/system/system.admin.inc'),('admin/modules/update','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:26:\"update_manager_update_form\";i:1;s:6:\"module\";}','',7,3,1,'admin/modules','admin/modules','Update','t','','','a:0:{}',132,'','',10,'modules/update/update.manager.inc'),('admin/people','','','user_access','a:1:{i:0;s:16:\"administer users\";}','user_admin','a:1:{i:0;s:4:\"list\";}','',3,2,0,'','admin/people','People','t','','','a:0:{}',6,'Manage user accounts, roles, and permissions.','left',-4,'modules/user/user.admin.inc'),('admin/people/create','','','user_access','a:1:{i:0;s:16:\"administer users\";}','user_admin','a:1:{i:0;s:6:\"create\";}','',7,3,1,'admin/people','admin/people','Add user','t','','','a:0:{}',388,'','',0,'modules/user/user.admin.inc'),('admin/people/people','','','user_access','a:1:{i:0;s:16:\"administer users\";}','user_admin','a:1:{i:0;s:4:\"list\";}','',7,3,1,'admin/people','admin/people','List','t','','','a:0:{}',140,'Find and manage people interacting with your site.','',-10,'modules/user/user.admin.inc'),('admin/people/permissions','','','user_access','a:1:{i:0;s:22:\"administer permissions\";}','drupal_get_form','a:1:{i:0;s:22:\"user_admin_permissions\";}','',7,3,1,'admin/people','admin/people','Permissions','t','','','a:0:{}',132,'Determine access to features by selecting permissions for roles.','',0,'modules/user/user.admin.inc'),('admin/people/permissions/list','','','user_access','a:1:{i:0;s:22:\"administer permissions\";}','drupal_get_form','a:1:{i:0;s:22:\"user_admin_permissions\";}','',15,4,1,'admin/people/permissions','admin/people','Permissions','t','','','a:0:{}',140,'Determine access to features by selecting permissions for roles.','',-8,'modules/user/user.admin.inc'),('admin/people/permissions/roles','','','user_access','a:1:{i:0;s:22:\"administer permissions\";}','drupal_get_form','a:1:{i:0;s:16:\"user_admin_roles\";}','',15,4,1,'admin/people/permissions','admin/people','Roles','t','','','a:0:{}',132,'List, edit, or add user roles.','',-5,'modules/user/user.admin.inc'),('admin/people/permissions/roles/delete/%','a:1:{i:5;s:14:\"user_role_load\";}','','user_role_edit_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:30:\"user_admin_role_delete_confirm\";i:1;i:5;}','',62,6,0,'','admin/people/permissions/roles/delete/%','Delete role','t','','','a:0:{}',6,'','',0,'modules/user/user.admin.inc'),('admin/people/permissions/roles/edit/%','a:1:{i:5;s:14:\"user_role_load\";}','','user_role_edit_access','a:1:{i:0;i:5;}','drupal_get_form','a:2:{i:0;s:15:\"user_admin_role\";i:1;i:5;}','',62,6,0,'','admin/people/permissions/roles/edit/%','Edit role','t','','','a:0:{}',6,'','',0,'modules/user/user.admin.inc'),('admin/reports','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','system_admin_menu_block_page','a:0:{}','',3,2,0,'','admin/reports','Reports','t','','','a:0:{}',6,'View reports, updates, and errors.','left',5,'modules/system/system.admin.inc'),('admin/reports/access-denied','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_top','a:1:{i:0;s:13:\"access denied\";}','',7,3,0,'','admin/reports/access-denied','Top \'access denied\' errors','t','','','a:0:{}',6,'View \'access denied\' errors (403s).','',0,'modules/dblog/dblog.admin.inc'),('admin/reports/dblog','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_overview','a:0:{}','',7,3,0,'','admin/reports/dblog','Recent log messages','t','','','a:0:{}',6,'View events that have recently been logged.','',-1,'modules/dblog/dblog.admin.inc'),('admin/reports/event/%','a:1:{i:3;N;}','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_event','a:1:{i:0;i:3;}','',14,4,0,'','admin/reports/event/%','Details','t','','','a:0:{}',6,'','',0,'modules/dblog/dblog.admin.inc'),('admin/reports/fields','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','field_ui_fields_list','a:0:{}','',7,3,0,'','admin/reports/fields','Field list','t','','','a:0:{}',6,'Overview of fields on all entity types.','',0,'modules/field_ui/field_ui.admin.inc'),('admin/reports/page-not-found','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_top','a:1:{i:0;s:14:\"page not found\";}','',7,3,0,'','admin/reports/page-not-found','Top \'page not found\' errors','t','','','a:0:{}',6,'View \'page not found\' errors (404s).','',0,'modules/dblog/dblog.admin.inc'),('admin/reports/search','','','user_access','a:1:{i:0;s:19:\"access site reports\";}','dblog_top','a:1:{i:0;s:6:\"search\";}','',7,3,0,'','admin/reports/search','Top search phrases','t','','','a:0:{}',6,'View most popular search phrases.','',0,'modules/dblog/dblog.admin.inc'),('admin/reports/status','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_status','a:0:{}','',7,3,0,'','admin/reports/status','Status report','t','','','a:0:{}',6,'Get a status report about your site\'s operation and any detected problems.','',-60,'modules/system/system.admin.inc'),('admin/reports/status/php','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_php','a:0:{}','',15,4,0,'','admin/reports/status/php','PHP','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/reports/status/rebuild','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','drupal_get_form','a:1:{i:0;s:30:\"node_configure_rebuild_confirm\";}','',15,4,0,'','admin/reports/status/rebuild','Rebuild permissions','t','','','a:0:{}',0,'','',0,'modules/node/node.admin.inc'),('admin/reports/status/run-cron','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','system_run_cron','a:0:{}','',15,4,0,'','admin/reports/status/run-cron','Run cron','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('admin/reports/updates','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','update_status','a:0:{}','',7,3,0,'','admin/reports/updates','Available updates','t','','','a:0:{}',6,'Get a status report about available updates for your installed modules and themes.','',-50,'modules/update/update.report.inc'),('admin/reports/updates/check','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','update_manual_status','a:0:{}','',15,4,0,'','admin/reports/updates/check','Manual update check','t','','','a:0:{}',0,'','',0,'modules/update/update.fetch.inc'),('admin/reports/updates/install','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:27:\"update_manager_install_form\";i:1;s:6:\"report\";}','',15,4,1,'admin/reports/updates','admin/reports/updates','Install new module or theme','t','','','a:0:{}',388,'','',25,'modules/update/update.manager.inc'),('admin/reports/updates/list','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','update_status','a:0:{}','',15,4,1,'admin/reports/updates','admin/reports/updates','List','t','','','a:0:{}',140,'','',0,'modules/update/update.report.inc'),('admin/reports/updates/settings','','','user_access','a:1:{i:0;s:29:\"administer site configuration\";}','drupal_get_form','a:1:{i:0;s:15:\"update_settings\";}','',15,4,1,'admin/reports/updates','admin/reports/updates','Settings','t','','','a:0:{}',132,'','',50,'modules/update/update.settings.inc'),('admin/reports/updates/update','','','update_manager_access','a:0:{}','drupal_get_form','a:2:{i:0;s:26:\"update_manager_update_form\";i:1;s:6:\"report\";}','',15,4,1,'admin/reports/updates','admin/reports/updates','Update','t','','','a:0:{}',132,'','',10,'modules/update/update.manager.inc'),('admin/structure','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',3,2,0,'','admin/structure','Structure','t','','','a:0:{}',6,'Administer blocks, content types, menus, etc.','right',-8,'modules/system/system.admin.inc'),('admin/structure/block','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','block_admin_display','a:1:{i:0;s:6:\"centum\";}','',7,3,0,'','admin/structure/block','Blocks','t','','','a:0:{}',6,'Configure what block content appears in your site\'s sidebars and other regions.','',0,'modules/block/block.admin.inc'),('admin/structure/block/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',15,4,1,'admin/structure/block','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/bartik','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:6:\"bartik\";}','',31,5,0,'','admin/structure/block/demo/bartik','Bartik','t','','_block_custom_theme','a:1:{i:0;s:6:\"bartik\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/centum','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:35:\"sites/all/themes/centum/centum.info\";s:4:\"name\";s:6:\"centum\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:6:\"Centum\";s:11:\"description\";s:65:\"Centum theme, developed by <a href=\"http://tabvn.com/\">Tabvn</a>.\";s:4:\"core\";s:3:\"7.x\";s:7:\"scripts\";a:9:{s:12:\"js/custom.js\";s:36:\"sites/all/themes/centum/js/custom.js\";s:15:\"js/selectnav.js\";s:39:\"sites/all/themes/centum/js/selectnav.js\";s:16:\"js/flexslider.js\";s:40:\"sites/all/themes/centum/js/flexslider.js\";s:13:\"js/tooltip.js\";s:37:\"sites/all/themes/centum/js/tooltip.js\";s:13:\"js/effects.js\";s:37:\"sites/all/themes/centum/js/effects.js\";s:14:\"js/fancybox.js\";s:38:\"sites/all/themes/centum/js/fancybox.js\";s:14:\"js/carousel.js\";s:38:\"sites/all/themes/centum/js/carousel.js\";s:13:\"js/isotope.js\";s:37:\"sites/all/themes/centum/js/isotope.js\";s:12:\"js/centum.js\";s:36:\"sites/all/themes/centum/js/centum.js\";}s:8:\"features\";a:6:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:20:\"comment_user_picture\";i:4;s:25:\"comment_user_verification\";i:5;s:7:\"favicon\";}s:7:\"regions\";a:17:{s:4:\"help\";s:4:\"Help\";s:6:\"header\";s:6:\"Header\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:13:\"home_services\";s:13:\"Home services\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:15:{s:11:\"twitter_url\";s:1:\"#\";s:12:\"facebook_url\";s:1:\"#\";s:12:\"dribbble_url\";s:1:\"#\";s:12:\"linkedin_url\";s:1:\"#\";s:12:\"pintrest_url\";s:1:\"#\";s:20:\"header_contact_email\";s:18:\"support@centum.com\";s:20:\"header_contact_phone\";s:15:\"+48 880 450 120\";s:24:\"footer_copyright_message\";s:65:\"© Copyright 2012 by <a href=\"#\">Centum</a>. All rights reserved.\";s:17:\"default_portfolio\";s:2:\"4c\";s:23:\"default_nodes_portfolio\";s:2:\"12\";s:15:\"default_banners\";a:2:{i:1;a:5:{s:10:\"image_path\";s:24:\"images/slider-img-01.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:15:\"image_published\";b:1;s:12:\"image_weight\";s:1:\"0\";}i:2;a:5:{s:10:\"image_path\";s:24:\"images/slider-img-02.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:15:\"image_published\";b:1;s:12:\"image_weight\";s:1:\"1\";}}s:11:\"theme_color\";s:9:\"green.css\";s:22:\"theme_background_color\";s:0:\"\";s:22:\"theme_background_image\";s:9:\"noise.png\";s:18:\"theme_layout_style\";s:9:\"boxed.css\";}s:6:\"engine\";s:11:\"phptemplate\";s:10:\"screenshot\";s:38:\"sites/all/themes/centum/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:11:\"stylesheets\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:7:\"scripts\";a:9:{s:12:\"js/custom.js\";s:36:\"sites/all/themes/centum/js/custom.js\";s:15:\"js/selectnav.js\";s:39:\"sites/all/themes/centum/js/selectnav.js\";s:16:\"js/flexslider.js\";s:40:\"sites/all/themes/centum/js/flexslider.js\";s:13:\"js/tooltip.js\";s:37:\"sites/all/themes/centum/js/tooltip.js\";s:13:\"js/effects.js\";s:37:\"sites/all/themes/centum/js/effects.js\";s:14:\"js/fancybox.js\";s:38:\"sites/all/themes/centum/js/fancybox.js\";s:14:\"js/carousel.js\";s:38:\"sites/all/themes/centum/js/carousel.js\";s:13:\"js/isotope.js\";s:37:\"sites/all/themes/centum/js/isotope.js\";s:12:\"js/centum.js\";s:36:\"sites/all/themes/centum/js/centum.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:6:\"centum\";}','',31,5,0,'','admin/structure/block/demo/centum','Centum','t','','_block_custom_theme','a:1:{i:0;s:6:\"centum\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/garland','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:7:\"garland\";}','',31,5,0,'','admin/structure/block/demo/garland','Garland','t','','_block_custom_theme','a:1:{i:0;s:7:\"garland\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/seven','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:5:\"seven\";}','',31,5,0,'','admin/structure/block/demo/seven','Seven','t','','_block_custom_theme','a:1:{i:0;s:5:\"seven\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/demo/stark','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:17:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_demo','a:1:{i:0;s:5:\"stark\";}','',31,5,0,'','admin/structure/block/demo/stark','Stark','t','','_block_custom_theme','a:1:{i:0;s:5:\"stark\";}',0,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/bartik','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:25:\"themes/bartik/bartik.info\";s:4:\"name\";s:6:\"bartik\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:6:\"bartik\";}','',31,5,1,'admin/structure/block','admin/structure/block','Bartik','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/bartik/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/bartik','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/centum','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:35:\"sites/all/themes/centum/centum.info\";s:4:\"name\";s:6:\"centum\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:14:{s:4:\"name\";s:6:\"Centum\";s:11:\"description\";s:65:\"Centum theme, developed by <a href=\"http://tabvn.com/\">Tabvn</a>.\";s:4:\"core\";s:3:\"7.x\";s:7:\"scripts\";a:9:{s:12:\"js/custom.js\";s:36:\"sites/all/themes/centum/js/custom.js\";s:15:\"js/selectnav.js\";s:39:\"sites/all/themes/centum/js/selectnav.js\";s:16:\"js/flexslider.js\";s:40:\"sites/all/themes/centum/js/flexslider.js\";s:13:\"js/tooltip.js\";s:37:\"sites/all/themes/centum/js/tooltip.js\";s:13:\"js/effects.js\";s:37:\"sites/all/themes/centum/js/effects.js\";s:14:\"js/fancybox.js\";s:38:\"sites/all/themes/centum/js/fancybox.js\";s:14:\"js/carousel.js\";s:38:\"sites/all/themes/centum/js/carousel.js\";s:13:\"js/isotope.js\";s:37:\"sites/all/themes/centum/js/isotope.js\";s:12:\"js/centum.js\";s:36:\"sites/all/themes/centum/js/centum.js\";}s:8:\"features\";a:6:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:20:\"comment_user_picture\";i:4;s:25:\"comment_user_verification\";i:5;s:7:\"favicon\";}s:7:\"regions\";a:17:{s:4:\"help\";s:4:\"Help\";s:6:\"header\";s:6:\"Header\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:13:\"home_services\";s:13:\"Home services\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:15:{s:11:\"twitter_url\";s:1:\"#\";s:12:\"facebook_url\";s:1:\"#\";s:12:\"dribbble_url\";s:1:\"#\";s:12:\"linkedin_url\";s:1:\"#\";s:12:\"pintrest_url\";s:1:\"#\";s:20:\"header_contact_email\";s:18:\"support@centum.com\";s:20:\"header_contact_phone\";s:15:\"+48 880 450 120\";s:24:\"footer_copyright_message\";s:65:\"© Copyright 2012 by <a href=\"#\">Centum</a>. All rights reserved.\";s:17:\"default_portfolio\";s:2:\"4c\";s:23:\"default_nodes_portfolio\";s:2:\"12\";s:15:\"default_banners\";a:2:{i:1;a:5:{s:10:\"image_path\";s:24:\"images/slider-img-01.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:15:\"image_published\";b:1;s:12:\"image_weight\";s:1:\"0\";}i:2;a:5:{s:10:\"image_path\";s:24:\"images/slider-img-02.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:15:\"image_published\";b:1;s:12:\"image_weight\";s:1:\"1\";}}s:11:\"theme_color\";s:9:\"green.css\";s:22:\"theme_background_color\";s:0:\"\";s:22:\"theme_background_image\";s:9:\"noise.png\";s:18:\"theme_layout_style\";s:9:\"boxed.css\";}s:6:\"engine\";s:11:\"phptemplate\";s:10:\"screenshot\";s:38:\"sites/all/themes/centum/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:11:\"stylesheets\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:7:\"scripts\";a:9:{s:12:\"js/custom.js\";s:36:\"sites/all/themes/centum/js/custom.js\";s:15:\"js/selectnav.js\";s:39:\"sites/all/themes/centum/js/selectnav.js\";s:16:\"js/flexslider.js\";s:40:\"sites/all/themes/centum/js/flexslider.js\";s:13:\"js/tooltip.js\";s:37:\"sites/all/themes/centum/js/tooltip.js\";s:13:\"js/effects.js\";s:37:\"sites/all/themes/centum/js/effects.js\";s:14:\"js/fancybox.js\";s:38:\"sites/all/themes/centum/js/fancybox.js\";s:14:\"js/carousel.js\";s:38:\"sites/all/themes/centum/js/carousel.js\";s:13:\"js/isotope.js\";s:37:\"sites/all/themes/centum/js/isotope.js\";s:12:\"js/centum.js\";s:36:\"sites/all/themes/centum/js/centum.js\";}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:6:\"centum\";}','',31,5,1,'admin/structure/block','admin/structure/block','Centum','t','','','a:0:{}',140,'','',-10,'modules/block/block.admin.inc'),('admin/structure/block/list/garland','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:27:\"themes/garland/garland.info\";s:4:\"name\";s:7:\"garland\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:7:\"garland\";}','',31,5,1,'admin/structure/block','admin/structure/block','Garland','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/garland/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/garland','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/seven','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/seven/seven.info\";s:4:\"name\";s:5:\"seven\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"1\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:18:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:5:\"seven\";}','',31,5,1,'admin/structure/block','admin/structure/block','Seven','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/seven/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/seven','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/stark','','','_block_themes_access','a:1:{i:0;O:8:\"stdClass\":12:{s:8:\"filename\";s:23:\"themes/stark/stark.info\";s:4:\"name\";s:5:\"stark\";s:4:\"type\";s:5:\"theme\";s:5:\"owner\";s:45:\"themes/engines/phptemplate/phptemplate.engine\";s:6:\"status\";s:1:\"0\";s:9:\"bootstrap\";s:1:\"0\";s:14:\"schema_version\";s:2:\"-1\";s:6:\"weight\";s:1:\"0\";s:4:\"info\";a:17:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}s:6:\"prefix\";s:11:\"phptemplate\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:6:\"engine\";s:11:\"phptemplate\";}}','block_admin_display','a:1:{i:0;s:5:\"stark\";}','',31,5,1,'admin/structure/block','admin/structure/block','Stark','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/list/stark/add','','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:1:{i:0;s:20:\"block_add_block_form\";}','',63,6,1,'admin/structure/block/list/stark','admin/structure/block','Add block','t','','','a:0:{}',388,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/manage/%/%','a:2:{i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:3:{i:0;s:21:\"block_admin_configure\";i:1;i:4;i:2;i:5;}','',60,6,0,'','admin/structure/block/manage/%/%','Configure block','t','','','a:0:{}',6,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/manage/%/%/configure','a:2:{i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:3:{i:0;s:21:\"block_admin_configure\";i:1;i:4;i:2;i:5;}','',121,7,2,'admin/structure/block/manage/%/%','admin/structure/block/manage/%/%','Configure block','t','','','a:0:{}',140,'','',0,'modules/block/block.admin.inc'),('admin/structure/block/manage/%/%/delete','a:2:{i:4;N;i:5;N;}','','user_access','a:1:{i:0;s:17:\"administer blocks\";}','drupal_get_form','a:3:{i:0;s:25:\"block_custom_block_delete\";i:1;i:4;i:2;i:5;}','',121,7,0,'admin/structure/block/manage/%/%','admin/structure/block/manage/%/%','Delete block','t','','','a:0:{}',132,'','',0,'modules/block/block.admin.inc'),('admin/structure/contact','','','user_access','a:1:{i:0;s:24:\"administer contact forms\";}','contact_category_list','a:0:{}','',7,3,0,'','admin/structure/contact','Contact form','t','','','a:0:{}',6,'Create a system contact form and set up categories for the form to use.','',0,'modules/contact/contact.admin.inc'),('admin/structure/contact/add','','','user_access','a:1:{i:0;s:24:\"administer contact forms\";}','drupal_get_form','a:1:{i:0;s:26:\"contact_category_edit_form\";}','',15,4,1,'admin/structure/contact','admin/structure/contact','Add category','t','','','a:0:{}',388,'','',1,'modules/contact/contact.admin.inc'),('admin/structure/contact/delete/%','a:1:{i:4;s:12:\"contact_load\";}','','user_access','a:1:{i:0;s:24:\"administer contact forms\";}','drupal_get_form','a:2:{i:0;s:28:\"contact_category_delete_form\";i:1;i:4;}','',30,5,0,'','admin/structure/contact/delete/%','Delete contact','t','','','a:0:{}',6,'','',0,'modules/contact/contact.admin.inc'),('admin/structure/contact/edit/%','a:1:{i:4;s:12:\"contact_load\";}','','user_access','a:1:{i:0;s:24:\"administer contact forms\";}','drupal_get_form','a:2:{i:0;s:26:\"contact_category_edit_form\";i:1;i:4;}','',30,5,0,'','admin/structure/contact/edit/%','Edit contact category','t','','','a:0:{}',6,'','',0,'modules/contact/contact.admin.inc'),('admin/structure/menu','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_overview_page','a:0:{}','',7,3,0,'','admin/structure/menu','Menus','t','','','a:0:{}',6,'Add new menus to your site, edit existing menus, and rename and reorganize menu links.','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/add','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:14:\"menu_edit_menu\";i:1;s:3:\"add\";}','',15,4,1,'admin/structure/menu','admin/structure/menu','Add menu','t','','','a:0:{}',388,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/item/%/delete','a:1:{i:4;s:14:\"menu_link_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_item_delete_page','a:1:{i:0;i:4;}','',61,6,0,'','admin/structure/menu/item/%/delete','Delete menu link','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/item/%/edit','a:1:{i:4;s:14:\"menu_link_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:4:{i:0;s:14:\"menu_edit_item\";i:1;s:4:\"edit\";i:2;i:4;i:3;N;}','',61,6,0,'','admin/structure/menu/item/%/edit','Edit menu link','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/item/%/reset','a:1:{i:4;s:14:\"menu_link_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:23:\"menu_reset_item_confirm\";i:1;i:4;}','',61,6,0,'','admin/structure/menu/item/%/reset','Reset menu link','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/list','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_overview_page','a:0:{}','',15,4,1,'admin/structure/menu','admin/structure/menu','List menus','t','','','a:0:{}',140,'','',-10,'modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}','',30,5,0,'','admin/structure/menu/manage/%','Customize menu','menu_overview_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%/add','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:4:{i:0;s:14:\"menu_edit_item\";i:1;s:3:\"add\";i:2;N;i:3;i:4;}','',61,6,1,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','Add link','t','','','a:0:{}',388,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%/delete','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','menu_delete_menu_page','a:1:{i:0;i:4;}','',61,6,0,'','admin/structure/menu/manage/%/delete','Delete menu','t','','','a:0:{}',6,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%/edit','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:3:{i:0;s:14:\"menu_edit_menu\";i:1;s:4:\"edit\";i:2;i:4;}','',61,6,3,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','Edit menu','t','','','a:0:{}',132,'','',0,'modules/menu/menu.admin.inc'),('admin/structure/menu/manage/%/list','a:1:{i:4;s:9:\"menu_load\";}','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:2:{i:0;s:18:\"menu_overview_form\";i:1;i:4;}','',61,6,3,'admin/structure/menu/manage/%','admin/structure/menu/manage/%','List links','t','','','a:0:{}',140,'','',-10,'modules/menu/menu.admin.inc'),('admin/structure/menu/parents','','','user_access','a:1:{i:0;b:1;}','menu_parent_options_js','a:0:{}','',15,4,0,'','admin/structure/menu/parents','Parent menu items','t','','','a:0:{}',0,'','',0,''),('admin/structure/menu/settings','','','user_access','a:1:{i:0;s:15:\"administer menu\";}','drupal_get_form','a:1:{i:0;s:14:\"menu_configure\";}','',15,4,1,'admin/structure/menu','admin/structure/menu','Settings','t','','','a:0:{}',132,'','',5,'modules/menu/menu.admin.inc'),('admin/structure/pages','','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_list_page','a:0:{}','',7,3,0,'','admin/structure/pages','Pages','t','','ajax_base_page_theme','a:0:{}',6,'Add, edit and remove overridden system pages and user defined pages from the system.','',0,'sites/all/modules/ctools/page_manager/page_manager.admin.inc'),('admin/structure/pages/%/disable/%','a:2:{i:3;s:14:\"ctools_js_load\";i:5;s:23:\"page_manager_cache_load\";}','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_enable_page','a:3:{i:0;b:1;i:1;i:3;i:2;i:5;}','',58,6,0,'','admin/structure/pages/%/disable/%','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/page_manager/page_manager.admin.inc'),('admin/structure/pages/%/enable/%','a:2:{i:3;s:14:\"ctools_js_load\";i:5;s:23:\"page_manager_cache_load\";}','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_enable_page','a:3:{i:0;b:0;i:1;i:3;i:2;i:5;}','',58,6,0,'','admin/structure/pages/%/enable/%','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/page_manager/page_manager.admin.inc'),('admin/structure/pages/%/operation/%','a:2:{i:3;s:14:\"ctools_js_load\";i:5;s:23:\"page_manager_cache_load\";}','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_edit_page_operation','a:2:{i:0;i:3;i:1;i:5;}','',58,6,0,'','admin/structure/pages/%/operation/%','','t','','ajax_base_page_theme','a:0:{}',6,'','',0,'sites/all/modules/ctools/page_manager/page_manager.admin.inc'),('admin/structure/pages/add','','','user_access','a:1:{i:0;s:23:\"administer page manager\";}','page_manager_page_add_subtask','a:0:{}','',15,4,1,'admin/structure/pages','admin/structure/pages','Add custom page','t','','ajax_base_page_theme','a:0:{}',388,'','',0,'sites/all/modules/ctools/page_manager/plugins/tasks/page.admin.inc'),('admin/structure/pages/argument','','','user_access','a:1:{i:0;s:23:\"administer page manager\";}','page_manager_page_subtask_argument_ajax','a:0:{}','',15,4,0,'','admin/structure/pages/argument','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/page_manager/plugins/tasks/page.admin.inc'),('admin/structure/pages/edit/%','a:1:{i:4;s:23:\"page_manager_cache_load\";}','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_edit_page','a:1:{i:0;i:4;}','',30,5,0,'','admin/structure/pages/edit/%','Edit','t','','ajax_base_page_theme','a:0:{}',6,'','',0,'sites/all/modules/ctools/page_manager/page_manager.admin.inc'),('admin/structure/pages/import','','','ctools_access_multiperm','a:2:{i:0;s:23:\"administer page manager\";i:1;s:20:\"use PHP for settings\";}','drupal_get_form','a:2:{i:0;s:32:\"page_manager_page_import_subtask\";i:1;s:4:\"page\";}','',15,4,1,'admin/structure/pages','admin/structure/pages','Import page','t','','ajax_base_page_theme','a:0:{}',388,'','',0,'sites/all/modules/ctools/page_manager/plugins/tasks/page.admin.inc'),('admin/structure/pages/list','','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_list_page','a:0:{}','',15,4,1,'admin/structure/pages','admin/structure/pages','List','t','','ajax_base_page_theme','a:0:{}',140,'','',-10,'sites/all/modules/ctools/page_manager/page_manager.admin.inc'),('admin/structure/pages/wizard','','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_page_wizard_list','a:1:{i:0;i:4;}','',15,4,1,'admin/structure/pages','admin/structure/pages','Wizards','t','','ajax_base_page_theme','a:0:{}',132,'','',-5,'sites/all/modules/ctools/includes/page-wizard.inc'),('admin/structure/pages/wizard/%','a:1:{i:4;N;}','','user_access','a:1:{i:0;s:16:\"use page manager\";}','page_manager_page_wizard','a:1:{i:0;i:4;}','',30,5,0,'','admin/structure/pages/wizard/%','Wizard','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/page-wizard.inc'),('admin/structure/panels','','','user_access','a:1:{i:0;s:20:\"use panels dashboard\";}','panels_admin_page','a:0:{}','',7,3,0,'','admin/structure/panels','Panels','t','','','a:0:{}',6,'Get a bird\'s eye view of items related to Panels.','',0,'sites/all/modules/panels/includes/callbacks.inc'),('admin/structure/panels/dashboard','','','user_access','a:1:{i:0;s:20:\"use panels dashboard\";}','panels_admin_page','a:0:{}','',15,4,1,'admin/structure/panels','admin/structure/panels','Dashboard','t','','','a:0:{}',140,'','',-10,'sites/all/modules/panels/includes/callbacks.inc'),('admin/structure/panels/layouts','','','ctools_export_ui_task_access','a:2:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"list\";}','',15,4,1,'admin/structure/panels','admin/structure/panels','Layouts','t','','','a:0:{}',132,'Add, edit or delete custom content layouts.','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/add-flexible','','','ctools_export_ui_task_access','a:2:{i:0;s:14:\"panels_layouts\";i:1;s:3:\"add\";}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:3:\"add\";i:2;s:8:\"flexible\";}','',31,5,1,'admin/structure/panels/layouts','admin/structure/panels','Add flexible layout','t','','','a:0:{}',388,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/import','','','ctools_export_ui_task_access','a:2:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"import\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"import\";}','',31,5,1,'admin/structure/panels/layouts','admin/structure/panels','Import','t','','','a:0:{}',388,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list','','','ctools_export_ui_task_access','a:2:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"list\";}','ctools_export_ui_switcher_page','a:2:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"list\";}','',31,5,1,'admin/structure/panels/layouts','admin/structure/panels','List','t','','','a:0:{}',140,'','',-10,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"edit\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"edit\";i:2;i:5;}','',62,6,0,'','admin/structure/panels/layouts/list/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/clone','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:5:\"clone\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:5:\"clone\";i:2;i:5;}','',125,7,0,'','admin/structure/panels/layouts/list/%/clone','Clone','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/delete','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"delete\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"delete\";i:2;i:5;}','',125,7,0,'','admin/structure/panels/layouts/list/%/delete','Delete','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/disable','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:7:\"disable\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:7:\"disable\";i:2;i:5;}','',125,7,0,'','admin/structure/panels/layouts/list/%/disable','Disable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/edit','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"edit\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:4:\"edit\";i:2;i:5;}','',125,7,1,'admin/structure/panels/layouts/list/%','admin/structure/panels/layouts/list/%','Edit','t','','','a:0:{}',140,'','',-10,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/enable','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"enable\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"enable\";i:2;i:5;}','',125,7,0,'','admin/structure/panels/layouts/list/%/enable','Enable','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/export','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"export\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"export\";i:2;i:5;}','',125,7,1,'admin/structure/panels/layouts/list/%','admin/structure/panels/layouts/list/%','Export','t','','','a:0:{}',132,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/panels/layouts/list/%/revert','a:1:{i:5;a:1:{s:21:\"ctools_export_ui_load\";a:1:{i:0;s:14:\"panels_layouts\";}}}','','ctools_export_ui_task_access','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"revert\";i:2;i:5;}','ctools_export_ui_switcher_page','a:3:{i:0;s:14:\"panels_layouts\";i:1;s:6:\"delete\";i:2;i:5;}','',125,7,0,'','admin/structure/panels/layouts/list/%/revert','Revert','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/export-ui.inc'),('admin/structure/panels/settings','','','user_access','a:1:{i:0;s:20:\"use panels dashboard\";}','drupal_get_form','a:1:{i:0;s:26:\"panels_admin_settings_page\";}','',15,4,1,'admin/structure/panels','admin/structure/panels','Settings','t','','','a:0:{}',132,'','',0,'sites/all/modules/panels/includes/callbacks.inc'),('admin/structure/panels/settings/general','','','user_access','a:1:{i:0;s:23:\"administer page manager\";}','drupal_get_form','a:1:{i:0;s:26:\"panels_admin_settings_page\";}','',31,5,1,'admin/structure/panels/settings','admin/structure/panels','General','t','','','a:0:{}',140,'','',-10,'sites/all/modules/panels/includes/callbacks.inc'),('admin/structure/panels/settings/panel-page','','','user_access','a:1:{i:0;s:20:\"use panels dashboard\";}','panels_admin_panel_context_page','a:0:{}','',31,5,1,'admin/structure/panels/settings','admin/structure/panels','Panel pages','t','','','a:0:{}',132,'','',-10,'sites/all/modules/panels/includes/callbacks.inc'),('admin/structure/taxonomy','','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:1:{i:0;s:30:\"taxonomy_overview_vocabularies\";}','',7,3,0,'','admin/structure/taxonomy','Taxonomy','t','','','a:0:{}',6,'Manage tagging, categorization, and classification of your content.','',0,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:23:\"taxonomy_overview_terms\";i:1;i:3;}','',14,4,0,'','admin/structure/taxonomy/%','','entity_label','a:2:{i:0;s:19:\"taxonomy_vocabulary\";i:1;i:3;}','','a:0:{}',6,'','',0,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%/add','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:3:{i:0;s:18:\"taxonomy_form_term\";i:1;a:0:{}i:2;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Add term','t','','','a:0:{}',388,'','',0,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%/display','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:7:\"default\";}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/display/default','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:7:\"default\";i:3;s:11:\"user_access\";i:4;s:19:\"administer taxonomy\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:7:\"default\";}','',59,6,1,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/display/full','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:4:\"full\";i:3;s:11:\"user_access\";i:4;s:19:\"administer taxonomy\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:4:\"full\";}','',59,6,1,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Taxonomy term page','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/display/token','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:5:\"token\";i:3;s:11:\"user_access\";i:4;s:19:\"administer taxonomy\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;i:3;s:5:\"token\";}','',59,6,1,'admin/structure/taxonomy/%/display','admin/structure/taxonomy/%','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/edit','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:24:\"taxonomy_form_vocabulary\";i:1;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Edit','t','','','a:0:{}',132,'','',-10,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/%/fields','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:13:\"taxonomy_term\";i:2;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',58,6,0,'','admin/structure/taxonomy/%/fields/%','','field_ui_menu_title','a:1:{i:0;i:5;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/delete','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/edit','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/field-settings','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/fields/%/widget-type','a:2:{i:3;a:1:{s:37:\"taxonomy_vocabulary_machine_name_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}i:5;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:13:\"taxonomy_term\";i:1;i:3;i:2;s:1:\"3\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:5;}','',117,7,1,'admin/structure/taxonomy/%/fields/%','admin/structure/taxonomy/%/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/taxonomy/%/list','a:1:{i:3;s:37:\"taxonomy_vocabulary_machine_name_load\";}','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:2:{i:0;s:23:\"taxonomy_overview_terms\";i:1;i:3;}','',29,5,1,'admin/structure/taxonomy/%','admin/structure/taxonomy/%','List','t','','','a:0:{}',140,'','',-20,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/add','','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:1:{i:0;s:24:\"taxonomy_form_vocabulary\";}','',15,4,1,'admin/structure/taxonomy','admin/structure/taxonomy','Add vocabulary','t','','','a:0:{}',388,'','',0,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/taxonomy/list','','','user_access','a:1:{i:0;s:19:\"administer taxonomy\";}','drupal_get_form','a:1:{i:0;s:30:\"taxonomy_overview_vocabularies\";}','',15,4,1,'admin/structure/taxonomy','admin/structure/taxonomy','List','t','','','a:0:{}',140,'','',-10,'modules/taxonomy/taxonomy.admin.inc'),('admin/structure/types','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','node_overview_types','a:0:{}','',7,3,0,'','admin/structure/types','Content types','t','','','a:0:{}',6,'Manage content types, including default status, front page promotion, comment settings, etc.','',0,'modules/node/content_types.inc'),('admin/structure/types/add','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:1:{i:0;s:14:\"node_type_form\";}','',15,4,1,'admin/structure/types','admin/structure/types','Add content type','t','','','a:0:{}',388,'','',0,'modules/node/content_types.inc'),('admin/structure/types/list','','','user_access','a:1:{i:0;s:24:\"administer content types\";}','node_overview_types','a:0:{}','',15,4,1,'admin/structure/types','admin/structure/types','List','t','','','a:0:{}',140,'','',-10,'modules/node/content_types.inc'),('admin/structure/types/manage/%','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:14:\"node_type_form\";i:1;i:4;}','',30,5,0,'','admin/structure/types/manage/%','Edit content type','node_type_page_title','a:1:{i:0;i:4;}','','a:0:{}',6,'','',0,'modules/node/content_types.inc'),('admin/structure/types/manage/%/comment/display','a:1:{i:4;s:22:\"comment_node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:7:\"default\";}','',123,7,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Comment display','t','','','a:0:{}',132,'','',4,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/display/default','a:1:{i:4;s:22:\"comment_node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:7:\"default\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:7:\"default\";}','',247,8,1,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/display/full','a:1:{i:4;s:22:\"comment_node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:4:\"full\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:4:\"full\";}','',247,8,1,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%','Full comment','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/display/token','a:1:{i:4;s:22:\"comment_node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:5:\"token\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:7:\"comment\";i:2;i:4;i:3;s:5:\"token\";}','',247,8,1,'admin/structure/types/manage/%/comment/display','admin/structure/types/manage/%','Tokens','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields','a:1:{i:4;s:22:\"comment_node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:7:\"comment\";i:2;i:4;}','',123,7,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Comment fields','t','','','a:0:{}',132,'','',3,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',246,8,0,'','admin/structure/types/manage/%/comment/fields/%','','field_ui_menu_title','a:1:{i:0;i:7;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/delete','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/edit','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/field-settings','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/comment/fields/%/widget-type','a:2:{i:4;a:1:{s:22:\"comment_node_type_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:7;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:7:\"comment\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:7;}','',493,9,1,'admin/structure/types/manage/%/comment/fields/%','admin/structure/types/manage/%/comment/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/delete','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:24:\"node_type_delete_confirm\";i:1;i:4;}','',61,6,0,'','admin/structure/types/manage/%/delete','Delete','t','','','a:0:{}',6,'','',0,'modules/node/content_types.inc'),('admin/structure/types/manage/%/display','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:7:\"default\";}','',61,6,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Manage display','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/default','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:7:\"default\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:7:\"default\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Default','t','','','a:0:{}',140,'','',-10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/full','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:4:\"full\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:4:\"full\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Full content','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/rss','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:3:\"rss\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:3:\"rss\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','RSS','t','','','a:0:{}',132,'','',2,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/search_index','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:12:\"search_index\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:12:\"search_index\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Search index','t','','','a:0:{}',132,'','',3,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/search_result','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:13:\"search_result\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:13:\"search_result\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Search result','t','','','a:0:{}',132,'','',4,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/teaser','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:6:\"teaser\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:6:\"teaser\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Teaser','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/display/token','a:1:{i:4;s:14:\"node_type_load\";}','','_field_ui_view_mode_menu_access','a:5:{i:0;s:4:\"node\";i:1;i:4;i:2;s:5:\"token\";i:3;s:11:\"user_access\";i:4;s:24:\"administer content types\";}','drupal_get_form','a:4:{i:0;s:30:\"field_ui_display_overview_form\";i:1;s:4:\"node\";i:2;i:4;i:3;s:5:\"token\";}','',123,7,1,'admin/structure/types/manage/%/display','admin/structure/types/manage/%','Tokens','t','','','a:0:{}',132,'','',5,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/edit','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:14:\"node_type_form\";i:1;i:4;}','',61,6,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Edit','t','','','a:0:{}',140,'','',0,'modules/node/content_types.inc'),('admin/structure/types/manage/%/fields','a:1:{i:4;s:14:\"node_type_load\";}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:3:{i:0;s:28:\"field_ui_field_overview_form\";i:1;s:4:\"node\";i:2;i:4;}','',61,6,1,'admin/structure/types/manage/%','admin/structure/types/manage/%','Manage fields','t','','','a:0:{}',132,'','',1,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',122,7,0,'','admin/structure/types/manage/%/fields/%','','field_ui_menu_title','a:1:{i:0;i:6;}','','a:0:{}',6,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/delete','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:26:\"field_ui_field_delete_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Delete','t','','','a:0:{}',132,'','',10,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/edit','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:24:\"field_ui_field_edit_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Edit','t','','','a:0:{}',140,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/field-settings','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:28:\"field_ui_field_settings_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Field settings','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/structure/types/manage/%/fields/%/widget-type','a:2:{i:4;a:1:{s:14:\"node_type_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}i:6;a:1:{s:18:\"field_ui_menu_load\";a:4:{i:0;s:4:\"node\";i:1;i:4;i:2;s:1:\"4\";i:3;s:4:\"%map\";}}}','','user_access','a:1:{i:0;s:24:\"administer content types\";}','drupal_get_form','a:2:{i:0;s:25:\"field_ui_widget_type_form\";i:1;i:6;}','',245,8,1,'admin/structure/types/manage/%/fields/%','admin/structure/types/manage/%/fields/%','Widget type','t','','','a:0:{}',132,'','',0,'modules/field_ui/field_ui.admin.inc'),('admin/tasks','','','user_access','a:1:{i:0;s:27:\"access administration pages\";}','system_admin_menu_block_page','a:0:{}','',3,2,1,'admin','admin','Tasks','t','','','a:0:{}',140,'','',-20,'modules/system/system.admin.inc'),('admin/update/ready','','','update_manager_access','a:0:{}','drupal_get_form','a:1:{i:0;s:32:\"update_manager_update_ready_form\";}','',7,3,0,'','admin/update/ready','Ready to update','t','','','a:0:{}',0,'','',0,'modules/update/update.manager.inc'),('batch','','','1','a:0:{}','system_batch_page','a:0:{}','',1,1,0,'','batch','','t','','_system_batch_theme','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('blog','','','user_access','a:1:{i:0;s:14:\"access content\";}','blog_page_last','a:0:{}','',1,1,0,'','blog','Blogs','t','','','a:0:{}',20,'','',0,'modules/blog/blog.pages.inc'),('blog/%','a:1:{i:1;s:22:\"user_uid_optional_load\";}','a:1:{i:1;s:24:\"user_uid_optional_to_arg\";}','blog_page_user_access','a:1:{i:0;i:1;}','blog_page_user','a:1:{i:0;i:1;}','',2,2,0,'','blog/%','My blog','t','','','a:0:{}',6,'','',0,'modules/blog/blog.pages.inc'),('blog/%/feed','a:1:{i:1;s:9:\"user_load\";}','','blog_page_user_access','a:1:{i:0;i:1;}','blog_feed_user','a:1:{i:0;i:1;}','',5,3,0,'','blog/%/feed','Blogs','t','','','a:0:{}',0,'','',0,'modules/blog/blog.pages.inc'),('blog/feed','','','user_access','a:1:{i:0;s:14:\"access content\";}','blog_feed_last','a:0:{}','',3,2,0,'','blog/feed','Blogs','t','','','a:0:{}',0,'','',0,'modules/blog/blog.pages.inc'),('comment/%','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:15:\"access comments\";}','comment_permalink','a:1:{i:0;i:1;}','',2,2,0,'','comment/%','Comment permalink','t','','','a:0:{}',6,'','',0,''),('comment/%/approve','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_approve','a:1:{i:0;i:1;}','',5,3,0,'','comment/%/approve','Approve','t','','','a:0:{}',6,'','',1,'modules/comment/comment.pages.inc'),('comment/%/delete','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:19:\"administer comments\";}','comment_confirm_delete_page','a:1:{i:0;i:1;}','',5,3,1,'comment/%','comment/%','Delete','t','','','a:0:{}',132,'','',2,'modules/comment/comment.admin.inc'),('comment/%/edit','a:1:{i:1;s:12:\"comment_load\";}','','comment_access','a:2:{i:0;s:4:\"edit\";i:1;i:1;}','comment_edit_page','a:1:{i:0;i:1;}','',5,3,1,'comment/%','comment/%','Edit','t','','','a:0:{}',132,'','',0,''),('comment/%/view','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:15:\"access comments\";}','comment_permalink','a:1:{i:0;i:1;}','',5,3,1,'comment/%','comment/%','View comment','t','','','a:0:{}',140,'','',-10,''),('comment/reply/%','a:1:{i:2;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:4:\"view\";i:1;i:2;}','comment_reply','a:1:{i:0;i:2;}','',6,3,0,'','comment/reply/%','Add new comment','t','','','a:0:{}',6,'','',0,'modules/comment/comment.pages.inc'),('contact','','','user_access','a:1:{i:0;s:29:\"access site-wide contact form\";}','drupal_get_form','a:1:{i:0;s:17:\"contact_site_form\";}','',1,1,0,'','contact','Contact','t','','','a:0:{}',20,'','',0,'modules/contact/contact.pages.inc'),('ctools/autocomplete/%','a:1:{i:2;N;}','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_content_autocomplete_entity','a:1:{i:0;i:2;}','',6,3,0,'','ctools/autocomplete/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/content.menu.inc'),('ctools/context/ajax/access/add','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_access_ajax_add','a:0:{}','',31,5,0,'','ctools/context/ajax/access/add','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-access-admin.inc'),('ctools/context/ajax/access/configure','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_access_ajax_edit','a:0:{}','',31,5,0,'','ctools/context/ajax/access/configure','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-access-admin.inc'),('ctools/context/ajax/access/delete','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_access_ajax_delete','a:0:{}','',31,5,0,'','ctools/context/ajax/access/delete','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-access-admin.inc'),('ctools/context/ajax/add','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_context_ajax_item_add','a:0:{}','',15,4,0,'','ctools/context/ajax/add','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-admin.inc'),('ctools/context/ajax/configure','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_context_ajax_item_edit','a:0:{}','',15,4,0,'','ctools/context/ajax/configure','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-admin.inc'),('ctools/context/ajax/delete','','','user_access','a:1:{i:0;s:14:\"access content\";}','ctools_context_ajax_item_delete','a:0:{}','',15,4,0,'','ctools/context/ajax/delete','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/ctools/includes/context-admin.inc'),('file/ajax','','','user_access','a:1:{i:0;s:14:\"access content\";}','file_ajax_upload','a:0:{}','ajax_deliver',3,2,0,'','file/ajax','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,''),('file/progress','','','user_access','a:1:{i:0;s:14:\"access content\";}','file_ajax_progress','a:0:{}','',3,2,0,'','file/progress','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,''),('filter/tips','','','1','a:0:{}','filter_tips_long','a:0:{}','',3,2,0,'','filter/tips','Compose tips','t','','','a:0:{}',20,'','',0,'modules/filter/filter.pages.inc'),('front-page','','','ctools_access_menu','a:1:{i:0;a:2:{s:4:\"type\";s:4:\"none\";s:8:\"settings\";N;}}','page_manager_page_execute','a:1:{i:0;s:10:\"front_page\";}','',1,1,0,'','front-page','','t','','','a:0:{}',0,'','',0,'sites/all/modules/ctools/page_manager/plugins/tasks/page.inc'),('imce','','','imce_access','a:2:{i:0;b:0;i:1;i:1;}','imce','a:0:{}','',1,1,0,'','imce','File browser','t','','','a:0:{}',0,'','',0,'sites/all/modules/imce/inc/imce.page.inc'),('node','','','user_access','a:1:{i:0;s:14:\"access content\";}','node_page_default','a:0:{}','',1,1,0,'','node','','t','','','a:0:{}',0,'','',0,''),('node/%','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:4:\"view\";i:1;i:1;}','node_page_view','a:1:{i:0;i:1;}','',2,2,0,'','node/%','','node_page_title','a:1:{i:0;i:1;}','','a:0:{}',6,'','',0,''),('node/%/delete','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:6:\"delete\";i:1;i:1;}','drupal_get_form','a:2:{i:0;s:19:\"node_delete_confirm\";i:1;i:1;}','',5,3,2,'node/%','node/%','Delete','t','','','a:0:{}',132,'','',1,'modules/node/node.pages.inc'),('node/%/edit','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:6:\"update\";i:1;i:1;}','node_page_edit','a:1:{i:0;i:1;}','',5,3,3,'node/%','node/%','Edit','t','','','a:0:{}',132,'','',0,'modules/node/node.pages.inc'),('node/%/revisions','a:1:{i:1;s:9:\"node_load\";}','','_node_revision_access','a:1:{i:0;i:1;}','node_revision_overview','a:1:{i:0;i:1;}','',5,3,1,'node/%','node/%','Revisions','t','','','a:0:{}',132,'','',2,'modules/node/node.pages.inc'),('node/%/revisions/%/delete','a:2:{i:1;a:1:{s:9:\"node_load\";a:1:{i:0;i:3;}}i:3;N;}','','_node_revision_access','a:2:{i:0;i:1;i:1;s:6:\"delete\";}','drupal_get_form','a:2:{i:0;s:28:\"node_revision_delete_confirm\";i:1;i:1;}','',21,5,0,'','node/%/revisions/%/delete','Delete earlier revision','t','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('node/%/revisions/%/revert','a:2:{i:1;a:1:{s:9:\"node_load\";a:1:{i:0;i:3;}}i:3;N;}','','_node_revision_access','a:2:{i:0;i:1;i:1;s:6:\"update\";}','drupal_get_form','a:2:{i:0;s:28:\"node_revision_revert_confirm\";i:1;i:1;}','',21,5,0,'','node/%/revisions/%/revert','Revert to earlier revision','t','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('node/%/revisions/%/view','a:2:{i:1;a:1:{s:9:\"node_load\";a:1:{i:0;i:3;}}i:3;N;}','','_node_revision_access','a:1:{i:0;i:1;}','node_show','a:2:{i:0;i:1;i:1;b:1;}','',21,5,0,'','node/%/revisions/%/view','Revisions','t','','','a:0:{}',6,'','',0,''),('node/%/view','a:1:{i:1;s:9:\"node_load\";}','','node_access','a:2:{i:0;s:4:\"view\";i:1;i:1;}','node_page_view','a:1:{i:0;i:1;}','',5,3,1,'node/%','node/%','View','t','','','a:0:{}',140,'','',-10,''),('node/add','','','_node_add_access','a:0:{}','node_add_page','a:0:{}','',3,2,0,'','node/add','Add content','t','','','a:0:{}',6,'','',0,'modules/node/node.pages.inc'),('node/add/article','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:7:\"article\";}','node_add','a:1:{i:0;s:7:\"article\";}','',7,3,0,'','node/add/article','Article','check_plain','','','a:0:{}',6,'Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.','',0,'modules/node/node.pages.inc'),('node/add/blog','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:4:\"blog\";}','node_add','a:1:{i:0;s:4:\"blog\";}','',7,3,0,'','node/add/blog','Blog entry','check_plain','','','a:0:{}',6,'Use for multi-user blogs. Every user gets a personal blog.','',0,'modules/node/node.pages.inc'),('node/add/page','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:4:\"page\";}','node_add','a:1:{i:0;s:4:\"page\";}','',7,3,0,'','node/add/page','Basic page','check_plain','','','a:0:{}',6,'Use <em>basic pages</em> for your static content, such as an \'About us\' page.','',0,'modules/node/node.pages.inc'),('node/add/portfolio','','','node_access','a:2:{i:0;s:6:\"create\";i:1;s:9:\"portfolio\";}','node_add','a:1:{i:0;s:9:\"portfolio\";}','',7,3,0,'','node/add/portfolio','Portfolio','check_plain','','','a:0:{}',6,'Portfolio content.','',0,'modules/node/node.pages.inc'),('overlay-ajax/%','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:14:\"access overlay\";}','overlay_ajax_render_region','a:1:{i:0;i:1;}','',2,2,0,'','overlay-ajax/%','','t','','','a:0:{}',0,'','',0,''),('overlay/dismiss-message','','','user_access','a:1:{i:0;s:14:\"access overlay\";}','overlay_user_dismiss_message','a:0:{}','',3,2,0,'','overlay/dismiss-message','','t','','','a:0:{}',0,'','',0,''),('panels/ajax','','','user_access','a:1:{i:0;s:14:\"access content\";}','panels_ajax_router','a:0:{}','ajax_deliver',3,2,0,'','panels/ajax','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,''),('portfolio','','','user_access','a:1:{i:0;s:14:\"access content\";}','portfolio_default_page','a:1:{i:0;i:1;}','',1,1,0,'','portfolio','Portfolio','t','','','a:0:{}',0,'','',0,'sites/all/modules/tabvn/portfolio/portfolio.pages.inc'),('rss.xml','','','user_access','a:1:{i:0;s:14:\"access content\";}','node_feed','a:2:{i:0;b:0;i:1;a:0:{}}','',1,1,0,'','rss.xml','RSS feed','t','','','a:0:{}',0,'','',0,''),('search','','','search_is_active','a:0:{}','search_view','a:0:{}','',1,1,0,'','search','Search','t','','','a:0:{}',20,'','',0,'modules/search/search.pages.inc'),('search/node','','','_search_menu_access','a:1:{i:0;s:4:\"node\";}','search_view','a:2:{i:0;s:4:\"node\";i:1;s:0:\"\";}','',3,2,1,'search','search','Content','t','','','a:0:{}',132,'','',-10,'modules/search/search.pages.inc'),('search/node/%','a:1:{i:2;a:1:{s:14:\"menu_tail_load\";a:2:{i:0;s:4:\"%map\";i:1;s:6:\"%index\";}}}','a:1:{i:2;s:16:\"menu_tail_to_arg\";}','_search_menu_access','a:1:{i:0;s:4:\"node\";}','search_view','a:2:{i:0;s:4:\"node\";i:1;i:2;}','',6,3,1,'search/node','search/node/%','Content','t','','','a:0:{}',132,'','',0,'modules/search/search.pages.inc'),('search/user','','','_search_menu_access','a:1:{i:0;s:4:\"user\";}','search_view','a:2:{i:0;s:4:\"user\";i:1;s:0:\"\";}','',3,2,1,'search','search','Users','t','','','a:0:{}',132,'','',0,'modules/search/search.pages.inc'),('search/user/%','a:1:{i:2;a:1:{s:14:\"menu_tail_load\";a:2:{i:0;s:4:\"%map\";i:1;s:6:\"%index\";}}}','a:1:{i:2;s:16:\"menu_tail_to_arg\";}','_search_menu_access','a:1:{i:0;s:4:\"user\";}','search_view','a:2:{i:0;s:4:\"user\";i:1;i:2;}','',6,3,1,'search/node','search/node/%','Users','t','','','a:0:{}',132,'','',0,'modules/search/search.pages.inc'),('sites/default/files/styles/%','a:1:{i:4;s:16:\"image_style_load\";}','','1','a:0:{}','image_style_deliver','a:1:{i:0;i:4;}','',30,5,0,'','sites/default/files/styles/%','Generate image style','t','','','a:0:{}',0,'','',0,''),('system/ajax','','','1','a:0:{}','ajax_form_callback','a:0:{}','ajax_deliver',3,2,0,'','system/ajax','AHAH callback','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'includes/form.inc'),('system/files','','','1','a:0:{}','file_download','a:1:{i:0;s:7:\"private\";}','',3,2,0,'','system/files','File download','t','','','a:0:{}',0,'','',0,''),('system/files/styles/%','a:1:{i:3;s:16:\"image_style_load\";}','','1','a:0:{}','image_style_deliver','a:1:{i:0;i:3;}','',14,4,0,'','system/files/styles/%','Generate image style','t','','','a:0:{}',0,'','',0,''),('system/temporary','','','1','a:0:{}','file_download','a:1:{i:0;s:9:\"temporary\";}','',3,2,0,'','system/temporary','Temporary files','t','','','a:0:{}',0,'','',0,''),('system/timezone','','','1','a:0:{}','system_timezone','a:0:{}','',3,2,0,'','system/timezone','Time zone','t','','','a:0:{}',0,'','',0,'modules/system/system.admin.inc'),('tagadelic','','','user_access','a:1:{i:0;s:14:\"access content\";}','tagadelic_page_chunk','a:1:{i:0;N;}','',1,1,0,'','tagadelic','Tags','t','','','a:0:{}',20,'','',0,''),('tagadelic/chunk/%','a:1:{i:2;s:19:\"tagadelic_vocs_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','tagadelic_page_chunk','a:1:{i:0;i:2;}','',6,3,0,'','tagadelic/chunk/%','Tags','t','','','a:0:{}',20,'','',0,''),('tagadelic/list/%','a:1:{i:2;s:19:\"tagadelic_vocs_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','tagadelic_page_list','a:1:{i:0;i:2;}','',6,3,0,'','tagadelic/list/%','Tags','t','','','a:0:{}',0,'','',0,''),('taxonomy/autocomplete','','','user_access','a:1:{i:0;s:14:\"access content\";}','taxonomy_autocomplete','a:0:{}','',3,2,0,'','taxonomy/autocomplete','Autocomplete taxonomy','t','','','a:0:{}',0,'','',0,'modules/taxonomy/taxonomy.pages.inc'),('taxonomy/term/%','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','taxonomy_term_page','a:1:{i:0;i:2;}','',6,3,0,'','taxonomy/term/%','Taxonomy term','taxonomy_term_title','a:1:{i:0;i:2;}','','a:0:{}',6,'','',0,'modules/taxonomy/taxonomy.pages.inc'),('taxonomy/term/%/edit','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','taxonomy_term_edit_access','a:1:{i:0;i:2;}','drupal_get_form','a:3:{i:0;s:18:\"taxonomy_form_term\";i:1;i:2;i:2;N;}','',13,4,1,'taxonomy/term/%','taxonomy/term/%','Edit','t','','','a:0:{}',132,'','',10,'modules/taxonomy/taxonomy.admin.inc'),('taxonomy/term/%/feed','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','taxonomy_term_feed','a:1:{i:0;i:2;}','',13,4,0,'','taxonomy/term/%/feed','Taxonomy term','taxonomy_term_title','a:1:{i:0;i:2;}','','a:0:{}',0,'','',0,'modules/taxonomy/taxonomy.pages.inc'),('taxonomy/term/%/view','a:1:{i:2;s:18:\"taxonomy_term_load\";}','','user_access','a:1:{i:0;s:14:\"access content\";}','taxonomy_term_page','a:1:{i:0;i:2;}','',13,4,1,'taxonomy/term/%','taxonomy/term/%','View','t','','','a:0:{}',140,'','',0,'modules/taxonomy/taxonomy.pages.inc'),('token/autocomplete/%','a:1:{i:2;s:15:\"token_type_load\";}','','1','a:0:{}','token_autocomplete_token','a:1:{i:0;i:2;}','',6,3,0,'','token/autocomplete/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/token/token.pages.inc'),('token/flush-cache','','','user_access','a:1:{i:0;s:12:\"flush caches\";}','token_flush_cache_callback','a:0:{}','',3,2,0,'','token/flush-cache','','t','','','a:0:{}',0,'','',0,'sites/all/modules/token/token.pages.inc'),('token/tree','','','1','a:0:{}','token_page_output_tree','a:0:{}','',3,2,0,'','token/tree','','t','','ajax_base_page_theme','a:0:{}',0,'','',0,'sites/all/modules/token/token.pages.inc'),('toolbar/toggle','','','user_access','a:1:{i:0;s:14:\"access toolbar\";}','toolbar_toggle_page','a:0:{}','',3,2,0,'','toolbar/toggle','Toggle drawer visibility','t','','','a:0:{}',0,'','',0,''),('user','','','1','a:0:{}','user_page','a:0:{}','',1,1,0,'','user','User account','user_menu_title','','','a:0:{}',6,'','',-10,'modules/user/user.pages.inc'),('user/%','a:1:{i:1;s:9:\"user_load\";}','','user_view_access','a:1:{i:0;i:1;}','user_view_page','a:1:{i:0;i:1;}','',2,2,0,'','user/%','My account','user_page_title','a:1:{i:0;i:1;}','','a:0:{}',6,'','',0,''),('user/%/cancel','a:1:{i:1;s:9:\"user_load\";}','','user_cancel_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:24:\"user_cancel_confirm_form\";i:1;i:1;}','',5,3,0,'','user/%/cancel','Cancel account','t','','','a:0:{}',6,'','',0,'modules/user/user.pages.inc'),('user/%/cancel/confirm/%/%','a:3:{i:1;s:9:\"user_load\";i:4;N;i:5;N;}','','user_cancel_access','a:1:{i:0;i:1;}','user_cancel_confirm','a:3:{i:0;i:1;i:1;i:4;i:2;i:5;}','',44,6,0,'','user/%/cancel/confirm/%/%','Confirm account cancellation','t','','','a:0:{}',6,'','',0,'modules/user/user.pages.inc'),('user/%/contact','a:1:{i:1;s:9:\"user_load\";}','','_contact_personal_tab_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:21:\"contact_personal_form\";i:1;i:1;}','',5,3,1,'user/%','user/%','Contact','t','','','a:0:{}',132,'','',2,'modules/contact/contact.pages.inc'),('user/%/edit','a:1:{i:1;s:9:\"user_load\";}','','user_edit_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:17:\"user_profile_form\";i:1;i:1;}','',5,3,1,'user/%','user/%','Edit','t','','','a:0:{}',132,'','',0,'modules/user/user.pages.inc'),('user/%/edit/account','a:1:{i:1;a:1:{s:18:\"user_category_load\";a:2:{i:0;s:4:\"%map\";i:1;s:6:\"%index\";}}}','','user_edit_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:17:\"user_profile_form\";i:1;i:1;}','',11,4,1,'user/%/edit','user/%','Account','t','','','a:0:{}',140,'','',0,'modules/user/user.pages.inc'),('user/%/imce','a:1:{i:1;s:9:\"user_load\";}','','imce_user_page_access','a:1:{i:0;i:1;}','imce_user_page','a:1:{i:0;i:1;}','',5,3,1,'user/%','user/%','File browser','t','','','a:0:{}',132,'','',10,'sites/all/modules/imce/inc/imce.page.inc'),('user/%/shortcuts','a:1:{i:1;s:9:\"user_load\";}','','shortcut_set_switch_access','a:1:{i:0;i:1;}','drupal_get_form','a:2:{i:0;s:19:\"shortcut_set_switch\";i:1;i:1;}','',5,3,1,'user/%','user/%','Shortcuts','t','','','a:0:{}',132,'','',0,'modules/shortcut/shortcut.admin.inc'),('user/%/view','a:1:{i:1;s:9:\"user_load\";}','','user_view_access','a:1:{i:0;i:1;}','user_view_page','a:1:{i:0;i:1;}','',5,3,1,'user/%','user/%','View','t','','','a:0:{}',140,'','',-10,''),('user/autocomplete','','','user_access','a:1:{i:0;s:20:\"access user profiles\";}','user_autocomplete','a:0:{}','',3,2,0,'','user/autocomplete','User autocomplete','t','','','a:0:{}',0,'','',0,'modules/user/user.pages.inc'),('user/login','','','user_is_anonymous','a:0:{}','user_page','a:0:{}','',3,2,1,'user','user','Log in','t','','','a:0:{}',140,'','',0,'modules/user/user.pages.inc'),('user/logout','','','user_is_logged_in','a:0:{}','user_logout','a:0:{}','',3,2,0,'','user/logout','Log out','t','','','a:0:{}',6,'','',10,'modules/user/user.pages.inc'),('user/password','','','1','a:0:{}','drupal_get_form','a:1:{i:0;s:9:\"user_pass\";}','',3,2,1,'user','user','Request new password','t','','','a:0:{}',132,'','',0,'modules/user/user.pages.inc'),('user/register','','','user_register_access','a:0:{}','drupal_get_form','a:1:{i:0;s:18:\"user_register_form\";}','',3,2,1,'user','user','Create new account','t','','','a:0:{}',132,'','',0,''),('user/reset/%/%/%','a:3:{i:2;N;i:3;N;i:4;N;}','','1','a:0:{}','drupal_get_form','a:4:{i:0;s:15:\"user_pass_reset\";i:1;i:2;i:2;i:3;i:3;i:4;}','',24,5,0,'','user/reset/%/%/%','Reset password','t','','','a:0:{}',0,'','',0,'modules/user/user.pages.inc'),('wysiwyg/%','a:1:{i:1;N;}','','user_access','a:1:{i:0;s:14:\"access content\";}','wysiwyg_dialog','a:1:{i:0;i:1;}','wysiwyg_deliver_dialog_page',2,2,0,'','wysiwyg/%','','t','','','a:0:{}',0,'','',0,'sites/all/modules/wysiwyg/wysiwyg.dialog.inc');
/*!40000 ALTER TABLE `menu_router` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `node`
--

DROP TABLE IF EXISTS `node`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node` (
  `nid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for a node.',
  `vid` int(10) unsigned DEFAULT NULL COMMENT 'The current node_revision.vid version identifier.',
  `type` varchar(32) NOT NULL DEFAULT '' COMMENT 'The node_type.type of this node.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The languages.language of this node.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of this node, always treated as non-markup plain text.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that owns this node; initially, this is the user that created it.',
  `status` int(11) NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether the node is published (visible to non-administrators).',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was created.',
  `changed` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was most recently saved.',
  `comment` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this node: 0 = no, 1 = closed (read only), 2 = open (read/write).',
  `promote` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node should be displayed on the front page.',
  `sticky` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node should be displayed at the top of lists in which it appears.',
  `tnid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The translation set id for this node, which equals the node id of the source post in each set.',
  `translate` int(11) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this translation page needs to be updated.',
  PRIMARY KEY (`nid`),
  UNIQUE KEY `vid` (`vid`),
  KEY `node_changed` (`changed`),
  KEY `node_created` (`created`),
  KEY `node_frontpage` (`promote`,`status`,`sticky`,`created`),
  KEY `node_status_type` (`status`,`type`,`nid`),
  KEY `node_title_type` (`title`,`type`(4)),
  KEY `node_type` (`type`(4)),
  KEY `uid` (`uid`),
  KEY `tnid` (`tnid`),
  KEY `translate` (`translate`)
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8 COMMENT='The base table for nodes.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node`
--

LOCK TABLES `node` WRITE;
/*!40000 ALTER TABLE `node` DISABLE KEYS */;
INSERT INTO `node` VALUES (1,1,'blog','und','Aenean lacinia bibendum',1,1,1359711790,1359711482,2,1,0,0,0),(2,2,'blog','und','Vivamus metus massa',1,1,1359708253,1359708253,2,1,0,0,0),(3,3,'blog','und','Phasellus nec velit sit amet',1,1,1359708289,1359708289,2,1,0,0,0),(4,4,'portfolio','und','Maritime Details',1,1,1359716915,1359720530,1,0,0,0,0),(5,5,'portfolio','und','Grand Canyon',1,1,1359737417,1359735822,1,0,0,0,0),(6,6,'portfolio','und','Coffee Time ',1,1,1359737417,1359735859,1,0,0,0,0),(7,7,'portfolio','und','Surfing The Web',1,1,1359737417,1359735968,1,0,0,0,0),(8,8,'portfolio','und','Wireless Keyboard',1,1,1359737417,1359735918,1,0,0,0,0),(9,9,'portfolio','und','Pine Tree Near Water',1,1,1359734895,1359734895,1,0,0,0,0),(10,10,'portfolio','und',' Digital World',1,1,1359734998,1359735009,1,0,0,0,0),(11,11,'portfolio','und','Grand Canyon',1,1,1359735771,1359735771,1,0,0,0,0),(12,12,'page','und','Shortcodes',1,1,1359798991,1359808293,1,0,0,0,0),(13,13,'page','und','Full width',1,1,1359800228,1359800228,1,0,0,0,0),(14,14,'page','und','About Us',1,1,1359800306,1359800306,1,0,0,0,0),(15,15,'page','und','Services',1,1,1359800697,1359800697,1,0,0,0,0),(16,16,'page','und','Pricing tables',1,1,1359800777,1359800777,1,0,0,0,0);
/*!40000 ALTER TABLE `node` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `node_access`
--

DROP TABLE IF EXISTS `node_access`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_access` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record affects.',
  `gid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The grant ID a user must possess in the specified realm to gain this row’s privileges on the node.',
  `realm` varchar(255) NOT NULL DEFAULT '' COMMENT 'The realm in which the user must possess the grant ID. Each node access node can define one or more realms.',
  `grant_view` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can view this node.',
  `grant_update` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can edit this node.',
  `grant_delete` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether a user with the realm/grant pair can delete this node.',
  PRIMARY KEY (`nid`,`gid`,`realm`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Identifies which realm/grant pairs a user must possess in...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_access`
--

LOCK TABLES `node_access` WRITE;
/*!40000 ALTER TABLE `node_access` DISABLE KEYS */;
INSERT INTO `node_access` VALUES (0,0,'all',1,0,0);
/*!40000 ALTER TABLE `node_access` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `node_comment_statistics`
--

DROP TABLE IF EXISTS `node_comment_statistics`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_comment_statistics` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid for which the statistics are compiled.',
  `cid` int(11) NOT NULL DEFAULT '0' COMMENT 'The comment.cid of the last comment.',
  `last_comment_timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp of the last comment that was posted within this node, from comment.changed.',
  `last_comment_name` varchar(60) DEFAULT NULL COMMENT 'The name of the latest author to post a comment on this node, from comment.name.',
  `last_comment_uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The user ID of the latest author to post a comment on this node, from comment.uid.',
  `comment_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The total number of comments on this node.',
  PRIMARY KEY (`nid`),
  KEY `node_comment_timestamp` (`last_comment_timestamp`),
  KEY `comment_count` (`comment_count`),
  KEY `last_comment_uid` (`last_comment_uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maintains statistics of node and comments posts to show ...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_comment_statistics`
--

LOCK TABLES `node_comment_statistics` WRITE;
/*!40000 ALTER TABLE `node_comment_statistics` DISABLE KEYS */;
INSERT INTO `node_comment_statistics` VALUES (1,3,1359797325,'',1,3),(2,0,1359708253,NULL,1,0),(3,0,1359708289,NULL,1,0),(4,0,1359716915,NULL,1,0),(5,0,1359717317,NULL,1,0),(6,0,1359734371,NULL,1,0),(7,0,1359734487,NULL,1,0),(8,0,1359734848,NULL,1,0),(9,0,1359734895,NULL,1,0),(10,0,1359734998,NULL,1,0),(11,0,1359735771,NULL,1,0),(12,0,1359798991,NULL,1,0),(13,0,1359800228,NULL,1,0),(14,0,1359800306,NULL,1,0),(15,0,1359800697,NULL,1,0),(16,0,1359800777,NULL,1,0);
/*!40000 ALTER TABLE `node_comment_statistics` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `node_revision`
--

DROP TABLE IF EXISTS `node_revision`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_revision` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node this version belongs to.',
  `vid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The primary identifier for this version.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid that created this version.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of this version.',
  `log` longtext NOT NULL COMMENT 'The log entry explaining the changes in this version.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'A Unix timestamp indicating when this version was created.',
  `status` int(11) NOT NULL DEFAULT '1' COMMENT 'Boolean indicating whether the node (at the time of this revision) is published (visible to non-administrators).',
  `comment` int(11) NOT NULL DEFAULT '0' COMMENT 'Whether comments are allowed on this node (at the time of this revision): 0 = no, 1 = closed (read only), 2 = open (read/write).',
  `promote` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node (at the time of this revision) should be displayed on the front page.',
  `sticky` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the node (at the time of this revision) should be displayed at the top of lists in which it appears.',
  PRIMARY KEY (`vid`),
  KEY `nid` (`nid`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8 COMMENT='Stores information about each saved version of a node.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_revision`
--

LOCK TABLES `node_revision` WRITE;
/*!40000 ALTER TABLE `node_revision` DISABLE KEYS */;
INSERT INTO `node_revision` VALUES (1,1,1,'Aenean lacinia bibendum','',1359711482,1,2,1,0),(2,2,1,'Vivamus metus massa','',1359708253,1,2,1,0),(3,3,1,'Phasellus nec velit sit amet','',1359708289,1,2,1,0),(4,4,1,'Maritime Details','',1359720530,1,1,0,0),(5,5,1,'Grand Canyon','',1359735822,1,1,0,0),(6,6,1,'Coffee Time ','',1359735859,1,1,0,0),(7,7,1,'Surfing The Web','',1359735968,1,1,0,0),(8,8,1,'Wireless Keyboard','',1359735918,1,1,0,0),(9,9,1,'Pine Tree Near Water','',1359734895,1,1,0,0),(10,10,1,' Digital World','',1359735009,1,1,0,0),(11,11,1,'Grand Canyon','',1359735771,1,1,0,0),(12,12,1,'Shortcodes','',1359808293,1,1,0,0),(13,13,1,'Full width','',1359800228,1,1,0,0),(14,14,1,'About Us','',1359800306,1,1,0,0),(15,15,1,'Services','',1359800697,1,1,0,0),(16,16,1,'Pricing tables','',1359800777,1,1,0,0);
/*!40000 ALTER TABLE `node_revision` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `node_type`
--

DROP TABLE IF EXISTS `node_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `node_type` (
  `type` varchar(32) NOT NULL COMMENT 'The machine-readable name of this type.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The human-readable name of this type.',
  `base` varchar(255) NOT NULL COMMENT 'The base string used to construct callbacks corresponding to this node type.',
  `module` varchar(255) NOT NULL COMMENT 'The module defining this node type.',
  `description` mediumtext NOT NULL COMMENT 'A brief description of this type.',
  `help` mediumtext NOT NULL COMMENT 'Help information shown to the user when creating a node of this type.',
  `has_title` tinyint(3) unsigned NOT NULL COMMENT 'Boolean indicating whether this type uses the node.title field.',
  `title_label` varchar(255) NOT NULL DEFAULT '' COMMENT 'The label displayed for the title field on the edit form.',
  `custom` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this type is defined by a module (FALSE) or by a user via Add content type (TRUE).',
  `modified` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether this type has been modified by an administrator; currently not used in any way.',
  `locked` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether the administrator can change the machine name of this type.',
  `disabled` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'A boolean indicating whether the node type is disabled.',
  `orig_type` varchar(255) NOT NULL DEFAULT '' COMMENT 'The original machine-readable name of this node type. This may be different from the current type name if the locked field is 0.',
  PRIMARY KEY (`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about all defined node types.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `node_type`
--

LOCK TABLES `node_type` WRITE;
/*!40000 ALTER TABLE `node_type` DISABLE KEYS */;
INSERT INTO `node_type` VALUES ('article','Article','node_content','node','Use <em>articles</em> for time-sensitive content like news, press releases or blog posts.','',1,'Title',1,1,0,0,'article'),('blog','Blog entry','blog','blog','Use for multi-user blogs. Every user gets a personal blog.','',1,'Title',0,1,1,0,'blog'),('page','Basic page','node_content','node','Use <em>basic pages</em> for your static content, such as an \'About us\' page.','',1,'Title',1,1,0,0,'page'),('portfolio','Portfolio','node_content','node','Portfolio content.','',1,'Title',1,1,0,0,'portfolio');
/*!40000 ALTER TABLE `node_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `page_manager_handlers`
--

DROP TABLE IF EXISTS `page_manager_handlers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `page_manager_handlers` (
  `did` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary ID field for the table. Not used for anything except internal lookups.',
  `name` varchar(255) DEFAULT NULL COMMENT 'Unique ID for this task handler. Used to identify it programmatically.',
  `task` varchar(64) DEFAULT NULL COMMENT 'ID of the task this handler is for.',
  `subtask` varchar(64) NOT NULL DEFAULT '' COMMENT 'ID of the subtask this handler is for.',
  `handler` varchar(64) DEFAULT NULL COMMENT 'ID of the task handler being used.',
  `weight` int(11) DEFAULT NULL COMMENT 'The order in which this handler appears. Lower numbers go first.',
  `conf` longtext NOT NULL COMMENT 'Serialized configuration of the handler, if needed.',
  PRIMARY KEY (`did`),
  UNIQUE KEY `name` (`name`),
  KEY `fulltask` (`task`,`subtask`,`weight`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `page_manager_handlers`
--

LOCK TABLES `page_manager_handlers` WRITE;
/*!40000 ALTER TABLE `page_manager_handlers` DISABLE KEYS */;
INSERT INTO `page_manager_handlers` VALUES (1,'page_front_page_panel_context','page','front_page','panel_context',0,'a:10:{s:5:\"title\";s:5:\"Panel\";s:9:\"no_blocks\";i:0;s:8:\"pipeline\";s:8:\"standard\";s:22:\"body_classes_to_remove\";s:0:\"\";s:19:\"body_classes_to_add\";s:0:\"\";s:6:\"css_id\";s:0:\"\";s:3:\"css\";s:0:\"\";s:8:\"contexts\";a:0:{}s:13:\"relationships\";a:0:{}s:3:\"did\";s:1:\"1\";}');
/*!40000 ALTER TABLE `page_manager_handlers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `page_manager_pages`
--

DROP TABLE IF EXISTS `page_manager_pages`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `page_manager_pages` (
  `pid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary ID field for the table. Not used for anything except internal lookups.',
  `name` varchar(255) DEFAULT NULL COMMENT 'Unique ID for this subtask. Used to identify it programmatically.',
  `task` varchar(64) DEFAULT 'page' COMMENT 'What type of page this is, so that we can use the same mechanism for creating tighter UIs for targeted pages.',
  `admin_title` varchar(255) DEFAULT NULL COMMENT 'Human readable title for this page subtask.',
  `admin_description` longtext COMMENT 'Administrative description of this item.',
  `path` varchar(255) DEFAULT NULL COMMENT 'The menu path that will invoke this task.',
  `access` longtext NOT NULL COMMENT 'Access configuration for this path.',
  `menu` longtext NOT NULL COMMENT 'Serialized configuration of Drupal menu visibility settings for this item.',
  `arguments` longtext NOT NULL COMMENT 'Configuration of arguments for this menu item.',
  `conf` longtext NOT NULL COMMENT 'Serialized configuration of the page, if needed.',
  PRIMARY KEY (`pid`),
  UNIQUE KEY `name` (`name`),
  KEY `task` (`task`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='Contains page subtasks for implementing pages with...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `page_manager_pages`
--

LOCK TABLES `page_manager_pages` WRITE;
/*!40000 ALTER TABLE `page_manager_pages` DISABLE KEYS */;
INSERT INTO `page_manager_pages` VALUES (1,'front_page','page','Front page','Front page.','front-page','a:0:{}','a:0:{}','a:0:{}','a:1:{s:11:\"admin_paths\";b:0;}');
/*!40000 ALTER TABLE `page_manager_pages` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `page_manager_weights`
--

DROP TABLE IF EXISTS `page_manager_weights`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `page_manager_weights` (
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Unique ID for this task handler. Used to identify it programmatically.',
  `weight` int(11) DEFAULT NULL COMMENT 'The order in which this handler appears. Lower numbers go first.',
  PRIMARY KEY (`name`),
  KEY `weights` (`name`,`weight`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Contains override weights for page_manager handlers that...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `page_manager_weights`
--

LOCK TABLES `page_manager_weights` WRITE;
/*!40000 ALTER TABLE `page_manager_weights` DISABLE KEYS */;
/*!40000 ALTER TABLE `page_manager_weights` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `panels_display`
--

DROP TABLE IF EXISTS `panels_display`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `panels_display` (
  `did` int(11) NOT NULL AUTO_INCREMENT,
  `layout` varchar(255) DEFAULT '',
  `layout_settings` longtext,
  `panel_settings` longtext,
  `cache` text,
  `title` varchar(255) DEFAULT '',
  `hide_title` tinyint(4) DEFAULT '0',
  `title_pane` int(11) DEFAULT '0',
  PRIMARY KEY (`did`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `panels_display`
--

LOCK TABLES `panels_display` WRITE;
/*!40000 ALTER TABLE `panels_display` DISABLE KEYS */;
INSERT INTO `panels_display` VALUES (1,'onecol','a:0:{}','a:1:{s:14:\"style_settings\";a:2:{s:7:\"default\";N;s:6:\"middle\";N;}}','a:0:{}','',1,1);
/*!40000 ALTER TABLE `panels_display` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `panels_layout`
--

DROP TABLE IF EXISTS `panels_layout`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `panels_layout` (
  `lid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'A database primary key to ensure uniqueness.',
  `name` varchar(255) DEFAULT NULL COMMENT 'Unique ID for this content. Used to identify it programmatically.',
  `admin_title` varchar(255) DEFAULT NULL COMMENT 'Administrative title for this layout.',
  `admin_description` longtext COMMENT 'Administrative description for this layout.',
  `category` varchar(255) DEFAULT NULL COMMENT 'Administrative category for this layout.',
  `plugin` varchar(255) DEFAULT NULL COMMENT 'The layout plugin that owns this layout.',
  `settings` longtext COMMENT 'Serialized settings for the actual layout. The contents of this field are up to the plugin that uses it.',
  PRIMARY KEY (`lid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Contains exportable customized layouts for this site.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `panels_layout`
--

LOCK TABLES `panels_layout` WRITE;
/*!40000 ALTER TABLE `panels_layout` DISABLE KEYS */;
/*!40000 ALTER TABLE `panels_layout` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `panels_pane`
--

DROP TABLE IF EXISTS `panels_pane`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `panels_pane` (
  `pid` int(11) NOT NULL AUTO_INCREMENT,
  `did` int(11) NOT NULL DEFAULT '0',
  `panel` varchar(32) DEFAULT '',
  `type` varchar(32) DEFAULT '',
  `subtype` varchar(64) DEFAULT '',
  `shown` tinyint(4) DEFAULT '1',
  `access` longtext,
  `configuration` longtext,
  `cache` longtext,
  `style` longtext,
  `css` longtext,
  `extras` longtext,
  `position` smallint(6) DEFAULT '0',
  `locks` longtext,
  PRIMARY KEY (`pid`),
  KEY `did_idx` (`did`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `panels_pane`
--

LOCK TABLES `panels_pane` WRITE;
/*!40000 ALTER TABLE `panels_pane` DISABLE KEYS */;
INSERT INTO `panels_pane` VALUES (1,1,'middle','block','custom-recent_projects',1,'a:0:{}','a:2:{s:14:\"override_title\";i:0;s:19:\"override_title_text\";s:0:\"\";}','a:0:{}','a:1:{s:8:\"settings\";N;}','a:0:{}','a:0:{}',0,'a:0:{}'),(2,1,'middle','block','block-7',1,'a:0:{}','a:2:{s:14:\"override_title\";i:1;s:19:\"override_title_text\";s:0:\"\";}','a:0:{}','a:1:{s:8:\"settings\";N;}','a:0:{}','a:0:{}',1,'a:0:{}');
/*!40000 ALTER TABLE `panels_pane` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `panels_renderer_pipeline`
--

DROP TABLE IF EXISTS `panels_renderer_pipeline`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `panels_renderer_pipeline` (
  `rpid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'A database primary key to ensure uniqueness.',
  `name` varchar(255) DEFAULT NULL COMMENT 'Unique ID for this content. Used to identify it programmatically.',
  `admin_title` varchar(255) DEFAULT NULL COMMENT 'Administrative title for this pipeline.',
  `admin_description` longtext COMMENT 'Administrative description for this pipeline.',
  `weight` smallint(6) DEFAULT '0',
  `settings` longtext COMMENT 'Serialized settings for the actual pipeline. The contents of this field are up to the plugin that uses it.',
  PRIMARY KEY (`rpid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Contains renderer pipelines for Panels. Each pipeline...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `panels_renderer_pipeline`
--

LOCK TABLES `panels_renderer_pipeline` WRITE;
/*!40000 ALTER TABLE `panels_renderer_pipeline` DISABLE KEYS */;
/*!40000 ALTER TABLE `panels_renderer_pipeline` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `queue`
--

DROP TABLE IF EXISTS `queue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `queue` (
  `item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique item ID.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The queue name.',
  `data` longblob COMMENT 'The arbitrary data for the item.',
  `expire` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the claim lease expires on the item.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp when the item was created.',
  PRIMARY KEY (`item_id`),
  KEY `name_created` (`name`,`created`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=utf8 COMMENT='Stores items in queues.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `queue`
--

LOCK TABLES `queue` WRITE;
/*!40000 ALTER TABLE `queue` DISABLE KEYS */;
/*!40000 ALTER TABLE `queue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rdf_mapping`
--

DROP TABLE IF EXISTS `rdf_mapping`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rdf_mapping` (
  `type` varchar(128) NOT NULL COMMENT 'The name of the entity type a mapping applies to (node, user, comment, etc.).',
  `bundle` varchar(128) NOT NULL COMMENT 'The name of the bundle a mapping applies to.',
  `mapping` longblob COMMENT 'The serialized mapping of the bundle type and fields to RDF terms.',
  PRIMARY KEY (`type`,`bundle`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores custom RDF mappings for user defined content types...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rdf_mapping`
--

LOCK TABLES `rdf_mapping` WRITE;
/*!40000 ALTER TABLE `rdf_mapping` DISABLE KEYS */;
INSERT INTO `rdf_mapping` VALUES ('node','article','a:11:{s:11:\"field_image\";a:2:{s:10:\"predicates\";a:2:{i:0;s:8:\"og:image\";i:1;s:12:\"rdfs:seeAlso\";}s:4:\"type\";s:3:\"rel\";}s:10:\"field_tags\";a:2:{s:10:\"predicates\";a:1:{i:0;s:10:\"dc:subject\";}s:4:\"type\";s:3:\"rel\";}s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Item\";i:1;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}'),('node','blog','a:9:{s:7:\"rdftype\";a:2:{i:0;s:9:\"sioc:Post\";i:1;s:14:\"sioct:BlogPost\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}'),('node','page','a:9:{s:7:\"rdftype\";a:1:{i:0;s:13:\"foaf:Document\";}s:5:\"title\";a:1:{s:10:\"predicates\";a:1:{i:0;s:8:\"dc:title\";}}s:7:\"created\";a:3:{s:10:\"predicates\";a:2:{i:0;s:7:\"dc:date\";i:1;s:10:\"dc:created\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:7:\"changed\";a:3:{s:10:\"predicates\";a:1:{i:0;s:11:\"dc:modified\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}s:4:\"body\";a:1:{s:10:\"predicates\";a:1:{i:0;s:15:\"content:encoded\";}}s:3:\"uid\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:has_creator\";}s:4:\"type\";s:3:\"rel\";}s:4:\"name\";a:1:{s:10:\"predicates\";a:1:{i:0;s:9:\"foaf:name\";}}s:13:\"comment_count\";a:2:{s:10:\"predicates\";a:1:{i:0;s:16:\"sioc:num_replies\";}s:8:\"datatype\";s:11:\"xsd:integer\";}s:13:\"last_activity\";a:3:{s:10:\"predicates\";a:1:{i:0;s:23:\"sioc:last_activity_date\";}s:8:\"datatype\";s:12:\"xsd:dateTime\";s:8:\"callback\";s:12:\"date_iso8601\";}}');
/*!40000 ALTER TABLE `rdf_mapping` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `registry`
--

DROP TABLE IF EXISTS `registry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `registry` (
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the function, class, or interface.',
  `type` varchar(9) NOT NULL DEFAULT '' COMMENT 'Either function or class or interface.',
  `filename` varchar(255) NOT NULL COMMENT 'Name of the file.',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the module the file belongs to.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The order in which this module’s hooks should be invoked relative to other modules. Equal-weighted modules are ordered by name.',
  PRIMARY KEY (`name`,`type`),
  KEY `hook` (`type`,`weight`,`module`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Each record is a function, class, or interface name and...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `registry`
--

LOCK TABLES `registry` WRITE;
/*!40000 ALTER TABLE `registry` DISABLE KEYS */;
INSERT INTO `registry` VALUES ('AccessDeniedTestCase','class','modules/system/system.test','system',0),('AdminMetaTagTestCase','class','modules/system/system.test','system',0),('ArchiverInterface','interface','includes/archiver.inc','',0),('ArchiverTar','class','modules/system/system.archiver.inc','system',0),('ArchiverZip','class','modules/system/system.archiver.inc','system',0),('Archive_Tar','class','modules/system/system.tar.inc','system',0),('BatchMemoryQueue','class','includes/batch.queue.inc','',0),('BatchQueue','class','includes/batch.queue.inc','',0),('BlockAdminThemeTestCase','class','modules/block/block.test','block',0),('BlockCacheTestCase','class','modules/block/block.test','block',0),('BlockHiddenRegionTestCase','class','modules/block/block.test','block',0),('BlockHTMLIdTestCase','class','modules/block/block.test','block',0),('BlockInvalidRegionTestCase','class','modules/block/block.test','block',0),('BlockTemplateSuggestionsUnitTest','class','modules/block/block.test','block',0),('BlockTestCase','class','modules/block/block.test','block',0),('BlogTestCase','class','modules/blog/blog.test','blog',0),('ColorTestCase','class','modules/color/color.test','color',0),('CommentActionsTestCase','class','modules/comment/comment.test','comment',0),('CommentAnonymous','class','modules/comment/comment.test','comment',0),('CommentApprovalTest','class','modules/comment/comment.test','comment',0),('CommentBlockFunctionalTest','class','modules/comment/comment.test','comment',0),('CommentContentRebuild','class','modules/comment/comment.test','comment',0),('CommentController','class','modules/comment/comment.module','comment',0),('CommentFieldsTest','class','modules/comment/comment.test','comment',0),('CommentHelperCase','class','modules/comment/comment.test','comment',0),('CommentInterfaceTest','class','modules/comment/comment.test','comment',0),('CommentNodeAccessTest','class','modules/comment/comment.test','comment',0),('CommentNodeChangesTestCase','class','modules/comment/comment.test','comment',0),('CommentPagerTest','class','modules/comment/comment.test','comment',0),('CommentPreviewTest','class','modules/comment/comment.test','comment',0),('CommentRSSUnitTest','class','modules/comment/comment.test','comment',0),('CommentThreadingTestCase','class','modules/comment/comment.test','comment',0),('CommentTokenReplaceTestCase','class','modules/comment/comment.test','comment',0),('ContactPersonalTestCase','class','modules/contact/contact.test','contact',0),('ContactSitewideTestCase','class','modules/contact/contact.test','contact',0),('ContextualDynamicContextTestCase','class','modules/contextual/contextual.test','contextual',0),('CronRunTestCase','class','modules/system/system.test','system',0),('ctools_context','class','sites/all/modules/ctools/includes/context.inc','ctools',0),('ctools_context_optional','class','sites/all/modules/ctools/includes/context.inc','ctools',0),('ctools_context_required','class','sites/all/modules/ctools/includes/context.inc','ctools',0),('ctools_export_ui','class','sites/all/modules/ctools/plugins/export_ui/ctools_export_ui.class.php','ctools',0),('ctools_math_expr','class','sites/all/modules/ctools/includes/math-expr.inc','ctools',0),('ctools_math_expr_stack','class','sites/all/modules/ctools/includes/math-expr.inc','ctools',0),('ctools_stylizer_image_processor','class','sites/all/modules/ctools/includes/stylizer.inc','ctools',0),('DashboardBlocksTestCase','class','modules/dashboard/dashboard.test','dashboard',0),('Database','class','includes/database/database.inc','',0),('DatabaseCondition','class','includes/database/query.inc','',0),('DatabaseConnection','class','includes/database/database.inc','',0),('DatabaseConnectionNotDefinedException','class','includes/database/database.inc','',0),('DatabaseConnection_mysql','class','includes/database/mysql/database.inc','',0),('DatabaseConnection_pgsql','class','includes/database/pgsql/database.inc','',0),('DatabaseConnection_sqlite','class','includes/database/sqlite/database.inc','',0),('DatabaseDriverNotSpecifiedException','class','includes/database/database.inc','',0),('DatabaseLog','class','includes/database/log.inc','',0),('DatabaseSchema','class','includes/database/schema.inc','',0),('DatabaseSchemaObjectDoesNotExistException','class','includes/database/schema.inc','',0),('DatabaseSchemaObjectExistsException','class','includes/database/schema.inc','',0),('DatabaseSchema_mysql','class','includes/database/mysql/schema.inc','',0),('DatabaseSchema_pgsql','class','includes/database/pgsql/schema.inc','',0),('DatabaseSchema_sqlite','class','includes/database/sqlite/schema.inc','',0),('DatabaseStatementBase','class','includes/database/database.inc','',0),('DatabaseStatementEmpty','class','includes/database/database.inc','',0),('DatabaseStatementInterface','interface','includes/database/database.inc','',0),('DatabaseStatementPrefetch','class','includes/database/prefetch.inc','',0),('DatabaseStatement_sqlite','class','includes/database/sqlite/database.inc','',0),('DatabaseTaskException','class','includes/install.inc','',0),('DatabaseTasks','class','includes/install.inc','',0),('DatabaseTasks_mysql','class','includes/database/mysql/install.inc','',0),('DatabaseTasks_pgsql','class','includes/database/pgsql/install.inc','',0),('DatabaseTasks_sqlite','class','includes/database/sqlite/install.inc','',0),('DatabaseTransaction','class','includes/database/database.inc','',0),('DatabaseTransactionCommitFailedException','class','includes/database/database.inc','',0),('DatabaseTransactionExplicitCommitNotAllowedException','class','includes/database/database.inc','',0),('DatabaseTransactionNameNonUniqueException','class','includes/database/database.inc','',0),('DatabaseTransactionNoActiveException','class','includes/database/database.inc','',0),('DatabaseTransactionOutOfOrderException','class','includes/database/database.inc','',0),('DateTimeFunctionalTest','class','modules/system/system.test','system',0),('DBLogTestCase','class','modules/dblog/dblog.test','dblog',0),('DefaultMailSystem','class','modules/system/system.mail.inc','system',0),('DeleteQuery','class','includes/database/query.inc','',0),('DeleteQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('DrupalCacheArray','class','includes/bootstrap.inc','',0),('DrupalCacheInterface','interface','includes/cache.inc','',0),('DrupalDatabaseCache','class','includes/cache.inc','',0),('DrupalDefaultEntityController','class','includes/entity.inc','',0),('DrupalEntityControllerInterface','interface','includes/entity.inc','',0),('DrupalFakeCache','class','includes/cache-install.inc','',0),('DrupalLocalStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalPrivateStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalPublicStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalQueue','class','modules/system/system.queue.inc','system',0),('DrupalQueueInterface','interface','modules/system/system.queue.inc','system',0),('DrupalReliableQueueInterface','interface','modules/system/system.queue.inc','system',0),('DrupalStreamWrapperInterface','interface','includes/stream_wrappers.inc','',0),('DrupalTemporaryStreamWrapper','class','includes/stream_wrappers.inc','',0),('DrupalUpdateException','class','includes/update.inc','',0),('DrupalUpdaterInterface','interface','includes/updater.inc','',0),('EnableDisableTestCase','class','modules/system/system.test','system',0),('EntityFieldQuery','class','includes/entity.inc','',0),('EntityFieldQueryException','class','includes/entity.inc','',0),('EntityMalformedException','class','includes/entity.inc','',0),('EntityPropertiesTestCase','class','modules/field/tests/field.test','field',0),('FieldAttachOtherTestCase','class','modules/field/tests/field.test','field',0),('FieldAttachStorageTestCase','class','modules/field/tests/field.test','field',0),('FieldAttachTestCase','class','modules/field/tests/field.test','field',0),('FieldBulkDeleteTestCase','class','modules/field/tests/field.test','field',0),('FieldCrudTestCase','class','modules/field/tests/field.test','field',0),('FieldDisplayAPITestCase','class','modules/field/tests/field.test','field',0),('FieldException','class','modules/field/field.module','field',0),('FieldFormTestCase','class','modules/field/tests/field.test','field',0),('FieldInfoTestCase','class','modules/field/tests/field.test','field',0),('FieldInstanceCrudTestCase','class','modules/field/tests/field.test','field',0),('FieldsOverlapException','class','includes/database/database.inc','',0),('FieldSqlStorageTestCase','class','modules/field/modules/field_sql_storage/field_sql_storage.test','field_sql_storage',0),('FieldTestCase','class','modules/field/tests/field.test','field',0),('FieldTranslationsTestCase','class','modules/field/tests/field.test','field',0),('FieldUIAlterTestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUIManageDisplayTestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUIManageFieldsTestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUITestCase','class','modules/field_ui/field_ui.test','field_ui',0),('FieldUpdateForbiddenException','class','modules/field/field.module','field',0),('FieldValidationException','class','modules/field/field.attach.inc','field',0),('FileFieldDisplayTestCase','class','modules/file/tests/file.test','file',0),('FileFieldPathTestCase','class','modules/file/tests/file.test','file',0),('FileFieldRevisionTestCase','class','modules/file/tests/file.test','file',0),('FileFieldTestCase','class','modules/file/tests/file.test','file',0),('FileFieldValidateTestCase','class','modules/file/tests/file.test','file',0),('FileFieldWidgetTestCase','class','modules/file/tests/file.test','file',0),('FileManagedFileElementTestCase','class','modules/file/tests/file.test','file',0),('FilePrivateTestCase','class','modules/file/tests/file.test','file',0),('FileTokenReplaceTestCase','class','modules/file/tests/file.test','file',0),('FileTransfer','class','includes/filetransfer/filetransfer.inc','',0),('FileTransferChmodInterface','interface','includes/filetransfer/filetransfer.inc','',0),('FileTransferException','class','includes/filetransfer/filetransfer.inc','',0),('FileTransferFTP','class','includes/filetransfer/ftp.inc','',0),('FileTransferFTPExtension','class','includes/filetransfer/ftp.inc','',0),('FileTransferLocal','class','includes/filetransfer/local.inc','',0),('FileTransferSSH','class','includes/filetransfer/ssh.inc','',0),('FilterAdminTestCase','class','modules/filter/filter.test','filter',0),('FilterCRUDTestCase','class','modules/filter/filter.test','filter',0),('FilterDefaultFormatTestCase','class','modules/filter/filter.test','filter',0),('FilterFormatAccessTestCase','class','modules/filter/filter.test','filter',0),('FilterHooksTestCase','class','modules/filter/filter.test','filter',0),('FilterNoFormatTestCase','class','modules/filter/filter.test','filter',0),('FilterSecurityTestCase','class','modules/filter/filter.test','filter',0),('FilterSettingsTestCase','class','modules/filter/filter.test','filter',0),('FilterUnitTestCase','class','modules/filter/filter.test','filter',0),('FloodFunctionalTest','class','modules/system/system.test','system',0),('FrontPageTestCase','class','modules/system/system.test','system',0),('HelpTestCase','class','modules/help/help.test','help',0),('HookRequirementsTestCase','class','modules/system/system.test','system',0),('ImageAdminStylesUnitTest','class','modules/image/image.test','image',0),('ImageDimensionsScaleTestCase','class','modules/image/image.test','image',0),('ImageDimensionsTestCase','class','modules/image/image.test','image',0),('ImageEffectsUnitTest','class','modules/image/image.test','image',0),('ImageFieldDefaultImagesTestCase','class','modules/image/image.test','image',0),('ImageFieldDisplayTestCase','class','modules/image/image.test','image',0),('ImageFieldTestCase','class','modules/image/image.test','image',0),('ImageFieldValidateTestCase','class','modules/image/image.test','image',0),('ImageStylesPathAndUrlTestCase','class','modules/image/image.test','image',0),('ImageThemeFunctionWebTestCase','class','modules/image/image.test','image',0),('InfoFileParserTestCase','class','modules/system/system.test','system',0),('InsertQuery','class','includes/database/query.inc','',0),('InsertQuery_mysql','class','includes/database/mysql/query.inc','',0),('InsertQuery_pgsql','class','includes/database/pgsql/query.inc','',0),('InsertQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('InvalidMergeQueryException','class','includes/database/database.inc','',0),('IPAddressBlockingTestCase','class','modules/system/system.test','system',0),('ListDynamicValuesTestCase','class','modules/field/modules/list/tests/list.test','list',0),('ListDynamicValuesValidationTestCase','class','modules/field/modules/list/tests/list.test','list',0),('ListFieldTestCase','class','modules/field/modules/list/tests/list.test','list',0),('ListFieldUITestCase','class','modules/field/modules/list/tests/list.test','list',0),('MailSystemInterface','interface','includes/mail.inc','',0),('MemoryQueue','class','modules/system/system.queue.inc','system',0),('MenuNodeTestCase','class','modules/menu/menu.test','menu',0),('MenuTestCase','class','modules/menu/menu.test','menu',0),('MergeQuery','class','includes/database/query.inc','',0),('ModuleDependencyTestCase','class','modules/system/system.test','system',0),('ModuleRequiredTestCase','class','modules/system/system.test','system',0),('ModuleTestCase','class','modules/system/system.test','system',0),('ModuleUpdater','class','modules/system/system.updater.inc','system',0),('ModuleVersionTestCase','class','modules/system/system.test','system',0),('MultiStepNodeFormBasicOptionsTest','class','modules/node/node.test','node',0),('NewDefaultThemeBlocks','class','modules/block/block.test','block',0),('NodeAccessBaseTableTestCase','class','modules/node/node.test','node',0),('NodeAccessFieldTestCase','class','modules/node/node.test','node',0),('NodeAccessPagerTestCase','class','modules/node/node.test','node',0),('NodeAccessRebuildTestCase','class','modules/node/node.test','node',0),('NodeAccessRecordsTestCase','class','modules/node/node.test','node',0),('NodeAccessTestCase','class','modules/node/node.test','node',0),('NodeAdminTestCase','class','modules/node/node.test','node',0),('NodeBlockFunctionalTest','class','modules/node/node.test','node',0),('NodeBlockTestCase','class','modules/node/node.test','node',0),('NodeBuildContent','class','modules/node/node.test','node',0),('NodeController','class','modules/node/node.module','node',0),('NodeCreationTestCase','class','modules/node/node.test','node',0),('NodeEntityFieldQueryAlter','class','modules/node/node.test','node',0),('NodeEntityViewModeAlterTest','class','modules/node/node.test','node',0),('NodeFeedTestCase','class','modules/node/node.test','node',0),('NodeLoadHooksTestCase','class','modules/node/node.test','node',0),('NodeLoadMultipleTestCase','class','modules/node/node.test','node',0),('NodePostSettingsTestCase','class','modules/node/node.test','node',0),('NodeQueryAlter','class','modules/node/node.test','node',0),('NodeRevisionPermissionsTestCase','class','modules/node/node.test','node',0),('NodeRevisionsTestCase','class','modules/node/node.test','node',0),('NodeRSSContentTestCase','class','modules/node/node.test','node',0),('NodeSaveTestCase','class','modules/node/node.test','node',0),('NodeTitleTestCase','class','modules/node/node.test','node',0),('NodeTitleXSSTestCase','class','modules/node/node.test','node',0),('NodeTokenReplaceTestCase','class','modules/node/node.test','node',0),('NodeTypePersistenceTestCase','class','modules/node/node.test','node',0),('NodeTypeTestCase','class','modules/node/node.test','node',0),('NodeWebTestCase','class','modules/node/node.test','node',0),('NoFieldsException','class','includes/database/database.inc','',0),('NoHelpTestCase','class','modules/help/help.test','help',0),('NonDefaultBlockAdmin','class','modules/block/block.test','block',0),('NumberFieldTestCase','class','modules/field/modules/number/number.test','number',0),('OptionsSelectDynamicValuesTestCase','class','modules/field/modules/options/options.test','options',0),('OptionsWidgetsTestCase','class','modules/field/modules/options/options.test','options',0),('PageEditTestCase','class','modules/node/node.test','node',0),('PageNotFoundTestCase','class','modules/system/system.test','system',0),('PagePreviewTestCase','class','modules/node/node.test','node',0),('PagerDefault','class','includes/pager.inc','',0),('PageTitleFiltering','class','modules/system/system.test','system',0),('PageViewTestCase','class','modules/node/node.test','node',0),('PanelsLegacyState','class','sites/all/modules/panels/includes/legacy.inc','panels',0),('panels_allowed_layouts','class','sites/all/modules/panels/includes/common.inc','panels',0),('panels_cache_object','class','sites/all/modules/panels/includes/plugins.inc','panels',0),('panels_display','class','sites/all/modules/panels/panels.module','panels',0),('panels_layouts_ui','class','sites/all/modules/panels/plugins/export_ui/panels_layouts_ui.class.php','panels',0),('panels_renderer_editor','class','sites/all/modules/panels/plugins/display_renderers/panels_renderer_editor.class.php','panels',0),('panels_renderer_simple','class','sites/all/modules/panels/plugins/display_renderers/panels_renderer_simple.class.php','panels',0),('panels_renderer_standard','class','sites/all/modules/panels/plugins/display_renderers/panels_renderer_standard.class.php','panels',0),('panels_views_plugin_row_fields','class','sites/all/modules/panels/plugins/views/panels_views_plugin_row_fields.inc','panels',0),('PathautoBulkUpdateTestCase','class','sites/all/modules/pathauto/pathauto.test','pathauto',0),('PathautoFunctionalTestCase','class','sites/all/modules/pathauto/pathauto.test','pathauto',0),('PathautoFunctionalTestHelper','class','sites/all/modules/pathauto/pathauto.test','pathauto',0),('PathautoLocaleTestCase','class','sites/all/modules/pathauto/pathauto.test','pathauto',0),('PathautoTestHelper','class','sites/all/modules/pathauto/pathauto.test','pathauto',0),('PathautoTokenTestCase','class','sites/all/modules/pathauto/pathauto.test','pathauto',0),('PathautoUnitTestCase','class','sites/all/modules/pathauto/pathauto.test','pathauto',0),('PathLanguageTestCase','class','modules/path/path.test','path',0),('PathLanguageUITestCase','class','modules/path/path.test','path',0),('PathMonolingualTestCase','class','modules/path/path.test','path',0),('PathTaxonomyTermTestCase','class','modules/path/path.test','path',0),('PathTestCase','class','modules/path/path.test','path',0),('Query','class','includes/database/query.inc','',0),('QueryAlterableInterface','interface','includes/database/query.inc','',0),('QueryConditionInterface','interface','includes/database/query.inc','',0),('QueryExtendableInterface','interface','includes/database/select.inc','',0),('QueryPlaceholderInterface','interface','includes/database/query.inc','',0),('QueueTestCase','class','modules/system/system.test','system',0),('RdfCommentAttributesTestCase','class','modules/rdf/rdf.test','rdf',0),('RdfCrudTestCase','class','modules/rdf/rdf.test','rdf',0),('RdfGetRdfNamespacesTestCase','class','modules/rdf/rdf.test','rdf',0),('RdfMappingDefinitionTestCase','class','modules/rdf/rdf.test','rdf',0),('RdfMappingHookTestCase','class','modules/rdf/rdf.test','rdf',0),('RdfRdfaMarkupTestCase','class','modules/rdf/rdf.test','rdf',0),('RdfTrackerAttributesTestCase','class','modules/rdf/rdf.test','rdf',0),('RetrieveFileTestCase','class','modules/system/system.test','system',0),('SchemaCache','class','includes/bootstrap.inc','',0),('SearchAdvancedSearchForm','class','modules/search/search.test','search',0),('SearchBlockTestCase','class','modules/search/search.test','search',0),('SearchCommentCountToggleTestCase','class','modules/search/search.test','search',0),('SearchCommentTestCase','class','modules/search/search.test','search',0),('SearchConfigSettingsForm','class','modules/search/search.test','search',0),('SearchEmbedForm','class','modules/search/search.test','search',0),('SearchExactTestCase','class','modules/search/search.test','search',0),('SearchExcerptTestCase','class','modules/search/search.test','search',0),('SearchExpressionInsertExtractTestCase','class','modules/search/search.test','search',0),('SearchKeywordsConditions','class','modules/search/search.test','search',0),('SearchLanguageTestCase','class','modules/search/search.test','search',0),('SearchMatchTestCase','class','modules/search/search.test','search',0),('SearchNodeAccessTest','class','modules/search/search.test','search',0),('SearchNumberMatchingTestCase','class','modules/search/search.test','search',0),('SearchNumbersTestCase','class','modules/search/search.test','search',0),('SearchPageOverride','class','modules/search/search.test','search',0),('SearchPageText','class','modules/search/search.test','search',0),('SearchQuery','class','modules/search/search.extender.inc','search',0),('SearchRankingTestCase','class','modules/search/search.test','search',0),('SearchSimplifyTestCase','class','modules/search/search.test','search',0),('SearchTokenizerTestCase','class','modules/search/search.test','search',0),('SelectQuery','class','includes/database/select.inc','',0),('SelectQueryExtender','class','includes/database/select.inc','',0),('SelectQueryInterface','interface','includes/database/select.inc','',0),('SelectQuery_pgsql','class','includes/database/pgsql/select.inc','',0),('SelectQuery_sqlite','class','includes/database/sqlite/select.inc','',0),('ShortcutLinksTestCase','class','modules/shortcut/shortcut.test','shortcut',0),('ShortcutSetsTestCase','class','modules/shortcut/shortcut.test','shortcut',0),('ShortcutTestCase','class','modules/shortcut/shortcut.test','shortcut',0),('ShutdownFunctionsTest','class','modules/system/system.test','system',0),('SiteMaintenanceTestCase','class','modules/system/system.test','system',0),('SkipDotsRecursiveDirectoryIterator','class','includes/filetransfer/filetransfer.inc','',0),('StreamWrapperInterface','interface','includes/stream_wrappers.inc','',0),('SummaryLengthTestCase','class','modules/node/node.test','node',0),('SystemAdminTestCase','class','modules/system/system.test','system',0),('SystemAuthorizeCase','class','modules/system/system.test','system',0),('SystemBlockTestCase','class','modules/system/system.test','system',0),('SystemIndexPhpTest','class','modules/system/system.test','system',0),('SystemInfoAlterTestCase','class','modules/system/system.test','system',0),('SystemMainContentFallback','class','modules/system/system.test','system',0),('SystemQueue','class','modules/system/system.queue.inc','system',0),('SystemThemeFunctionalTest','class','modules/system/system.test','system',0),('TableSort','class','includes/tablesort.inc','',0),('TaxonomyEFQTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyHooksTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyLegacyTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyLoadMultipleTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyRSSTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermController','class','modules/taxonomy/taxonomy.module','taxonomy',0),('TaxonomyTermFieldMultipleVocabularyTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermFieldTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermFunctionTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermIndexTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTermTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyThemeTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyTokenReplaceTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyVocabularyController','class','modules/taxonomy/taxonomy.module','taxonomy',0),('TaxonomyVocabularyFunctionalTest','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyVocabularyTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TaxonomyWebTestCase','class','modules/taxonomy/taxonomy.test','taxonomy',0),('TestingMailSystem','class','modules/system/system.mail.inc','system',0),('TextFieldTestCase','class','modules/field/modules/text/text.test','text',0),('TextSummaryTestCase','class','modules/field/modules/text/text.test','text',0),('TextTranslationTestCase','class','modules/field/modules/text/text.test','text',0),('ThemeRegistry','class','includes/theme.inc','',0),('ThemeUpdater','class','modules/system/system.updater.inc','system',0),('TokenArrayTestCase','class','sites/all/modules/token/token.test','token',0),('TokenBlockTestCase','class','sites/all/modules/token/token.test','token',0),('TokenCommentTestCase','class','sites/all/modules/token/token.test','token',0),('TokenCurrentPageTestCase','class','sites/all/modules/token/token.test','token',0),('TokenDateTestCase','class','sites/all/modules/token/token.test','token',0),('TokenEntityTestCase','class','sites/all/modules/token/token.test','token',0),('TokenFileTestCase','class','sites/all/modules/token/token.test','token',0),('TokenMenuTestCase','class','sites/all/modules/token/token.test','token',0),('TokenNodeTestCase','class','sites/all/modules/token/token.test','token',0),('TokenProfileTestCase','class','sites/all/modules/token/token.test','token',0),('TokenRandomTestCase','class','sites/all/modules/token/token.test','token',0),('TokenReplaceTestCase','class','modules/system/system.test','system',0),('TokenTaxonomyTestCase','class','sites/all/modules/token/token.test','token',0),('TokenTestHelper','class','sites/all/modules/token/token.test','token',0),('TokenUnitTestCase','class','sites/all/modules/token/token.test','token',0),('TokenURLTestCase','class','sites/all/modules/token/token.test','token',0),('TokenUserTestCase','class','sites/all/modules/token/token.test','token',0),('TruncateQuery','class','includes/database/query.inc','',0),('TruncateQuery_mysql','class','includes/database/mysql/query.inc','',0),('TruncateQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('UpdateCoreTestCase','class','modules/update/update.test','update',0),('UpdateCoreUnitTestCase','class','modules/update/update.test','update',0),('UpdateQuery','class','includes/database/query.inc','',0),('UpdateQuery_pgsql','class','includes/database/pgsql/query.inc','',0),('UpdateQuery_sqlite','class','includes/database/sqlite/query.inc','',0),('Updater','class','includes/updater.inc','',0),('UpdaterException','class','includes/updater.inc','',0),('UpdaterFileTransferException','class','includes/updater.inc','',0),('UpdateScriptFunctionalTest','class','modules/system/system.test','system',0),('UpdateTestContribCase','class','modules/update/update.test','update',0),('UpdateTestHelper','class','modules/update/update.test','update',0),('UpdateTestUploadCase','class','modules/update/update.test','update',0),('UserAccountLinksUnitTests','class','modules/user/user.test','user',0),('UserAdminTestCase','class','modules/user/user.test','user',0),('UserAuthmapAssignmentTestCase','class','modules/user/user.test','user',0),('UserAutocompleteTestCase','class','modules/user/user.test','user',0),('UserBlocksUnitTests','class','modules/user/user.test','user',0),('UserCancelTestCase','class','modules/user/user.test','user',0),('UserController','class','modules/user/user.module','user',0),('UserCreateTestCase','class','modules/user/user.test','user',0),('UserEditedOwnAccountTestCase','class','modules/user/user.test','user',0),('UserEditTestCase','class','modules/user/user.test','user',0),('UserLoginTestCase','class','modules/user/user.test','user',0),('UserPasswordResetTestCase','class','modules/user/user.test','user',0),('UserPermissionsTestCase','class','modules/user/user.test','user',0),('UserPictureTestCase','class','modules/user/user.test','user',0),('UserRegistrationTestCase','class','modules/user/user.test','user',0),('UserRoleAdminTestCase','class','modules/user/user.test','user',0),('UserRolesAssignmentTestCase','class','modules/user/user.test','user',0),('UserSaveTestCase','class','modules/user/user.test','user',0),('UserSignatureTestCase','class','modules/user/user.test','user',0),('UserTimeZoneFunctionalTest','class','modules/user/user.test','user',0),('UserTokenReplaceTestCase','class','modules/user/user.test','user',0),('UserUserSearchTestCase','class','modules/user/user.test','user',0),('UserValidateCurrentPassCustomForm','class','modules/user/user.test','user',0),('UserValidationTestCase','class','modules/user/user.test','user',0),('WysiwygProfileController','class','sites/all/modules/wysiwyg/wysiwyg.module','wysiwyg',0);
/*!40000 ALTER TABLE `registry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `registry_file`
--

DROP TABLE IF EXISTS `registry_file`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `registry_file` (
  `filename` varchar(255) NOT NULL COMMENT 'Path to the file.',
  `hash` varchar(64) NOT NULL COMMENT 'sha-256 hash of the file’s contents when last parsed.',
  PRIMARY KEY (`filename`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Files parsed to build the registry.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `registry_file`
--

LOCK TABLES `registry_file` WRITE;
/*!40000 ALTER TABLE `registry_file` DISABLE KEYS */;
INSERT INTO `registry_file` VALUES ('includes/actions.inc','f36b066681463c7dfe189e0430cb1a89bf66f7e228cbb53cdfcd93987193f759'),('includes/ajax.inc','03eadc82eeac4fb6c5a417d0092a99f4c6604ab0495f40c0282e9a68bc50431a'),('includes/archiver.inc','bdbb21b712a62f6b913590b609fd17cd9f3c3b77c0d21f68e71a78427ed2e3e9'),('includes/authorize.inc','6d64d8c21aa01eb12fc29918732e4df6b871ed06e5d41373cb95c197ed661d13'),('includes/batch.inc','059da9e36e1f3717f27840aae73f10dea7d6c8daf16f6520401cc1ca3b4c0388'),('includes/batch.queue.inc','554b2e92e1dad0f7fd5a19cb8dff7e109f10fbe2441a5692d076338ec908de0f'),('includes/bootstrap.inc','a33a9e85ccfaf70bcedeab22872ea1ab8ac9f04ade2b1012e61129c846d1f45f'),('includes/cache-install.inc','e7ed123c5805703c84ad2cce9c1ca46b3ce8caeeea0d8ef39a3024a4ab95fa0e'),('includes/cache.inc','0a70a291f7ce423d1aab4816ef06a6eaf58b454a03a1f419ff309c1147c4765b'),('includes/common.inc','bc10087927d1e9b41d102a90dd9afd21aaa60762396abf12132c38e06f5885d8'),('includes/database/database.inc','8caecb405825809b7861df05dcb194046b6a55677f8f334dc66544452d36270b'),('includes/database/log.inc','9feb5a17ae2fabcf26a96d2a634ba73da501f7bcfc3599a693d916a6971d00d1'),('includes/database/mysql/database.inc','d4648a3212519b038654457b83466aabc1b928affdd56076c655ba3d8b79a54b'),('includes/database/mysql/install.inc','6ae316941f771732fbbabed7e1d6b4cbb41b1f429dd097d04b3345aa15e461a0'),('includes/database/mysql/query.inc','7d9ea18a7ff04b7aab6210abbd0313cb53325c19a47ff8ed6c0e591c6e7149c2'),('includes/database/mysql/schema.inc','d8d3904ea9c23a526c2f2a7acc8ba870b31c378aac2eb53e2e41a73c6209c5bd'),('includes/database/pgsql/database.inc','56726100fd44f461a04886c590c9c472cc2b2a1b92eb26c7674bf3821a76bb64'),('includes/database/pgsql/install.inc','585b80c5bbd6f134bff60d06397f15154657a577d4da8d1b181858905f09dea5'),('includes/database/pgsql/query.inc','cb4c84f8f1ffc73098ed71137248dcd078a505a7530e60d979d74b3a3cdaa658'),('includes/database/pgsql/schema.inc','8fd647e4557522283caef63e528c6e403fc0751a46e94aac867a281af85eac27'),('includes/database/pgsql/select.inc','fd4bba7887c1dc6abc8f080fc3a76c01d92ea085434e355dc1ecb50d8743c22d'),('includes/database/prefetch.inc','b5b207a66a69ecb52ee4f4459af16a7b5eabedc87254245f37cc33bebb61c0fb'),('includes/database/query.inc','128b5fdb90562d7f7a9e2662ff6f35251b1370ac215298e2c3297c87ebafd961'),('includes/database/schema.inc','7eb7251f331109757173353263d1031493c1198ae17a165a6f5a03d3f14f93e7'),('includes/database/select.inc','1c74fa55c7721a704f5ef3389032604bf7a60fced15c40d844aee3e1cead7dc6'),('includes/database/sqlite/database.inc','ed2b9981794239cdad2cd04cf4bcdc896ad4d6b66179a4fa487b0d1ec2150a10'),('includes/database/sqlite/install.inc','381f3db8c59837d961978ba3097bb6443534ed1659fd713aa563963fa0c42cc5'),('includes/database/sqlite/query.inc','523ff7c05aa2b2aca08cad3743b321868ec772856f2b1c7af908bb236c6919ad'),('includes/database/sqlite/schema.inc','238414785aa96dd27f10f48c961783f4d1091392beee8d0e7ca8ae774e917da2'),('includes/database/sqlite/select.inc','8d1c426dbd337733c206cce9f59a172546c6ed856d8ef3f1c7bef05a16f7bf68'),('includes/date.inc','18c047be64f201e16d189f1cc47ed9dcf0a145151b1ee187e90511b24e5d2b36'),('includes/entity.inc','93ed9b3f29fb2a75852af3b4cf03ce0edf3e9eddf19e4b82eeba8659d3d5bc78'),('includes/errors.inc','0923cf3303e0e976756d159c80c86bbe039109bd90a35a9aca18027c68abd0aa'),('includes/file.inc','e255d823e2652df64896af1f074beb0903bd63c30fa008089355692e1014c7fd'),('includes/file.mimetypes.inc','f88c967550576694b7a1ce2afd0f2f1bbc1a91d21cc2c20f86c44d39ff353867'),('includes/filetransfer/filetransfer.inc','ad42c3696d317f5ebb100c6aca003b8b52b80148ac9553361eab0731d1169592'),('includes/filetransfer/ftp.inc','589ebf4b8bd4a2973aa56a156ac1fa83b6c73e703391361fb573167670e0d832'),('includes/filetransfer/local.inc','7cbfdb46abbdf539640db27e66fb30e5265128f31002bd0dfc3af16ae01a9492'),('includes/filetransfer/ssh.inc','002e24a24cac133d12728bd3843868ce378681237d7fad420761af84e6efe5ad'),('includes/form.inc','ccec80695ca7e2189783bd56863ee69a46e48f786787febbf2ebd15cf9f3deba'),('includes/graph.inc','8e0e313a8bb33488f371df11fc1b58d7cf80099b886cd1003871e2c896d1b536'),('includes/image.inc','ea529f15dc0ac27dbd466ee8a38a9e3eb254c9388dc5a3df5d2033aa9f122e06'),('includes/install.core.inc','279ac33cbeba9b5e1e8b0999fc6cd37e10f559bcb9ad8c135aef09a1b2837b64'),('includes/install.inc','b58dc8ba85d84b39196c1c20b57b45ec88ca62040595a34ccd1e72862a3a6363'),('includes/iso.inc','27730e6175b79c3b5d494582a124f6210289faa03bef099e16347bb914464c66'),('includes/json-encode.inc','02a822a652d00151f79db9aa9e171c310b69b93a12f549bc2ce00533a8efa14e'),('includes/language.inc','bbb04c7f467d9419ed288fee8a2d092a507c553ee9824740091ca041c8159772'),('includes/locale.inc','8cc571c114587f2b30e4e24db17e97e51e81f9cc395fa01f348aba12cee8523e'),('includes/lock.inc','daa62e95528f6b986b85680b600a896452bf2ce6f38921242857dcc5a3460a1b'),('includes/mail.inc','1c2f3e2cd0272751d1628b1e998472296164138b6ba054bb02103c416b96d4e9'),('includes/menu.inc','e7d91cd217fce42d7fde220174b212e73acb2b1f4941255d007687a1adfc281b'),('includes/module.inc','17e8e3664d69ac4951908144ab119e772d0c67658de51db33a4fc4c6210f056f'),('includes/pager.inc','6f9494b85c07a2cc3be4e54aff2d2757485238c476a7da084d25bde1d88be6d8'),('includes/password.inc','aba5df25a237c14cc69335c4cf72d57da130144410ab04d10917d9da21cd606c'),('includes/path.inc','1d939d6b59b07ef41e71c9d616c2e9a34712dd81f6110e1a1f280613b3228738'),('includes/registry.inc','4ffb8c9c8c179c1417ff01790f339edf50b5f7cc0c8bb976eef6858cc71e9bc8'),('includes/session.inc','7e309e8fb83649bcd838490f50dee04d8440f8771601558095a976f29efb0c30'),('includes/stream_wrappers.inc','b04e31585a9a397b0edf7b3586050cbd4b1f631e283296e1c93f4356662faeb9'),('includes/tablesort.inc','3f3cb2820920f7edc0c3d046ffba4fc4e3b73a699a2492780371141cf501aa50'),('includes/theme.inc','afc1cc778c7b82fd2a842397094467625559a671d06754993a23eef10216896b'),('includes/theme.maintenance.inc','d110314b4d943c3e965fcefe452f6873b53cd6a8844154467dfcbb2b6142dc82'),('includes/token.inc','a975300558711bb49406a5c7f78294648baa2e5c912cb66f0c78bb2991c0f3c3'),('includes/unicode.entities.inc','2b858138596d961fbaa4c6e3986e409921df7f76b6ee1b109c4af5970f1e0f54'),('includes/unicode.inc','465d9c1e8e57a525c304cb0c62dac8bb20c2caf011d2e93bcff607b10d4280a9'),('includes/update.inc','fceffc2a28bdf089ef2374e562d52cddfb1cf2eea6ba9d692f78fb65ebed4bc1'),('includes/updater.inc','d2da0e74ed86e93c209f16069f3d32e1a134ceb6c06a0044f78e841a1b54e380'),('includes/utility.inc','9b834814fd3f5ef10ce1946be30ef1ddf3f283c749f1ef1a4ebf845ecd524d59'),('includes/xmlrpc.inc','c5b6ea78adeb135373d11aeaaea057d9fa8995faa4e8c0fec9b7c647f15cc4e0'),('includes/xmlrpcs.inc','79dc6e9882f4c506123d7dd8e228a61e22c46979c3aab21a5b1afa315ef6639c'),('modules/block/block.test','7aefd627d62b44f9c1e9ee3aa9da6c6e2a7cfce01c6613e8bd24c0b9c464dd73'),('modules/blog/blog.test','12dc3105782db5fb0df00ff4872561dd049f242eeeb65c979cf349aa75aa1a51'),('modules/color/color.test','013806279bd47ceb2f82ca854b57f880ba21058f7a2592c422afae881a7f5d15'),('modules/comment/comment.module','594bab37ef1f4d0b0f9a54c7a0f620698fa595bc6b61c8e62635f6dda70fe672'),('modules/comment/comment.test','5404277c15b1306a1ad5eca6703f7d2003567fea6085ffd2b1c3d65896acdf21'),('modules/contact/contact.test','6ad6e1585fef729036e64b58db83be22d09e2df41117036f3969e698533a4a7e'),('modules/contextual/contextual.test','023dafa199bd325ecc55a17b2a3db46ac0a31e23059f701f789f3bc42427ba0b'),('modules/dashboard/dashboard.test','270378b5c8ed0e7d0e00fbc62e617813c6dec1d79396229786942bf9fb738e16'),('modules/dblog/dblog.test','74b2ec1fd67c39edcc30d2460d9c9752311a1fc44c82836a22abff97a704604b'),('modules/field/field.attach.inc','d1d0d7e63ccbe1e184bd137adfd0b17434f7a85ff97c579155bb88130fc1f3c5'),('modules/field/field.module','8cdfc5afe890564d7fc9f0cf3ae9a24f13396ae9f42da96b06a2c85290946bbd'),('modules/field/modules/field_sql_storage/field_sql_storage.test','8ede9843d771e307dfd3d7e7562976b07e0e0a9310a5cf409413581f199c897f'),('modules/field/modules/list/tests/list.test','9f366469763beb3fe0571d66318bac6df293fd15f4eb5cfe4850b9fb9a509f38'),('modules/field/modules/number/number.test','cb55fbc3a1ceed154af673af727b4c5ee6ac2e7dc9d4e1cbc33f3f8e2269146c'),('modules/field/modules/options/options.test','8c6dd464fdb5cca90b0260bcfa5f56941b4b28edd879b23a795f0442f5368d4c'),('modules/field/modules/text/text.test','9d74c6d039f55dd7d6447a59186da8d48bf20617bfe58424612798f649797586'),('modules/field/tests/field.test','83b24244179ffb630f792bbc687907cba6ca480de731520cae8675c6cf1067fc'),('modules/field_ui/field_ui.test','ca549daa46206221863098c6ee5da53a4c647a3016ee5903687804224a44dc9d'),('modules/file/tests/file.test','802532f0032f1740592379d7bd9c93f8c453f68b93f11bf0143bd5de648659c8'),('modules/filter/filter.test','f439e0d529cae5089990c7f0c5059ece953ae14c56e8a753d6375acf0f873560'),('modules/help/help.test','c6f03ece30548a6a345afcfac920d85afc418596a19dc4cf43f994391c5050d9'),('modules/image/image.test','c3be392031e405420d9dc7588b5a8a9788112ee123368bc4752edefe3c4d557a'),('modules/menu/menu.test','b8ee602184584fab464900a946090dc1f3d81c15b8176004ee62022814632430'),('modules/node/node.module','879ce1cc1800b36f0127b283ea4c2366c31f3954a8b24eb89451dccc16ba0ebd'),('modules/node/node.test','993e86ff2fc8dec1e2fae7b3b66cb9c220f130f2d3cf4f9c24c9fe3ba28379ae'),('modules/path/path.test','c05b26db575e93a73f2e4c8eaa6091b4fe8fc805f59620c2f7e1276cc206ba9d'),('modules/rdf/rdf.test','de1fae2117cc338b25d3405412f93b056c7ab62af06af250742a69feb9bd74b8'),('modules/search/search.extender.inc','fea036745113dca3fea52ba956af605c4789f4acfa2ab1650a5843c6e173d7fe'),('modules/search/search.test','1fe9dfc982953f42f67d7eee9a855e7248373067ba55cfff001d8a750b83e695'),('modules/shortcut/shortcut.test','9d0f81602c9a58b60ad3ae4b996e5a431016014151540769e9594711232575e4'),('modules/system/system.archiver.inc','faa849f3e646a910ab82fd6c8bbf0a4e6b8c60725d7ba81ec0556bd716616cd1'),('modules/system/system.mail.inc','3c2c06b55bded609e72add89db41af3bb405d42b9553793acba5fe51be8861d8'),('modules/system/system.queue.inc','caf4feda51bdf7ad62cf782bc23274d367154e51897f2732f07bd06982d85ab1'),('modules/system/system.tar.inc','8a31d91f7b3cd7eac25b3fa46e1ed9a8527c39718ba76c3f8c0bbbeaa3aa4086'),('modules/system/system.test','ca539539bea3d2c070552f79dbae279e2872ba9d48af386c89ab6c1fc95488da'),('modules/system/system.updater.inc','e2eeed65b833a6215f807b113f6fb4cc3cc487e93efcb1402ed87c536d2c9ea6'),('modules/taxonomy/taxonomy.module','389f4e8e040e99c02b4795983e7b44ffb00e766d2a4b3fa06aca98621073f6b2'),('modules/taxonomy/taxonomy.test','c986487a1ffb9cd75b4ce607494055ddf5a9a82b40f7d7a98175c145a7a17a8c'),('modules/update/update.test','f0c11dfc51716e9dd5980428a416cdead4246435e1dceaff75ce52c5f381d617'),('modules/user/user.module','e3b673f877ae8fe6b741e29eb3a8c094135efaf8155629a48bdfb1cceb6e8aa1'),('modules/user/user.test','0cdf12305cce4a65da5be1155925ba2a83b6f5363d6c192f0cfec2985e835e20'),('sites/all/modules/ctools/includes/context.inc','9564cbebde8daa634b4c074c7fe197613d8c23caf60ad7a31e2c3a73c441204f'),('sites/all/modules/ctools/includes/math-expr.inc','3386323b01da62e02c9f3607cd7f0a0d46f1af90a107a07aed726b1fa8c28235'),('sites/all/modules/ctools/includes/stylizer.inc','e18f5a1b8af526751d7175354162c06c2013c96f62d9baa399564d8c45a1c90e'),('sites/all/modules/ctools/plugins/export_ui/ctools_export_ui.class.php','3d6d5df2fd5657b59023c8cb7f2d8f96a3f282f28307e5803cc9159297d6a2ab'),('sites/all/modules/jquery_update/jquery_update.install','17d0b3e4e05f9dc32bf6227459e7303068b92b000e20352b5af2c3d2f67f7183'),('sites/all/modules/jquery_update/jquery_update.module','28cbb57d05bd00f4042c04b477c8d309968b991aa077fdf08f092fcf82ae60e2'),('sites/all/modules/panels/includes/common.inc','fcc6c2923d7f567514109f1a333f518c9044df463d7bfef7b7d2f3f1515060c8'),('sites/all/modules/panels/includes/legacy.inc','dc65c1a82f4a063f9cbebbd8a0ceb512a3b41a1ee2603ec8045034412a791aab'),('sites/all/modules/panels/includes/plugins.inc','d08bc486c44016463a4af61c5c399e7f7b52a04a65a17a5e8e810e1a3c2d1158'),('sites/all/modules/panels/panels.module','0312b8d317e75f19196d8d8aaba3e9f895ca59c1da79f391d7181d1d5ef5ea34'),('sites/all/modules/panels/plugins/display_renderers/panels_renderer_editor.class.php','962f6a761b008182f18cf90063e2b9eb289a9e9a7de69591a75735ccc449a64a'),('sites/all/modules/panels/plugins/display_renderers/panels_renderer_simple.class.php','420aeca22872635ebd5ab3ce719dd8e1d7fef339271db5f20a0834b812084a6e'),('sites/all/modules/panels/plugins/display_renderers/panels_renderer_standard.class.php','7497764e0b1afa55cab7126035b5957869550ab747db48299a9a336e97b48770'),('sites/all/modules/panels/plugins/export_ui/panels_layouts_ui.class.php','c68da9f716ede2dab44e9b3d410374ab82d50f52657f6f363f1df6cb21c6fa9f'),('sites/all/modules/panels/plugins/views/panels_views_plugin_row_fields.inc','a30d798fcbc5e0d44894166e31bc2ab9f9c12b1b34629bf5a7b745374e85408b'),('sites/all/modules/pathauto/pathauto.test','9204240a755119e02eae68c77e7b9ab816747423ccaaf51742231fbaef1f604f'),('sites/all/modules/tagadelic/tagadelic.install','9dd370f854c45d5eaf6aa26d9cf9792df455c84bbf5a8e241e4386493832a117'),('sites/all/modules/tagadelic/tagadelic.module','113c4916bc743ada246da6736fe55e3ed8bb72597ae7ce4cedc29cf2059e28d3'),('sites/all/modules/token/token.test','703ea26074b80cc85e5d9e5bcedf5e745dddda0917bf2db678bbfa2e58e0609c'),('sites/all/modules/wysiwyg/tests/wysiwyg.test','351bd7ed3eb279052b92cd900ceaedb3baa97ab502eed61a390efed83d8cefd8'),('sites/all/modules/wysiwyg/wysiwyg.module','23bbe445f32ba4e8d58c555b11e3275bf954380fea6c4e2a02bbc46fcc41daf8');
/*!40000 ALTER TABLE `registry_file` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role`
--

DROP TABLE IF EXISTS `role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role` (
  `rid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique role ID.',
  `name` varchar(64) NOT NULL DEFAULT '' COMMENT 'Unique role name.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of this role in listings and the user interface.',
  PRIMARY KEY (`rid`),
  UNIQUE KEY `name` (`name`),
  KEY `name_weight` (`name`,`weight`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='Stores user roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role`
--

LOCK TABLES `role` WRITE;
/*!40000 ALTER TABLE `role` DISABLE KEYS */;
INSERT INTO `role` VALUES (3,'administrator',2),(1,'anonymous user',0),(2,'authenticated user',1);
/*!40000 ALTER TABLE `role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role_permission`
--

DROP TABLE IF EXISTS `role_permission`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role_permission` (
  `rid` int(10) unsigned NOT NULL COMMENT 'Foreign Key: role.rid.',
  `permission` varchar(128) NOT NULL DEFAULT '' COMMENT 'A single permission granted to the role identified by rid.',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The module declaring the permission.',
  PRIMARY KEY (`rid`,`permission`),
  KEY `permission` (`permission`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the permissions assigned to user roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role_permission`
--

LOCK TABLES `role_permission` WRITE;
/*!40000 ALTER TABLE `role_permission` DISABLE KEYS */;
INSERT INTO `role_permission` VALUES (1,'access comments','comment'),(1,'access content','node'),(1,'access site-wide contact form','contact'),(1,'search content','search'),(1,'use text format filtered_html','filter'),(2,'access comments','comment'),(2,'access content','node'),(2,'access site-wide contact form','contact'),(2,'post comments','comment'),(2,'search content','search'),(2,'skip comment approval','comment'),(2,'use text format filtered_html','filter'),(3,'access administration menu','admin_menu'),(3,'access administration pages','system'),(3,'access comments','comment'),(3,'access content','node'),(3,'access content overview','node'),(3,'access contextual links','contextual'),(3,'access dashboard','dashboard'),(3,'access devel information','devel'),(3,'access overlay','overlay'),(3,'access site in maintenance mode','system'),(3,'access site reports','system'),(3,'access site-wide contact form','contact'),(3,'access toolbar','toolbar'),(3,'access user contact forms','contact'),(3,'access user profiles','user'),(3,'administer actions','system'),(3,'administer advanced pane settings','panels'),(3,'administer blocks','block'),(3,'administer comments','comment'),(3,'administer contact forms','contact'),(3,'administer content types','node'),(3,'administer filters','filter'),(3,'administer image styles','image'),(3,'administer imce','imce'),(3,'administer menu','menu'),(3,'administer modules','system'),(3,'administer nodes','node'),(3,'administer page manager','page_manager'),(3,'administer pane access','panels'),(3,'administer panels layouts','panels'),(3,'administer panels styles','panels'),(3,'administer pathauto','pathauto'),(3,'administer permissions','user'),(3,'administer search','search'),(3,'administer shortcuts','shortcut'),(3,'administer site configuration','system'),(3,'administer software updates','system'),(3,'administer taxonomy','taxonomy'),(3,'administer themes','system'),(3,'administer url aliases','path'),(3,'administer users','user'),(3,'block IP addresses','system'),(3,'bypass node access','node'),(3,'cancel account','user'),(3,'change layouts in place editing','panels'),(3,'change own username','user'),(3,'create article content','node'),(3,'create page content','node'),(3,'create url aliases','path'),(3,'customize shortcut links','shortcut'),(3,'delete any article content','node'),(3,'delete any page content','node'),(3,'delete own article content','node'),(3,'delete own page content','node'),(3,'delete revisions','node'),(3,'delete terms in 1','taxonomy'),(3,'display drupal links','admin_menu'),(3,'edit any article content','node'),(3,'edit any page content','node'),(3,'edit own article content','node'),(3,'edit own comments','comment'),(3,'edit own page content','node'),(3,'edit terms in 1','taxonomy'),(3,'execute php code','devel'),(3,'flush caches','admin_menu'),(3,'notify of path changes','pathauto'),(3,'post comments','comment'),(3,'revert revisions','node'),(3,'search content','search'),(3,'select account cancellation method','user'),(3,'skip comment approval','comment'),(3,'switch shortcut sets','shortcut'),(3,'switch users','devel'),(3,'use advanced search','search'),(3,'use page manager','page_manager'),(3,'use panels caching features','panels'),(3,'use panels dashboard','panels'),(3,'use panels in place editing','panels'),(3,'use panels locks','panels'),(3,'use text format filtered_html','filter'),(3,'use text format full_html','filter'),(3,'use text format wysiwyg','filter'),(3,'view own unpublished content','node'),(3,'view pane admin links','panels'),(3,'view revisions','node'),(3,'view the administration theme','system');
/*!40000 ALTER TABLE `role_permission` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_dataset`
--

DROP TABLE IF EXISTS `search_dataset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_dataset` (
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Search item ID, e.g. node ID for nodes.',
  `type` varchar(16) NOT NULL COMMENT 'Type of item, e.g. node.',
  `data` longtext NOT NULL COMMENT 'List of space-separated words from the item.',
  `reindex` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Set to force node reindexing.',
  PRIMARY KEY (`sid`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores items that will be searched.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_dataset`
--

LOCK TABLES `search_dataset` WRITE;
/*!40000 ALTER TABLE `search_dataset` DISABLE KEYS */;
INSERT INTO `search_dataset` VALUES (1,'node',' aenean lacinia bibendum admin s blog maecenas dolor est interdum a euismod eu accumsan posuere nisl nam sed iaculis massa sed nisl lectus tempor sed euismod quis sollicitudin nec est suspendisse dignissim bibendum tempor nam erat felis commodo sed semper commodo vel mauris suspendisse dignissim bibendum tempus sed auctor sem et volutpat facilisis risus leo venenatis leo ultricies accumsan urna ante vel nisl integer feugiat risus nec nisl dictum vestibulum vestibulum nec purus orci mauris ornare dolor eget purus malesuada vitae convallis dui dapibus donec sed leo magna ac pellentesque lorem vivamus sapien tortor lobortis ut ultrices vel tempus non metus suspendisse id est id elit commodo pellentesque non non lorem aenean sed blandit sapien nullam risus sapien dignissim tempor auctor non porta congue mi mauris aliquet ultricies ante non faucibus ante gravida sed sed ultrices pellentesque purus vulputate volutpat ipsum hendrerit sed neque sed sapien rutrum laoreet justo ultrices in pellentesque lorem condimentum dui conse vivamus semper mi sed congue semper odio felis tristique neque ac venenatis mauris augue cras varius enim ac tellus gravida aliquet praesent nec ante odio at egestas lorem phasellus nec velit sit amet leo pellentesque tempor vivamus molestie fringilla nulla at egestas magna tempor nec suspendisse potenti vivamus metus massa viverra sit amet bibendum ac consequat porta sem nullam venenatis faucibus sem donec non mi et felis iaculis tempor sed at dolor maecenas dignissim euismod permalink submitted by admin on sat 2022013 1628 maecenas dignissim euismod nunc in commodo est luctus eget proin in nunc laoreet justo volutpat blandit enim sem felis ullamcorper vel aliquam non varius eget justo duis quis nunc tellus mauris a felis arcu vitae sollicitudin mauris aliquam quis tellus vel massa mattis ornare et eu felis log in or register to post comments dignissim euismod nunc in permalink submitted by admin on sat 2022013 1628 dignissim euismod nunc in commodo est luctus eget proin in nunc laoreet justo volutpat blandit enim sem felis ullamcorper vel aliquam non varius eget justo duis quis nunc tellus mauris a felis arcu vitae sollicitudin mauris aliquam quis tellus vel massa mattis log in or register to post comments morbi velit eros sagittis in permalink submitted by admin on sat 2022013 1628 morbi velit eros sagittis in facilisis non rhoncus et erat nam posuere tristique sem eu ultricies tortor imperdiet vitae curabitur lacinia neque non metus log in or register to post comments  ',0),(2,'node',' vivamus metus massa admin s blog maecenas dolor est interdum a euismod eu accumsan posuere nisl nam sed iaculis massa sed nisl lectus tempor sed euismod quis sollicitudin nec est suspendisse dignissim bibendum tempor nam erat felis commodo sed semper commodo vel mauris suspendisse dignissim bibendum tempus sed auctor sem et volutpat facilisis risus leo venenatis leo ultricies accumsan urna ante vel nisl integer feugiat risus nec nisl dictum vestibulum vestibulum nec purus orci mauris ornare dolor eget purus malesuada vitae convallis dui dapibus donec sed leo magna ac pellentesque lorem vivamus sapien tortor lobortis ut ultrices vel tempus non metus suspendisse id est id elit commodo pellentesque non non lorem aenean sed blandit sapien nullam risus sapien dignissim tempor auctor non porta congue mi mauris aliquet ultricies ante non faucibus ante gravida sed sed ultrices pellentesque purus vulputate volutpat ipsum hendrerit sed neque sed sapien rutrum laoreet justo ultrices in pellentesque lorem condimentum dui conse vivamus semper mi sed congue semper odio felis tristique neque ac venenatis mauris augue cras varius enim ac tellus gravida aliquet praesent nec ante odio at egestas lorem phasellus nec velit sit amet leo pellentesque tempor vivamus molestie fringilla nulla at egestas magna tempor nec suspendisse potenti vivamus metus massa viverra sit amet bibendum ac consequat porta sem nullam venenatis faucibus sem donec non mi et felis iaculis tempor sed at dolor  ',0),(3,'node',' phasellus nec velit sit amet admin s blog maecenas dolor est interdum a euismod eu accumsan posuere nisl nam sed iaculis massa sed nisl lectus tempor sed euismod quis sollicitudin nec est suspendisse dignissim bibendum tempor nam erat felis commodo sed semper commodo vel mauris suspendisse dignissim bibendum tempus sed auctor sem et volutpat facilisis risus leo venenatis leo ultricies accumsan urna ante vel nisl integer feugiat risus nec nisl dictum vestibulum vestibulum nec purus orci mauris ornare dolor eget purus malesuada vitae convallis dui dapibus donec sed leo magna ac pellentesque lorem vivamus sapien tortor lobortis ut ultrices vel tempus non metus suspendisse id est id elit commodo pellentesque non non lorem aenean sed blandit sapien nullam risus sapien dignissim tempor auctor non porta congue mi mauris aliquet ultricies ante non faucibus ante gravida sed sed ultrices pellentesque purus vulputate volutpat ipsum hendrerit sed neque sed sapien rutrum laoreet justo ultrices in pellentesque lorem condimentum dui conse vivamus semper mi sed congue semper odio felis tristique neque ac venenatis mauris augue cras varius enim ac tellus gravida aliquet praesent nec ante odio at egestas lorem phasellus nec velit sit amet leo pellentesque tempor vivamus molestie fringilla nulla at egestas magna tempor nec suspendisse potenti vivamus metus massa viverra sit amet bibendum ac consequat porta sem nullam venenatis faucibus sem donec non mi et felis iaculis tempor sed at dolor  ',0),(4,'node',' maritime details lorem ipsum dolor sit amet consectetur adipiscing elit vestibulum id ligula felis euismod semper donec ullamcorper nulla non metus auctor fringilla nullam quis risus eget urna mollis ornare vel eu leo aenean eu leo quam pellentesque ornare sem lacinia quam venenatis vestibulum vestibulum id ligula porta felis euismod semper sed posuere consectetur est at lobortis cras mattis consectetur purus sit amet fermentumnullam quis risus eget urna mollis ornare donec sed odio dui nulla vitae elit libero a pharetra augue nullam id dolor id ultricies vehicula ut id elit integer posuere erat a ante venenatis dapibus posuere velit aliquet duis mollis est non commodo luctus nisi erat porttitor ligula eget lacinia odio sem nec elit aenean lacinia bibendum nulla sed consectetur cras mattis consectetur purus sit amet fermentum donec id elit non mi porta gravida at eget metus duis mollis est non commodo luctus nisi erat porttitor http tabvncom google  ',0),(5,'node',' grand canyon lorem ipsum dolor sit amet consectetur adipiscing elit vestibulum id ligula felis euismod semper donec ullamcorper nulla non metus auctor fringilla nullam quis risus eget urna mollis ornare vel eu leo aenean eu leo quam pellentesque ornare sem lacinia quam venenatis vestibulum vestibulum id ligula porta felis euismod semper sed posuere consectetur est at lobortis cras mattis consectetur purus sit amet fermentumnullam quis risus eget urna mollis ornare donec sed odio dui nulla vitae elit libero a pharetra augue nullam id dolor id ultricies vehicula ut id elit integer posuere erat a ante venenatis dapibus posuere velit aliquet duis mollis est non commodo luctus nisi erat porttitor ligula eget lacinia odio sem nec elit aenean lacinia bibendum nulla sed consectetur cras mattis consectetur purus sit amet fermentum donec id elit non mi porta gravida at eget metus duis mollis est non commodo luctus nisi erat porttitor http tabvncom envato  ',0),(6,'node',' coffee time lorem ipsum dolor sit amet consectetur adipiscing elit vestibulum id ligula felis euismod semper donec ullamcorper nulla non metus auctor fringilla nullam quis risus eget urna mollis ornare vel eu leo aenean eu leo quam pellentesque ornare sem lacinia quam venenatis vestibulum vestibulum id ligula porta felis euismod semper sed posuere consectetur est at lobortis cras mattis consectetur purus sit amet fermentumnullam quis risus eget urna mollis ornare donec sed odio dui nulla vitae elit libero a pharetra augue nullam id dolor id ultricies vehicula ut id elit integer posuere erat a ante venenatis dapibus posuere velit aliquet duis mollis est non commodo luctus nisi erat porttitor ligula eget lacinia odio sem nec elit aenean lacinia bibendum nulla sed consectetur cras mattis consectetur purus sit amet fermentum donec id elit non mi porta gravida at eget metus duis mollis est non commodo luctus nisi erat porttitor http tabvncom google  ',0),(7,'node',' surfing the web lorem ipsum dolor sit amet consectetur adipiscing elit vestibulum id ligula felis euismod semper donec ullamcorper nulla non metus auctor fringilla nullam quis risus eget urna mollis ornare vel eu leo aenean eu leo quam pellentesque ornare sem lacinia quam venenatis vestibulum vestibulum id ligula porta felis euismod semper sed posuere consectetur est at lobortis cras mattis consectetur purus sit amet fermentumnullam quis risus eget urna mollis ornare donec sed odio dui nulla vitae elit libero a pharetra augue nullam id dolor id ultricies vehicula ut id elit integer posuere erat a ante venenatis dapibus posuere velit aliquet duis mollis est non commodo luctus nisi erat porttitor ligula eget lacinia odio sem nec elit aenean lacinia bibendum nulla sed consectetur cras mattis consectetur purus sit amet fermentum donec id elit non mi porta gravida at eget metus duis mollis est non commodo luctus nisi erat porttitor http tabvncom google  ',0),(8,'node',' wireless keyboard lorem ipsum dolor sit amet consectetur adipiscing elit vestibulum id ligula felis euismod semper donec ullamcorper nulla non metus auctor fringilla nullam quis risus eget urna mollis ornare vel eu leo aenean eu leo quam pellentesque ornare sem lacinia quam venenatis vestibulum vestibulum id ligula porta felis euismod semper sed posuere consectetur est at lobortis cras mattis consectetur purus sit amet fermentumnullam quis risus eget urna mollis ornare donec sed odio dui nulla vitae elit libero a pharetra augue nullam id dolor id ultricies vehicula ut id elit integer posuere erat a ante venenatis dapibus posuere velit aliquet duis mollis est non commodo luctus nisi erat porttitor ligula eget lacinia odio sem nec elit aenean lacinia bibendum nulla sed consectetur cras mattis consectetur purus sit amet fermentum donec id elit non mi porta gravida at eget metus duis mollis est non commodo luctus nisi erat porttitor http tabvncom google  ',0),(9,'node',' pine tree near water lorem ipsum dolor sit amet consectetur adipiscing elit vestibulum id ligula felis euismod semper donec ullamcorper nulla non metus auctor fringilla nullam quis risus eget urna mollis ornare vel eu leo aenean eu leo quam pellentesque ornare sem lacinia quam venenatis vestibulum vestibulum id ligula porta felis euismod semper sed posuere consectetur est at lobortis cras mattis consectetur purus sit amet fermentumnullam quis risus eget urna mollis ornare donec sed odio dui nulla vitae elit libero a pharetra augue nullam id dolor id ultricies vehicula ut id elit integer posuere erat a ante venenatis dapibus posuere velit aliquet duis mollis est non commodo luctus nisi erat porttitor ligula eget lacinia odio sem nec elit aenean lacinia bibendum nulla sed consectetur cras mattis consectetur purus sit amet fermentum donec id elit non mi porta gravida at eget metus duis mollis est non commodo luctus nisi erat porttitor http tabvncom google  ',0),(10,'node',' digital world lorem ipsum dolor sit amet consectetur adipiscing elit vestibulum id ligula felis euismod semper donec ullamcorper nulla non metus auctor fringilla nullam quis risus eget urna mollis ornare vel eu leo aenean eu leo quam pellentesque ornare sem lacinia quam venenatis vestibulum vestibulum id ligula porta felis euismod semper sed posuere consectetur est at lobortis cras mattis consectetur purus sit amet fermentumnullam quis risus eget urna mollis ornare donec sed odio dui nulla vitae elit libero a pharetra augue nullam id dolor id ultricies vehicula ut id elit integer posuere erat a ante venenatis dapibus posuere velit aliquet duis mollis est non commodo luctus nisi erat porttitor ligula eget lacinia odio sem nec elit aenean lacinia bibendum nulla sed consectetur cras mattis consectetur purus sit amet fermentum donec id elit non mi porta gravida at eget metus duis mollis est non commodo luctus nisi erat porttitor http tabvncom envato  ',0),(11,'node',' grand canyon lorem ipsum dolor sit amet consectetur adipiscing elit vestibulum id ligula felis euismod semper donec ullamcorper nulla non metus auctor fringilla nullam quis risus eget urna mollis ornare vel eu leo aenean eu leo quam pellentesque ornare sem lacinia quam venenatis vestibulum vestibulum id ligula porta felis euismod semper sed posuere consectetur est at lobortis cras mattis consectetur purus sit amet fermentumnullam quis risus eget urna mollis ornare donec sed odio dui nulla vitae elit libero a pharetra augue nullam id dolor id ultricies vehicula ut id elit integer posuere erat a ante venenatis dapibus posuere velit aliquet duis mollis est non commodo luctus nisi erat porttitor ligula eget lacinia odio sem nec elit aenean lacinia bibendum nulla sed consectetur cras mattis consectetur purus sit amet fermentum donec id elit non mi porta gravida at eget metus duis mollis est non commodo luctus nisi erat porttitor http tabvncom google  ',0),(12,'node',' shortcodes buttons button button button button button button tabs tab 1 tab 3 1 lorem ipsum pharetra felis aliquam egestas consectetur elementum class aptent taciti sociosqu ad litora torquent perea conubia nostra lorem inceptos orem ipsum dolor sit amet consectetur adipiscing elit 2 lorem ipsum pharetra felis aliquam egestas consectetur elementum class aptent taciti sociosqu ad litora torquent perea conubia nostra lorem inceptos orem ipsum dolor sit amet consectetur adipiscing elit 3 lorem ipsum pharetra felis aliquam egestas consectetur elementum class aptent taciti sociosqu ad litora torquent perea conubia nostra lorem inceptos orem ipsum dolor sit amet consectetur adipiscing elit accordions accordion 1 lorem ipsum dolor sit amet consectetur adipiscing elit aenean nisl orci lorem condiment ultrices consequat eu lorem ipsum dolor sit amet inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo accordion 2 lorem ipsum dolor sit amet consectetur adipiscing elit aenean nisl orci lorem condiment ultrices consequat eu lorem ipsum dolor sit amet inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo accordion 3 lorem ipsum dolor sit amet consectetur adipiscing elit aenean nisl orci lorem condiment ultrices consequat eu lorem ipsum dolor sit amet inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo alert boxes error please fill in all the fields required success you did it now relax and enjoy it warning change this and that and try again notice please edit the information below tooltips condiment adipiscing varius accumsan fusce placerat neque sed sapien rutrum laoreet justo ultrices in pellentesque lorem condimentum dui consequat adipiscing nisi tincidunt morbi pulvinar dui non quam pretium ut lacinia tortor blockquote mauris aliquet ultricies ante non faucibus ante gravida sed sed ultrices pellentesque purus vulputate volutpat ipsum hendrerit sed neque sed sapien rutrum laoreet justo ultrices in pellentesque lorem condimentum dui conse icon boxes website design proin iaculis purus consequat sem cure digni ssim donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt website development nam aliquam volutpat leo vel bibendum nunc elit purus tempus pulvinare rhoncus egestas nibh volutpat leo social marketing fusce porttitor turpis quis molestie costant equat nam purus tincidunt sedeat dapibus ugravida ut dui fusce et magna libero list styles check list lorem ipsum aperia plus list dolor beatae lorem minus list perspiciatis adipiscing star list lorem ipsum aperia arrow 2 list dolor beatae lorem square list perspiciatis adipiscing circle list lorem ipsum aperia cross list dolor beatae lorem testimonials posuere erat a ante venenatis dapibus posuere velit aliquet duis llis est non coeammodo luctus nisi erat porttitor ligula egeteas laciniato odiomo sem michael flash developer integer eu libero sit amet nisl vestibulum semper fusce nec porttitor massa in nec neque elit curabitur malesuada ligula vitae purus ornare onec etea magna diam varius john web developer cras sed odio est sit amet porttitor elit vestibulum elementum erat vitae ante venenatis cursus scelerisque quam vel nibh imperdiet vitae porta lorem posuere peter project manager elementum erat vitae ante venenatis dapibus maecenas cursus scelerisque quam vel nibh imperdiet vitae porta lorem posuere kathy art director large notice this is a headline this is a example of style component for calling extra attention to featured content or information read more social icons amazon behance blogger deviantart dribbble dropbox evernote facebook forrst github google plus joli cloud last fm linkedin picasa pintrest rss skype spotify stumbleupon tumblr twitter vimeo wordpress xing yahoo youtube table header 1 header 2 header 3 header 4 item 1 description 100 gb 100 gb item 2 description 200 gb 200 gb item 3 description 300 gb 300 gb item 4 description 400 gb 400 gb item 5 description 500 gb 500 gb mini icons miniicoglass miniicomusic miniicosearch miniicoenvelope miniicoheart miniicostar miniicostarempty miniicouser miniicofilm miniicothlarge miniicoth miniicothlist miniicook miniicoremove miniicozoomin miniicozoomout miniicooff miniicosignal miniicocog miniicotrash miniicohome miniicofile miniicotime miniicoroad miniicodownloadalt miniicodownload miniicoupload miniicoinbox miniicoplaycircle miniicorepeat miniicorefresh miniicolistalt miniicolock miniicoflag miniicoheadphones miniicovolumeoff miniicovolumedown miniicovolumeup miniicoqrcode miniicobarcode miniicotag miniicotags miniicobook miniicobookmark miniicoprint miniicocamera miniicofont miniicobold miniicoitalic miniicotextheight miniicotextwidth miniicoalignleft miniicoaligncenter miniicoalignright miniicoalignjustify miniicolist miniicoindentleft miniicoindentright miniicofacetimevideo miniicopicture miniicopencil miniicomapmarker miniicoadjust miniicotint miniicoedit miniicoshare miniicocheck miniicomove miniicostepbackward miniicofastbackward miniicobackward miniicoplay miniicopause miniicostop miniicoforward miniicofastforward miniicostepforward miniicoeject miniicochevronleft miniicochevronright miniicoplussign miniicominussign miniicoremovesign miniicooksign miniicoquestionsign miniicoinfosign miniicoscreenshot miniicoremovecircle miniicookcircle miniicobancircle miniicoarrowleft miniicoarrowright miniicoarrowup miniicoarrowdown miniicosharealt miniicoresizefull miniicoresizesmall miniicoplus miniicominus miniicoasterisk miniicoexclamationsign miniicogift miniicoleaf miniicofire miniicoeyeopen miniicoeyeclose miniicowarningsign miniicoplane miniicocalendar miniicorandom miniicocomment miniicomagnet miniicochevronup miniicochevrondown miniicoretweet miniicoshoppingcart miniicofolderclose miniicofolderopen miniicoresizevertical miniicoresizehorizontal miniicohdd miniicobullhorn miniicobell miniicocertificate miniicothumbsup miniicothumbsdown miniicohandright miniicohandleft miniicohandup miniicohanddown miniicocirclearrowright miniicocirclearrowleft miniicocirclearrowup miniicocirclearrowdown miniicoglobe miniicowrench miniicotasks miniicofilter miniicobriefcase miniicofullscreen icons icoglass icoleaf icodog icouser icogirl icocar icouseradd icoremove icofilm icomagic icoenvelope icocamera icohearth icobeachumbrella icotrain icoprint icobin ico music iconote icocogwheel icohome icosnowflake icofire icocogwheels icoparents icobinoculars icoroad icosearch icocars iconotes icopencil icobus icowifialt icoluggage icooldman icowoman icofile icocredit icoairplane iconotes icostats icocharts icopiechart icogroup icokeys icocalendar icorouter icocamerasmall icodislikes icostar icolink icoeyeopen icoeyeclose icoalarm icoclock icostopwatch icoprojector icohistory icotruck icocargo icocompass icokeynote icoattach icopower icolightbulb icotag icotags icocleaning icoruller icogift icoumbrella ico book icobookmark icosignalalt icocup icostroller icoheadphones icoheadset icowarningsign icosignal icoretweet icorefresh icoroundabout icorandom icoheat icorepeat icodisplay icologbook icoadressbook icomagnet icotable icoadjust icotint icocrop icovectorpathsquare icovectorpathcircle icovectorpathpolygon icovectorpathline icovectorpathcurve icovectorpathall icofont icoitalic icobold icotextunderline icotextstrike icotextheight icotextwidth icotextresize icoleftindent icorightindent icoalignleft icoaligncenter icoalignright icojustify icolist icotextsmaller icotextbugger icoembed icoembedclose icoadjustalt icomessagefull icomessageempty icomessagein icomessageout icomessageplus icomessageminus icomessageban icomessageflag icomessagelock icomessagenew icoinbox icoinboxplus icoinboxminus icoinboxlock icoinboxin icoinboxout icocomputerlocked icocomputerservice icocomputerprocess icophone icodatabaselock icodatabaseplus icodatabaseminus icodatabaseban icofolderopen icofolderplus ico folderminus icofolderlock icofolderflag icofoldernew icocheck icoedit iconewwindow icomorewindows icoshowbigthumbnails icoshowthumbnails icoshowthumbnailslines icoshowlines icoplaylist icopicture icoimac icomacbook icoipad icoiphone icoiphonetransfer icoiphoneexchange icoipod icoipodshuffle icoearplugs icoalbums icostepbackward icofastbackward icorewind icoplay icopause icostop icoforward icofastforward icostepforward icoeject icofacetimevideo icodownloadalt icomute icovolumeup icovolumedown icoscreenshot icomove icomore icobrightnessreduce icobrightnessincrease icocircleplus icocircleminus icocircleremove icocircleok icocirclequestionmark icocircleinfo icocircleexclamationmark icoremove icook icoban icodownload icoupload icoshoppingcart icolock icounlock icoelectricity icook icoremove icocartout icocartin icoleftarrow icorightarrow icodownarrow icouparrow icoresizesmall icoresizefull icocirclearrowleft icocirclearrowright icocirclearrowtop ico icoplaybutton icounshare icoshare icothinrightarrow icothinleftarrow icobluetooth icoeuro icousd icobp icoretweet icomoon icosun icocloud icodirectio icobrush icopen icozoomin icozoomout icopin icoriflescope icorotationlock icoflash icogooglemaps icoanchor icoconversation icochat icomale icofemale icoasterisk icodivide icosnorkeldiving icoscubadiving icooxygenvottle icofins icofishes icoboat icodeletepoint icosheriffsstar icoqrcode icobarcode  icopool icobuoy icospade icobank icovcard icoelectircalplug icoflag icocreditcard icokeyboardwirelsss icokeyboardwired icoshield icoring icocake icodrink icobeer icofastfood icocutlery icopizza icobirthdaycake icotablet icosettings icobullets icocardio icotshirt icopants icosweater icofabric icoleather icoscissors icopodium icoskull icocelebratio icoteakettle icofrenchpress icocoffecup icopot icograter icokettle icohospital icohospitalh icomicrophone icowebcam icotemplechurch icotempleislam icotemplehindu icotemplebuddhist icoelectricalsocketeu icoelectricalsocketus icobomb icocomments icoflower icobaseball icorugby icoax icotabletennis icobowling  icotreeconifer icotreedeciduous icomoreitems icosort icofilter icogamepad icoplayingdices icocalculator icotie icowallet icoshare icosampler icopiano icowebbrowser icoblog icodashboard icocertificate icobell icocandle icopinclassic icoiphoneshake icopinflag icoturtle icorabbit icoglobe icobriefcase icohdd icothumbsup icothumbsdown icohandright ico handleft icohandup icohanddown icofullscreen icoshoppingbag icobookopen iconameplate iconameplatealt icovases icoannouncement icodumbbell icosuitcase icofileimport icofileexport ',0),(13,'node',' full width 16 columns cras consequat porttitor tincidunt praesent eu tincidunt lacus donec ut neque vitae erat congue venenatis duis hendrerit lacinia leo in dignissim aliquam erat volutpat sed dignissim hendrerit nibh quis faucibus erat cursus eget integer porta nisl vitae felis rutrum ut mollis felis congue vestibulum augue nisl egestas eu rhoncus eu fermentum in leo pellentesque ultricies pharetra nulla sit amet sagittis curabitur at feugiat nibh duis sit amet odio eros donec non purus non augue cursus convallis sed id purus in fringilla luctus scelerisque donec mauris magna iaculis non suscipit eu pellentesque nec urna 8 columns praesent ut ante id metus sollicitudin sodales mauris dictum lorem quis pretium feugiat nibh metus ultricies quam nec venenatis dolor dolor at massa aliquam aliquet quam augue feugiat in lore ipsum dolor sit amet convallis magna suscipit 8 columns praesent ut ante id metus sollicitudin sodales mauris dictum lorem quis pretium feugiat nibh metus ultricies quam nec venenatis dolor dolor at massa aliquam aliquet quam augue feugiat in lore ipsum dolor sit amet convallis magna suscipit 13 column cras semper facilisis vestibulum nam purus magna venenatis a mollis at lacinia id lacus quisque metus arcu condimentum vitae dignissim at condimentum id dui fusce at dui metus nulla in purus in mauris luctus gravida vel vitae arcu magna nisi integer ut risus nulla 13 column cras semper facilisis vestibulum nam purus magna venenatis a mollis at lacinia id lacus quisque metus arcu condimentum vitae dignissim at condimentum id dui fusce at dui metus nulla in purus in mauris luctus gravida vel vitae arcu magna nisi integer ut risus nulla 13 column cras semper facilisis vestibulum nam purus magna venenatis a mollis at lacinia id lacus quisque metus arcu condimentum vitae dignissim at condimentum id dui fusce at dui metus nulla in purus in mauris luctus gravida vel vitae arcu magna nisi integer ut risus nulla 14 column magna nisi integer ut risus nulla aliquam at erat in purus aliquet mollis fusce elementum velit vel dolor iaculis egestas nullam vitae neque luctus dolor pulvinar condimentum nec sed 14 column magna nisi integer ut risus nulla aliquam at erat in purus aliquet mollis fusce elementum velit vel dolor iaculis egestas nullam vitae neque luctus dolor pulvinar condimentum nec sed 14 column magna nisi integer ut risus nulla aliquam at erat in purus aliquet mollis fusce elementum velit vel dolor iaculis egestas nullam vitae neque luctus dolor pulvinar condimentum nec sed 14 column magna nisi integer ut risus nulla aliquam at erat in purus aliquet mollis fusce elementum velit vel dolor iaculis egestas nullam vitae neque luctus dolor pulvinar condimentum nec sed 12 columns sed at odio ut arcu fringilla dictum eu eu nisl donec rutrum erat non arcu gravida porttitor nunc et magna nisialiquam at erat in purus aliquet mollis fusce elementum velit vel dolor iaculis egestas maecenas ut nulla quis eros scelerisque posuere vel vitae nibh proin id condimentum sem morbi vitae dui in magna vestibulum suscipit vitae vel nunc integer ut risus nulla malesuada tortor nec scelerisque lorem mattis lore aliquam at erat in purus aliquet mollis fusce elementum velit vel dolor iaculis egestas nullam vitae neque luctus dolor 4 columns magna nisi integer ut risus nulla lorem aliquam at erat in purus aliquet mollis nullam vitae pulvinar condimentum nec aiquam at erat in purus aliquet mollis lorem ipsum dolor sed  ',0),(14,'node',' about us our approach donec odio ut arcu fringilla dictum eu eu nisl donec rutrum erat non arcu gravida porttitor nunc et magna nisialiquam at erat in purus aliquet mollis fusce elementum velit vel dolor iaculis egestas maecenas ut nulla quis eros scelerisque posuere vel vitae nibh proin id condimentum sem morbi vitae dui in magna vestibulum suscipit vitae vel nunc integer ut risus nulla malesuada tortor nec scelerisque lorem mattis nunc et rutrum consetetur sadipscing elitr sed diam nonumy at volutpat sed consectetur suscipit lorem nuncadipiscing elit integer commodo tristique odio quis fringilla ligula aliquet ut maecenas sed justo varius velit imperdiet bibendum integer commodo tristique odio quis fringilla ligula aliquet ut maecenas sed justo varius velit imperdiet bibendum vivamus nec sapien massa a imperdiet diam aliquam erat volutpat sed tetur suscipit nunc et rutrum careers we re hiring we re offering great oppurtunites for project manager and web designer apply meet the team jane smith chief executive officer ceo consectetur dolor ipsum quiam dolor adipisci velit aenean at lorem vel est posuere feugiat sed quia noneas numquasa mode tempora incidunt ipsum facebook linkedin google plus john doe web designer consectetur dolor ipsum quiam dolor adipisci velit aenean at lorem vel est posuere feugiat sed quia noneas numquasa mode tempora incidunt ipsum facebook linkedin forrst dribbble michael smith project manager consectetur dolor ipsum quiam dolor adipisci velit aenean at lorem vel est posuere feugiat sed quia noneas numquasa mode tempora incidunt ipsum facebook linkedin blogger google plus pintrest ',0),(15,'node',' services if you re looking for service which isn t listed below please send us a message  methodology donec rutrum erat non arcu gravida porttitor nunc et magna nisialiquam at erat in purus aliquet mollis fusce elementum velit vel dolor iaculis egestas maecenas ut nulla quis eros scelerisque posuere vel vitae nibh proin id condimentum sem morbi vitae dui in magna vestibulum suscipit vitae vel nunc nunc et rutrum consetetur sadipscing elitr sed diam nonumy at volutpat sed consectetur suscipit lorem nuncadipiscing elit integer commodo tristique odio quis fringilla ligula aliquet ut maecenas sed justo varius velit imperdietaliquam at erat in purus aliquet mollis fusce elementum velit vel dolor iaculis features quick and convenient localization support compatible with the latest w3c standards flexible responsive layout compatible with major browsers attuned to smartphones and tablet pcs services web usability proin iaculis purus consequat sem cure digni ssim donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt mauris ut ligula tortorea lorem ipsum dolor sit amet gorbi vel nulla eget quam porttitor gravida social marketing proin iaculis purus consequat sem cure digni ssim donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt mauris ut ligula tortorea lorem ipsum dolor sit amet gorbi vel nulla eget quam porttitor gravida web design proin iaculis purus consequat sem cure digni ssim donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt mauris ut ligula tortorea lorem ipsum dolor sit amet gorbi vel nulla eget quam porttitor gravida video recording proin iaculis purus consequat sem cure digni ssim donec porttitora entum suscipit aenean rhoncus posuere odio in tincidunt mauris ut ligula tortorea lorem ipsum dolor sit amet gorbi vel nulla eget quam porttitor gravida our clients ',0),(16,'node',' pricing tables four tables standard  999 per month 5 gb storage free live support unlimited users no time tracking enhanced ssl security sign up premium  2999 per month 25 gb storage free live support unlimited users no time tracking enhanced ssl security sign up professional  4999 per month 50 gb storage free live support unlimited users no time tracking enhanced ssl security sign up ultimate  9999 per month 100 gb storage free live support unlimited users no time tracking enhanced ssl security sign up three tables standard  999 per month 5 gb storage free live support unlimited users no time tracking enhanced ssl security sign up premium  2999 per month 25 gb storage free live support unlimited users no time tracking enhanced ssl security sign up professional  4999 per month 50 gb storage free live support unlimited users no time tracking enhanced ssl security sign up ',0);
/*!40000 ALTER TABLE `search_dataset` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_index`
--

DROP TABLE IF EXISTS `search_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_index` (
  `word` varchar(50) NOT NULL DEFAULT '' COMMENT 'The search_total.word that is associated with the search item.',
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The search_dataset.sid of the searchable item to which the word belongs.',
  `type` varchar(16) NOT NULL COMMENT 'The search_dataset.type of the searchable item to which the word belongs.',
  `score` float DEFAULT NULL COMMENT 'The numeric score of the word, higher being more important.',
  PRIMARY KEY (`word`,`sid`,`type`),
  KEY `sid_type` (`sid`,`type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the search index, associating words, items and...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_index`
--

LOCK TABLES `search_index` WRITE;
/*!40000 ALTER TABLE `search_index` DISABLE KEYS */;
INSERT INTO `search_index` VALUES ('1',12,'node',24.2502),('100',12,'node',1.24218),('100',16,'node',1),('12',13,'node',16),('13',13,'node',48),('14',13,'node',64),('16',13,'node',16),('1628',1,'node',2.85483),('2',12,'node',14.0607),('200',12,'node',1.23898),('2022013',1,'node',2.85896),('25',16,'node',2),('2999',16,'node',26),('3',12,'node',24.2454),('300',12,'node',1.23581),('4',12,'node',1.24385),('4',13,'node',15.694),('400',12,'node',1.23265),('4999',16,'node',26),('5',12,'node',0.615536),('5',16,'node',2),('50',16,'node',2),('500',12,'node',1.22638),('8',13,'node',32),('999',16,'node',26),('9999',16,'node',13),('about',14,'node',26),('accordion',12,'node',33),('accordions',12,'node',16),('accumsan',1,'node',2),('accumsan',2,'node',2),('accumsan',3,'node',2),('accumsan',12,'node',1),('adipisci',14,'node',2.92613),('adipiscing',4,'node',1),('adipiscing',5,'node',1),('adipiscing',6,'node',1),('adipiscing',7,'node',1),('adipiscing',8,'node',1),('adipiscing',9,'node',1),('adipiscing',10,'node',1),('adipiscing',11,'node',1),('adipiscing',12,'node',19.6302),('admin',1,'node',13.8631),('admin',2,'node',11),('admin',3,'node',11),('aenean',1,'node',27),('aenean',2,'node',1),('aenean',3,'node',1),('aenean',4,'node',2),('aenean',5,'node',2),('aenean',6,'node',2),('aenean',7,'node',2),('aenean',8,'node',2),('aenean',9,'node',2),('aenean',10,'node',2),('aenean',11,'node',2),('aenean',12,'node',3.92027),('aenean',14,'node',2.92613),('aenean',15,'node',3.89111),('again',12,'node',1),('aiquam',13,'node',0.976851),('alert',12,'node',16),('aliquam',1,'node',3.80289),('aliquam',12,'node',3.90286),('aliquam',13,'node',8.95772),('aliquam',14,'node',1),('aliquet',1,'node',2),('aliquet',2,'node',2),('aliquet',3,'node',2),('aliquet',4,'node',1),('aliquet',5,'node',1),('aliquet',6,'node',1),('aliquet',7,'node',1),('aliquet',8,'node',1),('aliquet',9,'node',1),('aliquet',10,'node',1),('aliquet',11,'node',1),('aliquet',12,'node',1.79475),('aliquet',13,'node',9.93059),('aliquet',14,'node',3),('aliquet',15,'node',3),('all',12,'node',1),('amazon',12,'node',7.47842),('amet',1,'node',2),('amet',2,'node',2),('amet',3,'node',28),('amet',4,'node',3),('amet',5,'node',3),('amet',6,'node',3),('amet',7,'node',3),('amet',8,'node',3),('amet',9,'node',3),('amet',10,'node',3),('amet',11,'node',3),('amet',12,'node',10.4935),('amet',13,'node',4),('amet',15,'node',3.88426),('and',12,'node',3),('and',14,'node',1),('and',15,'node',2),('ante',1,'node',4),('ante',2,'node',4),('ante',3,'node',4),('ante',4,'node',1),('ante',5,'node',1),('ante',6,'node',1),('ante',7,'node',1),('ante',8,'node',1),('ante',9,'node',1),('ante',10,'node',1),('ante',11,'node',1),('ante',12,'node',4.24122),('ante',13,'node',2),('aperia',12,'node',2.45526),('apply',14,'node',11),('approach',14,'node',13),('aptent',12,'node',3),('architecto',12,'node',3),('arcu',1,'node',1.89947),('arcu',13,'node',8),('arcu',14,'node',2),('arcu',15,'node',1),('arrow',12,'node',0.816452),('art',12,'node',0.712106),('attention',12,'node',0.691597),('attuned',15,'node',1),('auctor',1,'node',2),('auctor',2,'node',2),('auctor',3,'node',2),('auctor',4,'node',1),('auctor',5,'node',1),('auctor',6,'node',1),('auctor',7,'node',1),('auctor',8,'node',1),('auctor',9,'node',1),('auctor',10,'node',1),('auctor',11,'node',1),('augue',1,'node',1),('augue',2,'node',1),('augue',3,'node',1),('augue',4,'node',1),('augue',5,'node',1),('augue',6,'node',1),('augue',7,'node',1),('augue',8,'node',1),('augue',9,'node',1),('augue',10,'node',1),('augue',11,'node',1),('augue',13,'node',4),('beatae',12,'node',5.44403),('behance',12,'node',7.45733),('below',12,'node',1),('below',15,'node',1),('bibendum',1,'node',29),('bibendum',2,'node',3),('bibendum',3,'node',3),('bibendum',4,'node',1),('bibendum',5,'node',1),('bibendum',6,'node',1),('bibendum',7,'node',1),('bibendum',8,'node',1),('bibendum',9,'node',1),('bibendum',10,'node',1),('bibendum',11,'node',1),('bibendum',12,'node',0.896076),('bibendum',14,'node',2),('blandit',1,'node',2.91124),('blandit',2,'node',1),('blandit',3,'node',1),('blockquote',12,'node',16),('blog',1,'node',11),('blog',2,'node',11),('blog',3,'node',11),('blogger',12,'node',7.43636),('blogger',14,'node',10.5295),('book',12,'node',1.59729),('boxes',12,'node',31.4397),('browsers',15,'node',1),('button',12,'node',66),('buttons',12,'node',16),('calling',12,'node',0.695602),('canyon',5,'node',26),('canyon',11,'node',26),('careers',14,'node',13),('ceo',14,'node',1),('change',12,'node',1),('check',12,'node',0.833529),('chief',14,'node',1),('circle',12,'node',0.810915),('class',12,'node',3),('clients',15,'node',12.3942),('cloud',12,'node',7.23303),('coeammodo',12,'node',0.786915),('coffee',6,'node',26),('column',13,'node',112),('columns',13,'node',79.6296),('comments',1,'node',2.79721),('commodo',1,'node',4.91926),('commodo',2,'node',3),('commodo',3,'node',3),('commodo',4,'node',2),('commodo',5,'node',2),('commodo',6,'node',2),('commodo',7,'node',2),('commodo',8,'node',2),('commodo',9,'node',2),('commodo',10,'node',2),('commodo',11,'node',2),('commodo',14,'node',2),('commodo',15,'node',1),('compatible',15,'node',2),('component',12,'node',0.699655),('condiment',12,'node',4),('condimentum',1,'node',1),('condimentum',2,'node',1),('condimentum',3,'node',1),('condimentum',12,'node',11.9729),('condimentum',13,'node',11.9769),('condimentum',14,'node',1),('condimentum',15,'node',1),('congue',1,'node',2),('congue',2,'node',2),('congue',3,'node',2),('congue',13,'node',2),('conse',1,'node',1),('conse',2,'node',1),('conse',3,'node',1),('conse',12,'node',0.972861),('consectetur',4,'node',5),('consectetur',5,'node',5),('consectetur',6,'node',5),('consectetur',7,'node',5),('consectetur',8,'node',5),('consectetur',9,'node',5),('consectetur',10,'node',5),('consectetur',11,'node',5),('consectetur',12,'node',9),('consectetur',14,'node',3.92613),('consectetur',15,'node',1),('consequat',1,'node',1),('consequat',2,'node',1),('consequat',3,'node',1),('consequat',12,'node',4.9496),('consequat',13,'node',1),('consequat',15,'node',3.89111),('consetetur',14,'node',1),('consetetur',15,'node',1),('content',12,'node',0.687638),('conubia',12,'node',3),('convallis',1,'node',1),('convallis',2,'node',1),('convallis',3,'node',1),('convallis',13,'node',3),('convenient',15,'node',1),('costant',12,'node',0.860547),('cras',1,'node',1),('cras',2,'node',1),('cras',3,'node',1),('cras',4,'node',2),('cras',5,'node',2),('cras',6,'node',2),('cras',7,'node',2),('cras',8,'node',2),('cras',9,'node',2),('cras',10,'node',2),('cras',11,'node',2),('cras',12,'node',0.733888),('cras',13,'node',4),('cross',12,'node',0.808176),('curabitur',1,'node',0.920273),('curabitur',12,'node',0.752312),('curabitur',13,'node',1),('cure',12,'node',0.945829),('cure',15,'node',3.89111),('cursus',12,'node',1.44587),('cursus',13,'node',2),('dapibus',1,'node',1),('dapibus',2,'node',1),('dapibus',3,'node',1),('dapibus',4,'node',1),('dapibus',5,'node',1),('dapibus',6,'node',1),('dapibus',7,'node',1),('dapibus',8,'node',1),('dapibus',9,'node',1),('dapibus',10,'node',1),('dapibus',11,'node',1),('dapibus',12,'node',2.3651),('description',12,'node',3.09356),('design',12,'node',15.3774),('design',15,'node',15.5025),('designer',14,'node',1.9689),('details',4,'node',26),('developer',12,'node',1.50065),('development',12,'node',14.5559),('deviantart',12,'node',7.4155),('diam',12,'node',0.740689),('diam',14,'node',2),('diam',15,'node',1),('dicta',12,'node',3),('dictum',1,'node',1),('dictum',2,'node',1),('dictum',3,'node',1),('dictum',13,'node',3),('dictum',14,'node',1),('did',12,'node',1),('digital',10,'node',26),('digni',12,'node',0.942091),('digni',15,'node',3.89111),('dignissim',1,'node',49.5061),('dignissim',2,'node',3),('dignissim',3,'node',3),('dignissim',13,'node',5),('director',12,'node',0.71),('doe',14,'node',9.72861),('dolor',1,'node',3),('dolor',2,'node',3),('dolor',3,'node',3),('dolor',4,'node',2),('dolor',5,'node',2),('dolor',6,'node',2),('dolor',7,'node',2),('dolor',8,'node',2),('dolor',9,'node',2),('dolor',10,'node',2),('dolor',11,'node',2),('dolor',12,'node',11.444),('dolor',13,'node',17.9346),('dolor',14,'node',6.85226),('dolor',15,'node',5.88842),('donec',1,'node',2),('donec',2,'node',2),('donec',3,'node',2),('donec',4,'node',3),('donec',5,'node',3),('donec',6,'node',3),('donec',7,'node',3),('donec',8,'node',3),('donec',9,'node',3),('donec',10,'node',3),('donec',11,'node',3),('donec',12,'node',0.934703),('donec',13,'node',4),('donec',14,'node',2),('donec',15,'node',4.89111),('dribbble',12,'node',7.39477),('dribbble',14,'node',10.6148),('dropbox',12,'node',7.37415),('dui',1,'node',2),('dui',2,'node',2),('dui',3,'node',2),('dui',4,'node',1),('dui',5,'node',1),('dui',6,'node',1),('dui',7,'node',1),('dui',8,'node',1),('dui',9,'node',1),('dui',10,'node',1),('dui',11,'node',1),('dui',12,'node',3.81818),('dui',13,'node',6.99315),('dui',14,'node',1),('dui',15,'node',1),('duis',1,'node',1.90336),('duis',4,'node',2),('duis',5,'node',2),('duis',6,'node',2),('duis',7,'node',2),('duis',8,'node',2),('duis',9,'node',2),('duis',10,'node',2),('duis',11,'node',2),('duis',12,'node',0.794753),('duis',13,'node',2),('edit',12,'node',1),('egestas',1,'node',2),('egestas',2,'node',2),('egestas',3,'node',2),('egestas',12,'node',3.88282),('egestas',13,'node',6.98087),('egestas',14,'node',1),('egestas',15,'node',1),('eget',1,'node',4.81859),('eget',2,'node',1),('eget',3,'node',1),('eget',4,'node',4),('eget',5,'node',4),('eget',6,'node',4),('eget',7,'node',4),('eget',8,'node',4),('eget',9,'node',4),('eget',10,'node',4),('eget',11,'node',4),('eget',13,'node',1),('eget',15,'node',3.87604),('egeteas',12,'node',0.779231),('elementum',12,'node',4.44801),('elementum',13,'node',5.98087),('elementum',14,'node',1),('elementum',15,'node',2),('elit',1,'node',1),('elit',2,'node',1),('elit',3,'node',1),('elit',4,'node',5),('elit',5,'node',5),('elit',6,'node',5),('elit',7,'node',5),('elit',8,'node',5),('elit',9,'node',5),('elit',10,'node',5),('elit',11,'node',5),('elit',12,'node',8.37336),('elit',14,'node',1),('elit',15,'node',1),('elitr',14,'node',1),('elitr',15,'node',1),('enhanced',16,'node',7),('enim',1,'node',2.91124),('enim',2,'node',1),('enim',3,'node',1),('enjoy',12,'node',1),('entum',12,'node',0.927431),('entum',15,'node',3.89111),('envato',5,'node',1),('envato',10,'node',1),('equat',12,'node',0.857458),('erat',1,'node',1.92384),('erat',2,'node',1),('erat',3,'node',1),('erat',4,'node',3),('erat',5,'node',3),('erat',6,'node',3),('erat',7,'node',3),('erat',8,'node',3),('erat',9,'node',3),('erat',10,'node',3),('erat',11,'node',3),('erat',12,'node',3.03253),('erat',13,'node',11.9306),('erat',14,'node',3),('erat',15,'node',3),('eros',1,'node',22.4256),('eros',13,'node',2),('eros',14,'node',1),('eros',15,'node',1),('error',12,'node',1),('est',1,'node',4.91926),('est',2,'node',3),('est',3,'node',3),('est',4,'node',3),('est',5,'node',3),('est',6,'node',3),('est',7,'node',3),('est',8,'node',3),('est',9,'node',3),('est',10,'node',3),('est',11,'node',3),('est',12,'node',1.52116),('est',14,'node',2.92613),('etea',12,'node',0.742984),('euismod',1,'node',48.5061),('euismod',2,'node',2),('euismod',3,'node',2),('euismod',4,'node',2),('euismod',5,'node',2),('euismod',6,'node',2),('euismod',7,'node',2),('euismod',8,'node',2),('euismod',9,'node',2),('euismod',10,'node',2),('euismod',11,'node',2),('evernote',12,'node',7.35365),('example',12,'node',0.703756),('executive',14,'node',1),('explicabo',12,'node',3),('extra',12,'node',0.693594),('facebook',12,'node',7.33326),('facebook',14,'node',32.112),('facilisis',1,'node',1.92743),('facilisis',2,'node',1),('facilisis',3,'node',1),('facilisis',13,'node',3),('faucibus',1,'node',2),('faucibus',2,'node',2),('faucibus',3,'node',2),('faucibus',12,'node',0.997306),('faucibus',13,'node',1),('featured',12,'node',0.689612),('features',15,'node',13),('felis',1,'node',7.76411),('felis',2,'node',3),('felis',3,'node',3),('felis',4,'node',2),('felis',5,'node',2),('felis',6,'node',2),('felis',7,'node',2),('felis',8,'node',2),('felis',9,'node',2),('felis',10,'node',2),('felis',11,'node',2),('felis',12,'node',3),('felis',13,'node',2),('fermentum',4,'node',1),('fermentum',5,'node',1),('fermentum',6,'node',1),('fermentum',7,'node',1),('fermentum',8,'node',1),('fermentum',9,'node',1),('fermentum',10,'node',1),('fermentum',11,'node',1),('fermentum',13,'node',1),('fermentumnullam',4,'node',1),('fermentumnullam',5,'node',1),('fermentumnullam',6,'node',1),('fermentumnullam',7,'node',1),('fermentumnullam',8,'node',1),('fermentumnullam',9,'node',1),('fermentumnullam',10,'node',1),('fermentumnullam',11,'node',1),('feugiat',1,'node',1),('feugiat',2,'node',1),('feugiat',3,'node',1),('feugiat',13,'node',5),('feugiat',14,'node',2.92613),('fields',12,'node',1),('fill',12,'node',1),('flash',12,'node',0.769219),('flexible',15,'node',1),('folderminus',12,'node',1.42408),('for',12,'node',0.697623),('for',14,'node',1),('for',15,'node',1),('forrst',12,'node',7.31299),('forrst',14,'node',10.6579),('four',16,'node',13),('free',16,'node',7),('fringilla',1,'node',1),('fringilla',2,'node',1),('fringilla',3,'node',1),('fringilla',4,'node',1),('fringilla',5,'node',1),('fringilla',6,'node',1),('fringilla',7,'node',1),('fringilla',8,'node',1),('fringilla',9,'node',1),('fringilla',10,'node',1),('fringilla',11,'node',1),('fringilla',13,'node',2),('fringilla',14,'node',3),('fringilla',15,'node',1),('full',13,'node',26),('fusce',12,'node',3.47552),('fusce',13,'node',8.98087),('fusce',14,'node',1),('fusce',15,'node',2),('github',12,'node',7.29284),('google',4,'node',1),('google',6,'node',1),('google',7,'node',1),('google',8,'node',1),('google',9,'node',1),('google',11,'node',1),('google',12,'node',7.27279),('google',14,'node',21.3216),('gorbi',15,'node',3.88013),('grand',5,'node',26),('grand',11,'node',26),('gravida',1,'node',2),('gravida',2,'node',2),('gravida',3,'node',2),('gravida',4,'node',1),('gravida',5,'node',1),('gravida',6,'node',1),('gravida',7,'node',1),('gravida',8,'node',1),('gravida',9,'node',1),('gravida',10,'node',1),('gravida',11,'node',1),('gravida',12,'node',0.993146),('gravida',13,'node',4),('gravida',14,'node',1),('gravida',15,'node',4.86796),('great',14,'node',1),('handleft',12,'node',1.11486),('header',12,'node',2.50859),('headline',12,'node',13.4107),('hendrerit',1,'node',1),('hendrerit',2,'node',1),('hendrerit',3,'node',1),('hendrerit',12,'node',0.976851),('hendrerit',13,'node',2),('hiring',14,'node',19),('http',4,'node',1),('http',5,'node',1),('http',6,'node',1),('http',7,'node',1),('http',8,'node',1),('http',9,'node',1),('http',10,'node',1),('http',11,'node',1),('iaculis',1,'node',2),('iaculis',2,'node',2),('iaculis',3,'node',2),('iaculis',12,'node',0.953396),('iaculis',13,'node',6.98087),('iaculis',14,'node',1),('iaculis',15,'node',5.89111),('ico',12,'node',7.18163),('icoadjust',12,'node',1.547),('icoadjustalt',12,'node',1.48181),('icoadressbook',12,'node',1.55433),('icoairplane',12,'node',1.68512),('icoalarm',12,'node',1.6455),('icoalbums',12,'node',1.37843),('icoaligncenter',12,'node',1.49985),('icoalignleft',12,'node',1.50214),('icoalignright',12,'node',1.49757),('icoanchor',12,'node',1.25792),('icoannouncement',12,'node',1.10383),('icoasterisk',12,'node',1.25003),('icoattach',12,'node',1.62103),('icoax',12,'node',1.15598),('icoban',12,'node',1.32499),('icobank',12,'node',1.22694),('icobarcode',12,'node',1.23301),('icobaseball',12,'node',1.15866),('icobeachumbrella',12,'node',1.76414),('icobeer',12,'node',1.21057),('icobell',12,'node',1.13119),('icobin',12,'node',1.75464),('icobinoculars',12,'node',1.7237),('icobirthdaycake',12,'node',1.20473),('icoblog',12,'node',1.13503),('icobluetooth',12,'node',1.28555),('icoboat',12,'node',1.23914),('icobold',12,'node',1.5207),('icobomb',12,'node',1.16269),('icobookmark',12,'node',1.59469),('icobookopen',12,'node',1.1087),('icobowling',12,'node',1.15332),('icobp',12,'node',1.28058),('icobriefcase',12,'node',1.12108),('icobrightnessincrease',12,'node',1.34112),('icobrightnessreduce',12,'node',1.34293),('icobrush',12,'node',1.27239),('icobullets',12,'node',1.20038),('icobuoy',12,'node',1.22997),('icobus',12,'node',1.70568),('icocake',12,'node',1.21351),('icocalculator',12,'node',1.1428),('icocalendar',12,'node',1.66791),('icocamera',12,'node',1.77053),('icocamerasmall',12,'node',1.66225),('icocandle',12,'node',1.12992),('icocar',12,'node',1.79),('icocardio',12,'node',1.19894),('icocargo',12,'node',1.6291),('icocars',12,'node',1.71464),('icocartin',12,'node',1.31099),('icocartout',12,'node',1.31273),('icocelebratio',12,'node',1.18613),('icocertificate',12,'node',1.13247),('icocharts',12,'node',1.67934),('icochat',12,'node',1.25475),('icocheck',12,'node',1.41592),('icocirclearrowleft',12,'node',1.29899),('icocirclearrowright',12,'node',1.2973),('icocirclearrowtop',12,'node',1.29561),('icocircleexclamationmark',12,'node',1.32854),('icocircleinfo',12,'node',1.33032),('icocircleminus',12,'node',1.3375),('icocircleok',12,'node',1.3339),('icocircleplus',12,'node',1.3393),('icocirclequestionmark',12,'node',1.33211),('icocircleremove',12,'node',1.3357),('icocleaning',12,'node',1.60775),('icoclock',12,'node',1.64275),('icocloud',12,'node',1.27566),('icocoffecup',12,'node',1.18192),('icocogwheel',12,'node',1.74213),('icocogwheels',12,'node',1.7298),('icocomments',12,'node',1.16135),('icocompass',12,'node',1.6264),('icocomputerlocked',12,'node',1.44492),('icocomputerprocess',12,'node',1.4407),('icocomputerservice',12,'node',1.44281),('icoconversation',12,'node',1.25633),('icocredit',12,'node',1.68803),('icocreditcard',12,'node',1.22094),('icocrop',12,'node',1.54215),('icocup',12,'node',1.58953),('icocutlery',12,'node',1.20764),('icodashboard',12,'node',1.13375),('icodatabaseban',12,'node',1.43027),('icodatabaselock',12,'node',1.43651),('icodatabaseminus',12,'node',1.43234),('icodatabaseplus',12,'node',1.43442),('icodeletepoint',12,'node',1.2376),('icodirectio',12,'node',1.27402),('icodislikes',12,'node',1.65943),('icodisplay',12,'node',1.55926),('icodivide',12,'node',1.24846),('icodog',12,'node',1.7999),('icodownarrow',12,'node',1.30582),('icodownload',12,'node',1.32323),('icodownloadalt',12,'node',1.35579),('icodrink',12,'node',1.21204),('icodumbbell',12,'node',1.10262),('icoearplugs',12,'node',1.38035),('icoedit',12,'node',1.4139),('icoeject',12,'node',1.35951),('icoelectircalplug',12,'node',1.22393),('icoelectricalsocketeu',12,'node',1.1654),('icoelectricalsocketus',12,'node',1.16405),('icoelectricity',12,'node',1.31447),('icoembed',12,'node',1.48628),('icoembedclose',12,'node',1.48404),('icoenvelope',12,'node',1.77375),('icoeuro',12,'node',1.28389),('icoeyeclose',12,'node',1.64827),('icoeyeopen',12,'node',1.65105),('icofabric',12,'node',1.19321),('icofacetimevideo',12,'node',1.35765),('icofastbackward',12,'node',1.3746),('icofastfood',12,'node',1.2091),('icofastforward',12,'node',1.36325),('icofemale',12,'node',1.2516),('icofile',12,'node',1.69094),('icofileexport',12,'node',1.099),('icofileimport',12,'node',1.1002),('icofilm',12,'node',1.78021),('icofilter',12,'node',1.14672),('icofins',12,'node',1.24223),('icofire',12,'node',1.73287),('icofishes',12,'node',1.24069),('icoflag',12,'node',1.22243),('icoflash',12,'node',1.26111),('icoflower',12,'node',1.16),('icofolderflag',12,'node',1.41999),('icofolderlock',12,'node',1.42203),('icofoldernew',12,'node',1.41795),('icofolderopen',12,'node',1.4282),('icofolderplus',12,'node',1.42614),('icofont',12,'node',1.52541),('icoforward',12,'node',1.36513),('icofrenchpress',12,'node',1.18332),('icofullscreen',12,'node',1.11116),('icogamepad',12,'node',1.14541),('icogift',12,'node',1.6025),('icogirl',12,'node',1.79329),('icoglass',12,'node',1.80656),('icoglobe',12,'node',1.12233),('icogooglemaps',12,'node',1.25951),('icograter',12,'node',1.17914),('icogroup',12,'node',1.67361),('icohanddown',12,'node',1.11239),('icohandright',12,'node',1.1161),('icohandup',12,'node',1.11362),('icohdd',12,'node',1.11983),('icoheadphones',12,'node',1.5844),('icoheadset',12,'node',1.58185),('icohearth',12,'node',1.76733),('icoheat',12,'node',1.56422),('icohistory',12,'node',1.63453),('icohome',12,'node',1.73903),('icohospital',12,'node',1.17636),('icohospitalh',12,'node',1.17498),('icoimac',12,'node',1.39593),('icoinbox',12,'node',1.45772),('icoinboxin',12,'node',1.44916),('icoinboxlock',12,'node',1.45129),('icoinboxminus',12,'node',1.45343),('icoinboxout',12,'node',1.44704),('icoinboxplus',12,'node',1.45557),('icoipad',12,'node',1.392),('icoiphone',12,'node',1.39005),('icoiphoneexchange',12,'node',1.38615),('icoiphoneshake',12,'node',1.12738),('icoiphonetransfer',12,'node',1.3881),('icoipod',12,'node',1.38422),('icoipodshuffle',12,'node',1.38228),('icoitalic',12,'node',1.52305),('icojustify',12,'node',1.4953),('icokettle',12,'node',1.17775),('icokeyboardwired',12,'node',1.21796),('icokeyboardwirelsss',12,'node',1.21944),('icokeynote',12,'node',1.62371),('icokeys',12,'node',1.67075),('icoleaf',12,'node',1.80322),('icoleather',12,'node',1.19179),('icoleftarrow',12,'node',1.30927),('icoleftindent',12,'node',1.50674),('icolightbulb',12,'node',1.61569),('icolink',12,'node',1.65383),('icolist',12,'node',1.49304),('icolock',12,'node',1.31796),('icologbook',12,'node',1.55679),('icoluggage',12,'node',1.69975),('icomacbook',12,'node',1.39397),('icomagic',12,'node',1.77697),('icomagnet',12,'node',1.55188),('icomale',12,'node',1.25317),('icomessageban',12,'node',1.46639),('icomessageempty',12,'node',1.47737),('icomessageflag',12,'node',1.46421),('icomessagefull',12,'node',1.47959),('icomessagein',12,'node',1.47516),('icomessagelock',12,'node',1.46204),('icomessageminus',12,'node',1.46857),('icomessagenew',12,'node',1.45988),('icomessageout',12,'node',1.47296),('icomessageplus',12,'node',1.47076),('icomicrophone',12,'node',1.1736),('icomoon',12,'node',1.27894),('icomore',12,'node',1.34475),('icomoreitems',12,'node',1.14935),('icomorewindows',12,'node',1.40986),('icomove',12,'node',1.34658),('icomute',12,'node',1.35394),('icon',12,'node',15.5025),('iconameplate',12,'node',1.10748),('iconameplatealt',12,'node',1.10626),('iconewwindow',12,'node',1.41188),('iconote',12,'node',1.74524),('iconotes',12,'node',3.39387),('icons',12,'node',27.9085),('icook',12,'node',2.63949),('icooldman',12,'node',1.6968),('icooxygenvottle',12,'node',1.24378),('icopants',12,'node',1.19607),('icoparents',12,'node',1.72675),('icopause',12,'node',1.3689),('icopen',12,'node',1.27077),('icopencil',12,'node',1.70865),('icophone',12,'node',1.4386),('icopiano',12,'node',1.13761),('icopicture',12,'node',1.3979),('icopiechart',12,'node',1.67647),('icopin',12,'node',1.26592),('icopinclassic',12,'node',1.12865),('icopinflag',12,'node',1.12611),('icopizza',12,'node',1.20618),('icoplay',12,'node',1.3708),('icoplaybutton',12,'node',1.29392),('icoplayingdices',12,'node',1.1441),('icoplaylist',12,'node',1.39988),('icopodium',12,'node',1.18895),('icopool',12,'node',1.23149),('icopot',12,'node',1.18053),('icopower',12,'node',1.61835),('icoprint',12,'node',1.75779),('icoprojector',12,'node',1.63726),('icoqrcode',12,'node',1.23454),('icorabbit',12,'node',1.12359),('icorandom',12,'node',1.56672),('icorefresh',12,'node',1.57173),('icoremove',12,'node',4.42295),('icorepeat',12,'node',1.56174),('icoresizefull',12,'node',1.30069),('icoresizesmall',12,'node',1.3024),('icoretweet',12,'node',2.85318),('icorewind',12,'node',1.3727),('icoriflescope',12,'node',1.26431),('icorightarrow',12,'node',1.30754),('icorightindent',12,'node',1.50444),('icoring',12,'node',1.21499),('icoroad',12,'node',1.72067),('icorotationlock',12,'node',1.26271),('icoroundabout',12,'node',1.56922),('icorouter',12,'node',1.66507),('icorugby',12,'node',1.15732),('icoruller',12,'node',1.60512),('icosampler',12,'node',1.1389),('icoscissors',12,'node',1.19037),('icoscreenshot',12,'node',1.34841),('icoscubadiving',12,'node',1.24534),('icosearch',12,'node',1.71765),('icosettings',12,'node',1.20183),('icoshare',12,'node',2.42946),('icosheriffsstar',12,'node',1.23607),('icoshield',12,'node',1.21647),('icoshoppingbag',12,'node',1.10993),('icoshoppingcart',12,'node',1.31971),('icoshowbigthumbnails',12,'node',1.40786),('icoshowlines',12,'node',1.40187),('icoshowthumbnails',12,'node',1.40585),('icoshowthumbnailslines',12,'node',1.40386),('icosignal',12,'node',1.57677),('icosignalalt',12,'node',1.59211),('icoskull',12,'node',1.18754),('icosnorkeldiving',12,'node',1.2469),('icosnowflake',12,'node',1.73594),('icosort',12,'node',1.14803),('icospade',12,'node',1.22846),('icostar',12,'node',1.65663),('icostats',12,'node',1.68223),('icostepbackward',12,'node',1.37652),('icostepforward',12,'node',1.36138),('icostop',12,'node',1.36701),('icostopwatch',12,'node',1.64),('icostroller',12,'node',1.58696),('icosuitcase',12,'node',1.10141),('icosun',12,'node',1.2773),('icosweater',12,'node',1.19464),('icotable',12,'node',1.54943),('icotablet',12,'node',1.20327),('icotabletennis',12,'node',1.15465),('icotag',12,'node',1.61303),('icotags',12,'node',1.61039),('icoteakettle',12,'node',1.18473),('icotemplebuddhist',12,'node',1.16676),('icotemplechurch',12,'node',1.17086),('icotemplehindu',12,'node',1.16812),('icotempleislam',12,'node',1.16949),('icotextbugger',12,'node',1.48853),('icotextheight',12,'node',1.51368),('icotextresize',12,'node',1.50905),('icotextsmaller',12,'node',1.49078),('icotextstrike',12,'node',1.51601),('icotextunderline',12,'node',1.51835),('icotextwidth',12,'node',1.51136),('icothinleftarrow',12,'node',1.28722),('icothinrightarrow',12,'node',1.28888),('icothumbsdown',12,'node',1.11734),('icothumbsup',12,'node',1.11858),('icotie',12,'node',1.14149),('icotint',12,'node',1.54457),('icotrain',12,'node',1.76096),('icotreeconifer',12,'node',1.15199),('icotreedeciduous',12,'node',1.15067),('icotruck',12,'node',1.63181),('icotshirt',12,'node',1.1975),('icoturtle',12,'node',1.12485),('icoumbrella',12,'node',1.59989),('icounlock',12,'node',1.31621),('icounshare',12,'node',1.29224),('icouparrow',12,'node',1.30411),('icoupload',12,'node',1.32146),('icousd',12,'node',1.28224),('icouser',12,'node',1.79659),('icouseradd',12,'node',1.78672),('icovases',12,'node',1.10504),('icovcard',12,'node',1.22544),('icovectorpathall',12,'node',1.52778),('icovectorpathcircle',12,'node',1.53733),('icovectorpathcurve',12,'node',1.53015),('icovectorpathline',12,'node',1.53254),('icovectorpathpolygon',12,'node',1.53493),('icovectorpathsquare',12,'node',1.53973),('icovolumedown',12,'node',1.35025),('icovolumeup',12,'node',1.35209),('icowallet',12,'node',1.1402),('icowarningsign',12,'node',1.57931),('icowebbrowser',12,'node',1.13632),('icowebcam',12,'node',1.17223),('icowifialt',12,'node',1.70271),('icowoman',12,'node',1.69387),('icozoomin',12,'node',1.26915),('icozoomout',12,'node',1.26753),('imperdiet',1,'node',0.923838),('imperdiet',12,'node',1.44144),('imperdiet',14,'node',3),('imperdietaliquam',15,'node',1),('inceptos',12,'node',3),('incidunt',14,'node',2.92344),('information',12,'node',1.68568),('integer',1,'node',1),('integer',2,'node',1),('integer',3,'node',1),('integer',4,'node',1),('integer',5,'node',1),('integer',6,'node',1),('integer',7,'node',1),('integer',8,'node',1),('integer',9,'node',1),('integer',10,'node',1),('integer',11,'node',1),('integer',12,'node',0.76431),('integer',13,'node',9.97),('integer',14,'node',3),('integer',15,'node',1),('interdum',1,'node',1),('interdum',2,'node',1),('interdum',3,'node',1),('inventore',12,'node',3),('ipsum',1,'node',1),('ipsum',2,'node',1),('ipsum',3,'node',1),('ipsum',4,'node',1),('ipsum',5,'node',1),('ipsum',6,'node',1),('ipsum',7,'node',1),('ipsum',8,'node',1),('ipsum',9,'node',1),('ipsum',10,'node',1),('ipsum',11,'node',1),('ipsum',12,'node',15.4321),('ipsum',13,'node',2.97286),('ipsum',14,'node',5.84541),('ipsum',15,'node',3.89111),('isn',15,'node',1),('item',12,'node',3.09675),('jane',14,'node',10),('john',12,'node',0.738408),('john',14,'node',9.76851),('joli',12,'node',7.25286),('justo',1,'node',4.8146),('justo',2,'node',1),('justo',3,'node',1),('justo',12,'node',1.97286),('justo',14,'node',2),('justo',15,'node',1),('kathy',12,'node',0.714225),('keyboard',8,'node',26),('lacinia',1,'node',26.9167),('lacinia',4,'node',3),('lacinia',5,'node',3),('lacinia',6,'node',3),('lacinia',7,'node',3),('lacinia',8,'node',3),('lacinia',9,'node',3),('lacinia',10,'node',3),('lacinia',11,'node',3),('lacinia',12,'node',1),('lacinia',13,'node',4),('laciniato',12,'node',0.776703),('lacus',13,'node',4),('laoreet',1,'node',2.91124),('laoreet',2,'node',1),('laoreet',3,'node',1),('laoreet',12,'node',1.97286),('large',12,'node',11.3265),('last',12,'node',7.21332),('latest',15,'node',1),('layout',15,'node',1),('lectus',1,'node',1),('lectus',2,'node',1),('lectus',3,'node',1),('leo',1,'node',4),('leo',2,'node',4),('leo',3,'node',4),('leo',4,'node',2),('leo',5,'node',2),('leo',6,'node',2),('leo',7,'node',2),('leo',8,'node',2),('leo',9,'node',2),('leo',10,'node',2),('leo',11,'node',2),('leo',12,'node',1.78242),('leo',13,'node',2),('libero',4,'node',1),('libero',5,'node',1),('libero',6,'node',1),('libero',7,'node',1),('libero',8,'node',1),('libero',9,'node',1),('libero',10,'node',1),('libero',11,'node',1),('libero',12,'node',1.60422),('ligula',4,'node',3),('ligula',5,'node',3),('ligula',6,'node',3),('ligula',7,'node',3),('ligula',8,'node',3),('ligula',9,'node',3),('ligula',10,'node',3),('ligula',11,'node',3),('ligula',12,'node',1.52939),('ligula',14,'node',2),('ligula',15,'node',4.89111),('linkedin',12,'node',7.19372),('linkedin',14,'node',32.0667),('list',12,'node',19.9624),('listed',15,'node',1),('litora',12,'node',3),('live',16,'node',7),('llis',12,'node',0.792123),('lobortis',1,'node',1),('lobortis',2,'node',1),('lobortis',3,'node',1),('lobortis',4,'node',1),('lobortis',5,'node',1),('lobortis',6,'node',1),('lobortis',7,'node',1),('lobortis',8,'node',1),('lobortis',9,'node',1),('lobortis',10,'node',1),('lobortis',11,'node',1),('localization',15,'node',1),('log',1,'node',6.17873),('looking',15,'node',1),('lore',13,'node',2.98087),('lorem',1,'node',4),('lorem',2,'node',4),('lorem',3,'node',4),('lorem',4,'node',1),('lorem',5,'node',1),('lorem',6,'node',1),('lorem',7,'node',1),('lorem',8,'node',1),('lorem',9,'node',1),('lorem',10,'node',1),('lorem',11,'node',1),('lorem',12,'node',23.3092),('lorem',13,'node',4.93464),('lorem',14,'node',4.92613),('lorem',15,'node',4.89111),('luctus',1,'node',1.91926),('luctus',4,'node',2),('luctus',5,'node',2),('luctus',6,'node',2),('luctus',7,'node',2),('luctus',8,'node',2),('luctus',9,'node',2),('luctus',10,'node',2),('luctus',11,'node',2),('luctus',12,'node',0.784336),('luctus',13,'node',8.98087),('maecenas',1,'node',24.9849),('maecenas',2,'node',1),('maecenas',3,'node',1),('maecenas',12,'node',0.716357),('maecenas',13,'node',1),('maecenas',14,'node',3),('maecenas',15,'node',2),('magna',1,'node',2),('magna',2,'node',2),('magna',3,'node',2),('magna',12,'node',1.58601),('magna',13,'node',15.97),('magna',14,'node',2),('magna',15,'node',2),('major',15,'node',1),('malesuada',1,'node',1),('malesuada',2,'node',1),('malesuada',3,'node',1),('malesuada',12,'node',0.749958),('malesuada',13,'node',0.993146),('malesuada',14,'node',1),('manager',12,'node',0.718502),('manager',14,'node',1.95723),('maritime',4,'node',26),('marketing',12,'node',14.0214),('marketing',15,'node',15.5658),('massa',1,'node',3.89561),('massa',2,'node',28),('massa',3,'node',2),('massa',12,'node',0.754681),('massa',13,'node',2),('massa',14,'node',1),('mattis',1,'node',1.89561),('mattis',4,'node',2),('mattis',5,'node',2),('mattis',6,'node',2),('mattis',7,'node',2),('mattis',8,'node',2),('mattis',9,'node',2),('mattis',10,'node',2),('mattis',11,'node',2),('mattis',13,'node',0.98493),('mattis',14,'node',1),('mauris',1,'node',7.79508),('mauris',2,'node',4),('mauris',3,'node',4),('mauris',12,'node',1),('mauris',13,'node',6),('mauris',15,'node',3.89111),('meet',14,'node',13),('message',15,'node',1),('methodology',15,'node',13),('metus',1,'node',2.91674),('metus',2,'node',28),('metus',3,'node',2),('metus',4,'node',2),('metus',5,'node',2),('metus',6,'node',2),('metus',7,'node',2),('metus',8,'node',2),('metus',9,'node',2),('metus',10,'node',2),('metus',11,'node',2),('metus',13,'node',10),('michael',12,'node',0.771698),('michael',14,'node',9.61087),('mini',12,'node',9.79855),('miniicoadjust',12,'node',0.528135),('miniicoaligncenter',12,'node',0.539902),('miniicoalignjustify',12,'node',0.537506),('miniicoalignleft',12,'node',0.541108),('miniicoalignright',12,'node',0.538701),('miniicoarrowdown',12,'node',0.494765),('miniicoarrowleft',12,'node',0.497805),('miniicoarrowright',12,'node',0.496787),('miniicoarrowup',12,'node',0.495774),('miniicoasterisk',12,'node',0.488796),('miniicobackward',12,'node',0.519091),('miniicobancircle',12,'node',0.498827),('miniicobarcode',12,'node',0.556022),('miniicobell',12,'node',0.467218),('miniicobold',12,'node',0.545988),('miniicobook',12,'node',0.552215),('miniicobookmark',12,'node',0.550958),('miniicobriefcase',12,'node',0.453319),('miniicobullhorn',12,'node',0.468115),('miniicocalendar',12,'node',0.480114),('miniicocamera',12,'node',0.548462),('miniicocertificate',12,'node',0.466323),('miniicocheck',12,'node',0.523573),('miniicochevrondown',12,'node',0.475426),('miniicochevronleft',12,'node',0.510357),('miniicochevronright',12,'node',0.509287),('miniicochevronup',12,'node',0.476356),('miniicocirclearrowdown',12,'node',0.45757),('miniicocirclearrowleft',12,'node',0.459294),('miniicocirclearrowright',12,'node',0.460161),('miniicocirclearrowup',12,'node',0.45843),('miniicocog',12,'node',0.584241),('miniicocomment',12,'node',0.478227),('miniicodownload',12,'node',0.574516),('miniicodownloadalt',12,'node',0.575885),('miniicoedit',12,'node',0.525844),('miniicoeject',12,'node',0.511433),('miniicoenvelope',12,'node',0.606252),('miniicoexclamationsign',12,'node',0.487816),('miniicoeyeclose',12,'node',0.482973),('miniicoeyeopen',12,'node',0.483934),('miniicofacetimevideo',12,'node',0.532778),('miniicofastbackward',12,'node',0.520204),('miniicofastforward',12,'node',0.513597),('miniicofile',12,'node',0.580033),('miniicofilm',12,'node',0.59873),('miniicofilter',12,'node',0.454162),('miniicofire',12,'node',0.484898),('miniicoflag',12,'node',0.563797),('miniicofolderclose',12,'node',0.472657),('miniicofolderopen',12,'node',0.471741),('miniicofont',12,'node',0.547222),('miniicoforward',12,'node',0.514686),('miniicofullscreen',12,'node',0.452478),('miniicogift',12,'node',0.486839),('miniicoglass',12,'node',0.610858),('miniicoglobe',12,'node',0.456713),('miniicohanddown',12,'node',0.461031),('miniicohandleft',12,'node',0.462781),('miniicohandright',12,'node',0.463662),('miniicohandup',12,'node',0.461904),('miniicohdd',12,'node',0.469016),('miniicoheadphones',12,'node',0.562486),('miniicoheart',12,'node',0.604732),('miniicohome',12,'node',0.581429),('miniicoinbox',12,'node',0.571798),('miniicoindentleft',12,'node',0.535131),('miniicoindentright',12,'node',0.533952),('miniicoinfosign',12,'node',0.502958),('miniicoitalic',12,'node',0.544759),('miniicoleaf',12,'node',0.485867),('miniicolist',12,'node',0.536316),('miniicolistalt',12,'node',0.566439),('miniicolock',12,'node',0.565115),('miniicomagnet',12,'node',0.47729),('miniicomapmarker',12,'node',0.529288),('miniicominus',12,'node',0.489781),('miniicominussign',12,'node',0.507159),('miniicomove',12,'node',0.522445),('miniicomusic',12,'node',0.609315),('miniicooff',12,'node',0.587082),('miniicook',12,'node',0.592848),('miniicookcircle',12,'node',0.499853),('miniicooksign',12,'node',0.50505),('miniicopause',12,'node',0.516879),('miniicopencil',12,'node',0.530446),('miniicopicture',12,'node',0.53161),('miniicoplane',12,'node',0.481063),('miniicoplay',12,'node',0.517983),('miniicoplaycircle',12,'node',0.570448),('miniicoplus',12,'node',0.490769),('miniicoplussign',12,'node',0.508221),('miniicoprint',12,'node',0.549707),('miniicoqrcode',12,'node',0.557303),('miniicoquestionsign',12,'node',0.504001),('miniicorandom',12,'node',0.479169),('miniicorefresh',12,'node',0.567769),('miniicoremove',12,'node',0.591395),('miniicoremovecircle',12,'node',0.500884),('miniicoremovesign',12,'node',0.506102),('miniicorepeat',12,'node',0.569105),('miniicoresizefull',12,'node',0.492759),('miniicoresizehorizontal',12,'node',0.469921),('miniicoresizesmall',12,'node',0.491762),('miniicoresizevertical',12,'node',0.470829),('miniicoretweet',12,'node',0.474499),('miniicoroad',12,'node',0.577261),('miniicoscreenshot',12,'node',0.501918),('miniicosearch',12,'node',0.60778),('miniicoshare',12,'node',0.524706),('miniicosharealt',12,'node',0.49376),('miniicoshoppingcart',12,'node',0.473576),('miniicosignal',12,'node',0.585658),('miniicostar',12,'node',0.60322),('miniicostarempty',12,'node',0.601716),('miniicostepbackward',12,'node',0.521322),('miniicostepforward',12,'node',0.512513),('miniicostop',12,'node',0.51578),('miniicotag',12,'node',0.554747),('miniicotags',12,'node',0.553478),('miniicotasks',12,'node',0.45501),('miniicotextheight',12,'node',0.543537),('miniicotextwidth',12,'node',0.542319),('miniicoth',12,'node',0.595774),('miniicothlarge',12,'node',0.597248),('miniicothlist',12,'node',0.594307),('miniicothumbsdown',12,'node',0.464545),('miniicothumbsup',12,'node',0.465433),('miniicotime',12,'node',0.578643),('miniicotint',12,'node',0.526987),('miniicotrash',12,'node',0.582831),('miniicoupload',12,'node',0.573154),('miniicouser',12,'node',0.600219),('miniicovolumedown',12,'node',0.559882),('miniicovolumeoff',12,'node',0.561181),('miniicovolumeup',12,'node',0.558589),('miniicowarningsign',12,'node',0.482016),('miniicowrench',12,'node',0.45586),('miniicozoomin',12,'node',0.58995),('miniicozoomout',12,'node',0.588512),('minus',12,'node',0.824901),('mode',14,'node',2.92613),('molestie',1,'node',1),('molestie',2,'node',1),('molestie',3,'node',1),('molestie',12,'node',0.863659),('mollis',4,'node',4),('mollis',5,'node',4),('mollis',6,'node',4),('mollis',7,'node',4),('mollis',8,'node',4),('mollis',9,'node',4),('mollis',10,'node',4),('mollis',11,'node',4),('mollis',13,'node',11.9306),('mollis',14,'node',1),('mollis',15,'node',2),('month',16,'node',91),('morbi',1,'node',22.5102),('morbi',12,'node',1),('morbi',13,'node',0.997306),('morbi',14,'node',1),('morbi',15,'node',1),('more',12,'node',7.52097),('music',12,'node',1.74836),('nam',1,'node',2.92384),('nam',2,'node',2),('nam',3,'node',2),('nam',12,'node',1.76068),('nam',13,'node',3),('near',9,'node',26),('nec',1,'node',6),('nec',2,'node',6),('nec',3,'node',32),('nec',4,'node',1),('nec',5,'node',1),('nec',6,'node',1),('nec',7,'node',1),('nec',8,'node',1),('nec',9,'node',1),('nec',10,'node',1),('nec',11,'node',1),('nec',12,'node',1.50938),('nec',13,'node',8.96178),('nec',14,'node',2),('neque',1,'node',2.91674),('neque',2,'node',2),('neque',3,'node',2),('neque',12,'node',2.72517),('neque',13,'node',5.98087),('nibh',12,'node',2.32426),('nibh',13,'node',5),('nibh',14,'node',1),('nibh',15,'node',1),('nisi',4,'node',2),('nisi',5,'node',2),('nisi',6,'node',2),('nisi',7,'node',2),('nisi',8,'node',2),('nisi',9,'node',2),('nisi',10,'node',2),('nisi',11,'node',2),('nisi',12,'node',1.78178),('nisi',13,'node',7.97685),('nisialiquam',13,'node',1),('nisialiquam',14,'node',1),('nisialiquam',15,'node',1),('nisl',1,'node',4),('nisl',2,'node',4),('nisl',3,'node',4),('nisl',12,'node',3.76188),('nisl',13,'node',3),('nisl',14,'node',1),('non',1,'node',9.74753),('non',2,'node',6),('non',3,'node',6),('non',4,'node',4),('non',5,'node',4),('non',6,'node',4),('non',7,'node',4),('non',8,'node',4),('non',9,'node',4),('non',10,'node',4),('non',11,'node',4),('non',12,'node',2.78422),('non',13,'node',4),('non',14,'node',1),('non',15,'node',1),('noneas',14,'node',2.92613),('nonumy',14,'node',1),('nonumy',15,'node',1),('nostra',12,'node',3),('notice',12,'node',12.2932),('now',12,'node',1),('nulla',1,'node',1),('nulla',2,'node',1),('nulla',3,'node',1),('nulla',4,'node',3),('nulla',5,'node',3),('nulla',6,'node',3),('nulla',7,'node',3),('nulla',8,'node',3),('nulla',9,'node',3),('nulla',10,'node',3),('nulla',11,'node',3),('nulla',13,'node',13.97),('nulla',14,'node',2),('nulla',15,'node',4.87604),('nullam',1,'node',2),('nullam',2,'node',2),('nullam',3,'node',2),('nullam',4,'node',2),('nullam',5,'node',2),('nullam',6,'node',2),('nullam',7,'node',2),('nullam',8,'node',2),('nullam',9,'node',2),('nullam',10,'node',2),('nullam',11,'node',2),('nullam',13,'node',5.95772),('numquasa',14,'node',2.92613),('nunc',1,'node',27.3168),('nunc',12,'node',0.892724),('nunc',13,'node',1.99315),('nunc',14,'node',4),('nunc',15,'node',3),('nuncadipiscing',14,'node',1),('nuncadipiscing',15,'node',1),('odio',1,'node',2),('odio',2,'node',2),('odio',3,'node',2),('odio',4,'node',2),('odio',5,'node',2),('odio',6,'node',2),('odio',7,'node',2),('odio',8,'node',2),('odio',9,'node',2),('odio',10,'node',2),('odio',11,'node',2),('odio',12,'node',1.64488),('odio',13,'node',2),('odio',14,'node',3),('odio',15,'node',4.89111),('odiomo',12,'node',0.774192),('offering',14,'node',1),('officer',14,'node',1),('onec',12,'node',0.745294),('oppurtunites',14,'node',1),('orci',1,'node',1),('orci',2,'node',1),('orci',3,'node',1),('orci',12,'node',3),('orem',12,'node',3),('ornare',1,'node',1.9534),('ornare',2,'node',1),('ornare',3,'node',1),('ornare',4,'node',3),('ornare',5,'node',3),('ornare',6,'node',3),('ornare',7,'node',3),('ornare',8,'node',3),('ornare',9,'node',3),('ornare',10,'node',3),('ornare',11,'node',3),('ornare',12,'node',0.747619),('our',14,'node',13),('our',15,'node',12.4439),('pcs',15,'node',1),('pellentesque',1,'node',5),('pellentesque',2,'node',5),('pellentesque',3,'node',5),('pellentesque',4,'node',1),('pellentesque',5,'node',1),('pellentesque',6,'node',1),('pellentesque',7,'node',1),('pellentesque',8,'node',1),('pellentesque',9,'node',1),('pellentesque',10,'node',1),('pellentesque',11,'node',1),('pellentesque',12,'node',2.96188),('pellentesque',13,'node',2),('per',16,'node',91),('perea',12,'node',3),('permalink',1,'node',31.5239),('perspiciatis',12,'node',1.63298),('peter',12,'node',0.722831),('pharetra',4,'node',1),('pharetra',5,'node',1),('pharetra',6,'node',1),('pharetra',7,'node',1),('pharetra',8,'node',1),('pharetra',9,'node',1),('pharetra',10,'node',1),('pharetra',11,'node',1),('pharetra',12,'node',3),('pharetra',13,'node',1),('phasellus',1,'node',1),('phasellus',2,'node',1),('phasellus',3,'node',27),('picasa',12,'node',7.17422),('pine',9,'node',26),('pintrest',12,'node',7.15483),('pintrest',14,'node',10.4874),('placerat',12,'node',1),('please',12,'node',2),('please',15,'node',1),('plus',12,'node',8.08061),('plus',14,'node',21.277),('porta',1,'node',2),('porta',2,'node',2),('porta',3,'node',2),('porta',4,'node',2),('porta',5,'node',2),('porta',6,'node',2),('porta',7,'node',2),('porta',8,'node',2),('porta',9,'node',2),('porta',10,'node',2),('porta',11,'node',2),('porta',12,'node',1.43924),('porta',13,'node',1),('porttitor',4,'node',2),('porttitor',5,'node',2),('porttitor',6,'node',2),('porttitor',7,'node',2),('porttitor',8,'node',2),('porttitor',9,'node',2),('porttitor',10,'node',2),('porttitor',11,'node',2),('porttitor',12,'node',3.14124),('porttitor',13,'node',2),('porttitor',14,'node',1),('porttitor',15,'node',4.86796),('porttitora',12,'node',0.931053),('porttitora',15,'node',3.89111),('post',1,'node',2.80095),('posuere',1,'node',1.92384),('posuere',2,'node',1),('posuere',3,'node',1),('posuere',4,'node',3),('posuere',5,'node',3),('posuere',6,'node',3),('posuere',7,'node',3),('posuere',8,'node',3),('posuere',9,'node',3),('posuere',10,'node',3),('posuere',11,'node',3),('posuere',12,'node',3.95395),('posuere',13,'node',1),('posuere',14,'node',3.92613),('posuere',15,'node',4.89111),('potenti',1,'node',1),('potenti',2,'node',1),('potenti',3,'node',1),('praesent',1,'node',1),('praesent',2,'node',1),('praesent',3,'node',1),('praesent',13,'node',3),('premium',16,'node',32),('pretium',12,'node',1),('pretium',13,'node',2),('pricing',16,'node',26),('professional',16,'node',32),('proin',1,'node',1.91523),('proin',12,'node',0.957226),('proin',13,'node',1),('proin',14,'node',1),('proin',15,'node',4.89111),('project',12,'node',0.72066),('project',14,'node',1.95723),('pulvinar',12,'node',1),('pulvinar',13,'node',4.97685),('pulvinare',12,'node',0.886095),('purus',1,'node',3),('purus',2,'node',3),('purus',3,'node',3),('purus',4,'node',2),('purus',5,'node',2),('purus',6,'node',2),('purus',7,'node',2),('purus',8,'node',2),('purus',9,'node',2),('purus',10,'node',2),('purus',11,'node',2),('purus',12,'node',4.43002),('purus',13,'node',15.9306),('purus',14,'node',1),('purus',15,'node',5.89111),('quam',4,'node',2),('quam',5,'node',2),('quam',6,'node',2),('quam',7,'node',2),('quam',8,'node',2),('quam',9,'node',2),('quam',10,'node',2),('quam',11,'node',2),('quam',12,'node',2.44144),('quam',13,'node',4),('quam',15,'node',3.87198),('quasi',12,'node',3),('quia',14,'node',2.92613),('quiam',14,'node',2.92613),('quick',15,'node',1),('quis',1,'node',4.79508),('quis',2,'node',1),('quis',3,'node',1),('quis',4,'node',2),('quis',5,'node',2),('quis',6,'node',2),('quis',7,'node',2),('quis',8,'node',2),('quis',9,'node',2),('quis',10,'node',2),('quis',11,'node',2),('quis',12,'node',0.866793),('quis',13,'node',4),('quis',14,'node',3),('quis',15,'node',2),('quisque',13,'node',3),('read',12,'node',7.54243),('recording',15,'node',15.3774),('register',1,'node',6.17037),('relax',12,'node',1),('required',12,'node',1),('responsive',15,'node',1),('rhoncus',1,'node',0.927431),('rhoncus',12,'node',1.80309),('rhoncus',13,'node',1),('rhoncus',15,'node',3.89111),('risus',1,'node',3),('risus',2,'node',3),('risus',3,'node',3),('risus',4,'node',2),('risus',5,'node',2),('risus',6,'node',2),('risus',7,'node',2),('risus',8,'node',2),('risus',9,'node',2),('risus',10,'node',2),('risus',11,'node',2),('risus',13,'node',8.97),('risus',14,'node',1),('rss',12,'node',7.13555),('rutrum',1,'node',1),('rutrum',2,'node',1),('rutrum',3,'node',1),('rutrum',12,'node',1.97286),('rutrum',13,'node',2),('rutrum',14,'node',3),('rutrum',15,'node',2),('sadipscing',14,'node',1),('sadipscing',15,'node',1),('sagittis',1,'node',22.3416),('sagittis',13,'node',1),('sapien',1,'node',4),('sapien',2,'node',4),('sapien',3,'node',4),('sapien',12,'node',1.97286),('sapien',14,'node',1),('sat',1,'node',2.86312),('scelerisque',12,'node',1.44365),('scelerisque',13,'node',2.98493),('scelerisque',14,'node',2),('scelerisque',15,'node',1),('security',16,'node',7),('sed',1,'node',13),('sed',2,'node',13),('sed',3,'node',13),('sed',4,'node',3),('sed',5,'node',3),('sed',6,'node',3),('sed',7,'node',3),('sed',8,'node',3),('sed',9,'node',3),('sed',10,'node',3),('sed',11,'node',3),('sed',12,'node',5.65541),('sed',13,'node',7.97286),('sed',14,'node',7.92613),('sed',15,'node',3),('sedeat',12,'node',0.854391),('sem',1,'node',5.83508),('sem',2,'node',3),('sem',3,'node',3),('sem',4,'node',2),('sem',5,'node',2),('sem',6,'node',2),('sem',7,'node',2),('sem',8,'node',2),('sem',9,'node',2),('sem',10,'node',2),('sem',11,'node',2),('sem',12,'node',1.72129),('sem',13,'node',1),('sem',14,'node',1),('sem',15,'node',4.89111),('semper',1,'node',3),('semper',2,'node',3),('semper',3,'node',3),('semper',4,'node',2),('semper',5,'node',2),('semper',6,'node',2),('semper',7,'node',2),('semper',8,'node',2),('semper',9,'node',2),('semper',10,'node',2),('semper',11,'node',2),('semper',12,'node',0.759465),('semper',13,'node',3),('send',15,'node',1),('service',15,'node',1),('services',15,'node',39),('shortcodes',12,'node',26),('sign',16,'node',77),('sit',1,'node',2),('sit',2,'node',2),('sit',3,'node',28),('sit',4,'node',3),('sit',5,'node',3),('sit',6,'node',3),('sit',7,'node',3),('sit',8,'node',3),('sit',9,'node',3),('sit',10,'node',3),('sit',11,'node',3),('sit',12,'node',10.4935),('sit',13,'node',4),('sit',15,'node',3.88842),('skype',12,'node',7.11637),('smartphones',15,'node',1),('smith',14,'node',19.5723),('social',12,'node',24.9816),('social',15,'node',15.6296),('sociosqu',12,'node',3),('sodales',13,'node',2),('sollicitudin',1,'node',2.89561),('sollicitudin',2,'node',1),('sollicitudin',3,'node',1),('sollicitudin',13,'node',2),('spotify',12,'node',7.0973),('square',12,'node',0.813674),('ssim',12,'node',0.938382),('ssim',15,'node',3.89111),('ssl',16,'node',7),('standard',16,'node',32),('standards',15,'node',1),('star',12,'node',0.819249),('storage',16,'node',7),('stumbleupon',12,'node',7.07833),('style',12,'node',0.7017),('styles',12,'node',13.3831),('submitted',1,'node',2.86581),('success',12,'node',1),('sunt',12,'node',3),('support',15,'node',1),('support',16,'node',7),('surfing',7,'node',26),('suscipit',12,'node',0.923838),('suscipit',13,'node',3.99315),('suscipit',14,'node',3),('suscipit',15,'node',5.89111),('suspendisse',1,'node',4),('suspendisse',2,'node',4),('suspendisse',3,'node',4),('tab',12,'node',22),('table',12,'node',10.0803),('tables',16,'node',52),('tablet',15,'node',1),('tabs',12,'node',16),('tabvncom',4,'node',1),('tabvncom',5,'node',1),('tabvncom',6,'node',1),('tabvncom',7,'node',1),('tabvncom',8,'node',1),('tabvncom',9,'node',1),('tabvncom',10,'node',1),('tabvncom',11,'node',1),('taciti',12,'node',3),('team',14,'node',13),('tellus',1,'node',4.79508),('tellus',2,'node',1),('tellus',3,'node',1),('tempor',1,'node',6),('tempor',2,'node',6),('tempor',3,'node',6),('tempora',14,'node',2.92613),('tempus',1,'node',2),('tempus',2,'node',2),('tempus',3,'node',2),('tempus',12,'node',0.889397),('testimonials',12,'node',12.8873),('tetur',14,'node',1),('that',12,'node',1),('the',7,'node',26),('the',12,'node',2),('the',14,'node',13),('the',15,'node',1),('this',12,'node',15.1144),('three',16,'node',13),('time',6,'node',26),('time',16,'node',7),('tincidunt',12,'node',2.76413),('tincidunt',13,'node',2),('tincidunt',15,'node',3.89111),('tooltips',12,'node',16),('torquent',12,'node',3),('tortor',1,'node',1.92384),('tortor',2,'node',1),('tortor',3,'node',1),('tortor',12,'node',1),('tortor',13,'node',0.989021),('tortor',14,'node',1),('tortorea',15,'node',3.89111),('tracking',16,'node',7),('tree',9,'node',26),('tristique',1,'node',1.92384),('tristique',2,'node',1),('tristique',3,'node',1),('tristique',14,'node',2),('tristique',15,'node',1),('try',12,'node',1),('tumblr',12,'node',7.05946),('turpis',12,'node',0.869951),('twitter',12,'node',7.04069),('ugravida',12,'node',0.848323),('ullamcorper',1,'node',1.91124),('ullamcorper',4,'node',1),('ullamcorper',5,'node',1),('ullamcorper',6,'node',1),('ullamcorper',7,'node',1),('ullamcorper',8,'node',1),('ullamcorper',9,'node',1),('ullamcorper',10,'node',1),('ullamcorper',11,'node',1),('ultimate',16,'node',16),('ultrices',1,'node',3),('ultrices',2,'node',3),('ultrices',3,'node',3),('ultrices',12,'node',5.96188),('ultricies',1,'node',2.92384),('ultricies',2,'node',2),('ultricies',3,'node',2),('ultricies',4,'node',1),('ultricies',5,'node',1),('ultricies',6,'node',1),('ultricies',7,'node',1),('ultricies',8,'node',1),('ultricies',9,'node',1),('ultricies',10,'node',1),('ultricies',11,'node',1),('ultricies',12,'node',1),('ultricies',13,'node',3),('unlimited',16,'node',7),('urna',1,'node',1),('urna',2,'node',1),('urna',3,'node',1),('urna',4,'node',2),('urna',5,'node',2),('urna',6,'node',2),('urna',7,'node',2),('urna',8,'node',2),('urna',9,'node',2),('urna',10,'node',2),('urna',11,'node',2),('urna',13,'node',1),('usability',15,'node',16),('users',16,'node',7),('varius',1,'node',2.90336),('varius',2,'node',1),('varius',3,'node',1),('varius',12,'node',11.7384),('varius',14,'node',2),('varius',15,'node',1),('vehicula',4,'node',1),('vehicula',5,'node',1),('vehicula',6,'node',1),('vehicula',7,'node',1),('vehicula',8,'node',1),('vehicula',9,'node',1),('vehicula',10,'node',1),('vehicula',11,'node',1),('vel',1,'node',6.80289),('vel',2,'node',3),('vel',3,'node',3),('vel',4,'node',1),('vel',5,'node',1),('vel',6,'node',1),('vel',7,'node',1),('vel',8,'node',1),('vel',9,'node',1),('vel',10,'node',1),('vel',11,'node',1),('vel',12,'node',2.34089),('vel',13,'node',10.974),('vel',14,'node',5.92613),('vel',15,'node',7.87604),('velit',1,'node',23.4256),('velit',2,'node',1),('velit',3,'node',27),('velit',4,'node',1),('velit',5,'node',1),('velit',6,'node',1),('velit',7,'node',1),('velit',8,'node',1),('velit',9,'node',1),('velit',10,'node',1),('velit',11,'node',1),('velit',12,'node',0.797402),('velit',13,'node',5.98087),('velit',14,'node',5.92613),('velit',15,'node',3),('venenatis',1,'node',3),('venenatis',2,'node',3),('venenatis',3,'node',3),('venenatis',4,'node',2),('venenatis',5,'node',2),('venenatis',6,'node',2),('venenatis',7,'node',2),('venenatis',8,'node',2),('venenatis',9,'node',2),('venenatis',10,'node',2),('venenatis',11,'node',2),('venenatis',12,'node',2.24807),('venenatis',13,'node',6),('veritatis',12,'node',3),('vestibulum',1,'node',2),('vestibulum',2,'node',2),('vestibulum',3,'node',2),('vestibulum',4,'node',3),('vestibulum',5,'node',3),('vestibulum',6,'node',3),('vestibulum',7,'node',3),('vestibulum',8,'node',3),('vestibulum',9,'node',3),('vestibulum',10,'node',3),('vestibulum',11,'node',3),('vestibulum',12,'node',1.49353),('vestibulum',13,'node',4.99315),('vestibulum',14,'node',1),('vestibulum',15,'node',1),('video',15,'node',15.4397),('vimeo',12,'node',7.02203),('vitae',1,'node',3.81588),('vitae',2,'node',1),('vitae',3,'node',1),('vitae',4,'node',1),('vitae',5,'node',1),('vitae',6,'node',1),('vitae',7,'node',1),('vitae',8,'node',1),('vitae',9,'node',1),('vitae',10,'node',1),('vitae',11,'node',1),('vitae',12,'node',6.63487),('vitae',13,'node',16.944),('vitae',14,'node',3),('vitae',15,'node',3),('vivamus',1,'node',4),('vivamus',2,'node',30),('vivamus',3,'node',4),('vivamus',14,'node',1),('viverra',1,'node',1),('viverra',2,'node',1),('viverra',3,'node',1),('volutpat',1,'node',3.91124),('volutpat',2,'node',2),('volutpat',3,'node',2),('volutpat',12,'node',2.7633),('volutpat',13,'node',1),('volutpat',14,'node',2),('volutpat',15,'node',1),('vulputate',1,'node',1),('vulputate',2,'node',1),('vulputate',3,'node',1),('vulputate',12,'node',0.98493),('w3c',15,'node',1),('warning',12,'node',1),('water',9,'node',26),('web',7,'node',26),('web',12,'node',0.736141),('web',14,'node',1.9689),('web',15,'node',31.5025),('website',12,'node',29.9956),('which',15,'node',1),('width',13,'node',26),('wireless',8,'node',26),('with',15,'node',2),('wordpress',12,'node',7.00346),('world',10,'node',26),('xing',12,'node',6.985),('yahoo',12,'node',6.96663),('you',12,'node',1),('you',15,'node',1),('youtube',12,'node',6.94837);
/*!40000 ALTER TABLE `search_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_node_links`
--

DROP TABLE IF EXISTS `search_node_links`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_node_links` (
  `sid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The search_dataset.sid of the searchable item containing the link to the node.',
  `type` varchar(16) NOT NULL DEFAULT '' COMMENT 'The search_dataset.type of the searchable item containing the link to the node.',
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid that this item links to.',
  `caption` longtext COMMENT 'The text used to link to the node.nid.',
  PRIMARY KEY (`sid`,`type`,`nid`),
  KEY `nid` (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores items (like nodes) that link to other nodes, used...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_node_links`
--

LOCK TABLES `search_node_links` WRITE;
/*!40000 ALTER TABLE `search_node_links` DISABLE KEYS */;
/*!40000 ALTER TABLE `search_node_links` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `search_total`
--

DROP TABLE IF EXISTS `search_total`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `search_total` (
  `word` varchar(50) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique word in the search index.',
  `count` float DEFAULT NULL COMMENT 'The count of the word in the index using Zipf’s law to equalize the probability distribution.',
  PRIMARY KEY (`word`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores search totals for words.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `search_total`
--

LOCK TABLES `search_total` WRITE;
/*!40000 ALTER TABLE `search_total` DISABLE KEYS */;
INSERT INTO `search_total` VALUES ('1',0.0175495),('100',0.160167),('12',0.0263289),('13',0.00895484),('14',0.00673338),('16',0.0263289),('1628',0.130425),('2',0.0298382),('200',0.256985),('2022013',0.130262),('25',0.176091),('2999',0.0163904),('3',0.0175529),('300',0.257484),('4',0.0249121),('400',0.257981),('4999',0.0163904),('5',0.140612),('50',0.176091),('500',0.258974),('8',0.013364),('999',0.0163904),('9999',0.0321847),('about',0.0163904),('accordion',0.012965),('accordions',0.0263289),('accumsan',0.0579919),('adipisci',0.127671),('adipiscing',0.0154404),('admin',0.011944),('aenean',0.00772271),('again',0.30103),('aiquam',0.30103),('alert',0.0263289),('aliquam',0.0239164),('aliquet',0.0134779),('all',0.30103),('amazon',0.0545051),('amet',0.00580013),('and',0.0669468),('ante',0.0162425),('aperia',0.148383),('apply',0.0377886),('approach',0.0321847),('aptent',0.124939),('architecto',0.124939),('arcu',0.0324264),('arrow',0.30103),('art',0.30103),('attention',0.30103),('attuned',0.30103),('auctor',0.0299632),('augue',0.0280287),('beatae',0.0732371),('behance',0.0546499),('below',0.176091),('bibendum',0.00936095),('blandit',0.0804874),('blockquote',0.0263289),('blog',0.012965),('blogger',0.0235246),('book',0.211137),('boxes',0.0135984),('browsers',0.30103),('button',0.00653087),('buttons',0.0263289),('calling',0.30103),('canyon',0.00827253),('careers',0.0321847),('ceo',0.30103),('change',0.30103),('check',0.30103),('chief',0.30103),('circle',0.30103),('class',0.124939),('clients',0.0336984),('cloud',0.0562394),('coeammodo',0.30103),('coffee',0.0163904),('column',0.00386042),('columns',0.00541997),('comments',0.13274),('commodo',0.0142782),('compatible',0.176091),('component',0.30103),('condiment',0.09691),('condimentum',0.0147484),('congue',0.0511525),('conse',0.0975029),('consectetur',0.00797975),('consequat',0.0325693),('consetetur',0.176091),('content',0.30103),('conubia',0.124939),('convallis',0.0669468),('convenient',0.30103),('costant',0.30103),('cras',0.0179235),('cross',0.30103),('curabitur',0.13804),('cure',0.0816146),('cursus',0.110658),('dapibus',0.0313364),('description',0.121643),('design',0.0138411),('designer',0.178372),('details',0.0163904),('developer',0.221774),('development',0.0288561),('deviantart',0.0549395),('diam',0.10289),('dicta',0.124939),('dictum',0.0579919),('did',0.30103),('digital',0.0163904),('digni',0.0816721),('dignissim',0.00711903),('director',0.30103),('doe',0.0424927),('dolor',0.00642276),('donec',0.0102612),('dribbble',0.023469),('dropbox',0.0552288),('dui',0.0159034),('duis',0.0204912),('edit',0.30103),('egestas',0.0224333),('eget',0.00982728),('egeteas',0.30103),('elementum',0.0311928),('elit',0.00806163),('elitr',0.176091),('enhanced',0.0579919),('enim',0.0804874),('enjoy',0.30103),('entum',0.0818985),('envato',0.176091),('equat',0.30103),('erat',0.00879401),('eros',0.0161313),('error',0.30103),('est',0.0108943),('etea',0.30103),('euismod',0.00629368),('evernote',0.0553733),('example',0.30103),('executive',0.30103),('explicabo',0.124939),('extra',0.30103),('facebook',0.0108728),('facilisis',0.0585603),('faucibus',0.0511688),('featured',0.30103),('features',0.0321847),('felis',0.0123163),('fermentum',0.0457575),('fermentumnullam',0.0511525),('feugiat',0.0380332),('fields',0.30103),('fill',0.30103),('flash',0.30103),('flexible',0.30103),('folderminus',0.231012),('for',0.136941),('forrst',0.0235181),('four',0.0321847),('free',0.0579919),('fringilla',0.0248236),('full',0.0163904),('fusce',0.0272265),('github',0.0558066),('google',0.0123759),('gorbi',0.0995851),('grand',0.00827253),('gravida',0.0171266),('great',0.30103),('handleft',0.278062),('header',0.145703),('headline',0.0312337),('hendrerit',0.067187),('hiring',0.0222764),('http',0.0511525),('iaculis',0.0203689),('ico',0.0566168),('icoadjust',0.216539),('icoadjustalt',0.223976),('icoadressbook',0.215734),('icoairplane',0.202333),('icoalarm',0.206209),('icoalbums',0.236905),('icoaligncenter',0.221866),('icoalignleft',0.221601),('icoalignright',0.22213),('icoanchor',0.254055),('icoannouncement',0.280109),('icoasterisk',0.255268),('icoattach',0.208681),('icoax',0.270694),('icoban',0.244208),('icobank',0.258885),('icobarcode',0.257924),('icobaseball',0.270229),('icobeachumbrella',0.195027),('icobeer',0.261515),('icobell',0.275086),('icobin',0.195877),('icobinoculars',0.198697),('icobirthdaycake',0.262466),('icoblog',0.274396),('icobluetooth',0.249902),('icoboat',0.25696),('icobold',0.219478),('icobomb',0.26953),('icobookmark',0.211409),('icobookopen',0.2792),('icobowling',0.271159),('icobp',0.250638),('icobriefcase',0.27692),('icobrightnessincrease',0.241957),('icobrightnessreduce',0.241706),('icobrush',0.251862),('icobullets',0.263179),('icobuoy',0.258404),('icobus',0.200379),('icocake',0.261038),('icocalculator',0.273012),('icocalendar',0.203999),('icocamera',0.194459),('icocamerasmall',0.204553),('icocandle',0.275316),('icocar',0.192751),('icocardio',0.263416),('icocargo',0.207859),('icocars',0.199539),('icocartin',0.246198),('icocartout',0.24595),('icocelebratio',0.265543),('icocertificate',0.274856),('icocharts',0.202889),('icochat',0.254541),('icocheck',0.232044),('icocirclearrowleft',0.247931),('icocirclearrowright',0.248178),('icocirclearrowtop',0.248424),('icocircleexclamationmark',0.243709),('icocircleinfo',0.243459),('icocircleminus',0.242458),('icocircleok',0.242959),('icocircleplus',0.242207),('icocirclequestionmark',0.243209),('icocircleremove',0.242709),('icocleaning',0.210048),('icoclock',0.206485),('icocloud',0.251373),('icocoffecup',0.26625),('icocogwheel',0.197008),('icocogwheels',0.198135),('icocomments',0.269763),('icocompass',0.208133),('icocomputerlocked',0.228421),('icocomputerprocess',0.228941),('icocomputerservice',0.228681),('icoconversation',0.254298),('icocredit',0.202054),('icocreditcard',0.259843),('icocrop',0.217075),('icocup',0.211952),('icocutlery',0.261991),('icodashboard',0.274626),('icodatabaseban',0.230237),('icodatabaselock',0.22946),('icodatabaseminus',0.229978),('icodatabaseplus',0.229719),('icodeletepoint',0.257201),('icodirectio',0.251617),('icodislikes',0.204829),('icodisplay',0.215196),('icodivide',0.255511),('icodog',0.191894),('icodownarrow',0.246942),('icodownload',0.244457),('icodownloadalt',0.239944),('icodrink',0.261276),('icodumbbell',0.280335),('icoearplugs',0.236651),('icoedit',0.232301),('icoeject',0.239439),('icoelectircalplug',0.259364),('icoelectricalsocketeu',0.269063),('icoelectricalsocketus',0.269296),('icoelectricity',0.245702),('icoembed',0.223449),('icoembedclose',0.223713),('icoenvelope',0.194175),('icoeuro',0.250147),('icoeyeclose',0.205934),('icoeyeopen',0.205658),('icofabric',0.264363),('icofacetimevideo',0.239692),('icofastbackward',0.237414),('icofastfood',0.261753),('icofastforward',0.238934),('icofemale',0.255026),('icofile',0.201775),('icofileexport',0.281014),('icofileimport',0.280788),('icofilm',0.193606),('icofilter',0.272318),('icofins',0.256478),('icofire',0.197853),('icofishes',0.256719),('icoflag',0.259604),('icoflash',0.253569),('icoflower',0.269996),('icofolderflag',0.231528),('icofolderlock',0.23127),('icofoldernew',0.231786),('icofolderopen',0.230495),('icofolderplus',0.230754),('icofont',0.218945),('icoforward',0.238681),('icofrenchpress',0.266015),('icofullscreen',0.278745),('icogamepad',0.27255),('icogift',0.210593),('icogirl',0.192466),('icoglass',0.191322),('icoglobe',0.276691),('icogooglemaps',0.253812),('icograter',0.26672),('icogroup',0.203444),('icohanddown',0.278518),('icohandright',0.277834),('icohandup',0.27829),('icohdd',0.277149),('icoheadphones',0.212495),('icoheadset',0.212766),('icohearth',0.194743),('icoheat',0.214657),('icohistory',0.20731),('icohome',0.19729),('icohospital',0.26719),('icohospitalh',0.267424),('icoimac',0.23461),('icoinbox',0.226858),('icoinboxin',0.227901),('icoinboxlock',0.22764),('icoinboxminus',0.22738),('icoinboxout',0.228161),('icoinboxplus',0.227119),('icoipad',0.235121),('icoiphone',0.235377),('icoiphoneexchange',0.235887),('icoiphoneshake',0.275775),('icoiphonetransfer',0.235632),('icoipod',0.236142),('icoipodshuffle',0.236397),('icoitalic',0.219212),('icojustify',0.222394),('icokettle',0.266955),('icokeyboardwired',0.260321),('icokeyboardwirelsss',0.260082),('icokeynote',0.208407),('icokeys',0.203722),('icoleaf',0.191608),('icoleather',0.264599),('icoleftarrow',0.246446),('icoleftindent',0.221071),('icolightbulb',0.209228),('icolink',0.205382),('icolist',0.222658),('icolock',0.245204),('icologbook',0.215465),('icoluggage',0.200938),('icomacbook',0.234866),('icomagic',0.193891),('icomagnet',0.216002),('icomale',0.254784),('icomessageban',0.225812),('icomessageempty',0.224501),('icomessageflag',0.226074),('icomessagefull',0.224239),('icomessagein',0.224764),('icomessagelock',0.226336),('icomessageminus',0.225551),('icomessagenew',0.226597),('icomessageout',0.225026),('icomessageplus',0.225289),('icomicrophone',0.267659),('icomoon',0.250883),('icomore',0.241455),('icomoreitems',0.271855),('icomorewindows',0.232815),('icomove',0.241203),('icomute',0.240196),('icon',0.0271481),('iconameplate',0.279428),('iconameplatealt',0.279655),('iconewwindow',0.232558),('iconote',0.196725),('iconotes',0.112152),('icons',0.015289),('icook',0.13952),('icooldman',0.201218),('icooxygenvottle',0.256236),('icopants',0.26389),('icoparents',0.198416),('icopause',0.238175),('icopen',0.252106),('icopencil',0.200099),('icophone',0.2292),('icopiano',0.273935),('icopicture',0.234354),('icopiechart',0.203167),('icopin',0.252838),('icopinclassic',0.275546),('icopinflag',0.276004),('icopizza',0.262229),('icoplay',0.237921),('icoplaybutton',0.248671),('icoplayingdices',0.272781),('icoplaylist',0.234098),('icopodium',0.265072),('icopool',0.258164),('icopot',0.266485),('icopower',0.208955),('icoprint',0.195594),('icoprojector',0.207035),('icoqrcode',0.257683),('icorabbit',0.276463),('icorandom',0.214387),('icorefresh',0.213848),('icoremove',0.0885235),('icorepeat',0.214926),('icoresizefull',0.247684),('icoresizesmall',0.247437),('icoretweet',0.13049),('icorewind',0.237667),('icoriflescope',0.253082),('icorightarrow',0.246694),('icorightindent',0.221336),('icoring',0.260799),('icoroad',0.198978),('icorotationlock',0.253326),('icoroundabout',0.214118),('icorouter',0.204276),('icorugby',0.270461),('icoruller',0.21032),('icosampler',0.273705),('icoscissors',0.264836),('icoscreenshot',0.240952),('icoscubadiving',0.255994),('icosearch',0.199259),('icosettings',0.262941),('icoshare',0.149716),('icosheriffsstar',0.257442),('icoshield',0.26056),('icoshoppingbag',0.278973),('icoshoppingcart',0.244956),('icoshowbigthumbnails',0.233072),('icoshowlines',0.233842),('icoshowthumbnails',0.233329),('icoshowthumbnailslines',0.233586),('icosignal',0.213307),('icosignalalt',0.211681),('icoskull',0.265308),('icosnorkeldiving',0.255753),('icosnowflake',0.197572),('icosort',0.272087),('icospade',0.258645),('icostar',0.205106),('icostats',0.202611),('icostepbackward',0.23716),('icostepforward',0.239187),('icostop',0.238428),('icostopwatch',0.20676),('icostroller',0.212224),('icosuitcase',0.280562),('icosun',0.251128),('icosweater',0.264126),('icotable',0.216271),('icotablet',0.262704),('icotabletennis',0.270926),('icotag',0.209502),('icotags',0.209775),('icoteakettle',0.265779),('icotemplebuddhist',0.268829),('icotemplechurch',0.268128),('icotemplehindu',0.268595),('icotempleislam',0.268362),('icotextbugger',0.223186),('icotextheight',0.220275),('icotextresize',0.220806),('icotextsmaller',0.222922),('icotextstrike',0.22001),('icotextunderline',0.219744),('icotextwidth',0.220541),('icothinleftarrow',0.249656),('icothinrightarrow',0.24941),('icothumbsdown',0.277606),('icothumbsup',0.277377),('icotie',0.273243),('icotint',0.216807),('icotrain',0.195311),('icotreeconifer',0.271391),('icotreedeciduous',0.271623),('icotruck',0.207585),('icotshirt',0.263653),('icoturtle',0.276233),('icoumbrella',0.210865),('icounlock',0.245453),('icounshare',0.248917),('icouparrow',0.247189),('icoupload',0.244707),('icousd',0.250393),('icouser',0.19218),('icouseradd',0.193036),('icovases',0.279882),('icovcard',0.259124),('icovectorpathall',0.218679),('icovectorpathcircle',0.21761),('icovectorpathcurve',0.218412),('icovectorpathline',0.218145),('icovectorpathpolygon',0.217878),('icovectorpathsquare',0.217343),('icovolumedown',0.2407),('icovolumeup',0.240448),('icowallet',0.273474),('icowarningsign',0.213036),('icowebbrowser',0.274166),('icowebcam',0.267893),('icowifialt',0.200659),('icowoman',0.201497),('icozoomin',0.252351),('icozoomout',0.252595),('imperdiet',0.0742252),('imperdietaliquam',0.30103),('inceptos',0.124939),('incidunt',0.127773),('information',0.20228),('integer',0.0165565),('interdum',0.124939),('inventore',0.124939),('ipsum',0.0109561),('isn',0.30103),('item',0.121533),('jane',0.0413927),('john',0.0394837),('joli',0.0560952),('justo',0.035364),('kathy',0.30103),('keyboard',0.0163904),('lacinia',0.00769817),('laciniato',0.30103),('lacus',0.09691),('laoreet',0.0589049),('large',0.036744),('last',0.0563835),('latest',0.30103),('layout',0.30103),('lectus',0.124939),('leo',0.013454),('libero',0.0430166),('ligula',0.0131932),('linkedin',0.0109234),('list',0.0212282),('listed',0.30103),('litora',0.124939),('live',0.0579919),('llis',0.30103),('lobortis',0.0377886),('localization',0.30103),('log',0.0651484),('looking',0.30103),('lore',0.125635),('lorem',0.00741627),('luctus',0.0154106),('maecenas',0.0126991),('magna',0.0154812),('major',0.30103),('malesuada',0.0697132),('manager',0.137901),('maritime',0.0163904),('marketing',0.0144359),('massa',0.0113844),('mattis',0.0213136),('mauris',0.0159766),('meet',0.0321847),('message',0.30103),('methodology',0.0321847),('metus',0.00730947),('michael',0.0399355),('mini',0.0422036),('miniicoadjust',0.30103),('miniicoaligncenter',0.30103),('miniicoalignjustify',0.30103),('miniicoalignleft',0.30103),('miniicoalignright',0.30103),('miniicoarrowdown',0.30103),('miniicoarrowleft',0.30103),('miniicoarrowright',0.30103),('miniicoarrowup',0.30103),('miniicoasterisk',0.30103),('miniicobackward',0.30103),('miniicobancircle',0.30103),('miniicobarcode',0.30103),('miniicobell',0.30103),('miniicobold',0.30103),('miniicobook',0.30103),('miniicobookmark',0.30103),('miniicobriefcase',0.30103),('miniicobullhorn',0.30103),('miniicocalendar',0.30103),('miniicocamera',0.30103),('miniicocertificate',0.30103),('miniicocheck',0.30103),('miniicochevrondown',0.30103),('miniicochevronleft',0.30103),('miniicochevronright',0.30103),('miniicochevronup',0.30103),('miniicocirclearrowdown',0.30103),('miniicocirclearrowleft',0.30103),('miniicocirclearrowright',0.30103),('miniicocirclearrowup',0.30103),('miniicocog',0.30103),('miniicocomment',0.30103),('miniicodownload',0.30103),('miniicodownloadalt',0.30103),('miniicoedit',0.30103),('miniicoeject',0.30103),('miniicoenvelope',0.30103),('miniicoexclamationsign',0.30103),('miniicoeyeclose',0.30103),('miniicoeyeopen',0.30103),('miniicofacetimevideo',0.30103),('miniicofastbackward',0.30103),('miniicofastforward',0.30103),('miniicofile',0.30103),('miniicofilm',0.30103),('miniicofilter',0.30103),('miniicofire',0.30103),('miniicoflag',0.30103),('miniicofolderclose',0.30103),('miniicofolderopen',0.30103),('miniicofont',0.30103),('miniicoforward',0.30103),('miniicofullscreen',0.30103),('miniicogift',0.30103),('miniicoglass',0.30103),('miniicoglobe',0.30103),('miniicohanddown',0.30103),('miniicohandleft',0.30103),('miniicohandright',0.30103),('miniicohandup',0.30103),('miniicohdd',0.30103),('miniicoheadphones',0.30103),('miniicoheart',0.30103),('miniicohome',0.30103),('miniicoinbox',0.30103),('miniicoindentleft',0.30103),('miniicoindentright',0.30103),('miniicoinfosign',0.30103),('miniicoitalic',0.30103),('miniicoleaf',0.30103),('miniicolist',0.30103),('miniicolistalt',0.30103),('miniicolock',0.30103),('miniicomagnet',0.30103),('miniicomapmarker',0.30103),('miniicominus',0.30103),('miniicominussign',0.30103),('miniicomove',0.30103),('miniicomusic',0.30103),('miniicooff',0.30103),('miniicook',0.30103),('miniicookcircle',0.30103),('miniicooksign',0.30103),('miniicopause',0.30103),('miniicopencil',0.30103),('miniicopicture',0.30103),('miniicoplane',0.30103),('miniicoplay',0.30103),('miniicoplaycircle',0.30103),('miniicoplus',0.30103),('miniicoplussign',0.30103),('miniicoprint',0.30103),('miniicoqrcode',0.30103),('miniicoquestionsign',0.30103),('miniicorandom',0.30103),('miniicorefresh',0.30103),('miniicoremove',0.30103),('miniicoremovecircle',0.30103),('miniicoremovesign',0.30103),('miniicorepeat',0.30103),('miniicoresizefull',0.30103),('miniicoresizehorizontal',0.30103),('miniicoresizesmall',0.30103),('miniicoresizevertical',0.30103),('miniicoretweet',0.30103),('miniicoroad',0.30103),('miniicoscreenshot',0.30103),('miniicosearch',0.30103),('miniicoshare',0.30103),('miniicosharealt',0.30103),('miniicoshoppingcart',0.30103),('miniicosignal',0.30103),('miniicostar',0.30103),('miniicostarempty',0.30103),('miniicostepbackward',0.30103),('miniicostepforward',0.30103),('miniicostop',0.30103),('miniicotag',0.30103),('miniicotags',0.30103),('miniicotasks',0.30103),('miniicotextheight',0.30103),('miniicotextwidth',0.30103),('miniicoth',0.30103),('miniicothlarge',0.30103),('miniicothlist',0.30103),('miniicothumbsdown',0.30103),('miniicothumbsup',0.30103),('miniicotime',0.30103),('miniicotint',0.30103),('miniicotrash',0.30103),('miniicoupload',0.30103),('miniicouser',0.30103),('miniicovolumedown',0.30103),('miniicovolumeoff',0.30103),('miniicovolumeup',0.30103),('miniicowarningsign',0.30103),('miniicowrench',0.30103),('miniicozoomin',0.30103),('miniicozoomout',0.30103),('minus',0.30103),('mode',0.127671),('molestie',0.0999643),('mollis',0.00915676),('month',0.00474644),('morbi',0.0160823),('more',0.0542152),('music',0.196443),('nam',0.0356632),('near',0.0163904),('nec',0.00668455),('neque',0.0269453),('nibh',0.0442446),('nisi',0.0165411),('nisialiquam',0.124939),('nisl',0.0214384),('non',0.00689024),('noneas',0.127671),('nonumy',0.176091),('nostra',0.124939),('notice',0.0339646),('now',0.30103),('nulla',0.00898336),('nullam',0.0152626),('numquasa',0.127671),('nunc',0.0115196),('nuncadipiscing',0.176091),('odio',0.0127608),('odiomo',0.30103),('offering',0.30103),('officer',0.30103),('onec',0.30103),('oppurtunites',0.30103),('orci',0.0669468),('orem',0.124939),('ornare',0.014874),('our',0.0167418),('pcs',0.30103),('pellentesque',0.0152604),('per',0.00474644),('perea',0.124939),('permalink',0.0135627),('perspiciatis',0.207467),('peter',0.30103),('pharetra',0.0347621),('phasellus',0.0147233),('picasa',0.0566716),('pine',0.0163904),('pintrest',0.0239444),('placerat',0.30103),('please',0.124939),('plus',0.0145469),('porta',0.0174164),('porttitor',0.015789),('porttitora',0.0818425),('post',0.132587),('posuere',0.010293),('potenti',0.124939),('praesent',0.0669468),('premium',0.013364),('pretium',0.124939),('pricing',0.0163904),('professional',0.013364),('proin',0.0423477),('project',0.137806),('pulvinar',0.067187),('pulvinare',0.30103),('purus',0.00823305),('quam',0.0161988),('quasi',0.124939),('quia',0.127671),('quiam',0.127671),('quick',0.30103),('quis',0.0130972),('quisque',0.124939),('read',0.0540701),('recording',0.0273621),('register',0.0652303),('relax',0.30103),('required',0.30103),('responsive',0.30103),('rhoncus',0.0535415),('risus',0.0122448),('rss',0.0569595),('rutrum',0.0348378),('sadipscing',0.176091),('sagittis',0.0182185),('sapien',0.0280779),('sat',0.130099),('scelerisque',0.0548486),('security',0.0579919),('sed',0.00493217),('sedeat',0.30103),('sem',0.0117551),('semper',0.0148443),('send',0.30103),('service',0.30103),('services',0.0109954),('shortcodes',0.0163904),('sign',0.00560388),('sit',0.00579981),('skype',0.0571033),('smartphones',0.30103),('smith',0.021641),('social',0.0105644),('sociosqu',0.124939),('sodales',0.176091),('sollicitudin',0.058813),('spotify',0.0572471),('square',0.30103),('ssim',0.0817293),('ssl',0.0579919),('standard',0.013364),('standards',0.30103),('star',0.30103),('storage',0.0579919),('stumbleupon',0.0573908),('style',0.30103),('styles',0.0312957),('submitted',0.129993),('success',0.30103),('sunt',0.124939),('support',0.0511525),('surfing',0.0163904),('suscipit',0.0303654),('suspendisse',0.0347621),('tab',0.0193052),('table',0.0410781),('tables',0.00827253),('tablet',0.30103),('tabs',0.0263289),('tabvncom',0.0511525),('taciti',0.124939),('team',0.0321847),('tellus',0.059626),('tempor',0.0234811),('tempora',0.127671),('tempus',0.0588626),('testimonials',0.0324559),('tetur',0.30103),('that',0.30103),('the',0.0102192),('this',0.0278232),('three',0.0321847),('time',0.012965),('tincidunt',0.0474839),('tooltips',0.0263289),('torquent',0.124939),('tortor',0.0586757),('tortorea',0.0993339),('tracking',0.0579919),('tree',0.0163904),('tristique',0.0585887),('try',0.30103),('tumblr',0.0575345),('turpis',0.30103),('twitter',0.0576781),('ugravida',0.30103),('ullamcorper',0.0417461),('ultimate',0.0263289),('ultrices',0.0280979),('ultricies',0.0223638),('unlimited',0.0579919),('urna',0.0211893),('usability',0.0263289),('users',0.0579919),('varius',0.0215663),('vehicula',0.0511525),('vel',0.00896964),('velit',0.00574244),('venenatis',0.0128697),('veritatis',0.124939),('vestibulum',0.0111402),('video',0.0272551),('vimeo',0.0578216),('vitae',0.00989442),('vivamus',0.0109954),('viverra',0.124939),('volutpat',0.0286303),('vulputate',0.0972384),('w3c',0.30103),('warning',0.30103),('water',0.0163904),('web',0.00715405),('website',0.0142425),('which',0.30103),('width',0.0163904),('wireless',0.0163904),('with',0.176091),('wordpress',0.0579651),('world',0.0163904),('xing',0.0581085),('yahoo',0.0582519),('you',0.176091),('youtube',0.0583952);
/*!40000 ALTER TABLE `search_total` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `semaphore`
--

DROP TABLE IF EXISTS `semaphore`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `semaphore` (
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Primary Key: Unique name.',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT 'A value for the semaphore.',
  `expire` double NOT NULL COMMENT 'A Unix timestamp with microseconds indicating when the semaphore should expire.',
  PRIMARY KEY (`name`),
  KEY `value` (`value`),
  KEY `expire` (`expire`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table for holding semaphores, locks, flags, etc. that...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `semaphore`
--

LOCK TABLES `semaphore` WRITE;
/*!40000 ALTER TABLE `semaphore` DISABLE KEYS */;
/*!40000 ALTER TABLE `semaphore` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sequences`
--

DROP TABLE IF EXISTS `sequences`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sequences` (
  `value` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'The value of the sequence.',
  PRIMARY KEY (`value`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8 COMMENT='Stores IDs.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sequences`
--

LOCK TABLES `sequences` WRITE;
/*!40000 ALTER TABLE `sequences` DISABLE KEYS */;
INSERT INTO `sequences` VALUES (3);
/*!40000 ALTER TABLE `sequences` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sessions`
--

DROP TABLE IF EXISTS `sessions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sessions` (
  `uid` int(10) unsigned NOT NULL COMMENT 'The users.uid corresponding to a session, or 0 for anonymous user.',
  `sid` varchar(128) NOT NULL COMMENT 'A session ID. The value is generated by Drupal’s session handlers.',
  `ssid` varchar(128) NOT NULL DEFAULT '' COMMENT 'Secure session ID. The value is generated by Drupal’s session handlers.',
  `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'The IP address that last used this session ID (sid).',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when this session last requested a page. Old records are purged by PHP automatically.',
  `cache` int(11) NOT NULL DEFAULT '0' COMMENT 'The time of this user’s last post. This is used when the site has specified a minimum_cache_lifetime. See cache_get().',
  `session` longblob COMMENT 'The serialized contents of $_SESSION, an array of name/value pairs that persists across page requests by this session ID. Drupal loads $_SESSION from here at the start of each request and saves it at the end.',
  PRIMARY KEY (`sid`,`ssid`),
  KEY `timestamp` (`timestamp`),
  KEY `uid` (`uid`),
  KEY `ssid` (`ssid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Drupal’s session handlers read and write into the...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sessions`
--

LOCK TABLES `sessions` WRITE;
/*!40000 ALTER TABLE `sessions` DISABLE KEYS */;
INSERT INTO `sessions` VALUES (1,'u12HtzIu8S06dgVlGqXydgWyYlfScZ3raBwrrc4Xtpc','','127.0.0.1',1362623493,0,'imce_directory|s:1:\".\";');
/*!40000 ALTER TABLE `sessions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shortcut_set`
--

DROP TABLE IF EXISTS `shortcut_set`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shortcut_set` (
  `set_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'Primary Key: The menu_links.menu_name under which the set’s links are stored.',
  `title` varchar(255) NOT NULL DEFAULT '' COMMENT 'The title of the set.',
  PRIMARY KEY (`set_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores information about sets of shortcuts links.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shortcut_set`
--

LOCK TABLES `shortcut_set` WRITE;
/*!40000 ALTER TABLE `shortcut_set` DISABLE KEYS */;
INSERT INTO `shortcut_set` VALUES ('shortcut-set-1','Default');
/*!40000 ALTER TABLE `shortcut_set` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shortcut_set_users`
--

DROP TABLE IF EXISTS `shortcut_set_users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `shortcut_set_users` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid for this set.',
  `set_name` varchar(32) NOT NULL DEFAULT '' COMMENT 'The shortcut_set.set_name that will be displayed for this user.',
  PRIMARY KEY (`uid`),
  KEY `set_name` (`set_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maps users to shortcut sets.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `shortcut_set_users`
--

LOCK TABLES `shortcut_set_users` WRITE;
/*!40000 ALTER TABLE `shortcut_set_users` DISABLE KEYS */;
/*!40000 ALTER TABLE `shortcut_set_users` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `system`
--

DROP TABLE IF EXISTS `system`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `system` (
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT 'The path of the primary file for this item, relative to the Drupal root; e.g. modules/node/node.module.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The name of the item; e.g. node.',
  `type` varchar(12) NOT NULL DEFAULT '' COMMENT 'The type of the item, either module, theme, or theme_engine.',
  `owner` varchar(255) NOT NULL DEFAULT '' COMMENT 'A theme’s ’parent’ . Can be either a theme or an engine.',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether or not this item is enabled.',
  `bootstrap` int(11) NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether this module is loaded during Drupal’s early bootstrapping phase (e.g. even before the page cache is consulted).',
  `schema_version` smallint(6) NOT NULL DEFAULT '-1' COMMENT 'The module’s database schema version number. -1 if the module is not installed (its tables do not exist); 0 or the largest N of the module’s hook_update_N() function that has either been run or existed when the module was first installed.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The order in which this module’s hooks should be invoked relative to other modules. Equal-weighted modules are ordered by name.',
  `info` blob COMMENT 'A serialized array containing information from the module’s .info file; keys can include name, description, package, version, core, dependencies, and php.',
  PRIMARY KEY (`filename`),
  KEY `system_list` (`status`,`bootstrap`,`type`,`weight`,`name`),
  KEY `type_name` (`type`,`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='A list of all modules, themes, and theme engines that are...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `system`
--

LOCK TABLES `system` WRITE;
/*!40000 ALTER TABLE `system` DISABLE KEYS */;
INSERT INTO `system` VALUES ('modules/aggregator/aggregator.module','aggregator','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:10:\"Aggregator\";s:11:\"description\";s:57:\"Aggregates syndicated content (RSS, RDF, and Atom feeds).\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"aggregator.test\";}s:9:\"configure\";s:41:\"admin/config/services/aggregator/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:14:\"aggregator.css\";s:33:\"modules/aggregator/aggregator.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/aggregator/tests/aggregator_test.module','aggregator_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:23:\"Aggregator module tests\";s:11:\"description\";s:46:\"Support module for aggregator related testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/block/block.module','block','module','',1,0,7008,-5,'a:12:{s:4:\"name\";s:5:\"Block\";s:11:\"description\";s:140:\"Controls the visual building blocks a page is constructed with. Blocks are boxes of content rendered into an area, or region, of a web page.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"block.test\";}s:9:\"configure\";s:21:\"admin/structure/block\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/block/tests/block_test.module','block_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Block test\";s:11:\"description\";s:21:\"Provides test blocks.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/blog/blog.module','blog','module','',1,0,0,0,'a:11:{s:4:\"name\";s:4:\"Blog\";s:11:\"description\";s:25:\"Enables multi-user blogs.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"blog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/book/book.module','book','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:4:\"Book\";s:11:\"description\";s:66:\"Allows users to create and organize related content in an outline.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"book.test\";}s:9:\"configure\";s:27:\"admin/content/book/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"book.css\";s:21:\"modules/book/book.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/color/color.module','color','module','',1,0,7001,0,'a:11:{s:4:\"name\";s:5:\"Color\";s:11:\"description\";s:70:\"Allows administrators to change the color scheme of compatible themes.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"color.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/comment/comment.module','comment','module','',1,0,7009,0,'a:13:{s:4:\"name\";s:7:\"Comment\";s:11:\"description\";s:57:\"Allows users to comment on and discuss published content.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"text\";}s:5:\"files\";a:2:{i:0;s:14:\"comment.module\";i:1;s:12:\"comment.test\";}s:9:\"configure\";s:21:\"admin/content/comment\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:11:\"comment.css\";s:27:\"modules/comment/comment.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/contact/contact.module','contact','module','',1,0,7003,0,'a:12:{s:4:\"name\";s:7:\"Contact\";s:11:\"description\";s:61:\"Enables the use of both personal and site-wide contact forms.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"contact.test\";}s:9:\"configure\";s:23:\"admin/structure/contact\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/contextual/contextual.module','contextual','module','',1,0,0,0,'a:11:{s:4:\"name\";s:16:\"Contextual links\";s:11:\"description\";s:75:\"Provides contextual links to perform actions related to elements on a page.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"contextual.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/dashboard/dashboard.module','dashboard','module','',1,0,0,0,'a:12:{s:4:\"name\";s:9:\"Dashboard\";s:11:\"description\";s:136:\"Provides a dashboard page in the administrative interface for organizing administrative tasks and tracking information within your site.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:5:\"files\";a:1:{i:0;s:14:\"dashboard.test\";}s:12:\"dependencies\";a:1:{i:0;s:5:\"block\";}s:9:\"configure\";s:25:\"admin/dashboard/customize\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/dblog/dblog.module','dblog','module','',1,1,7001,0,'a:11:{s:4:\"name\";s:16:\"Database logging\";s:11:\"description\";s:47:\"Logs and records system events to the database.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"dblog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/field.module','field','module','',1,0,7002,0,'a:13:{s:4:\"name\";s:5:\"Field\";s:11:\"description\";s:57:\"Field API to add fields to entities like nodes and users.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:12:\"field.module\";i:1;s:16:\"field.attach.inc\";i:2;s:16:\"tests/field.test\";}s:12:\"dependencies\";a:1:{i:0;s:17:\"field_sql_storage\";}s:8:\"required\";b:1;s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:15:\"theme/field.css\";s:29:\"modules/field/theme/field.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/modules/field_sql_storage/field_sql_storage.module','field_sql_storage','module','',1,0,7002,0,'a:12:{s:4:\"name\";s:17:\"Field SQL storage\";s:11:\"description\";s:37:\"Stores field data in an SQL database.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:22:\"field_sql_storage.test\";}s:8:\"required\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/modules/list/list.module','list','module','',1,0,7002,0,'a:11:{s:4:\"name\";s:4:\"List\";s:11:\"description\";s:69:\"Defines list field types. Use with Options to create selection lists.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:5:\"field\";i:1;s:7:\"options\";}s:5:\"files\";a:1:{i:0;s:15:\"tests/list.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/modules/list/tests/list_test.module','list_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:9:\"List test\";s:11:\"description\";s:41:\"Support module for the List module tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/field/modules/number/number.module','number','module','',1,0,0,0,'a:11:{s:4:\"name\";s:6:\"Number\";s:11:\"description\";s:28:\"Defines numeric field types.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:11:\"number.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/modules/options/options.module','options','module','',1,0,0,0,'a:11:{s:4:\"name\";s:7:\"Options\";s:11:\"description\";s:82:\"Defines selection, check box and radio button widgets for text and numeric fields.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:12:\"options.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field/modules/text/text.module','text','module','',1,0,7000,0,'a:13:{s:4:\"name\";s:4:\"Text\";s:11:\"description\";s:32:\"Defines simple text field types.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:9:\"text.test\";}s:8:\"required\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}'),('modules/field/tests/field_test.module','field_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:14:\"Field API Test\";s:11:\"description\";s:39:\"Support module for the Field API tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:5:\"files\";a:1:{i:0;s:21:\"field_test.entity.inc\";}s:7:\"version\";s:4:\"7.21\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/field_ui/field_ui.module','field_ui','module','',1,0,0,0,'a:11:{s:4:\"name\";s:8:\"Field UI\";s:11:\"description\";s:33:\"User interface for the Field API.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:13:\"field_ui.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/file/file.module','file','module','',1,0,0,0,'a:11:{s:4:\"name\";s:4:\"File\";s:11:\"description\";s:26:\"Defines a file field type.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"field\";}s:5:\"files\";a:1:{i:0;s:15:\"tests/file.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/file/tests/file_module_test.module','file_module_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:9:\"File test\";s:11:\"description\";s:53:\"Provides hooks for testing File module functionality.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/filter/filter.module','filter','module','',1,0,7010,0,'a:13:{s:4:\"name\";s:6:\"Filter\";s:11:\"description\";s:43:\"Filters content in preparation for display.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"filter.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:28:\"admin/config/content/formats\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/forum/forum.module','forum','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:5:\"Forum\";s:11:\"description\";s:27:\"Provides discussion forums.\";s:12:\"dependencies\";a:2:{i:0;s:8:\"taxonomy\";i:1;s:7:\"comment\";}s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"forum.test\";}s:9:\"configure\";s:21:\"admin/structure/forum\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:9:\"forum.css\";s:23:\"modules/forum/forum.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/help/help.module','help','module','',1,0,0,0,'a:11:{s:4:\"name\";s:4:\"Help\";s:11:\"description\";s:35:\"Manages the display of online help.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"help.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/image/image.module','image','module','',1,0,7004,0,'a:14:{s:4:\"name\";s:5:\"Image\";s:11:\"description\";s:34:\"Provides image manipulation tools.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:4:\"file\";}s:5:\"files\";a:1:{i:0;s:10:\"image.test\";}s:9:\"configure\";s:31:\"admin/config/media/image-styles\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}'),('modules/image/tests/image_module_test.module','image_module_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Image test\";s:11:\"description\";s:69:\"Provides hook implementations for testing Image module functionality.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:24:\"image_module_test.module\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/locale/locale.module','locale','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:6:\"Locale\";s:11:\"description\";s:119:\"Adds language handling functionality and enables the translation of the user interface to languages other than English.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"locale.test\";}s:9:\"configure\";s:30:\"admin/config/regional/language\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/locale/tests/locale_test.module','locale_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Locale Test\";s:11:\"description\";s:42:\"Support module for the locale layer tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/menu/menu.module','menu','module','',1,0,7003,0,'a:12:{s:4:\"name\";s:4:\"Menu\";s:11:\"description\";s:60:\"Allows administrators to customize the site navigation menu.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"menu.test\";}s:9:\"configure\";s:20:\"admin/structure/menu\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/node/node.module','node','module','',1,0,7013,0,'a:14:{s:4:\"name\";s:4:\"Node\";s:11:\"description\";s:66:\"Allows content to be submitted to the site and displayed on pages.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:11:\"node.module\";i:1;s:9:\"node.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:21:\"admin/structure/types\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"node.css\";s:21:\"modules/node/node.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/node/tests/node_access_test.module','node_access_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:24:\"Node module access tests\";s:11:\"description\";s:43:\"Support module for node permission testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/node/tests/node_test.module','node_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Node module tests\";s:11:\"description\";s:40:\"Support module for node related testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/node/tests/node_test_exception.module','node_test_exception','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:27:\"Node module exception tests\";s:11:\"description\";s:50:\"Support module for node related exception testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/openid/openid.module','openid','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:6:\"OpenID\";s:11:\"description\";s:48:\"Allows users to log into your site using OpenID.\";s:7:\"version\";s:4:\"7.21\";s:7:\"package\";s:4:\"Core\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"openid.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/openid/tests/openid_test.module','openid_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:21:\"OpenID dummy provider\";s:11:\"description\";s:33:\"OpenID provider used for testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"openid\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/overlay/overlay.module','overlay','module','',1,1,0,0,'a:11:{s:4:\"name\";s:7:\"Overlay\";s:11:\"description\";s:59:\"Displays the Drupal administration interface in an overlay.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/path/path.module','path','module','',1,0,0,0,'a:12:{s:4:\"name\";s:4:\"Path\";s:11:\"description\";s:28:\"Allows users to rename URLs.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"path.test\";}s:9:\"configure\";s:24:\"admin/config/search/path\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/php/php.module','php','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:10:\"PHP filter\";s:11:\"description\";s:50:\"Allows embedded PHP code/snippets to be evaluated.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:8:\"php.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/poll/poll.module','poll','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:4:\"Poll\";s:11:\"description\";s:95:\"Allows your site to capture votes on different topics in the form of multiple choice questions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:9:\"poll.test\";}s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"poll.css\";s:21:\"modules/poll/poll.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/profile/profile.module','profile','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:7:\"Profile\";s:11:\"description\";s:36:\"Supports configurable user profiles.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"profile.test\";}s:9:\"configure\";s:27:\"admin/config/people/profile\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/rdf/rdf.module','rdf','module','',1,0,0,0,'a:11:{s:4:\"name\";s:3:\"RDF\";s:11:\"description\";s:148:\"Enriches your content with metadata to let other applications (e.g. search engines, aggregators) better understand its relationships and attributes.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:8:\"rdf.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/rdf/tests/rdf_test.module','rdf_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:16:\"RDF module tests\";s:11:\"description\";s:38:\"Support module for RDF module testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/search/search.module','search','module','',1,0,7000,0,'a:13:{s:4:\"name\";s:6:\"Search\";s:11:\"description\";s:36:\"Enables site-wide keyword searching.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:19:\"search.extender.inc\";i:1;s:11:\"search.test\";}s:9:\"configure\";s:28:\"admin/config/search/settings\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"search.css\";s:25:\"modules/search/search.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/search/tests/search_embedded_form.module','search_embedded_form','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:20:\"Search embedded form\";s:11:\"description\";s:59:\"Support module for search module testing of embedded forms.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/search/tests/search_extra_type.module','search_extra_type','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:16:\"Test search type\";s:11:\"description\";s:41:\"Support module for search module testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/shortcut/shortcut.module','shortcut','module','',1,0,0,0,'a:12:{s:4:\"name\";s:8:\"Shortcut\";s:11:\"description\";s:60:\"Allows users to manage customizable lists of shortcut links.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:13:\"shortcut.test\";}s:9:\"configure\";s:36:\"admin/config/user-interface/shortcut\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/simpletest.module','simpletest','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:7:\"Testing\";s:11:\"description\";s:53:\"Provides a framework for unit and functional testing.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:48:{i:0;s:15:\"simpletest.test\";i:1;s:24:\"drupal_web_test_case.php\";i:2;s:18:\"tests/actions.test\";i:3;s:15:\"tests/ajax.test\";i:4;s:16:\"tests/batch.test\";i:5;s:20:\"tests/bootstrap.test\";i:6;s:16:\"tests/cache.test\";i:7;s:17:\"tests/common.test\";i:8;s:24:\"tests/database_test.test\";i:9;s:32:\"tests/entity_crud_hook_test.test\";i:10;s:23:\"tests/entity_query.test\";i:11;s:16:\"tests/error.test\";i:12;s:15:\"tests/file.test\";i:13;s:23:\"tests/filetransfer.test\";i:14;s:15:\"tests/form.test\";i:15;s:16:\"tests/graph.test\";i:16;s:16:\"tests/image.test\";i:17;s:15:\"tests/lock.test\";i:18;s:15:\"tests/mail.test\";i:19;s:15:\"tests/menu.test\";i:20;s:17:\"tests/module.test\";i:21;s:16:\"tests/pager.test\";i:22;s:19:\"tests/password.test\";i:23;s:15:\"tests/path.test\";i:24;s:19:\"tests/registry.test\";i:25;s:17:\"tests/schema.test\";i:26;s:18:\"tests/session.test\";i:27;s:20:\"tests/tablesort.test\";i:28;s:16:\"tests/theme.test\";i:29;s:18:\"tests/unicode.test\";i:30;s:17:\"tests/update.test\";i:31;s:17:\"tests/xmlrpc.test\";i:32;s:26:\"tests/upgrade/upgrade.test\";i:33;s:34:\"tests/upgrade/upgrade.comment.test\";i:34;s:33:\"tests/upgrade/upgrade.filter.test\";i:35;s:32:\"tests/upgrade/upgrade.forum.test\";i:36;s:33:\"tests/upgrade/upgrade.locale.test\";i:37;s:31:\"tests/upgrade/upgrade.menu.test\";i:38;s:31:\"tests/upgrade/upgrade.node.test\";i:39;s:35:\"tests/upgrade/upgrade.taxonomy.test\";i:40;s:34:\"tests/upgrade/upgrade.trigger.test\";i:41;s:39:\"tests/upgrade/upgrade.translatable.test\";i:42;s:33:\"tests/upgrade/upgrade.upload.test\";i:43;s:31:\"tests/upgrade/upgrade.user.test\";i:44;s:36:\"tests/upgrade/update.aggregator.test\";i:45;s:33:\"tests/upgrade/update.trigger.test\";i:46;s:31:\"tests/upgrade/update.field.test\";i:47;s:30:\"tests/upgrade/update.user.test\";}s:9:\"configure\";s:41:\"admin/config/development/testing/settings\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/actions_loop_test.module','actions_loop_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Actions loop test\";s:11:\"description\";s:39:\"Support module for action loop testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/ajax_forms_test.module','ajax_forms_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:26:\"AJAX form test mock module\";s:11:\"description\";s:25:\"Test for AJAX form calls.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/ajax_test.module','ajax_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:9:\"AJAX Test\";s:11:\"description\";s:40:\"Support module for AJAX framework tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/batch_test.module','batch_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:14:\"Batch API test\";s:11:\"description\";s:35:\"Support module for Batch API tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/common_test.module','common_test','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:11:\"Common Test\";s:11:\"description\";s:32:\"Support module for Common tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:15:\"common_test.css\";s:40:\"modules/simpletest/tests/common_test.css\";}s:5:\"print\";a:1:{s:21:\"common_test.print.css\";s:46:\"modules/simpletest/tests/common_test.print.css\";}}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/common_test_cron_helper.module','common_test_cron_helper','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:23:\"Common Test Cron Helper\";s:11:\"description\";s:56:\"Helper module for CronRunTestCase::testCronExceptions().\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/database_test.module','database_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:13:\"Database Test\";s:11:\"description\";s:40:\"Support module for Database layer tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/drupal_system_listing_compatible_test/drupal_system_listing_compatible_test.module','drupal_system_listing_compatible_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:37:\"Drupal system listing compatible test\";s:11:\"description\";s:62:\"Support module for testing the drupal_system_listing function.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/drupal_system_listing_incompatible_test/drupal_system_listing_incompatible_test.module','drupal_system_listing_incompatible_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:39:\"Drupal system listing incompatible test\";s:11:\"description\";s:62:\"Support module for testing the drupal_system_listing function.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_cache_test.module','entity_cache_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:17:\"Entity cache test\";s:11:\"description\";s:40:\"Support module for testing entity cache.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:28:\"entity_cache_test_dependency\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_cache_test_dependency.module','entity_cache_test_dependency','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:28:\"Entity cache test dependency\";s:11:\"description\";s:51:\"Support dependency module for testing entity cache.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_crud_hook_test.module','entity_crud_hook_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:22:\"Entity CRUD Hooks Test\";s:11:\"description\";s:35:\"Support module for CRUD hook tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/entity_query_access_test.module','entity_query_access_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:24:\"Entity query access test\";s:11:\"description\";s:49:\"Support module for checking entity query results.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/error_test.module','error_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Error test\";s:11:\"description\";s:47:\"Support module for error and exception testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/file_test.module','file_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:9:\"File test\";s:11:\"description\";s:39:\"Support module for file handling tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:16:\"file_test.module\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/filter_test.module','filter_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:18:\"Filter test module\";s:11:\"description\";s:33:\"Tests filter hooks and functions.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/form_test.module','form_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:12:\"FormAPI Test\";s:11:\"description\";s:34:\"Support module for Form API tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/image_test.module','image_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Image test\";s:11:\"description\";s:39:\"Support module for image toolkit tests.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/menu_test.module','menu_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Hook menu tests\";s:11:\"description\";s:37:\"Support module for menu hook testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/module_test.module','module_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Module test\";s:11:\"description\";s:41:\"Support module for module system testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/path_test.module','path_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Hook path tests\";s:11:\"description\";s:37:\"Support module for path hook testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/requirements1_test.module','requirements1_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:19:\"Requirements 1 Test\";s:11:\"description\";s:80:\"Tests that a module is not installed when it fails hook_requirements(\'install\').\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/requirements2_test.module','requirements2_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:19:\"Requirements 2 Test\";s:11:\"description\";s:98:\"Tests that a module is not installed when the one it depends on fails hook_requirements(\'install).\";s:12:\"dependencies\";a:2:{i:0;s:18:\"requirements1_test\";i:1;s:7:\"comment\";}s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/session_test.module','session_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:12:\"Session test\";s:11:\"description\";s:40:\"Support module for session data testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_dependencies_test.module','system_dependencies_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:22:\"System dependency test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:19:\"_missing_dependency\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_core_version_dependencies_test.module','system_incompatible_core_version_dependencies_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:50:\"System incompatible core version dependencies test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:37:\"system_incompatible_core_version_test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_core_version_test.module','system_incompatible_core_version_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:37:\"System incompatible core version test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"5.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_module_version_dependencies_test.module','system_incompatible_module_version_dependencies_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:52:\"System incompatible module version dependencies test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:46:\"system_incompatible_module_version_test (>2.0)\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_incompatible_module_version_test.module','system_incompatible_module_version_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:39:\"System incompatible module version test\";s:11:\"description\";s:47:\"Support module for testing system dependencies.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/system_test.module','system_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"System test\";s:11:\"description\";s:34:\"Support module for system testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:18:\"system_test.module\";}s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/taxonomy_test.module','taxonomy_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:20:\"Taxonomy test module\";s:11:\"description\";s:45:\"\"Tests functions and hooks not used in core\".\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:8:\"taxonomy\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/theme_test.module','theme_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Theme test\";s:11:\"description\";s:40:\"Support module for theme system testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_script_test.module','update_script_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:18:\"Update script test\";s:11:\"description\";s:41:\"Support module for update script testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_test_1.module','update_test_1','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:34:\"Support module for update testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_test_2.module','update_test_2','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:34:\"Support module for update testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/update_test_3.module','update_test_3','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:34:\"Support module for update testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/url_alter_test.module','url_alter_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Url_alter tests\";s:11:\"description\";s:45:\"A support modules for url_alter hook testing.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/simpletest/tests/xmlrpc_test.module','xmlrpc_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:12:\"XML-RPC Test\";s:11:\"description\";s:75:\"Support module for XML-RPC tests according to the validator1 specification.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/statistics/statistics.module','statistics','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Statistics\";s:11:\"description\";s:37:\"Logs access statistics for your site.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:15:\"statistics.test\";}s:9:\"configure\";s:30:\"admin/config/system/statistics\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/syslog/syslog.module','syslog','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:6:\"Syslog\";s:11:\"description\";s:41:\"Logs and records system events to syslog.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"syslog.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/system/system.module','system','module','',1,1,7077,0,'a:13:{s:4:\"name\";s:6:\"System\";s:11:\"description\";s:54:\"Handles general site configuration for administrators.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:6:{i:0;s:19:\"system.archiver.inc\";i:1;s:15:\"system.mail.inc\";i:2;s:16:\"system.queue.inc\";i:3;s:14:\"system.tar.inc\";i:4;s:18:\"system.updater.inc\";i:5;s:11:\"system.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:19:\"admin/config/system\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/taxonomy/taxonomy.module','taxonomy','module','',1,0,7010,0,'a:14:{s:4:\"name\";s:8:\"Taxonomy\";s:11:\"description\";s:38:\"Enables the categorization of content.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:7:\"options\";}s:5:\"files\";a:2:{i:0;s:15:\"taxonomy.module\";i:1;s:13:\"taxonomy.test\";}s:9:\"configure\";s:24:\"admin/structure/taxonomy\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;s:8:\"required\";b:1;s:11:\"explanation\";s:73:\"Field type(s) in use - see <a href=\"/admin/reports/fields\">Field list</a>\";}'),('modules/toolbar/toolbar.module','toolbar','module','',1,0,0,0,'a:11:{s:4:\"name\";s:7:\"Toolbar\";s:11:\"description\";s:99:\"Provides a toolbar that shows the top-level administration menu items and links from other modules.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/tracker/tracker.module','tracker','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:7:\"Tracker\";s:11:\"description\";s:45:\"Enables tracking of recent content for users.\";s:12:\"dependencies\";a:1:{i:0;s:7:\"comment\";}s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"tracker.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/translation/tests/translation_test.module','translation_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:24:\"Content Translation Test\";s:11:\"description\";s:49:\"Support module for the content translation tests.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/translation/translation.module','translation','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:19:\"Content translation\";s:11:\"description\";s:57:\"Allows content to be translated into different languages.\";s:12:\"dependencies\";a:1:{i:0;s:6:\"locale\";}s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:16:\"translation.test\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/trigger/tests/trigger_test.module','trigger_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:12:\"Trigger Test\";s:11:\"description\";s:33:\"Support module for Trigger tests.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.21\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/trigger/trigger.module','trigger','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:7:\"Trigger\";s:11:\"description\";s:90:\"Enables actions to be fired on certain system events, such as when new content is created.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:12:\"trigger.test\";}s:9:\"configure\";s:23:\"admin/structure/trigger\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/update/tests/aaa_update_test.module','aaa_update_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"AAA Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.21\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/tests/bbb_update_test.module','bbb_update_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"BBB Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.21\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/tests/ccc_update_test.module','ccc_update_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"CCC Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"version\";s:4:\"7.21\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/tests/update_test.module','update_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Update test\";s:11:\"description\";s:41:\"Support module for update module testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/update/update.module','update','module','',1,0,7001,0,'a:12:{s:4:\"name\";s:14:\"Update manager\";s:11:\"description\";s:104:\"Checks for available updates, and can securely install or update modules and themes via a web interface.\";s:7:\"version\";s:4:\"7.21\";s:7:\"package\";s:4:\"Core\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:11:\"update.test\";}s:9:\"configure\";s:30:\"admin/reports/updates/settings\";s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('modules/user/tests/user_form_test.module','user_form_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:22:\"User module form tests\";s:11:\"description\";s:37:\"Support module for user form testing.\";s:7:\"package\";s:7:\"Testing\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:6:\"hidden\";b:1;s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('modules/user/user.module','user','module','',1,0,7018,0,'a:14:{s:4:\"name\";s:4:\"User\";s:11:\"description\";s:47:\"Manages the user registration and login system.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:11:\"user.module\";i:1;s:9:\"user.test\";}s:8:\"required\";b:1;s:9:\"configure\";s:19:\"admin/config/people\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:8:\"user.css\";s:21:\"modules/user/user.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('profiles/standard/standard.profile','standard','module','',1,0,0,1000,'a:14:{s:4:\"name\";s:8:\"Standard\";s:11:\"description\";s:51:\"Install with commonly used features pre-configured.\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:21:{i:0;s:5:\"block\";i:1;s:5:\"color\";i:2;s:7:\"comment\";i:3;s:10:\"contextual\";i:4;s:9:\"dashboard\";i:5;s:4:\"help\";i:6;s:5:\"image\";i:7;s:4:\"list\";i:8;s:4:\"menu\";i:9;s:6:\"number\";i:10;s:7:\"options\";i:11;s:4:\"path\";i:12;s:8:\"taxonomy\";i:13;s:5:\"dblog\";i:14;s:6:\"search\";i:15;s:8:\"shortcut\";i:16;s:7:\"toolbar\";i:17;s:7:\"overlay\";i:18;s:8:\"field_ui\";i:19;s:4:\"file\";i:20;s:3:\"rdf\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;s:6:\"hidden\";b:1;s:8:\"required\";b:1;s:17:\"distribution_name\";s:6:\"Drupal\";}'),('sites/all/modules/admin_menu/admin_devel/admin_devel.module','admin_devel','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:32:\"Administration Development tools\";s:11:\"description\";s:76:\"Administration and debugging functionality for developers and site builders.\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:7:\"scripts\";a:1:{s:14:\"admin_devel.js\";s:55:\"sites/all/modules/admin_menu/admin_devel/admin_devel.js\";}s:7:\"version\";s:11:\"7.x-3.0-rc3\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1337292349\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/admin_menu/admin_menu.module','admin_menu','module','',0,0,7304,100,'a:12:{s:4:\"name\";s:19:\"Administration menu\";s:11:\"description\";s:123:\"Provides a dropdown menu to most administrative tasks and other common destinations (to users with the proper permissions).\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:38:\"admin/config/administration/admin_menu\";s:12:\"dependencies\";a:1:{i:0;s:14:\"system (>7.10)\";}s:5:\"files\";a:1:{i:0;s:21:\"tests/admin_menu.test\";}s:7:\"version\";s:11:\"7.x-3.0-rc3\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1337292349\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/admin_menu/admin_menu_toolbar/admin_menu_toolbar.module','admin_menu_toolbar','module','',0,0,6300,101,'a:11:{s:4:\"name\";s:33:\"Administration menu Toolbar style\";s:11:\"description\";s:17:\"A better Toolbar.\";s:7:\"package\";s:14:\"Administration\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:10:\"admin_menu\";}s:7:\"version\";s:11:\"7.x-3.0-rc3\";s:7:\"project\";s:10:\"admin_menu\";s:9:\"datestamp\";s:10:\"1337292349\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/bulk_export/bulk_export.module','bulk_export','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:11:\"Bulk Export\";s:11:\"description\";s:67:\"Performs bulk exporting of data objects known about by Chaos tools.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/ctools.module','ctools','module','',1,0,6007,0,'a:11:{s:4:\"name\";s:11:\"Chaos tools\";s:11:\"description\";s:46:\"A library of helpful tools by Merlin of Chaos.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:5:\"files\";a:3:{i:0;s:20:\"includes/context.inc\";i:1;s:22:\"includes/math-expr.inc\";i:2;s:21:\"includes/stylizer.inc\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/ctools_access_ruleset/ctools_access_ruleset.module','ctools_access_ruleset','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:15:\"Custom rulesets\";s:11:\"description\";s:81:\"Create custom, exportable, reusable access rulesets for applications like Panels.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/ctools_ajax_sample/ctools_ajax_sample.module','ctools_ajax_sample','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:33:\"Chaos Tools (CTools) AJAX Example\";s:11:\"description\";s:41:\"Shows how to use the power of Chaos AJAX.\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/ctools_custom_content/ctools_custom_content.module','ctools_custom_content','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:20:\"Custom content panes\";s:11:\"description\";s:79:\"Create custom, exportable, reusable content panes for applications like Panels.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/ctools_plugin_example/ctools_plugin_example.module','ctools_plugin_example','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:35:\"Chaos Tools (CTools) Plugin Example\";s:11:\"description\";s:75:\"Shows how an external module can provide ctools plugins (for Panels, etc.).\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:4:{i:0;s:6:\"ctools\";i:1;s:6:\"panels\";i:2;s:12:\"page_manager\";i:3;s:13:\"advanced_help\";}s:4:\"core\";s:3:\"7.x\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/page_manager/page_manager.module','page_manager','module','',1,0,0,99,'a:11:{s:4:\"name\";s:12:\"Page manager\";s:11:\"description\";s:54:\"Provides a UI and API to manage pages within the site.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:7:\"package\";s:16:\"Chaos tool suite\";s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/stylizer/stylizer.module','stylizer','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:8:\"Stylizer\";s:11:\"description\";s:53:\"Create custom styles for applications such as Panels.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:5:\"color\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/tests/ctools_export_test/ctools_export_test.module','ctools_export_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:18:\"CTools export test\";s:11:\"description\";s:25:\"CTools export test module\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:6:\"hidden\";b:1;s:5:\"files\";a:1:{i:0;s:18:\"ctools_export.test\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/tests/ctools_plugin_test.module','ctools_plugin_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:24:\"Chaos tools plugins test\";s:11:\"description\";s:42:\"Provides hooks for testing ctools plugins.\";s:7:\"package\";s:16:\"Chaos tool suite\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:4:{i:0;s:19:\"ctools.plugins.test\";i:1;s:17:\"object_cache.test\";i:2;s:8:\"css.test\";i:3;s:12:\"context.test\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/ctools/views_content/views_content.module','views_content','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:19:\"Views content panes\";s:11:\"description\";s:104:\"Allows Views content to be used in Panels, Dashboard and other modules which use the CTools Content API.\";s:7:\"package\";s:16:\"Chaos tool suite\";s:12:\"dependencies\";a:2:{i:0;s:6:\"ctools\";i:1;s:5:\"views\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:3:{i:0;s:61:\"plugins/views/views_content_plugin_display_ctools_context.inc\";i:1;s:57:\"plugins/views/views_content_plugin_display_panel_pane.inc\";i:2;s:59:\"plugins/views/views_content_plugin_style_ctools_context.inc\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:6:\"ctools\";s:9:\"datestamp\";s:10:\"1345319204\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/devel/devel.module','devel','module','',0,0,7004,88,'a:13:{s:4:\"name\";s:5:\"Devel\";s:11:\"description\";s:52:\"Various blocks, pages, and functions for developers.\";s:7:\"package\";s:11:\"Development\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:30:\"admin/config/development/devel\";s:4:\"tags\";a:1:{i:0;s:9:\"developer\";}s:5:\"files\";a:2:{i:0;s:10:\"devel.test\";i:1;s:14:\"devel.mail.inc\";}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:5:\"devel\";s:9:\"datestamp\";s:10:\"1338940281\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/devel/devel_generate/devel_generate.module','devel_generate','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:14:\"Devel generate\";s:11:\"description\";s:48:\"Generate dummy users, nodes, and taxonomy terms.\";s:7:\"package\";s:11:\"Development\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:5:\"devel\";}s:4:\"tags\";a:1:{i:0;s:9:\"developer\";}s:9:\"configure\";s:33:\"admin/config/development/generate\";s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:5:\"devel\";s:9:\"datestamp\";s:10:\"1338940281\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/devel/devel_node_access.module','devel_node_access','module','',0,0,-1,0,'a:13:{s:4:\"name\";s:17:\"Devel node access\";s:11:\"description\";s:68:\"Developer blocks and page illustrating relevant node_access records.\";s:7:\"package\";s:11:\"Development\";s:12:\"dependencies\";a:1:{i:0;s:4:\"menu\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:30:\"admin/config/development/devel\";s:4:\"tags\";a:1:{i:0;s:9:\"developer\";}s:7:\"version\";s:7:\"7.x-1.3\";s:7:\"project\";s:5:\"devel\";s:9:\"datestamp\";s:10:\"1338940281\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/imce/imce.module','imce','module','',1,0,7001,0,'a:12:{s:4:\"name\";s:4:\"IMCE\";s:11:\"description\";s:82:\"An image/file uploader and browser supporting personal directories and user quota.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Media\";s:9:\"configure\";s:23:\"admin/config/media/imce\";s:7:\"version\";s:7:\"7.x-1.7\";s:7:\"project\";s:4:\"imce\";s:9:\"datestamp\";s:10:\"1359476607\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/imce_wysiwyg/imce_wysiwyg.module','imce_wysiwyg','module','',1,0,0,0,'a:11:{s:4:\"name\";s:23:\"IMCE Wysiwyg API bridge\";s:11:\"description\";s:82:\"Makes IMCE available as plugin for client-side editors integrated via Wysiwyg API.\";s:7:\"package\";s:14:\"User interface\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:2:{i:0;s:4:\"imce\";i:1;s:7:\"wysiwyg\";}s:7:\"version\";s:7:\"7.x-1.0\";s:7:\"project\";s:12:\"imce_wysiwyg\";s:9:\"datestamp\";s:10:\"1317851503\";s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/jquery_update/jquery_update.module','jquery_update','module','',1,0,7000,0,'a:12:{s:4:\"name\";s:13:\"jQuery Update\";s:11:\"description\";s:53:\"Update jQuery and jQuery UI to a more recent version.\";s:7:\"package\";s:14:\"User interface\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:2:{i:0;s:20:\"jquery_update.module\";i:1;s:21:\"jquery_update.install\";}s:9:\"configure\";s:38:\"admin/config/development/jquery_update\";s:7:\"version\";s:7:\"7.x-2.3\";s:7:\"project\";s:13:\"jquery_update\";s:9:\"datestamp\";s:10:\"1360375905\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/panels/panels.module','panels','module','',1,0,7301,0,'a:12:{s:4:\"name\";s:6:\"Panels\";s:11:\"description\";s:107:\"Core Panels display functions; provides no external UI, at least one other Panels module should be enabled.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:6:\"Panels\";s:9:\"configure\";s:22:\"admin/structure/panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"ctools\";}s:5:\"files\";a:5:{i:0;s:13:\"panels.module\";i:1;s:19:\"includes/common.inc\";i:2;s:19:\"includes/legacy.inc\";i:3;s:20:\"includes/plugins.inc\";i:4;s:48:\"plugins/views/panels_views_plugin_row_fields.inc\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1345319572\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/panels/panels_ipe/panels_ipe.module','panels_ipe','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:22:\"Panels In-Place Editor\";s:11:\"description\";s:101:\"Provide a UI for managing some Panels directly on the frontend, instead of having to use the backend.\";s:7:\"package\";s:6:\"Panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"panels\";}s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:22:\"admin/structure/panels\";s:5:\"files\";a:1:{i:0;s:17:\"panels_ipe.module\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1345319572\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/panels/panels_mini/panels_mini.module','panels_mini','module','',0,0,-1,0,'a:11:{s:4:\"name\";s:11:\"Mini panels\";s:11:\"description\";s:89:\"Create mini panels that can be used as blocks by Drupal and panes by other panel modules.\";s:7:\"package\";s:6:\"Panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"panels\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:42:\"plugins/export_ui/panels_mini_ui.class.php\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1345319572\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/panels/panels_node/panels_node.module','panels_node','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:11:\"Panel nodes\";s:11:\"description\";s:65:\"Create nodes that are divided into areas with selectable content.\";s:7:\"package\";s:6:\"Panels\";s:12:\"dependencies\";a:1:{i:0;s:6:\"panels\";}s:9:\"configure\";s:22:\"admin/structure/panels\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:18:\"panels_node.module\";}s:7:\"version\";s:7:\"7.x-3.3\";s:7:\"project\";s:6:\"panels\";s:9:\"datestamp\";s:10:\"1345319572\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/pathauto/pathauto.module','pathauto','module','',1,0,7005,1,'a:13:{s:4:\"name\";s:8:\"Pathauto\";s:11:\"description\";s:95:\"Provides a mechanism for modules to automatically generate aliases for the content they manage.\";s:12:\"dependencies\";a:2:{i:0;s:4:\"path\";i:1;s:5:\"token\";}s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:13:\"pathauto.test\";}s:9:\"configure\";s:33:\"admin/config/search/path/patterns\";s:10:\"recommends\";a:1:{i:0;s:8:\"redirect\";}s:7:\"version\";s:7:\"7.x-1.2\";s:7:\"project\";s:8:\"pathauto\";s:9:\"datestamp\";s:10:\"1344525185\";s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/tabvn/custom/custom.module','custom','module','',1,0,0,0,'a:9:{s:4:\"name\";s:6:\"custom\";s:11:\"description\";s:13:\"Custom module\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Tabvn\";s:12:\"dependencies\";a:0:{}s:7:\"version\";N;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/tabvn/portfolio/portfolio.module','portfolio','module','',1,0,0,0,'a:9:{s:4:\"name\";s:14:\"Portfolio page\";s:11:\"description\";s:14:\"Portfolio page\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Tabvn\";s:12:\"dependencies\";a:0:{}s:7:\"version\";N;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/tabvn/widget/widget.module','widget','module','',1,0,0,0,'a:9:{s:4:\"name\";s:6:\"widget\";s:11:\"description\";s:47:\"provide custom widget such as twitter,flickr...\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:5:\"Tabvn\";s:12:\"dependencies\";a:0:{}s:7:\"version\";N;s:3:\"php\";s:5:\"5.2.4\";s:5:\"files\";a:0:{}s:9:\"bootstrap\";i:0;}'),('sites/all/modules/tagadelic/tagadelic.module','tagadelic','module','',1,0,6100,0,'a:12:{s:4:\"name\";s:9:\"Tagadelic\";s:11:\"description\";s:61:\"Tagadelic makes weighted tag clouds from your taxonomy terms.\";s:4:\"core\";s:3:\"7.x\";s:12:\"dependencies\";a:1:{i:0;s:8:\"taxonomy\";}s:7:\"package\";s:8:\"Taxonomy\";s:9:\"configure\";s:30:\"admin/config/content/tagadelic\";s:5:\"files\";a:2:{i:0;s:16:\"tagadelic.module\";i:1;s:17:\"tagadelic.install\";}s:7:\"version\";s:11:\"7.x-1.x-dev\";s:7:\"project\";s:9:\"tagadelic\";s:9:\"datestamp\";s:10:\"1328704746\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/token/tests/token_test.module','token_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:10:\"Token Test\";s:11:\"description\";s:39:\"Testing module for token functionality.\";s:7:\"package\";s:7:\"Testing\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:17:\"token_test.module\";}s:6:\"hidden\";b:1;s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1361665026\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/token/token.module','token','module','',1,0,7001,0,'a:11:{s:4:\"name\";s:5:\"Token\";s:11:\"description\";s:73:\"Provides a user interface for the Token API and some missing core tokens.\";s:4:\"core\";s:3:\"7.x\";s:5:\"files\";a:1:{i:0;s:10:\"token.test\";}s:7:\"version\";s:7:\"7.x-1.5\";s:7:\"project\";s:5:\"token\";s:9:\"datestamp\";s:10:\"1361665026\";s:12:\"dependencies\";a:0:{}s:7:\"package\";s:5:\"Other\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/wysiwyg/tests/wysiwyg_test.module','wysiwyg_test','module','',0,0,-1,0,'a:12:{s:4:\"name\";s:15:\"Wysiwyg testing\";s:11:\"description\";s:50:\"Tests Wysiwyg module functionality. Do not enable.\";s:4:\"core\";s:3:\"7.x\";s:7:\"package\";s:7:\"Testing\";s:6:\"hidden\";b:1;s:12:\"dependencies\";a:1:{i:0;s:7:\"wysiwyg\";}s:5:\"files\";a:1:{i:0;s:19:\"wysiwyg_test.module\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:7:\"wysiwyg\";s:9:\"datestamp\";s:10:\"1349213776\";s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/modules/wysiwyg/wysiwyg.module','wysiwyg','module','',1,0,7200,0,'a:12:{s:4:\"name\";s:7:\"Wysiwyg\";s:11:\"description\";s:48:\"Allows to edit content with client-side editors.\";s:7:\"package\";s:14:\"User interface\";s:4:\"core\";s:3:\"7.x\";s:9:\"configure\";s:28:\"admin/config/content/wysiwyg\";s:5:\"files\";a:2:{i:0;s:14:\"wysiwyg.module\";i:1;s:18:\"tests/wysiwyg.test\";}s:7:\"version\";s:7:\"7.x-2.2\";s:7:\"project\";s:7:\"wysiwyg\";s:9:\"datestamp\";s:10:\"1349213776\";s:12:\"dependencies\";a:0:{}s:3:\"php\";s:5:\"5.2.4\";s:9:\"bootstrap\";i:0;}'),('sites/all/themes/centum/centum.info','centum','theme','themes/engines/phptemplate/phptemplate.engine',1,0,-1,0,'a:14:{s:4:\"name\";s:6:\"Centum\";s:11:\"description\";s:65:\"Centum theme, developed by <a href=\"http://tabvn.com/\">Tabvn</a>.\";s:4:\"core\";s:3:\"7.x\";s:7:\"scripts\";a:9:{s:12:\"js/custom.js\";s:36:\"sites/all/themes/centum/js/custom.js\";s:15:\"js/selectnav.js\";s:39:\"sites/all/themes/centum/js/selectnav.js\";s:16:\"js/flexslider.js\";s:40:\"sites/all/themes/centum/js/flexslider.js\";s:13:\"js/tooltip.js\";s:37:\"sites/all/themes/centum/js/tooltip.js\";s:13:\"js/effects.js\";s:37:\"sites/all/themes/centum/js/effects.js\";s:14:\"js/fancybox.js\";s:38:\"sites/all/themes/centum/js/fancybox.js\";s:14:\"js/carousel.js\";s:38:\"sites/all/themes/centum/js/carousel.js\";s:13:\"js/isotope.js\";s:37:\"sites/all/themes/centum/js/isotope.js\";s:12:\"js/centum.js\";s:36:\"sites/all/themes/centum/js/centum.js\";}s:8:\"features\";a:6:{i:0;s:4:\"logo\";i:1;s:4:\"name\";i:2;s:6:\"slogan\";i:3;s:20:\"comment_user_picture\";i:4;s:25:\"comment_user_verification\";i:5;s:7:\"favicon\";}s:7:\"regions\";a:17:{s:4:\"help\";s:4:\"Help\";s:6:\"header\";s:6:\"Header\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:13:\"home_services\";s:13:\"Home services\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:15:{s:11:\"twitter_url\";s:1:\"#\";s:12:\"facebook_url\";s:1:\"#\";s:12:\"dribbble_url\";s:1:\"#\";s:12:\"linkedin_url\";s:1:\"#\";s:12:\"pintrest_url\";s:1:\"#\";s:20:\"header_contact_email\";s:18:\"support@centum.com\";s:20:\"header_contact_phone\";s:15:\"+48 880 450 120\";s:24:\"footer_copyright_message\";s:65:\"© Copyright 2012 by <a href=\"#\">Centum</a>. All rights reserved.\";s:17:\"default_portfolio\";s:2:\"4c\";s:23:\"default_nodes_portfolio\";s:2:\"12\";s:15:\"default_banners\";a:2:{i:1;a:5:{s:10:\"image_path\";s:24:\"images/slider-img-01.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:15:\"image_published\";b:1;s:12:\"image_weight\";s:1:\"0\";}i:2;a:5:{s:10:\"image_path\";s:24:\"images/slider-img-02.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:15:\"image_published\";b:1;s:12:\"image_weight\";s:1:\"1\";}}s:11:\"theme_color\";s:9:\"green.css\";s:22:\"theme_background_color\";s:0:\"\";s:22:\"theme_background_image\";s:9:\"noise.png\";s:18:\"theme_layout_style\";s:9:\"boxed.css\";}s:6:\"engine\";s:11:\"phptemplate\";s:10:\"screenshot\";s:38:\"sites/all/themes/centum/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:11:\"stylesheets\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}'),('themes/bartik/bartik.info','bartik','theme','themes/engines/phptemplate/phptemplate.engine',1,0,-1,0,'a:18:{s:4:\"name\";s:6:\"Bartik\";s:11:\"description\";s:48:\"A flexible, recolorable theme with many regions.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:3:{s:14:\"css/layout.css\";s:28:\"themes/bartik/css/layout.css\";s:13:\"css/style.css\";s:27:\"themes/bartik/css/style.css\";s:14:\"css/colors.css\";s:28:\"themes/bartik/css/colors.css\";}s:5:\"print\";a:1:{s:13:\"css/print.css\";s:27:\"themes/bartik/css/print.css\";}}s:7:\"regions\";a:20:{s:6:\"header\";s:6:\"Header\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:11:\"highlighted\";s:11:\"Highlighted\";s:8:\"featured\";s:8:\"Featured\";s:7:\"content\";s:7:\"Content\";s:13:\"sidebar_first\";s:13:\"Sidebar first\";s:14:\"sidebar_second\";s:14:\"Sidebar second\";s:14:\"triptych_first\";s:14:\"Triptych first\";s:15:\"triptych_middle\";s:15:\"Triptych middle\";s:13:\"triptych_last\";s:13:\"Triptych last\";s:18:\"footer_firstcolumn\";s:19:\"Footer first column\";s:19:\"footer_secondcolumn\";s:20:\"Footer second column\";s:18:\"footer_thirdcolumn\";s:19:\"Footer third column\";s:19:\"footer_fourthcolumn\";s:20:\"Footer fourth column\";s:6:\"footer\";s:6:\"Footer\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"0\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:28:\"themes/bartik/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}'),('themes/garland/garland.info','garland','theme','themes/engines/phptemplate/phptemplate.engine',0,0,-1,0,'a:18:{s:4:\"name\";s:7:\"Garland\";s:11:\"description\";s:111:\"A multi-column theme which can be configured to modify colors and switch between fixed and fluid width layouts.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:2:{s:3:\"all\";a:1:{s:9:\"style.css\";s:24:\"themes/garland/style.css\";}s:5:\"print\";a:1:{s:9:\"print.css\";s:24:\"themes/garland/print.css\";}}s:8:\"settings\";a:1:{s:13:\"garland_width\";s:5:\"fluid\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:29:\"themes/garland/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}'),('themes/seven/seven.info','seven','theme','themes/engines/phptemplate/phptemplate.engine',1,0,-1,0,'a:18:{s:4:\"name\";s:5:\"Seven\";s:11:\"description\";s:65:\"A simple one-column, tableless, fluid width administration theme.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:6:\"screen\";a:2:{s:9:\"reset.css\";s:22:\"themes/seven/reset.css\";s:9:\"style.css\";s:22:\"themes/seven/style.css\";}}s:8:\"settings\";a:1:{s:20:\"shortcut_module_link\";s:1:\"1\";}s:7:\"regions\";a:8:{s:7:\"content\";s:7:\"Content\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:13:\"sidebar_first\";s:13:\"First sidebar\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:14:\"regions_hidden\";a:3:{i:0;s:13:\"sidebar_first\";i:1;s:8:\"page_top\";i:2;s:11:\"page_bottom\";}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/seven/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}'),('themes/stark/stark.info','stark','theme','themes/engines/phptemplate/phptemplate.engine',0,0,-1,0,'a:17:{s:4:\"name\";s:5:\"Stark\";s:11:\"description\";s:208:\"This theme demonstrates Drupal\'s default HTML markup and CSS styles. To learn how to build your own theme and override Drupal\'s default code, see the <a href=\"http://drupal.org/theme-guide\">Theming Guide</a>.\";s:7:\"package\";s:4:\"Core\";s:7:\"version\";s:4:\"7.21\";s:4:\"core\";s:3:\"7.x\";s:11:\"stylesheets\";a:1:{s:3:\"all\";a:1:{s:10:\"layout.css\";s:23:\"themes/stark/layout.css\";}}s:7:\"project\";s:6:\"drupal\";s:9:\"datestamp\";s:10:\"1362616996\";s:6:\"engine\";s:11:\"phptemplate\";s:7:\"regions\";a:12:{s:13:\"sidebar_first\";s:12:\"Left sidebar\";s:14:\"sidebar_second\";s:13:\"Right sidebar\";s:7:\"content\";s:7:\"Content\";s:6:\"header\";s:6:\"Header\";s:6:\"footer\";s:6:\"Footer\";s:11:\"highlighted\";s:11:\"Highlighted\";s:4:\"help\";s:4:\"Help\";s:8:\"page_top\";s:8:\"Page top\";s:11:\"page_bottom\";s:11:\"Page bottom\";s:14:\"dashboard_main\";s:16:\"Dashboard (main)\";s:17:\"dashboard_sidebar\";s:19:\"Dashboard (sidebar)\";s:18:\"dashboard_inactive\";s:20:\"Dashboard (inactive)\";}s:8:\"features\";a:9:{i:0;s:4:\"logo\";i:1;s:7:\"favicon\";i:2;s:4:\"name\";i:3;s:6:\"slogan\";i:4;s:17:\"node_user_picture\";i:5;s:20:\"comment_user_picture\";i:6;s:25:\"comment_user_verification\";i:7;s:9:\"main_menu\";i:8;s:14:\"secondary_menu\";}s:10:\"screenshot\";s:27:\"themes/stark/screenshot.png\";s:3:\"php\";s:5:\"5.2.4\";s:7:\"scripts\";a:0:{}s:15:\"overlay_regions\";a:5:{i:0;s:14:\"dashboard_main\";i:1;s:17:\"dashboard_sidebar\";i:2;s:18:\"dashboard_inactive\";i:3;s:7:\"content\";i:4;s:4:\"help\";}s:14:\"regions_hidden\";a:2:{i:0;s:8:\"page_top\";i:1;s:11:\"page_bottom\";}s:28:\"overlay_supplemental_regions\";a:1:{i:0;s:8:\"page_top\";}}');
/*!40000 ALTER TABLE `system` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taxonomy_index`
--

DROP TABLE IF EXISTS `taxonomy_index`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_index` (
  `nid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The node.nid this record tracks.',
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The term ID.',
  `sticky` tinyint(4) DEFAULT '0' COMMENT 'Boolean indicating whether the node is sticky.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'The Unix timestamp when the node was created.',
  KEY `term_node` (`tid`,`sticky`,`created`),
  KEY `nid` (`nid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maintains denormalized information about node/term...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_index`
--

LOCK TABLES `taxonomy_index` WRITE;
/*!40000 ALTER TABLE `taxonomy_index` DISABLE KEYS */;
INSERT INTO `taxonomy_index` VALUES (2,4,0,1359708253),(2,5,0,1359708253),(2,6,0,1359708253),(3,1,0,1359708289),(3,3,0,1359708289),(1,1,0,1359711790),(1,2,0,1359711790),(1,3,0,1359711790),(4,7,0,1359716915),(4,8,0,1359716915),(9,9,0,1359734895),(9,10,0,1359734895),(10,9,0,1359734998),(10,10,0,1359734998),(11,9,0,1359735771),(11,10,0,1359735771),(5,8,0,1359737417),(5,9,0,1359737417),(6,9,0,1359737417),(6,10,0,1359737417),(8,8,0,1359737417),(8,9,0,1359737417),(7,7,0,1359737417),(7,8,0,1359737417);
/*!40000 ALTER TABLE `taxonomy_index` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taxonomy_term_data`
--

DROP TABLE IF EXISTS `taxonomy_term_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_term_data` (
  `tid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique term ID.',
  `vid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The taxonomy_vocabulary.vid of the vocabulary to which the term is assigned.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The term name.',
  `description` longtext COMMENT 'A description of the term.',
  `format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the description.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of this term in relation to other terms.',
  PRIMARY KEY (`tid`),
  KEY `taxonomy_tree` (`vid`,`weight`,`name`),
  KEY `vid_name` (`vid`,`name`),
  KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8 COMMENT='Stores term information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_term_data`
--

LOCK TABLES `taxonomy_term_data` WRITE;
/*!40000 ALTER TABLE `taxonomy_term_data` DISABLE KEYS */;
INSERT INTO `taxonomy_term_data` VALUES (1,1,'Photography',NULL,NULL,0),(2,1,'Motion Graphics',NULL,NULL,0),(3,1,'Business',NULL,NULL,0),(4,1,'Drupal',NULL,NULL,0),(5,1,'Wordpress',NULL,NULL,0),(6,1,'Joomla',NULL,NULL,0),(7,2,'Interior Design','','full_html',0),(8,2,'Architecture','','full_html',1),(9,2,'Scenery','','full_html',2),(10,2,'Real Estate','','full_html',3);
/*!40000 ALTER TABLE `taxonomy_term_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taxonomy_term_hierarchy`
--

DROP TABLE IF EXISTS `taxonomy_term_hierarchy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_term_hierarchy` (
  `tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: The taxonomy_term_data.tid of the term.',
  `parent` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: The taxonomy_term_data.tid of the term’s parent. 0 indicates no parent.',
  PRIMARY KEY (`tid`,`parent`),
  KEY `parent` (`parent`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores the hierarchical relationship between terms.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_term_hierarchy`
--

LOCK TABLES `taxonomy_term_hierarchy` WRITE;
/*!40000 ALTER TABLE `taxonomy_term_hierarchy` DISABLE KEYS */;
INSERT INTO `taxonomy_term_hierarchy` VALUES (1,0),(2,0),(3,0),(4,0),(5,0),(6,0),(7,0),(8,0),(9,0),(10,0);
/*!40000 ALTER TABLE `taxonomy_term_hierarchy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taxonomy_vocabulary`
--

DROP TABLE IF EXISTS `taxonomy_vocabulary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `taxonomy_vocabulary` (
  `vid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique vocabulary ID.',
  `name` varchar(255) NOT NULL DEFAULT '' COMMENT 'Name of the vocabulary.',
  `machine_name` varchar(255) NOT NULL DEFAULT '' COMMENT 'The vocabulary machine name.',
  `description` longtext COMMENT 'Description of the vocabulary.',
  `hierarchy` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'The type of hierarchy allowed within the vocabulary. (0 = disabled, 1 = single, 2 = multiple)',
  `module` varchar(255) NOT NULL DEFAULT '' COMMENT 'The module which created the vocabulary.',
  `weight` int(11) NOT NULL DEFAULT '0' COMMENT 'The weight of this vocabulary in relation to other vocabularies.',
  PRIMARY KEY (`vid`),
  UNIQUE KEY `machine_name` (`machine_name`),
  KEY `list` (`weight`,`name`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='Stores vocabulary information.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxonomy_vocabulary`
--

LOCK TABLES `taxonomy_vocabulary` WRITE;
/*!40000 ALTER TABLE `taxonomy_vocabulary` DISABLE KEYS */;
INSERT INTO `taxonomy_vocabulary` VALUES (1,'Tags','tags','Use tags to group articles on similar topics into categories.',0,'taxonomy',0),(2,'Portfolio categories','portfolio_categories','',0,'taxonomy',0);
/*!40000 ALTER TABLE `taxonomy_vocabulary` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `url_alias`
--

DROP TABLE IF EXISTS `url_alias`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `url_alias` (
  `pid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'A unique path alias identifier.',
  `source` varchar(255) NOT NULL DEFAULT '' COMMENT 'The Drupal path this alias is for; e.g. node/12.',
  `alias` varchar(255) NOT NULL DEFAULT '' COMMENT 'The alias for this path; e.g. title-of-the-story.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'The language this alias is for; if ’und’, the alias will be used for unknown languages. Each Drupal path can have an alias for each supported language.',
  PRIMARY KEY (`pid`),
  KEY `alias_language_pid` (`alias`,`language`,`pid`),
  KEY `source_language_pid` (`source`,`language`,`pid`)
) ENGINE=InnoDB AUTO_INCREMENT=29 DEFAULT CHARSET=utf8 COMMENT='A list of URL aliases for Drupal paths; a user may visit...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `url_alias`
--

LOCK TABLES `url_alias` WRITE;
/*!40000 ALTER TABLE `url_alias` DISABLE KEYS */;
INSERT INTO `url_alias` VALUES (1,'taxonomy/term/1','tags/photography','und'),(2,'taxonomy/term/2','tags/motion-graphics','und'),(3,'taxonomy/term/3','tags/business','und'),(4,'node/1','blog/aenean-lacinia-bibendum','und'),(5,'taxonomy/term/4','tags/drupal','und'),(6,'taxonomy/term/5','tags/wordpress','und'),(7,'taxonomy/term/6','tags/joomla','und'),(8,'node/2','blog/vivamus-metus-massa','und'),(9,'node/3','blog/phasellus-nec-velit-sit-amet','und'),(10,'taxonomy/term/7','portfolio-categories/interior-design','und'),(11,'taxonomy/term/8','portfolio-categories/architecture','und'),(12,'taxonomy/term/9','portfolio-categories/scenery','und'),(13,'taxonomy/term/10','portfolio-categories/real-estate','und'),(14,'node/4','portfolio/maritime-details','und'),(15,'node/5','portfolio/grand-canyon','und'),(16,'node/6','portfolio/coffee-time','und'),(17,'node/7','portfolio/surfing-web','und'),(18,'node/8','portfolio/wireless-keyboard','und'),(19,'node/9','portfolio/pine-tree-near-water','und'),(20,'node/10','portfolio/digital-world','und'),(21,'node/11','portfolio/grand-canyon-0','und'),(22,'user/1','users/admin','und'),(23,'blog/1','blogs/admin','und'),(24,'node/12','content/shortcodes','und'),(25,'node/13','content/full-width','und'),(26,'node/14','about','und'),(27,'node/15','services','und'),(28,'node/16','content/pricing-tables','und');
/*!40000 ALTER TABLE `url_alias` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: Unique user ID.',
  `name` varchar(60) NOT NULL DEFAULT '' COMMENT 'Unique user name.',
  `pass` varchar(128) NOT NULL DEFAULT '' COMMENT 'User’s password (hashed).',
  `mail` varchar(254) DEFAULT '' COMMENT 'User’s e-mail address.',
  `theme` varchar(255) NOT NULL DEFAULT '' COMMENT 'User’s default theme.',
  `signature` varchar(255) NOT NULL DEFAULT '' COMMENT 'User’s signature.',
  `signature_format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the signature.',
  `created` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp for when user was created.',
  `access` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp for previous time user accessed the site.',
  `login` int(11) NOT NULL DEFAULT '0' COMMENT 'Timestamp for user’s last login.',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'Whether the user is active(1) or blocked(0).',
  `timezone` varchar(32) DEFAULT NULL COMMENT 'User’s time zone.',
  `language` varchar(12) NOT NULL DEFAULT '' COMMENT 'User’s default language.',
  `picture` int(11) NOT NULL DEFAULT '0' COMMENT 'Foreign key: file_managed.fid of user’s picture.',
  `init` varchar(254) DEFAULT '' COMMENT 'E-mail address used for initial account creation.',
  `data` longblob COMMENT 'A serialized array of name value pairs that are related to the user. Any form values posted during user edit are stored and are loaded into the $user object during user_load(). Use of this field is discouraged and it will likely disappear in a future...',
  PRIMARY KEY (`uid`),
  UNIQUE KEY `name` (`name`),
  KEY `access` (`access`),
  KEY `created` (`created`),
  KEY `mail` (`mail`),
  KEY `picture` (`picture`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores user data.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users`
--

LOCK TABLES `users` WRITE;
/*!40000 ALTER TABLE `users` DISABLE KEYS */;
INSERT INTO `users` VALUES (0,'','','','','',NULL,0,0,0,0,NULL,'',0,'',NULL),(1,'admin','$S$DGxri/i6SzCyrn0Fvb4ySgg7.sZeJ.SYRgqi5STjAtsdJDifYBGv','toan@tabvn.com','','','full_html',1359648853,1362623493,1361183248,1,'Asia/Bangkok','',22,'toan@tabvn.com','a:1:{s:7:\"contact\";i:0;}');
/*!40000 ALTER TABLE `users` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `users_roles`
--

DROP TABLE IF EXISTS `users_roles`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `users_roles` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: users.uid for user.',
  `rid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Primary Key: role.rid for role.',
  PRIMARY KEY (`uid`,`rid`),
  KEY `rid` (`rid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Maps users to roles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `users_roles`
--

LOCK TABLES `users_roles` WRITE;
/*!40000 ALTER TABLE `users_roles` DISABLE KEYS */;
INSERT INTO `users_roles` VALUES (1,3);
/*!40000 ALTER TABLE `users_roles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `variable`
--

DROP TABLE IF EXISTS `variable`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `variable` (
  `name` varchar(128) NOT NULL DEFAULT '' COMMENT 'The name of the variable.',
  `value` longblob NOT NULL COMMENT 'The value of the variable.',
  PRIMARY KEY (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Named variable/value pairs created by Drupal core or any...';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `variable`
--

LOCK TABLES `variable` WRITE;
/*!40000 ALTER TABLE `variable` DISABLE KEYS */;
INSERT INTO `variable` VALUES ('additional_settings__active_tab_blog','s:13:\"edit-workflow\";'),('additional_settings__active_tab_portfolio','s:13:\"edit-workflow\";'),('admin_menu_cache_client','i:1;'),('admin_menu_devel_modules_skip','a:4:{s:11:\"admin_devel\";i:0;s:5:\"devel\";i:0;s:17:\"devel_node_access\";i:0;s:8:\"field_ui\";i:0;}'),('admin_menu_margin_top','i:1;'),('admin_menu_position_fixed','i:1;'),('admin_menu_tweak_modules','i:0;'),('admin_menu_tweak_permissions','i:0;'),('admin_menu_tweak_tabs','i:0;'),('admin_theme','s:5:\"seven\";'),('anonymous','s:9:\"Anonymous\";'),('block_cache','i:0;'),('blog_block_count','s:2:\"10\";'),('cache','i:0;'),('cache_lifetime','s:1:\"0\";'),('clean_url','s:1:\"1\";'),('comment_anonymous_blog','i:0;'),('comment_anonymous_portfolio','i:0;'),('comment_blog','s:1:\"2\";'),('comment_default_mode_blog','i:1;'),('comment_default_mode_portfolio','i:0;'),('comment_default_per_page_blog','s:2:\"50\";'),('comment_default_per_page_portfolio','s:2:\"50\";'),('comment_form_location_blog','i:1;'),('comment_form_location_portfolio','i:1;'),('comment_page','i:0;'),('comment_portfolio','s:1:\"0\";'),('comment_preview_blog','s:1:\"1\";'),('comment_preview_portfolio','s:1:\"0\";'),('comment_subject_field_blog','i:1;'),('comment_subject_field_portfolio','i:0;'),('contact_default_status','i:1;'),('cron_key','s:43:\"Y9SXKaqynBbR421mHl60yeUNFh09bvtCYg_l6pC8yAE\";'),('cron_last','i:1362623493;'),('css_js_query_string','s:6:\"mj9tb0\";'),('ctools_last_cron','i:1362623494;'),('date_default_timezone','s:12:\"Asia/Bangkok\";'),('default_nodes_main','s:1:\"8\";'),('drupal_http_request_fails','b:0;'),('drupal_private_key','s:43:\"IxJ4ruIYb_p0GnjeyJD6cNOuW4DG3YJSR-GX_egNdg8\";'),('email__active_tab','s:24:\"edit-email-admin-created\";'),('field_bundle_settings_node__blog','a:2:{s:10:\"view_modes\";a:6:{s:6:\"teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:3:\"rss\";a:1:{s:15:\"custom_settings\";b:0;}s:12:\"search_index\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"search_result\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:2:\"-5\";}s:4:\"path\";a:1:{s:6:\"weight\";s:2:\"30\";}}s:7:\"display\";a:0:{}}}'),('field_bundle_settings_node__portfolio','a:2:{s:10:\"view_modes\";a:6:{s:6:\"teaser\";a:1:{s:15:\"custom_settings\";b:1;}s:4:\"full\";a:1:{s:15:\"custom_settings\";b:0;}s:3:\"rss\";a:1:{s:15:\"custom_settings\";b:0;}s:12:\"search_index\";a:1:{s:15:\"custom_settings\";b:0;}s:13:\"search_result\";a:1:{s:15:\"custom_settings\";b:0;}s:5:\"token\";a:1:{s:15:\"custom_settings\";b:0;}}s:12:\"extra_fields\";a:2:{s:4:\"form\";a:2:{s:5:\"title\";a:1:{s:6:\"weight\";s:2:\"-5\";}s:4:\"path\";a:1:{s:6:\"weight\";s:2:\"30\";}}s:7:\"display\";a:0:{}}}'),('file_temporary_path','s:4:\"/tmp\";'),('filter_fallback_format','s:10:\"plain_text\";'),('imce_profiles','a:2:{i:1;a:10:{s:4:\"name\";s:6:\"User-1\";s:7:\"usertab\";i:1;s:8:\"filesize\";i:0;s:5:\"quota\";i:0;s:7:\"tuquota\";i:0;s:10:\"extensions\";s:1:\"*\";s:10:\"dimensions\";s:9:\"1200x1200\";s:7:\"filenum\";i:0;s:11:\"directories\";a:1:{i:0;a:7:{s:4:\"name\";s:1:\".\";s:6:\"subnav\";i:1;s:6:\"browse\";i:1;s:6:\"upload\";i:1;s:5:\"thumb\";i:1;s:6:\"delete\";i:1;s:6:\"resize\";i:1;}}s:10:\"thumbnails\";a:3:{i:0;a:4:{s:4:\"name\";s:5:\"Small\";s:10:\"dimensions\";s:5:\"90x90\";s:6:\"prefix\";s:6:\"small_\";s:6:\"suffix\";s:0:\"\";}i:1;a:4:{s:4:\"name\";s:6:\"Medium\";s:10:\"dimensions\";s:7:\"120x120\";s:6:\"prefix\";s:7:\"medium_\";s:6:\"suffix\";s:0:\"\";}i:2;a:4:{s:4:\"name\";s:5:\"Large\";s:10:\"dimensions\";s:7:\"180x180\";s:6:\"prefix\";s:6:\"large_\";s:6:\"suffix\";s:0:\"\";}}}i:2;a:10:{s:4:\"name\";s:14:\"Sample profile\";s:7:\"usertab\";i:1;s:8:\"filesize\";i:1;s:5:\"quota\";i:2;s:7:\"tuquota\";i:0;s:10:\"extensions\";s:16:\"gif png jpg jpeg\";s:10:\"dimensions\";s:7:\"800x600\";s:7:\"filenum\";i:1;s:11:\"directories\";a:1:{i:0;a:7:{s:4:\"name\";s:5:\"u%uid\";s:6:\"subnav\";i:0;s:6:\"browse\";i:1;s:6:\"upload\";i:1;s:5:\"thumb\";i:1;s:6:\"delete\";i:0;s:6:\"resize\";i:0;}}s:10:\"thumbnails\";a:1:{i:0;a:4:{s:4:\"name\";s:5:\"Thumb\";s:10:\"dimensions\";s:5:\"90x90\";s:6:\"prefix\";s:6:\"thumb_\";s:6:\"suffix\";s:0:\"\";}}}}'),('install_profile','s:8:\"standard\";'),('install_task','s:4:\"done\";'),('install_time','i:1359648896;'),('jquery_update_compression_type','s:3:\"min\";'),('jquery_update_jquery_cdn','s:4:\"none\";'),('jquery_update_jquery_version','s:3:\"1.7\";'),('menu_expanded','a:0:{}'),('menu_masks','a:34:{i:0;i:501;i:1;i:493;i:2;i:250;i:3;i:247;i:4;i:246;i:5;i:245;i:6;i:125;i:7;i:123;i:8;i:122;i:9;i:121;i:10;i:117;i:11;i:63;i:12;i:62;i:13;i:61;i:14;i:60;i:15;i:59;i:16;i:58;i:17;i:44;i:18;i:31;i:19;i:30;i:20;i:29;i:21;i:28;i:22;i:24;i:23;i:21;i:24;i:15;i:25;i:14;i:26;i:13;i:27;i:11;i:28;i:7;i:29;i:6;i:30;i:5;i:31;i:3;i:32;i:2;i:33;i:1;}'),('menu_options_blog','a:1:{i:0;s:9:\"main-menu\";}'),('menu_options_portfolio','a:1:{i:0;s:9:\"main-menu\";}'),('menu_parent_blog','s:11:\"main-menu:0\";'),('menu_parent_portfolio','s:11:\"main-menu:0\";'),('node_admin_theme','s:1:\"1\";'),('node_cron_last','s:10:\"1359808293\";'),('node_options_blog','a:1:{i:0;s:6:\"status\";}'),('node_options_page','a:1:{i:0;s:6:\"status\";}'),('node_options_portfolio','a:1:{i:0;s:6:\"status\";}'),('node_preview_blog','s:1:\"0\";'),('node_preview_portfolio','s:1:\"0\";'),('node_submitted_blog','i:1;'),('node_submitted_page','b:0;'),('node_submitted_portfolio','i:0;'),('page_cache_maximum_age','s:1:\"0\";'),('page_compression','i:1;'),('pathauto_blog_pattern','s:17:\"blogs/[user:name]\";'),('pathauto_forum_pattern','s:29:\"[term:vocabulary]/[term:name]\";'),('pathauto_node_article_pattern','s:0:\"\";'),('pathauto_node_blog_pattern','s:17:\"blog/[node:title]\";'),('pathauto_node_page_pattern','s:0:\"\";'),('pathauto_node_pattern','s:20:\"content/[node:title]\";'),('pathauto_node_portfolio_pattern','s:22:\"portfolio/[node:title]\";'),('pathauto_punctuation_hyphen','i:1;'),('pathauto_taxonomy_term_pattern','s:29:\"[term:vocabulary]/[term:name]\";'),('pathauto_taxonomy_term_portfolio_categories_pattern','s:0:\"\";'),('pathauto_taxonomy_term_tags_pattern','s:16:\"tags/[term:name]\";'),('pathauto_user_pattern','s:17:\"users/[user:name]\";'),('path_alias_whitelist','a:4:{s:4:\"blog\";b:1;s:4:\"node\";b:1;s:8:\"taxonomy\";b:1;s:4:\"user\";b:1;}'),('preprocess_css','i:0;'),('preprocess_js','i:0;'),('save_continue_portfolio','s:19:\"Save and add fields\";'),('site_403','s:0:\"\";'),('site_404','s:0:\"\";'),('site_default_country','s:0:\"\";'),('site_frontpage','s:10:\"front-page\";'),('site_mail','s:14:\"toan@tabvn.com\";'),('site_name','s:6:\"Centum\";'),('site_slogan','s:35:\"It\'s time to impress your visitors!\";'),('tagadelic_block_tags_1','s:2:\"12\";'),('theme_centum_banner_settings','a:2:{i:0;a:7:{s:10:\"image_path\";s:33:\"public://banner/slider-img-01.jpg\";s:11:\"image_thumb\";s:39:\"public://banner/thumb/slider-img-01.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:12:\"image_weight\";s:1:\"0\";s:15:\"image_published\";s:1:\"1\";s:12:\"image_delete\";N;}i:1;a:7:{s:10:\"image_path\";s:33:\"public://banner/slider-img-02.jpg\";s:11:\"image_thumb\";s:39:\"public://banner/thumb/slider-img-02.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:12:\"image_weight\";s:1:\"1\";s:15:\"image_published\";s:1:\"1\";s:12:\"image_delete\";N;}}'),('theme_centum_first_install','b:0;'),('theme_centum_settings','a:29:{s:11:\"toggle_logo\";i:1;s:11:\"toggle_name\";i:1;s:13:\"toggle_slogan\";i:1;s:27:\"toggle_comment_user_picture\";i:1;s:32:\"toggle_comment_user_verification\";i:1;s:14:\"toggle_favicon\";i:1;s:12:\"default_logo\";i:1;s:9:\"logo_path\";s:0:\"\";s:11:\"logo_upload\";s:0:\"\";s:15:\"default_favicon\";i:1;s:12:\"favicon_path\";s:0:\"\";s:14:\"favicon_upload\";s:0:\"\";s:20:\"header_contact_email\";s:18:\"support@centum.com\";s:20:\"header_contact_phone\";s:15:\"+48 880 450 120\";s:12:\"facebook_url\";s:1:\"#\";s:11:\"twitter_url\";s:1:\"#\";s:12:\"dribbble_url\";s:1:\"#\";s:12:\"linkedin_url\";s:1:\"#\";s:12:\"pintrest_url\";s:1:\"#\";s:17:\"default_portfolio\";s:2:\"4c\";s:23:\"default_nodes_portfolio\";s:2:\"12\";s:24:\"footer_copyright_message\";s:65:\"© Copyright 2012 by <a href=\"#\">Centum</a>. All rights reserved.\";s:18:\"theme_layout_style\";s:9:\"boxed.css\";s:11:\"theme_color\";s:9:\"green.css\";s:22:\"theme_background_color\";s:0:\"\";s:22:\"theme_background_image\";s:9:\"noise.png\";s:20:\"settings__active_tab\";s:9:\"edit-skin\";s:6:\"images\";a:3:{i:0;a:1:{s:5:\"image\";a:7:{s:10:\"image_path\";s:33:\"public://banner/slider-img-01.jpg\";s:11:\"image_thumb\";s:39:\"public://banner/thumb/slider-img-01.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:12:\"image_weight\";s:1:\"0\";s:15:\"image_published\";i:1;s:12:\"image_delete\";i:0;}}i:1;a:1:{s:5:\"image\";a:7:{s:10:\"image_path\";s:33:\"public://banner/slider-img-02.jpg\";s:11:\"image_thumb\";s:39:\"public://banner/thumb/slider-img-02.jpg\";s:11:\"image_title\";s:17:\"This is a caption\";s:17:\"image_description\";s:180:\"Donec scelerisque aliquet mi, non venenatis urnas iaculis. Utea id nila ante. Cras est massa, interdum  ateal imperdiet etean, gravida eu quame. Aeneana volutpat hendrerit posuere.\";s:12:\"image_weight\";s:1:\"1\";s:15:\"image_published\";i:1;s:12:\"image_delete\";i:0;}}s:18:\"images__active_tab\";s:13:\"edit-images-0\";}s:12:\"image_upload\";s:0:\"\";}'),('theme_default','s:6:\"centum\";'),('update_last_check','i:1362626410;'),('update_last_email_notification','i:1362623493;'),('update_notify_emails','a:1:{i:0;s:14:\"toan@tabvn.com\";}'),('user_admin_role','s:1:\"3\";'),('user_cancel_method','s:17:\"user_cancel_block\";'),('user_email_verification','i:1;'),('user_mail_cancel_confirm_body','s:381:\"[user:name],\r\n\r\nA request to cancel your account has been made at [site:name].\r\n\r\nYou may now cancel your account on [site:url-brief] by clicking this link or copying and pasting it into your browser:\r\n\r\n[user:cancel-url]\r\n\r\nNOTE: The cancellation of your account is not reversible.\r\n\r\nThis link expires in one day and nothing will happen if it is not used.\r\n\r\n--  [site:name] team\";'),('user_mail_cancel_confirm_subject','s:59:\"Account cancellation request for [user:name] at [site:name]\";'),('user_mail_password_reset_body','s:407:\"[user:name],\r\n\r\nA request to reset the password for your account has been made at [site:name].\r\n\r\nYou may now log in by clicking this link or copying and pasting it to your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password. It expires after one day and nothing will happen if it\'s not used.\r\n\r\n--  [site:name] team\";'),('user_mail_password_reset_subject','s:60:\"Replacement login information for [user:name] at [site:name]\";'),('user_mail_register_admin_created_body','s:476:\"[user:name],\r\n\r\nA site administrator at [site:name] has created an account for you. You may now log in by clicking this link or copying and pasting it to your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password.\r\n\r\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\r\n\r\nusername: [user:name]\r\npassword: Your password\r\n\r\n--  [site:name] team\";'),('user_mail_register_admin_created_subject','s:58:\"An administrator created an account for you at [site:name]\";'),('user_mail_register_no_approval_required_body','s:450:\"[user:name],\r\n\r\nThank you for registering at [site:name]. You may now log in by clicking this link or copying and pasting it to your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password.\r\n\r\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\r\n\r\nusername: [user:name]\r\npassword: Your password\r\n\r\n--  [site:name] team\";'),('user_mail_register_no_approval_required_subject','s:46:\"Account details for [user:name] at [site:name]\";'),('user_mail_register_pending_approval_body','s:287:\"[user:name],\r\n\r\nThank you for registering at [site:name]. Your application for an account is currently pending approval. Once it has been approved, you will receive another e-mail containing information about how to log in, set your password, and other details.\r\n\r\n\r\n--  [site:name] team\";'),('user_mail_register_pending_approval_subject','s:71:\"Account details for [user:name] at [site:name] (pending admin approval)\";'),('user_mail_status_activated_body','s:461:\"[user:name],\r\n\r\nYour account at [site:name] has been activated.\r\n\r\nYou may now log in by clicking this link or copying and pasting it into your browser:\r\n\r\n[user:one-time-login-url]\r\n\r\nThis link can only be used once to log in and will lead you to a page where you can set your password.\r\n\r\nAfter setting your password, you will be able to log in at [site:login-url] in the future using:\r\n\r\nusername: [user:name]\r\npassword: Your password\r\n\r\n--  [site:name] team\";'),('user_mail_status_activated_notify','i:1;'),('user_mail_status_activated_subject','s:57:\"Account details for [user:name] at [site:name] (approved)\";'),('user_mail_status_blocked_body','s:85:\"[user:name],\r\n\r\nYour account on [site:name] has been blocked.\r\n\r\n--  [site:name] team\";'),('user_mail_status_blocked_notify','i:0;'),('user_mail_status_blocked_subject','s:56:\"Account details for [user:name] at [site:name] (blocked)\";'),('user_mail_status_canceled_body','s:86:\"[user:name],\r\n\r\nYour account on [site:name] has been canceled.\r\n\r\n--  [site:name] team\";'),('user_mail_status_canceled_notify','i:0;'),('user_mail_status_canceled_subject','s:57:\"Account details for [user:name] at [site:name] (canceled)\";'),('user_pictures','i:1;'),('user_picture_default','s:74:\"http://www.gravatar.com/avatar/00000000000000000000000000000000?d=mm&s=100\";'),('user_picture_dimensions','s:9:\"1024x1024\";'),('user_picture_file_size','s:3:\"800\";'),('user_picture_guidelines','s:0:\"\";'),('user_picture_path','s:8:\"pictures\";'),('user_picture_style','s:9:\"thumbnail\";'),('user_register','s:1:\"2\";'),('user_signatures','i:0;'),('widget_flickr_id','s:12:\"36587311@N08\";'),('widget_flickr_photo_count','s:1:\"6\";');
/*!40000 ALTER TABLE `variable` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `watchdog`
--

DROP TABLE IF EXISTS `watchdog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `watchdog` (
  `wid` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key: Unique watchdog event ID.',
  `uid` int(11) NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user who triggered the event.',
  `type` varchar(64) NOT NULL DEFAULT '' COMMENT 'Type of log message, for example "user" or "page not found."',
  `message` longtext NOT NULL COMMENT 'Text of log message to be passed into the t() function.',
  `variables` longblob NOT NULL COMMENT 'Serialized array of variables that match the message string and that is passed into the t() function.',
  `severity` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'The severity level of the event; ranges from 0 (Emergency) to 7 (Debug)',
  `link` varchar(255) DEFAULT '' COMMENT 'Link to view the result of the event.',
  `location` text NOT NULL COMMENT 'URL of the origin of the event.',
  `referer` text COMMENT 'URL of referring page.',
  `hostname` varchar(128) NOT NULL DEFAULT '' COMMENT 'Hostname of the user who triggered the event.',
  `timestamp` int(11) NOT NULL DEFAULT '0' COMMENT 'Unix timestamp of when event occurred.',
  PRIMARY KEY (`wid`),
  KEY `type` (`type`),
  KEY `uid` (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Table that contains logs of all system events.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `watchdog`
--

LOCK TABLES `watchdog` WRITE;
/*!40000 ALTER TABLE `watchdog` DISABLE KEYS */;
/*!40000 ALTER TABLE `watchdog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wysiwyg`
--

DROP TABLE IF EXISTS `wysiwyg`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `wysiwyg` (
  `format` varchar(255) NOT NULL COMMENT 'The filter_format.format of the text format.',
  `editor` varchar(128) NOT NULL DEFAULT '' COMMENT 'Internal name of the editor attached to the text format.',
  `settings` text COMMENT 'Configuration settings for the editor.',
  PRIMARY KEY (`format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores Wysiwyg profiles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wysiwyg`
--

LOCK TABLES `wysiwyg` WRITE;
/*!40000 ALTER TABLE `wysiwyg` DISABLE KEYS */;
INSERT INTO `wysiwyg` VALUES ('filtered_html','',NULL),('full_html','',NULL),('plain_text','',NULL),('wysiwyg','ckeditor','a:20:{s:7:\"default\";i:1;s:11:\"user_choose\";i:0;s:11:\"show_toggle\";i:1;s:5:\"theme\";s:8:\"advanced\";s:8:\"language\";s:2:\"en\";s:7:\"buttons\";a:2:{s:7:\"default\";a:26:{s:4:\"Bold\";i:1;s:6:\"Italic\";i:1;s:9:\"Underline\";i:1;s:11:\"JustifyLeft\";i:1;s:13:\"JustifyCenter\";i:1;s:12:\"JustifyRight\";i:1;s:12:\"JustifyBlock\";i:1;s:7:\"BidiLtr\";i:1;s:7:\"BidiRtl\";i:1;s:12:\"BulletedList\";i:1;s:12:\"NumberedList\";i:1;s:4:\"Undo\";i:1;s:4:\"Redo\";i:1;s:4:\"Link\";i:1;s:6:\"Unlink\";i:1;s:5:\"Image\";i:1;s:9:\"TextColor\";i:1;s:9:\"Subscript\";i:1;s:10:\"Blockquote\";i:1;s:6:\"Source\";i:1;s:12:\"RemoveFormat\";i:1;s:6:\"Format\";i:1;s:4:\"Font\";i:1;s:8:\"FontSize\";i:1;s:6:\"Styles\";i:1;s:5:\"Table\";i:1;}s:4:\"imce\";a:1:{s:4:\"imce\";i:1;}}s:11:\"toolbar_loc\";s:3:\"top\";s:13:\"toolbar_align\";s:4:\"left\";s:8:\"path_loc\";s:6:\"bottom\";s:8:\"resizing\";i:1;s:11:\"verify_html\";i:1;s:12:\"preformatted\";i:0;s:22:\"convert_fonts_to_spans\";i:1;s:17:\"remove_linebreaks\";i:1;s:23:\"apply_source_formatting\";i:0;s:27:\"paste_auto_cleanup_on_paste\";i:0;s:13:\"block_formats\";s:32:\"p,address,pre,h2,h3,h4,h5,h6,div\";s:11:\"css_setting\";s:5:\"theme\";s:8:\"css_path\";s:0:\"\";s:11:\"css_classes\";s:0:\"\";}');
/*!40000 ALTER TABLE `wysiwyg` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wysiwyg_user`
--

DROP TABLE IF EXISTS `wysiwyg_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `wysiwyg_user` (
  `uid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The users.uid of the user.',
  `format` varchar(255) DEFAULT NULL COMMENT 'The filter_format.format of the text format.',
  `status` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Boolean indicating whether the format is enabled by default.',
  KEY `uid` (`uid`),
  KEY `format` (`format`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Stores user preferences for wysiwyg profiles.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `wysiwyg_user`
--

LOCK TABLES `wysiwyg_user` WRITE;
/*!40000 ALTER TABLE `wysiwyg_user` DISABLE KEYS */;
/*!40000 ALTER TABLE `wysiwyg_user` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2013-03-07 10:21:15
